EmpceBuild = require('./empce_build')

module.exports = (grunt) ->
  empce = new EmpceBuild(grunt)

  packagedir = empce.config.packagedir

  # Project configuration.
  grunt.initConfig
    pkg: grunt.file.readJSON('package.json')
  #   watch: tasks: 'coffee'
  #   coffee:
  #     compile:
  #       files: 
  #       src: packagedir+'pce-ui-app.js'
  #       dest: packagedir+'pce-ui-app.coffee'

  # grunt.loadNpmTasks('grunt-contrib-coffee');


  # Main tasks
  grunt.task.registerTask 'configure', 'Configure emulator build', (arch) ->
    if (arch is 'native')
      empce.config.emscripten = false
      empce.config.prefix = 'build-native/'
    if (arch is 'em')
      empce.config.emscripten = true
      empce.config.prefix = 'build/'

    empce.run(this.async(), './10-configure.sh')

    empce.saveConfig()

  grunt.task.registerTask 'make', 'Build emulator', ->
    empce.run(this.async(), './20-make.sh')

  grunt.task.registerTask 'afterbuild', 'Afterbuild tasks', (target) ->
    empce.config.target = target if target

    empce.run(this.async(), './30-afterbuild.sh')

  grunt.task.registerTask 'run', 'Run emulator', ->
    empce.run(this.async(), 'http-server', [packagedir])

    console.log('serving emulator at http://localhost:8080/')

  # Alias tasks
  grunt.registerTask('build', [
    'configure',
    'make',
    'afterbuild'
  ])
  grunt.registerTask('build:ibmpc', [
    'configure:none',
    'make',
    'afterbuild:ibmpc'
  ])
  grunt.registerTask('build:native', [
    'configure:native',
    'make'
  ])
  grunt.registerTask('rebuild', [
    'make',
    'afterbuild'
  ])
  grunt.registerTask('rebuild:ibmpc', [
    'make',
    'afterbuild:ibmpc'
  ])

  # Default task
  grunt.registerTask('default', ['build'])
