
                      D_RomCheckSum:
0      28BA 61CE                 DC.L      $28BA61CE       ; Rom CheckSum
4      0040 002A                 DC.L      $0040002A       ; Boot Vector = EBootStart
8      00                        DC.B      $00             ; Machine Type
9      69                        DC.B      $69             ; Rom Version
A      6000 0038                 Bra       L2
E      6000 04F0                 Bra       L37
12     6000 0026                 Bra       L1
16     1080                      Move.B    D0, (A0)

                      L0:
                      ; Check memory A7 times, boot if no failure
18     4DFA 0006                 Lea.L     E_4, A6
1C     6000 0676                 Bra       P_TestMemory    ; Call with return address in A6
20     6600 00D2      E_4:       BNE       P_mCritErr
24     538F                      SubQ.L    $1, A7
26     200F                      Move.L    A7, D0
28     66EE                      BNE       L0

                      EBootStart:
                      ; Check if test software exists, and if so run it
2A     4CF9 0101 00F8            MoveM.L   (TestSoftare), D0/A0
       0000
32     0C40 AA55                 Cmp       $-55AB, D0
36     660C                      BNE       L2
38     4ED0                      Jmp       (A0)

                      L1:
                      ; return address in A5
3A     4CB9 0007 00F0            MoveM     (Phase_Read), D0-D2
       0000
42     4ED5                      Jmp       (A5)

                      L2:
                      ; Check timing signals
44     46FC 2700                 Move      $2700, SR
48     4BFA 0004                 Lea.L     E_6, A5
4C     60EC                      Bra       L1              ; Call with return address in A5
4E     7E01           E_6:       MoveQ.L   $1, D7
50     4DF9 009F FFF8            Lea.L     (SCCRd_Base), A6
56     1C87                      Move.B    D7, (A6)
58     C047                      And       D7, D0
5A     C247                      And       D7, D1
5C     C447                      And       D7, D2
5E     D042                      Add       D2, D0
60     D041                      Add       D1, D0
62     5340                      SubQ.L    $1, D0
64     6F02                      BLE       L3
66     4A56                      Tst       (A6)            ; Adjust the phase, with word access
68     267C 0060 0000 L3:        Move.L    $600000, A3     ; Overlay RAM address
6E     247C 0067 A700            Move.L    $67A700, A2     ; Screen buffer in Overlay
74     4DFA 0006                 Lea.L     E_7, A6
78     6000 014A                 Bra       P_EraseScrnBuff ; Call with return address in A6
                      ; Init VIA
7C     2A7C 00EF E1FE E_7:       Move.L    $EFE1FE, A5
82     1B7C 007B 1E00            Move.B    $7B, $1E00(A5)
88     1B7C 007F 0600            Move.B    $7F, $600(A5)
8E     1ABC 0007                 Move.B    $7, (A5)
92     1B7C 0087 0400            Move.B    $-79, $400(A5)
98     1B7C 0082 1C00            Move.B    $-7E, $1C00(A5)
9E     422D 1800                 Clr.B     $1800(A5)
A2     7628                      MoveQ.L   $28, D3
A4     4DFA 0006                 Lea.L     E_8, A6
A8     6000 0144                 Bra       P_mBootBeep     ; Call with return address in A6
                      ; Init IWM
AC     207C 00DF E1FF E_8:       Move.L    $DFE1FF, A0
B2     701F                      MoveQ.L   $1F, D0
B4     4A28 1000      L4:        Tst.B     $1000(A0)
B8     4A28 1A00                 Tst.B     $1A00(A0)
BC     1428 1C00                 Move.B    $1C00(A0), D2
C0     0802 0005                 BTst.B    $5, D2
C4     66EE                      BNE       L4
C6     C400                      And.B     D0, D2
C8     B400                      Cmp.B     D0, D2
CA     670A                      BEQ       L5
CC     1140 1E00                 Move.B    D0, $1E00(A0)
D0     4A28 1C00                 Tst.B     $1C00(A0)
D4     60DE                      Bra       L4
D6     4A28 1800      L5:        Tst.B     $1800(A0)
DA     99CC                      SubA.L    A4, A4
DC     524C                      AddQ      $1, A4
DE     4DFA 0006                 Lea.L     E_9, A6
E2     6000 0596                 Bra       P_ChecksumRom   ; Call with return address in A6
E6     660C           E_9:       BNE       P_mCritErr
E8     4DFA 0006                 Lea.L     E_10, A6
EC     6000 05A6                 Bra       P_TestMemory    ; Call with return address in A6
F0     6700 017A      E_10:      BEQ       P_BootPart2

                      P_mCritErr:
                      ; display boot failure
F4     48F9 FFFF 0067            MoveM.L   D0-D7/A0-A7, ($67FC80)
       FC80
FC     4A39 00DF F1FF            Tst.B     ($DFF1FF)
102    45F9 0007 A700            Lea.L     ($7A700), A2
108    D5CB                      AddA.L    A3, A2
10A    4DFA 0006                 Lea.L     E_11, A6
10E    6000 00B4                 Bra       P_EraseScrnBuff ; Call with return address in A6
112    300C           E_11:      Move      A4, D0
114    4BFA 0006                 Lea.L     E_12, A5
118    6000 06B2                 Bra       L67             ; Call with return address in A5
11C    4840           E_12:      Swap      D0
11E    3001                      Move      D1, D0
120    E188                      LsL.L     $8, D0
122    247C 0007 D3DD            Move.L    $7D3DD, A2
128    D5CB                      AddA.L    A3, A2
12A    7805                      MoveQ.L   $5, D4
12C    E998           L7:        ROL.L     $4, D0
12E    3A00                      Move      D0, D5
130    0245 000F                 And       $F, D5
134    CAFC 0003                 MulU      $3, D5
138    43FB 5040                 Lea.L     DT1(D5.W), A1
13C    72C3                      MoveQ.L   $-3D, D1
13E    7602                      MoveQ.L   $2, D3
140    1A11           L8:        Move.B    (A1), D5
142    E44D                      LsR       $2, D5
144    8A41                      Or        D1, D5
146    1485                      Move.B    D5, (A2)
148    D4FC 0040                 AddA      $40, A2
14C    1A19                      Move.B    (A1)+, D5
14E    E54D                      LsL       $2, D5
150    8A41                      Or        D1, D5
152    1485                      Move.B    D5, (A2)
154    D4FC 0040                 AddA      $40, A2
158    51CB FFE6                 DBF       D3, L8
15C    94FC 017F                 SubA      $17F, A2
160    51CC FFCA                 DBF       D4, L7
164    D4FC 01FC                 AddA      $1FC, A2
168    46FC 2700                 Move      $2700, SR
16C    5280           L9:        AddQ      $1, D0
16E    4840                      Swap      D0
170    1480                      Move.B    D0, (A2)
172    1552 0001                 Move.B    (A2), $1(A2)
176    4840                      Swap      D0
178    60F2                      Bra       L9

                      DT1:
17A    9642 69B3 BBB1            DC.B      ' Bi   '
180    96ED B00E 9E69            DC.B      '     i'
186    6660 EE07 1E69            DC.B      'f`   i'
18C    8716 690E DDBB            DC.B      '  i   '
192    9696 6996 68E1            DC.B      '  i h '
198    9660 6616 1661            DC.B      ' `f  a'
19E    8777 7816 6661            DC.B      ' wx fa'
1A4    0717 7007 1777            DC.B      '  p  w'

                      P_mGenExcps:
1AA    6126                      Bsr       P_mToDeepShit
1AC    6124                      Bsr       P_mToDeepShit
1AE    6122                      Bsr       P_mToDeepShit
1B0    6120                      Bsr       P_mToDeepShit
1B2    611E                      Bsr       P_mToDeepShit
1B4    611C                      Bsr       P_mToDeepShit
1B6    611A                      Bsr       P_mToDeepShit
1B8    6118                      Bsr       P_mToDeepShit
1BA    6116                      Bsr       P_mToDeepShit
1BC    6114                      Bsr       P_mToDeepShit
1BE    6112                      Bsr       P_mToDeepShit

                      E_14:
1C0    544F                      AddQ      $2, A7
1C2    610E                      Bsr       P_mToDeepShit

                      P_EraseScrnBuff:
                      ; return address in A6
                      ; screen address in A2
1C4    76FF                      MoveQ.L   $-1, D3
1C6    343C 157F                 Move      $157F, D2
1CA    24C3           L11:       Move.L    D3, (A2)+
1CC    51CA FFFC                 DBF       D2, L11
1D0    4ED6                      Jmp       (A6)

                      P_mToDeepShit:
1D2    48F9 FFFF 0007            MoveM.L   D0-D7/A0-A7, ($7FC80)
       FC80
1DA    4A39 00DF F1FF            Tst.B     ($DFF1FF)
1E0    41FA FFC8                 Lea.L     P_mGenExcps, A0
1E4    201F                      Move.L    (A7)+, D0
1E6    9088                      Sub.L     A0, D0
1E8    E248                      LsR       $1, D0
1EA    6000 0760                 Bra       P_mSysErr2

                      P_mBootBeep:
                      ; return address in A6
1EE    2A7C 00EF E1FE            Move.L    $EFE1FE, A5
1F4    0895 0007                 BClr.B    $7, (A5)
1F8    41F9 0007 FD00            Lea.L     ($7FD00), A0
1FE    D1CB                      AddA.L    A3, A0
200    2848                      Move.L    A0, A4
202    7004                      MoveQ.L   $4, D0
204    223C FA40 C006 L13:       Move.L    $-5BF3FFA, D1
20A    7413           L14:       MoveQ.L   $13, D2
20C    1081           L15:       Move.B    D1, (A0)
20E    5448                      AddQ      $2, A0
210    5342                      SubQ.L    $1, D2
212    66F8                      BNE       L15
214    E089                      LsR.L     $8, D1
216    66F2                      BNE       L14
218    51C8 FFEA                 DBF       D0, L13
21C    204C           L16:       Move.L    A4, A0
21E    43E8 0092                 Lea.L     $92(A0), A1
222    7049                      MoveQ.L   $49, D0
224    1411           L17:       Move.B    (A1), D2
226    5849                      AddQ      $4, A1
228    1211                      Move.B    (A1), D1
22A    D441                      Add       D1, D2
22C    5549                      SubQ.L    $2, A1
22E    1211                      Move.B    (A1), D1
230    D441                      Add       D1, D2
232    D441                      Add       D1, D2
234    5642                      AddQ      $3, D2
236    E442                      AsR       $2, D2
238    1082                      Move.B    D2, (A0)
23A    5448                      AddQ      $2, A0
23C    51C8 FFE6                 DBF       D0, L17
240    303C 0127                 Move      $127, D0
244    10A8 FFB6      L18:       Move.B    $-4A(A0), (A0)
248    5448                      AddQ      $2, A0
24A    51C8 FFF8                 DBF       D0, L18
24E    303C 157C                 Move      $157C, D0
252    082D 0001 1A00 L19:       BTst.B    $1, $1A00(A5)
258    56C8 FFF8                 DBNE      D0, L19
25C    1B7C 0002 1A00            Move.B    $2, $1A00(A5)
262    51CB FFB8                 DBF       D3, L16
266    08D5 0007                 BSet.B    $7, (A5)
26A    4ED6                      Jmp       (A6)

                      P_BootPart2:
                      ; continue with booting
                      ; A3 contains overlay RAM address
                      ; Clear first 128k of it
26C    204B                      Move.L    A3, A0
26E    72FF                      MoveQ.L   $-1, D1
270    7002                      MoveQ.L   $2, D0
272    4840                      Swap      D0
274    20C1           L21:       Move.L    D1, (A0)+
276    5380                      SubQ.L    $1, D0
278    66FA                      BNE       L21
                      ; init 680x0 vector table
27A    204B                      Move.L    A3, A0
27C    5088                      AddQ      $8, A0
27E    43FA FF2A                 Lea.L     P_mGenExcps, A1
282    7009                      MoveQ.L   $9, D0
284    20C9           L22:       Move.L    A1, (A0)+
286    5489                      AddQ      $2, A1
288    51C8 FFFA                 DBF       D0, L22
28C    700C                      MoveQ.L   $C, D0
28E    20C9           L23:       Move.L    A1, (A0)+
290    51C8 FFFC                 DBF       D0, L23
294    45FA FF2A                 Lea.L     E_14, A2
298    7006                      MoveQ.L   $6, D0
29A    20CA           L24:       Move.L    A2, (A0)+
29C    51C8 FFFC                 DBF       D0, L24
2A0    701F                      MoveQ.L   $1F, D0
2A2    20C9           L25:       Move.L    A1, (A0)+
2A4    51C8 FFFC                 DBF       D0, L25
                      ; turn off overlay
2A8    13FC 0068 00EF            Move.B    $68, ($EFFFFE)
       FFFE
                      ; init stack
2B0    2E7C 0000 FC00            Move.L    $FC00, A7
                      ; more inits
2B6    97CB                      SubA.L    A3, A3
2B8    42B8 02BA                 Clr.L     (DSAlertTab)
2BC    21FC 0001 0001            Move.L    $10001, (OneOne)
       0A02
2C4    70FF                      MoveQ.L   $-1, D0
2C6    21C0 0A06                 Move.L    D0, (MinusOne)
2CA    21FC 0040 0000            Move.L    $400000, (ROMBase)
       02AE
2D2    42B8 013E                 Clr.L     (PollProc)
2D6    21FC 0007 FD01            Move.L    $7FD01, (PWMBuf2)
       0312
                      ; find memory size. 128k or 512k?
2DE    41F9 0007 FFFC            Lea.L     ($7FFFC), A0
2E4    43F9 0001 FFFC            Lea.L     ($1FFFC), A1
2EA    4298                      Clr.L     (A0)+
2EC    4A99                      Tst.L     (A1)+
2EE    6602                      BNE       L26
2F0    2049                      Move.L    A1, A0
2F2    21C8 0108      L26:       Move.L    A0, (MemTop)
                      ; end of find memory size
2F6    90FC 0300                 SubA      $300, A0
2FA    21C8 0266                 Move.L    A0, (SoundBase)
2FE    90FC 5600                 SubA      $5600, A0
302    21C8 010C                 Move.L    A0, (BufPtr)
306    42B8 0110                 Clr.L     (StackLowPoint)
30A    21FC 00EF E1FE            Move.L    $EFE1FE, (VIA)
       01D4
312    21FC 00DF E1FF            Move.L    $DFE1FF, (IWM)
       01E0
31A    41FA 0DA8                 Lea.L     DT_mFSIODNETbl, A0
31E    43F8 08F4                 Lea.L     (JFetch), A1
322    7202                      MoveQ.L   $2, D1
324    6100 02C6                 Bsr       P_mJmpTblInit
328    42B8 012C                 Clr.L     (DskVerify)
32C    4278 0144                 Clr       (SysEvtMask)
330    42B8 021A                 Clr.L     (JKybdTask)
334    43F8 0160                 Lea.L     (VBLQueueHdr_Flags), A1
338    4EBA 0850                 Jsr       P_mInitQueue
33C    42B8 016A                 Clr.L     (Ticks)
340    42B8 016E                 Clr.L     (MBTicks)
344    1039 00EF E1FE            Move.B    (VIA_Base), D0
34A    E900                      AsL.B     $4, D0
34C    11C0 0172                 Move.B    D0, (MBState)
350    41F8 0800                 Lea.L     (GrafBegin_JHideCursor), A0
354    43F8 08F2                 Lea.L     (WWExist), A1
358    4258           L27:       Clr       (A0)+
35A    B1C9                      CmpA.L    A1, A0
35C    6DFA                      BLT       L27
35E    21F8 010C 0824            Move.L    (BufPtr), (ScrnBase)
364    203C 000F 000F            Move.L    $F000F, D0
36A    41F8 0828                 Lea.L     (MTemp_v), A0
36E    20C0                      Move.L    D0, (A0)+
370    20C0                      Move.L    D0, (A0)+
372    20C0                      Move.L    D0, (A0)+
374    20FC 0001 0002            Move.L    $10002, (A0)+
37A    20BC 0154 01FE            Move.L    $15401FE, (A0)
380    41FA 0BD2                 Lea.L     P_mCrsrVBLTask, A0
384    2308                      Move.L    A0, -(A1)
386    333C 0006                 Move      $6, -(A1)
38A    41FA 09AC                 Lea.L     DT_mCRSRCore, A0
38E    43F8 0800                 Lea.L     (GrafBegin_JHideCursor), A1
392    7207                      MoveQ.L   $7, D1
394    6100 0256                 Bsr       P_mJmpTblInit
398    70FF                      MoveQ.L   $-1, D0
39A    31C0 08CE                 Move      D0, (CrsrNew)
39E    21C0 08D6                 Move.L    D0, (MouseMask)
3A2    41F8 0192                 Lea.L     (Lvl1DT), A0
3A6    43FA 087A                 Lea.L     E_34, A1
3AA    2448                      Move.L    A0, A2
3AC    700F                      MoveQ.L   $F, D0
3AE    20C9           L28:       Move.L    A1, (A0)+
3B0    51C8 FFFC                 DBF       D0, L28
3B4    41FA 0862                 Lea.L     P_mOneSecInt_VIA, A0
3B8    24C8                      Move.L    A0, (A2)+
3BA    41FA 0868                 Lea.L     P_mVBLInt_VIA, A0
3BE    2488                      Move.L    A0, (A2)
3C0    45F8 0064                 Lea.L     (Lev1AutoVector), A2
3C4    41FA 07CE                 Lea.L     P_mLvl1Int_VIA, A0
3C8    24C8                      Move.L    A0, (A2)+
3CA    41FA 07F0                 Lea.L     P_mLvl2Int_SCC, A0
3CE    24C8                      Move.L    A0, (A2)+
3D0    41FA 081A                 Lea.L     P_mSpurious_IntVIAandSCC, A0
3D4    2488                      Move.L    A0, (A2)
3D6    45F8 02BE                 Lea.L     (ExtStsDT), A2
3DA    24C9                      Move.L    A1, (A2)+
3DC    41FA 0B4C                 Lea.L     P_SCCInt_BChng_MouseV, A0
3E0    24C8                      Move.L    A0, (A2)+
3E2    24C9                      Move.L    A1, (A2)+
3E4    41FA 0B1C                 Lea.L     P_SCCInt_AChng_MouseH, A0
3E8    2488                      Move.L    A0, (A2)
3EA    45F8 01B6                 Lea.L     (Lvl2DT.1), A2
3EE    41FA 07FE                 Lea.L     P_mExtBInt_StatusChngSCC, A0
3F2    2488                      Move.L    A0, (A2)
3F4    41FA 0802                 Lea.L     P_mExtAInt_StatusChngSCC, A0
3F8    2548 0010                 Move.L    A0, $10(A2)
3FC    4EBA 4B5C                 Jsr       P_tInitUtil
400    0838 0003 020B            BTst.B    $3, (SPMisc2)
406    56F8 08D3                 SNE.B     (CrsrScale)
                      ; Begin setting up A-line dispatch
40A    43F8 0400                 Lea.L     (DispatchTab), A1
40E    41FA 0184                 Lea.L     P_tUnimplemented, A0
412    91F8 02AE                 SubA.L    (ROMBase), A0
416    2008                      Move.L    A0, D0
418    E248                      LsR       $1, D0
41A    2049                      Move.L    A1, A0
41C    323C 01FF                 Move      $1FF, D1
420    30C0           L29:       Move      D0, (A0)+
422    51C9 FFFC                 DBF       D1, L29
426    41FA 4C72                 Lea.L     DT32, A0
42A    7400                      MoveQ.L   $0, D2
42C    1018           L30:       Move.B    (A0)+, D0
42E    6B0E                      BMI       L33
430    E140                      AsL       $8, D0
432    1018                      Move.B    (A0)+, D0
434    3400           L31:       Move      D0, D2
436    6710                      BEQ       L34
438    3280                      Move      D0, (A1)
43A    5449           L32:       AddQ      $2, A1
43C    60EE                      Bra       L30
43E    0240 007F      L33:       And       $7F, D0
442    67F6                      BEQ       L32
444    D042                      Add       D2, D0
446    60EC                      Bra       L31
                      ; Done setting up A-line dispatch
448    41FA 0BCE      L34:       Lea.L     P_mEMT1010_TrapDispatch, A0
44C    21C8 0028                 Move.L    A0, (ATrapVector)
450    4EBA 267A                 Jsr       P73
454    6100 0164                 Bsr       P_InitSCC
458    4EBA 10C8                 Jsr       P_InitKeyboard
45C    6100 01B6                 Bsr       P_mInitIOMgr
460    46FC 2000                 Move      $2000, SR
464    4BEF 0190                 Lea.L     $190(A7), A5
468    486D FFFC                 Pea.L     $-4(A5)
46C    A86E                      _InitGraf
46E    4879 0000 FE00            Pea.L     ($FE00)
474    A86F                      _OpenPort
476    2455                      Move.L    (A5), A2
478    486A FF94                 Pea.L     $-6C(A2)
47C    A851                      _SetCursor
47E    486A FF8C                 Pea.L     $-74(A2)
482    2F17                      Move.L    (A7), -(A7)
484    A8A2                      _PaintRect
486    2F3C 0010 0010            Move.L    $100010, -(A7)
48C    486A FFE8                 Pea.L     $-18(A2)
490    A8B4                      _FillRoundRect
492    A852                      _HideCursor
494    97CB                      SubA.L    A3, A3
496    4BFA 0006                 Lea.L     E_15, A5
49A    6000 0358                 Bra       L69             ; Call with return address in A5
49E    A853           E_15:      _ShowCursor
4A0    41FA 0426                 Lea.L     DT_mQMark, A0
4A4    2E08                      Move.L    A0, D7
4A6    7C01                      MoveQ.L   $1, D6
4A8    0838 0004 020B            BTst.B    $4, (SPMisc2)
4AE    6702                      BEQ       L35
4B0    5246                      AddQ      $1, D6
4B2    7603           L35:       MoveQ.L   $3, D3
4B4    7800                      MoveQ.L   $0, D4
4B6    4A38 0172                 Tst.B     (MBState)
4BA    6A44                      BPL       L37
4BC    204F           L36:       Move.L    A7, A0
4BE    317C FFFB 0018            Move      $-5, $18(A0)
4C4    317C 0001 002C            Move      $1, $2C(A0)
4CA    42A8 002E                 Clr.L     $2E(A0)
4CE    227C 0001 0000            Move.L    $10000, A1
4D4    2149 0020                 Move.L    A1, $20(A0)
4D8    217C 0000 0400            Move.L    $400, $24(A0)
       0024
4E0    3146 0016                 Move      D6, $16(A0)
4E4    31C6 0210                 Move      D6, (BootDrive)
4E8    A002                      _Read
4EA    6700 005A                 BEQ       L42
4EE    0C40 FFBF                 Cmp       $-41, D0
4F2    6728                      BEQ       L38
4F4    0C40 FFC0                 Cmp       $-40, D0
4F8    6606                      BNE       L37
4FA    B746                      Eor       D3, D6
4FC    7600                      MoveQ.L   $0, D3
4FE    601C                      Bra       L38
500    204F           L37:       Move.L    A7, A0
502    317C FFFB 0018            Move      $-5, $18(A0)
508    317C 0007 001A            Move      $7, $1A(A0)
50E    3146 0016                 Move      D6, $16(A0)
512    A004                      _Control
514    41FA 03D0                 Lea.L     DT_mXMark, A0
518    2E08                      Move.L    A0, D7
51A    7A08                      MoveQ.L   $8, D5
51C    48E7 1F00      L38:       MoveM.L   D3-D7, -(A7)
520    E24C                      LsR       $1, D4
522    6402                      BCC       L39
524    7E00                      MoveQ.L   $0, D7
526    6132           L39:       Bsr       P_mPlotDisk
528    4CDF 00F8                 MoveM.L   (A7)+, D3-D7
52C    7004                      MoveQ.L   $4, D0
52E    4840                      Swap      D0
530    5380           L40:       SubQ.L    $1, D0
532    66FC                      BNE       L40
534    5244                      AddQ      $1, D4
536    5345                      SubQ.L    $1, D5
538    6606                      BNE       L41
53A    41FA 038C                 Lea.L     DT_mQMark, A0
53E    2E08                      Move.L    A0, D7
540    B746           L41:       Eor       D3, D6
542    6000 FF78                 Bra       L36
546    0C59 4C4B      L42:       Cmp       $4C4B, (A1)+
54A    66B4                      BNE       L37
54C    2F09                      Move.L    A1, -(A7)
54E    A852                      _HideCursor
550    4BFA 0006                 Lea.L     E_16, A5
554    6000 029E                 Bra       L69             ; Call with return address in A5
558    4E75           E_16:      Rts

                      P_mPlotDisk:
55A    A852                      _HideCursor
55C    2038 016A                 Move.L    (Ticks), D0
560    B0B8 016A      L43:       Cmp.L     (Ticks), D0
564    67FA                      BEQ       L43
566    49FA 0308                 Lea.L     DT6, A4
56A    247C 0007 CB5E            Move.L    $7CB5E, A2
570    4DFA 0006                 Lea.L     E_17, A6
574    6000 0218                 Bra       L60             ; Call with return address in A6
578    4A47           E_17:      Tst       D7
57A    6714                      BEQ       L44
57C    247C 0007 CF1F            Move.L    $7CF1F, A2
582    2847                      Move.L    D7, A4
584    D5CB                      AddA.L    A3, A2
586    740E                      MoveQ.L   $E, D2
588    4DFA 0006                 Lea.L     L44, A6
58C    6000 0270                 Bra       L71
590    A853           L44:       _ShowCursor
592    4E75                      Rts

                      P_tUnimplemented:
594    700C                      MoveQ.L   $C, D0
596    6000 03AC                 Bra       P_tSysError

                      DT2:
59A    0940 044C 0200            DC.B      ' @ L  '
5A0    03C0 0F08 0010            DC.B      '      '
5A6    0010 0101 0980            DC.B      '      '
5AC    044C 03C0 0F08            DC.B      ' L    '
5B2    0010 0010 0101            DC.B      '      '
5B8    090A                      DC.B      '  '

                      P_InitSCC:
5BA    207C 00BF FFF9            Move.L    $BFFFF9, A0
5C0    227C 009F FFF8            Move.L    $9FFFF8, A1
5C6    21C8 01DC                 Move.L    A0, (SCCWr)
5CA    21C9 01D8                 Move.L    A1, (SCCRd)
5CE    45FA FFCA                 Lea.L     DT2, A2
5D2    7210                      MoveQ.L   $10, D1
5D4    6106                      Bsr       P3
5D6    5488                      AddQ      $2, A0
5D8    5489                      AddQ      $2, A1
5DA    7210                      MoveQ.L   $10, D1

                      P3:
5DC    1411                      Move.B    (A1), D2
5DE    6006                      Bra       L46
5E0    2E97           L45:       Move.L    (A7), (A7)
5E2    2E97                      Move.L    (A7), (A7)
5E4    109A                      Move.B    (A2)+, (A0)
5E6    51C9 FFF8      L46:       DBF       D1, L45
5EA    4E75                      Rts

                      P_mJmpTblInit:
5EC    2008                      Move.L    A0, D0
                      L_mJmpTbl2:
5EE    7400                      MoveQ.L   $0, D2
5F0    3418                      Move      (A0)+, D2
5F2    D480                      Add.L     D0, D2
5F4    22C2                      Move.L    D2, (A1)+
5F6    51C9 FFF6                 DBF       D1, L_mJmpTbl2
5FA    4E75                      Rts

                      DT3:
                      ; The following 6 instructions don't jump to real code
                      ; This seems to be a way to get addresses of drivers
5FC    4EFA 2EB0                 Jmp       Driver_Sound
600    4EFA 108E                 Jmp       Driver_Sony
604    4EFA 1F4C                 Jmp       Driver_AIn
608    4EFA 1F60                 Jmp       Driver_AOut
60C    4EFA 1F74                 Jmp       Driver_BIn
610    4EFA 1F88                 Jmp       Driver_BOut

                      P_mInitIOMgr:
614    7020                      MoveQ.L   $20, D0
616    31C0 01D2                 Move      D0, (UnitTableEntryCount)
61A    E580                      AsL.L     $2, D0
61C    A71E                      _NewPtrSysClear
61E    21C8 011C                 Move.L    A0, (UTableBase)
622    45FA FFD8                 Lea.L     DT3, A2
626    7205                      MoveQ.L   $5, D1
628    7E03                      MoveQ.L   $3, D7
62A    544A           L48:       AddQ      $2, A2
62C    224A                      Move.L    A2, A1
62E    7000                      MoveQ.L   $0, D0
630    301A                      Move      (A2)+, D0
632    D3C0                      AddA.L    D0, A1
634    3007                      Move      D7, D0
636    4640                      Not       D0
638    9EFC 0032                 SubA      $32, A7
63C    3F40 0018                 Move      D0, $18(A7)
640    A03D                      _DrvrInstall
642    3F7C 0001 001A            Move      $1, $1A(A7)
648    204F                      Move.L    A7, A0
64A    A005                      _Status
64C    2668 001C                 Move.L    $1C(A0), A3
650    2653                      Move.L    (A3), A3
652    26C9                      Move.L    A1, (A3)+
654    4253                      Clr       (A3)
656    1691                      Move.B    (A1), (A3)
658    0C47 0005                 Cmp       $5, D7
65C    6410                      BCC       L49
65E    43E9 0012                 Lea.L     $12(A1), A1
662    2F49 0012                 Move.L    A1, $12(A7)
666    422F 001B                 Clr.B     $1B(A7)
66A    204F                      Move.L    A7, A0
66C    A000                      _Open
66E    DEFC 0032      L49:       AddA      $32, A7
672    5247                      AddQ      $1, D7
674    51C9 FFB4                 DBF       D1, L48
678    4E75                      Rts

                      P_ChecksumRom:
                      ; return address in A6
67A    7000                      MoveQ.L   $0, D0
67C    7200                      MoveQ.L   $0, D1
67E    41FA F980                 Lea.L     D_RomCheckSum, A0
682    2618                      Move.L    (A0)+, D3
684    343C 7FFD                 Move      $7FFD, D2
688    3218           L51:       Move      (A0)+, D1
68A    D081                      Add.L     D1, D0
68C    51CA FFFA                 DBF       D2, L51
690    B780                      Eor.L     D3, D0
692    4ED6                      Jmp       (A6)

                      P_TestMemory:
                      ; return address in A6
694    7200                      MoveQ.L   $0, D1
696    524C                      AddQ      $1, A4
698    204B                      Move.L    A3, A0
69A    7401                      MoveQ.L   $1, D2
69C    767F                      MoveQ.L   $7F, D3
69E    3082           L53:       Move      D2, (A0)
6A0    3210                      Move      (A0), D1
6A2    B541                      Eor       D2, D1
6A4    6600 007C                 BNE       L56
6A8    E35A                      ROL       $1, D2
6AA    51CB FFF2                 DBF       D3, L53
6AE    524C                      AddQ      $1, A4
6B0    343C 55AA                 Move      $55AA, D2
6B4    0588 0000                 MoveP     D0, $0(A0)
6B8    0588 0001                 MoveP     D0, $1(A0)
6BC    2210                      Move.L    (A0), D1
6BE    0A81 5555 AAAA            Eor.L     $5555AAAA, D1
6C4    6600 005C                 BNE       L56
6C8    524C                      AddQ      $1, A4
6CA    7000                      MoveQ.L   $0, D0
6CC    45FA 0098                 Lea.L     DT4, A2
6D0    4CD2 007C                 MoveM.L   (A2), D2-D6
6D4    4BFA 0006                 Lea.L     E_19, A5
6D8    6000 004C                 Bra       L57             ; Call with return address in A5
6DC    4CEA 007C 0004 E_19:      MoveM.L   $4(A2), D2-D6
6E2    4BFA 0006                 Lea.L     E_20, A5
6E6    6000 003E                 Bra       L57             ; Call with return address in A5
6EA    4CEA 007C 0008 E_20:      MoveM.L   $8(A2), D2-D6
6F0    4BFA 0006                 Lea.L     E_21, A5
6F4    6000 0030                 Bra       L57             ; Call with return address in A5
6F8    7200           E_21:      MoveQ.L   $0, D1
6FA    3200                      Move      D0, D1
6FC    4840                      Swap      D0
6FE    8240                      Or        D0, D1
700    0C41 FFFF                 Cmp       $-1, D1
704    661C                      BNE       L56
706    524C                      AddQ      $1, A4
708    204B                      Move.L    A3, A0
70A    2248                      Move.L    A0, A1
70C    74FF                      MoveQ.L   $-1, D2
70E    30C2           L54:       Move      D2, (A0)+
710    51CA FFFC                 DBF       D2, L54
714    3619           L55:       Move      (A1)+, D3
716    B543                      Eor       D2, D3
718    8243                      Or        D3, D1
71A    51CA FFF8                 DBF       D2, L55
71E    6602                      BNE       L56
720    8240                      Or        D0, D1
722    4A41           L56:       Tst       D1
724    4ED6                      Jmp       (A6)

                      L57:
                      ; return address in A5
726    4CEA 0302 001C            MoveM.L   $1C(A2), D1/A0-A1
72C    48D0 001C      L58:       MoveM.L   D2-D4, (A0)
730    D0FC 000C                 AddA      $C, A0
734    48E1 0E00                 MoveM.L   D4-D6, -(A1)
738    51C9 FFF2                 DBF       D1, L58
73C    4CEA 0302 001C            MoveM.L   $1C(A2), D1/A0-A1
742    4841                      Swap      D1
744    4CD8 00E0      L59:       MoveM.L   (A0)+, D5-D7
748    B585                      Eor.L     D2, D5
74A    B786                      Eor.L     D3, D6
74C    B987                      Eor.L     D4, D7
74E    8C85                      Or.L      D5, D6
750    8E86                      Or.L      D6, D7
752    8087                      Or.L      D7, D0
754    51C9 FFEE                 DBF       D1, L59
758    4CD8 0060                 MoveM.L   (A0)+, D5-D6
75C    B585                      Eor.L     D2, D5
75E    B786                      Eor.L     D3, D6
760    8C85                      Or.L      D5, D6
762    8086                      Or.L      D6, D0
764    4ED5                      Jmp       (A5)

                      DT4:
766    DB6D B6DB 6DB6            DC.B      ' m  m '
76C    DB6D B6DB 6DB6            DC.B      ' m  m '
772    DB6D B6DB 6DB6            DC.B      ' m  m '
778    DB6D B6DB 6DB6            DC.B      ' m  m '
77E    DB6D B6DB 2AA9            DC.B      ' m  * '
784    1555 0060 0000            DC.B      ' U `  '
78A    0062 0000                 DC.B      ' b  '
78E    D5CB           L60:       AddA.L    A3, A2

                      P_tPutIcon:
790    760F                      MoveQ.L   $F, D3
792    204A                      Move.L    A2, A0
794    7403                      MoveQ.L   $3, D2
796    383C 0100      L61:       Move      $100, D4
79A    181C                      Move.B    (A4)+, D4
79C    E24C           L62:       LsR       $1, D4
79E    6714                      BEQ       L65
7A0    6404                      BCC       L63
7A2    421A                      Clr.B     (A2)+
7A4    6002                      Bra       L64
7A6    14DC           L63:       Move.B    (A4)+, (A2)+
7A8    51CA FFF2      L64:       DBF       D2, L62
7AC    D4FC 003C                 AddA      $3C, A2
7B0    7403                      MoveQ.L   $3, D2
7B2    60E8                      Bra       L62
7B4    51CB FFE0      L65:       DBF       D3, L61
7B8    2248                      Move.L    A0, A1
7BA    761E                      MoveQ.L   $1E, D3
7BC    D2FC 0040      L66:       AddA      $40, A1
7C0    2810                      Move.L    (A0), D4
7C2    B991                      Eor.L     D4, (A1)
7C4    2049                      Move.L    A1, A0
7C6    51CB FFF4                 DBF       D3, L66
7CA    4ED6                      Jmp       (A6)

                      L67:
                      ; return address in A5
7CC    41FA 00E6                 Lea.L     DT8, A0
7D0    49FA 003A      L68:       Lea.L     DT5, A4
7D4    2E08                      Move.L    A0, D7
7D6    247C 0007 CB5E            Move.L    $7CB5E, A2
7DC    4DFA 0004                 Lea.L     E_23, A6
7E0    60AC                      Bra       L60             ; Call with return address in A6
7E2    247C 0007 CCDF E_23:      Move.L    $7CCDF, A2
7E8    2847                      Move.L    D7, A4
7EA    4DFA 0006                 Lea.L     E_24, A6
7EE    6000 000A                 Bra       P_mPutSymbol    ; Call with return address in A6
7F2    4ED5           E_24:      Jmp       (A5)

                      L69:
                      ; return address in A5
7F4    41FA 00AA                 Lea.L     DT7, A0
7F8    60D6                      Bra       L68

                      P_mPutSymbol:
                      ; return address in A6
7FA    D5CB                      AddA.L    A3, A2
7FC    7409                      MoveQ.L   $9, D2
7FE    14DC           L71:       Move.B    (A4)+, (A2)+
800    14DC                      Move.B    (A4)+, (A2)+
802    D4FC 003E                 AddA      $3E, A2
806    51CA FFF6                 DBF       D2, L71
80A    4ED6                      Jmp       (A6)

                      DT5:
80C    0057 FFFF D5FF            DC.B      ' W    '
812    FFFF FF06 F83F            DC.B      '     ?'
818    E1FF FF0F 60E3            DC.B      '    ` '
81E    FFFF 8FE0 0F66            DC.B      '     f'
824    E00F E00F 66E0            DC.B      '    f '
82A    0FE0 0F66 E00F            DC.B      '   f  '
830    E00F 66E0 0FE0            DC.B      '  f   '
836    0F66 E00F E00F            DC.B      ' f    '
83C    06E0 0FE3 FFFF            DC.B      '      '
842    8F60 E1FF FF0F            DC.B      ' `    '
848    E00F 66E0 0FE0            DC.B      '  f   '
84E    0F22 E33F 0FE3            DC.B      ' " ?  '
854    3F0F 66E0 0FE0            DC.B      '? f   '
85A    0F06 E00F FFFF            DC.B      '      '
860    FFFF 60F7 FFFF            DC.B      '  `   '
866    DFF0 1F06 F01F            DC.B      '      '
86C    F7FF FFDF                 DC.B      '    '

                      DT6:
870    007F FFFF F5FE            DC.B      '      '
876    FFFE FF33 700F            DC.B      '   3p '
87C    F807 F703 FFBB            DC.B      '      '
882    F870 9801 FFFF            DC.B      ' p    '
888    FFFE FF00 07FF            DC.B      '      '
88E    FFE0 0FFF FFF0            DC.B      '      '
894    FFFF FFFF FFFF            DC.B      '      '
89A    FF0F 77FF FFEF            DC.B      '  w   '

                      DT7:
8A0    0000 1110 1110            DC.B      '      '
8A6    0100 0100 0300            DC.B      '      '
8AC    0000 0840 0780            DC.B      '   @  '
8B2    0000                      DC.B      '  '

                      DT8:
8B4    2828 1010 2828            DC.B      '((  (('
8BA    0000 0480 0300            DC.B      '      '
8C0    0000 0FC0 1030            DC.B      '     0'
8C6    0008                      DC.B      '  '

                      DT_mQMark:
8C8    0000 0000 07E0            DC.B      '      '
8CE    0FF0 0C30 0C30            DC.B      '   0 0'
8D4    0070 00E0 01C0            DC.B      ' p    '
8DA    0180 0180 0000            DC.B      '      '
8E0    0180 0180 0000            DC.B      '      '

                      DT_mXMark:
8E6    0000 0000 1008            DC.B      '      '
8EC    381C 1C38 0E70            DC.B      '8  8 p'
8F2    07E0 03C0 03C0            DC.B      '      '
8F8    07E0 0E70 1C38            DC.B      '   p 8'
8FE    381C 1008 0000            DC.B      '8     '

                      P_mAllocFakeRgns:
904    43EE 0018                 Lea.L     $18(A6), A1
908    41EE 006C                 Lea.L     $6C(A6), A0
90C    22C8                      Move.L    A0, (A1)+
90E    5848                      AddQ      $4, A0
910    22C8                      Move.L    A0, (A1)+
912    43FA 000A                 Lea.L     DT11, A1
916    2089                      Move.L    A1, (A0)
918    5948                      SubQ.L    $4, A0
91A    2089                      Move.L    A1, (A0)
91C    4E75                      Rts

                      DT11:
91E    000A 8AD0 8AD0            DC.B      '      '
924    7530 7530                 DC.B      'u0u0'

                      P_tSysBeep:
928    48E7 FF7E                 MoveM.L   D0-D7/A1-A6, -(A7)
92C    362F 003C                 Move      $3C(A7), D3
930    97CB                      SubA.L    A3, A3
932    4DFA 0006                 Lea.L     E_26, A6
936    6000 F8B6                 Bra       P_mBootBeep     ; Call with return address in A6
93A    4CDF 7EFF      E_26:      MoveM.L   (A7)+, D0-D7/A1-A6
93E    205F                      Move.L    (A7)+, A0
940    544F                      AddQ      $2, A7
942    4ED0                      Jmp       (A0)

                      P_tSysError:
944    48F9 FFFF 0007            MoveM.L   D0-D7/A0-A7, ($7FC80)
       FC80
                      P_mSysErr2:
94C    23D7 0007 FCC0            Move.L    (A7), ($7FCC0)
952    48E7 FFFE                 MoveM.L   D0-D7/A0-A6, -(A7)
956    31C0 0AF0                 Move      D0, (DSErrCode)
95A    4AB8 02BA                 Tst.L     (DSAlertTab)
95E    6770                      BEQ       L80
960    4BEF FFFC                 Lea.L     $-4(A7), A5
964    9EFC 015A                 SubA      $15A, A7
968    2C4F                      Move.L    A7, A6
96A    3F00                      Move      D0, -(A7)
96C    486D FFFC                 Pea.L     $-4(A5)
970    A86E                      _InitGraf
972    6190                      Bsr       P_mAllocFakeRgns
974    2F0E                      Move.L    A6, -(A7)
976    A86D                      _InitPort
978    4A57                      Tst       (A7)
97A    6B04                      BMI       L73
97C    6100 00B6                 Bsr       P9
980    301F           L73:       Move      (A7)+, D0
982    6158                      Bsr       P7
984    6606                      BNE       L74
986    2078 02BA                 Move.L    (DSAlertTab), A0
98A    5C48                      AddQ      $6, A0
98C    2648           L74:       Move.L    A0, A3
98E    616A                      Bsr       P8
990    6168                      Bsr       P8
992    301B                      Move      (A3)+, D0
994    6712                      BEQ       L75
996    6144                      Bsr       P7
998    670E                      BEQ       L75
99A    4868 0008                 Pea.L     $8(A0)
99E    2F08                      Move.L    A0, -(A7)
9A0    486F 0004                 Pea.L     $4(A7)
9A4    A94B                      _PlotIcon
9A6    584F                      AddQ      $4, A7
9A8    301B           L75:       Move      (A3)+, D0
9AA    6706                      BEQ       L76
9AC    612E                      Bsr       P7
9AE    6702                      BEQ       L76
9B0    4E90                      Jsr       (A0)
9B2    301B           L76:       Move      (A3)+, D0
9B4    670E                      BEQ       L78
9B6    4AB8 0A8C                 Tst.L     (ResumeProc)
9BA    6702                      BEQ       L77
9BC    5240                      AddQ      $1, D0
9BE    6100 00B2      L77:       Bsr       P10
9C2    660A                      BNE       L79
9C4    DEFC 015A      L78:       AddA      $15A, A7
9C8    4CDF 7FFF                 MoveM.L   (A7)+, D0-D7/A0-A6
9CC    4E75                      Rts
9CE    4ED0           L79:       Jmp       (A0)
9D0    3200           L80:       Move      D0, D1
9D2    387C 000F                 Move      $F, A4
9D6    97CB                      SubA.L    A3, A3
9D8    6000 F71A                 Bra       P_mCritErr

                      P7:
9DC    2078 02BA                 Move.L    (DSAlertTab), A0
9E0    3218                      Move      (A0)+, D1
9E2    6006                      Bra       L82
9E4    B058           L81:       Cmp       (A0)+, D0
9E6    670C                      BEQ       L83
9E8    D0D8                      AddA      (A0)+, A0
9EA    51C9 FFF8      L82:       DBF       D1, L81
9EE    7000                      MoveQ.L   $0, D0
9F0    91C8                      SubA.L    A0, A0
9F2    4E75                      Rts
9F4    70FF           L83:       MoveQ.L   $-1, D0
9F6    5448                      AddQ      $2, A0
9F8    4E75                      Rts

                      P8:
9FA    301B                      Move      (A3)+, D0
9FC    6734                      BEQ       L86
9FE    61DC                      Bsr       P7
A00    6730                      BEQ       L86
A02    2618                      Move.L    (A0)+, D3
A04    2448                      Move.L    A0, A2
A06    1018           L84:       Move.B    (A0)+, D0
A08    6706                      BEQ       L85
A0A    0C00 002F                 Cmp.B     $2F, D0
A0E    66F6                      BNE       L84
A10    1F00           L85:       Move.B    D0, -(A7)
A12    2F0A                      Move.L    A2, -(A7)
A14    4267                      Clr       -(A7)
A16    2008                      Move.L    A0, D0
A18    908A                      Sub.L     A2, D0
A1A    5340                      SubQ.L    $1, D0
A1C    2448                      Move.L    A0, A2
A1E    3F00                      Move      D0, -(A7)
A20    2F03                      Move.L    D3, -(A7)
A22    A893                      _MoveTo
A24    A885                      _DrawText
A26    0683 000E 0000            Add.L     $E0000, D3
A2C    204A                      Move.L    A2, A0
A2E    101F                      Move.B    (A7)+, D0
A30    66D4                      BNE       L84
A32    4E75           L86:       Rts

                      P9:
A34    45FA 0034                 Lea.L     DT12, A2
A38    2F0A                      Move.L    A2, -(A7)
A3A    A8A3                      _EraseRect
A3C    2F0A                      Move.L    A2, -(A7)
A3E    A8A1                      _FrameRect
A40    2F3C 0003 0003            Move.L    $30003, -(A7)
A46    A89B                      _PenSize
A48    3F2A 0002                 Move      $2(A2), -(A7)
A4C    5657                      AddQ      $3, (A7)
A4E    3F2A 0004                 Move      $4(A2), -(A7)
A52    A893                      _MoveTo
A54    3F2A 0006                 Move      $6(A2), -(A7)
A58    3F17                      Move      (A7), -(A7)
A5A    3F2A 0004                 Move      $4(A2), -(A7)
A5E    A891                      _LineTo
A60    3F12                      Move      (A2), -(A7)
A62    5657                      AddQ      $3, (A7)
A64    A891                      _LineTo
A66    A89E                      _PenNormal
A68    4E75           L87:       Rts

                      DT12:
A6A    0040 0020 00BE            DC.B      ' @    '
A70    01E0                      DC.B      '  '

                      P10:
A72    6100 FF68                 Bsr       P7
A76    67F0                      BEQ       L87
A78    2448                      Move.L    A0, A2
A7A    3618                      Move      (A0)+, D3
A7C    2648                      Move.L    A0, A3
A7E    2F2B 0002      L88:       Move.L    $2(A3), -(A7)
A82    0697 000E 0004            Add.L     $E0004, (A7)
A88    A893                      _MoveTo
A8A    3013                      Move      (A3), D0
A8C    6100 FF4E                 Bsr       P7
A90    5348                      SubQ.L    $1, A0
A92    2F08                      Move.L    A0, -(A7)
A94    A884                      _DrawString
A96    486B 0002                 Pea.L     $2(A3)
A9A    2F3C 0010 0010            Move.L    $100010, -(A7)
AA0    A8B0                      _FrameRoundRect
AA2    D6FC 000C                 AddA      $C, A3
AA6    5343                      SubQ.L    $1, D3
AA8    66D4                      BNE       L88
AAA    2055                      Move.L    (A5), A0
AAC    4868 FF94                 Pea.L     $-6C(A0)
AB0    A851                      _SetCursor
AB2    A853                      _ShowCursor
AB4    46FC 2000                 Move      $2000, SR
AB8    50F8 08CF                 ST.B      (CrsrCouple)
ABC    4238 0160                 Clr.B     (VBLQueueHdr_Flags)
AC0    0839 0003 00EF L89:       BTst.B    $3, (VIA_Base)
       E1FE
AC8    66F6                      BNE       L89
ACA    264A                      Move.L    A2, A3
ACC    361B                      Move      (A3)+, D3
ACE    544B                      AddQ      $2, A3
AD0    6134           L90:       Bsr       P11
AD2    660A                      BNE       L91
AD4    D6FC 000C                 AddA      $C, A3
AD8    5343                      SubQ.L    $1, D3
ADA    66F4                      BNE       L90
ADC    60E2                      Bra       L89
ADE    6134           L91:       Bsr       P12
AE0    7601                      MoveQ.L   $1, D3
AE2    6122           L92:       Bsr       P11
AE4    B600                      Cmp.B     D0, D3
AE6    6706                      BEQ       L93
AE8    0A43 0001                 Eor       $1, D3
AEC    6126                      Bsr       P12
AEE    0839 0003 00EF L93:       BTst.B    $3, (VIA_Base)
       E1FE
AF6    67EA                      BEQ       L92
AF8    4A03                      Tst.B     D3
AFA    67C4                      BEQ       L89
AFC    302B 0008                 Move      $8(A3), D0
B00    6100 FEDA                 Bsr       P7
B04    4E75                      Rts

                      P11:
B06    554F                      SubQ.L    $2, A7
B08    2F38 0830                 Move.L    (Mouse_v), -(A7)
B0C    2F0B                      Move.L    A3, -(A7)
B0E    A8AD                      _PtInRect
B10    101F                      Move.B    (A7)+, D0
B12    4E75                      Rts

                      P12:
B14    2F0B                      Move.L    A3, -(A7)
B16    2F3C 0010 0010            Move.L    $100010, -(A7)
B1C    A8B3                      _InvertRoundRect
B1E    4E75                      Rts

                      P13:
B20    40E7                      Move      SR, -(A7)
B22    5449                      AddQ      $2, A1
B24    007C 0300                 Or        $300, SR
B28    4290                      Clr.L     (A0)
B2A    4A99                      Tst.L     (A1)+
B2C    6606                      BNE       L94
B2E    2288                      Move.L    A0, (A1)
B30    2308                      Move.L    A0, -(A1)
B32    600C                      Bra       L95
B34    2F0A           L94:       Move.L    A2, -(A7)
B36    2451                      Move.L    (A1), A2
B38    2488                      Move.L    A0, (A2)
B3A    2288                      Move.L    A0, (A1)
B3C    245F                      Move.L    (A7)+, A2
B3E    5949                      SubQ.L    $4, A1
B40    5549           L95:       SubQ.L    $2, A1
B42    4E73                      Rte

                      P14:
B44    40E7                      Move      SR, -(A7)
B46    48E7 0030                 MoveM.L   A2-A3, -(A7)
B4A    007C 0300                 Or        $300, SR
B4E    2469 0002                 Move.L    $2(A1), A2
B52    264A                      Move.L    A2, A3
B54    B1CB           L96:       CmpA.L    A3, A0
B56    670E                      BEQ       L97
B58    244B                      Move.L    A3, A2
B5A    2652                      Move.L    (A2), A3
B5C    B5E9 0006                 CmpA.L    $6(A1), A2
B60    66F2                      BNE       L96
B62    70FF                      MoveQ.L   $-1, D0
B64    6010                      Bra       L99
B66    B7CA           L97:       CmpA.L    A2, A3
B68    6612                      BNE       L100
B6A    2352 0002                 Move.L    (A2), $2(A1)
B6E    6604                      BNE       L98
B70    42A9 0006                 Clr.L     $6(A1)
B74    7000           L98:       MoveQ.L   $0, D0
B76    4CDF 0C00      L99:       MoveM.L   (A7)+, A2-A3
B7A    4E73                      Rte
B7C    2493           L100:      Move.L    (A3), (A2)
B7E    B7E9 0006                 CmpA.L    $6(A1), A3
B82    66F0                      BNE       L98
B84    234A 0006                 Move.L    A2, $6(A1)
B88    60EA                      Bra       L98

                      P_mInitQueue:
B8A    4259                      Clr       (A1)+
B8C    4299                      Clr.L     (A1)+
B8E    4291                      Clr.L     (A1)
B90    5D49                      SubQ.L    $6, A1
B92    4E75                      Rts

                      P_mLvl1Int_VIA:
B94    48E7 F0F0                 MoveM.L   D0-D3/A0-A3, -(A7)
B98    41F8 018E                 Lea.L     (KeyThresh), A0
B9C    2278 01D4                 Move.L    (VIA), A1
BA0    1029 1A00                 Move.B    $1A00(A1), D0
BA4    C029 1C00                 And.B     $1C00(A1), D0
BA8    08C0 0007                 BSet.B    $7, D0
BAC    5888           L101:      AddQ      $4, A0
BAE    E208                      LsR.B     $1, D0
BB0    64FA                      BCC       L101
BB2    2050                      Move.L    (A0), A0
BB4    4E90                      Jsr       (A0)
BB6    4CDF 0F0F                 MoveM.L   (A7)+, D0-D3/A0-A3
BBA    4E73                      Rte

                      P_mLvl2Int_SCC:
BBC    48E7 F0F0                 MoveM.L   D0-D3/A0-A3, -(A7)
BC0    2078 01D8                 Move.L    (SCCRd), A0
BC4    1010                      Move.B    (A0), D0
BC6    2278 01DC                 Move.L    (SCCWr), A1
BCA    12BC 0002                 Move.B    $2, (A1)
BCE    45F8 01B2                 Lea.L     (Lvl2DT), A2
BD2    700E                      MoveQ.L   $E, D0
BD4    C010                      And.B     (A0), D0
BD6    0C00 0008                 Cmp.B     $8, D0
BDA    6D04                      BLT       L102
BDC    5448                      AddQ      $2, A0
BDE    5449                      AddQ      $2, A1
BE0    D040           L102:      Add       D0, D0
BE2    2472 0000                 Move.L    $0(A2,D0.W), A2
BE6    4E92                      Jsr       (A2)
BE8    4CDF 0F0F                 MoveM.L   (A7)+, D0-D3/A0-A3

                      P_mSpurious_IntVIAandSCC:
BEC    4E73                      Rte

                      P_mExtBInt_StatusChngSCC:
BEE    47F8 02CF                 Lea.L     (SCCBSts), A3
BF2    45F8 02BE                 Lea.L     (ExtStsDT), A2
BF6    6008                      Bra       L103

                      P_mExtAInt_StatusChngSCC:
BF8    47F8 02CE                 Lea.L     (SCCASts), A3
BFC    45F8 02C6                 Lea.L     (ExtStsDT.A), A2
C00    1010           L103:      Move.B    (A0), D0
C02    1213                      Move.B    (A3), D1
C04    B101                      Eor.B     D0, D1
C06    1680                      Move.B    D0, (A3)
C08    12BC 0010                 Move.B    $10, (A1)
C0C    0C01 0008                 Cmp.B     $8, D1
C10    6602                      BNE       L104
C12    584A                      AddQ      $4, A2
C14    2452           L104:      Move.L    (A2), A2
C16    4ED2                      Jmp       (A2)

                      P_mOneSecInt_VIA:
C18    52B8 020C                 AddQ      $1, (Time)
C1C    137C 0001 1A00            Move.B    $1, $1A00(A1)

                      E_34:
C22    4E75                      Rts

                      P_mVBLInt_VIA:
C24    52B8 016A                 AddQ      $1, (Ticks)
C28    137C 0002 1A00            Move.B    $2, $1A00(A1)
C2E    46FC 2000                 Move      $2000, SR
C32    08F8 0006 0160            BSet.B    $6, (VBLQueueHdr_Flags)
C38    66E8                      BNE       E_34
C3A    2038 0110                 Move.L    (StackLowPoint), D0
C3E    6718                      BEQ       L106
C40    BFC0                      CmpA.L    D0, A7
C42    6400 0006                 BCC       L105
C46    21CF 0110                 Move.L    A7, (StackLowPoint)
C4A    2278 02AA      L105:      Move.L    (ApplZone), A1
C4E    BFD1                      CmpA.L    (A1), A7
C50    6400 0006                 BCC       L106
C54    701C                      MoveQ.L   $1C, D0
C56    A9C9                      _SysError
C58    2078 08EE      L106:      Move.L    (JCrsrTask), A0
C5C    4E90                      Jsr       (A0)
C5E    0838 0000 016D            BTst.B    $0, (Ticks.LoByte)
C64    6652                      BNE       L109
C66    7001                      MoveQ.L   $1, D0
C68    1439 00EF E1FE            Move.B    (VIA_Base), D2
C6E    E902                      AsL.B     $4, D2
C70    6A02                      BPL       L107
C72    7002                      MoveQ.L   $2, D0
C74    1238 0172      L107:      Move.B    (MBState), D1
C78    B501                      Eor.B     D2, D1
C7A    6A28                      BPL       L108
C7C    2238 016A                 Move.L    (Ticks), D1
C80    92B8 016E                 Sub.L     (MBTicks), D1
C84    0C81 0000 0003            Cmp.L     $3, D1
C8A    6D18                      BLT       L108
C8C    D3B8 0156                 Add.L     D1, (RndSeed)
C90    21F8 016A 016E            Move.L    (Ticks), (MBTicks)
C96    0202 0080                 And.B     $-80, D2
C9A    11C2 0172                 Move.B    D2, (MBState)
C9E    2040                      Move.L    D0, A0
CA0    7000                      MoveQ.L   $0, D0
CA2    A02F                      _PostEvent
CA4    1038 016D      L108:      Move.B    (Ticks.LoByte), D0
CA8    0200 001F                 And.B     $1F, D0
CAC    660A                      BNE       L109
CAE    2038 021A                 Move.L    (JKybdTask), D0
CB2    6704                      BEQ       L109
CB4    2040                      Move.L    D0, A0
CB6    4E90                      Jsr       (A0)
CB8    2038 0162      L109:      Move.L    (VBLQueueHdr.Head), D0
CBC    6724                      BEQ       L112
CBE    2040           L110:      Move.L    D0, A0
CC0    5368 000A                 SubQ.L    $1, $A(A0)
CC4    6618                      BNE       L111
CC6    2F08                      Move.L    A0, -(A7)
CC8    2268 0006                 Move.L    $6(A0), A1
CCC    4E91                      Jsr       (A1)
CCE    205F                      Move.L    (A7)+, A0
CD0    4A68 000A                 Tst       $A(A0)
CD4    6608                      BNE       L111
CD6    43F8 0160                 Lea.L     (VBLQueueHdr_Flags), A1
CDA    4EBA FE68                 Jsr       P14
CDE    2010           L111:      Move.L    (A0), D0
CE0    66DC                      BNE       L110
CE2    08B8 0006 0160 L112:      BClr.B    $6, (VBLQueueHdr_Flags)
CE8    4E75                      Rts

                      P_tVInstall:
CEA    0C68 0001 0004            Cmp       $1, $4(A0)
CF0    6704                      BEQ       L114
CF2    70FE           L113:      MoveQ.L   $-2, D0
CF4    4E75                      Rts
CF6    3228 000A      L114:      Move      $A(A0), D1
CFA    671A                      BEQ       L116
CFC    2038 016A                 Move.L    (Ticks), D0
D00    80C1                      DivU      D1, D0
D02    4840                      Swap      D0
D04    3228 000C                 Move      $C(A0), D1
D08    670C                      BEQ       L116
D0A    9041                      Sub       D1, D0
D0C    5240                      AddQ      $1, D0
D0E    6A02                      BPL       L115
D10    4440                      Neg       D0
D12    D168 000A      L115:      Add       D0, $A(A0)
D16    43F8 0160      L116:      Lea.L     (VBLQueueHdr_Flags), A1
D1A    4EBA FE04                 Jsr       P13
D1E    7000                      MoveQ.L   $0, D0
D20    4E75                      Rts

                      P_tVRemove:
D22    0C68 0001 0004            Cmp       $1, $4(A0)
D28    66C8                      BNE       L113
D2A    2F09                      Move.L    A1, -(A7)
D2C    43F8 0160                 Lea.L     (VBLQueueHdr_Flags), A1
D30    4EBA FE12                 Jsr       P14
D34    225F                      Move.L    (A7)+, A1
D36    4E75                      Rts

                      DT_mCRSRCore:
D38    001E 006E 013C            DC.B      '   n <'
D3E    01B2 01BA 0060            DC.B      '     `'
D44    017E 0010                 DC.B      ' ~  '

                      P_CrsrObscure:
D48    11FC 0001 08CD            Move.B    $1, (CrsrBusy)
D4E    08F8 0000 08D2            BSet.B    $0, (CrsrObscure)
D54    663C                      BNE       L119

                      P_HideCursor:
D56    11FC 0001 08CD            Move.B    $1, (CrsrBusy)
D5C    4A38 08CC                 Tst.B     (CrsrVis)
D60    672C                      BEQ       L118
D62    48E7 C0C0                 MoveM.L   D0-D1/A0-A1, -(A7)
D66    43F8 083C                 Lea.L     (CrsrRect), A1
D6A    3211                      Move      (A1), D1
D6C    4299                      Clr.L     (A1)+
D6E    9251                      Sub       (A1), D1
D70    4291                      Clr.L     (A1)
D72    4441                      Neg       D1
D74    2278 0888                 Move.L    (CrsrAddr), A1
D78    41F8 088C                 Lea.L     (CrsrSave), A0
D7C    7040                      MoveQ.L   $40, D0
D7E    2298           L117:      Move.L    (A0)+, (A1)
D80    D2C0                      AddA      D0, A1
D82    5341                      SubQ.L    $1, D1
D84    66F8                      BNE       L117
D86    4238 08CC                 Clr.B     (CrsrVis)
D8A    4CDF 0303                 MoveM.L   (A7)+, D0-D1/A0-A1
D8E    5378 08D0      L118:      SubQ.L    $1, (CrsrState)
D92    4238 08CD      L119:      Clr.B     (CrsrBusy)
D96    4E75                      Rts

                      P_InitCrsr:
D98    11FC 0001 08CD            Move.B    $1, (CrsrBusy)
D9E    4238 08D2                 Clr.B     (CrsrObscure)
DA2    4278 08D0                 Clr       (CrsrState)

                      P_ShowCursor:
DA6    11FC 0001 08CD            Move.B    $1, (CrsrBusy)
DAC    5278 08D0                 AddQ      $1, (CrsrState)
DB0    6DE0                      BLT       L119
DB2    4278 08D0                 Clr       (CrsrState)
DB6    4A38 08CC                 Tst.B     (CrsrVis)
DBA    66D6                      BNE       L119
DBC    48E7 FCF0                 MoveM.L   D0-D5/A0-A3, -(A7)
DC0    7A10                      MoveQ.L   $10, D5
DC2    41F8 088C                 Lea.L     (CrsrSave), A0
DC6    45F8 0844                 Lea.L     (TheCrsr_data), A2
DCA    47F8 0864                 Lea.L     (TheCrsr.mask), A3
DCE    3038 0832                 Move      (Mouse.h), D0
DD2    9078 0886                 Sub       (TheCrsr.hotspot.h), D0
DD6    740F                      MoveQ.L   $F, D2
DD8    C440                      And       D0, D2
DDA    4442                      Neg       D2
DDC    D445                      Add       D5, D2
DDE    7600                      MoveQ.L   $0, D3
DE0    5343                      SubQ.L    $1, D3
DE2    E5AB                      LsL.L     D2, D3
DE4    0240 FFF0                 And       $-10, D0
DE8    6C08                      BGE       L120
DEA    7000                      MoveQ.L   $0, D0
DEC    4843                      Swap      D3
DEE    9643                      Sub       D3, D3
DF0    D445                      Add       D5, D2
DF2    0C40 01E0      L120:      Cmp       $1E0, D0
DF6    6F0A                      BLE       L121
DF8    303C 01E0                 Move      $1E0, D0
DFC    9643                      Sub       D3, D3
DFE    4843                      Swap      D3
E00    D445                      Add       D5, D2
E02    3805           L121:      Move      D5, D4
E04    3238 0830                 Move      (Mouse_v), D1
E08    9278 0884                 Sub       (TheCrsr.hotspot_v), D1
E0C    6C0A                      BGE       L122
E0E    D841                      Add       D1, D4
E10    D241                      Add       D1, D1
E12    94C1                      SubA      D1, A2
E14    96C1                      SubA      D1, A3
E16    7200                      MoveQ.L   $0, D1
E18    0C41 0146      L122:      Cmp       $146, D1
E1C    6F06                      BLE       L123
E1E    383C 0156                 Move      $156, D4
E22    9841                      Sub       D1, D4
E24    43F8 083C      L123:      Lea.L     (CrsrRect), A1
E28    32C1                      Move      D1, (A1)+
E2A    32C0                      Move      D0, (A1)+
E2C    3281                      Move      D1, (A1)
E2E    D959                      Add       D4, (A1)+
E30    3280                      Move      D0, (A1)
E32    0651 0020                 Add       $20, (A1)
E36    2278 0824                 Move.L    (ScrnBase), A1
E3A    E648                      LsR       $3, D0
E3C    D2C0                      AddA      D0, A1
E3E    7A40                      MoveQ.L   $40, D5
E40    C2C5                      MulU      D5, D1
E42    D3C1                      AddA.L    D1, A1
E44    21C9 0888                 Move.L    A1, (CrsrAddr)
E48    6016                      Bra       L125
E4A    301A           L124:      Move      (A2)+, D0
E4C    E5B8                      ROL.L     D2, D0
E4E    C083                      And.L     D3, D0
E50    321B                      Move      (A3)+, D1
E52    E5B9                      ROL.L     D2, D1
E54    C283                      And.L     D3, D1
E56    4681                      Not.L     D1
E58    20D1                      Move.L    (A1), (A0)+
E5A    C391                      And.L     D1, (A1)
E5C    B191                      Eor.L     D0, (A1)
E5E    D2C5                      AddA      D5, A1
E60    51CC FFE8      L125:      DBF       D4, L124
E64    11FC 0001 08CC            Move.B    $1, (CrsrVis)
E6A    4CDF 0F3F                 MoveM.L   (A7)+, D0-D5/A0-A3
E6E    4238 08CD                 Clr.B     (CrsrBusy)
E72    4E75                      Rts

                      P_ShieldCursor:
E74    48E7 8080                 MoveM.L   D0/A0, -(A7)
E78    41F8 083C                 Lea.L     (CrsrRect), A0
E7C    302F 000C                 Move      $C(A7), D0
E80    B058                      Cmp       (A0)+, D0
E82    6D24                      BLT       L127
E84    0C50 01F0                 Cmp       $1F0, (A0)
E88    6C18                      BGE       L126
E8A    302F 000E                 Move      $E(A7), D0
E8E    B058                      Cmp       (A0)+, D0
E90    6F16                      BLE       L127
E92    302F 0010                 Move      $10(A7), D0
E96    B058                      Cmp       (A0)+, D0
E98    6C0E                      BGE       L127
E9A    302F 0012                 Move      $12(A7), D0
E9E    B050                      Cmp       (A0), D0
EA0    6C06                      BGE       L127
EA2    6100 FEB2      L126:      Bsr       P_HideCursor
EA6    6004                      Bra       L128
EA8    5378 08D0      L127:      SubQ.L    $1, (CrsrState)
EAC    4CDF 0101      L128:      MoveM.L   (A7)+, D0/A0
EB0    2E9F                      Move.L    (A7)+, (A7)
EB2    2E9F                      Move.L    (A7)+, (A7)
EB4    4E75                      Rts

                      P_SetCrsr:
EB6    206F 0008                 Move.L    $8(A7), A0
EBA    43F8 0844                 Lea.L     (TheCrsr_data), A1
EBE    740F                      MoveQ.L   $F, D2
EC0    7200                      MoveQ.L   $0, D1
EC2    2018           L129:      Move.L    (A0)+, D0
EC4    B091                      Cmp.L     (A1), D0
EC6    6702                      BEQ       L130
EC8    5241                      AddQ      $1, D1
ECA    22C0           L130:      Move.L    D0, (A1)+
ECC    51CA FFF4                 DBF       D2, L129
ED0    21EF 000E 0884            Move.L    $E(A7), (TheCrsr.hotspot_v)
ED6    4A41                      Tst       D1
ED8    6708                      BEQ       L131
EDA    6100 FE7A                 Bsr       P_HideCursor
EDE    6100 FEC6                 Bsr       P_ShowCursor
EE2    205F           L131:      Move.L    (A7)+, A0
EE4    DEFC 000E                 AddA      $E, A7
EE8    4ED0                      Jmp       (A0)

                      P_mScrnAddress:
EEA    2F78 0824 0004            Move.L    (ScrnBase), $4(A7)
EF0    4E75                      Rts

                      P_mScrnSize:
EF2    225F                      Move.L    (A7)+, A1
EF4    205F                      Move.L    (A7)+, A0
EF6    30BC 0156                 Move      $156, (A0)
EFA    205F                      Move.L    (A7)+, A0
EFC    30BC 0200                 Move      $200, (A0)
F00    4ED1                      Jmp       (A1)

                      P_SCCInt_AChng_MouseH:
F02    1239 00EF E1FE            Move.B    (VIA_Base), D1
F08    D040                      Add       D0, D0
F0A    B141                      Eor       D0, D1
F0C    0801 0004                 BTst.B    $4, D1
F10    670C                      BEQ       L132
F12    5278 082A                 AddQ      $1, (MTemp.h)
F16    11F8 08CF 08CE            Move.B    (CrsrCouple), (CrsrNew)
F1C    4E75                      Rts
F1E    5378 082A      L132:      SubQ.L    $1, (MTemp.h)
F22    11F8 08CF 08CE            Move.B    (CrsrCouple), (CrsrNew)
F28    4E75                      Rts

                      P_SCCInt_BChng_MouseV:
F2A    1239 00EF E1FE            Move.B    (VIA_Base), D1
F30    D040                      Add       D0, D0
F32    D040                      Add       D0, D0
F34    B141                      Eor       D0, D1
F36    0801 0005                 BTst.B    $5, D1
F3A    670C                      BEQ       L133
F3C    5378 0828                 SubQ.L    $1, (MTemp_v)
F40    11F8 08CF 08CE            Move.B    (CrsrCouple), (CrsrNew)
F46    4E75                      Rts
F48    5278 0828      L133:      AddQ      $1, (MTemp_v)
F4C    11F8 08CF 08CE            Move.B    (CrsrCouple), (CrsrNew)
F52    4E75           L134:      Rts

                      P_mCrsrVBLTask:
F54    4A38 08CE                 Tst.B     (CrsrNew)
F58    67F8                      BEQ       L134
F5A    4A38 08CD                 Tst.B     (CrsrBusy)
F5E    66F2                      BNE       L134
F60    4A38 08CF                 Tst.B     (CrsrCouple)
F64    675A                      BEQ       L140
F66    3038 0828                 Move      (MTemp_v), D0
F6A    9078 082C                 Sub       (RawMouse_v), D0
F6E    3400                      Move      D0, D2
F70    6C02                      BGE       L135
F72    4442                      Neg       D2
F74    3238 082A      L135:      Move      (MTemp.h), D1
F78    9278 082E                 Sub       (RawMouse.h), D1
F7C    6C04                      BGE       L136
F7E    9441                      Sub       D1, D2
F80    6002                      Bra       L137
F82    D441           L136:      Add       D1, D2
F84    4A38 08D3      L137:      Tst.B     (CrsrScale)
F88    670A                      BEQ       L138
F8A    B478 08EC                 Cmp       (CrsrThresh), D2
F8E    6D04                      BLT       L138
F90    D241                      Add       D1, D1
F92    D040                      Add       D0, D0
F94    D378 082E      L138:      Add       D1, (RawMouse.h)
F98    D178 082C                 Add       D0, (RawMouse_v)
F9C    41F8 0834                 Lea.L     (CrsrPin), A0
FA0    2038 082C                 Move.L    (RawMouse_v), D0
FA4    6132                      Bsr       P16
FA6    21C0 082C                 Move.L    D0, (RawMouse_v)
FAA    21C0 0828                 Move.L    D0, (MTemp_v)
FAE    C0B8 08D6                 And.L     (MouseMask), D0
FB2    2238 08DA                 Move.L    (MouseOffset), D1
FB6    6704                      BEQ       L139
FB8    D081                      Add.L     D1, D0
FBA    611C                      Bsr       P16
FBC    21C0 0830      L139:      Move.L    D0, (Mouse_v)
FC0    4A38 08D2      L140:      Tst.B     (CrsrObscure)
FC4    6604                      BNE       L141
FC6    6100 FD8E                 Bsr       P_HideCursor
FCA    4238 08CE      L141:      Clr.B     (CrsrNew)
FCE    4238 08D2                 Clr.B     (CrsrObscure)
FD2    6100 FDD2                 Bsr       P_ShowCursor
FD6    4E75                      Rts

                      P16:
FD8    B068 0002                 Cmp       $2(A0), D0
FDC    6C04                      BGE       L142
FDE    3028 0002                 Move      $2(A0), D0
FE2    B068 0006      L142:      Cmp       $6(A0), D0
FE6    6F06                      BLE       L143
FE8    3028 0006                 Move      $6(A0), D0
FEC    5340                      SubQ.L    $1, D0
FEE    4840           L143:      Swap      D0
FF0    B050                      Cmp       (A0), D0
FF2    6C02                      BGE       L144
FF4    3010                      Move      (A0), D0
FF6    B068 0004      L144:      Cmp       $4(A0), D0
FFA    6F06                      BLE       L145
FFC    3028 0004                 Move      $4(A0), D0
1000   5340                      SubQ.L    $1, D0
1002   4840           L145:      Swap      D0
1004   4E75                      Rts

                      P_tPinRect:
1006   202F 0004                 Move.L    $4(A7), D0
100A   206F 0008                 Move.L    $8(A7), A0
100E   61C8                      Bsr       P16
1010   205F                      Move.L    (A7)+, A0
1012   504F                      AddQ      $8, A7
1014   2E80                      Move.L    D0, (A7)
1016   4ED0                      Jmp       (A0)

                      P_mEMT1010_TrapDispatch:
1018   558F                      SubQ.L    $2, A7
101A   48E7 6020                 MoveM.L   D1-D2/A2, -(A7)
101E   246F 0010                 Move.L    $10(A7), A2
1022   341A                      Move      (A2)+, D2
1024   2F4A 0010                 Move.L    A2, $10(A7)
1028   3202                      Move      D2, D1
102A   0C42 A800                 Cmp       $-5800, D2
102E   6534                      BCS       L148
1030   6112                      Bsr       P17
1032   2F42 000C                 Move.L    D2, $C(A7)
1036   0C41 AC00                 Cmp       $-5400, D1
103A   4CDF 0406                 MoveM.L   (A7)+, D1-D2/A2
103E   6502                      BCS       L146
1040   2E9F                      Move.L    (A7)+, (A7)
1042   4E75           L146:      Rts

                      P17:
1044   0242 01FF                 And       $1FF, D2
1048   48C2                      Ext.L     D2
104A   D442                      Add       D2, D2
104C   45F8 0400                 Lea.L     (DispatchTab), A2
1050   3432 2000                 Move      $0(A2,D2.W), D2
1054   D442                      Add       D2, D2
1056   6506                      BCS       L147
1058   D4B8 02AE                 Add.L     (ROMBase), D2
105C   4E75                      Rts
105E   D4B8 02B2      L147:      Add.L     (RAMBase), D2
1062   4E75                      Rts
1064   0882 0008      L148:      BClr.B    $8, D2
1068   6618                      BNE       L150
106A   61D8                      Bsr       P17
106C   2442                      Move.L    D2, A2
106E   48E7 00C0                 MoveM.L   A0-A1, -(A7)
1072   4E92                      Jsr       (A2)
1074   4CDF 0300                 MoveM.L   (A7)+, A0-A1
1078   4CDF 0406      L149:      MoveM.L   (A7)+, D1-D2/A2
107C   584F                      AddQ      $4, A7
107E   4A40                      Tst       D0
1080   4E75                      Rts
1082   61C0           L150:      Bsr       P17
1084   2442                      Move.L    D2, A2
1086   2F09                      Move.L    A1, -(A7)
1088   4E92                      Jsr       (A2)
108A   225F                      Move.L    (A7)+, A1
108C   60EA                      Bra       L149

                      P_tGetTrapAddress:
108E   2F0A                      Move.L    A2, -(A7)
1090   3400                      Move      D0, D2
1092   61B0                      Bsr       P17
1094   2042                      Move.L    D2, A0
1096   245F                      Move.L    (A7)+, A2
1098   7000                      MoveQ.L   $0, D0
109A   4E75                      Rts

                      P_tSetTrapAddress:
109C   2208                      Move.L    A0, D1
109E   B2B8 02AE                 Cmp.L     (ROMBase), D1
10A2   6D18                      BLT       L152
10A4   92B8 02AE                 Sub.L     (ROMBase), D1
10A8   E259           L151:      ROR       $1, D1
10AA   0240 01FF                 And       $1FF, D0
10AE   D040                      Add       D0, D0
10B0   41F8 0400                 Lea.L     (DispatchTab), A0
10B4   3181 0000                 Move      D1, $0(A0,D0.W)
10B8   7000                      MoveQ.L   $0, D0
10BA   4E75                      Rts
10BC   92B8 02B2      L152:      Sub.L     (RAMBase), D1
10C0   5241                      AddQ      $1, D1
10C2   60E4                      Bra       L151

                      DT_mFSIODNETbl:
10C4   0006 004A 0052            DC.B      '   J R'

                      P_mFetch:
10CA   0880 000F                 BClr.B    $F, D0
10CE   48E7 4030      L153:      MoveM.L   D1/A2-A3, -(A7)
10D2   2229 0008                 Move.L    $8(A1), D1
10D6   6732                      BEQ       L157
10D8   2641                      Move.L    D1, A3
10DA   222B 0028                 Move.L    $28(A3), D1
10DE   246B 0020                 Move.L    $20(A3), A2
10E2   0880 000F                 BClr.B    $F, D0
10E6   6606                      BNE       L154
10E8   1032 1800                 Move.B    $0(A2,D1.L), D0
10EC   6004                      Bra       L155
10EE   1580 1800      L154:      Move.B    D0, $0(A2,D1.L)
10F2   5281           L155:      AddQ      $1, D1
10F4   2741 0028                 Move.L    D1, $28(A3)
10F8   B2AB 0024                 Cmp.L     $24(A3), D1
10FC   6D04                      BLT       L156
10FE   08C0 000F                 BSet.B    $F, D0
1102   4A40           L156:      Tst       D0
1104   4CDF 0C02                 MoveM.L   (A7)+, D1/A2-A3
1108   4E75                      Rts
110A   700E           L157:      MoveQ.L   $E, D0
110C   A9C9                      _SysError

                      P_mStash:
110E   08C0 000F                 BSet.B    $F, D0
1112   60BA                      Bra       L153
1114   7000           L158:      MoveQ.L   $0, D0

                      P_mIODone:
1116   2069 0008                 Move.L    $8(A1), A0
111A   0828 0001 0006            BTst.B    $1, $6(A0)
1120   661A                      BNE       L159
1122   40E7                      Move      SR, -(A7)
1124   40C1                      Move      SR, D1
1126   007C 0300                 Or        $300, SR
112A   610A                      Bsr       P18
112C   612A                      Bsr       P19
112E   4AA9 0008                 Tst.L     $8(A1)
1132   666A                      BNE       L164
1134   4E73                      Rte

                      P18:
1136   08A9 0007 0005            BClr.B    $7, $5(A1)
113C   0829 0006 0004 L159:      BTst.B    $6, $4(A1)
1142   6612                      BNE       L160
1144   2051                      Move.L    (A1), A0
1146   0890 0007                 BClr.B    $7, (A0)
114A   2078 02A6                 Move.L    (SysZone), A0
114E   D1E9 FFFC                 AddA.L    $-4(A1), A0
1152   0890 0007                 BClr.B    $7, (A0)
1156   4E75           L160:      Rts

                      P19:
1158   2069 0008                 Move.L    $8(A1), A0
115C   0C68 0002 0004            Cmp       $2, $4(A0)
1162   66A6                      BNE       L157
1164   2350 0008                 Move.L    (A0), $8(A1)
1168   6604                      BNE       L161
116A   42A9 000C                 Clr.L     $C(A1)
116E   46C1           L161:      Move      D1, SR
1170   3140 0010                 Move      D0, $10(A0)
1174   6F04                      BLE       L162
1176   4468 0010                 Neg       $10(A0)
117A   2228 000C      L162:      Move.L    $C(A0), D1
117E   670A                      BEQ       L163
1180   2F09                      Move.L    A1, -(A7)
1182   2241                      Move.L    D1, A1
1184   4A40                      Tst       D0
1186   4E91                      Jsr       (A1)
1188   225F                      Move.L    (A7)+, A1
118A   4E75           L163:      Rts

                      P20:
118C   2209                      Move.L    A1, D1
118E   43E9 0006                 Lea.L     $6(A1), A1
1192   4EBA F98C                 Jsr       P13
1196   2241                      Move.L    D1, A1
1198   40E7                      Move      SR, -(A7)
119A   007C 0300                 Or        $300, SR
119E   08E9 0007 0005 L164:      BSet.B    $7, $5(A1)
11A4   6704                      BEQ       L165
11A6   7000                      MoveQ.L   $0, D0
11A8   4E73                      Rte
11AA   46DF           L165:      Move      (A7)+, SR
11AC   2069 0008                 Move.L    $8(A1), A0
11B0   720C           L166:      MoveQ.L   $C, D1
11B2   0C28 0004 0007            Cmp.B     $4, $7(A0)
11B8   672A                      BEQ       P21
11BA   720E                      MoveQ.L   $E, D1
11BC   0C28 0005 0007            Cmp.B     $5, $7(A0)
11C2   6720                      BEQ       P21
11C4   4AA8 0024                 Tst.L     $24(A0)
11C8   6700 FF4A                 BEQ       L158
11CC   3028 002C                 Move      $2C(A0), D0
11D0   2228 002E                 Move.L    $2E(A0), D1
11D4   E410                      RXR.B     $2, D0
11D6   6A0A                      BPL       L168
11D8   6404                      BCC       L167
11DA   D2A9 0010                 Add.L     $10(A1), D1
11DE   2341 0010      L167:      Move.L    D1, $10(A1)
11E2   720A           L168:      MoveQ.L   $A, D1

                      P21:
11E4   2011                      Move.L    (A1), D0
11E6   6608                      BNE       L169
11E8   70EA                      MoveQ.L   $-16, D0
11EA   3140 0010                 Move      D0, $10(A0)
11EE   4E75                      Rts
11F0   48E7 1F7E      L169:      MoveM.L   D3-D7/A1-A6, -(A7)
11F4   2451                      Move.L    (A1), A2
11F6   0829 0006 0005            BTst.B    $6, $5(A1)
11FC   6724                      BEQ       L171
11FE   2678 02A6                 Move.L    (SysZone), A3
1202   D7E9 FFFC                 AddA.L    $-4(A1), A3
1206   08D3 0007                 BSet.B    $7, (A3)
120A   4A92                      Tst.L     (A2)
120C   660A                      BNE       L170
120E   2F0A                      Move.L    A2, -(A7)
1210   A9A2                      _LoadResource
1212   3038 0A60                 Move      (ResErr), D0
1216   6616                      BNE       L172
1218   08D2 0007      L170:      BSet.B    $7, (A2)
121C   2F12                      Move.L    (A2), -(A7)
121E   4217                      Clr.B     (A7)
1220   245F                      Move.L    (A7)+, A2
1222   3232 1000      L171:      Move      $0(A2,D1.W), D1
1226   7000                      MoveQ.L   $0, D0
1228   4EB2 1000                 Jsr       $0(A2,D1.W)
122C   6004                      Bra       L173
122E   3140 0010      L172:      Move      D0, $10(A0)
1232   4CDF 7EF8      L173:      MoveM.L   (A7)+, D3-D7/A1-A6
1236   4E75                      Rts

                      P22:
1238   4642                      Not       D2
123A   6B1E                      BMI       L174
123C   B478 01D2                 Cmp       (UnitTableEntryCount), D2
1240   6C18                      BGE       L174
1242   E542                      AsL       $2, D2
1244   2278 011C                 Move.L    (UTableBase), A1
1248   2431 2000                 Move.L    $0(A1,D2.W), D2
124C   670C                      BEQ       L174
124E   2442                      Move.L    D2, A2
1250   2412                      Move.L    (A2), D2
1252   6700 FEB6                 BEQ       L157
1256   2242                      Move.L    D2, A1
1258   4E75                      Rts
125A   4CDF 0C39      L174:      MoveM.L   (A7)+, D0/D3-D5/A2-A3
125E   70EB                      MoveQ.L   $-15, D0
1260   4E75                      Rts

                      P_tOpen:
1262   48E7 1C30                 MoveM.L   D3-D5/A2-A3, -(A7)
1266   2A08                      Move.L    A0, D5
1268   3141 0006                 Move      D1, $6(A0)
126C   4A78 0A58                 Tst       (SysMap)
1270   6B6C                      BMI       L177
1272   594F                      SubQ.L    $4, A7
1274   2F3C 4452 5652            Move.L    $44525652, -(A7)
127A   2668 0012                 Move.L    $12(A0), A3
127E   2F0B                      Move.L    A3, -(A7)
1280   A9A1                      _GetNamedResource
1282   261F                      Move.L    (A7)+, D3
1284   6758                      BEQ       L177
1286   3038 0A60                 Move      (ResErr), D0
128A   6628                      BNE       L175
128C   4E56 FEF2                 Link      A6, $-10E
1290   2F03                      Move.L    D3, -(A7)
1292   486E FFFC                 Pea.L     $-4(A6)
1296   486E FFF8                 Pea.L     $-8(A6)
129A   486E FEF2                 Pea.L     $-10E(A6)
129E   A9A8                      _GetResInfo
12A0   382E FFFC                 Move      $-4(A6), D4
12A4   4644                      Not       D4
12A6   4E5E                      Unlk      A6
12A8   3004                      Move      D4, D0
12AA   6100 022C                 Bsr       P23
12AE   6608                      BNE       L176
12B0   3004                      Move      D4, D0
12B2   A03D                      _DrvrInstall
12B4   6600 00CA      L175:      BNE       L183
12B8   3404           L176:      Move      D4, D2
12BA   6100 FF7C                 Bsr       P22
12BE   2283                      Move.L    D3, (A1)
12C0   2043                      Move.L    D3, A0
12C2   2050                      Move.L    (A0), A0
12C4   3358 0004                 Move      (A0)+, $4(A1)
12C8   2358 0022                 Move.L    (A0)+, $22(A1)
12CC   3358 0026                 Move      (A0)+, $26(A1)
12D0   08A9 0007 0005            BClr.B    $7, $5(A1)
12D6   08E9 0006 0005            BSet.B    $6, $5(A1)
12DC   604E                      Bra       L180
12DE   2045           L177:      Move.L    D5, A0
12E0   2678 011C                 Move.L    (UTableBase), A3
12E4   7409                      MoveQ.L   $9, D2
12E6   78FF                      MoveQ.L   $-1, D4
12E8   201B           L178:      Move.L    (A3)+, D0
12EA   672E                      BEQ       L179
12EC   2440                      Move.L    D0, A2
12EE   2012                      Move.L    (A2), D0
12F0   6728                      BEQ       L179
12F2   2240                      Move.L    D0, A1
12F4   0829 0006 0005            BTst.B    $6, $5(A1)
12FA   661E                      BNE       L179
12FC   48E7 00C0                 MoveM.L   A0-A1, -(A7)
1300   2068 0012                 Move.L    $12(A0), A0
1304   2251                      Move.L    (A1), A1
1306   43E9 0012                 Lea.L     $12(A1), A1
130A   7000                      MoveQ.L   $0, D0
130C   1018                      Move.B    (A0)+, D0
130E   4840                      Swap      D0
1310   1019                      Move.B    (A1)+, D0
1312   A03C                      _CmpString
1314   4CDF 0300                 MoveM.L   (A7)+, A0-A1
1318   6712                      BEQ       L180
131A   5344           L179:      SubQ.L    $1, D4
131C   5342                      SubQ.L    $1, D2
131E   6EC8                      BGT       L178
1320   3228 0006                 Move      $6(A0), D1
1324   4CDF 0C38                 MoveM.L   (A7)+, D3-D5/A2-A3
1328   4EFA 2BE4                 Jmp       L742
132C   0829 0006 0004 L180:      BTst.B    $6, $4(A1)
1332   6710                      BEQ       L181
1334   7008                      MoveQ.L   $8, D0
1336   4840                      Swap      D0
1338   A04C                      _CompactMem
133A   2051                      Move.L    (A1), A0
133C   08D0 0007                 BSet.B    $7, (A0)
1340   08D2 0007                 BSet.B    $7, (A2)
1344   2045           L181:      Move.L    D5, A0
1346   3144 0018                 Move      D4, $18(A0)
134A   70E9                      MoveQ.L   $-17, D0
134C   1229 0004                 Move.B    $4(A1), D1
1350   3401                      Move      D1, D2
1352   8228 001B                 Or.B      $1B(A0), D1
1356   B501                      Eor.B     D2, D1
1358   0201 0003                 And.B     $3, D1
135C   6622                      BNE       L183
135E   08E9 0005 0005            BSet.B    $5, $5(A1)
1364   6620                      BNE       L184
1366   7208                      MoveQ.L   $8, D1
1368   6100 FE7A                 Bsr       P21
136C   0829 0006 0004            BTst.B    $6, $4(A1)
1372   6612                      BNE       L184
1374   7000                      MoveQ.L   $0, D0
1376   2051           L182:      Move.L    (A1), A0
1378   0890 0007                 BClr.B    $7, (A0)
137C   0892 0007                 BClr.B    $7, (A2)
1380   4CDF 0C38      L183:      MoveM.L   (A7)+, D3-D5/A2-A3
1384   4E75                      Rts
1386   7000           L184:      MoveQ.L   $0, D0
1388   60F6                      Bra       L183

                      P_tClose:
138A   3428 0018                 Move      $18(A0), D2
138E   6B04                      BMI       L185
1390   4EFA 340E                 Jmp       P_mFileClose
1394   48E7 1C30      L185:      MoveM.L   D3-D5/A2-A3, -(A7)
1398   6100 FE9E                 Bsr       P22
139C   0829 0005 0005            BTst.B    $5, $5(A1)
13A2   67E2                      BEQ       L184
13A4   0829 0007 0005 L186:      BTst.B    $7, $5(A1)
13AA   66F8                      BNE       L186
13AC   7210                      MoveQ.L   $10, D1
13AE   6100 FE34                 Bsr       P21
13B2   08A9 0005 0005            BClr.B    $5, $5(A1)
13B8   60BC                      Bra       L182

                      P_tRead:
13BA   3428 0018                 Move      $18(A0), D2
13BE   6B04                      BMI       L187
13C0   4EFA 30D2                 Jmp       L_mFileRead
13C4   48E7 1C30      L187:      MoveM.L   D3-D5/A2-A3, -(A7)
13C8   70ED                      MoveQ.L   $-13, D0
13CA   7800                      MoveQ.L   $0, D4
13CC   6100 FE6A      L188:      Bsr       P22
13D0   0C01 0003                 Cmp.B     $3, D1
13D4   6E04                      BGT       L189
13D6   42A8 0028                 Clr.L     $28(A0)
13DA   317C 0001 0010 L189:      Move      $1, $10(A0)
13E0   3141 0006                 Move      D1, $6(A0)
13E4   317C 0002 0004            Move      $2, $4(A0)
13EA   0929 0004                 BTst.B    D4, $4(A1)
13EE   4CDF 0C38                 MoveM.L   (A7)+, D3-D5/A2-A3
13F2   672C                      BEQ       L191
13F4   70E4                      MoveQ.L   $-1C, D0
13F6   0829 0005 0005            BTst.B    $5, $5(A1)
13FC   6722                      BEQ       L191
13FE   0801 0009                 BTst.B    $9, D1
1402   6600 FDAC                 BNE       L166
1406   0801 000A                 BTst.B    $A, D1
140A   6600 FD80                 BNE       P20
140E   42A8 000C                 Clr.L     $C(A0)
1412   2F08                      Move.L    A0, -(A7)
1414   6100 FD76                 Bsr       P20
1418   205F                      Move.L    (A7)+, A0
141A   3028 0010      L190:      Move      $10(A0), D0
141E   6EFA                      BGT       L190
1420   4E75           L191:      Rts

                      P_tWrite:
1422   3428 0018                 Move      $18(A0), D2
1426   6B04                      BMI       L192
1428   4EFA 3298                 Jmp       P_mFileWrite
142C   48E7 1C30      L192:      MoveM.L   D3-D5/A2-A3, -(A7)
1430   70EC                      MoveQ.L   $-14, D0
1432   7801                      MoveQ.L   $1, D4
1434   6096                      Bra       L188

                      P_tControl:
1436   48E7 1C30                 MoveM.L   D3-D5/A2-A3, -(A7)
143A   3428 0018                 Move      $18(A0), D2
143E   70EF                      MoveQ.L   $-11, D0
1440   7802                      MoveQ.L   $2, D4
1442   6088                      Bra       L188

                      P_tStatus:
1444   48E7 1C30                 MoveM.L   D3-D5/A2-A3, -(A7)
1448   3428 0018                 Move      $18(A0), D2
144C   0C68 0001 001A            Cmp       $1, $1A(A0)
1452   6708                      BEQ       L193
1454   70EE                      MoveQ.L   $-12, D0
1456   7803                      MoveQ.L   $3, D4
1458   6000 FF72                 Bra       L188
145C   6100 FDDA      L193:      Bsr       P22
1460   214A 001C                 Move.L    A2, $1C(A0)
1464   6000 FF20                 Bra       L184

                      P_tKillIO:
1468   48E7 1C30                 MoveM.L   D3-D5/A2-A3, -(A7)
146C   3428 0018                 Move      $18(A0), D2
1470   6100 FDC6                 Bsr       P22
1474   317C 0001 001A            Move      $1, $1A(A0)
147A   40E7                      Move      SR, -(A7)
147C   007C 0300                 Or        $300, SR
1480   720C                      MoveQ.L   $C, D1
1482   6100 FD60                 Bsr       P21
1486   6618                      BNE       L196
1488   4AA9 0008      L194:      Tst.L     $8(A1)
148C   670C                      BEQ       L195
148E   70E5                      MoveQ.L   $-1B, D0
1490   323C 2300                 Move      $2300, D1
1494   6100 FCC2                 Bsr       P19
1498   60EE                      Bra       L194
149A   6100 FC9A      L195:      Bsr       P18
149E   7000                      MoveQ.L   $0, D0
14A0   46DF           L196:      Move      (A7)+, SR
14A2   6000 FEDC                 Bra       L183

                      P_tDrvrInstall:
14A6   48E7 1C30                 MoveM.L   D3-D5/A2-A3, -(A7)
14AA   2648                      Move.L    A0, A3
14AC   2600                      Move.L    D0, D3
14AE   6128                      Bsr       P23
14B0   6606                      BNE       L197
14B2   7028                      MoveQ.L   $28, D0
14B4   A522                      _NewHandleSys
14B6   661A                      BNE       L200
14B8   7027           L197:      MoveQ.L   $27, D0
14BA   2250                      Move.L    (A0), A1
14BC   4219           L198:      Clr.B     (A1)+
14BE   51C8 FFFC                 DBF       D0, L198
14C2   2488                      Move.L    A0, (A2)
14C4   2650                      Move.L    (A0), A3
14C6   08EB 0006 0005            BSet.B    $6, $5(A3)
14CC   3743 0018                 Move      D3, $18(A3)
14D0   7000           L199:      MoveQ.L   $0, D0
14D2   4CDF 0C38      L200:      MoveM.L   (A7)+, D3-D5/A2-A3
14D6   4E75                      Rts

                      P23:
14D8   4640                      Not       D0
14DA   6B14                      BMI       L201
14DC   B078 01D2                 Cmp       (UnitTableEntryCount), D0
14E0   6C0E                      BGE       L201
14E2   E540                      AsL       $2, D0
14E4   2478 011C                 Move.L    (UTableBase), A2
14E8   D4C0                      AddA      D0, A2
14EA   2052                      Move.L    (A2), A0
14EC   2008                      Move.L    A0, D0
14EE   4E75                      Rts
14F0   6000 FD68      L201:      Bra       L174

                      P_tDrvrRemove:
14F4   48E7 1C30                 MoveM.L   D3-D5/A2-A3, -(A7)
14F8   61DE                      Bsr       P23
14FA   67D4                      BEQ       L199
14FC   264A                      Move.L    A2, A3
14FE   2440                      Move.L    D0, A2
1500   2252                      Move.L    (A2), A1
1502   0829 0005 0005            BTst.B    $5, $5(A1)
1508   6614                      BNE       L203
150A   0829 0006 0005            BTst.B    $6, $5(A1)
1510   6704                      BEQ       L202
1512   2F11                      Move.L    (A1), -(A7)
1514   A9A3                      _ReleaseResource
1516   204A           L202:      Move.L    A2, A0
1518   A023                      _DisposeHandle
151A   4293                      Clr.L     (A3)
151C   60B2                      Bra       L199
151E   70E7           L203:      MoveQ.L   $-19, D0
1520   60B0                      Bra       L200

                      P_InitKeyboard:
1522   4238 021E                 Clr.B     (KbdType)
1526   42B8 0216                 Clr.L     (KbdVers)
152A   6100 0152                 Bsr       P27
152E   50F8 0216                 ST.B      (KbdVers)
1532   41FA 0068                 Lea.L     P_VIAInt_KeyDataReady, A0
1536   21C8 019A                 Move.L    A0, (Lvl1DT.2)
153A   42B8 029E                 Clr.L     (Key1Trans)
153E   42B8 02A2                 Clr.L     (Key2Trans)
1542   41FA 012C                 Lea.L     P_KybdTask, A0
1546   21C8 021A                 Move.L    A0, (JKybdTask)

                      P25:
154A   2278 01D4                 Move.L    (VIA), A1
154E   4229 1800                 Clr.B     $1800(A1)
1552   137C 0087 1C00            Move.B    $-79, $1C00(A1)
1558   7016                      MoveQ.L   $16, D0
155A   50F8 0218                 ST.B      (KbdLast)
155E   2278 01D4      L204:      Move.L    (VIA), A1
1562   40E7                      Move      SR, -(A7)
1564   007C 0300                 Or        $300, SR
1568   1229 1600                 Move.B    $1600(A1), D1
156C   0201 00E3                 And.B     $-1D, D1
1570   3F01                      Move      D1, -(A7)
1572   1341 1600                 Move.B    D1, $1600(A1)
1576   4229 1400                 Clr.B     $1400(A1)
157A   0001 0018                 Or.B      $18, D1
157E   1341 1600                 Move.B    D1, $1600(A1)
1582   4229 1400                 Clr.B     $1400(A1)
1586   4E71                      Nop
1588   321F                      Move      (A7)+, D1
158A   1341 1600                 Move.B    D1, $1600(A1)
158E   0001 001C                 Or.B      $1C, D1
1592   1341 1600                 Move.B    D1, $1600(A1)
1596   1340 1400                 Move.B    D0, $1400(A1)
159A   4E73                      Rte

                      P_VIAInt_KeyDataReady:
159C   0829 0004 1600            BTst.B    $4, $1600(A1)
15A2   671A                      BEQ       L206
15A4   137C 0004 1A00            Move.B    $4, $1A00(A1)
15AA   303C 0096                 Move      $96, D0
15AE   51C8 FFFE      L205:      DBF       D0, L205
15B2   08A9 0004 1600            BClr.B    $4, $1600(A1)
15B8   1029 1400                 Move.B    $1400(A1), D0
15BC   4E75                      Rts
15BE   50F8 0216      L206:      ST.B      (KbdVers)
15C2   1029 1400                 Move.B    $1400(A1), D0
15C6   1600                      Move.B    D0, D3
15C8   0C00 007B                 Cmp.B     $7B, D0
15CC   671E                      BEQ       L208
15CE   4A38 0218                 Tst.B     (KbdLast)
15D2   670A                      BEQ       L207
15D4   11C0 021E                 Move.B    D0, (KbdType)
15D8   4238 0218                 Clr.B     (KbdLast)
15DC   600E                      Bra       L208
15DE   0C00 0079      L207:      Cmp.B     $79, D0
15E2   660E                      BNE       L210
15E4   50F8 0217                 ST.B      (KbdVars.1)
15E8   7014                      MoveQ.L   $14, D0
15EA   6002                      Bra       L209
15EC   7010           L208:      MoveQ.L   $10, D0
15EE   6000 FF6E      L209:      Bra       L204
15F2   747F           L210:      MoveQ.L   $7F, D2
15F4   C400                      And.B     D0, D2
15F6   E20A                      LsR.B     $1, D2
15F8   4A38 0217                 Tst.B     (KbdVars.1)
15FC   6704                      BEQ       L211
15FE   0642 0040                 Add       $40, D2
1602   4A03           L211:      Tst.B     D3
1604   6A0E                      BPL       L212
1606   3238 0184                 Move      (KeyLast), D1
160A   E049                      LsR       $8, D1
160C   B401                      Cmp.B     D1, D2
160E   6604                      BNE       L212
1610   4278 0184                 Clr       (KeyLast)
1614   2F02           L212:      Move.L    D2, -(A7)
1616   6128                      Bsr       P26
1618   241F                      Move.L    (A7)+, D2
161A   E14A                      LsL       $8, D2
161C   1400                      Move.B    D0, D2
161E   67CC                      BEQ       L208
1620   7004                      MoveQ.L   $4, D0
1622   4A03                      Tst.B     D3
1624   6B12                      BMI       L213
1626   7003                      MoveQ.L   $3, D0
1628   21F8 016A 0186            Move.L    (Ticks), (KeyTime)
162E   21F8 016A 018A            Move.L    (Ticks), (KeyRepTime)
1634   31C2 0184                 Move      D2, (KeyLast)
1638   2040           L213:      Move.L    D0, A0
163A   2002                      Move.L    D2, D0
163C   A02F                      _PostEvent
163E   60AC                      Bra       L208

                      P26:
1640   41F8 0174                 Lea.L     (KeyMap), A0
1644   3202                      Move      D2, D1
1646   E649                      LsR       $3, D1
1648   D0C1                      AddA      D1, A0
164A   05D0                      BSet.B    D2, (A0)
164C   4A03                      Tst.B     D3
164E   6A02                      BPL       L214
1650   0590                      BClr.B    D2, (A0)
1652   2F38 029E      L214:      Move.L    (Key1Trans), -(A7)
1656   4A38 0217                 Tst.B     (KbdVars.1)
165A   6708                      BEQ       L215
165C   2EB8 02A2                 Move.L    (Key2Trans), (A7)
1660   4238 0217                 Clr.B     (KbdVars.1)
1664   3238 017A      L215:      Move      (KeyMap.6), D1
1668   4A97                      Tst.L     (A7)
166A   6602                      BNE       L216
166C   201F                      Move.L    (A7)+, D0
166E   4E75           L216:      Rts

                      P_KybdTask:
1670   4A38 0216                 Tst.B     (KbdVers)
1674   6614                      BNE       L218
1676   4238 021E                 Clr.B     (KbdType)
167A   6100 FECE                 Bsr       P25

                      P27:
167E   41F8 0174                 Lea.L     (KeyMap), A0
1682   7008                      MoveQ.L   $8, D0
1684   4258           L217:      Clr       (A0)+
1686   51C8 FFFC                 DBF       D0, L217
168A   4238 0216      L218:      Clr.B     (KbdVers)
168E   4E75                      Rts

                      Driver_Sony:
1690   4F00                      DC.W      $4F00           ; flags
1692   0000                      DC.W      $0000           ; number of ticks between periodic actions
1694   0000                      DC.W      $0000           ; desk accessory event mask
1696   0000                      DC.W      $0000           ; menu ID
1698   0050                      DC.W      $0050           ; offset to open routine
169A   018C                      DC.W      $018C           ; offset to prime routine
169C   00DA                      DC.W      $00DA           ; offset to control routine
169E   0144                      DC.W      $0144           ; offset to status routine
16A0   00B4                      DC.W      $00B4           ; offset to close routine
16A2   05                        DC.B      $05             ; length of driver name
                      ; Name
16A3   2E53 6F6E 79              DC.B      '.Sony'
                      ; end of Name

                      DT15:
16A8   0870 017A 0A0C            DC.B      ' p z  '
16AE   0AC8 0D20 05EC            DC.B      '      '
16B4   09D4 06DC 00C8            DC.B      '      '
16BA   065A 02B4 07DA            DC.B      ' Z    '

                      DT16:
16C0   0800 0200 4000            DC.B      '    @ '
16C6   0800 0000 012C            DC.B      '     ,'
16CC   05DC 0FA0 0005            DC.B      '      '
16D2   0078 0064 001E            DC.B      ' x d  '
16D8   1D4C 0000 3840            DC.B      ' L  8@'
16DE   FC00                      DC.B      '  '

                      E_Sony_Open:
16E0   707D                      MoveQ.L   $7D, D0
16E2   D080                      Add.L     D0, D0
16E4   A71E                      _NewPtrSysClear
16E6   21C8 0134                 Move.L    A0, (SonyVars)
16EA   2448                      Move.L    A0, A2
16EC   2089                      Move.L    A1, (A0)
16EE   3429 0018                 Move      $18(A1), D2
16F2   43F8 0308                 Lea.L     (DrvQHdr_Flags), A1
16F6   4EBA F492                 Jsr       P_mInitQueue
16FA   704A                      MoveQ.L   $4A, D0
16FC   41F2 0006                 Lea.L     $6(A2,D0.W), A0
1700   7001                      MoveQ.L   $1, D0
1702   6142                      Bsr       P28
1704   D0FC 0042                 AddA      $42, A0
1708   7002                      MoveQ.L   $2, D0
170A   613A                      Bsr       P28
170C   41FA FF9A                 Lea.L     DT15, A0
1710   43F8 0222                 Lea.L     (DiskVars_JFigTrkSpd), A1
1714   720B                      MoveQ.L   $B, D1
1716   4EBA EED4                 Jsr       P_mJmpTblInit
171A   50EA 0018                 ST.B      $18(A2)
171E   43EA 002A                 Lea.L     $2A(A2), A1
1722   41FA FF9C                 Lea.L     DT16, A0
1726   7020                      MoveQ.L   $20, D0
1728   A02E                      _BlockMove
172A   41EA 0004                 Lea.L     $4(A2), A0
172E   317C 0001 0004            Move      $1, $4(A0)
1734   43FA 0892                 Lea.L     E_88, A1
1738   2149 0006                 Move.L    A1, $6(A0)
173C   317C 001E 000A            Move      $1E, $A(A0)
1742   A033                      _VInstall

                      E_Sony_Close:
1744   4E75                      Rts

                      P28:
1746   4840                      Swap      D0
1748   3002                      Move      D2, D0

                      P_tAddDrive:
174A   2140 0006                 Move.L    D0, $6(A0)
174E   43F8 0308                 Lea.L     (DrvQHdr_Flags), A1
1752   4EFA F3CC                 Jmp       P13
1756   31C0 0142      L219:      Move      D0, (DskErr)
175A   2278 0134                 Move.L    (SonyVars), A1
175E   4229 0019                 Clr.B     $19(A1)
1762   2251                      Move.L    (A1), A1
1764   2F38 08FC                 Move.L    (JIODone), -(A7)
1768   4E75                      Rts

                      E_Sony_Control:
176A   2F38 0242                 Move.L    (DiskVars.JControl), -(A7)
176E   4E75                      Rts

                      P_Sony_Control:
1770   3028 001A                 Move      $1A(A0), D0
1774   5340                      SubQ.L    $1, D0
1776   6616                      BNE       L220
1778   40E7                      Move      SR, -(A7)
177A   007C 0100                 Or        $100, SR
177E   6100 068C                 Bsr       P44
1782   157C 0020 1C00            Move.B    $20, $1C00(A2)
1788   4229 0019                 Clr.B     $19(A1)
178C   4E73                      Rte
178E   5D40           L220:      SubQ.L    $6, D0
1790   6714                      BEQ       L222
1792   5340                      SubQ.L    $1, D0
1794   660C                      BNE       L221
1796   2278 0134                 Move.L    (SonyVars), A1
179A   2368 001C 00F4            Move.L    $1C(A0), $F4(A1)
17A0   602E                      Bra       L223
17A2   70EF           L221:      MoveQ.L   $-11, D0
17A4   60B0                      Bra       L219
17A6   6150           L222:      Bsr       P29
17A8   66AC                      BNE       L219
17AA   6100 0678                 Bsr       P45
17AE   700D                      MoveQ.L   $D, D0
17B0   6100 03AA                 Bsr       P34
17B4   4A28 0E00                 Tst.B     $E00(A0)
17B8   3029 0042                 Move      $42(A1), D0
17BC   6100 053E                 Bsr       E_Sony_WakeUp
17C0   13A9 0048 1003            Move.B    $48(A1), $3(A1,D1.W)
17C6   4A28 0C00                 Tst.B     $C00(A0)
17CA   7000                      MoveQ.L   $0, D0
17CC   6100 063E                 Bsr       P44
17D0   7000           L223:      MoveQ.L   $0, D0
17D2   6082                      Bra       L219

                      E_Sony_Status:
17D4   70EE                      MoveQ.L   $-12, D0
17D6   0C68 0008 001A            Cmp       $8, $1A(A0)
17DC   6600 FF78                 BNE       L219
17E0   6116                      Bsr       P29
17E2   6600 FF72                 BNE       L219
17E6   41E8 001C                 Lea.L     $1C(A0), A0
17EA   700B                      MoveQ.L   $B, D0
17EC   D2C1                      AddA      D1, A1
17EE   30D9           L224:      Move      (A1)+, (A0)+
17F0   5340                      SubQ.L    $1, D0
17F2   6EFA                      BGT       L224
17F4   6000 FF60                 Bra       L219

                      P29:
17F8   2278 0134                 Move.L    (SonyVars), A1
17FC   50E9 0019                 ST.B      $19(A1)
1800   3028 0016                 Move      $16(A0), D0
1804   6712                      BEQ       L225
1806   0C40 0002                 Cmp       $2, D0
180A   6E0C                      BGT       L225
180C   3340 0012                 Move      D0, $12(A1)
1810   6100 0334                 Bsr       P33
1814   7000                      MoveQ.L   $0, D0
1816   4E75                      Rts
1818   70C8           L225:      MoveQ.L   $-38, D0
181A   4E75                      Rts

                      E_Sony_Prime:
181C   2F38 0226                 Move.L    (DiskVars.JDiskPrime), -(A7)
1820   4E75                      Rts

                      P_Sony_DiskPrime:
1822   007C 0100                 Or        $100, SR
1826   3628 0006                 Move      $6(A0), D3
182A   0828 0006 002D            BTst.B    $6, $2D(A0)
1830   56F8 012C                 SNE.B     (DskVerify)
1834   61C2                      Bsr       P29
1836   6670                      BNE       L231
1838   3343 0032                 Move      D3, $32(A1)
183C   6100 060E                 Bsr       P47
1840   6100 07F4                 Bsr       P55
1844   6B62                      BMI       L231
1846   7002                      MoveQ.L   $2, D0
1848   6100 0348                 Bsr       P35
184C   6A08                      BPL       L226
184E   4231 1003                 Clr.B     $3(A1,D1.W)
1852   70BF                      MoveQ.L   $-41, D0
1854   6052                      Bra       L231
1856   0C31 0002 1003 L226:      Cmp.B     $2, $3(A1,D1.W)
185C   6724                      BEQ       L227
185E   6100 05C4                 Bsr       P45
1862   6100 051A                 Bsr       E_Sony_Recal
1866   6B34                      BMI       L229
1868   6100 0612                 Bsr       E_Sony_MakeSpdTbl
186C   662E                      BNE       L229
186E   7006                      MoveQ.L   $6, D0
1870   6100 0320                 Bsr       P35
1874   5AF1 1002                 SPL.B     $2(A1,D1.W)
1878   13BC 0002 1003            Move.B    $2, $3(A1,D1.W)
187E   4231 1012                 Clr.B     $12(A1,D1.W)
1882   6100 0230      L227:      Bsr       P31
1886   6728                      BEQ       L232
1888   3378 0302 0026            Move      (BufTgFBkNum), $26(A1)
188E   4A31 1002                 Tst.B     $2(A1,D1.W)
1892   6A1C                      BPL       L232
1894   70D4                      MoveQ.L   $-2C, D0
1896   3429 003A      L228:      Move      $3A(A1), D2
189A   6002                      Bra       L230
189C   7400           L229:      MoveQ.L   $0, D2
189E   3F00           L230:      Move      D0, -(A7)
18A0   3002                      Move      D2, D0
18A2   6100 0568                 Bsr       P44
18A6   301F                      Move      (A7)+, D0
18A8   027C F8FF      L231:      And       $-701, SR
18AC   6000 FEA8                 Bra       L219
18B0   3C31 1000      L232:      Move      $0(A1,D1.W), D6
18B4   6100 0308                 Bsr       P38
18B8   6100 056E                 Bsr       P46
18BC   50F1 1013                 ST.B      $13(A1,D1.W)
18C0   2451           L233:      Move.L    (A1), A2
18C2   206A 0008                 Move.L    $8(A2), A0
18C6   202A 0010                 Move.L    $10(A2), D0
18CA   E088                      LsR.L     $8, D0
18CC   E288                      LsR.L     $1, D0
18CE   7400                      MoveQ.L   $0, D2
18D0   7600                      MoveQ.L   $0, D3
18D2   7E04                      MoveQ.L   $4, D7
18D4   780D                      MoveQ.L   $D, D4
18D6   7A0F           L234:      MoveQ.L   $F, D5
18D8   5344                      SubQ.L    $1, D4
18DA   7C00           L235:      MoveQ.L   $0, D6
18DC   D444           L236:      Add       D4, D2
18DE   B440                      Cmp       D0, D2
18E0   6E18                      BGT       L239
18E2   4A06                      Tst.B     D6
18E4   6606                      BNE       L237
18E6   1C31 1012                 Move.B    $12(A1,D1.W), D6
18EA   66F0                      BNE       L236
18EC   5243           L237:      AddQ      $1, D3
18EE   51CD FFEA                 DBF       D5, L235
18F2   51CF FFE2                 DBF       D7, L234
18F6   70CE           L238:      MoveQ.L   $-32, D0
18F8   609C                      Bra       L228
18FA   4A06           L239:      Tst.B     D6
18FC   670E                      BEQ       L240
18FE   08C3 000B                 BSet.B    $B, D3
1902   4A31 1005                 Tst.B     $5(A1,D1.W)
1906   6604                      BNE       L240
1908   70B2                      MoveQ.L   $-4E, D0
190A   608A                      Bra       L228
190C   3343 0016      L240:      Move      D3, $16(A1)
1910   9042                      Sub       D2, D0
1912   D840                      Add       D0, D4
1914   4440                      Neg       D0
1916   3344 0020                 Move      D4, $20(A1)
191A   2A28 0024                 Move.L    $24(A0), D5
191E   2428 0028                 Move.L    $28(A0), D2
1922   9A82                      Sub.L     D2, D5
1924   E08D                      LsR.L     $8, D5
1926   E28D                      LsR.L     $1, D5
1928   67CC                      BEQ       L238
192A   B045                      Cmp       D5, D0
192C   6F02                      BLE       L241
192E   3005                      Move      D5, D0
1930   7600           L241:      MoveQ.L   $0, D3
1932   09C3           L242:      BSet.B    D4, D3
1934   5244                      AddQ      $1, D4
1936   5340                      SubQ.L    $1, D0
1938   66F8                      BNE       L242
193A   2343 0022                 Move.L    D3, $22(A1)
193E   2628 0020                 Move.L    $20(A0), D3
1942   D682                      Add.L     D2, D3
1944   2343 001C                 Move.L    D3, $1C(A1)
1948   E08A                      LsR.L     $8, D2
194A   E28A                      LsR.L     $1, D2
194C   3342 0028                 Move      D2, $28(A1)
1950   1369 002C 002D            Move.B    $2C(A1), $2D(A1)
1956   2F38 024A      L243:      Move.L    (DiskVars.JReSeek), -(A7)
195A   4E75                      Rts

                      P_Sony_ReSeek:
195C   1369 0030 0031            Move.B    $30(A1), $31(A1)
1962   3C29 0016      L244:      Move      $16(A1), D6
1966   6100 031E                 Bsr       E_Sony_Seek
196A   6B56                      BMI       L247
196C   1369 002A 002B            Move.B    $2A(A1), $2B(A1)
1972   E84E                      LsR       $4, D6
1974   E74E                      LsL       $3, D6
1976   45F1 101A                 Lea.L     $1A(A1,D1.W), A2
197A   45F2 6004                 Lea.L     $4(A2,D6.W), A2
197E   2438 016A                 Move.L    (Ticks), D2
1982   2012                      Move.L    (A2), D0
1984   670A                      BEQ       L245
1986   9082                      Sub.L     D2, D0
1988   4480                      Neg.L     D0
198A   B0A9 0044                 Cmp.L     $44(A1), D0
198E   6D36                      BLT       L248
1990   2482           L245:      Move.L    D2, (A2)
1992   47FA 0006                 Lea.L     E_76, A3
1996   6000 055C                 Bra       L310

                      E_76:
199A   6B26                      BMI       L247
199C   3022                      Move      -(A2), D0
199E   41FA 04C8                 Lea.L     DT19, A0
19A2   E24E                      LsR       $1, D6
19A4   D0C6                      AddA      D6, A0
19A6   B858                      Cmp       (A0)+, D4
19A8   6E06                      BGT       L246
19AA   4440                      Neg       D0
19AC   B850                      Cmp       (A0), D4
19AE   6E16                      BGT       L248
19B0   9162           L246:      Sub       D0, -(A2)
19B2   42AA 0004                 Clr.L     $4(A2)
19B6   5271 1018                 AddQ      $1, $18(A1,D1.W)
19BA   5329 0031                 SubQ.L    $1, $31(A1)
19BE   6AA2                      BPL       L244
19C0   70B1                      MoveQ.L   $-4F, D0
19C2   6000 0152      L247:      Bra       L263
19C6   1369 002E 002F L248:      Move.B    $2E(A1), $2F(A1)
19CC   2C01           L249:      Move.L    D1, D6
19CE   6100 06C6                 Bsr       P57
19D2   6A06                      BPL       L251
19D4   487A 0134      L250:      Pea.L     E_79
19D8   600C                      Bra       L252
19DA   B269 0016      L251:      Cmp       $16(A1), D1
19DE   670A                      BEQ       L253
19E0   70B0                      MoveQ.L   $-50, D0
19E2   487A 0132                 Pea.L     L263
19E6   6000 009E      L252:      Bra       P30
19EA   2029 0022      L253:      Move.L    $22(A1), D0
19EE   0500                      BTst.B    D2, D0
19F0   660C                      BNE       L254
19F2   52B8 0156                 AddQ      $1, (RndSeed)
19F6   70AF                      MoveQ.L   $-51, D0
19F8   487A 0136                 Pea.L     E_80
19FC   60E8                      Bra       L252
19FE   31C2 02FA      L254:      Move      D2, (TagData)
1A02   0C03 001F                 Cmp.B     $1F, D3
1A06   5EF1 6012                 SGT.B     $12(A1,D6.W)
1A0A   9469 0020                 Sub       $20(A1), D2
1A0E   3202                      Move      D2, D1
1A10   E181                      AsL.L     $8, D1
1A12   D281                      Add.L     D1, D1
1A14   D2A9 001C                 Add.L     $1C(A1), D1
1A18   2041                      Move.L    D1, A0
1A1A   3229 0028                 Move      $28(A1), D1
1A1E   D242                      Add       D2, D1
1A20   3001                      Move      D1, D0
1A22   D241                      Add       D1, D1
1A24   D240                      Add       D0, D1
1A26   E541                      AsL       $2, D1
1A28   3341 00F8                 Move      D1, $F8(A1)
1A2C   6100 0086                 Bsr       P31
1A30   672E                      BEQ       L257
1A32   2629 00F4                 Move.L    $F4(A1), D3
1A36   6710                      BEQ       L255
1A38   2243                      Move.L    D3, A1
1A3A   D2C1                      AddA      D1, A1
1A3C   45F8 02FC                 Lea.L     (BufTgFNum), A2
1A40   24D9                      Move.L    (A1)+, (A2)+
1A42   24D9                      Move.L    (A1)+, (A2)+
1A44   24D9                      Move.L    (A1)+, (A2)+
1A46   600E                      Bra       L256
1A48   D069 0026      L255:      Add       $26(A1), D0
1A4C   31C0 0302                 Move      D0, (BufTgFBkNum)
1A50   21F8 020C 0304            Move.L    (Time), (BufTgDate)
1A56   6100 0966      L256:      Bsr       E_Sony_WrData
1A5A   6600 FF78                 BNE       L250
1A5E   6022                      Bra       L258
1A60   6100 0704      L257:      Bsr       E_Sony_RdData
1A64   6600 FF6E                 BNE       L250
1A68   2278 0134                 Move.L    (SonyVars), A1
1A6C   2029 00F4                 Move.L    $F4(A1), D0
1A70   6710                      BEQ       L258
1A72   2040                      Move.L    D0, A0
1A74   D0E9 00F8                 AddA      $F8(A1), A0
1A78   45F8 02FC                 Lea.L     (BufTgFNum), A2
1A7C   20DA                      Move.L    (A2)+, (A0)+
1A7E   20DA                      Move.L    (A2)+, (A0)+
1A80   20DA                      Move.L    (A2)+, (A0)+
1A82   487A 0038      L258:      Pea.L     E_78

                      P30:
1A86   285F                      Move.L    (A7)+, A4
1A88   487A 0014                 Pea.L     E_77            ; Return address for call to PollProc
1A8C   2F38 013E                 Move.L    (PollProc), -(A7)
1A90   6718                      BEQ       L259
1A92   2278 0134                 Move.L    (SonyVars), A1
1A96   48E9 110D 00D0            MoveM.L   D0/D2-D3/A0/A4, $D0(A1)
1A9C   4E75                      Rts                       ; Actually a call to PollProc
1A9E   6100 00A6      E_77:      Bsr       P33
1AA2   4CE9 110D 00D0            MoveM.L   $D0(A1), D0/D2-D3/A0/A4
1AA8   4ED4                      Jmp       (A4)
1AAA   2E78 013A      L259:      Move.L    (PollStack), A7
1AAE   6100 0096                 Bsr       P33
1AB2   4ED4                      Jmp       (A4)

                      P31:
1AB4   0C29 0002 0033            Cmp.B     $2, $33(A1)
1ABA   4E75                      Rts

                      E_78:
1ABC   4A29 0018                 Tst.B     $18(A1)
1AC0   6604                      BNE       L260
1AC2   027C F8FF                 And       $-701, SR
1AC6   61EC           L260:      Bsr       P31
1AC8   670A                      BEQ       L261
1ACA   4A38 012F                 Tst.B     (CPUFlag)
1ACE   6604                      BNE       L261
1AD0   6100 0226                 Bsr       P41
1AD4   2451           L261:      Move.L    (A1), A2
1AD6   206A 0008                 Move.L    $8(A2), A0
1ADA   7002                      MoveQ.L   $2, D0
1ADC   E180                      AsL.L     $8, D0
1ADE   D1AA 0010                 Add.L     D0, $10(A2)
1AE2   D1A8 0028                 Add.L     D0, $28(A0)
1AE6   2029 0022                 Move.L    $22(A1), D0
1AEA   3438 02FA                 Move      (TagData), D2
1AEE   0580                      BClr.B    D2, D0
1AF0   2340 0022                 Move.L    D0, $22(A1)
1AF4   6600 FED0                 BNE       L248
1AF8   2028 0028                 Move.L    $28(A0), D0
1AFC   B0A8 0024                 Cmp.L     $24(A0), D0
1B00   6D00 FDBE                 BLT       L233
1B04   7000                      MoveQ.L   $0, D0
1B06   6000 FD8E      L262:      Bra       L228

                      E_79:
1B0A   5271 1014                 AddQ      $1, $14(A1,D1.W)
1B0E   5329 002B                 SubQ.L    $1, $2B(A1)
1B12   6A00 FEB2                 BPL       L248
1B16   027C F8FF      L263:      And       $-701, SR
1B1A   5329 002D                 SubQ.L    $1, $2D(A1)
1B1E   6F0E                      BLE       L264
1B20   6100 025C                 Bsr       E_Sony_Recal
1B24   6B08                      BMI       L264
1B26   6100 0354                 Bsr       E_Sony_MakeSpdTbl
1B2A   6A00 FE2A                 BPL       L243
1B2E   60D6           L264:      Bra       L262

                      E_80:
1B30   5329 002F                 SubQ.L    $1, $2F(A1)
1B34   6BE0                      BMI       L263
1B36   6100 01C0                 Bsr       P41
1B3A   6000 FE90                 Bra       L249

                      P32:
1B3E   2078 01E0                 Move.L    (IWM), A0
1B42   2478 01D4                 Move.L    (VIA), A2

                      P33:
1B46   2278 0134                 Move.L    (SonyVars), A1
1B4A   0C69 0001 0012            Cmp       $1, $12(A1)
1B50   6706                      BEQ       L265
1B52   323C 008C                 Move      $8C, D1
1B56   4E75                      Rts
1B58   724A           L265:      MoveQ.L   $4A, D1
1B5A   4E75                      Rts

                      P34:
1B5C   61E0                      Bsr       P32
1B5E   4A28 0200                 Tst.B     $200(A0)
1B62   4A28 0600                 Tst.B     $600(A0)
1B66   4A28 0800                 Tst.B     $800(A0)
1B6A   E208                      LsR.B     $1, D0
1B6C   6404                      BCC       L266
1B6E   4A28 0A00                 Tst.B     $A00(A0)
1B72   08AA 0005 1E00 L266:      BClr.B    $5, $1E00(A2)
1B78   E208                      LsR.B     $1, D0
1B7A   6406                      BCC       L267
1B7C   08EA 0005 1E00            BSet.B    $5, $1E00(A2)
1B82   E208           L267:      LsR.B     $1, D0
1B84   6502                      BCS       L268
1B86   4A10                      Tst.B     (A0)
1B88   E208           L268:      LsR.B     $1, D0
1B8A   6504                      BCS       L269
1B8C   4A28 0400                 Tst.B     $400(A0)
1B90   4E75           L269:      Rts

                      P35:
1B92   61C8                      Bsr       P34
1B94   40E7                      Move      SR, -(A7)
1B96   007C 0300                 Or        $300, SR
1B9A   4A28 1A00                 Tst.B     $1A00(A0)
1B9E   1028 1C00                 Move.B    $1C00(A0), D0
1BA2   4A28 1800                 Tst.B     $1800(A0)
1BA6   46DF                      Move      (A7)+, SR
1BA8   4A00                      Tst.B     D0
1BAA   4E75                      Rts

                      P36:
1BAC   61AE                      Bsr       P34

                      P37:
1BAE   40E7                      Move      SR, -(A7)
1BB0   007C 0300                 Or        $300, SR
1BB4   4A28 0E00                 Tst.B     $E00(A0)
1BB8   4A28 0C00                 Tst.B     $C00(A0)
1BBC   4E73                      Rte

                      P38:
1BBE   6186                      Bsr       P33
1BC0   3406                      Move      D6, D2
1BC2   E84A                      LsR       $4, D2
1BC4   E74A                      LsL       $3, D2
1BC6   D441                      Add       D1, D2
1BC8   3431 201A                 Move      $1A(A1,D2.W), D2
1BCC   D471 1016                 Add       $16(A1,D1.W), D2
1BD0   6A02                      BPL       L270
1BD2   7400                      MoveQ.L   $0, D2
1BD4   0C42 018F      L270:      Cmp       $18F, D2
1BD8   6F04                      BLE       L271
1BDA   343C 018F                 Move      $18F, D2
1BDE   3038 0138      L271:      Move      (PWMValue), D0
1BE2   6A06                      BPL       L272
1BE4   3029 0038                 Move      $38(A1), D0
1BE8   6016                      Bra       L274
1BEA   9042           L272:      Sub       D2, D0
1BEC   6700 FF58                 BEQ       P33
1BF0   6A02                      BPL       L273
1BF2   4440                      Neg       D0
1BF4   EB48           L273:      LsL       $5, D0
1BF6   B069 0036                 Cmp       $36(A1), D0
1BFA   6E04                      BGT       L274
1BFC   3029 0036                 Move      $36(A1), D0
1C00   D069 0014      L274:      Add       $14(A1), D0
1C04   B069 0038                 Cmp       $38(A1), D0
1C08   6D04                      BLT       L275
1C0A   3029 0038                 Move      $38(A1), D0
1C0E   3340 0014      L275:      Move      D0, $14(A1)

                      P39:
1C12   31C2 0138                 Move      D2, (PWMValue)
1C16   48E7 1E20                 MoveM.L   D3-D6/A2, -(A7)
1C1A   0442 018F                 Sub       $18F, D2
1C1E   4442                      Neg       D2
1C20   48C2                      Ext.L     D2
1C22   84FC 000A                 DivU      $A, D2
1C26   700B                      MoveQ.L   $B, D0
1C28   1200           L276:      Move.B    D0, D1
1C2A   1600                      Move.B    D0, D3
1C2C   E208                      LsR.B     $1, D0
1C2E   B103                      Eor.B     D0, D3
1C30   E20B                      LsR.B     $1, D3
1C32   6404                      BCC       L277
1C34   08C0 0005                 BSet.B    $5, D0
1C38   51CA FFEE      L277:      DBF       D2, L276
1C3C   4842                      Swap      D2
1C3E   1A3B 203A                 Move.B    DT17(D2.W), D5
1C42   E145                      AsL       $8, D5
1C44   1A3B 2035                 Move.B    DT18(D2.W), D5
1C48   7624                      MoveQ.L   $24, D3
1C4A   41F9 0007 FD01            Lea.L     ($7FD01), A0
1C50   2478 0312                 Move.L    (PWMBuf2), A2
1C54   7409           L278:      MoveQ.L   $9, D2
1C56   3805                      Move      D5, D4
1C58   E34C           L279:      LsL       $1, D4
1C5A   6404                      BCC       L280
1C5C   1C00                      Move.B    D0, D6
1C5E   6002                      Bra       L281
1C60   1C01           L280:      Move.B    D1, D6
1C62   1086           L281:      Move.B    D6, (A0)
1C64   1486                      Move.B    D6, (A2)
1C66   5448                      AddQ      $2, A0
1C68   544A                      AddQ      $2, A2
1C6A   51CA FFEC                 DBF       D2, L279
1C6E   51CB FFE4                 DBF       D3, L278
1C72   4CDF 0478                 MoveM.L   (A7)+, D3-D6/A2
1C76   6000 FECE                 Bra       P33

                      DT17:
1C7A   00                        DC.B      ' '

                      DT18:
1C7B   2021 2494 AAB5            DC.B      ' !$   '
1C81   B77B FF40 00              DC.B      ' { @ '

                      E_Sony_Seek:
1C86   0886 000B                 BClr.B    $B, D6
1C8A   6100 FF32                 Bsr       P38
1C8E   2F38 0236                 Move.L    (DiskVars.JSeek), -(A7)
1C92   4E75                      Rts

                      P_Sony_Seek:
1C94   2C5F                      Move.L    (A7)+, A6
1C96   6100 FEAE                 Bsr       P33
1C9A   3E31 1000                 Move      $0(A1,D1.W), D7
1C9E   6A08                      BPL       L282
1CA0   6100 00DC                 Bsr       E_Sony_Recal
1CA4   3E00                      Move      D0, D7
1CA6   664E                      BNE       L289
1CA8   BE46           L282:      Cmp       D6, D7
1CAA   6740                      BEQ       L287
1CAC   7000           L283:      MoveQ.L   $0, D0
1CAE   7201                      MoveQ.L   $1, D1
1CB0   3407                      Move      D7, D2
1CB2   9446                      Sub       D6, D2
1CB4   6728                      BEQ       L286
1CB6   6B04                      BMI       L284
1CB8   7001                      MoveQ.L   $1, D0
1CBA   72FF                      MoveQ.L   $-1, D1
1CBC   DE41           L284:      Add       D1, D7
1CBE   6100 FEEC                 Bsr       P36
1CC2   3387 1000                 Move      D7, $0(A1,D1.W)
1CC6   7004                      MoveQ.L   $4, D0
1CC8   6100 FEC8                 Bsr       P35
1CCC   6B04                      BMI       L285
1CCE   7EB5                      MoveQ.L   $-4B, D7
1CD0   600C                      Bra       L286
1CD2   6100 FEDA      L285:      Bsr       P37
1CD6   3029 003C                 Move      $3C(A1), D0
1CDA   6120                      Bsr       E_Sony_WakeUp
1CDC   60CE                      Bra       L283
1CDE   6100 FE66      L286:      Bsr       P33
1CE2   3387 1000                 Move      D7, $0(A1,D1.W)
1CE6   3029 0034                 Move      $34(A1), D0
1CEA   6110                      Bsr       E_Sony_WakeUp
1CEC   3029 0014      L287:      Move      $14(A1), D0
1CF0   6702                      BEQ       L288
1CF2   6108                      Bsr       E_Sony_WakeUp
1CF4   3007           L288:      Move      D7, D0
1CF6   4ED6           L289:      Jmp       (A6)

                      P41:
1CF8   3029 003E                 Move      $3E(A1), D0

                      E_Sony_WakeUp:
1CFC   2F38 0246                 Move.L    (DiskVars.JWakeUp), -(A7)
1D00   4E75                      Rts

                      P_Sony_WakeUp:
1D02   6100 FE3A                 Bsr       P32
1D06   21DF 0124                 Move.L    (A7)+, (DskRtnAdr)
1D0A   007C 0100                 Or        $100, SR
1D0E   9169 0014                 Sub       D0, $14(A1)
1D12   6E04                      BGT       L290
1D14   4269 0014                 Clr       $14(A1)
1D18   724E           L290:      MoveQ.L   $4E, D1
1D1A   C2C0                      MulU      D0, D1
1D1C   08AA 0005 1600            BClr.B    $5, $1600(A2)
1D22   41FA 002A                 Lea.L     P_VIAInt_Timer2, A0
1D26   21C8 01A6                 Move.L    A0, (Lvl1DT.5)
1D2A   1541 1000                 Move.B    D1, $1000(A2)
1D2E   E059                      ROR       $8, D1
1D30   1541 1200                 Move.B    D1, $1200(A2)
1D34   157C 00A0 1C00            Move.B    $-60, $1C00(A2)
1D3A   4841                      Swap      D1
1D3C   3341 00CE                 Move      D1, $CE(A1)
1D40   7000                      MoveQ.L   $0, D0
1D42   48E9 78F8 00D0            MoveM.L   D3-D7/A3-A6, $D0(A1)
1D48   027C F8FF                 And       $-701, SR
1D4C   4E75                      Rts

                      P_VIAInt_Timer2:
1D4E   1369 1200 1200            Move.B    $1200(A1), $1200(A1)
1D54   6100 FDE8                 Bsr       P32
1D58   5369 00CE                 SubQ.L    $1, $CE(A1)
1D5C   6B02                      BMI       L291
1D5E   4E75                      Rts
1D60   157C 0020 1C00 L291:      Move.B    $20, $1C00(A2)
1D66   48E7 0F0E                 MoveM.L   D4-D7/A4-A6, -(A7)
1D6A   4CE9 78F8 00D0            MoveM.L   $D0(A1), D3-D7/A3-A6
1D70   487A 0006                 Pea.L     E_84
1D74   6000 0234                 Bra       L321

                      E_84:
1D78   4CDF 70F0                 MoveM.L   (A7)+, D4-D7/A4-A6
1D7C   4E75                      Rts

                      E_Sony_Recal:
1D7E   2F38 023E                 Move.L    (DiskVars.JRecal), -(A7)
1D82   4E75                      Rts

                      P_Sony_Recal:
1D84   2A5F                      Move.L    (A7)+, A5
1D86   6100 FDB6                 Bsr       P32
1D8A   721F                      MoveQ.L   $1F, D1
1D8C   4A28 1A00                 Tst.B     $1A00(A0)
1D90   1028 1C00                 Move.B    $1C00(A0), D0
1D94   4A28 1800                 Tst.B     $1800(A0)
1D98   C001                      And.B     D1, D0
1D9A   B001                      Cmp.B     D1, D0
1D9C   6732                      BEQ       L294
1D9E   7402                      MoveQ.L   $2, D2
1DA0   4842                      Swap      D2
1DA2   70B3           L292:      MoveQ.L   $-4D, D0
1DA4   5382                      SubQ.L    $1, D2
1DA6   6B5E                      BMI       L299
1DA8   4A28 1000                 Tst.B     $1000(A0)
1DAC   4A28 1A00                 Tst.B     $1A00(A0)
1DB0   1028 1C00                 Move.B    $1C00(A0), D0
1DB4   0800 0005                 BTst.B    $5, D0
1DB8   66E8                      BNE       L292
1DBA   C001                      And.B     D1, D0
1DBC   B001                      Cmp.B     D1, D0
1DBE   670A                      BEQ       L293
1DC0   1141 1E00                 Move.B    D1, $1E00(A0)
1DC4   4A28 1C00                 Tst.B     $1C00(A0)
1DC8   60D8                      Bra       L292
1DCA   4A28 1800      L293:      Tst.B     $1800(A0)
1DCE   6158                      Bsr       P46
1DD0   7E52           L294:      MoveQ.L   $52, D7
1DD2   7000                      MoveQ.L   $0, D0
1DD4   6012                      Bra       L296
1DD6   3029 003C      L295:      Move      $3C(A1), D0
1DDA   6100 FF20                 Bsr       E_Sony_WakeUp
1DDE   700A                      MoveQ.L   $A, D0
1DE0   6100 FDB0                 Bsr       P35
1DE4   6A1A                      BPL       L297
1DE6   7001                      MoveQ.L   $1, D0
1DE8   6100 FDC2      L296:      Bsr       P36
1DEC   7004                      MoveQ.L   $4, D0
1DEE   6100 FDA2                 Bsr       P35
1DF2   6A10                      BPL       L298
1DF4   70B4                      MoveQ.L   $-4C, D0
1DF6   5347                      SubQ.L    $1, D7
1DF8   670C                      BEQ       L299
1DFA   6100 FDB2                 Bsr       P37
1DFE   60D6                      Bra       L295
1E00   7000           L297:      MoveQ.L   $0, D0
1E02   6002                      Bra       L299
1E04   70B5           L298:      MoveQ.L   $-4B, D0
1E06   3380 1000      L299:      Move      D0, $0(A1,D1.W)
1E0A   4ED5                      Jmp       (A5)

                      P44:
1E0C   6100 FD38                 Bsr       P33
1E10   3340 001A                 Move      D0, $1A(A1)
1E14   6702                      BEQ       L300
1E16   4E75                      Rts
1E18   7009           L300:      MoveQ.L   $9, D0
1E1A   6100 FD90                 Bsr       P36
1E1E   4A28 1000                 Tst.B     $1000(A0)
1E22   4E75                      Rts

                      P45:
1E24   7000                      MoveQ.L   $0, D0
1E26   6004                      Bra       L301

                      P46:
1E28   3029 0038                 Move      $38(A1), D0
1E2C   3400           L301:      Move      D0, D2
1E2E   6100 FD16                 Bsr       P33
1E32   4269 001A                 Clr       $1A(A1)
1E36   6114                      Bsr       P47
1E38   7008                      MoveQ.L   $8, D0
1E3A   6100 FD56                 Bsr       P35
1E3E   6A0A                      BPL       L302
1E40   6100 FD6C                 Bsr       P37
1E44   3002                      Move      D2, D0
1E46   6600 FEB4                 BNE       E_Sony_WakeUp
1E4A   4E75           L302:      Rts

                      P47:
1E4C   6100 FCF0                 Bsr       P32

                      P48:
1E50   303C 1400                 Move      $1400, D0
1E54   0C41 004A                 Cmp       $4A, D1
1E58   6704                      BEQ       L303
1E5A   303C 1600                 Move      $1600, D0
1E5E   4A30 0000      L303:      Tst.B     $0(A0,D0.W)
1E62   4A28 1200                 Tst.B     $1200(A0)
1E66   4E75                      Rts

                      DT19:
1E68   11E9 1135 138A            DC.B      '   5  '
1E6E   12C6 157F 14A7            DC.B      '      '
1E74   17E2 16F2 1ADE            DC.B      '      '
1E7A   19D0                      DC.B      '  '

                      E_Sony_MakeSpdTbl:
1E7C   2F38 024E                 Move.L    (DiskVars.JMakeSpdTbl), -(A7)
1E80   4E75                      Rts

                      P_Sony_MakeSpdTbl:
1E82   285F                      Move.L    (A7)+, A4
1E84   343C 0080                 Move      $80, D2
1E88   615C                      Bsr       P50
1E8A   6B56                      BMI       L309
1E8C   2604                      Move.L    D4, D3
1E8E   343C 0100                 Move      $100, D2
1E92   6152                      Bsr       P50
1E94   6B4C                      BMI       L309
1E96   2A04                      Move.L    D4, D5
1E98   9A83                      Sub.L     D3, D5
1E9A   E38B                      LsL.L     $1, D3
1E9C   7C04                      MoveQ.L   $4, D6
1E9E   4BFA FFC8                 Lea.L     DT19, A5
1EA2   6100 FCA2                 Bsr       P33
1EA6   47F1 101A                 Lea.L     $1A(A1,D1.W), A3
1EAA   7400           L304:      MoveQ.L   $0, D2
1EAC   341D                      Move      (A5)+, D2
1EAE   2E02                      Move.L    D2, D7
1EB0   D45D                      Add       (A5)+, D2
1EB2   E24A                      LsR       $1, D2
1EB4   D484           L305:      Add.L     D4, D2
1EB6   9483                      Sub.L     D3, D2
1EB8   6A02                      BPL       L306
1EBA   7400                      MoveQ.L   $0, D2
1EBC   EF8A           L306:      LsL.L     $7, D2
1EBE   6702                      BEQ       L307
1EC0   84C5                      DivU      D5, D2
1EC2   5242           L307:      AddQ      $1, D2
1EC4   0C42 018F                 Cmp       $18F, D2
1EC8   6F04                      BLE       L308
1ECA   343C 018F                 Move      $18F, D2
1ECE   36C2           L308:      Move      D2, (A3)+
1ED0   CF42                      Exg.L     D7, D2
1ED2   4640                      Not       D0
1ED4   66DE                      BNE       L305
1ED6   594B                      SubQ.L    $4, A3
1ED8   9E5B                      Sub       (A3)+, D7
1EDA   36C7                      Move      D7, (A3)+
1EDC   429B                      Clr.L     (A3)+
1EDE   51CE FFCA                 DBF       D6, L304
1EE2   4A40           L309:      Tst       D0
1EE4   4ED4                      Jmp       (A4)

                      P50:
1EE6   265F                      Move.L    (A7)+, A3
1EE8   6100 FD28                 Bsr       P39
1EEC   3029 0038                 Move      $38(A1), D0
1EF0   6100 FE0A                 Bsr       E_Sony_WakeUp
1EF4   7800           L310:      MoveQ.L   $0, D4
1EF6   7A03                      MoveQ.L   $3, D5
1EF8   6118           L311:      Bsr       E_Sony_FigTrkSpd
1EFA   6B14                      BMI       L312
1EFC   D880                      Add.L     D0, D4
1EFE   51CD FFF8                 DBF       D5, L311
1F02   E68C                      LsR.L     $3, D4
1F04   203C 0400 0000            Move.L    $4000000, D0
1F0A   80C4                      DivU      D4, D0
1F0C   3800                      Move      D0, D4
1F0E   7000                      MoveQ.L   $0, D0
1F10   4ED3           L312:      Jmp       (A3)

                      E_Sony_FigTrkSpd:
1F12   2F38 0222                 Move.L    (DiskVars_JFigTrkSpd), -(A7)
1F16   4E75                      Rts

                      P_Sony_FigTrkSpd:
1F18   40E7                      Move      SR, -(A7)
1F1A   48E7 7FFE                 MoveM.L   D1-D7/A0-A6, -(A7)
1F1E   7004                      MoveQ.L   $4, D0
1F20   6100 0154                 Bsr       E_Sony_SetUpPoll
1F24   700E                      MoveQ.L   $E, D0
1F26   6100 FC34                 Bsr       P34
1F2A   41F9 00DF E1FF            Lea.L     (IWM_Base), A0
1F30   4A28 1A00                 Tst.B     $1A00(A0)
1F34   72FF                      MoveQ.L   $-1, D1
1F36   7605                      MoveQ.L   $5, D3
1F38   2478 01D4                 Move.L    (VIA), A2
1F3C   47EA 1A00                 Lea.L     $1A00(A2), A3
1F40   43E8 1C00                 Lea.L     $1C00(A0), A1
1F44   6116                      Bsr       P52
1F46   614A                      Bsr       P53
1F48   671C                      BEQ       L314
1F4A   4A28 1800      L313:      Tst.B     $1800(A0)
1F4E   6100 FB36                 Bsr       P30
1F52   4CDF 7FFE                 MoveM.L   (A7)+, D1-D7/A0-A6
1F56   46DF                      Move      (A7)+, SR
1F58   4A80                      Tst.L     D0
1F5A   4E75                      Rts

                      P52:
1F5C   1541 1000                 Move.B    D1, $1000(A2)
1F60   1541 1200                 Move.B    D1, $1200(A2)
1F64   4E75                      Rts
1F66   61F4           L314:      Bsr       P52
1F68   740E                      MoveQ.L   $E, D2
1F6A   6126           L315:      Bsr       P53
1F6C   66DC                      BNE       L313
1F6E   51CA FFFA                 DBF       D2, L315
1F72   142A 1200                 Move.B    $1200(A2), D2
1F76   122A 1000                 Move.B    $1000(A2), D1
1F7A   B42A 1200                 Cmp.B     $1200(A2), D2
1F7E   6702                      BEQ       L316
1F80   7200                      MoveQ.L   $0, D1
1F82   0713           L316:      BTst.B    D3, (A3)
1F84   66C4                      BNE       L313
1F86   E14A                      LsL       $8, D2
1F88   8401                      Or.B      D1, D2
1F8A   4642                      Not       D2
1F8C   7000                      MoveQ.L   $0, D0
1F8E   3002                      Move      D2, D0
1F90   60B8                      Bra       L313

                      P53:
1F92   21DF 0124                 Move.L    (A7)+, (DskRtnAdr)
1F96   4A15           L317:      Tst.B     (A5)
1F98   6B02                      BMI       L318
1F9A   1F16                      Move.B    (A6), -(A7)
1F9C   4A11           L318:      Tst.B     (A1)
1F9E   6B04                      BMI       L319
1FA0   4A11                      Tst.B     (A1)
1FA2   6A0E                      BPL       L322
1FA4   0713           L319:      BTst.B    D3, (A3)
1FA6   67EE                      BEQ       L317
1FA8   70C0           L320:      MoveQ.L   $-40, D0
1FAA   2F38 0124      L321:      Move.L    (DskRtnAdr), -(A7)
1FAE   4A40                      Tst       D0
1FB0   4E75                      Rts
1FB2   4A15           L322:      Tst.B     (A5)
1FB4   6B02                      BMI       L323
1FB6   1F16                      Move.B    (A6), -(A7)
1FB8   0713           L323:      BTst.B    D3, (A3)
1FBA   66EC                      BNE       L320
1FBC   4A11                      Tst.B     (A1)
1FBE   6AF2                      BPL       L322
1FC0   4A11                      Tst.B     (A1)
1FC2   6AEE                      BPL       L322
1FC4   7000                      MoveQ.L   $0, D0
1FC6   60E2                      Bra       L321

                      E_88:
1FC8   40E7                      Move      SR, -(A7)
1FCA   007C 0100                 Or        $100, SR
1FCE   2278 0134                 Move.L    (SonyVars), A1
1FD2   3169 0040 000A            Move      $40(A1), $A(A0)
1FD8   4A29 0019                 Tst.B     $19(A1)
1FDC   661E                      BNE       L325
1FDE   4A69 001A                 Tst       $1A(A1)
1FE2   6710                      BEQ       L324
1FE4   5369 001A                 SubQ.L    $1, $1A(A1)
1FE8   6612                      BNE       L325
1FEA   7009                      MoveQ.L   $9, D0
1FEC   6100 FBBE                 Bsr       P36
1FF0   4A28 1000                 Tst.B     $1000(A0)
1FF4   7602           L324:      MoveQ.L   $2, D3
1FF6   6106                      Bsr       P54
1FF8   7601                      MoveQ.L   $1, D3
1FFA   6102                      Bsr       P54
1FFC   4E73           L325:      Rte

                      P54:
1FFE   3343 0012                 Move      D3, $12(A1)
2002   6100 FB3A                 Bsr       P32
2006   612E                      Bsr       P55
2008   6B2A                      BMI       L328
200A   6100 FE44                 Bsr       P48
200E   4A31 1003                 Tst.B     $3(A1,D1.W)
2012   6E20                      BGT       L328
2014   6706                      BEQ       L326
2016   5231 1003                 AddQ      $1, $3(A1,D1.W)
201A   6B14                      BMI       L327
201C   7002           L326:      MoveQ.L   $2, D0
201E   6100 FB72                 Bsr       P35
2022   6B0C                      BMI       L327
2024   5231 1003                 AddQ      $1, $3(A1,D1.W)
2028   307C 0007                 Move      $7, A0
202C   2003                      Move.L    D3, D0
202E   A02F                      _PostEvent
2030   50F1 1000      L327:      ST.B      $0(A1,D1.W)
2034   4E75           L328:      Rts

                      P55:
2036   1431 1004                 Move.B    $4(A1,D1.W), D2
203A   661A                      BNE       L329
203C   6100 FE12                 Bsr       P48
2040   700D                      MoveQ.L   $D, D0
2042   74FF                      MoveQ.L   $-1, D2
2044   6100 FB4C                 Bsr       P35
2048   6B14                      BMI       L330
204A   7401                      MoveQ.L   $1, D2
204C   7009                      MoveQ.L   $9, D0
204E   6100 FB42                 Bsr       P35
2052   5BF1 1005                 SMI.B     $5(A1,D1.W)
2056   70C0           L329:      MoveQ.L   $-40, D0
2058   1382 1004                 Move.B    D2, $4(A1,D1.W)
205C   4E75                      Rts
205E   41F1 1006      L330:      Lea.L     $6(A1,D1.W), A0
2062   43F8 0308                 Lea.L     (DrvQHdr_Flags), A1
2066   4EBA EADC                 Jsr       P14
206A   6100 FADA                 Bsr       P33
206E   60E6                      Bra       L329

                      DT20:
2070   D5AA 96DE AAFF            DC.B      '      '

                      E_Sony_SetUpPoll:
2076   2F38 023A                 Move.L    (DiskVars.JSetUpPoll), -(A7)
207A   4E75                      Rts

                      P_Sony_SetUpPoll:
207C   4DF9 009F FFFE            Lea.L     ($9FFFFE), A6
2082   4BF9 00EF FFFE            Lea.L     ($EFFFFE), A5
2088   21CF 013A                 Move.L    A7, (PollStack)
208C   D1B8 013A                 Add.L     D0, (PollStack)
2090   007C 0300                 Or        $300, SR
2094   4E75                      Rts

                      P57:
2096   7008                      MoveQ.L   $8, D0
2098   61DC                      Bsr       E_Sony_SetUpPoll
209A   7001                      MoveQ.L   $1, D0
209C   0829 0003 0016            BTst.B    $3, $16(A1)
20A2   6702                      BEQ       L331
20A4   7003                      MoveQ.L   $3, D0
20A6   6100 FAB4      L331:      Bsr       P34
20AA   45FA FFC4                 Lea.L     DT20, A2
20AE   2F38 022A                 Move.L    (DiskVars.JRdAddr), -(A7)
20B2   4E75                      Rts

                      P_Sony_RdAddr:
20B4   7603                      MoveQ.L   $3, D3
20B6   7430                      MoveQ.L   $30, D2
20B8   7A00                      MoveQ.L   $0, D5
20BA   287C 00DF F9FF            Move.L    $DFF9FF, A4
20C0   21DF 0124                 Move.L    (A7)+, (DskRtnAdr)
20C4   4A15           L332:      Tst.B     (A5)
20C6   6B02                      BMI       L333
20C8   1F16                      Move.B    (A6), -(A7)
20CA   1A14           L333:      Move.B    (A4), D5
20CC   51CA 0008                 DBF       D2, L334
20D0   70BE                      MoveQ.L   $-42, D0
20D2   6000 0080                 Bra       L346
20D6   6AEC           L334:      BPL       L332
20D8   5343                      SubQ.L    $1, D3
20DA   66E8                      BNE       L332
20DC   303C 05DC                 Move      $5DC, D0
20E0   47FA 01D4                 Lea.L     E_92, A3
20E4   204A           L335:      Move.L    A2, A0
20E6   7203                      MoveQ.L   $3, D1
20E8   1A14           L336:      Move.B    (A4), D5
20EA   6AFC                      BPL       L336
20EC   4A15                      Tst.B     (A5)
20EE   6B02                      BMI       L337
20F0   1F16                      Move.B    (A6), -(A7)
20F2   51C8 0006      L337:      DBF       D0, L338
20F6   70BD                      MoveQ.L   $-43, D0
20F8   605A                      Bra       L346
20FA   BA18           L338:      Cmp.B     (A0)+, D5
20FC   66E6                      BNE       L335
20FE   5341                      SubQ.L    $1, D1
2100   66E6                      BNE       L336
2102   1A14           L339:      Move.B    (A4), D5
2104   6AFC                      BPL       L339
2106   1233 5000                 Move.B    $0(A3,D5.W), D1
210A   1801                      Move.B    D1, D4
210C   EC59                      ROR       $6, D1
210E   1A14           L340:      Move.B    (A4), D5
2110   6AFC                      BPL       L340
2112   1433 5000                 Move.B    $0(A3,D5.W), D2
2116   B504                      Eor.B     D2, D4
2118   1A14           L341:      Move.B    (A4), D5
211A   6AFC                      BPL       L341
211C   1233 5000                 Move.B    $0(A3,D5.W), D1
2120   B304                      Eor.B     D1, D4
2122   ED59                      ROL       $6, D1
2124   4A15                      Tst.B     (A5)
2126   6B02                      BMI       L342
2128   1F16                      Move.B    (A6), -(A7)
212A   1A14           L342:      Move.B    (A4), D5
212C   6AFC                      BPL       L342
212E   1633 5000                 Move.B    $0(A3,D5.W), D3
2132   B704                      Eor.B     D3, D4
2134   1A14           L343:      Move.B    (A4), D5
2136   6AFC                      BPL       L343
2138   1A33 5000                 Move.B    $0(A3,D5.W), D5
213C   BB04                      Eor.B     D5, D4
213E   6618                      BNE       L347
2140   7801                      MoveQ.L   $1, D4
2142   1A14           L344:      Move.B    (A4), D5
2144   6AFC                      BPL       L344
2146   4A15                      Tst.B     (A5)
2148   6B02                      BMI       L345
214A   1F16                      Move.B    (A6), -(A7)
214C   BA18           L345:      Cmp.B     (A0)+, D5
214E   660C                      BNE       L348
2150   51CC FFF0                 DBF       D4, L344
2154   6000 FE54      L346:      Bra       L321
2158   70BB           L347:      MoveQ.L   $-45, D0
215A   60F8                      Bra       L346
215C   70BA           L348:      MoveQ.L   $-46, D0
215E   60F4                      Bra       L346

                      DT21:
2160   D5AA ADDE AAFF            DC.B      '      '

                      E_Sony_RdData:
2166   43FA FFF8                 Lea.L     DT21, A1
216A   2F38 022E                 Move.L    (DiskVars.JRdData), -(A7)
216E   4E75                      Rts

                      P_Sony_RdData:
2170   21DF 0124                 Move.L    (A7)+, (DskRtnAdr)
2174   7430                      MoveQ.L   $30, D2
2176   7600                      MoveQ.L   $0, D3
2178   70C0                      MoveQ.L   $-40, D0
217A   283C 01FE 000A            Move.L    $1FE000A, D4
2180   7A00                      MoveQ.L   $0, D5
2182   7C00                      MoveQ.L   $0, D6
2184   7E00                      MoveQ.L   $0, D7
2186   2449           L349:      Move.L    A1, A2
2188   7203                      MoveQ.L   $3, D1
218A   1614           L350:      Move.B    (A4), D3
218C   6AFC                      BPL       L350
218E   4A15                      Tst.B     (A5)
2190   6B02                      BMI       L351
2192   1F16                      Move.B    (A6), -(A7)
2194   51CA 0006      L351:      DBF       D2, L352
2198   70B9                      MoveQ.L   $-47, D0
219A   60B8                      Bra       L346
219C   B61A           L352:      Cmp.B     (A2)+, D3
219E   66E6                      BNE       L349
21A0   5341                      SubQ.L    $1, D1
21A2   66E6                      BNE       L350
21A4   1614           L353:      Move.B    (A4), D3
21A6   6AFC                      BPL       L353
21A8   43F8 02FB                 Lea.L     (TagData.1), A1
21AC   12F3 3000                 Move.B    $0(A3,D3.W), (A1)+
21B0   4A15           L354:      Tst.B     (A5)
21B2   6B02                      BMI       L355
21B4   1F16                      Move.B    (A6), -(A7)
21B6   1614           L355:      Move.B    (A4), D3
21B8   6AF6                      BPL       L354
21BA   1233 3000                 Move.B    $0(A3,D3.W), D1
21BE   E519                      ROL.B     $2, D1
21C0   1401                      Move.B    D1, D2
21C2   C400                      And.B     D0, D2
21C4   1614           L356:      Move.B    (A4), D3
21C6   6AFC                      BPL       L356
21C8   8433 3000                 Or.B      $0(A3,D3.W), D2
21CC   1607                      Move.B    D7, D3
21CE   D607                      Add.B     D7, D3
21D0   E31F                      ROL.B     $1, D7
21D2   BF02                      Eor.B     D7, D2
21D4   12C2                      Move.B    D2, (A1)+
21D6   DB02                      AddX.B    D2, D5
21D8   E519                      ROL.B     $2, D1
21DA   1401                      Move.B    D1, D2
21DC   C400                      And.B     D0, D2
21DE   1614           L357:      Move.B    (A4), D3
21E0   6AFC                      BPL       L357
21E2   8433 3000                 Or.B      $0(A3,D3.W), D2
21E6   BB02                      Eor.B     D5, D2
21E8   12C2                      Move.B    D2, (A1)+
21EA   DD02                      AddX.B    D2, D6
21EC   E519                      ROL.B     $2, D1
21EE   C200                      And.B     D0, D1
21F0   4A15                      Tst.B     (A5)
21F2   6B02                      BMI       L358
21F4   1F16                      Move.B    (A6), -(A7)
21F6   1614           L358:      Move.B    (A4), D3
21F8   6AFC                      BPL       L358
21FA   8233 3000                 Or.B      $0(A3,D3.W), D1
21FE   BD01                      Eor.B     D6, D1
2200   12C1                      Move.B    D1, (A1)+
2202   DF01                      AddX.B    D1, D7
2204   5744                      SubQ.L    $3, D4
2206   6AA8                      BPL       L354
2208   4844                      Swap      D4
220A   4A38 012C                 Tst.B     (DskVerify)
220E   6708                      BEQ       L360
2210   6062                      Bra       L365
2212   4A15           L359:      Tst.B     (A5)
2214   6B02                      BMI       L360
2216   1F16                      Move.B    (A6), -(A7)
2218   1614           L360:      Move.B    (A4), D3
221A   6AF6                      BPL       L359
221C   1233 3000                 Move.B    $0(A3,D3.W), D1
2220   E519                      ROL.B     $2, D1
2222   1401                      Move.B    D1, D2
2224   C400                      And.B     D0, D2
2226   1614           L361:      Move.B    (A4), D3
2228   6AFC                      BPL       L361
222A   8433 3000                 Or.B      $0(A3,D3.W), D2
222E   1607                      Move.B    D7, D3
2230   D607                      Add.B     D7, D3
2232   E31F                      ROL.B     $1, D7
2234   BF02                      Eor.B     D7, D2
2236   10C2                      Move.B    D2, (A0)+
2238   DB02                      AddX.B    D2, D5
223A   E519                      ROL.B     $2, D1
223C   1401                      Move.B    D1, D2
223E   C400                      And.B     D0, D2
2240   1614           L362:      Move.B    (A4), D3
2242   6AFC                      BPL       L362
2244   8433 3000                 Or.B      $0(A3,D3.W), D2
2248   BB02                      Eor.B     D5, D2
224A   10C2                      Move.B    D2, (A0)+
224C   DD02                      AddX.B    D2, D6
224E   4A44                      Tst       D4
2250   677E                      BEQ       L370
2252   E519                      ROL.B     $2, D1
2254   C200                      And.B     D0, D1
2256   4A15                      Tst.B     (A5)
2258   6B02                      BMI       L363
225A   1F16                      Move.B    (A6), -(A7)
225C   1614           L363:      Move.B    (A4), D3
225E   6AFC                      BPL       L363
2260   8233 3000                 Or.B      $0(A3,D3.W), D1
2264   BD01                      Eor.B     D6, D1
2266   10C1                      Move.B    D1, (A0)+
2268   DF01                      AddX.B    D1, D7
226A   5744                      SubQ.L    $3, D4
226C   60A4                      Bra       L359
226E   4A15           L364:      Tst.B     (A5)
2270   6B02                      BMI       L365
2272   1F16                      Move.B    (A6), -(A7)
2274   1614           L365:      Move.B    (A4), D3
2276   6AF6                      BPL       L364
2278   1233 3000                 Move.B    $0(A3,D3.W), D1
227C   E519                      ROL.B     $2, D1
227E   1401                      Move.B    D1, D2
2280   C400                      And.B     D0, D2
2282   1614           L366:      Move.B    (A4), D3
2284   6AFC                      BPL       L366
2286   8433 3000                 Or.B      $0(A3,D3.W), D2
228A   1607                      Move.B    D7, D3
228C   D607                      Add.B     D7, D3
228E   E31F                      ROL.B     $1, D7
2290   BF02                      Eor.B     D7, D2
2292   B418                      Cmp.B     (A0)+, D2
2294   6632                      BNE       L369
2296   DB02                      AddX.B    D2, D5
2298   E519                      ROL.B     $2, D1
229A   1401                      Move.B    D1, D2
229C   C400                      And.B     D0, D2
229E   1614           L367:      Move.B    (A4), D3
22A0   6AFC                      BPL       L367
22A2   8433 3000                 Or.B      $0(A3,D3.W), D2
22A6   BB02                      Eor.B     D5, D2
22A8   B418                      Cmp.B     (A0)+, D2
22AA   667E                      BNE       L376
22AC   DD02                      AddX.B    D2, D6
22AE   4A44                      Tst       D4
22B0   671E                      BEQ       L370
22B2   E519                      ROL.B     $2, D1
22B4   C200                      And.B     D0, D1

                      E_92:
22B6   4A15                      Tst.B     (A5)
22B8   6B02                      BMI       L368
22BA   1F16                      Move.B    (A6), -(A7)
22BC   1614           L368:      Move.B    (A4), D3
22BE   6AFC                      BPL       L368
22C0   8233 3000                 Or.B      $0(A3,D3.W), D1
22C4   BD01                      Eor.B     D6, D1
22C6   B218                      Cmp.B     (A0)+, D1
22C8   6660           L369:      BNE       L376
22CA   DF01                      AddX.B    D1, D7
22CC   5744                      SubQ.L    $3, D4
22CE   609E                      Bra       L364
22D0   4A15           L370:      Tst.B     (A5)
22D2   6B02                      BMI       L371
22D4   1F16                      Move.B    (A6), -(A7)
22D6   1614           L371:      Move.B    (A4), D3
22D8   6AFC                      BPL       L371
22DA   1233 3000                 Move.B    $0(A3,D3.W), D1
22DE   6B46                      BMI       L375
22E0   E519                      ROL.B     $2, D1
22E2   1401                      Move.B    D1, D2
22E4   C400                      And.B     D0, D2
22E6   1614           L372:      Move.B    (A4), D3
22E8   6AFC                      BPL       L372
22EA   1633 3000                 Move.B    $0(A3,D3.W), D3
22EE   6B36                      BMI       L375
22F0   8403                      Or.B      D3, D2
22F2   BA02                      Cmp.B     D2, D5
22F4   6630                      BNE       L375
22F6   E519                      ROL.B     $2, D1
22F8   1401                      Move.B    D1, D2
22FA   C400                      And.B     D0, D2
22FC   1614           L373:      Move.B    (A4), D3
22FE   6AFC                      BPL       L373
2300   1633 3000                 Move.B    $0(A3,D3.W), D3
2304   6B20                      BMI       L375
2306   8403                      Or.B      D3, D2
2308   BC02                      Cmp.B     D2, D6
230A   661A                      BNE       L375
230C   E519                      ROL.B     $2, D1
230E   C200                      And.B     D0, D1
2310   4A15                      Tst.B     (A5)
2312   6B02                      BMI       L374
2314   1F16                      Move.B    (A6), -(A7)
2316   1614           L374:      Move.B    (A4), D3
2318   6AFC                      BPL       L374
231A   1633 3000                 Move.B    $0(A3,D3.W), D3
231E   6B06                      BMI       L375
2320   8203                      Or.B      D3, D1
2322   BE01                      Cmp.B     D1, D7
2324   6708                      BEQ       L377
2326   70B8           L375:      MoveQ.L   $-48, D0
2328   601A                      Bra       L380
232A   70BC           L376:      MoveQ.L   $-44, D0
232C   6016                      Bra       L380
232E   7801           L377:      MoveQ.L   $1, D4
2330   1614           L378:      Move.B    (A4), D3
2332   6AFC                      BPL       L378
2334   4A15                      Tst.B     (A5)
2336   6B02                      BMI       L379
2338   1F16                      Move.B    (A6), -(A7)
233A   B61A           L379:      Cmp.B     (A2)+, D3
233C   660A                      BNE       L381
233E   51CC FFF0                 DBF       D4, L378
2342   7000                      MoveQ.L   $0, D0
2344   6000 FC64      L380:      Bra       L321
2348   70B7           L381:      MoveQ.L   $-49, D0
234A   60F8                      Bra       L380
234C   0001 FFFF 0203            DC.B      '      '
2352   FF04 0506 FFFF            DC.B      '      '
2358   FFFF FFFF 0708            DC.B      '      '
235E   FFFF FF09 0A0B            DC.B      '      '
2364   0C0D FFFF 0E0F            DC.B      '      '
236A   1011 1213 FF14            DC.B      '      '
2370   1516 1718 191A            DC.B      '      '
2376   FFFF FFFF FFFF            DC.B      '      '
237C   FFFF FFFF FF1B            DC.B      '      '
2382   FF1C 1D1E FFFF            DC.B      '      '
2388   FF1F FFFF 2021            DC.B      '     !'
238E   FF22 2324 2526            DC.B      ' "#$%&'
2394   2728 FFFF FFFF            DC.B      ''(    '
239A   FF29 2A2B FF2C            DC.B      ' )*+ ,'
23A0   2D2E 2F30 3132            DC.B      '-./012'
23A6   FFFF 3334 3536            DC.B      '  3456'
23AC   3738 FF39 3A3B            DC.B      '78 9:;'
23B2   3C3D 3E3F                 DC.B      '<=>?'

                      DT22:
23B6   FF3F CFF3 FCFF            DC.B      ' ?    '
23BC   D5AA                      DC.B      '  '

                      E_Sony_WrData:
23BE   45FA FFF6                 Lea.L     DT22, A2
23C2   2F38 0232                 Move.L    (DiskVars.JWrData), -(A7)
23C6   4E75                      Rts

                      P_Sony_WrData:
23C8   21DF 0124                 Move.L    (A7)+, (DskRtnAdr)
23CC   43F8 02FB                 Lea.L     (TagData.1), A1
23D0   283C 0201 0009            Move.L    $2010009, D4
23D6   7400                      MoveQ.L   $0, D2
23D8   7600                      MoveQ.L   $0, D3
23DA   267C 00DF FBFF            Move.L    $DFFBFF, A3
23E0   4A13                      Tst.B     (A3)
23E2   7006                      MoveQ.L   $6, D0
23E4   7A00                      MoveQ.L   $0, D5
23E6   13DA 00DF FFFF            Move.B    (A2)+, ($DFFFFF)
23EC   7C00                      MoveQ.L   $0, D6
23EE   7E00                      MoveQ.L   $0, D7
23F0   121A           L382:      Move.B    (A2)+, D1
23F2   4A14           L383:      Tst.B     (A4)
23F4   6AFC                      BPL       L383
23F6   1681                      Move.B    D1, (A3)
23F8   4A15                      Tst.B     (A5)
23FA   6B02                      BMI       L384
23FC   1F16                      Move.B    (A6), -(A7)
23FE   5340           L384:      SubQ.L    $1, D0
2400   66EE                      BNE       L382
2402   121A                      Move.B    (A2)+, D1
2404   45FA 010C                 Lea.L     DT24, A2
2408   4A14           L385:      Tst.B     (A4)
240A   6AFC                      BPL       L385
240C   1681                      Move.B    D1, (A3)
240E   720B                      MoveQ.L   $B, D1
2410   1419                      Move.B    (A1)+, D2
2412   602C                      Bra       L391
2414   2248           L386:      Move.L    A0, A1
2416   DF02           L387:      AddX.B    D2, D7
2418   BD02                      Eor.B     D6, D2
241A   1602                      Move.B    D2, D3
241C   EC4B                      LsR       $6, D3
241E   4A14           L388:      Tst.B     (A4)
2420   6AFC                      BPL       L388
2422   16B2 3000                 Move.B    $0(A2,D3.W), (A3)
2426   5744                      SubQ.L    $3, D4
2428   1607                      Move.B    D7, D3
242A   D607                      Add.B     D7, D3
242C   E31F                      ROL.B     $1, D7
242E   0200 003F                 And.B     $3F, D0
2432   4A15           L389:      Tst.B     (A5)
2434   6B02                      BMI       L390
2436   1F16                      Move.B    (A6), -(A7)
2438   4A14           L390:      Tst.B     (A4)
243A   6AF6                      BPL       L389
243C   16B2 0000                 Move.B    $0(A2,D0.W), (A3)
2440   1019           L391:      Move.B    (A1)+, D0
2442   DB00                      AddX.B    D0, D5
2444   BF00                      Eor.B     D7, D0
2446   1600                      Move.B    D0, D3
2448   E55B                      ROL       $2, D3
244A   0201 003F                 And.B     $3F, D1
244E   4A14           L392:      Tst.B     (A4)
2450   6AFC                      BPL       L392
2452   16B2 1000                 Move.B    $0(A2,D1.W), (A3)
2456   1219                      Move.B    (A1)+, D1
2458   DD01                      AddX.B    D1, D6
245A   BB01                      Eor.B     D5, D1
245C   1601                      Move.B    D1, D3
245E   E55B                      ROL       $2, D3
2460   0202 003F                 And.B     $3F, D2
2464   4A15                      Tst.B     (A5)
2466   6B02                      BMI       L393
2468   1F16                      Move.B    (A6), -(A7)
246A   4A14           L393:      Tst.B     (A4)
246C   6AFC                      BPL       L393
246E   16B2 2000                 Move.B    $0(A2,D2.W), (A3)
2472   1419                      Move.B    (A1)+, D2
2474   4A44                      Tst       D4
2476   669E                      BNE       L387
2478   4844                      Swap      D4
247A   6698                      BNE       L386
247C   4203                      Clr.B     D3
247E   EC4B                      LsR       $6, D3
2480   4A14           L394:      Tst.B     (A4)
2482   6AFC                      BPL       L394
2484   16B2 3000                 Move.B    $0(A2,D3.W), (A3)
2488   1605                      Move.B    D5, D3
248A   E55B                      ROL       $2, D3
248C   1606                      Move.B    D6, D3
248E   E55B                      ROL       $2, D3
2490   0200 003F                 And.B     $3F, D0
2494   4A14           L395:      Tst.B     (A4)
2496   6AFC                      BPL       L395
2498   16B2 0000                 Move.B    $0(A2,D0.W), (A3)
249C   0201 003F                 And.B     $3F, D1
24A0   4A15                      Tst.B     (A5)
24A2   6B02                      BMI       L396
24A4   1F16                      Move.B    (A6), -(A7)
24A6   4A14           L396:      Tst.B     (A4)
24A8   6AFC                      BPL       L396
24AA   16B2 1000                 Move.B    $0(A2,D1.W), (A3)
24AE   1607                      Move.B    D7, D3
24B0   EC4B                      LsR       $6, D3
24B2   4A14           L397:      Tst.B     (A4)
24B4   6AFC                      BPL       L397
24B6   16B2 3000                 Move.B    $0(A2,D3.W), (A3)
24BA   0205 003F                 And.B     $3F, D5
24BE   4A14           L398:      Tst.B     (A4)
24C0   6AFC                      BPL       L398
24C2   16B2 5000                 Move.B    $0(A2,D5.W), (A3)
24C6   0206 003F                 And.B     $3F, D6
24CA   4A15                      Tst.B     (A5)
24CC   6B02                      BMI       L399
24CE   1F16                      Move.B    (A6), -(A7)
24D0   4A14           L399:      Tst.B     (A4)
24D2   6AFC                      BPL       L399
24D4   16B2 6000                 Move.B    $0(A2,D6.W), (A3)
24D8   0207 003F                 And.B     $3F, D7
24DC   4A14           L400:      Tst.B     (A4)
24DE   6AFC                      BPL       L400
24E0   16B2 7000                 Move.B    $0(A2,D7.W), (A3)
24E4   45FA 0028                 Lea.L     DT23, A2
24E8   7403                      MoveQ.L   $3, D2
24EA   1214           L401:      Move.B    (A4), D1
24EC   6AFC                      BPL       L401
24EE   169A                      Move.B    (A2)+, (A3)
24F0   4A15                      Tst.B     (A5)
24F2   6B02                      BMI       L402
24F4   1F16                      Move.B    (A6), -(A7)
24F6   51CA FFF2      L402:      DBF       D2, L401
24FA   7000                      MoveQ.L   $0, D0
24FC   0801 0006                 BTst.B    $6, D1
2500   6602                      BNE       L403
2502   70B6                      MoveQ.L   $-4A, D0
2504   4A39 00DF FDFF L403:      Tst.B     ($DFFDFF)
250A   6000 FA9E                 Bra       L321

                      DT23:
250E   DEAA FFFF                 DC.B      '    '

                      DT24:
2512   9697 9A9B 9D9E            DC.B      '      '
2518   9FA6 A7AB ACAD            DC.B      '      '
251E   AEAF B2B3 B4B5            DC.B      '      '
2524   B6B7 B9BA BBBC            DC.B      '      '
252A   BDBE BFCB CDCE            DC.B      '      '
2530   CFD3 D6D7 D9DA            DC.B      '      '
2536   DBDC DDDE DFE5            DC.B      '      '
253C   E6E7 E9EA EBEC            DC.B      '      '
2542   EDEE EFF2 F3F4            DC.B      '      '
2548   F5F6 F7F9 FAFB            DC.B      '      '
254E   FCFD FEFF                 DC.B      '    '

                      Driver_AIn:
2552   4D00                      DC.W      $4D00           ; flags
2554   0000                      DC.W      $0000           ; number of ticks between periodic actions
2556   0000                      DC.W      $0000           ; desk accessory event mask
2558   0000                      DC.W      $0000           ; menu ID
255A   0060                      DC.W      $0060           ; offset to open routine
255C   036A                      DC.W      $036A           ; offset to prime routine
255E   0232                      DC.W      $0232           ; offset to control routine
2560   01F6                      DC.W      $01F6           ; offset to status routine
2562   01F4                      DC.W      $01F4           ; offset to close routine
2564   04                        DC.B      $04             ; length of driver name
                      ; Name
2565   2E41 496E                 DC.B      '.AIn'
                      ; end of Name
2569   20                        DC.B      $20             ; align to word

                      Driver_AOut:
256A   4E00                      DC.W      $4E00           ; flags
256C   0000                      DC.W      $0000           ; number of ticks between periodic actions
256E   0000                      DC.W      $0000           ; desk accessory event mask
2570   0000                      DC.W      $0000           ; menu ID
2572   0054                      DC.W      $0054           ; offset to open routine
2574   02A4                      DC.W      $02A4           ; offset to prime routine
2576   021A                      DC.W      $021A           ; offset to control routine
2578   01DE                      DC.W      $01DE           ; offset to status routine
257A   019C                      DC.W      $019C           ; offset to close routine
257C   05                        DC.B      $05             ; length of driver name
                      ; Name
257D   2E41 4F75 74              DC.B      '.AOut'
                      ; end of Name

                      Driver_BIn:
2582   4D00                      DC.W      $4D00           ; flags
2584   0000                      DC.W      $0000           ; number of ticks between periodic actions
2586   0000                      DC.W      $0000           ; desk accessory event mask
2588   0000                      DC.W      $0000           ; menu ID
258A   0036                      DC.W      $0036           ; offset to open routine
258C   0340                      DC.W      $0340           ; offset to prime routine
258E   0208                      DC.W      $0208           ; offset to control routine
2590   01CC                      DC.W      $01CC           ; offset to status routine
2592   01C4                      DC.W      $01C4           ; offset to close routine
2594   04                        DC.B      $04             ; length of driver name
                      ; Name
2595   2E42 496E                 DC.B      '.BIn'
                      ; end of Name
2599   20                        DC.B      $20             ; align to word

                      Driver_BOut:
259A   4E00                      DC.W      $4E00           ; flags
259C   0000                      DC.W      $0000           ; number of ticks between periodic actions
259E   0000                      DC.W      $0000           ; desk accessory event mask
25A0   0000                      DC.W      $0000           ; menu ID
25A2   0050                      DC.W      $0050           ; offset to open routine
25A4   027A                      DC.W      $027A           ; offset to prime routine
25A6   01F0                      DC.W      $01F0           ; offset to control routine
25A8   01B4                      DC.W      $01B4           ; offset to status routine
25AA   017E                      DC.W      $017E           ; offset to close routine
25AC   05                        DC.B      $05             ; length of driver name
                      ; Name
25AD   2E42 4F75 74              DC.B      '.BOut'
                      ; end of Name

                      E_AIn_Open:
25B2   21C9 02D4                 Move.L    A1, (SerialVars.a.dce)
25B6   4E75                      Rts

                      E_BIn_Open:
25B8   21C9 02DC                 Move.L    A1, (ABusVars.dce)
25BC   4E75                      Rts

                      E_AOut_Open:
25BE   7008                      MoveQ.L   $8, D0
25C0   45F8 02D0                 Lea.L     (SerialVars_a), A2
25C4   47FA 02C8                 Lea.L     P_SCCInt_AOutEmpty, A3
25C8   49FA 049A                 Lea.L     P_SCCInt_AChng_AOut, A4
25CC   4BFA 03CA                 Lea.L     P_SCCInt_AInAvail, A5
25D0   4DFA 0450                 Lea.L     P_SCCInt_AInSpcl, A6
25D4   7202                      MoveQ.L   $2, D1
25D6   74F7                      MoveQ.L   $-9, D2
25D8   7680                      MoveQ.L   $-80, D3
25DA   3838 01FC                 Move      (SPPortA), D4
25DE   612A                      Bsr       P60
25E0   487A 037A                 Pea.L     P_AOut_PollProc
25E4   21DF 013E                 Move.L    (A7)+, (PollProc)
25E8   4E75                      Rts

                      E_BOut_Open:
25EA   7000                      MoveQ.L   $0, D0
25EC   45F8 02D8                 Lea.L     (ABusVars), A2
25F0   47FA 0296                 Lea.L     P_SCCInt_BOutEmpty, A3
25F4   49FA 0468                 Lea.L     P_SCCInt_BChng_BOut, A4
25F8   4BFA 0398                 Lea.L     P_SCCInt_BInAvail, A5
25FC   4DFA 041E                 Lea.L     P_SCCInt_BInSpcl, A6
2600   7200                      MoveQ.L   $0, D1
2602   7417                      MoveQ.L   $17, D2
2604   7640                      MoveQ.L   $40, D3
2606   3838 01FE                 Move      (SPPortB), D4

                      P60:
260A   41F8 02BE                 Lea.L     (ExtStsDT), A0
260E   218C 0000                 Move.L    A4, $0(A0,D0.W)
2612   41F8 01B2                 Lea.L     (Lvl2DT), A0
2616   D040                      Add       D0, D0
2618   218B 0000                 Move.L    A3, $0(A0,D0.W)
261C   48F0 6000 0008            MoveM.L   A5-A6, $8(A0,D0.W)
2622   7070                      MoveQ.L   $70, D0
2624   A722                      _NewHandleSysClear
2626   08D0 0007                 BSet.B    $7, (A0)
262A   2348 0014                 Move.L    A0, $14(A1)
262E   2490                      Move.L    (A0), (A2)
2630   2450                      Move.L    (A0), A2
2632   264A                      Move.L    A2, A3
2634   26C9                      Move.L    A1, (A3)+
2636   36C1                      Move      D1, (A3)+
2638   6100 018E                 Bsr       P64
263C   50EA 0011                 ST.B      $11(A2)
2640   50EA 0014                 ST.B      $14(A2)
2644   1543 0020                 Move.B    D3, $20(A2)
2648   1542 0029                 Move.B    D2, $29(A2)

                      P61:
264C   3544 002A                 Move      D4, $2A(A2)
2650   47EA 0021                 Lea.L     $21(A2), A3
2654   49FA 0022                 Lea.L     DT25, A4
2658   7007                      MoveQ.L   $7, D0
265A   121C           L404:      Move.B    (A4)+, D1
265C   3604                      Move      D4, D3
265E   E37B                      ROL       D1, D3
2660   C61C                      And.B     (A4)+, D3
2662   861C                      Or.B      (A4)+, D3
2664   16C3                      Move.B    D3, (A3)+
2666   51C8 FFF2                 DBF       D0, L404
266A   7264                      MoveQ.L   $64, D1
266C   C213                      And.B     (A3), D1
266E   1541 0022                 Move.B    D1, $22(A2)
2672   6140                      Bsr       P62
2674   7000                      MoveQ.L   $0, D0
2676   4E75                      Rts

                      DT25:
2678   040F 4000 0000            DC.B      '  @   '
267E   0CC0 000B 6002            DC.B      '    ` '
2684   00FF 0008 0300            DC.B      '      '
268A   0CC0 010B 600A            DC.B      '    ` '

                      DT26:
2690   09FF 04FF 01FF            DC.B      '      '
2696   0002 03FF 05FF            DC.B      '      '
269C   0209 500B 0CFF            DC.B      '  P   '
26A2   0DFF 03FF 05FF            DC.B      '      '
26A8   010E A80F 4000            DC.B      '    @ '
26AE   4000 01FF 0A09            DC.B      '@     '

                      P62:
26B4   47FA FFDA                 Lea.L     DT26, A3
26B8   7224                      MoveQ.L   $24, D1

                      P63:
26BA   40E7                      Move      SR, -(A7)
26BC   48E7 00E0                 MoveM.L   A0-A2, -(A7)
26C0   342A 0004                 Move      $4(A2), D2
26C4   4CF8 0300 01D8            MoveM.L   (SCCRd), A0-A1
26CA   D0C2                      AddA      D2, A0
26CC   D2C2                      AddA      D2, A1
26CE   007C 0300                 Or        $300, SR
26D2   1410                      Move.B    (A0), D2
26D4   45EA 0020                 Lea.L     $20(A2), A2
26D8   301B           L405:      Move      (A3)+, D0
26DA   4A00                      Tst.B     D0
26DC   6A04                      BPL       L406
26DE   101A                      Move.B    (A2)+, D0
26E0   E058                      ROR       $8, D0
26E2   1280           L406:      Move.B    D0, (A1)
26E4   E058                      ROR       $8, D0
26E6   2E97                      Move.L    (A7), (A7)
26E8   1280                      Move.B    D0, (A1)
26EA   5541                      SubQ.L    $2, D1
26EC   6EEA                      BGT       L405
26EE   1410                      Move.B    (A0), D2
26F0   E50A                      LsL.B     $2, D2
26F2   4CDF 0700                 MoveM.L   (A7)+, A0-A2
26F6   5BEA 001C                 SMI.B     $1C(A2)
26FA   4E73                      Rte

                      DT27:
26FC   09FF 080F 4000            DC.B      '    @ '
2702   4000 0101                 DC.B      '@   '

                      E_AOut_Close:
2706   42B8 013E                 Clr.L     (PollProc)
270A   49F8 01C2                 Lea.L     (Lvl2DT.4), A4
270E   4BF8 02C6                 Lea.L     (ExtStsDT.A), A5
2712   2478 02D0                 Move.L    (SerialVars_a), A2
2716   600C                      Bra       L407

                      E_BOut_Close:
2718   49F8 01B2                 Lea.L     (Lvl2DT), A4
271C   4BF8 02BE                 Lea.L     (ExtStsDT), A5
2720   2478 02D8                 Move.L    (ABusVars), A2
2724   47FA FFD6      L407:      Lea.L     DT27, A3
2728   720A                      MoveQ.L   $A, D1
272A   618E                      Bsr       P63
272C   47FA 0018                 Lea.L     E_ABIn_Close, A3
2730   288B                      Move.L    A3, (A4)
2732   2A8B                      Move.L    A3, (A5)
2734   508C                      AddQ      $8, A4
2736   28CB                      Move.L    A3, (A4)+
2738   288B                      Move.L    A3, (A4)
273A   2069 0014                 Move.L    $14(A1), A0
273E   A023                      _DisposeHandle
2740   42A9 0014                 Clr.L     $14(A1)
2744   4292                      Clr.L     (A2)

                      E_ABIn_Close:
2746   4E75                      Rts

                      E_AInOut_Status:
2748   2478 02D0                 Move.L    (SerialVars_a), A2
274C   6004                      Bra       L408

                      E_BInOut_Status:
274E   2478 02D8                 Move.L    (ABusVars), A2
2752   41E8 001A      L408:      Lea.L     $1A(A0), A0
2756   70EE                      MoveQ.L   $-12, D0
2758   7202                      MoveQ.L   $2, D1
275A   9258                      Sub       (A0)+, D1
275C   660E                      BNE       L409
275E   6100 01E0                 Bsr       P70
2762   6100 01EC                 Bsr       P71
2766   4258                      Clr       (A0)+
2768   3080                      Move      D0, (A0)
276A   6010                      Bra       L410
276C   5C41           L409:      AddQ      $6, D1
276E   660E                      BNE       L411
2770   30EA 0018                 Move      $18(A2), (A0)+
2774   422A 0018                 Clr.B     $18(A2)
2778   20EA 001A                 Move.L    $1A(A2), (A0)+
277C   7000           L410:      MoveQ.L   $0, D0
277E   2F38 08FC      L411:      Move.L    (JIODone), -(A7)
2782   4E75                      Rts

                      E_AInOut_Control:
2784   2478 02D0                 Move.L    (SerialVars_a), A2
2788   6004                      Bra       L412

                      E_BInOut_Control:
278A   2478 02D8                 Move.L    (ABusVars), A2
278E   41E8 001A      L412:      Lea.L     $1A(A0), A0
2792   3218                      Move      (A0)+, D1
2794   5341                      SubQ.L    $1, D1
2796   660A                      BNE       L413
2798   426A 001A                 Clr       $1A(A2)
279C   42AA 002C                 Clr.L     $2C(A2)
27A0   4E75                      Rts
27A2   5F41           L413:      SubQ.L    $7, D1
27A4   6610                      BNE       L416
27A6   3818                      Move      (A0)+, D4
27A8   B86A 002A                 Cmp       $2A(A2), D4
27AC   6704                      BEQ       L414
27AE   6100 FE9C                 Bsr       P61
27B2   7000           L414:      MoveQ.L   $0, D0
27B4   60C8           L415:      Bra       L411
27B6   5341           L416:      SubQ.L    $1, D1
27B8   6624                      BNE       L418
27BA   487A FFF6                 Pea.L     L414
27BE   42AA 002C                 Clr.L     $2C(A2)
27C2   2858                      Move.L    (A0)+, A4
27C4   3210                      Move      (A0), D1
27C6   6606                      BNE       L417

                      P64:
27C8   49EA 0030                 Lea.L     $30(A2), A4
27CC   7240                      MoveQ.L   $40, D1
27CE   47EA 0006      L417:      Lea.L     $6(A2), A3
27D2   26CC                      Move.L    A4, (A3)+
27D4   36C1                      Move      D1, (A3)+
27D6   E449                      LsR       $2, D1
27D8   36C1                      Move      D1, (A3)+
27DA   36C1                      Move      D1, (A3)+
27DC   4E75                      Rts
27DE   5341           L418:      SubQ.L    $1, D1
27E0   660C                      BNE       L419
27E2   D4FC 0010                 AddA      $10, A2
27E6   24D8                      Move.L    (A0)+, (A2)+
27E8   34D8                      Move      (A0)+, (A2)+
27EA   1498                      Move.B    (A0)+, (A2)
27EC   60C4                      Bra       L414
27EE   102A 0028      L419:      Move.B    $28(A2), D0
27F2   5341                      SubQ.L    $1, D1
27F4   6708                      BEQ       L420
27F6   08C0 0004                 BSet.B    $4, D0
27FA   5341                      SubQ.L    $1, D1
27FC   660C                      BNE       L421
27FE   6154           L420:      Bsr       P65
2800   16BC 0005                 Move.B    $5, (A3)
2804   2E97                      Move.L    (A7), (A7)
2806   1680                      Move.B    D0, (A3)
2808   60A8                      Bra       L414
280A   70EF           L421:      MoveQ.L   $-11, D0
280C   60A6           L422:      Bra       L415

                      E_AOut_Prime:
280E   2478 02D0                 Move.L    (SerialVars_a), A2
2812   6004                      Bra       L423

                      E_BOut_Prime:
2814   2478 02D8                 Move.L    (ABusVars), A2
2818   40E7           L423:      Move      SR, -(A7)
281A   007C 0300                 Or        $300, SR
281E   6148                      Bsr       P66
2820   6620                      BNE       L426
2822   6130           L424:      Bsr       P65
2824   671C                      BEQ       L426
2826   102A 0017                 Move.B    $17(A2), D0
282A   422A 0017                 Clr.B     $17(A2)
282E   0240 00FF                 And       $FF, D0
2832   6606                      BNE       L425
2834   2078 08F4                 Move.L    (JFetch), A0
2838   4E90                      Jsr       (A0)
283A   1740 0004      L425:      Move.B    D0, $4(A3)
283E   4A40                      Tst       D0
2840   6B08                      BMI       L427
2842   50EA 001B      L426:      ST.B      $1B(A2)
2846   7000                      MoveQ.L   $0, D0
2848   4E73                      Rte
284A   422A 001B      L427:      Clr.B     $1B(A2)
284E   46DF                      Move      (A7)+, SR
2850   7000           L428:      MoveQ.L   $0, D0
2852   60B8                      Bra       L422

                      P65:
2854   2678 01D8                 Move.L    (SCCRd), A3
2858   D6EA 0004                 AddA      $4(A2), A3
285C   0813 0002                 BTst.B    $2, (A3)
2860   D7FC 0020 0001            AddA.L    $200001, A3
2866   4E75                      Rts

                      P66:
2868   4A2A 0010                 Tst.B     $10(A2)
286C   6706                      BEQ       L429
286E   4A2A 001D                 Tst.B     $1D(A2)
2872   660C                      BNE       L430
2874   4A2A 0011      L429:      Tst.B     $11(A2)
2878   670A                      BEQ       L431
287A   4A2A 001C                 Tst.B     $1C(A2)
287E   6704                      BEQ       L431
2880   7001           L430:      MoveQ.L   $1, D0
2882   4E75                      Rts
2884   7000           L431:      MoveQ.L   $0, D0
2886   4E75                      Rts

                      P_SCCInt_BOutEmpty:
2888   2478 02D8                 Move.L    (ABusVars), A2
288C   6004                      Bra       L432

                      P_SCCInt_AOutEmpty:
288E   2478 02D0                 Move.L    (SerialVars_a), A2
2892   4A2A 0017      L432:      Tst.B     $17(A2)
2896   660A                      BNE       L433
2898   4A2A 001B                 Tst.B     $1B(A2)
289C   670C                      BEQ       L434
289E   61C8                      Bsr       P66
28A0   6608                      BNE       L434
28A2   2252           L433:      Move.L    (A2), A1
28A4   40E7                      Move      SR, -(A7)
28A6   6000 FF7A                 Bra       L424
28AA   12BC 0028      L434:      Move.B    $28, (A1)
28AE   4E75                      Rts
28B0   422A 001D      L435:      Clr.B     $1D(A2)
28B4   4A2A 001B      L436:      Tst.B     $1B(A2)
28B8   66E8                      BNE       L433
28BA   4E75                      Rts

                      E_AIn_Prime:
28BC   2478 02D0                 Move.L    (SerialVars_a), A2
28C0   6004                      Bra       L437

                      E_BIn_Prime:
28C2   2478 02D8                 Move.L    (ABusVars), A2
28C6   6178           L437:      Bsr       P70
28C8   40E7           L438:      Move      SR, -(A7)
28CA   007C 0300                 Or        $300, SR
28CE   B46A 002C                 Cmp       $2C(A2), D2
28D2   671E                      BEQ       L440
28D4   1033 2000                 Move.B    $0(A3,D2.W), D0
28D8   5242                      AddQ      $1, D2
28DA   B443                      Cmp       D3, D2
28DC   6602                      BNE       L439
28DE   7400                      MoveQ.L   $0, D2
28E0   3542 002E      L439:      Move      D2, $2E(A2)
28E4   613A                      Bsr       P68
28E6   46DF                      Move      (A7)+, SR
28E8   4A40                      Tst       D0
28EA   6ADC                      BPL       L438
28EC   610A                      Bsr       P67
28EE   6000 FF60                 Bra       L428
28F2   50EA 001A      L440:      ST.B      $1A(A2)
28F6   6006                      Bra       L441

                      P67:
28F8   40E7                      Move      SR, -(A7)
28FA   007C 0300                 Or        $300, SR
28FE   4A2A 0016      L441:      Tst.B     $16(A2)
2902   6718                      BEQ       L442
2904   613A                      Bsr       P70
2906   6148                      Bsr       P71
2908   B06A 000C                 Cmp       $C(A2), D0
290C   620E                      BHI       L442
290E   08AA 0007 0019            BClr.B    $7, $19(A2)
2914   6706                      BEQ       L442
2916   102A 0012                 Move.B    $12(A2), D0
291A   610A                      Bsr       P69
291C   7000           L442:      MoveQ.L   $0, D0
291E   4E73                      Rte

                      P68:
2920   2F38 08F8                 Move.L    (JStash), -(A7)
2924   4E75                      Rts

                      P69:
2926   41EA 0017                 Lea.L     $17(A2), A0
292A   4A10                      Tst.B     (A0)
292C   6704                      BEQ       L445
292E   4210           L443:      Clr.B     (A0)
2930   4E75           L444:      Rts
2932   1080           L445:      Move.B    D0, (A0)
2934   6100 FF1E                 Bsr       P65
2938   67F6                      BEQ       L444
293A   1740 0004                 Move.B    D0, $4(A3)
293E   60EE                      Bra       L443

                      P70:
2940   266A 0006                 Move.L    $6(A2), A3
2944   362A 000A                 Move      $A(A2), D3
2948   4CAA 0006 002C            MoveM     $2C(A2), D1-D2
294E   4E75                      Rts

                      P71:
2950   3001                      Move      D1, D0
2952   9042                      Sub       D2, D0
2954   6400 0004                 BCC       L446
2958   D043                      Add       D3, D0
295A   4E75           L446:      Rts

                      P_AOut_PollProc:
295C   2878 013A                 Move.L    (PollStack), A4
2960   21DF 0124                 Move.L    (A7)+, (DskRtnAdr)
2964   4A15           L447:      Tst.B     (A5)
2966   6B04                      BMI       L448
2968   1F16                      Move.B    (A6), -(A7)
296A   60F8                      Bra       L447
296C   B9CF           L448:      CmpA.L    A7, A4
296E   6718                      BEQ       L449
2970   554C                      SubQ.L    $2, A4
2972   1014                      Move.B    (A4), D0
2974   47F8 02D0                 Lea.L     (SerialVars_a), A3
2978   41F9 009F FFFA            Lea.L     ($9FFFFA), A0
297E   43F9 00BF FFFB            Lea.L     ($BFFFFB), A1
2984   611A                      Bsr       P72
2986   60DC                      Bra       L447
2988   2E78 013A      L449:      Move.L    (PollStack), A7
298C   2F38 0124                 Move.L    (DskRtnAdr), -(A7)
2990   4E75                      Rts

                      P_SCCInt_BInAvail:
2992   47F8 02D8                 Lea.L     (ABusVars), A3
2996   6004                      Bra       L450

                      P_SCCInt_AInAvail:
2998   47F8 02D0                 Lea.L     (SerialVars_a), A3
299C   1028 0004      L450:      Move.B    $4(A0), D0

                      P72:
29A0   245B                      Move.L    (A3)+, A2
29A2   2653                      Move.L    (A3), A3
29A4   4A2A 0010                 Tst.B     $10(A2)
29A8   6718                      BEQ       L451
29AA   727F                      MoveQ.L   $7F, D1
29AC   C200                      And.B     D0, D1
29AE   B22A 0012                 Cmp.B     $12(A2), D1
29B2   6700 FEFC                 BEQ       L435
29B6   B22A 0013                 Cmp.B     $13(A2), D1
29BA   6606                      BNE       L451
29BC   50EA 001D                 ST.B      $1D(A2)
29C0   6058                      Bra       L455
29C2   4A2A 001A      L451:      Tst.B     $1A(A2)
29C6   6710                      BEQ       L452
29C8   224B                      Move.L    A3, A1
29CA   6100 FF54                 Bsr       P68
29CE   6A4A                      BPL       L455
29D0   422A 001A                 Clr.B     $1A(A2)
29D4   6000 FE7A                 Bra       L428
29D8   6100 FF66      L452:      Bsr       P70
29DC   1780 1000                 Move.B    D0, $0(A3,D1.W)
29E0   5241                      AddQ      $1, D1
29E2   B243                      Cmp       D3, D1
29E4   6602                      BNE       L453
29E6   7200                      MoveQ.L   $0, D1
29E8   B242           L453:      Cmp       D2, D1
29EA   6608                      BNE       L454
29EC   08EA 0000 0018            BSet.B    $0, $18(A2)
29F2   4E75                      Rts
29F4   3541 002C      L454:      Move      D1, $2C(A2)
29F8   4A2A 0016                 Tst.B     $16(A2)
29FC   671C                      BEQ       L455
29FE   6100 FF50                 Bsr       P71
2A02   9640                      Sub       D0, D3
2A04   B06A 000E                 Cmp       $E(A2), D0
2A08   6410                      BCC       L455
2A0A   08EA 0007 0019            BSet.B    $7, $19(A2)
2A10   6608                      BNE       L455
2A12   102A 0013                 Move.B    $13(A2), D0
2A16   6100 FF0E                 Bsr       P69
2A1A   4E75           L455:      Rts

                      P_SCCInt_BInSpcl:
2A1C   47F8 02D8                 Lea.L     (ABusVars), A3
2A20   6004                      Bra       L456

                      P_SCCInt_AInSpcl:
2A22   47F8 02D0                 Lea.L     (SerialVars_a), A3
2A26   12BC 0001      L456:      Move.B    $1, (A1)
2A2A   245B                      Move.L    (A3)+, A2
2A2C   2653                      Move.L    (A3), A3
2A2E   1210                      Move.B    (A0), D1
2A30   7670                      MoveQ.L   $70, D3
2A32   C203                      And.B     D3, D1
2A34   832A 0018                 Or.B      D1, $18(A2)
2A38   1028 0004                 Move.B    $4(A0), D0
2A3C   142A 0014                 Move.B    $14(A2), D2
2A40   B302                      Eor.B     D1, D2
2A42   12BC 0030                 Move.B    $30, (A1)
2A46   C403                      And.B     D3, D2
2A48   6700 FF78                 BEQ       L451
2A4C   4A2A 001A                 Tst.B     $1A(A2)
2A50   67C8                      BEQ       L455
2A52   70A7                      MoveQ.L   $-59, D0
2A54   224B           L457:      Move.L    A3, A1
2A56   422A 001A                 Clr.B     $1A(A2)
2A5A   6000 FD22                 Bra       L411

                      P_SCCInt_BChng_BOut:
2A5E   47F8 02D8                 Lea.L     (ABusVars), A3
2A62   6004                      Bra       L458

                      P_SCCInt_AChng_AOut:
2A64   47F8 02D0                 Lea.L     (SerialVars_a), A3
2A68   245B           L458:      Move.L    (A3)+, A2
2A6A   2653                      Move.L    (A3), A3
2A6C   1401                      Move.B    D1, D2
2A6E   C42A 0015                 And.B     $15(A2), D2
2A72   6718                      BEQ       L459
2A74   48E7 8080                 MoveM.L   D0/A0, -(A7)
2A78   307C 000B                 Move      $B, A0
2A7C   E140                      AsL       $8, D0
2A7E   1001                      Move.B    D1, D0
2A80   4840                      Swap      D0
2A82   302B 0018                 Move      $18(A3), D0
2A86   A02F                      _PostEvent
2A88   4CDF 0101                 MoveM.L   (A7)+, D0/A0
2A8C   4A01           L459:      Tst.B     D1
2A8E   6B0C                      BMI       L460
2A90   E508                      LsL.B     $2, D0
2A92   5BEA 001C                 SMI.B     $1C(A2)
2A96   6A00 FE1C                 BPL       L436
2A9A   4E75                      Rts
2A9C   4A00           L460:      Tst.B     D0
2A9E   6B06                      BMI       L461
2AA0   1028 0004                 Move.B    $4(A0), D0
2AA4   4E75                      Rts
2AA6   70A6           L461:      MoveQ.L   $-5A, D0
2AA8   4A2A 001A                 Tst.B     $1A(A2)
2AAC   66A6                      BNE       L457
2AAE   4E75                      Rts

                      DT28:
2AB0   00FF FFFF 0000            DC.B      '      '
2AB6   0400 0000 2000            DC.B      '      '
2ABC   0000 0000 0B00            DC.B      '      '
2AC2   0000 4B00 0020            DC.B      '  K   '
2AC8   0000 0000                 DC.B      '    '

                      P73:
2ACC   41FA FFE2                 Lea.L     DT28, A0
2AD0   43F8 031A                 Lea.L     (Lo3Bytes), A1
2AD4   7006                      MoveQ.L   $6, D0
2AD6   32D8           L462:      Move      (A0)+, (A1)+
2AD8   51C8 FFFC                 DBF       D0, L462
2ADC   A019                      _InitZone
2ADE   21F8 0118 02A6            Move.L    (TheZone), (SysZone)
2AE4   4E75                      Rts

                      P_tSetAppBase:
2AE6   48E7 103E                 MoveM.L   D3/A2-A6, -(A7)
2AEA   2C78 02A6                 Move.L    (SysZone), A6
2AEE   90FC 000C                 SubA      $C, A0
2AF2   B1D6                      CmpA.L    (A6), A0
2AF4   6304                      BLS       L463
2AF6   4EBA 05FC                 Jsr       P_mZoneAdjustEnd
2AFA   6106           L463:      Bsr       P_tInitApplZone
2AFC   4CDF 7C08                 MoveM.L   (A7)+, D3/A2-A6
2B00   4E75                      Rts

                      P_tInitApplZone:
2B02   2F0E                      Move.L    A6, -(A7)
2B04   A996                      _RsrcZoneInit
2B06   42B8 02AA                 Clr.L     (ApplZone)
2B0A   4EBA 05CE                 Jsr       P_mToMaxLimit
2B0E   21C2 0130                 Move.L    D2, (ApplLimit)
2B12   2C78 02A6                 Move.L    (SysZone), A6
2B16   2056                      Move.L    (A6), A0
2B18   41E8 000C                 Lea.L     $C(A0), A0
2B1C   2248                      Move.L    A0, A1
2B1E   D2FC 1800                 AddA      $1800, A1
2B22   B3C1                      CmpA.L    D1, A1
2B24   6502                      BCS       L464
2B26   2241                      Move.L    D1, A1
2B28   42A7           L464:      Clr.L     -(A7)
2B2A   3F3C 0040                 Move      $40, -(A7)
2B2E   2F09                      Move.L    A1, -(A7)
2B30   2F08                      Move.L    A0, -(A7)
2B32   204F                      Move.L    A7, A0
2B34   A019                      _InitZone
2B36   DEFC 000E                 AddA      $E, A7
2B3A   2C78 0118                 Move.L    (TheZone), A6
2B3E   21D6 0114                 Move.L    (A6), (HeapEnd)
2B42   21CE 02AA                 Move.L    A6, (ApplZone)
2B46   7000                      MoveQ.L   $0, D0
2B48   2C5F                      Move.L    (A7)+, A6
2B4A   4E75                      Rts

                      P_tInitZone:
2B4C   48E7 0032                 MoveM.L   A2-A3/A6, -(A7)
2B50   2248                      Move.L    A0, A1
2B52   2C59                      Move.L    (A1)+, A6
2B54   21CE 0118                 Move.L    A6, (TheZone)
2B58   204E                      Move.L    A6, A0
2B5A   244E                      Move.L    A6, A2
2B5C   720C                      MoveQ.L   $C, D1
2B5E   4298           L465:      Clr.L     (A0)+
2B60   51C9 FFFC                 DBF       D1, L465
2B64   2659                      Move.L    (A1)+, A3
2B66   720C                      MoveQ.L   $C, D1
2B68   97C1                      SubA.L    D1, A3
2B6A   2681                      Move.L    D1, (A3)
2B6C   24CB                      Move.L    A3, (A2)+
2B6E   24C8                      Move.L    A0, (A2)+
2B70   584A                      AddQ      $4, A2
2B72   97C8                      SubA.L    A0, A3
2B74   200B                      Move.L    A3, D0
2B76   24C0                      Move.L    D0, (A2)+
2B78   3219                      Move      (A1)+, D1
2B7A   24D9                      Move.L    (A1)+, (A2)+
2B7C   34C1                      Move      D1, (A2)+
2B7E   34F8 0326                 Move      (MMDefFlags), (A2)+
2B82   4EBA 0280                 Jsr       P_mMakeBKF
2B86   4EBA 06CE                 Jsr       P_mHMakeMoreMasters
2B8A   7000                      MoveQ.L   $0, D0
2B8C   4CDF 4C00                 MoveM.L   (A7)+, A2-A3/A6
2B90   4E75                      Rts

                      P_tGetZone:
2B92   2078 0118                 Move.L    (TheZone), A0
2B96   6004                      Bra       L466

                      P_tSetZone:
2B98   21C8 0118                 Move.L    A0, (TheZone)
2B9C   7000           L466:      MoveQ.L   $0, D0
2B9E   4E75                      Rts

                      P_tCompactMem:
2BA0   4EBA 0244                 Jsr       P_mMMPrologue
2BA4   4EBA 05B2                 Jsr       P_mActuals
2BA8   43EE 0016                 Lea.L     $16(A6), A1
2BAC   1411                      Move.B    (A1), D2
2BAE   08D1 0004                 BSet.B    $4, (A1)
2BB2   4EBA 0492                 Jsr       P_mCompactHp
2BB6   1282                      Move.B    D2, (A1)
2BB8   2001                      Move.L    D1, D0
2BBA   6720                      BEQ       L470
2BBC   5180                      SubQ.L    $8, D0
2BBE   2208                      Move.L    A0, D1
2BC0   671A                      BEQ       L470
2BC2   6016                      Bra       L469

                      P_tPurgeMem:
2BC4   4EBA 0220                 Jsr       P_mMMPrologue
2BC8   4EBA 058E                 Jsr       P_mActuals
2BCC   4EBA 027E                 Jsr       P_mPurgeHeap
2BD0   2008           L467:      Move.L    A0, D0
2BD2   6604                      BNE       L468
2BD4   7094                      MoveQ.L   $-6C, D0
2BD6   6004                      Bra       L470
2BD8   7000           L468:      MoveQ.L   $0, D0
2BDA   5088           L469:      AddQ      $8, A0
2BDC   4EFA 0220      L470:      Jmp       L_mMMNoErrEpilogue

                      P_tFreeMem:
2BE0   4EBA 0204                 Jsr       P_mMMPrologue
2BE4   202E 000C                 Move.L    $C(A6), D0
2BE8   60F2                      Bra       L470

                      P_tResrvMem:
2BEA   4EBA 01FA                 Jsr       P_mMMPrologue
2BEE   4AAE 0008                 Tst.L     $8(A6)
2BF2   660C                      BNE       L471
2BF4   342E 0014                 Move      $14(A6), D2
2BF8   48C2                      Ext.L     D2
2BFA   E582                      AsL.L     $2, D2
2BFC   5082                      AddQ      $8, D2
2BFE   D082                      Add.L     D2, D0
2C00   4EBA 068E      L471:      Jsr       P_mMakePtrSpc
2C04   204A                      Move.L    A2, A0
2C06   60C8                      Bra       L467

                      P_tMaxMem:
2C08   4EBA 01DC                 Jsr       P_mMMPrologue
2C0C   203C 0080 0000            Move.L    $800000, D0
2C12   7400                      MoveQ.L   $0, D2
2C14   4EBA 02E8                 Jsr       P_mBKCompacts
2C18   2001                      Move.L    D1, D0
2C1A   6702                      BEQ       L472
2C1C   5180                      SubQ.L    $8, D0
2C1E   91C8           L472:      SubA.L    A0, A0
2C20   2278 02AA                 Move.L    (ApplZone), A1
2C24   B3F8 0118                 CmpA.L    (TheZone), A1
2C28   660E                      BNE       L473
2C2A   2438 0130                 Move.L    (ApplLimit), D2
2C2E   4EBA 04B2                 Jsr       P_mMaxLimit
2C32   92B8 0114                 Sub.L     (HeapEnd), D1
2C36   2041                      Move.L    D1, A0
2C38   4EFA 01C4      L473:      Jmp       L_mMMNoErrEpilogue

                      P_tSetGrowZone:
2C3C   2278 0118                 Move.L    (TheZone), A1
2C40   2348 0010                 Move.L    A0, $10(A1)
2C44   6004                      Bra       L474

                      P_tSetApplLimit:
2C46   21C8 0130                 Move.L    A0, (ApplLimit)
2C4A   7000           L474:      MoveQ.L   $0, D0
2C4C   4E75                      Rts

                      P_tNewPtr:
2C4E   4EBA 0196                 Jsr       P_mMMPrologue
2C52   93C9                      SubA.L    A1, A1
2C54   4EBA 063A                 Jsr       P_mMakePtrSpc
2C58   4EBA 0340                 Jsr       P_mAllocBK
2C5C   6708                      BEQ       L477
2C5E   6130                      Bsr       P74
2C60   7000           L475:      MoveQ.L   $0, D0
2C62   4EFA 019A      L476:      Jmp       L_mMMNoErrEpilogue
2C66   7094           L477:      MoveQ.L   $-6C, D0
2C68   60F8                      Bra       L476

                      P_tDisposePtr:
2C6A   4EBA 0146                 Jsr       P_mMMPPrologue
2C6E   4EBA 075E      L478:      Jsr       P_mFreeBk
2C72   60EC                      Bra       L475

                      P_tGetPtrSize:
2C74   4EBA 013C                 Jsr       P_mMMPPrologue
2C78   4EBA 04F2                 Jsr       P_mGetSize
2C7C   60E4                      Bra       L476

                      P_tSetPtrSize:
2C7E   4EBA 0132                 Jsr       P_mMMPPrologue
2C82   4EBA 050A                 Jsr       P_mSetSize
2C86   60DA                      Bra       L476

                      P_tPtrZone:
2C88   4EBA 0128                 Jsr       P_mMMPPrologue
2C8C   204E                      Move.L    A6, A0
2C8E   60D0                      Bra       L475

                      P74:
2C90   0801 0009                 BTst.B    $9, D1
2C94   670E                      BEQ       L480
2C96   2F08                      Move.L    A0, -(A7)
2C98   5280                      AddQ      $1, D0
2C9A   E288                      LsR.L     $1, D0
2C9C   4258           L479:      Clr       (A0)+
2C9E   5380                      SubQ.L    $1, D0
2CA0   6EFA                      BGT       L479
2CA2   205F                      Move.L    (A7)+, A0
2CA4   4E75           L480:      Rts

                      P_tNewHandle:
2CA6   4EBA 013E                 Jsr       P_mMMPrologue
2CAA   4EBA 058E                 Jsr       P_mNextMaster
2CAE   6604                      BNE       L481
2CB0   7094                      MoveQ.L   $-6C, D0
2CB2   6020                      Bra       L487
2CB4   4EBA 02E4      L481:      Jsr       P_mAllocBK
2CB8   670A                      BEQ       L485
2CBA   61D4           L482:      Bsr       P74
2CBC   2049                      Move.L    A1, A0
2CBE   7000           L483:      MoveQ.L   $0, D0
2CC0   4EFA 013C      L484:      Jmp       L_mMMNoErrEpilogue
2CC4   7094           L485:      MoveQ.L   $-6C, D0
2CC6   6008                      Bra       L486

                      P_tDisposeHandle:
2CC8   4EBA 00FC                 Jsr       P_mMMHPrologue
2CCC   66A0                      BNE       L478
2CCE   7000                      MoveQ.L   $0, D0
2CD0   4EBA 05B4      L486:      Jsr       P_mReleaseMP
2CD4   91C8           L487:      SubA.L    A0, A0
2CD6   60E8                      Bra       L484

                      P_tGetHandleSize:
2CD8   4EBA 00EC                 Jsr       P_mMMHPrologue
2CDC   670C                      BEQ       L488
2CDE   4EBA 048C                 Jsr       P_mGetSize
2CE2   600E                      Bra       L490

                      P_tSetHandleSize:
2CE4   4EBA 00E0                 Jsr       P_mMMHPrologue
2CE8   6604                      BNE       L489
2CEA   7093           L488:      MoveQ.L   $-6D, D0
2CEC   6004                      Bra       L490
2CEE   4EBA 049E      L489:      Jsr       P_mSetSize
2CF2   2049           L490:      Move.L    A1, A0
2CF4   60CA                      Bra       L484

                      P_tHandleZone:
2CF6   4EBA 00CE                 Jsr       P_mMMHPrologue
2CFA   204E                      Move.L    A6, A0
2CFC   60C0                      Bra       L483

                      P_tRecoverHandle:
2CFE   4EBA 00E6                 Jsr       P_mMMPrologue
2D02   2268 FFFC                 Move.L    $-4(A0), A1
2D06   D3CE                      AddA.L    A6, A1
2D08   60E8                      Bra       L490

                      P_tEmptyHandle:
2D0A   4EBA 00BA                 Jsr       P_mMMHPrologue
2D0E   6604                      BNE       L491
2D10   7000                      MoveQ.L   $0, D0
2D12   6004                      Bra       L492
2D14   4EBA 00F4      L491:      Jsr       P_mEH
2D18   60D8           L492:      Bra       L490

                      P_tReallocHandle:
2D1A   4EBA 00AA                 Jsr       P_mMMHPrologue
2D1E   4A91                      Tst.L     (A1)
2D20   6708                      BEQ       L493
2D22   4EBA 00E6                 Jsr       P_mEH
2D26   66CA                      BNE       L490
2D28   2002                      Move.L    D2, D0
2D2A   21C9 0328      L493:      Move.L    A1, (GZRootHnd)
2D2E   42B8 032C                 Clr.L     (GZRootPtr)
2D32   4EBA 0266                 Jsr       P_mAllocBK
2D36   4EBA 044C                 Jsr       P_mClearGZStuff
2D3A   2408                      Move.L    A0, D2
2D3C   6600 FF7C                 BNE       L482
2D40   7094                      MoveQ.L   $-6C, D0
2D42   60AE                      Bra       L490

                      P_tHLock:
2D44   4EBA 0080                 Jsr       P_mMMHPrologue
2D48   672C                      BEQ       L495
2D4A   08D1 0007                 BSet.B    $7, (A1)
2D4E   6022                      Bra       L494

                      P_tHUnlock:
2D50   4EBA 0074                 Jsr       P_mMMHPrologue
2D54   6720                      BEQ       L495
2D56   0891 0007                 BClr.B    $7, (A1)
2D5A   6016                      Bra       L494

                      P_tHPurge:
2D5C   4EBA 0068                 Jsr       P_mMMHPrologue
2D60   6714                      BEQ       L495
2D62   08D1 0006                 BSet.B    $6, (A1)
2D66   600A                      Bra       L494

                      P_tHNoPurge:
2D68   4EBA 005C                 Jsr       P_mMMHPrologue
2D6C   6708                      BEQ       L495
2D6E   0891 0006                 BClr.B    $6, (A1)
2D72   7000           L494:      MoveQ.L   $0, D0
2D74   6002                      Bra       L496
2D76   7093           L495:      MoveQ.L   $-6D, D0
2D78   4EFA 0084      L496:      Jmp       L_mMMNoErrEpilogue

                      P_mDerefHandle:
2D7C   2008                      Move.L    A0, D0
2D7E   C0B8 031A                 And.L     (Lo3Bytes), D0
2D82   2040                      Move.L    D0, A0
2D84   2248                      Move.L    A0, A1
2D86   2051                      Move.L    (A1), A0
2D88   2008                      Move.L    A0, D0
2D8A   4E75                      Rts

                      P76:
2D8C   2008                      Move.L    A0, D0
2D8E   C0B8 031A                 And.L     (Lo3Bytes), D0
2D92   2040                      Move.L    D0, A0
2D94   5188                      SubQ.L    $8, A0
2D96   4A10                      Tst.B     (A0)
2D98   6714                      BEQ       L500
2D9A   6B06                      BMI       L497
2D9C   2C68 0004                 Move.L    $4(A0), A6
2DA0   6006                      Bra       L498
2DA2   2C49           L497:      Move.L    A1, A6
2DA4   9DE8 0004                 SubA.L    $4(A0), A6
2DA8   7000           L498:      MoveQ.L   $0, D0
2DAA   5088           L499:      AddQ      $8, A0
2DAC   4E75                      Rts
2DAE   7091           L500:      MoveQ.L   $-6F, D0
2DB0   60F8                      Bra       L499

                      P_mMMPPrologue:
2DB2   225F                      Move.L    (A7)+, A1
2DB4   48E7 1F3E                 MoveM.L   D3-D7/A2-A6, -(A7)
2DB8   2F09                      Move.L    A1, -(A7)
2DBA   2400                      Move.L    D0, D2
2DBC   93C9                      SubA.L    A1, A1
2DBE   61CC                      Bsr       P76
2DC0   6B20                      BMI       L502
2DC2   2002                      Move.L    D2, D0
2DC4   4E75                      Rts

                      P_mMMHPrologue:
2DC6   225F                      Move.L    (A7)+, A1
2DC8   48E7 1F3E                 MoveM.L   D3-D7/A2-A6, -(A7)
2DCC   2F09                      Move.L    A1, -(A7)
2DCE   2400                      Move.L    D0, D2
2DD0   2C78 0118                 Move.L    (TheZone), A6
2DD4   61A6                      Bsr       P_mDerefHandle
2DD6   6704                      BEQ       L501
2DD8   61B2                      Bsr       P76
2DDA   6B06                      BMI       L502
2DDC   2002           L501:      Move.L    D2, D0
2DDE   2E08                      Move.L    A0, D7
2DE0   4E75                      Rts
2DE2   588F           L502:      AddQ      $4, A7
2DE4   6018                      Bra       L_mMMNoErrEpilogue

                      P_mMMPrologue:
2DE6   225F                      Move.L    (A7)+, A1
2DE8   48E7 1F3E                 MoveM.L   D3-D7/A2-A6, -(A7)
2DEC   2F09                      Move.L    A1, -(A7)
2DEE   2C78 0118                 Move.L    (TheZone), A6
2DF2   0801 000A                 BTst.B    $A, D1
2DF6   6704                      BEQ       L503
2DF8   2C78 02A6                 Move.L    (SysZone), A6
2DFC   4E75           L503:      Rts
                      L_mMMNoErrEpilogue:
2DFE   4CDF 7CF8                 MoveM.L   (A7)+, D3-D7/A2-A6
2E02   4E75                      Rts

                      P_mMakeBKF:
2E04   2080                      Move.L    D0, (A0)
2E06   4210                      Clr.B     (A0)
2E08   4E75                      Rts

                      P_mEH:
2E0A   0811 0007                 BTst.B    $7, (A1)
2E0E   660A                      BNE       L506
2E10   5188                      SubQ.L    $8, A0
2E12   6122                      Bsr       P83
2E14   5088                      AddQ      $8, A0
2E16   7000                      MoveQ.L   $0, D0
2E18   4E75           L505:      Rts
2E1A   7090           L506:      MoveQ.L   $-70, D0
2E1C   60FA                      Bra       L505

                      P82:
2E1E   4AAE 0028                 Tst.L     $28(A6)
2E22   6710                      BEQ       L507
2E24   48E7 E0C0                 MoveM.L   D0-D2/A0-A1, -(A7)
2E28   2F09                      Move.L    A1, -(A7)
2E2A   226E 0028                 Move.L    $28(A6), A1
2E2E   4E91                      Jsr       (A1)
2E30   4CDF 0307                 MoveM.L   (A7)+, D0-D2/A0-A1
2E34   4E75           L507:      Rts

                      P83:
2E36   2F00                      Move.L    D0, -(A7)
2E38   2010                      Move.L    (A0), D0
2E3A   C0B8 031A                 And.L     (Lo3Bytes), D0
2E3E   61DE                      Bsr       P82
2E40   4291                      Clr.L     (A1)
2E42   61C0                      Bsr       P_mMakeBKF
2E44   6100 03E8                 Bsr       P_mAdjustFree
2E48   201F                      Move.L    (A7)+, D0
2E4A   4E75                      Rts

                      P_mPurgeHeap:
2E4C   48E7 2078                 MoveM.L   D2/A1-A4, -(A7)
2E50   2656           L508:      Move.L    (A6), A3
2E52   41EE 0034                 Lea.L     $34(A6), A0
2E56   082E 0006 0016            BTst.B    $6, $16(A6)
2E5C   664A                      BNE       L514
2E5E   2448                      Move.L    A0, A2
2E60   7400                      MoveQ.L   $0, D2
2E62   2212           L509:      Move.L    (A2), D1
2E64   C2B8 031A                 And.L     (Lo3Bytes), D1
2E68   284A                      Move.L    A2, A4
2E6A   D5C1                      AddA.L    D1, A2
2E6C   4A14                      Tst.B     (A4)
2E6E   6718                      BEQ       L510
2E70   6A1E                      BPL       L511
2E72   226C 0004                 Move.L    $4(A4), A1
2E76   D3CE                      AddA.L    A6, A1
2E78   4A11                      Tst.B     (A1)
2E7A   6B14                      BMI       L511
2E7C   0811 0006                 BTst.B    $6, (A1)
2E80   6712                      BEQ       L513
2E82   B9EE 0004                 CmpA.L    $4(A6), A4
2E86   650A                      BCS       L512
2E88   D481           L510:      Add.L     D1, D2
2E8A   B480                      Cmp.L     D0, D2
2E8C   6506                      BCS       L513
2E8E   601A                      Bra       L515
2E90   7400           L511:      MoveQ.L   $0, D2
2E92   204A           L512:      Move.L    A2, A0
2E94   B5CB           L513:      CmpA.L    A3, A2
2E96   65CA                      BCS       L509
2E98   41EE 0034                 Lea.L     $34(A6), A0
2E9C   B1EE 0004                 CmpA.L    $4(A6), A0
2EA0   6706                      BEQ       L514
2EA2   2D48 0004                 Move.L    A0, $4(A6)
2EA6   60A8                      Bra       L508
2EA8   244B           L514:      Move.L    A3, A2
2EAA   2210           L515:      Move.L    (A0), D1
2EAC   C2B8 031A                 And.L     (Lo3Bytes), D1
2EB0   4A10                      Tst.B     (A0)
2EB2   6A18                      BPL       L516
2EB4   2268 0004                 Move.L    $4(A0), A1
2EB8   D3CE                      AddA.L    A6, A1
2EBA   4A11                      Tst.B     (A1)
2EBC   6B0E                      BMI       L516
2EBE   0811 0006                 BTst.B    $6, (A1)
2EC2   6708                      BEQ       L516
2EC4   6100 FF70                 Bsr       P83
2EC8   B280                      Cmp.L     D0, D1
2ECA   640A                      BCC       L517
2ECC   D1C1           L516:      AddA.L    D1, A0
2ECE   2D48 0004                 Move.L    A0, $4(A6)
2ED2   B1CA                      CmpA.L    A2, A0
2ED4   65D4                      BCS       L515
2ED6   6122           L517:      Bsr       P86
2ED8   4CDF 1E04                 MoveM.L   (A7)+, D2/A1-A4
2EDC   4E75                      Rts

                      P85:
2EDE   242E 0010                 Move.L    $10(A6), D2
2EE2   6714                      BEQ       L518
2EE4   48E7 DFFE                 MoveM.L   D0-D1/D3-D7/A0-A6, -(A7)
2EE8   226E 0010                 Move.L    $10(A6), A1
2EEC   42A7                      Clr.L     -(A7)
2EEE   2F00                      Move.L    D0, -(A7)
2EF0   4E91                      Jsr       (A1)
2EF2   241F                      Move.L    (A7)+, D2
2EF4   4CDF 7FFB                 MoveM.L   (A7)+, D0-D1/D3-D7/A0-A6
2EF8   4E75           L518:      Rts

                      P86:
2EFA   6000 014A                 Bra       P_mCompactHp

                      P_mBKCompacts:
2EFE   48E7 A000                 MoveM.L   D0/D2, -(A7)
2F02   61F6                      Bsr       P86
2F04   B081                      Cmp.L     D1, D0
2F06   632E                      BLS       L521
2F08   BDF8 02AA                 CmpA.L    (ApplZone), A6
2F0C   660E                      BNE       L519
2F0E   4A82                      Tst.L     D2
2F10   670A                      BEQ       L519
2F12   6100 0202                 Bsr       P98
2F16   61E2                      Bsr       P86
2F18   B081                      Cmp.L     D1, D0
2F1A   631A                      BLS       L521
2F1C   6100 FF2E      L519:      Bsr       P_mPurgeHeap
2F20   B081                      Cmp.L     D1, D0
2F22   6312                      BLS       L521
2F24   4A82                      Tst.L     D2
2F26   670E                      BEQ       L521
2F28   61B4           L520:      Bsr       P85
2F2A   61CE                      Bsr       P86
2F2C   B081                      Cmp.L     D1, D0
2F2E   6306                      BLS       L521
2F30   4A82                      Tst.L     D2
2F32   66F4                      BNE       L520
2F34   91C8                      SubA.L    A0, A0
2F36   2408           L521:      Move.L    A0, D2
2F38   4CDF 0005                 MoveM.L   (A7)+, D0/D2
2F3C   4E75                      Rts

                      P_mBFindS:
2F3E   48E7 6060                 MoveM.L   D1-D2/A1-A2, -(A7)
2F42   2438 031A                 Move.L    (Lo3Bytes), D2
2F46   45EE 0030                 Lea.L     $30(A6), A2
2F4A   082E 0005 0016            BTst.B    $5, $16(A6)
2F50   6702                      BEQ       L522
2F52   4292                      Clr.L     (A2)
2F54   2212           L522:      Move.L    (A2), D1
2F56   2241                      Move.L    D1, A1
2F58   6604                      BNE       L523
2F5A   43EE 0034                 Lea.L     $34(A6), A1
2F5E   2211           L523:      Move.L    (A1), D1
2F60   4A11                      Tst.B     (A1)
2F62   6706                      BEQ       L525
2F64   C282           L524:      And.L     D2, D1
2F66   D3C1                      AddA.L    D1, A1
2F68   60F4                      Bra       L523
2F6A   B3D6           L525:      CmpA.L    (A6), A1
2F6C   641A                      BCC       L528
2F6E   2049           L526:      Move.L    A1, A0
2F70   D1C1                      AddA.L    D1, A0
2F72   4A10                      Tst.B     (A0)
2F74   660A                      BNE       L527
2F76   B1D6                      CmpA.L    (A6), A0
2F78   6406                      BCC       L527
2F7A   D290                      Add.L     (A0), D1
2F7C   2281                      Move.L    D1, (A1)
2F7E   60EE                      Bra       L526
2F80   B280           L527:      Cmp.L     D0, D1
2F82   65E0                      BCS       L524
2F84   2049                      Move.L    A1, A0
2F86   600A                      Bra       L530
2F88   4A92           L528:      Tst.L     (A2)
2F8A   6704                      BEQ       L529
2F8C   4292                      Clr.L     (A2)
2F8E   60C4                      Bra       L522
2F90   91C8           L529:      SubA.L    A0, A0
2F92   2488           L530:      Move.L    A0, (A2)
2F94   4CDF 0606                 MoveM.L   (A7)+, D1-D2/A1-A2
2F98   4E75                      Rts

                      P_mAllocBK:
2F9A   48E7 FC00                 MoveM.L   D0-D5, -(A7)
2F9E   2800                      Move.L    D0, D4
2FA0   6100 01B6                 Bsr       P_mActuals
2FA4   6198                      Bsr       P_mBFindS
2FA6   660C                      BNE       L531
2FA8   74FF                      MoveQ.L   $-1, D2
2FAA   6100 FF52                 Bsr       P_mBKCompacts
2FAE   6604                      BNE       L531
2FB0   91C8                      SubA.L    A0, A0
2FB2   6028                      Bra       L534
2FB4   2400           L531:      Move.L    D0, D2
2FB6   2010                      Move.L    (A0), D0
2FB8   2A09                      Move.L    A1, D5
2FBA   6708                      BEQ       L532
2FBC   9A8E                      Sub.L     A6, D5
2FBE   7202                      MoveQ.L   $2, D1
2FC0   76FF                      MoveQ.L   $-1, D3
2FC2   6006                      Bra       L533
2FC4   2A0E           L532:      Move.L    A6, D5
2FC6   7201                      MoveQ.L   $1, D1
2FC8   7600                      MoveQ.L   $0, D3
2FCA   6132           L533:      Bsr       P91
2FCC   2145 0004                 Move.L    D5, $4(A0)
2FD0   2004                      Move.L    D4, D0
2FD2   6110                      Bsr       P90
2FD4   5088                      AddQ      $8, A0
2FD6   2A09                      Move.L    A1, D5
2FD8   6702                      BEQ       L534
2FDA   2288                      Move.L    A0, (A1)
2FDC   2008           L534:      Move.L    A0, D0
2FDE   4CDF 003F                 MoveM.L   (A7)+, D0-D5
2FE2   4E75                      Rts

                      P90:
2FE4   2F01                      Move.L    D1, -(A7)
2FE6   2210                      Move.L    (A0), D1
2FE8   C2B8 031A                 And.L     (Lo3Bytes), D1
2FEC   5181                      SubQ.L    $8, D1
2FEE   9280                      Sub.L     D0, D1
2FF0   0201 000F                 And.B     $F, D1
2FF4   0210 00C0                 And.B     $-40, (A0)
2FF8   8310                      Or.B      D1, (A0)
2FFA   221F                      Move.L    (A7)+, D1
2FFC   4E75                      Rts

                      P91:
2FFE   48E7 E840                 MoveM.L   D0-D2/D4/A1, -(A7)
3002   2800                      Move.L    D0, D4
3004   9082                      Sub.L     D2, D0
3006   2248                      Move.L    A0, A1
3008   0C80 0000 000C            Cmp.L     $C, D0
300E   6516                      BCS       L537
3010   4A43                      Tst       D3
3012   670A                      BEQ       L535
3014   4A2E 0016                 Tst.B     $16(A6)
3018   6A04                      BPL       L535
301A   D3C0                      AddA.L    D0, A1
301C   6002                      Bra       L536
301E   D1C2           L535:      AddA.L    D2, A0
3020   6100 FDE2      L536:      Bsr       P_mMakeBKF
3024   6002                      Bra       L538
3026   2404           L537:      Move.L    D4, D2
3028   2002           L538:      Move.L    D2, D0
302A   4480                      Neg.L     D0
302C   6100 0200                 Bsr       P_mAdjustFree
3030   2049                      Move.L    A1, A0
3032   E499                      ROR.L     $2, D1
3034   D282                      Add.L     D2, D1
3036   2081                      Move.L    D1, (A0)
3038   4CDF 0217                 MoveM.L   (A7)+, D0-D2/D4/A1
303C   4E75                      Rts

                      P92:
303E   2F00                      Move.L    D0, -(A7)
3040   A02E                      _BlockMove
3042   201F                      Move.L    (A7)+, D0
3044   4E75                      Rts

                      P_mCompactHp:
3046   48E7 BC78                 MoveM.L   D0/D2-D5/A1-A4, -(A7)
304A   2600                      Move.L    D0, D3
304C   7200                      MoveQ.L   $0, D1
304E   41EE 0034                 Lea.L     $34(A6), A0
3052   2810           L539:      Move.L    (A0), D4
3054   C8B8 031A                 And.L     (Lo3Bytes), D4
3058   D1C4                      AddA.L    D4, A0
305A   B1D6                      CmpA.L    (A6), A0
305C   6404                      BCC       L540
305E   4A10                      Tst.B     (A0)
3060   66F0                      BNE       L539
3062   082E 0004 0016 L540:      BTst.B    $4, $16(A6)
3068   57C5                      SEQ.B     D5
306A   2448                      Move.L    A0, A2
306C   2248           L541:      Move.L    A0, A1
306E   7400                      MoveQ.L   $0, D2
3070   B1D6           L542:      CmpA.L    (A6), A0
3072   6444                      BCC       L546
3074   2010                      Move.L    (A0), D0
3076   C0B8 031A                 And.L     (Lo3Bytes), D0
307A   4A10                      Tst.B     (A0)
307C   6720                      BEQ       L543
307E   6A34                      BPL       L545
3080   2668 0004                 Move.L    $4(A0), A3
3084   D7CE                      AddA.L    A6, A3
3086   4A13                      Tst.B     (A3)
3088   6B2A                      BMI       L545
308A   4A05                      Tst.B     D5
308C   6622                      BNE       L544
308E   49E9 0008                 Lea.L     $8(A1), A4
3092   1813                      Move.B    (A3), D4
3094   268C                      Move.L    A4, (A3)
3096   1684                      Move.B    D4, (A3)
3098   61A4                      Bsr       P92
309A   D3C0                      AddA.L    D0, A1
309C   6012                      Bra       L544
309E   D480           L543:      Add.L     D0, D2
30A0   2649                      Move.L    A1, A3
30A2   B483                      Cmp.L     D3, D2
30A4   650A                      BCS       L544
30A6   4A05                      Tst.B     D5
30A8   6710                      BEQ       L547
30AA   4205                      Clr.B     D5
30AC   204A                      Move.L    A2, A0
30AE   60BC                      Bra       L541
30B0   D1C0           L544:      AddA.L    D0, A0
30B2   60BC                      Bra       L542
30B4   6112           L545:      Bsr       P94
30B6   609A                      Bra       L539
30B8   97CB           L546:      SubA.L    A3, A3
30BA   610C           L547:      Bsr       P94
30BC   204B                      Move.L    A3, A0
30BE   2D48 0030                 Move.L    A0, $30(A6)
30C2   4CDF 1E3D                 MoveM.L   (A7)+, D0/D2-D5/A1-A4
30C6   4E75                      Rts

                      P94:
30C8   4A82                      Tst.L     D2
30CA   670C                      BEQ       L549
30CC   4A05                      Tst.B     D5
30CE   6602                      BNE       L548
30D0   2282                      Move.L    D2, (A1)
30D2   B282           L548:      Cmp.L     D2, D1
30D4   6402                      BCC       L549
30D6   2202                      Move.L    D2, D1
30D8   4E75           L549:      Rts

                      P_mToMaxLimit:
30DA   2438 010C                 Move.L    (BufPtr), D2
30DE   94B8 0322                 Sub.L     (DefltStack), D2

                      P_mMaxLimit:
30E2   220F                      Move.L    A7, D1
30E4   C2B8 031A                 And.L     (Lo3Bytes), D1
30E8   92B8 031E                 Sub.L     (MinStack), D1
30EC   B282                      Cmp.L     D2, D1
30EE   6502                      BCS       L550
30F0   2202                      Move.L    D2, D1
30F2   4E75           L550:      Rts

                      P_mZoneAdjustEnd:
30F4   48E7 80B0                 MoveM.L   D0/A0/A2-A3, -(A7)
30F8   2648                      Move.L    A0, A3
30FA   2056                      Move.L    (A6), A0
30FC   200B                      Move.L    A3, D0
30FE   9088                      Sub.L     A0, D0
3100   26BC 0000 000C            Move.L    $C, (A3)
3106   6100 FCFC                 Bsr       P_mMakeBKF
310A   6100 0122                 Bsr       P_mAdjustFree
310E   2C8B                      Move.L    A3, (A6)
3110   4CDF 0D01                 MoveM.L   (A7)+, D0/A0/A2-A3
3114   4E75                      Rts

                      P98:
3116   48E7 E080                 MoveM.L   D0-D2/A0, -(A7)
311A   0680 0000 0400            Add.L     $400, D0
3120   0240 FC00                 And       $-400, D0
3124   2438 0130                 Move.L    (ApplLimit), D2
3128   61B8                      Bsr       P_mMaxLimit
312A   2438 0114                 Move.L    (HeapEnd), D2
312E   B282                      Cmp.L     D2, D1
3130   6320                      BLS       L553
3132   D480                      Add.L     D0, D2
3134   B282                      Cmp.L     D2, D1
3136   6504                      BCS       L551
3138   2202                      Move.L    D2, D1
313A   600E                      Bra       L552
313C   2001           L551:      Move.L    D1, D0
313E   90B8 0114                 Sub.L     (HeapEnd), D0
3142   0C80 0000 000C            Cmp.L     $C, D0
3148   6508                      BCS       L553
314A   21C1 0114      L552:      Move.L    D1, (HeapEnd)
314E   2041                      Move.L    D1, A0
3150   61A2                      Bsr       P_mZoneAdjustEnd
3152   4CDF 0107      L553:      MoveM.L   (A7)+, D0-D2/A0
3156   4E75                      Rts

                      P_mActuals:
3158   5080                      AddQ      $8, D0
315A   5280                      AddQ      $1, D0
315C   0240 FFFE                 And       $-2, D0
3160   0C80 0000 000C            Cmp.L     $C, D0
3166   6402                      BCC       L554
3168   700C                      MoveQ.L   $C, D0
316A   4E75           L554:      Rts

                      P_mGetSize:
316C   2F01                      Move.L    D1, -(A7)
316E   5188                      SubQ.L    $8, A0
3170   720F                      MoveQ.L   $F, D1
3172   C210                      And.B     (A0), D1
3174   2010                      Move.L    (A0), D0
3176   C0B8 031A                 And.L     (Lo3Bytes), D0
317A   5180                      SubQ.L    $8, D0
317C   9081                      Sub.L     D1, D0
317E   5088                      AddQ      $8, A0
3180   221F                      Move.L    (A7)+, D1
3182   4E75                      Rts

                      P_mClearGZStuff:
3184   42B8 0328                 Clr.L     (GZRootHnd)
3188   42B8 032C                 Clr.L     (GZRootPtr)
318C   4E75                      Rts

                      P_mSetSize:
318E   48E7 7CE0                 MoveM.L   D1-D5/A0-A2, -(A7)
3192   1F11                      Move.B    (A1), -(A7)
3194   2200                      Move.L    D0, D1
3196   61C0                      Bsr       P_mActuals
3198   2600                      Move.L    D0, D3
319A   61D0                      Bsr       P_mGetSize
319C   B280                      Cmp.L     D0, D1
319E   6700 0084                 BEQ       L559
31A2   2448                      Move.L    A0, A2
31A4   518A                      SubQ.L    $8, A2
31A6   2412                      Move.L    (A2), D2
31A8   C4B8 031A                 And.L     (Lo3Bytes), D2
31AC   2802                      Move.L    D2, D4
31AE   B682                      Cmp.L     D2, D3
31B0   676A                      BEQ       L558
31B2   654C                      BCS       L557
31B4   21C9 0328                 Move.L    A1, (GZRootHnd)
31B8   21C8 032C                 Move.L    A0, (GZRootPtr)
31BC   204A                      Move.L    A2, A0
31BE   2003                      Move.L    D3, D0
31C0   9082                      Sub.L     D2, D0
31C2   D5C2                      AddA.L    D2, A2
31C4   08D1 0007                 BSet.B    $7, (A1)
31C8   6100 0120                 Bsr       P108
31CC   0891 0007                 BClr.B    $7, (A1)
31D0   280A                      Move.L    A2, D4
31D2   6618                      BNE       L556
31D4   2809                      Move.L    A1, D4
31D6   670E                      BEQ       L555
31D8   4A17                      Tst.B     (A7)
31DA   6B0A                      BMI       L555
31DC   2001                      Move.L    D1, D0
31DE   6100 019C                 Bsr       P110
31E2   61A0                      Bsr       P_mClearGZStuff
31E4   6040                      Bra       L560
31E6   619C           L555:      Bsr       P_mClearGZStuff
31E8   7094                      MoveQ.L   $-6C, D0
31EA   603A                      Bra       L560
31EC   6196           L556:      Bsr       P_mClearGZStuff
31EE   2012                      Move.L    (A2), D0
31F0   2800                      Move.L    D0, D4
31F2   D882                      Add.L     D2, D4
31F4   2448                      Move.L    A0, A2
31F6   1A12                      Move.B    (A2), D5
31F8   2484                      Move.L    D4, (A2)
31FA   1485                      Move.B    D5, (A2)
31FC   4480                      Neg.L     D0
31FE   612E                      Bsr       P_mAdjustFree
3200   9883           L557:      Sub.L     D3, D4
3202   0C84 0000 000C            Cmp.L     $C, D4
3208   6512                      BCS       L558
320A   204A                      Move.L    A2, A0
320C   D1C3                      AddA.L    D3, A0
320E   1A12                      Move.B    (A2), D5
3210   2483                      Move.L    D3, (A2)
3212   1485                      Move.B    D5, (A2)
3214   2004                      Move.L    D4, D0
3216   6100 FBEC                 Bsr       P_mMakeBKF
321A   6112                      Bsr       P_mAdjustFree
321C   204A           L558:      Move.L    A2, A0
321E   2001                      Move.L    D1, D0
3220   6100 FDC2                 Bsr       P90
3224   7000           L559:      MoveQ.L   $0, D0
3226   129F           L560:      Move.B    (A7)+, (A1)
3228   4CDF 073E                 MoveM.L   (A7)+, D1-D5/A0-A2
322C   4E75                      Rts

                      P_mAdjustFree:
322E   D1AE 000C                 Add.L     D0, $C(A6)
3232   6B02                      BMI       L561
3234   4E75                      Rts
3236   701F           L561:      MoveQ.L   $1F, D0
3238   A9C9                      _SysError

                      P_mNextMaster:
323A   48E7 8080                 MoveM.L   D0/A0, -(A7)
323E   226E 0008                 Move.L    $8(A6), A1
3242   2009                      Move.L    A1, D0
3244   6604                      BNE       L562
3246   610E                      Bsr       P_mHMakeMoreMasters
3248   6706                      BEQ       L563
324A   2D51 0008      L562:      Move.L    (A1), $8(A6)
324E   2009                      Move.L    A1, D0
3250   4CDF 0101      L563:      MoveM.L   (A7)+, D0/A0
3254   4E75                      Rts

                      P_mHMakeMoreMasters:
3256   48E7 C080                 MoveM.L   D0-D1/A0, -(A7)
325A   302E 0014                 Move      $14(A6), D0
325E   48C0                      Ext.L     D0
3260   6E02                      BGT       L564
3262   7020                      MoveQ.L   $20, D0
3264   2200           L564:      Move.L    D0, D1
3266   E580                      AsL.L     $2, D0
3268   6126                      Bsr       P_mMakePtrSpc
326A   93C9                      SubA.L    A1, A1
326C   6100 FD2C                 Bsr       P_mAllocBK
3270   670C                      BEQ       L566
3272   2248                      Move.L    A0, A1
3274   6110           L565:      Bsr       P_mReleaseMP
3276   5889                      AddQ      $4, A1
3278   5341                      SubQ.L    $1, D1
327A   66F8                      BNE       L565
327C   5989                      SubQ.L    $4, A1
327E   2009           L566:      Move.L    A1, D0
3280   4CDF 0103                 MoveM.L   (A7)+, D0-D1/A0
3284   4E75                      Rts

                      P_mReleaseMP:
3286   22AE 0008                 Move.L    $8(A6), (A1)
328A   2D49 0008                 Move.L    A1, $8(A6)
328E   4E75                      Rts

                      P_mMakePtrSpc:
3290   48E7 F0D0                 MoveM.L   D0-D3/A0-A1/A3, -(A7)
3294   6100 FEC2                 Bsr       P_mActuals
3298   BDF8 02AA                 CmpA.L    (ApplZone), A6
329C   57C3                      SEQ.B     D3
329E   41EE 0034      L567:      Lea.L     $34(A6), A0
32A2   2656                      Move.L    (A6), A3
32A4   2448                      Move.L    A0, A2
32A6   7400                      MoveQ.L   $0, D2
32A8   2210           L568:      Move.L    (A0), D1
32AA   C2B8 031A                 And.L     (Lo3Bytes), D1
32AE   4A10                      Tst.B     (A0)
32B0   670C                      BEQ       L569
32B2   6A1A                      BPL       L570
32B4   2268 0004                 Move.L    $4(A0), A1
32B8   D3CE                      AddA.L    A6, A1
32BA   4A11                      Tst.B     (A1)
32BC   6B10                      BMI       L570
32BE   D481           L569:      Add.L     D1, D2
32C0   D1C1                      AddA.L    D1, A0
32C2   B480                      Cmp.L     D0, D2
32C4   650E                      BCS       L572
32C6   6122                      Bsr       P108
32C8   240A                      Move.L    A2, D2
32CA   6618                      BNE       L574
32CC   6002                      Bra       L571
32CE   D1C1           L570:      AddA.L    D1, A0
32D0   2448           L571:      Move.L    A0, A2
32D2   7400                      MoveQ.L   $0, D2
32D4   B1CB           L572:      CmpA.L    A3, A0
32D6   65D0                      BCS       L568
32D8   5203                      AddQ      $1, D3
32DA   6606                      BNE       L573
32DC   6100 FE38                 Bsr       P98
32E0   60BC                      Bra       L567
32E2   95CA           L573:      SubA.L    A2, A2
32E4   4CDF 0B0F      L574:      MoveM.L   (A7)+, D0-D3/A0-A1/A3
32E8   4E75                      Rts

                      P108:
32EA   48E7 F0D0                 MoveM.L   D0-D3/A0-A1/A3, -(A7)
32EE   2200                      Move.L    D0, D1
32F0   264A                      Move.L    A2, A3
32F2   7600                      MoveQ.L   $0, D3
32F4   B681           L575:      Cmp.L     D1, D3
32F6   643A                      BCC       L578
32F8   B7D6                      CmpA.L    (A6), A3
32FA   6436                      BCC       L578
32FC   4A13                      Tst.B     (A3)
32FE   671E                      BEQ       L576
3300   6A30                      BPL       L578
3302   226B 0004                 Move.L    $4(A3), A1
3306   D3CE                      AddA.L    A6, A1
3308   1411                      Move.B    (A1), D2
330A   6B26                      BMI       L578
330C   613C                      Bsr       P109
330E   670E                      BEQ       L576
3310   0802 0006                 BTst.B    $6, D2
3314   671C                      BEQ       L578
3316   2051                      Move.L    (A1), A0
3318   5188                      SubQ.L    $8, A0
331A   6100 FB1A                 Bsr       P83
331E   204B           L576:      Move.L    A3, A0
3320   2010                      Move.L    (A0), D0
3322   B1EE 0030                 CmpA.L    $30(A6), A0
3326   6604                      BNE       L577
3328   42AE 0030                 Clr.L     $30(A6)
332C   D680           L577:      Add.L     D0, D3
332E   D7C0                      AddA.L    D0, A3
3330   60C2                      Bra       L575
3332   C6B8 031A      L578:      And.L     (Lo3Bytes), D3
3336   6702                      BEQ       L579
3338   2483                      Move.L    D3, (A2)
333A   B681           L579:      Cmp.L     D1, D3
333C   6402                      BCC       L580
333E   95CA                      SubA.L    A2, A2
3340   42AE 0030      L580:      Clr.L     $30(A6)
3344   4CDF 0B0F                 MoveM.L   (A7)+, D0-D3/A0-A1/A3
3348   4E75                      Rts

                      P109:
334A   2F08                      Move.L    A0, -(A7)
334C   2003                      Move.L    D3, D0
334E   6712                      BEQ       L581
3350   2483                      Move.L    D3, (A2)
3352   0092 4000 0000            Or.L      $40000000, (A2)
3358   254E 0004                 Move.L    A6, $4(A2)
335C   4480                      Neg.L     D0
335E   6100 FECE                 Bsr       P_mAdjustFree
3362   2051           L581:      Move.L    (A1), A0
3364   6100 FE06                 Bsr       P_mGetSize
3368   6112                      Bsr       P110
336A   2040                      Move.L    D0, A0
336C   2003                      Move.L    D3, D0
336E   6706                      BEQ       L582
3370   2483                      Move.L    D3, (A2)
3372   6100 FEBA                 Bsr       P_mAdjustFree
3376   2008           L582:      Move.L    A0, D0
3378   205F                      Move.L    (A7)+, A0
337A   4E75                      Rts

                      P110:
337C   48E7 40E0                 MoveM.L   D1/A0-A2, -(A7)
3380   2449                      Move.L    A1, A2
3382   21C9 0330                 Move.L    A1, (GZMoveHnd)
3386   1212                      Move.B    (A2), D1
3388   0892 0006                 BClr.B    $6, (A2)
338C   93C9                      SubA.L    A1, A1
338E   6100 FC0A                 Bsr       P_mAllocBK
3392   6734                      BEQ       L585
3394   4A92                      Tst.L     (A2)
3396   6722                      BEQ       L583
3398   2248                      Move.L    A0, A1
339A   2052                      Move.L    (A2), A0
339C   6100 FDCE                 Bsr       P_mGetSize
33A0   6100 FC9C                 Bsr       P92
33A4   5188                      SubQ.L    $8, A0
33A6   70C0                      MoveQ.L   $-40, D0
33A8   B110                      Eor.B     D0, (A0)
33AA   5888                      AddQ      $4, A0
33AC   5189                      SubQ.L    $8, A1
33AE   B111                      Eor.B     D0, (A1)
33B0   5889                      AddQ      $4, A1
33B2   22D0                      Move.L    (A0), (A1)+
33B4   2489                      Move.L    A1, (A2)
33B6   1481                      Move.B    D1, (A2)
33B8   20CE                      Move.L    A6, (A0)+
33BA   6112           L583:      Bsr       P_mFreeBk
33BC   7000                      MoveQ.L   $0, D0
33BE   42B8 0330      L584:      Clr.L     (GZMoveHnd)
33C2   4CDF 0702                 MoveM.L   (A7)+, D1/A0-A2
33C6   4E75                      Rts
33C8   1481           L585:      Move.B    D1, (A2)
33CA   7094                      MoveQ.L   $-6C, D0
33CC   60F0                      Bra       L584

                      P_mFreeBk:
33CE   48E7 C0C0                 MoveM.L   D0-D1/A0-A1, -(A7)
33D2   5188                      SubQ.L    $8, A0
33D4   2010                      Move.L    (A0), D0
33D6   2200                      Move.L    D0, D1
33D8   C0B8 031A                 And.L     (Lo3Bytes), D0
33DC   B181                      Eor.L     D0, D1
33DE   6714                      BEQ       L587
33E0   6A0A                      BPL       L586
33E2   2268 0004                 Move.L    $4(A0), A1
33E6   D3CE                      AddA.L    A6, A1
33E8   6100 FE9C                 Bsr       P_mReleaseMP
33EC   6100 FA16      L586:      Bsr       P_mMakeBKF
33F0   6100 FE3C                 Bsr       P_mAdjustFree
33F4   4CDF 0303      L587:      MoveM.L   (A7)+, D0-D1/A0-A1
33F8   4E75                      Rts

                      P_tBlockMove:
33FA   4A80                      Tst.L     D0
33FC   6722                      BEQ       L591
33FE   2408                      Move.L    A0, D2
3400   C4B8 031A                 And.L     (Lo3Bytes), D2
3404   2209                      Move.L    A1, D1
3406   C2B8 031A                 And.L     (Lo3Bytes), D1
340A   9282                      Sub.L     D2, D1
340C   6D04                      BLT       L588
340E   D1C0                      AddA.L    D0, A0
3410   D3C0                      AddA.L    D0, A1
3412   E249           L588:      LsR       $1, D1
3414   6414                      BCC       L593
3416   4A81           L589:      Tst.L     D1
3418   6A08                      BPL       L592
341A   12D8           L590:      Move.B    (A0)+, (A1)+
341C   5380                      SubQ.L    $1, D0
341E   66FA                      BNE       L590
3420   4E75           L591:      Rts
3422   1320           L592:      Move.B    -(A0), -(A1)
3424   5380                      SubQ.L    $1, D0
3426   66FA                      BNE       L592
3428   4E75                      Rts
342A   3408           L593:      Move      A0, D2
342C   E24A                      LsR       $1, D2
342E   640C                      BCC       L596
3430   4A81                      Tst.L     D1
3432   6A04                      BPL       L594
3434   12D8                      Move.B    (A0)+, (A1)+
3436   6002                      Bra       L595
3438   1320           L594:      Move.B    -(A0), -(A1)
343A   5380           L595:      SubQ.L    $1, D0
343C   747C           L596:      MoveQ.L   $7C, D2
343E   B082                      Cmp.L     D2, D0
3440   6502                      BCS       L597
3442   6126                      Bsr       P112
3444   0C40 0004      L597:      Cmp       $4, D0
3448   6D18                      BLT       L600
344A   3400                      Move      D0, D2
344C   E44A                      LsR       $2, D2
344E   5342                      SubQ.L    $1, D2
3450   4A81                      Tst.L     D1
3452   6B08                      BMI       L599
3454   2320           L598:      Move.L    -(A0), -(A1)
3456   51CA FFFC                 DBF       D2, L598
345A   6006                      Bra       L600
345C   22D8           L599:      Move.L    (A0)+, (A1)+
345E   51CA FFFC                 DBF       D2, L599
3462   7403           L600:      MoveQ.L   $3, D2
3464   C082                      And.L     D2, D0
3466   66AE                      BNE       L589
3468   4E75                      Rts

                      P112:
346A   48E7 5F3E                 MoveM.L   D1/D3-D7/A2-A6, -(A7)
346E   3F3C 0030                 Move      $30, -(A7)
3472   80D7                      DivU      (A7), D0
3474   5340                      SubQ.L    $1, D0
3476   4A81                      Tst.L     D1
3478   6B16                      BMI       L602
347A   90D7                      SubA      (A7), A0
347C   4CD8 7CFE      L601:      MoveM.L   (A0)+, D1-D7/A2-A6
3480   48E1 7F3E                 MoveM.L   D1-D7/A2-A6, -(A1)
3484   90FC 0060                 SubA      $60, A0
3488   51C8 FFF2                 DBF       D0, L601
348C   D0D7                      AddA      (A7), A0
348E   6014                      Bra       L604
3490   D2D7           L602:      AddA      (A7), A1
3492   4CD8 7CFE      L603:      MoveM.L   (A0)+, D1-D7/A2-A6
3496   48E1 7F3E                 MoveM.L   D1-D7/A2-A6, -(A1)
349A   D2FC 0060                 AddA      $60, A1
349E   51C8 FFF2                 DBF       D0, L603
34A2   92D7                      SubA      (A7), A1
34A4   548F           L604:      AddQ      $2, A7
34A6   4CDF 7CFA                 MoveM.L   (A7)+, D1/D3-D7/A2-A6
34AA   4840                      Swap      D0
34AC   4E75                      Rts

                      Driver_Sound:
34AE   4E00                      DC.W      $4E00           ; flags
34B0   0000                      DC.W      $0000           ; number of ticks between periodic actions
34B2   0000                      DC.W      $0000           ; desk accessory event mask
34B4   0000                      DC.W      $0000           ; menu ID
34B6   001A                      DC.W      $001A           ; offset to open routine
34B8   00C6                      DC.W      $00C6           ; offset to prime routine
34BA   00A6                      DC.W      $00A6           ; offset to control routine
34BC   00BA                      DC.W      $00BA           ; offset to status routine
34BE   0030                      DC.W      $0030           ; offset to close routine
34C0   06                        DC.B      $06             ; length of driver name
                      ; Name
34C1   2E53 6F75 6E64            DC.B      '.Sound'
                      ; end of Name
34C7   20                        DC.B      $20             ; align to word

                      E_Sound_Open:
34C8   21C9 027A                 Move.L    A1, (SoundDCE)
34CC   611E                      Bsr       P113
34CE   1038 0208                 Move.B    (SPVolCtl), D0
34D2   6100 005E                 Bsr       P117
34D6   4238 027E                 Clr.B     (SoundActive)
34DA   7000           L605:      MoveQ.L   $0, D0
34DC   4E75                      Rts

                      E_Sound_Close:
34DE   611C                      Bsr       P115
34E0   610A                      Bsr       P113
34E2   08F9 0007 00EF            BSet.B    $7, (VIA_Base)
       E1FE
34EA   60EE                      Bra       L605

                      P113:
34EC   70FF                      MoveQ.L   $-1, D0
34EE   611E                      Bsr       P116

                      P114:
34F0   2078 01D4                 Move.L    (VIA), A0
34F4   0228 003F 1600            And.B     $3F, $1600(A0)
34FA   4E75                      Rts

                      P115:
34FC   4A38 027E                 Tst.B     (SoundActive)
3500   670A                      BEQ       L606
3502   41F8 026A                 Lea.L     (SoundVBL_qLink), A0
3506   A034                      _VRemove
3508   4238 027E                 Clr.B     (SoundActive)
350C   4E75           L606:      Rts

                      P116:
350E   11C0 027F                 Move.B    D0, (SoundLevel)
3512   2078 0266                 Move.L    (SoundBase), A0
3516   7249                      MoveQ.L   $49, D1
3518   1080           L607:      Move.B    D0, (A0)
351A   5448                      AddQ      $2, A0
351C   1080                      Move.B    D0, (A0)
351E   5448                      AddQ      $2, A0
3520   1080                      Move.B    D0, (A0)
3522   5448                      AddQ      $2, A0
3524   1080                      Move.B    D0, (A0)
3526   5448                      AddQ      $2, A0
3528   1080                      Move.B    D0, (A0)
352A   5448                      AddQ      $2, A0
352C   51C9 FFEA                 DBF       D1, L607
3530   4E75                      Rts

                      P117:
3532   40E7                      Move      SR, -(A7)
3534   007C 0300                 Or        $300, SR
3538   1239 00EF FFFE            Move.B    ($EFFFFE), D1
353E   0241 00F8                 And       $F8, D1
3542   0240 0007                 And       $7, D0
3546   11C0 0260                 Move.B    D0, (SdVolume)
354A   8240                      Or        D0, D1
354C   13C1 00EF FFFE            Move.B    D1, ($EFFFFE)
3552   4E73                      Rte

                      E_Sound_Control:
3554   3028 001A                 Move      $1A(A0), D0
3558   670E                      BEQ       E_Sound_Status
355A   5540                      SubQ.L    $2, D0
355C   670E                      BEQ       L608
355E   6D00 FF7E                 BLT       E_Sound_Close
3562   3028 001C                 Move      $1C(A0), D0
3566   61A6                      Bsr       P116

                      E_Sound_Status:
3568   6000 00BA                 Bra       L615
356C   3028 001C      L608:      Move      $1C(A0), D0
3570   61C0                      Bsr       P117
3572   60F4                      Bra       E_Sound_Status

                      E_Sound_Prime:
3574   08B9 0007 00EF            BClr.B    $7, (VIA_Base)
       E1FE
357C   2268 0020                 Move.L    $20(A0), A1
3580   4A59                      Tst       (A1)+
3582   6700 014E                 BEQ       L620
3586   6A00 00A8                 BPL       L616
358A   4C99 0007      L609:      MoveM     (A1)+, D0-D2
358E   4A42                      Tst       D2
3590   6700 0078                 BEQ       L613
3594   2F08                      Move.L    A0, -(A7)
3596   2078 01D4                 Move.L    (VIA), A0
359A   0028 00C0 1600            Or.B      $-40, $1600(A0)
35A0   B078 0280                 Cmp       (CurPitch), D0
35A4   670E                      BEQ       L610
35A6   31C0 0280                 Move      D0, (CurPitch)
35AA   1140 0800                 Move.B    D0, $800(A0)
35AE   E048                      LsR       $8, D0
35B0   1140 0A00                 Move.B    D0, $A00(A0)
35B4   3001           L610:      Move      D1, D0
35B6   6100 FF56                 Bsr       P116
35BA   3002                      Move      D2, D0
35BC   43FA 0030                 Lea.L     P_SoundVBL_taskSquareWave, A1
35C0   610C                      Bsr       P119
35C2   205F                      Move.L    (A7)+, A0
35C4   5CA8 0028                 AddQ      $6, $28(A0)
35C8   7000           L611:      MoveQ.L   $0, D0
35CA   4E75                      Rts

                      P118:
35CC   7001                      MoveQ.L   $1, D0

                      P119:
35CE   41F8 026A                 Lea.L     (SoundVBL_qLink), A0
35D2   2208                      Move.L    A0, D1
35D4   4298                      Clr.L     (A0)+
35D6   30FC 0001                 Move      $1, (A0)+
35DA   20C9                      Move.L    A1, (A0)+
35DC   30C0                      Move      D0, (A0)+
35DE   4A38 027E                 Tst.B     (SoundActive)
35E2   6608                      BNE       L612
35E4   50F8 027E                 ST.B      (SoundActive)
35E8   2041                      Move.L    D1, A0
35EA   A033                      _VInstall
35EC   4E75           L612:      Rts

                      P_SoundVBL_taskSquareWave:
35EE   2278 027A                 Move.L    (SoundDCE), A1
35F2   2069 0008                 Move.L    $8(A1), A0
35F6   2028 0028                 Move.L    $28(A0), D0
35FA   2268 0020                 Move.L    $20(A0), A1
35FE   D3C0                      AddA.L    D0, A1
3600   5489                      AddQ      $2, A1
3602   5840                      AddQ      $4, D0
3604   B0A8 0024                 Cmp.L     $24(A0), D0
3608   6D80                      BLT       L609
360A   6100 FEE4      L613:      Bsr       P114
360E   4278 0280                 Clr       (CurPitch)
3612   6100 FEE8      L614:      Bsr       P115
3616   70FF                      MoveQ.L   $-1, D0
3618   6100 FEF4                 Bsr       P116
361C   08F9 0007 00EF            BSet.B    $7, (VIA_Base)
       E1FE
3624   7000           L615:      MoveQ.L   $0, D0
3626   2278 027A                 Move.L    (SoundDCE), A1
362A   2078 08FC                 Move.L    (JIODone), A0
362E   4ED0                      Jmp       (A0)
3630   21D9 0262      L616:      Move.L    (A1)+, (SoundPtr)
3634   43FA 000C                 Lea.L     P_SoundVBL_task4Tone, A1
3638   6192           L617:      Bsr       P118
363A   608C                      Bra       L611
363C   4CDF 7FFF      L618:      MoveM.L   (A7)+, D0-D7/A0-A6
3640   60D0                      Bra       L614

                      P_SoundVBL_task4Tone:
3642   48E7 FFFE                 MoveM.L   D0-D7/A0-A6, -(A7)
3646   2C78 0262                 Move.L    (SoundPtr), A6
364A   4A56                      Tst       (A6)
364C   67EE                      BEQ       L618
364E   31FC 0001 0274            Move      $1, (SoundVBL.Count)
3654   535E                      SubQ.L    $1, (A6)+
3656   4CD6 3FFC                 MoveM.L   (A6), D2-D7/A0-A5
365A   2C78 0266                 Move.L    (SoundBase), A6
365E   DCFC 0172                 AddA      $172, A6
3662   223C 00FF 0000            Move.L    $FF0000, D1
3668   3F3C 0002                 Move      $2, -(A7)
366C   3F3C 00B9                 Move      $B9, -(A7)
3670   4241           L619:      Clr       D1
3672   D682                      Add.L     D2, D3
3674   DA84                      Add.L     D4, D5
3676   DE86                      Add.L     D6, D7
3678   D3C8                      AddA.L    A0, A1
367A   2003                      Move.L    D3, D0
367C   C081                      And.L     D1, D0
367E   4840                      Swap      D0
3680   1232 0000                 Move.B    $0(A2,D0.W), D1
3684   2005                      Move.L    D5, D0
3686   C081                      And.L     D1, D0
3688   4840                      Swap      D0
368A   1033 0000                 Move.B    $0(A3,D0.W), D0
368E   D240                      Add       D0, D1
3690   2007                      Move.L    D7, D0
3692   C081                      And.L     D1, D0
3694   4840                      Swap      D0
3696   1034 0000                 Move.B    $0(A4,D0.W), D0
369A   D240                      Add       D0, D1
369C   2009                      Move.L    A1, D0
369E   C081                      And.L     D1, D0
36A0   4840                      Swap      D0
36A2   1035 0000                 Move.B    $0(A5,D0.W), D0
36A6   D240                      Add       D0, D1
36A8   E449                      LsR       $2, D1
36AA   1C81                      Move.B    D1, (A6)
36AC   544E                      AddQ      $2, A6
36AE   5357                      SubQ.L    $1, (A7)
36B0   66BE                      BNE       L619
36B2   2C78 0266                 Move.L    (SoundBase), A6
36B6   3EBC 00B9                 Move      $B9, (A7)
36BA   536F 0002                 SubQ.L    $1, $2(A7)
36BE   66B0                      BNE       L619
36C0   584F                      AddQ      $4, A7
36C2   2C78 0262                 Move.L    (SoundPtr), A6
36C6   544E                      AddQ      $2, A6
36C8   48D6 03FC                 MoveM.L   D2-D7/A0-A1, (A6)
36CC   4CDF 7FFF                 MoveM.L   (A7)+, D0-D7/A0-A6
36D0   4E75                      Rts
36D2   2278 027A      L620:      Move.L    (SoundDCE), A1
36D6   42A9 0010                 Clr.L     $10(A1)
36DA   43FA 0006                 Lea.L     P_SoundVBL_taskFreeForm, A1
36DE   6000 FF58                 Bra       L617

                      P_SoundVBL_taskFreeForm:
36E2   2278 027A                 Move.L    (SoundDCE), A1
36E6   2069 0008                 Move.L    $8(A1), A0
36EA   2629 0010                 Move.L    $10(A1), D3
36EE   2028 0028                 Move.L    $28(A0), D0
36F2   B0A8 0024                 Cmp.L     $24(A0), D0
36F6   6C00 FF1A                 BGE       L614
36FA   31FC 0001 0274            Move      $1, (SoundVBL.Count)
3700   2F0C                      Move.L    A4, -(A7)
3702   2268 0020                 Move.L    $20(A0), A1
3706   5449                      AddQ      $2, A1
3708   2219                      Move.L    (A1)+, D1
370A   2649                      Move.L    A1, A3
370C   D7E8 0024                 AddA.L    $24(A0), A3
3710   D3C0                      AddA.L    D0, A1
3712   2478 0266                 Move.L    (SoundBase), A2
3716   D4FC 0040                 AddA      $40, A2
371A   49EA 02A4                 Lea.L     $2A4(A2), A4
371E   4267                      Clr       -(A7)
3720   343C 0151                 Move      $151, D2
3724   7000           L621:      MoveQ.L   $0, D0
3726   1491           L622:      Move.B    (A1), (A2)
3728   544A                      AddQ      $2, A2
372A   D681                      Add.L     D1, D3
372C   4843                      Swap      D3
372E   D2C3                      AddA      D3, A1
3730   D043                      Add       D3, D0
3732   4243                      Clr       D3
3734   4843                      Swap      D3
3736   B7C9                      CmpA.L    A1, A3
3738   5FCA FFEC                 DBLE      D2, L622
373C   D1A8 0028                 Add.L     D0, $28(A0)
3740   4A5F                      Tst       (A7)+
3742   6722                      BEQ       L627
3744   4A42                      Tst       D2
3746   6B12                      BMI       L626
3748   7000           L623:      MoveQ.L   $0, D0
374A   1480           L624:      Move.B    D0, (A2)
374C   544A                      AddQ      $2, A2
374E   B9CA                      CmpA.L    A2, A4
3750   6E04                      BGT       L625
3752   2478 0266                 Move.L    (SoundBase), A2
3756   51CA FFF2      L625:      DBF       D2, L624
375A   2278 027A      L626:      Move.L    (SoundDCE), A1
375E   2343 0010                 Move.L    D3, $10(A1)
3762   285F                      Move.L    (A7)+, A4
3764   4E75                      Rts
3766   4A42           L627:      Tst       D2
3768   6B06                      BMI       L628
376A   0642 0020                 Add       $20, D2
376E   60D8                      Bra       L623
3770   3F3C 0001      L628:      Move      $1, -(A7)
3774   2478 0266                 Move.L    (SoundBase), A2
3778   741F                      MoveQ.L   $1F, D2
377A   60A8                      Bra       L621

                      P_tPostEvent:
377C   3438 0144                 Move      (SysEvtMask), D2
3780   3208                      Move      A0, D1
3782   0302                      BTst.B    D1, D2
3784   6604                      BNE       L629
3786   7001                      MoveQ.L   $1, D0
3788   4E75                      Rts
378A   40E7           L629:      Move      SR, -(A7)
378C   2F00                      Move.L    D0, -(A7)
378E   3F08                      Move      A0, -(A7)
3790   2078 0146                 Move.L    (SysEvtBuf), A0
3794   5C88                      AddQ      $6, A0
3796   7016                      MoveQ.L   $16, D0
3798   72FF                      MoveQ.L   $-1, D1
379A   90C0                      SubA      D0, A0
379C   3438 0154                 Move      (EvtBufCnt), D2
37A0   007C 0100                 Or        $100, SR
37A4   D0C0           L630:      AddA      D0, A0
37A6   B250                      Cmp       (A0), D1
37A8   57CA FFFA                 DBEQ      D2, L630
37AC   43F8 014A                 Lea.L     (EventQueue), A1
37B0   670A                      BEQ       L631
37B2   2069 0002                 Move.L    $2(A1), A0
37B6   2350 0002                 Move.L    (A0), $2(A1)
37BA   5C88                      AddQ      $6, A0
37BC   309F           L631:      Move      (A7)+, (A0)
37BE   215F 0002                 Move.L    (A7)+, $2(A0)
37C2   6112                      Bsr       P120
37C4   5D88                      SubQ.L    $6, A0
37C6   317C 0004 0004            Move      $4, $4(A0)
37CC   4EBA D352                 Jsr       P13
37D0   46DF                      Move      (A7)+, SR
37D2   7000                      MoveQ.L   $0, D0
37D4   4E75                      Rts

                      P120:
37D6   2178 016A 0006            Move.L    (Ticks), $6(A0)
37DC   2178 0830 000A            Move.L    (Mouse_v), $A(A0)
37E2   3238 017A                 Move      (KeyMap.6), D1
37E6   E359                      ROL       $1, D1
37E8   1141 000E                 Move.B    D1, $E(A0)
37EC   1178 0172 000F            Move.B    (MBState), $F(A0)
37F2   4E75                      Rts

                      P_tOSEventAvail:
37F4   43F8 014A                 Lea.L     (EventQueue), A1
37F8   40E7                      Move      SR, -(A7)
37FA   007C 0100                 Or        $100, SR
37FE   2229 0002                 Move.L    $2(A1), D1
3802   670E                      BEQ       L633
3804   2241           L632:      Move.L    D1, A1
3806   3229 0006                 Move      $6(A1), D1
380A   0300                      BTst.B    D1, D0
380C   6648                      BNE       L634
380E   2211                      Move.L    (A1), D1
3810   66F2                      BNE       L632
3812   C078 0144      L633:      And       (SysEvtMask), D0
3816   4A78 0184                 Tst       (KeyLast)
381A   6750                      BEQ       L636
381C   0800 0005                 BTst.B    $5, D0
3820   674A                      BEQ       L636
3822   2238 016A                 Move.L    (Ticks), D1
3826   2401                      Move.L    D1, D2
3828   92B8 0186                 Sub.L     (KeyTime), D1
382C   B278 018E                 Cmp       (KeyThresh), D1
3830   6D3A                      BLT       L636
3832   94B8 018A                 Sub.L     (KeyRepTime), D2
3836   B478 0190                 Cmp       (KeyRepThresh), D2
383A   6D30                      BLT       L636
383C   21F8 016A 018A            Move.L    (Ticks), (KeyRepTime)
3842   2F08                      Move.L    A0, -(A7)
3844   307C 0005                 Move      $5, A0
3848   7000                      MoveQ.L   $0, D0
384A   3038 0184                 Move      (KeyLast), D0
384E   6100 FF2C                 Bsr       P_tPostEvent
3852   2248                      Move.L    A0, A1
3854   205F                      Move.L    (A7)+, A0
3856   46DF           L634:      Move      (A7)+, SR
3858   7004                      MoveQ.L   $4, D0
385A   48E7 00C0                 MoveM.L   A0-A1, -(A7)
385E   5C89                      AddQ      $6, A1
3860   20D9           L635:      Move.L    (A1)+, (A0)+
3862   5340                      SubQ.L    $1, D0
3864   66FA                      BNE       L635
3866   4CDF 0300                 MoveM.L   (A7)+, A0-A1
386A   4E75                      Rts
386C   6100 FF68      L636:      Bsr       P120
3870   46DF                      Move      (A7)+, SR
3872   4250                      Clr       (A0)
3874   42A8 0002                 Clr.L     $2(A0)
3878   70FF                      MoveQ.L   $-1, D0
387A   4E75                      Rts

                      P_tGetOSEvent:
387C   6100 FF76                 Bsr       P_tOSEventAvail
3880   660A                      BNE       L637
3882   2049                      Move.L    A1, A0
3884   43F8 014A                 Lea.L     (EventQueue), A1
3888   6104                      Bsr       P121
388A   7000                      MoveQ.L   $0, D0
388C   4E75           L637:      Rts

                      P121:
388E   4EBA D2B4                 Jsr       P14
3892   317C FFFF 0006            Move      $-1, $6(A0)
3898   4E75                      Rts

                      P_tFlushEvents:
389A   40E7                      Move      SR, -(A7)
389C   48E7 1800                 MoveM.L   D3-D4, -(A7)
38A0   2200                      Move.L    D0, D1
38A2   4841                      Swap      D1
38A4   3800                      Move      D0, D4
38A6   43F8 014A                 Lea.L     (EventQueue), A1
38AA   007C 0100                 Or        $100, SR
38AE   2629 0002                 Move.L    $2(A1), D3
38B2   6716                      BEQ       L640
38B4   2043           L638:      Move.L    D3, A0
38B6   2610                      Move.L    (A0), D3
38B8   3428 0006                 Move      $6(A0), D2
38BC   0501                      BTst.B    D2, D1
38BE   660C                      BNE       L641
38C0   0504                      BTst.B    D2, D4
38C2   6702                      BEQ       L639
38C4   61C8                      Bsr       P121
38C6   4A83           L639:      Tst.L     D3
38C8   66EA                      BNE       L638
38CA   7400           L640:      MoveQ.L   $0, D2
38CC   4CDF 0018      L641:      MoveM.L   (A7)+, D3-D4
38D0   3002                      Move      D2, D0
38D2   4E73                      Rte

                      P122:
38D4   0881 000A                 BClr.B    $A, D1

                      P123:
38D8   2438 03E2                 Move.L    (FSQueueHook), D2
38DC   6F04                      BLE       L642
38DE   2242                      Move.L    D2, A1
38E0   4E91                      Jsr       (A1)
38E2   317C 0001 0010 L642:      Move      $1, $10(A0)
38E8   3141 0006                 Move      D1, $6(A0)
38EC   215F 0008                 Move.L    (A7)+, $8(A0)
38F0   317C 0005 0004            Move      $5, $4(A0)
38F6   0801 000A                 BTst.B    $A, D1
38FA   6708                      BEQ       L643
38FC   4A38 0349                 Tst.B     (FrcSync)
3900   6722                      BEQ       P124
3902   6004                      Bra       L644
3904   42A8 000C      L643:      Clr.L     $C(A0)
3908   2F08           L644:      Move.L    A0, -(A7)
390A   6118                      Bsr       P124
390C   205F                      Move.L    (A7)+, A0
390E   3028 0010      L645:      Move      $10(A0), D0
3912   6EFA                      BGT       L645
3914   0C40 FFCB                 Cmp       $-35, D0
3918   6608                      BNE       L646
391A   2F38 03EA                 Move.L    (DskSwtchHook), -(A7)
391E   6E02                      BGT       L646
3920   584F                      AddQ      $4, A7
3922   4E75           L646:      Rts

                      P124:
3924   43F8 0360                 Lea.L     (FSQHdr_Flags), A1
3928   4EBA D1F6                 Jsr       P13
392C   40E7                      Move      SR, -(A7)
392E   007C 0300                 Or        $300, SR
3932   08F8 0000 0360 L647:      BSet.B    $0, (FSQHdr_Flags)
3938   6704                      BEQ       L648
393A   7000                      MoveQ.L   $0, D0
393C   4E73                      Rte
393E   46DF           L648:      Move      (A7)+, SR
3940   2078 0362                 Move.L    (FSQHdr.Head), A0
3944   2268 0008                 Move.L    $8(A0), A1
3948   48E7 1F3E                 MoveM.L   D3-D7/A2-A6, -(A7)
394C   4E91                      Jsr       (A1)
394E   4CDF 7CF8                 MoveM.L   (A7)+, D3-D7/A2-A6
3952   4E75                      Rts
3954   2438 03E6      L649:      Move.L    (ExtFSHook), D2
3958   6F04                      BLE       L650
395A   2242                      Move.L    D2, A1
395C   4E91                      Jsr       (A1)
395E   40E7           L650:      Move      SR, -(A7)
3960   007C 0300                 Or        $300, SR
3964   4278 0360                 Clr       (FSQHdr_Flags)
3968   2078 0362                 Move.L    (FSQHdr.Head), A0
396C   0C68 0005 0004            Cmp       $5, $4(A0)
3972   6600 1064                 BNE       L899
3976   21D0 0362                 Move.L    (A0), (FSQHdr.Head)
397A   6604                      BNE       L651
397C   42B8 0366                 Clr.L     (FSQHdr.Tail)
3980   46DF           L651:      Move      (A7)+, SR
3982   3140 0010                 Move      D0, $10(A0)
3986   2228 000C                 Move.L    $C(A0), D1
398A   6706                      BEQ       L652
398C   2241                      Move.L    D1, A1
398E   4A40                      Tst       D0
3990   4E91                      Jsr       (A1)
3992   40E7           L652:      Move      SR, -(A7)
3994   007C 0300                 Or        $300, SR
3998   4AB8 0362                 Tst.L     (FSQHdr.Head)
399C   6694                      BNE       L647
399E   4E73                      Rte

                      P_tFInitQueue:
39A0   40E7                      Move      SR, -(A7)
39A2   007C 0300                 Or        $300, SR
39A6   2038 0362                 Move.L    (FSQHdr.Head), D0
39AA   6708                      BEQ       L653
39AC   2040                      Move.L    D0, A0
39AE   4290                      Clr.L     (A0)
39B0   21C8 0366                 Move.L    A0, (FSQHdr.Tail)
39B4   7000           L653:      MoveQ.L   $0, D0
39B6   4E73                      Rte

                      P_tMountVol:
39B8   6100 FF1A                 Bsr       P122
39BC   50F8 034A                 ST.B      (NewMount)
39C0   70CE                      MoveQ.L   $-32, D0
39C2   3428 0016                 Move      $16(A0), D2
39C6   6F0A                      BLE       L654
39C8   3002                      Move      D2, D0
39CA   6100 03BA                 Bsr       P133
39CE   6604                      BNE       L655
39D0   70C9                      MoveQ.L   $-37, D0
39D2   6080           L654:      Bra       L649
39D4   6100 023C      L655:      Bsr       P130
39D8   66F8                      BNE       L654
39DA   2448                      Move.L    A0, A2
39DC   705E                      MoveQ.L   $5E, D0
39DE   A71E                      _NewPtrSysClear
39E0   66F0                      BNE       L654
39E2   C14A                      Exg.L     A0, A2
39E4   3542 0048                 Move      D2, $48(A2)
39E8   3541 004A                 Move      D1, $4A(A2)
39EC   5340           L656:      SubQ.L    $1, D0
39EE   48E7 8020                 MoveM.L   D0/A2, -(A7)
39F2   6100 038A                 Bsr       P132
39F6   4CDF 0401                 MoveM.L   (A7)+, D0/A2
39FA   67F0                      BEQ       L656
39FC   3540 004E                 Move      D0, $4E(A2)
3A00   203C 0000 020A            Move.L    $20A, D0
3A06   A71E                      _NewPtrSysClear
3A08   6674                      BNE       L663
3A0A   D0FC 000A                 AddA      $A, A0
3A0E   2548 0054                 Move.L    A0, $54(A2)
3A12   3638 034C                 Move      (DrMstrBlk), D3
3A16   6100 0B7C                 Bsr       P163
3A1A   6660                      BNE       L662
3A1C   70C7                      MoveQ.L   $-39, D0
3A1E   0C55 D2D7                 Cmp       $-2D29, (A5)
3A22   6658                      BNE       L662
3A24   70C4                      MoveQ.L   $-3C, D0
3A26   222D 0014                 Move.L    $14(A5), D1
3A2A   6750                      BEQ       L662
3A2C   0241 01FF                 And       $1FF, D1
3A30   664A                      BNE       L662
3A32   701F                      MoveQ.L   $1F, D0
3A34   224D                      Move.L    A5, A1
3A36   41EA 0008                 Lea.L     $8(A2), A0
3A3A   30D9           L657:      Move      (A1)+, (A0)+
3A3C   51C8 FFFC                 DBF       D0, L657
3A40   2038 0358                 Move.L    (VCBQHdr.Head), D0
3A44   6766           L658:      BEQ       L666
3A46   2040                      Move.L    D0, A0
3A48   1568 0013 0013            Move.B    $13(A0), $13(A2)
3A4E   43E8 0008                 Lea.L     $8(A0), A1
3A52   47EA 0008                 Lea.L     $8(A2), A3
3A56   700F                      MoveQ.L   $F, D0
3A58   B789           L659:      CmpM.L    (A1)+, (A3)+
3A5A   661A                      BNE       L660
3A5C   51C8 FFFA                 DBF       D0, L659
3A60   4A51                      Tst       (A1)
3A62   6612                      BNE       L660
3A64   4238 034A                 Clr.B     (NewMount)
3A68   22DB                      Move.L    (A3)+, (A1)+
3A6A   216A 0054 0054            Move.L    $54(A2), $54(A0)
3A70   C14A                      Exg.L     A0, A2
3A72   A01F                      _DisposePtr
3A74   6036                      Bra       L666
3A76   2010           L660:      Move.L    (A0), D0
3A78   60CA                      Bra       L658
3A7A   610E           L661:      Bsr       P125
3A7C   6116           L662:      Bsr       P126
3A7E   4A38 034A      L663:      Tst.B     (NewMount)
3A82   6702                      BEQ       L664
3A84   611C                      Bsr       P127
3A86   6000 FF4A      L664:      Bra       L654

                      P125:
3A8A   3F00                      Move      D0, -(A7)
3A8C   206A 0050                 Move.L    $50(A2), A0
3A90   A01F                      _DisposePtr
3A92   6014                      Bra       L665

                      P126:
3A94   3F00                      Move      D0, -(A7)
3A96   206A 0054                 Move.L    $54(A2), A0
3A9A   5148                      SubQ.L    $8, A0
3A9C   5548                      SubQ.L    $2, A0
3A9E   A01F                      _DisposePtr
3AA0   6006                      Bra       L665

                      P127:
3AA2   3F00                      Move      D0, -(A7)
3AA4   204A                      Move.L    A2, A0
3AA6   A01F                      _DisposePtr
3AA8   301F           L665:      Move      (A7)+, D0
3AAA   4E75                      Rts
3AAC   7403           L666:      MoveQ.L   $3, D2
3AAE   C4EA 001A                 MulU      $1A(A2), D2
3AB2   5282                      AddQ      $1, D2
3AB4   E28A                      LsR.L     $1, D2
3AB6   3542 0058                 Move      D2, $58(A2)
3ABA   7E40                      MoveQ.L   $40, D7
3ABC   2002                      Move.L    D2, D0
3ABE   A51E                      _NewPtrSys
3AC0   66BA                      BNE       L662
3AC2   2548 0050                 Move.L    A0, $50(A2)
3AC6   30F5 7000      L667:      Move      $0(A5,D7.W), (A0)+
3ACA   5447                      AddQ      $2, D7
3ACC   5542                      SubQ.L    $2, D2
3ACE   6F12                      BLE       L668
3AD0   0C47 0200                 Cmp       $200, D7
3AD4   65F0                      BCS       L667
3AD6   5243                      AddQ      $1, D3
3AD8   6100 0ABA                 Bsr       P163
3ADC   669C                      BNE       L661
3ADE   7E00                      MoveQ.L   $0, D7
3AE0   60E4                      Bra       L667
3AE2   7602           L668:      MoveQ.L   $2, D3
3AE4   7200                      MoveQ.L   $0, D1
3AE6   6100 0EF4      L669:      Bsr       P180
3AEA   6602                      BNE       L670
3AEC   5241                      AddQ      $1, D1
3AEE   B66A 001A      L670:      Cmp       $1A(A2), D3
3AF2   6204                      BHI       L671
3AF4   5243                      AddQ      $1, D3
3AF6   60EE                      Bra       L669
3AF8   70C4           L671:      MoveQ.L   $-3C, D0
3AFA   B26A 002A                 Cmp       $2A(A2), D1
3AFE   6600 FF7A                 BNE       L661
3B02   7200                      MoveQ.L   $0, D1
3B04   7400                      MoveQ.L   $0, D2
3B06   7E00                      MoveQ.L   $0, D7
3B08   6100 07BC                 Bsr       P153
3B0C   6600 FF6C                 BNE       L661
3B10   7000           L672:      MoveQ.L   $0, D0
3B12   4A35 0000      L673:      Tst.B     $0(A5,D0.W)
3B16   6720                      BEQ       L675
3B18   5241                      AddQ      $1, D1
3B1A   B4B5 0012                 Cmp.L     $12(A5,D0.W), D2
3B1E   6204                      BHI       L674
3B20   2435 0012                 Move.L    $12(A5,D0.W), D2
3B24   47F5 0016      L674:      Lea.L     $16(A5,D0.W), A3
3B28   6100 0080                 Bsr       P128
3B2C   47F5 0020                 Lea.L     $20(A5,D0.W), A3
3B30   6178                      Bsr       P128
3B32   6100 052A                 Bsr       P145
3B36   65DA                      BCS       L673
3B38   6100 07B4      L675:      Bsr       P154
3B3C   67D2                      BEQ       L672
3B3E   0C40 FFDF                 Cmp       $-21, D0
3B42   6600 FF36                 BNE       L661
3B46   B4AA 0026                 Cmp.L     $26(A2), D2
3B4A   6508                      BCS       L676
3B4C   5282                      AddQ      $1, D2
3B4E   2542 0026                 Move.L    D2, $26(A2)
3B52   5207                      AddQ      $1, D7
3B54   B26A 0014      L676:      Cmp       $14(A2), D1
3B58   6706                      BEQ       L677
3B5A   3541 0014                 Move      D1, $14(A2)
3B5E   5407                      AddQ      $2, D7
3B60   4A07           L677:      Tst.B     D7
3B62   56EA 0006                 SNE.B     $6(A2)
3B66   41F8 03A4                 Lea.L     (Params), A0
3B6A   317C 0008 001A            Move      $8, $1A(A0)
3B70   A005                      _Status
3B72   4A28 001E                 Tst.B     $1E(A0)
3B76   6A04                      BPL       L678
3B78   08C7 0007                 BSet.B    $7, D7
3B7C   1547 0013      L678:      Move.B    D7, $13(A2)
3B80   2078 0362                 Move.L    (FSQHdr.Head), A0
3B84   316A 004E 0016            Move      $4E(A2), $16(A0)
3B8A   4A38 034A                 Tst.B     (NewMount)
3B8E   6714                      BEQ       L680
3B90   204A                      Move.L    A2, A0
3B92   43F8 0356                 Lea.L     (VCBQHdr_Flags), A1
3B96   4AA9 0002                 Tst.L     $2(A1)
3B9A   6604                      BNE       L679
3B9C   21CA 0352                 Move.L    A2, (DefVCBPtr)
3BA0   4EBA CF7E      L679:      Jsr       P13
3BA4   7000           L680:      MoveQ.L   $0, D0
3BA6   6000 FE2A                 Bra       L654

                      P128:
3BAA   48E7 3E00                 MoveM.L   D2-D6, -(A7)
3BAE   7C00                      MoveQ.L   $0, D6
3BB0   242A 001C                 Move.L    $1C(A2), D2
3BB4   3613                      Move      (A3), D3
3BB6   6710                      BEQ       L682
3BB8   6100 0E22      L681:      Bsr       P180
3BBC   3605                      Move      D5, D3
3BBE   6708                      BEQ       L682
3BC0   DC82                      Add.L     D2, D6
3BC2   0C43 0001                 Cmp       $1, D3
3BC6   66F0                      BNE       L681
3BC8   361B           L682:      Move      (A3)+, D3
3BCA   281B                      Move.L    (A3)+, D4
3BCC   2A1B                      Move.L    (A3)+, D5
3BCE   BC85                      Cmp.L     D5, D6
3BD0   671A                      BEQ       L685
3BD2   2706                      Move.L    D6, -(A3)
3BD4   6602                      BNE       L683
3BD6   4243                      Clr       D3
3BD8   B886           L683:      Cmp.L     D6, D4
3BDA   6302                      BLS       L684
3BDC   2806                      Move.L    D6, D4
3BDE   2704           L684:      Move.L    D4, -(A3)
3BE0   3703                      Move      D3, -(A3)
3BE2   08ED 0007 FFFE            BSet.B    $7, $-2(A5)
3BE8   08C7 0002                 BSet.B    $2, D7
3BEC   4CDF 007C      L685:      MoveM.L   (A7)+, D2-D6
3BF0   4E75                      Rts

                      P129:
3BF2   2F02                      Move.L    D2, -(A7)
3BF4   2428 0002                 Move.L    $2(A0), D2
3BF8   6714           L686:      BEQ       L689
3BFA   2042                      Move.L    D2, A0
3BFC   B070 1000                 Cmp       $0(A0,D1.W), D0
3C00   6704                      BEQ       L687
3C02   2410                      Move.L    (A0), D2
3C04   60F2                      Bra       L686
3C06   7000           L687:      MoveQ.L   $0, D0
3C08   241F           L688:      Move.L    (A7)+, D2
3C0A   4A40                      Tst       D0
3C0C   4E75                      Rts
3C0E   70FF           L689:      MoveQ.L   $-1, D0
3C10   60F6                      Bra       L688

                      P130:
3C12   2F08                      Move.L    A0, -(A7)
3C14   3002                      Move      D2, D0
3C16   41F8 0308                 Lea.L     (DrvQHdr_Flags), A0
3C1A   7206                      MoveQ.L   $6, D1
3C1C   61D4                      Bsr       P129
3C1E   6610                      BNE       L691
3C20   3228 0008                 Move      $8(A0), D1
3C24   3028 000A                 Move      $A(A0), D0
3C28   6702                      BEQ       L690
3C2A   70C6                      MoveQ.L   $-3A, D0
3C2C   205F           L690:      Move.L    (A7)+, A0
3C2E   4E75                      Rts
3C30   70C8           L691:      MoveQ.L   $-38, D0
3C32   60F8                      Bra       L690

                      P_tEject:
3C34   A013                      _FlushVol
3C36   6100 FCA0                 Bsr       P123
3C3A   6100 0166                 Bsr       P134
3C3E   670C                      BEQ       L693
3C40   3428 0016                 Move      $16(A0), D2
3C44   61CC                      Bsr       P130
3C46   6726                      BEQ       L694
3C48   6000 FD0A      L692:      Bra       L649
3C4C   6100 0126      L693:      Bsr       P131
3C50   66F6                      BNE       L692
3C52   43EA 0048                 Lea.L     $48(A2), A1
3C56   3411                      Move      (A1), D2
3C58   67EE                      BEQ       L692
3C5A   4259                      Clr       (A1)+
3C5C   3211                      Move      (A1), D1
3C5E   32C2                      Move      D2, (A1)+
3C60   5849                      AddQ      $4, A1
3C62   6100 FE26                 Bsr       P125
3C66   4299                      Clr.L     (A1)+
3C68   6100 FE2A                 Bsr       P126
3C6C   4291                      Clr.L     (A1)
3C6E   41F8 03A4      L694:      Lea.L     (Params), A0
3C72   43E8 0016                 Lea.L     $16(A0), A1
3C76   32C2                      Move      D2, (A1)+
3C78   32C1                      Move      D1, (A1)+
3C7A   32BC 0007                 Move      $7, (A1)
3C7E   43FA FCD4                 Lea.L     L649, A1
3C82   2149 000C                 Move.L    A1, $C(A0)
3C86   A404                      _ControlAsync
3C88   4E75                      Rts

                      P_tUnmountVol:
3C8A   6100 FC48                 Bsr       P122
3C8E   4238 0346                 Clr.B     (FlushOnly)
3C92   6008                      Bra       L695

                      P_tFlushVol:
3C94   6100 FC42                 Bsr       P123
3C98   50F8 0346                 ST.B      (FlushOnly)
3C9C   6100 0104      L695:      Bsr       P134
3CA0   661A                      BNE       L697
3CA2   6100 00D0                 Bsr       P131
3CA6   6614                      BNE       L697
3CA8   6100 0232                 Bsr       P140
3CAC   4AB1 1000      L696:      Tst.L     $0(A1,D1.W)
3CB0   670C                      BEQ       L698
3CB2   B5F1 1014                 CmpA.L    $14(A1,D1.W), A2
3CB6   6606                      BNE       L698
3CB8   6100 0B0E                 Bsr       P174
3CBC   666C           L697:      BNE       L702
3CBE   6100 0224      L698:      Bsr       P141
3CC2   65E8                      BCS       L696
3CC4   4A6A 0048                 Tst       $48(A2)
3CC8   6778                      BEQ       L705
3CCA   2A6A 0054                 Move.L    $54(A2), A5
3CCE   362D FFFE                 Move      $-2(A5), D3
3CD2   0883 000F                 BClr.B    $F, D3
3CD6   6706                      BEQ       L699
3CD8   6100 0982                 Bsr       P168
3CDC   664C                      BNE       L702
3CDE   4A6A 0006      L699:      Tst       $6(A2)
3CE2   6A5E                      BPL       L705
3CE4   3638 034C                 Move      (DrMstrBlk), D3
3CE8   42AD FFF6                 Clr.L     $-A(A5)
3CEC   42AD FFFA                 Clr.L     $-6(A5)
3CF0   701F                      MoveQ.L   $1F, D0
3CF2   224D                      Move.L    A5, A1
3CF4   41EA 0008                 Lea.L     $8(A2), A0
3CF8   2578 020C 000E            Move.L    (Time), $E(A2)
3CFE   32D8           L700:      Move      (A0)+, (A1)+
3D00   51C8 FFFC                 DBF       D0, L700
3D04   206A 0050                 Move.L    $50(A2), A0
3D08   342A 0058                 Move      $58(A2), D2
3D0C   7E40                      MoveQ.L   $40, D7
3D0E   3B98 7000      L701:      Move      (A0)+, $0(A5,D7.W)
3D12   5447                      AddQ      $2, D7
3D14   5542                      SubQ.L    $2, D2
3D16   6F16                      BLE       L703
3D18   0C47 0200                 Cmp       $200, D7
3D1C   65F0                      BCS       L701
3D1E   6100 093C                 Bsr       P168
3D22   6606                      BNE       L702
3D24   5243                      AddQ      $1, D3
3D26   4287                      Clr.L     D7
3D28   60E4                      Bra       L701
3D2A   6000 FC28      L702:      Bra       L649
3D2E   0C47 0200      L703:      Cmp       $200, D7
3D32   6508                      BCS       L704
3D34   4275 7000                 Clr       $0(A5,D7.W)
3D38   5447                      AddQ      $2, D7
3D3A   60F2                      Bra       L703
3D3C   6100 091E      L704:      Bsr       P168
3D40   66E8                      BNE       L702
3D42   422A 0006      L705:      Clr.B     $6(A2)
3D46   4A38 0346                 Tst.B     (FlushOnly)
3D4A   6624                      BNE       L708
3D4C   4A6A 0048                 Tst       $48(A2)
3D50   6708                      BEQ       L706
3D52   6100 FD36                 Bsr       P125
3D56   6100 FD3C                 Bsr       P126
3D5A   204A           L706:      Move.L    A2, A0
3D5C   43F8 0356                 Lea.L     (VCBQHdr_Flags), A1
3D60   4EBA CDE2                 Jsr       P14
3D64   B5F8 0352                 CmpA.L    (DefVCBPtr), A2
3D68   6604                      BNE       L707
3D6A   42B8 0352                 Clr.L     (DefVCBPtr)
3D6E   A01F           L707:      _DisposePtr
3D70   7000           L708:      MoveQ.L   $0, D0
3D72   60B6                      Bra       L702

                      P131:
3D74   302A 004C                 Move      $4C(A2), D0
3D78   6702                      BEQ       L709
3D7A   70C6                      MoveQ.L   $-3A, D0
3D7C   4E75           L709:      Rts

                      P132:
3D7E   48E7 4080                 MoveM.L   D1/A0, -(A7)
3D82   724E                      MoveQ.L   $4E, D1
3D84   6006                      Bra       L710

                      P133:
3D86   48E7 4080                 MoveM.L   D1/A0, -(A7)
3D8A   7248                      MoveQ.L   $48, D1
3D8C   41F8 0356      L710:      Lea.L     (VCBQHdr_Flags), A0
3D90   6100 FE60                 Bsr       P129
3D94   6608                      BNE       L712
3D96   2448                      Move.L    A0, A2
3D98   4CDF 0102      L711:      MoveM.L   (A7)+, D1/A0
3D9C   4E75                      Rts
3D9E   70DD           L712:      MoveQ.L   $-23, D0
3DA0   60F6                      Bra       L711

                      P134:
3DA2   4AA8 0012                 Tst.L     $12(A0)
3DA6   6628                      BNE       P136

                      P135:
3DA8   3028 0016                 Move      $16(A0), D0
3DAC   6712                      BEQ       L716
3DAE   6B0C                      BMI       L715
3DB0   61D4                      Bsr       P133
3DB2   6606           L713:      BNE       L714
3DB4   21CA 03EE                 Move.L    A2, (ReqstVol)
3DB8   4A40                      Tst       D0
3DBA   4E75           L714:      Rts
3DBC   61C0           L715:      Bsr       P132
3DBE   60F2                      Bra       L713
3DC0   2038 0352      L716:      Move.L    (DefVCBPtr), D0
3DC4   6706                      BEQ       L717
3DC6   2440                      Move.L    D0, A2
3DC8   7000                      MoveQ.L   $0, D0
3DCA   60E6                      Bra       L713
3DCC   70CE           L717:      MoveQ.L   $-32, D0
3DCE   4E75                      Rts

                      P136:
3DD0   2428 0012                 Move.L    $12(A0), D2

                      P137:
3DD4   48E7 0ED2                 MoveM.L   D4-D6/A0-A1/A3/A6, -(A7)
3DD8   6722                      BEQ       L720
3DDA   2842                      Move.L    D2, A4
3DDC   7400                      MoveQ.L   $0, D2
3DDE   141C                      Move.B    (A4)+, D2
3DE0   2602                      Move.L    D2, D3
3DE2   6718                      BEQ       L720
3DE4   1834 30FF      L718:      Move.B    $-1(A4,D3.W), D4
3DE8   0C04 003A                 Cmp.B     $3A, D4
3DEC   6712                      BEQ       L721
3DEE   5343                      SubQ.L    $1, D3
3DF0   66F2                      BNE       L718
3DF2   61B4                      Bsr       P135
3DF4   4CDF 4B70      L719:      MoveM.L   (A7)+, D4-D6/A0-A1/A3/A6
3DF8   4A40                      Tst       D0
3DFA   4E75                      Rts
3DFC   70DB           L720:      MoveQ.L   $-25, D0
3DFE   60F4                      Bra       L719
3E00   9483           L721:      Sub.L     D3, D2
3E02   224C                      Move.L    A4, A1
3E04   D9C3                      AddA.L    D3, A4
3E06   5343                      SubQ.L    $1, D3
3E08   2038 0358                 Move.L    (VCBQHdr.Head), D0
3E0C   671C           L722:      BEQ       L724
3E0E   2440                      Move.L    D0, A2
3E10   41EA 002C                 Lea.L     $2C(A2), A0
3E14   7000                      MoveQ.L   $0, D0
3E16   1018                      Move.B    (A0)+, D0
3E18   4840                      Swap      D0
3E1A   3003                      Move      D3, D0
3E1C   A03C                      _CmpString
3E1E   6606                      BNE       L723
3E20   21CA 03EE                 Move.L    A2, (ReqstVol)
3E24   60CE                      Bra       L719
3E26   2012           L723:      Move.L    (A2), D0
3E28   66E2                      BNE       L722
3E2A   70DD           L724:      MoveQ.L   $-23, D0
3E2C   60C6                      Bra       L719

                      P_tSetVol:
3E2E   6100 FAA8                 Bsr       P123
3E32   6100 FF6E                 Bsr       P134
3E36   6604                      BNE       L725
3E38   21CA 0352                 Move.L    A2, (DefVCBPtr)
3E3C   6000 FB16      L725:      Bra       L649

                      P_tGetVol:
3E40   6100 FA96                 Bsr       P123
3E44   2238 0352                 Move.L    (DefVCBPtr), D1
3E48   6708                      BEQ       L727
3E4A   2441                      Move.L    D1, A2
3E4C   6108                      Bsr       P138
3E4E   6000 FB04      L726:      Bra       L649
3E52   70DD           L727:      MoveQ.L   $-23, D0
3E54   60F8                      Bra       L726

                      P138:
3E56   316A 004E 0016            Move      $4E(A2), $16(A0)
3E5C   45EA 002C                 Lea.L     $2C(A2), A2
3E60   2028 0012                 Move.L    $12(A0), D0
3E64   670A                      BEQ       L729
3E66   2240                      Move.L    D0, A1
3E68   1012                      Move.B    (A2), D0
3E6A   12DA           L728:      Move.B    (A2)+, (A1)+
3E6C   5300                      SubQ.L    $1, D0
3E6E   64FA                      BCC       L728
3E70   7000           L729:      MoveQ.L   $0, D0
3E72   4E75                      Rts

                      P_tGetVolInfo:
3E74   6100 FA62                 Bsr       P123
3E78   3428 001C                 Move      $1C(A0), D2
3E7C   6E10                      BGT       L732
3E7E   6706                      BEQ       L730
3E80   6100 FF20                 Bsr       P134
3E84   6004                      Bra       L731
3E86   6100 FF20      L730:      Bsr       P135
3E8A   6638           L731:      BNE       L738
3E8C   6010                      Bra       L734
3E8E   2238 0358      L732:      Move.L    (VCBQHdr.Head), D1
3E92   67BE           L733:      BEQ       L727
3E94   5342                      SubQ.L    $1, D2
3E96   2441                      Move.L    D1, A2
3E98   6704                      BEQ       L734
3E9A   2212                      Move.L    (A2), D1
3E9C   60F4                      Bra       L733
3E9E   08EA 0006 0013 L734:      BSet.B    $6, $13(A2)
3EA4   6136                      Bsr       P140
3EA6   B5F1 1014      L735:      CmpA.L    $14(A1,D1.W), A2
3EAA   670A                      BEQ       L736
3EAC   6136                      Bsr       P141
3EAE   65F6                      BCS       L735
3EB0   08AA 0006 0013            BClr.B    $6, $13(A2)
3EB6   7020           L736:      MoveQ.L   $20, D0
3EB8   31B2 000A 001E L737:      Move      $A(A2,D0.W), $1E(A0,D0.W)
3EBE   5540                      SubQ.L    $2, D0
3EC0   6AF6                      BPL       L737
3EC2   6192                      Bsr       P138
3EC4   6000 FA8E      L738:      Bra       L649

                      P139:
3EC8   70D2                      MoveQ.L   $-2E, D0
3ECA   4A6A 0012                 Tst       $12(A2)
3ECE   6B0A                      BMI       L739
3ED0   70D4                      MoveQ.L   $-2C, D0
3ED2   4A2A 0013                 Tst.B     $13(A2)
3ED6   6B02                      BMI       L739
3ED8   7000                      MoveQ.L   $0, D0
3EDA   4E75           L739:      Rts

                      P140:
3EDC   2278 034E                 Move.L    (FCBSPtr), A1
3EE0   7202                      MoveQ.L   $2, D1
3EE2   4E75                      Rts

                      P141:
3EE4   0641 001E                 Add       $1E, D1
3EE8   B251                      Cmp       (A1), D1
3EEA   4E75                      Rts

                      P142:
3EEC   61EE                      Bsr       P140
3EEE   B4B1 1000      L740:      Cmp.L     $0(A1,D1.W), D2
3EF2   6606                      BNE       P143
3EF4   B5F1 1014                 CmpA.L    $14(A1,D1.W), A2
3EF8   6708                      BEQ       L741

                      P143:
3EFA   61E8                      Bsr       P141
3EFC   65F0                      BCS       L740
3EFE   44FC 0000                 Move      $0, CCR
3F02   4E75           L741:      Rts

                      P_tOpenRF:
3F04   6100 F9D2                 Bsr       P123
3F08   4238 0347                 Clr.B     (RegRsrc)
3F0C   6008                      Bra       L743
3F0E   6100 F9C8      L742:      Bsr       P123
3F12   50F8 0347                 ST.B      (RegRsrc)
3F16   61C4           L743:      Bsr       P140
3F18   4AB1 1000      L744:      Tst.L     $0(A1,D1.W)
3F1C   670E                      BEQ       L747
3F1E   61C4                      Bsr       P141
3F20   65F6                      BCS       L744
3F22   70D6                      MoveQ.L   $-2A, D0
3F24   4268 0018      L745:      Clr       $18(A0)
3F28   6000 FA2A      L746:      Bra       L649
3F2C   3141 0018      L747:      Move      D1, $18(A0)
3F30   D289                      Add.L     A1, D1
3F32   6100 03E4                 Bsr       P157
3F36   66EC                      BNE       L745
3F38   2641                      Move.L    D1, A3
3F3A   3E29 FFFE                 Move      $-2(A1), D7
3F3E   0887 000F                 BClr.B    $F, D7
3F42   3615                      Move      (A5), D3
3F44   0243 01FF                 And       $1FF, D3
3F48   2028 001C                 Move.L    $1C(A0), D0
3F4C   2840                      Move.L    D0, A4
3F4E   6704                      BEQ       L748
3F50   508C                      AddQ      $8, A4
3F52   425C                      Clr       (A4)+
3F54   4BED 0012      L748:      Lea.L     $12(A5), A5
3F58   241D                      Move.L    (A5)+, D2
3F5A   381D                      Move      (A5)+, D4
3F5C   2A1D                      Move.L    (A5)+, D5
3F5E   2C1D                      Move.L    (A5)+, D6
3F60   4A38 0347                 Tst.B     (RegRsrc)
3F64   660A                      BNE       L749
3F66   08C3 0009                 BSet.B    $9, D3
3F6A   381D                      Move      (A5)+, D4
3F6C   2A1D                      Move.L    (A5)+, D5
3F6E   2C1D                      Move.L    (A5)+, D6
3F70   0C28 0001 001B L749:      Cmp.B     $1, $1B(A0)
3F76   6606                      BNE       L750
3F78   0883 0008                 BClr.B    $8, D3
3F7C   6028                      Bra       L753
3F7E   70CA           L750:      MoveQ.L   $-36, D0
3F80   0843 0008                 BChg.B    $8, D3
3F84   669E                      BNE       L745
3F86   6100 FF64                 Bsr       P142
3F8A   661A                      BNE       L753
3F8C   3031 1004      L751:      Move      $4(A1,D1.W), D0
3F90   B740                      Eor       D3, D0
3F92   0240 0300                 And       $300, D0
3F96   6608                      BNE       L752
3F98   3141 0018                 Move      D1, $18(A0)
3F9C   70CF                      MoveQ.L   $-31, D0
3F9E   6088                      Bra       L746
3FA0   6100 FF58      L752:      Bsr       P143
3FA4   67E6                      BEQ       L751
3FA6   26C2           L753:      Move.L    D2, (A3)+
3FA8   36C3                      Move      D3, (A3)+
3FAA   36C4                      Move      D4, (A3)+
3FAC   26C5                      Move.L    D5, (A3)+
3FAE   26C6                      Move.L    D6, (A3)+
3FB0   429B                      Clr.L     (A3)+
3FB2   26CA                      Move.L    A2, (A3)+
3FB4   26CC                      Move.L    A4, (A3)+
3FB6   3687                      Move      D7, (A3)
3FB8   7000                      MoveQ.L   $0, D0
3FBA   6012                      Bra       L755

                      P_tCreate:
3FBC   6100 F91A                 Bsr       P123
3FC0   6100 0356                 Bsr       P157
3FC4   6602                      BNE       L754
3FC6   70D0                      MoveQ.L   $-30, D0
3FC8   0C40 FFD5      L754:      Cmp       $-2B, D0
3FCC   6704                      BEQ       L756
3FCE   6000 F984      L755:      Bra       L649
3FD2   70DB           L756:      MoveQ.L   $-25, D0
3FD4   4A42                      Tst       D2
3FD6   67F6                      BEQ       L755
3FD8   6100 FEEE                 Bsr       P139
3FDC   66F0                      BNE       L755
3FDE   6140                      Bsr       P144
3FE0   66EC                      BNE       L755
3FE2   3005                      Move      D5, D0
3FE4   224D                      Move.L    A5, A1
3FE6   4259           L757:      Clr       (A1)+
3FE8   5540                      SubQ.L    $2, D0
3FEA   62FA                      BHI       L757
3FEC   08D5 0007                 BSet.B    $7, (A5)
3FF0   1B68 001A 0001            Move.B    $1A(A0), $1(A5)
3FF6   2B6A 0026 0012            Move.L    $26(A2), $12(A5)
3FFC   52AA 0026                 AddQ      $1, $26(A2)
4000   4BED 002A                 Lea.L     $2A(A5), A5
4004   2AB8 020C                 Move.L    (Time), (A5)
4008   2ADD                      Move.L    (A5)+, (A5)+
400A   1AC2                      Move.B    D2, (A5)+
400C   6706                      BEQ       L759
400E   1ADC           L758:      Move.B    (A4)+, (A5)+
4010   5302                      SubQ.L    $1, D2
4012   62FA                      BHI       L758
4014   50EA 0006      L759:      ST.B      $6(A2)
4018   526A 0014                 AddQ      $1, $14(A2)
401C   7000                      MoveQ.L   $0, D0
401E   60AE                      Bra       L755

                      P144:
4020   265F                      Move.L    (A7)+, A3
4022   7A34                      MoveQ.L   $34, D5
4024   DA42                      Add       D2, D5
4026   0885 0000                 BClr.B    $0, D5
402A   6100 029A                 Bsr       P153
402E   6004                      Bra       L761
4030   6100 02BC      L760:      Bsr       P154
4034   6626           L761:      BNE       L764
4036   7000                      MoveQ.L   $0, D0
4038   4A35 0000      L762:      Tst.B     $0(A5,D0.W)
403C   6704                      BEQ       L763
403E   611E                      Bsr       P145
4040   65F6                      BCS       L762
4042   3800           L763:      Move      D0, D4
4044   D845                      Add       D5, D4
4046   0C44 0200                 Cmp       $200, D4
404A   64E4                      BCC       L760
404C   08ED 0007 FFFE            BSet.B    $7, $-2(A5)
4052   4BF5 0000                 Lea.L     $0(A5,D0.W), A5
4056   42AA 005A                 Clr.L     $5A(A2)
405A   7000                      MoveQ.L   $0, D0
405C   4ED3           L764:      Jmp       (A3)

                      P145:
405E   7C00                      MoveQ.L   $0, D6
4060   1C35 0032                 Move.B    $32(A5,D0.W), D6
4064   D046                      Add       D6, D0
4066   0640 0034                 Add       $34, D0
406A   0880 0000                 BClr.B    $0, D0
406E   0C40 01CC                 Cmp       $1CC, D0
4072   4E75                      Rts

                      P146:
4074   2F09                      Move.L    A1, -(A7)
4076   242D 0012                 Move.L    $12(A5), D2
407A   6100 FE70                 Bsr       P142
407E   6706                      BEQ       L766
4080   7000                      MoveQ.L   $0, D0
4082   225F           L765:      Move.L    (A7)+, A1
4084   4E75                      Rts
4086   3141 0018      L766:      Move      D1, $18(A0)
408A   70D1                      MoveQ.L   $-2F, D0
408C   60F4                      Bra       L765

                      P_tDelete:
408E   6100 F848                 Bsr       P123
4092   6100 021E                 Bsr       P152
4096   70D3                      MoveQ.L   $-2D, D0
4098   0815 0000                 BTst.B    $0, (A5)
409C   6620                      BNE       L767
409E   61D4                      Bsr       P146
40A0   661C                      BNE       L767
40A2   536A 0014                 SubQ.L    $1, $14(A2)
40A6   50EA 0006                 ST.B      $6(A2)
40AA   362D 0016                 Move      $16(A5), D3
40AE   6100 0A74                 Bsr       P185
40B2   362D 0020                 Move      $20(A5), D3
40B6   6100 0A6C                 Bsr       P185
40BA   6116                      Bsr       P148
40BC   7000                      MoveQ.L   $0, D0
40BE   6000 F894      L767:      Bra       L649

                      P147:
40C2   7000                      MoveQ.L   $0, D0
40C4   102D 0032                 Move.B    $32(A5), D0
40C8   0640 0034                 Add       $34, D0
40CC   0880 0000                 BClr.B    $0, D0
40D0   4E75                      Rts

                      P148:
40D2   48E7 80C4                 MoveM.L   D0/A0-A1/A5, -(A7)
40D6   08E9 0007 FFFE            BSet.B    $7, $-2(A1)
40DC   42AA 005A                 Clr.L     $5A(A2)
40E0   204D                      Move.L    A5, A0
40E2   61DE                      Bsr       P147
40E4   DBC0                      AddA.L    D0, A5
40E6   D2FC 0200                 AddA      $200, A1
40EA   BBC9           L768:      CmpA.L    A1, A5
40EC   6404                      BCC       L769
40EE   30DD                      Move      (A5)+, (A0)+
40F0   60F8                      Bra       L768
40F2   4258           L769:      Clr       (A0)+
40F4   B1C9                      CmpA.L    A1, A0
40F6   65FA                      BCS       L769
40F8   4CDF 2301                 MoveM.L   (A7)+, D0/A0-A1/A5
40FC   4E75                      Rts

                      P149:
40FE   610E                      Bsr       P150
4100   3038 03A2      L770:      Move      (ErCode), D0
4104   2A78 03DE                 Move.L    (FSTemp4), A5
4108   264D                      Move.L    A5, A3
410A   6EF4                      BGT       L770
410C   4E75                      Rts

                      P150:
410E   31FC 0001 03A2            Move      $1, (ErCode)
4114   6100 FF0A                 Bsr       P144
4118   31C0 03A2                 Move      D0, (ErCode)
411C   21CD 03DE                 Move.L    A5, (FSTemp4)
4120   4E75                      Rts

                      P_tRename:
4122   6100 F7B4                 Bsr       P123
4126   2428 001C                 Move.L    $1C(A0), D2
412A   6100 FCA8                 Bsr       P137
412E   6600 00CA                 BNE       L785
4132   4A42                      Tst       D2
4134   6700 00D0                 BEQ       L786
4138   224A                      Move.L    A2, A1
413A   3E03                      Move      D3, D7
413C   48F8 1004 03D6            MoveM.L   D2/A4, (FSTemp8)
4142   6100 FC8C                 Bsr       P136
4146   660A                      BNE       L772
4148   B5C9                      CmpA.L    A1, A2
414A   670A                      BEQ       L773
414C   4A47                      Tst       D7
414E   6706                      BEQ       L773
4150   70DB           L771:      MoveQ.L   $-25, D0
4152   6000 F800      L772:      Bra       L649
4156   6100 FD70      L773:      Bsr       P139
415A   66F6                      BNE       L772
415C   2F08                      Move.L    A0, -(A7)
415E   3002                      Move      D2, D0
4160   204C                      Move.L    A4, A0
4162   4CF8 1004 03D6            MoveM.L   (FSTemp8), D2/A4
4168   4840                      Swap      D0
416A   3002                      Move      D2, D0
416C   224C                      Move.L    A4, A1
416E   A03C                      _CmpString
4170   205F                      Move.L    (A7)+, A0
4172   670E                      BEQ       L775
4174   6100 01AA                 Bsr       P158
4178   6602                      BNE       L774
417A   70D0                      MoveQ.L   $-30, D0
417C   0C40 FFD5      L774:      Cmp       $-2B, D0
4180   66D0                      BNE       L772
4182   6100 0194      L775:      Bsr       P157
4186   66CA                      BNE       L772
4188   284F                      Move.L    A7, A4
418A   264D                      Move.L    A5, A3
418C   6100 FF34                 Bsr       P147
4190   3F33 00FE      L776:      Move      $-2(A3,D0.W), -(A7)
4194   5540                      SubQ.L    $2, D0
4196   6EF8                      BGT       L776
4198   6100 FF38                 Bsr       P148
419C   2438 03D6                 Move.L    (FSTemp8), D2
41A0   6100 FF5C                 Bsr       P149
41A4   661E                      BNE       L781
41A6   7018                      MoveQ.L   $18, D0
41A8   3ADF           L777:      Move      (A7)+, (A5)+
41AA   51C8 FFFC                 DBF       D0, L777
41AE   2E4C                      Move.L    A4, A7
41B0   4CF8 1004 03D6            MoveM.L   (FSTemp8), D2/A4
41B6   1AC2                      Move.B    D2, (A5)+
41B8   1ADC           L778:      Move.B    (A4)+, (A5)+
41BA   5342                      SubQ.L    $1, D2
41BC   6EFA                      BGT       L778
41BE   6120                      Bsr       P151
41C0   7000           L779:      MoveQ.L   $0, D0
41C2   608E           L780:      Bra       L772
41C4   142F 0032      L781:      Move.B    $32(A7), D2
41C8   6100 FF34                 Bsr       P149
41CC   6706                      BEQ       L782
41CE   2E4C                      Move.L    A4, A7
41D0   70C5                      MoveQ.L   $-3B, D0
41D2   60EE                      Bra       L780
41D4   3ADF           L782:      Move      (A7)+, (A5)+
41D6   B9CF                      CmpA.L    A7, A4
41D8   66FA                      BNE       L782
41DA   6104                      Bsr       P151
41DC   70DF                      MoveQ.L   $-21, D0
41DE   60E2                      Bra       L780

                      P151:
41E0   242B 0012                 Move.L    $12(A3), D2
41E4   6100 0124                 Bsr       P155
41E8   6100 FD02                 Bsr       P142
41EC   660A                      BNE       L784
41EE   3380 101C      L783:      Move      D0, $1C(A1,D1.W)
41F2   6100 FD06                 Bsr       P143
41F6   67F6                      BEQ       L783
41F8   4E75           L784:      Rts
41FA   0C40 FFDD      L785:      Cmp       $-23, D0
41FE   66C2                      BNE       L780
4200   4A42                      Tst       D2
4202   6600 FF4C                 BNE       L771
4206   4A43           L786:      Tst       D3
4208   67B8                      BEQ       L780
420A   6100 FBC4                 Bsr       P136
420E   66B2                      BNE       L780
4210   6100 FCB6                 Bsr       P139
4214   66AC                      BNE       L780
4216   4A6A 0048                 Tst       $48(A2)
421A   67A6                      BEQ       L780
421C   50EA 0006                 ST.B      $6(A2)
4220   45EA 002C                 Lea.L     $2C(A2), A2
4224   2268 001C                 Move.L    $1C(A0), A1
4228   1019                      Move.B    (A1)+, D0
422A   5300                      SubQ.L    $1, D0
422C   0C00 001B                 Cmp.B     $1B, D0
4230   6302                      BLS       L787
4232   701B                      MoveQ.L   $1B, D0
4234   14C0           L787:      Move.B    D0, (A2)+
4236   14D9           L788:      Move.B    (A1)+, (A2)+
4238   5300                      SubQ.L    $1, D0
423A   62FA                      BHI       L788
423C   6082                      Bra       L779

                      P_tSetFilType:
423E   6100 F698                 Bsr       P123
4242   1228 001A                 Move.B    $1A(A0), D1
4246   1168 001C 001A            Move.B    $1C(A0), $1A(A0)
424C   6100 00CA                 Bsr       P157
4250   6602                      BNE       L789
4252   70D0                      MoveQ.L   $-30, D0
4254   1141 001A      L789:      Move.B    D1, $1A(A0)
4258   0C40 FFD5                 Cmp       $-2B, D0
425C   663C                      BNE       L794
425E   6152                      Bsr       P152
4260   1B68 001C 0001            Move.B    $1C(A0), $1(A5)
4266   6000 002A                 Bra       L792

                      P_tSetFilLock:
426A   6100 F66C                 Bsr       P123
426E   50F8 0348                 ST.B      (FLckUnlck)
4272   6008                      Bra       L790

                      P_tRstFilLock:
4274   6100 F662                 Bsr       P123
4278   4238 0348                 Clr.B     (FLckUnlck)
427C   6134           L790:      Bsr       P152
427E   4A38 0348                 Tst.B     (FLckUnlck)
4282   6708                      BEQ       L791
4284   08D5 0000                 BSet.B    $0, (A5)
4288   660E                      BNE       L793
428A   6006                      Bra       L792
428C   0895 0000      L791:      BClr.B    $0, (A5)
4290   6706                      BEQ       L793
4292   08E9 0007 FFFE L792:      BSet.B    $7, $-2(A1)
4298   7000           L793:      MoveQ.L   $0, D0
429A   6000 F6B8      L794:      Bra       L649

                      P_tSetFileInfo:
429E   6100 F638                 Bsr       P123
42A2   610E                      Bsr       P152
42A4   4CE8 001E 0020            MoveM.L   $20(A0), D1-D4
42AA   48ED 001E 0002            MoveM.L   D1-D4, $2(A5)
42B0   60E0                      Bra       L792

                      P152:
42B2   21DF 03DE                 Move.L    (A7)+, (FSTemp4)
42B6   6160                      Bsr       P157
42B8   66E0                      BNE       L794
42BA   6100 FC0C                 Bsr       P139
42BE   66DA                      BNE       L794
42C0   2678 03DE                 Move.L    (FSTemp4), A3
42C4   4ED3                      Jmp       (A3)

                      P153:
42C6   382A 0018                 Move      $18(A2), D4
42CA   362A 0016                 Move      $16(A2), D3
42CE   D843                      Add       D3, D4
42D0   6138                      Bsr       P155
42D2   B043                      Cmp       D3, D0
42D4   6504                      BCS       L795
42D6   B044                      Cmp       D4, D0
42D8   6502                      BCS       L796
42DA   7000           L795:      MoveQ.L   $0, D0
42DC   31C3 0342      L796:      Move      D3, (NxtDB)
42E0   31C4 0344                 Move      D4, (MaxDB)
42E4   31C0 0340                 Move      D0, (CkdDB)
42E8   6704                      BEQ       P154
42EA   7000                      MoveQ.L   $0, D0
42EC   4E75                      Rts

                      P154:
42EE   3638 0342                 Move      (NxtDB), D3
42F2   5278 0342                 AddQ      $1, (NxtDB)
42F6   B678 0344                 Cmp       (MaxDB), D3
42FA   640A                      BCC       L797
42FC   B678 0340                 Cmp       (CkdDB), D3
4300   67EC                      BEQ       P154
4302   6000 0290                 Bra       P163
4306   70DF           L797:      MoveQ.L   $-21, D0
4308   4E75                      Rts

                      P155:
430A   2A6A 0054                 Move.L    $54(A2), A5

                      P156:
430E   302D FFFE                 Move      $-2(A5), D0
4312   0240 7FFF                 And       $7FFF, D0
4316   4E75                      Rts

                      P157:
4318   6100 FAB6                 Bsr       P136
431C   6702                      BEQ       P158
431E   4E75           L798:      Rts

                      P158:
4320   615C                      Bsr       P159
4322   66FA                      BNE       L798
4324   265F                      Move.L    (A7)+, A3
4326   3E2A 0014                 Move      $14(A2), D7
432A   670A                      BEQ       L800
432C   6198                      Bsr       P153
432E   670A           L799:      BEQ       L801
4330   0C40 FFDF                 Cmp       $-21, D0
4334   6646                      BNE       L806
4336   70D5           L800:      MoveQ.L   $-2B, D0
4338   6042                      Bra       L806
433A   7000           L801:      MoveQ.L   $0, D0
433C   224C                      Move.L    A4, A1
433E   3800           L802:      Move      D0, D4
4340   4A35 4000                 Tst.B     $0(A5,D4.W)
4344   672A                      BEQ       L804
4346   1C35 4001                 Move.B    $1(A5,D4.W), D6
434A   BC28 001A                 Cmp.B     $1A(A0), D6
434E   6614                      BNE       L803
4350   2F08                      Move.L    A0, -(A7)
4352   41F5 4032                 Lea.L     $32(A5,D4.W), A0
4356   7000                      MoveQ.L   $0, D0
4358   1018                      Move.B    (A0)+, D0
435A   4840                      Swap      D0
435C   3002                      Move      D2, D0
435E   A03C                      _CmpString
4360   205F                      Move.L    (A7)+, A0
4362   6712                      BEQ       L805
4364   5347           L803:      SubQ.L    $1, D7
4366   67CE                      BEQ       L800
4368   3004                      Move      D4, D0
436A   6100 FCF2                 Bsr       P145
436E   65CE                      BCS       L802
4370   6100 FF7C      L804:      Bsr       P154
4374   60B8                      Bra       L799
4376   224D           L805:      Move.L    A5, A1
4378   4BF5 4000                 Lea.L     $0(A5,D4.W), A5
437C   4ED3           L806:      Jmp       (A3)

                      P159:
437E   6100 F9F4                 Bsr       P131
4382   6608                      BNE       L807
4384   4A6A 0048                 Tst       $48(A2)
4388   6602                      BNE       L807
438A   70CB                      MoveQ.L   $-35, D0
438C   4A40           L807:      Tst       D0
438E   4E75                      Rts

                      P_tGetFileInfo:
4390   6100 F546                 Bsr       P123
4394   3228 001C                 Move      $1C(A0), D1
4398   6608                      BNE       L808
439A   6100 FF7C                 Bsr       P157
439E   665C                      BNE       L814
43A0   6076                      Bra       L817
43A2   6100 FA04      L808:      Bsr       P135
43A6   6654                      BNE       L814
43A8   61D4                      Bsr       P159
43AA   6650                      BNE       L814
43AC   B26A 0014                 Cmp       $14(A2), D1
43B0   6248                      BHI       L813
43B2   3A2A 0018                 Move      $18(A2), D5
43B6   362A 0016                 Move      $16(A2), D3
43BA   DA43                      Add       D3, D5
43BC   3E2A 005A                 Move      $5A(A2), D7
43C0   670A                      BEQ       L809
43C2   B247                      Cmp       D7, D1
43C4   6506                      BCS       L809
43C6   362A 005C                 Move      $5C(A2), D3
43CA   6002                      Bra       L810
43CC   7E01           L809:      MoveQ.L   $1, D7
43CE   B645           L810:      Cmp       D5, D3
43D0   6428                      BCC       L813
43D2   3543 005C                 Move      D3, $5C(A2)
43D6   3547 005A                 Move      D7, $5A(A2)
43DA   6100 01B8                 Bsr       P163
43DE   661A                      BNE       L813
43E0   7000                      MoveQ.L   $0, D0
43E2   7C00           L811:      MoveQ.L   $0, D6
43E4   4A35 0000                 Tst.B     $0(A5,D0.W)
43E8   670C                      BEQ       L812
43EA   B247                      Cmp       D7, D1
43EC   6712                      BEQ       L815
43EE   5247                      AddQ      $1, D7
43F0   6100 FC6C                 Bsr       P145
43F4   65EC                      BCS       L811
43F6   5243           L812:      AddQ      $1, D3
43F8   60D4                      Bra       L810
43FA   70D5           L813:      MoveQ.L   $-2B, D0
43FC   6000 F556      L814:      Bra       L649
4400   4BF5 0000      L815:      Lea.L     $0(A5,D0.W), A5
4404   47ED 0032                 Lea.L     $32(A5), A3
4408   2028 0012                 Move.L    $12(A0), D0
440C   670A                      BEQ       L817
440E   2840                      Move.L    D0, A4
4410   1013                      Move.B    (A3), D0
4412   18DB           L816:      Move.B    (A3)+, (A4)+
4414   5300                      SubQ.L    $1, D0
4416   64FA                      BCC       L816
4418   49E8 001E      L817:      Lea.L     $1E(A0), A4
441C   7018                      MoveQ.L   $18, D0
441E   47D5                      Lea.L     (A5), A3
4420   38DB           L818:      Move      (A3)+, (A4)+
4422   51C8 FFFC                 DBF       D0, L818
4426   6100 FC4C                 Bsr       P146
442A   660A                      BNE       L820
442C   08A8 0007 001E            BClr.B    $7, $1E(A0)
4432   7000           L819:      MoveQ.L   $0, D0
4434   60C6                      Bra       L814
4436   47E8 0034      L820:      Lea.L     $34(A0), A3
443A   2278 034E                 Move.L    (FCBSPtr), A1
443E   6100 03E4                 Bsr       P175
4442   6100 FAB6                 Bsr       P143
4446   67EE                      BEQ       L820
4448   60E8                      Bra       L819

                      P160:
444A   42A8 0028                 Clr.L     $28(A0)
444E   70CE                      MoveQ.L   $-32, D0
4450   2E28 0024                 Move.L    $24(A0), D7
4454   6B34                      BMI       L826
4456   2428 002E                 Move.L    $2E(A0), D2
445A   2A31 1010                 Move.L    $10(A1,D1.W), D5
445E   2831 1008                 Move.L    $8(A1,D1.W), D4
4462   1028 002D                 Move.B    $2D(A0), D0
4466   E410                      RXR.B     $2, D0
4468   6408                      BCC       L822
446A   6B02                      BMI       L821
446C   2A04                      Move.L    D4, D5
446E   DA82           L821:      Add.L     D2, D5
4470   6004                      Bra       L823
4472   6A02           L822:      BPL       L823
4474   2A02                      Move.L    D2, D5
4476   6A04           L823:      BPL       L824
4478   70D8                      MoveQ.L   $-28, D0
447A   600E                      Bra       L826
447C   2405           L824:      Move.L    D5, D2
447E   9484                      Sub.L     D4, D2
4480   6F02                      BLE       L825
4482   2A04                      Move.L    D4, D5
4484   2385 1010      L825:      Move.L    D5, $10(A1,D1.W)
4488   7000                      MoveQ.L   $0, D0
448A   4E75           L826:      Rts

                      P_tGetFPos:
448C   4228 002D                 Clr.B     $2D(A0)

                      P_tSetFPos:
4490   42A8 0024                 Clr.L     $24(A0)
                      L_mFileRead:
4494   6100 F442                 Bsr       P123
4498   6100 03B6                 Bsr       P_RFNCall
449C   6600 00A0                 BNE       L836
44A0   61A8                      Bsr       P160
44A2   6600 0092                 BNE       L835
44A6   4482                      Neg.L     D2
44A8   6B00 008A                 BMI       L834
44AC   BE82                      Cmp.L     D2, D7
44AE   6F02                      BLE       L828
44B0   2E02                      Move.L    D2, D7
44B2   4A87           L828:      Tst.L     D7
44B4   676E                      BEQ       L832
44B6   3428 002C                 Move      $2C(A0), D2
44BA   E04A                      LsR       $8, D2
44BC   6500 0084                 BCS       L837
44C0   3405                      Move      D5, D2
44C2   0242 01FF                 And       $1FF, D2
44C6   6714                      BEQ       L830
44C8   6100 00C0      L829:      Bsr       P162
44CC   6658                      BNE       L833
44CE   0828 0006 002D            BTst.B    $6, $2D(A0)
44D4   56C0                      SNE.B     D0
44D6   6100 027C                 Bsr       P172
44DA   664A                      BNE       L833
44DC   2807           L830:      Move.L    D7, D4
44DE   6744                      BEQ       L832
44E0   0C84 0000 0200            Cmp.L     $200, D4
44E6   65E0                      BCS       L829
44E8   0244 FE00                 And       $-200, D4
44EC   6100 0478                 Bsr       P_mLg2Phys
44F0   3803                      Move      D3, D4
44F2   6100 02C6                 Bsr       P173
44F6   6A16                      BPL       L831
44F8   B644                      Cmp       D4, D3
44FA   6512                      BCS       L831
44FC   B640                      Cmp       D0, D3
44FE   640E                      BCC       L831
4500   21C6 03DE                 Move.L    D6, (FSTemp4)
4504   6100 015A                 Bsr       P169
4508   661C                      BNE       L833
450A   2C38 03DE                 Move.L    (FSTemp4), D6
450E   3604           L831:      Move      D4, D3
4510   2A68 0020                 Move.L    $20(A0), A5
4514   DBE8 0028                 AddA.L    $28(A0), A5
4518   6100 00E6                 Bsr       P164
451C   6608                      BNE       L833
451E   6100 022A                 Bsr       P171
4522   60B8                      Bra       L830
4524   7000           L832:      MoveQ.L   $0, D0
4526   4A40           L833:      Tst       D0
4528   660C                      BNE       L835
452A   2428 0028                 Move.L    $28(A0), D2
452E   B4A8 0024                 Cmp.L     $24(A0), D2
4532   6702                      BEQ       L835
4534   70D9           L834:      MoveQ.L   $-27, D0
4536   2385 1010      L835:      Move.L    D5, $10(A1,D1.W)
453A   2145 002E                 Move.L    D5, $2E(A0)
453E   6000 F414      L836:      Bra       L649
4542   6100 0046      L837:      Bsr       P162
4546   66DE                      BNE       L833
4548   2405                      Move.L    D5, D2
454A   0242 01FF                 And       $1FF, D2
454E   2668 0020                 Move.L    $20(A0), A3
4552   2828 0028                 Move.L    $28(A0), D4
4556   1035 2000      L838:      Move.B    $0(A5,D2.W), D0
455A   1780 4800                 Move.B    D0, $0(A3,D4.L)
455E   52A8 0028                 AddQ      $1, $28(A0)
4562   5284                      AddQ      $1, D4
4564   5242                      AddQ      $1, D2
4566   5285                      AddQ      $1, D5
4568   B028 002C                 Cmp.B     $2C(A0), D0
456C   6604                      BNE       L839
456E   7000                      MoveQ.L   $0, D0
4570   60C4                      Bra       L835
4572   5387           L839:      SubQ.L    $1, D7
4574   67AE                      BEQ       L832
4576   B446                      Cmp       D6, D2
4578   65DC                      BCS       L838
457A   60C6                      Bra       L837

                      P161:
457C   2F31 1018                 Move.L    $18(A1,D1.W), -(A7)
4580   6604                      BNE       L840
4582   2EAA 0054                 Move.L    $54(A2), (A7)
4586   2A5F           L840:      Move.L    (A7)+, A5
4588   4E75                      Rts

                      P162:
458A   7801                      MoveQ.L   $1, D4
458C   6100 03D8                 Bsr       P_mLg2Phys
4590   61EA                      Bsr       P161
4592   6004                      Bra       L841

                      P163:
4594   2A6A 0054                 Move.L    $54(A2), A5
4598   7C02           L841:      MoveQ.L   $2, D6
459A   E186                      AsL.L     $8, D6
459C   2C5F                      Move.L    (A7)+, A6
459E   6100 0084                 Bsr       P166
45A2   6100 FD6A                 Bsr       P156
45A6   B640                      Cmp       D0, D3
45A8   660C                      BNE       L844
45AA   7000                      MoveQ.L   $0, D0

                      E_179:
45AC   616E                      Bsr       P165
45AE   4A40           L842:      Tst       D0
45B0   6702                      BEQ       L843
45B2   70DC                      MoveQ.L   $-24, D0
45B4   4ED6           L843:      Jmp       (A6)
45B6   08AD 0007 FFFE L844:      BClr.B    $7, $-2(A5)
45BC   671C                      BEQ       L845
45BE   3600                      Move      D0, D3
45C0   43FA 0014                 Lea.L     E_180, A1
45C4   617E                      Bsr       P167
45C6   4CED 0003 FFF6            MoveM.L   $-A(A5), D0-D1
45CC   48F8 0003 02FC            MoveM.L   D0-D1, (BufTgFNum)
45D2   A403                      _WriteAsync
45D4   4E75                      Rts

                      E_180:
45D6   6144                      Bsr       P165
45D8   66D4                      BNE       L842
45DA   41F8 03A4      L845:      Lea.L     (Params), A0
45DE   43FA 0008                 Lea.L     E_181, A1
45E2   6160                      Bsr       P167
45E4   A402                      _ReadAsync
45E6   4E75                      Rts

                      E_181:
45E8   6132                      Bsr       P165
45EA   6702                      BEQ       L846
45EC   7600                      MoveQ.L   $0, D3
45EE   3B43 FFFE      L846:      Move      D3, $-2(A5)
45F2   2B78 02FC FFF6            Move.L    (BufTgFNum), $-A(A5)
45F8   2B78 0300 FFFA            Move.L    (BufTgFFlg), $-6(A5)
45FE   60AE                      Bra       L842

                      P164:
4600   2C5F                      Move.L    (A7)+, A6
4602   1028 002D                 Move.B    $2D(A0), D0
4606   611C                      Bsr       P166
4608   E308                      LsL.B     $1, D0
460A   6A06                      BPL       L847
460C   08E8 0006 002D            BSet.B    $6, $2D(A0)
4612   43FA FF98      L847:      Lea.L     E_179, A1
4616   612C                      Bsr       P167
4618   A402                      _ReadAsync
461A   4E75                      Rts

                      P165:
461C   4CF8 7FFE 036A            MoveM.L   (RgSvArea), D1-D7/A0-A6
4622   4E75                      Rts

                      P166:
4624   48F8 7FFE 036A            MoveM.L   D1-D7/A0-A6, (RgSvArea)
462A   41F8 03A4                 Lea.L     (Params), A0
462E   316A 004A 0018            Move      $4A(A2), $18(A0)
4634   214D 0020                 Move.L    A5, $20(A0)
4638   2146 0024                 Move.L    D6, $24(A0)
463C   317C 0001 002C            Move      $1, $2C(A0)
4642   4E75                      Rts

                      P167:
4644   2149 000C                 Move.L    A1, $C(A0)
4648   7C00                      MoveQ.L   $0, D6
464A   3C03                      Move      D3, D6
464C   E386                      AsL.L     $1, D6
464E   E186                      AsL.L     $8, D6
4650   2146 002E                 Move.L    D6, $2E(A0)
4654   316A 0048 0016            Move      $48(A2), $16(A0)
465A   4E75                      Rts

                      P168:
465C   2A6A 0054                 Move.L    $54(A2), A5

                      P169:
4660   7C02                      MoveQ.L   $2, D6
4662   E186                      AsL.L     $8, D6
4664   2C5F                      Move.L    (A7)+, A6
4666   61BC                      Bsr       P166
4668   4CED 0003 FFF6            MoveM.L   $-A(A5), D0-D1
466E   48F8 0003 02FC            MoveM.L   D0-D1, (BufTgFNum)
4674   43FA 0008                 Lea.L     E_182, A1
4678   61CA           L848:      Bsr       P167
467A   A403                      _WriteAsync
467C   4E75                      Rts

                      E_182:
467E   619C                      Bsr       P165
4680   3B43 FFFE                 Move      D3, $-2(A5)
4684   6000 FF28                 Bra       L842

                      P170:
4688   2C5F                      Move.L    (A7)+, A6
468A   6198                      Bsr       P166
468C   21F1 1000 02FC            Move.L    $0(A1,D1.W), (BufTgFNum)
4692   31F1 1004 0300            Move      $4(A1,D1.W), (BufTgFFlg)
4698   2005                      Move.L    D5, D0
469A   E088                      LsR.L     $8, D0
469C   E288                      LsR.L     $1, D0
469E   31C0 0302                 Move      D0, (BufTgFBkNum)
46A2   6100 FED8                 Bsr       P161
46A6   6100 FC66                 Bsr       P156
46AA   B043                      Cmp       D3, D0
46AC   650E                      BCS       L849
46AE   E08E                      LsR.L     $8, D6
46B0   E28E                      LsR.L     $1, D6
46B2   DC43                      Add       D3, D6
46B4   B046                      Cmp       D6, D0
46B6   6404                      BCC       L849
46B8   426D FFFE                 Clr       $-2(A5)
46BC   43FA FEEE      L849:      Lea.L     E_179, A1
46C0   60B6                      Bra       L848
                      P_mFileWrite:
46C2   6100 F214                 Bsr       P123
46C6   6100 01B8                 Bsr       P_TstMod
46CA   6600 007A                 BNE       L860
46CE   6100 FD7A                 Bsr       P160
46D2   661A                      BNE       L852
46D4   4A82                      Tst.L     D2
46D6   6B02                      BMI       L851
46D8   DA82                      Add.L     D2, D5
46DA   2805           L851:      Move.L    D5, D4
46DC   D887                      Add.L     D7, D4
46DE   B8B1 1008                 Cmp.L     $8(A1,D1.W), D4
46E2   6314                      BLS       L854
46E4   98B1 100C                 Sub.L     $C(A1,D1.W), D4
46E8   6306                      BLS       L853
46EA   6100 031C                 Bsr       P181
46EE   6650           L852:      BNE       L859
46F0   2805           L853:      Move.L    D5, D4
46F2   D887                      Add.L     D7, D4
46F4   2384 1008                 Move.L    D4, $8(A1,D1.W)
46F8   3005           L854:      Move      D5, D0
46FA   0240 01FF                 And       $1FF, D0
46FE   6710                      BEQ       L856
4700   6100 FE88      L855:      Bsr       P162
4704   6632                      BNE       L858
4706   7001                      MoveQ.L   $1, D0
4708   614A                      Bsr       P172
470A   08ED 0007 FFFE            BSet.B    $7, $-2(A5)
4710   2807           L856:      Move.L    D7, D4
4712   6722                      BEQ       L857
4714   0C84 0000 0200            Cmp.L     $200, D4
471A   65E4                      BCS       L855
471C   0244 FE00                 And       $-200, D4
4720   6100 0244                 Bsr       P_mLg2Phys
4724   2A68 0020                 Move.L    $20(A0), A5
4728   DBE8 0028                 AddA.L    $28(A0), A5
472C   6100 FF5A                 Bsr       P170
4730   6606                      BNE       L858
4732   6116                      Bsr       P171
4734   60DA                      Bra       L856
4736   7000           L857:      MoveQ.L   $0, D0
4738   6100 01F4      L858:      Bsr       P_AdjEof
473C   2385 1010                 Move.L    D5, $10(A1,D1.W)
4740   2171 1010 002E L859:      Move.L    $10(A1,D1.W), $2E(A0)
4746   6000 F20C      L860:      Bra       L649

                      P171:
474A   9E86                      Sub.L     D6, D7
474C   DDA8 0028                 Add.L     D6, $28(A0)
4750   DA86                      Add.L     D6, D5
4752   4E75                      Rts

                      P172:
4754   2405                      Move.L    D5, D2
4756   0242 01FF                 And       $1FF, D2
475A   9C42                      Sub       D2, D6
475C   BE86                      Cmp.L     D6, D7
475E   6402                      BCC       L861
4760   2C07                      Move.L    D7, D6
4762   2668 0020      L861:      Move.L    $20(A0), A3
4766   D7E8 0028                 AddA.L    $28(A0), A3
476A   61DE                      Bsr       P171
476C   48E7 00C0                 MoveM.L   A0-A1, -(A7)
4770   204B                      Move.L    A3, A0
4772   224D                      Move.L    A5, A1
4774   D2C2                      AddA      D2, A1
4776   4A00                      Tst.B     D0
4778   6E04                      BGT       L862
477A   6B0E                      BMI       L865
477C   C149                      Exg.L     A0, A1
477E   2006           L862:      Move.L    D6, D0
4780   A02E                      _BlockMove
4782   7000           L863:      MoveQ.L   $0, D0
4784   4CDF 0300      L864:      MoveM.L   (A7)+, A0-A1
4788   4E75                      Rts
478A   70DC           L865:      MoveQ.L   $-24, D0
478C   B308           L866:      CmpM.B    (A0)+, (A1)+
478E   66F4                      BNE       L864
4790   5346                      SubQ.L    $1, D6
4792   66F8                      BNE       L866
4794   60EC                      Bra       L863

                      P_tFlushFile:
4796   6100 F140                 Bsr       P123
479A   50F8 0346                 ST.B      (FlushOnly)
479E   6008                      Bra       L868
                      P_mFileClose:
47A0   6100 F136                 Bsr       P123
47A4   4238 0346                 Clr.B     (FlushOnly)
47A8   6100 00A6      L868:      Bsr       P_RFNCall
47AC   6706                      BEQ       L869
47AE   0C40 FFCB                 Cmp       $-35, D0
47B2   6602                      BNE       L870
47B4   6112           L869:      Bsr       P174
47B6   6000 F19C      L870:      Bra       L649

                      P173:
47BA   6100 FDC0                 Bsr       P161
47BE   362D FFFE                 Move      $-2(A5), D3
47C2   0883 000F                 BClr.B    $F, D3
47C6   4E75                      Rts

                      P174:
47C8   285F                      Move.L    (A7)+, A4
47CA   08B1 0007 1004            BClr.B    $7, $4(A1,D1.W)
47D0   673C                      BEQ       L874
47D2   61E6                      Bsr       P173
47D4   6A06                      BPL       L871
47D6   6100 FE88                 Bsr       P169
47DA   6646                      BNE       L877
47DC   3631 101C      L871:      Move      $1C(A1,D1.W), D3
47E0   6100 FDB2                 Bsr       P163
47E4   663C                      BNE       L877
47E6   7000                      MoveQ.L   $0, D0
47E8   2631 1000                 Move.L    $0(A1,D1.W), D3
47EC   B6B5 0012      L872:      Cmp.L     $12(A5,D0.W), D3
47F0   670A                      BEQ       L873
47F2   6100 F86A                 Bsr       P145
47F6   65F4                      BCS       L872
47F8   70D5                      MoveQ.L   $-2B, D0
47FA   6026                      Bra       L877
47FC   47F5 0016      L873:      Lea.L     $16(A5,D0.W), A3
4800   6122                      Bsr       P175
4802   2BB8 020C 002E            Move.L    (Time), $2E(A5,D0.W)
4808   08ED 0007 FFFE            BSet.B    $7, $-2(A5)
480E   4A38 0346      L874:      Tst.B     (FlushOnly)
4812   660C                      BNE       L876
4814   47F1 1000                 Lea.L     $0(A1,D1.W), A3
4818   700E                      MoveQ.L   $E, D0
481A   425B           L875:      Clr       (A3)+
481C   51C8 FFFC                 DBF       D0, L875
4820   7000           L876:      MoveQ.L   $0, D0
4822   4ED4           L877:      Jmp       (A4)

                      P175:
4824   2F0C                      Move.L    A4, -(A7)
4826   49F1 1004                 Lea.L     $4(A1,D1.W), A4
482A   361C                      Move      (A4)+, D3
482C   EF4B                      LsL       $7, D3
482E   6404                      BCC       L878
4830   D6FC 000A                 AddA      $A, A3
4834   36DC           L878:      Move      (A4)+, (A3)+
4836   26DC                      Move.L    (A4)+, (A3)+
4838   26DC                      Move.L    (A4)+, (A3)+
483A   285F                      Move.L    (A7)+, A4
483C   4E75                      Rts

                      P_tGetEOF:
483E   6100 F098                 Bsr       P123
4842   610C                      Bsr       P_RFNCall
4844   6606                      BNE       L879
4846   2171 1008 001C            Move.L    $8(A1,D1.W), $1C(A0)
484C   6000 F106      L879:      Bra       L649

                      P_RFNCall:
4850   2278 034E                 Move.L    (FCBSPtr), A1
4854   4281                      Clr.L     D1
4856   3228 0018                 Move      $18(A0), D1
485A   2401                      Move.L    D1, D2
485C   70CD                      MoveQ.L   $-33, D0
485E   84FC 001E                 DivU      $1E, D2
4862   4842                      Swap      D2
4864   5542                      SubQ.L    $2, D2
4866   6614                      BNE       L880
4868   B251                      Cmp       (A1), D1
486A   6410                      BCC       L880
486C   70DA                      MoveQ.L   $-26, D0
486E   2431 1000                 Move.L    $0(A1,D1.W), D2
4872   6708                      BEQ       L880
4874   2471 1014                 Move.L    $14(A1,D1.W), A2
4878   6100 FB04                 Bsr       P159
487C   4A40           L880:      Tst       D0
487E   4E75                      Rts

                      P_TstMod:
4880   61CE                      Bsr       P_RFNCall
4882   660E                      BNE       L881
4884   70C3                      MoveQ.L   $-3D, D0
4886   0831 0000 1004            BTst.B    $0, $4(A1,D1.W)
488C   6704                      BEQ       L881
488E   6100 F638                 Bsr       P139
4892   4A40           L881:      Tst       D0
4894   4E75                      Rts

                      P_tAllocate:
4896   6100 F040                 Bsr       P123
489A   61E4                      Bsr       P_TstMod
489C   661E                      BNE       L882
489E   2828 0024                 Move.L    $24(A0), D4
48A2   7000                      MoveQ.L   $0, D0
48A4   6100 0164                 Bsr       P182
48A8   6612                      BNE       L882
48AA   2146 0028                 Move.L    D6, $28(A0)
48AE   6100 007E                 Bsr       P_AdjEof
48B2   70DE                      MoveQ.L   $-22, D0
48B4   BCA8 0024                 Cmp.L     $24(A0), D6
48B8   6502                      BCS       L882
48BA   7000                      MoveQ.L   $0, D0
48BC   6000 F096      L882:      Bra       L649

                      P_tSetEOF:
48C0   6100 F016                 Bsr       P123
48C4   61BA                      Bsr       P_TstMod
48C6   6620                      BNE       L885
48C8   2E28 001C                 Move.L    $1C(A0), D7
48CC   2807                      Move.L    D7, D4
48CE   98B1 100C                 Sub.L     $C(A1,D1.W), D4
48D2   6518                      BCS       L886
48D4   6250                      BHI       L890
48D6   7000           L883:      MoveQ.L   $0, D0
48D8   2387 1008                 Move.L    D7, $8(A1,D1.W)
48DC   BEB1 1010                 Cmp.L     $10(A1,D1.W), D7
48E0   6404                      BCC       L884
48E2   2387 1010                 Move.L    D7, $10(A1,D1.W)
48E6   6146           L884:      Bsr       P_AdjEof
48E8   6000 F06A      L885:      Bra       L649
48EC   7C00           L886:      MoveQ.L   $0, D6
48EE   3631 1006                 Move      $6(A1,D1.W), D3
48F2   242A 001C                 Move.L    $1C(A2), D2
48F6   2807                      Move.L    D7, D4
48F8   6608                      BNE       L888
48FA   4271 1006                 Clr       $6(A1,D1.W)
48FE   601C                      Bra       L889
4900   3605           L887:      Move      D5, D3
4902   DC82           L888:      Add.L     D2, D6
4904   6100 00D6                 Bsr       P180
4908   9882                      Sub.L     D2, D4
490A   62F4                      BHI       L887
490C   BCB1 100C                 Cmp.L     $C(A1,D1.W), D6
4910   64C4                      BCC       L883
4912   3F05                      Move      D5, -(A7)
4914   7A01                      MoveQ.L   $1, D5
4916   6100 01D4                 Bsr       P184
491A   361F                      Move      (A7)+, D3
491C   6100 0206      L889:      Bsr       P185
4920   2386 100C                 Move.L    D6, $C(A1,D1.W)
4924   60B0                      Bra       L883
4926   6100 00E0      L890:      Bsr       P181
492A   66BC                      BNE       L885
492C   60A8                      Bra       L883

                      P_AdjEof:
492E   48E7 FEE0                 MoveM.L   D0-D6/A0-A2, -(A7)
4932   D2C1                      AddA      D1, A1
4934   2419                      Move.L    (A1)+, D2
4936   08D1 0007                 BSet.B    $7, (A1)
493A   3011                      Move      (A1), D0
493C   4CD9 0478                 MoveM.L   (A1)+, D3-D6/A2
4940   3C00                      Move      D0, D6
4942   6100 F5A8                 Bsr       P142
4946   6618                      BNE       L893
4948   41F1 1004      L891:      Lea.L     $4(A1,D1.W), A0
494C   3018                      Move      (A0)+, D0
494E   BD40                      Eor       D6, D0
4950   EF48                      LsL       $7, D0
4952   6506                      BCS       L892
4954   30C3                      Move      D3, (A0)+
4956   20C4                      Move.L    D4, (A0)+
4958   20C5                      Move.L    D5, (A0)+
495A   6100 F59E      L892:      Bsr       P143
495E   67E8                      BEQ       L891
4960   4CDF 077F      L893:      MoveM.L   (A7)+, D0-D6/A0-A2
4964   4E75                      Rts

                      P_mLg2Phys:
4966   48E7 6D00                 MoveM.L   D1-D2/D4-D5/D7, -(A7)
496A   2E2A 001C                 Move.L    $1C(A2), D7
496E   3631 1006                 Move      $6(A1,D1.W), D3
4972   D885                      Add.L     D5, D4
4974   5384                      SubQ.L    $1, D4
4976   7209                      MoveQ.L   $9, D1
4978   7C00                      MoveQ.L   $0, D6
497A   E2AC                      LsR.L     D1, D4
497C   E2AF                      LsR.L     D1, D7
497E   2405                      Move.L    D5, D2
4980   E2AA                      LsR.L     D1, D2
4982   6008                      Bra       L895
4984   6156           L894:      Bsr       P180
4986   3605                      Move      D5, D3
4988   9847                      Sub       D7, D4
498A   9447                      Sub       D7, D2
498C   B447           L895:      Cmp       D7, D2
498E   64F4                      BCC       L894
4990   3003                      Move      D3, D0
4992   5540                      SubQ.L    $2, D0
4994   C0C7                      MulU      D7, D0
4996   D042                      Add       D2, D0
4998   D06A 0024                 Add       $24(A2), D0
499C   3F00                      Move      D0, -(A7)
499E   3007           L896:      Move      D7, D0
49A0   9042                      Sub       D2, D0
49A2   DC40                      Add       D0, D6
49A4   9840                      Sub       D0, D4
49A6   6B0A                      BMI       L897
49A8   6132                      Bsr       P180
49AA   7400                      MoveQ.L   $0, D2
49AC   5243                      AddQ      $1, D3
49AE   BA43                      Cmp       D3, D5
49B0   67EC                      BEQ       L896
49B2   361F           L897:      Move      (A7)+, D3
49B4   3003                      Move      D3, D0
49B6   D046                      Add       D6, D0
49B8   382A 0024                 Move      $24(A2), D4
49BC   CEEA 001A                 MulU      $1A(A2), D7
49C0   DE44                      Add       D4, D7
49C2   B047                      Cmp       D7, D0
49C4   6212                      BHI       L899
49C6   B644                      Cmp       D4, D3
49C8   650E                      BCS       L899
49CA   E3A6                      AsL.L     D1, D6
49CC   4CDF 00B6                 MoveM.L   (A7)+, D1-D2/D4-D5/D7
49D0   BC84                      Cmp.L     D4, D6
49D2   6302                      BLS       L898
49D4   2C04                      Move.L    D4, D6
49D6   4E75           L898:      Rts
49D8   701B           L899:      MoveQ.L   $1B, D0
49DA   A9C9                      _SysError

                      P180:
49DC   48E7 8020                 MoveM.L   D0/A2, -(A7)
49E0   246A 0050                 Move.L    $50(A2), A2
49E4   3003                      Move      D3, D0
49E6   5540                      SubQ.L    $2, D0
49E8   C0FC 000C                 MulU      $C, D0
49EC   E898                      ROR.L     $4, D0
49EE   E340                      AsL       $1, D0
49F0   2A32 0000                 Move.L    $0(A2,D0.W), D5
49F4   4240                      Clr       D0
49F6   E998                      ROL.L     $4, D0
49F8   0640 000C                 Add       $C, D0
49FC   E1BD                      ROL.L     D0, D5
49FE   0245 0FFF                 And       $FFF, D5
4A02   4CDF 0401                 MoveM.L   (A7)+, D0/A2
4A06   4E75                      Rts

                      P181:
4A08   2004                      Move.L    D4, D0

                      P182:
4A0A   48E7 7DF0                 MoveM.L   D1-D5/D7/A0-A3, -(A7)
4A0E   2E2A 001C                 Move.L    $1C(A2), D7
4A12   2C07                      Move.L    D7, D6
4A14   CCEA 002A                 MulU      $2A(A2), D6
4A18   B886                      Cmp.L     D6, D4
4A1A   6302                      BLS       L900
4A1C   2806                      Move.L    D6, D4
4A1E   B880           L900:      Cmp.L     D0, D4
4A20   6408                      BCC       L902
4A22   70DE                      MoveQ.L   $-22, D0
4A24   4CDF 0FBE      L901:      MoveM.L   (A7)+, D1-D5/D7/A0-A3
4A28   4E75                      Rts
4A2A   2431 100C      L902:      Move.L    $C(A1,D1.W), D2
4A2E   7C00                      MoveQ.L   $0, D6
4A30   3631 1006                 Move      $6(A1,D1.W), D3
4A34   6612                      BNE       L904
4A36   6152                      Bsr       P183
4A38   3385 1006                 Move      D5, $6(A1,D1.W)
4A3C   3605                      Move      D5, D3
4A3E   7A01                      MoveQ.L   $1, D5
4A40   6100 00AA                 Bsr       P184
4A44   6028                      Bra       L907
4A46   3605           L903:      Move      D5, D3
4A48   6192           L904:      Bsr       P180
4A4A   0C45 0001                 Cmp       $1, D5
4A4E   66F6                      BNE       L903
4A50   B66A 001A      L905:      Cmp       $1A(A2), D3
4A54   6230                      BHI       L908
4A56   5243                      AddQ      $1, D3
4A58   6182                      Bsr       P180
4A5A   5343                      SubQ.L    $1, D3
4A5C   4A45                      Tst       D5
4A5E   6626                      BNE       L908
4A60   3A03                      Move      D3, D5
4A62   5245                      AddQ      $1, D5
4A64   6100 0086      L906:      Bsr       P184
4A68   3605                      Move      D5, D3
4A6A   7A01                      MoveQ.L   $1, D5
4A6C   617E                      Bsr       P184
4A6E   DC87           L907:      Add.L     D7, D6
4A70   D487                      Add.L     D7, D2
4A72   536A 002A                 SubQ.L    $1, $2A(A2)
4A76   B886                      Cmp.L     D6, D4
4A78   62D6                      BHI       L905
4A7A   2382 100C                 Move.L    D2, $C(A1,D1.W)
4A7E   50EA 0006                 ST.B      $6(A2)
4A82   7000                      MoveQ.L   $0, D0
4A84   609E                      Bra       L901
4A86   6102           L908:      Bsr       P183
4A88   60DA                      Bra       L906

                      P183:
4A8A   48E7 FA50                 MoveM.L   D0-D4/D6/A1/A3, -(A7)
4A8E   9886                      Sub.L     D6, D4
4A90   B8AA 0020                 Cmp.L     $20(A2), D4
4A94   6404                      BCC       L909
4A96   282A 0020                 Move.L    $20(A2), D4
4A9A   226A 0050      L909:      Move.L    $50(A2), A1
4A9E   366A 001A                 Move      $1A(A2), A3
4AA2   524B                      AddQ      $1, A3
4AA4   7A00                      MoveQ.L   $0, D5
4AA6   7002                      MoveQ.L   $2, D0
4AA8   7402                      MoveQ.L   $2, D2
4AAA   7600                      MoveQ.L   $0, D3
4AAC   7C00                      MoveQ.L   $0, D6
4AAE   4267                      Clr       -(A7)
4AB0   1219           L910:      Move.B    (A1)+, D1
4AB2   E149                      LsL       $8, D1
4AB4   0845 0000                 BChg.B    $0, D5
4AB8   6606                      BNE       L911
4ABA   1211                      Move.B    (A1), D1
4ABC   E849                      LsR       $4, D1
4ABE   6006                      Bra       L912
4AC0   1219           L911:      Move.B    (A1)+, D1
4AC2   0241 0FFF                 And       $FFF, D1
4AC6   6612           L912:      BNE       L914
4AC8   D687                      Add.L     D7, D3
4ACA   B686                      Cmp.L     D6, D3
4ACC   6308                      BLS       L913
4ACE   2C03                      Move.L    D3, D6
4AD0   3E82                      Move      D2, (A7)
4AD2   B684                      Cmp.L     D4, D3
4AD4   640E                      BCC       L916
4AD6   5240           L913:      AddQ      $1, D0
4AD8   6006                      Bra       L915
4ADA   5240           L914:      AddQ      $1, D0
4ADC   3400                      Move      D0, D2
4ADE   7600                      MoveQ.L   $0, D3
4AE0   B04B           L915:      Cmp       A3, D0
4AE2   63CC                      BLS       L910
4AE4   3A1F           L916:      Move      (A7)+, D5
4AE6   4CDF 0A5F                 MoveM.L   (A7)+, D0-D4/D6/A1/A3
4AEA   4E75                      Rts

                      P184:
4AEC   48E7 8220                 MoveM.L   D0/D6/A2, -(A7)
4AF0   246A 0050                 Move.L    $50(A2), A2
4AF4   3003                      Move      D3, D0
4AF6   5540                      SubQ.L    $2, D0
4AF8   C0FC 000C                 MulU      $C, D0
4AFC   E898                      ROR.L     $4, D0
4AFE   E340                      AsL       $1, D0
4B00   2C32 0000                 Move.L    $0(A2,D0.W), D6
4B04   4840                      Swap      D0
4B06   E048                      LsR       $8, D0
4B08   E848                      LsR       $4, D0
4B0A   0640 000C                 Add       $C, D0
4B0E   E1BE                      ROL.L     D0, D6
4B10   0246 F000                 And       $-1000, D6
4B14   8C45                      Or        D5, D6
4B16   E0BE                      ROR.L     D0, D6
4B18   4840                      Swap      D0
4B1A   2586 0000                 Move.L    D6, $0(A2,D0.W)
4B1E   4CDF 0441                 MoveM.L   (A7)+, D0/D6/A2
4B22   4E75                      Rts

                      P185:
4B24   4A43                      Tst       D3
4B26   671A                      BEQ       L918
4B28   6100 FEB2      L917:      Bsr       P180
4B2C   3F05                      Move      D5, -(A7)
4B2E   4245                      Clr       D5
4B30   61BA                      Bsr       P184
4B32   526A 002A                 AddQ      $1, $2A(A2)
4B36   361F                      Move      (A7)+, D3
4B38   0C43 0001                 Cmp       $1, D3
4B3C   66EA                      BNE       L917
4B3E   50EA 0006                 ST.B      $6(A2)
4B42   4E75           L918:      Rts

                      P_tLoadSeg:
4B44   48E7 E0C0                 MoveM.L   D0-D2/A0-A1, -(A7)
4B48   302F 0018                 Move      $18(A7), D0
4B4C   615C                      Bsr       P186
4B4E   6754                      BEQ       L922
4B50   08D0 0007                 BSet.B    $7, (A0)
4B54   2F10                      Move.L    (A0), -(A7)
4B56   4217                      Clr.B     (A7)
4B58   205F                      Move.L    (A7)+, A0
4B5A   224D                      Move.L    A5, A1
4B5C   D2F8 0934                 AddA      (CurJTOffset), A1
4B60   D2D0                      AddA      (A0), A1
4B62   0C69 4EF9 0004            Cmp       $4EF9, $4(A1)
4B68   6720                      BEQ       L920
4B6A   3028 0002                 Move      $2(A0), D0
4B6E   671A                      BEQ       L920
4B70   322F 0018                 Move      $18(A7), D1
4B74   7400                      MoveQ.L   $0, D2
4B76   3419           L919:      Move      (A1)+, D2
4B78   3341 FFFE                 Move      D1, $-2(A1)
4B7C   32FC 4EF9                 Move      $4EF9, (A1)+
4B80   4870 2804                 Pea.L     $4(A0,D2.L)
4B84   22DF                      Move.L    (A7)+, (A1)+
4B86   5340                      SubQ.L    $1, D0
4B88   66EC                      BNE       L919
4B8A   226F 0014      L920:      Move.L    $14(A7), A1
4B8E   5D89                      SubQ.L    $6, A1
4B90   2F49 0016                 Move.L    A1, $16(A7)
4B94   4CDF 0307                 MoveM.L   (A7)+, D0-D2/A0-A1
4B98   544F                      AddQ      $2, A7
4B9A   4A38 012D                 Tst.B     (LoadTrap)
4B9E   6702                      BEQ       L921
4BA0   A9FF                      _Debugger
4BA2   4E75           L921:      Rts
4BA4   700F           L922:      MoveQ.L   $F, D0
4BA6   A9C9                      _SysError
4BA8   A9FF                      _Debugger

                      P186:
4BAA   594F                      SubQ.L    $4, A7
4BAC   2F3C 434F 4445            Move.L    $434F4445, -(A7)
4BB2   3F00                      Move      D0, -(A7)
4BB4   A9A0                      _GetResource
4BB6   205F                      Move.L    (A7)+, A0
4BB8   2008                      Move.L    A0, D0
4BBA   4E75                      Rts

                      P_tUnLoadSeg:
4BBC   206F 0004                 Move.L    $4(A7), A0
4BC0   0C50 4EF9                 Cmp       $4EF9, (A0)
4BC4   6634                      BNE       L924
4BC6   3028 FFFE                 Move      $-2(A0), D0
4BCA   61DE                      Bsr       P186
4BCC   0890 0007                 BClr.B    $7, (A0)
4BD0   2050                      Move.L    (A0), A0
4BD2   224D                      Move.L    A5, A1
4BD4   D2F8 0934                 AddA      (CurJTOffset), A1
4BD8   D2D0                      AddA      (A0), A1
4BDA   3028 0002                 Move      $2(A0), D0
4BDE   671A                      BEQ       L924
4BE0   3211           L923:      Move      (A1), D1
4BE2   2429 0004                 Move.L    $4(A1), D2
4BE6   9488                      Sub.L     A0, D2
4BE8   5982                      SubQ.L    $4, D2
4BEA   32C2                      Move      D2, (A1)+
4BEC   32FC 3F3C                 Move      $3F3C, (A1)+
4BF0   32C1                      Move      D1, (A1)+
4BF2   32FC A9F0                 Move      $-5610, (A1)+
4BF6   5340                      SubQ.L    $1, D0
4BF8   66E6                      BNE       L923
4BFA   2E9F           L924:      Move.L    (A7)+, (A7)
4BFC   4E75                      Rts
4BFE   2038 0108      L925:      Move.L    (MemTop), D0
4C02   0480 0000 5F00            Sub.L     $5F00, D0
4C08   6000 00BC                 Bra       L931

                      P_tChain:
4C0C   4278 0902                 Clr       (LaunchFlag)
4C10   6004                      Bra       L926

                      P_tLaunch:
4C12   50F8 0902                 ST.B      (LaunchFlag)
4C16   31E8 0004 0936 L926:      Move      $4(A0), (CurPageOption)
4C1C   2058                      Move.L    (A0)+, A0
4C1E   43F8 0910                 Lea.L     (CurApName), A1
4C22   7020                      MoveQ.L   $20, D0
4C24   A02E                      _BlockMove
4C26   3038 0900                 Move      (CurApRefNum), D0
4C2A   6F08                      BLE       L927
4C2C   3F00                      Move      D0, -(A7)
4C2E   A99A                      _CloseResFile
4C30   4278 0900                 Clr       (CurApRefNum)
4C34   2E78 010C      L927:      Move.L    (BufPtr), A7
4C38   42B8 0110                 Clr.L     (StackLowPoint)
4C3C   4A78 0902                 Tst       (LaunchFlag)
4C40   6736                      BEQ       L930
4C42   2038 0964                 Move.L    (ScrapHandle), D0
4C46   6F0E                      BLE       L928
4C48   2040                      Move.L    D0, A0
4C4A   A025                      _GetHandleSize
4C4C   9FC0                      SubA.L    D0, A7
4C4E   224F                      Move.L    A7, A1
4C50   2050                      Move.L    (A0), A0
4C52   2F00                      Move.L    D0, -(A7)
4C54   A02E                      _BlockMove
4C56   A02C           L928:      _InitApplZone
4C58   4278 0900                 Clr       (CurApRefNum)
4C5C   4AB8 0964                 Tst.L     (ScrapHandle)
4C60   6F14                      BLE       L929
4C62   221F                      Move.L    (A7)+, D1
4C64   2001                      Move.L    D1, D0
4C66   A122                      _NewHandle
4C68   21C8 0964                 Move.L    A0, (ScrapHandle)
4C6C   2001                      Move.L    D1, D0
4C6E   2250                      Move.L    (A0), A1
4C70   204F                      Move.L    A7, A0
4C72   A02E                      _BlockMove
4C74   DFC1                      AddA.L    D1, A7
4C76   A04F           L929:      _RDrvrInstall
4C78   42B8 09F6      L930:      Clr.L     (DragHook)
4C7C   42B8 0A6C                 Clr.L     (DeskHook)
4C80   41F8 0A88                 Lea.L     (CloseOrnHook), A0
4C84   4298                      Clr.L     (A0)+
4C86   4298                      Clr.L     (A0)+
4C88   4298                      Clr.L     (A0)+
4C8A   4278 0A62                 Clr       (TaskLock)
4C8E   42B8 0AF2                 Clr.L     (ResErrProc)
4C92   554F                      SubQ.L    $2, A7
4C94   4878 0910                 Pea.L     (CurApName)
4C98   A997                      _OpenResFile
4C9A   31DF 0900                 Move      (A7)+, (CurApRefNum)
4C9E   6F00 008A                 BLE       L933
4CA2   7000                      MoveQ.L   $0, D0
4CA4   6100 FF04                 Bsr       P186
4CA8   6700 0080                 BEQ       L933
4CAC   21C8 0930                 Move.L    A0, (SaveSegHandle)
4CB0   2050                      Move.L    (A0), A0
4CB2   4A78 0936                 Tst       (CurPageOption)
4CB6   6714                      BEQ       L_SegStack
4CB8   6A00 FF44                 BPL       L925
4CBC   2038 0108                 Move.L    (MemTop), D0
4CC0   0480 0000 D900            Sub.L     $D900, D0
4CC6   B08F           L931:      Cmp.L     A7, D0
4CC8   6C02                      BGE       L_SegStack
4CCA   2E40                      Move.L    D0, A7
                      L_SegStack:
4CCC   9FD8                      SubA.L    (A0)+, A7
4CCE   2A4F                      Move.L    A7, A5
4CD0   9FD8                      SubA.L    (A0)+, A7
4CD2   21CD 0904                 Move.L    A5, (CurrentA5)
4CD6   21CF 0908                 Move.L    A7, (CurStackBase)
4CDA   21CF 0110                 Move.L    A7, (StackLowPoint)
4CDE   2018                      Move.L    (A0)+, D0
4CE0   2258                      Move.L    (A0)+, A1
4CE2   31C9 0934                 Move      A1, (CurJTOffset)
4CE6   D3CD                      AddA.L    A5, A1
4CE8   47E9 0002                 Lea.L     $2(A1), A3
4CEC   A02E                      _BlockMove
4CEE   2F38 0930                 Move.L    (SaveSegHandle), -(A7)
4CF2   A9A3                      _ReleaseResource
4CF4   41ED 0008                 Lea.L     $8(A5), A0
4CF8   4298                      Clr.L     (A0)+
4CFA   4298                      Clr.L     (A0)+
4CFC   20F8 0AEC                 Move.L    (AppParmHandle), (A0)+
4D00   4258                      Clr       (A0)+
4D02   204F                      Move.L    A7, A0
4D04   91F8 0322                 SubA.L    (DefltStack), A0
4D08   A02D                      _SetApplLimit
4D0A   7E00                      MoveQ.L   $0, D7
4D0C   4E93                      Jsr       (A3)
4D0E   3F38 0900                 Move      (CurApRefNum), -(A7)
4D12   A99A                      _CloseResFile
4D14   4278 0900                 Clr       (CurApRefNum)

                      P_tExitToShell:
4D18   41F8 093A                 Lea.L     (LoaderPBlock), A0
4D1C   2248                      Move.L    A0, A1
4D1E   4878 02E0                 Pea.L     (FinderName)
4D22   22DF                      Move.L    (A7)+, (A1)+
4D24   4299                      Clr.L     (A1)+
4D26   6000 FEEA                 Bra       P_tLaunch
4D2A   701A           L933:      MoveQ.L   $1A, D0
4D2C   A9C9                      _SysError
4D2E   A9FF                      _Debugger

                      P_tGetAppParms:
4D30   205F                      Move.L    (A7)+, A0
4D32   225F                      Move.L    (A7)+, A1
4D34   22AD 0010                 Move.L    $10(A5), (A1)
4D38   225F                      Move.L    (A7)+, A1
4D3A   32B8 0900                 Move      (CurApRefNum), (A1)
4D3E   225F                      Move.L    (A7)+, A1
4D40   2F08                      Move.L    A0, -(A7)
4D42   41F8 0910                 Lea.L     (CurApName), A0
4D46   7020                      MoveQ.L   $20, D0
4D48   A02E                      _BlockMove
4D4A   4E75                      Rts

                      P_tRDrvrInstall:
4D4C   48E7 F8F0                 MoveM.L   D0-D4/A0-A3, -(A7)
4D50   2678 011C                 Move.L    (UTableBase), A3
4D54   3638 01D2                 Move      (UnitTableEntryCount), D3
4D58   78FF                      MoveQ.L   $-1, D4
4D5A   201B           L934:      Move.L    (A3)+, D0
4D5C   672A                      BEQ       L936
4D5E   2240                      Move.L    D0, A1
4D60   2251                      Move.L    (A1), A1
4D62   0829 0006 0005            BTst.B    $6, $5(A1)
4D68   671E                      BEQ       L936
4D6A   2011                      Move.L    (A1), D0
4D6C   671A                      BEQ       L936
4D6E   B0B8 02AA                 Cmp.L     (ApplZone), D0
4D72   6D20                      BLT       L937
4D74   7027                      MoveQ.L   $27, D0
4D76   2049                      Move.L    A1, A0
4D78   4218           L935:      Clr.B     (A0)+
4D7A   51C8 FFFC                 DBF       D0, L935
4D7E   08E9 0006 0005            BSet.B    $6, $5(A1)
4D84   3344 0018                 Move      D4, $18(A1)
4D88   5344           L936:      SubQ.L    $1, D4
4D8A   5343                      SubQ.L    $1, D3
4D8C   66CC                      BNE       L934
4D8E   4CDF 0F1F                 MoveM.L   (A7)+, D0-D4/A0-A3
4D92   4E75                      Rts
4D94   42A9 001E      L937:      Clr.L     $1E(A1)
4D98   2029 0014                 Move.L    $14(A1), D0
4D9C   B0B8 02AA                 Cmp.L     (ApplZone), D0
4DA0   6DE6                      BLT       L936
4DA2   42A9 0014                 Clr.L     $14(A1)
4DA6   60E0                      Bra       L936

                      P_tA037_mReadParam:
4DA8   43F8 01F8                 Lea.L     (SysParam_SPValid), A1
4DAC   6104                      Bsr       P187
4DAE   7000                      MoveQ.L   $0, D0
4DB0   4E75                      Rts

                      P187:
4DB2   7413                      MoveQ.L   $13, D2
4DB4   E288           L938:      LsR.L     $1, D0
4DB6   6402                      BCC       L939
4DB8   10D1                      Move.B    (A1), (A0)+
4DBA   5289           L939:      AddQ      $1, A1
4DBC   51CA FFF6                 DBF       D2, L938
4DC0   4E75                      Rts

                      P_tWriteParam:
4DC2   43F8 01F8                 Lea.L     (SysParam_SPValid), A1
4DC6   C149                      Exg.L     A0, A1
4DC8   61E8                      Bsr       P187
4DCA   6100 0238                 Bsr       P194
4DCE   43F8 01E4                 Lea.L     (Scratch20), A1
4DD2   6100 014E                 Bsr       P_mReadPRAM
4DD6   41F8 01F8                 Lea.L     (SysParam_SPValid), A0
4DDA   70A9                      MoveQ.L   $-57, D0
4DDC   7404                      MoveQ.L   $4, D2
4DDE   B388           L940:      CmpM.L    (A0)+, (A1)+
4DE0   6606                      BNE       L941
4DE2   51CA FFFA                 DBF       D2, L940
4DE6   7000                      MoveQ.L   $0, D0
4DE8   4E75           L941:      Rts

                      P_tReadDateTime:
4DEA   6100 01A2                 Bsr       P191
4DEE   20B8 020C                 Move.L    (Time), (A0)
4DF2   4E75                      Rts

                      P_tSetDateTime:
4DF4   21C0 020C                 Move.L    D0, (Time)
4DF8   6000 01CA                 Bra       L958

                      P_tDelay:
4DFC   46FC 2000                 Move      $2000, SR
4E00   2038 016A                 Move.L    (Ticks), D0
4E04   D088                      Add.L     A0, D0
4E06   B0B8 016A      L942:      Cmp.L     (Ticks), D0
4E0A   6EFA                      BGT       L942
4E0C   4E75                      Rts

                      P_tCmpString:
4E0E   2F03                      Move.L    D3, -(A7)
4E10   3400                      Move      D0, D2
4E12   4840                      Swap      D0

                      DT29:
4E14   B440                      Cmp       D0, D2
4E16   661A                      BNE       L945
4E18   7400                      MoveQ.L   $0, D2
4E1A   600E                      Bra       L944
4E1C   1419           L943:      Move.B    (A1)+, D2
4E1E   6118                      Bsr       P188
4E20   1602                      Move.B    D2, D3
4E22   1418                      Move.B    (A0)+, D2
4E24   6112                      Bsr       P188
4E26   B602                      Cmp.B     D2, D3
4E28   6608                      BNE       L945
4E2A   51C8 FFF0      L944:      DBF       D0, L943
4E2E   7000                      MoveQ.L   $0, D0
4E30   6002                      Bra       L946
4E32   7001           L945:      MoveQ.L   $1, D0
4E34   261F           L946:      Move.L    (A7)+, D3
4E36   4E75                      Rts

                      P188:
4E38   0801 0009                 BTst.B    $9, D1
4E3C   6710                      BEQ       L947
4E3E   0C02 0080                 Cmp.B     $-80, D2
4E42   650A                      BCS       L947
4E44   0C02 00CD                 Cmp.B     $-33, D2
4E48   6204                      BHI       L947
4E4A   143B 20C8                 Move.B    DT29(D2.W), D2
4E4E   0801 000A      L947:      BTst.B    $A, D1
4E52   662C                      BNE       L950
4E54   0C02 0061                 Cmp.B     $61, D2
4E58   6526                      BCS       L950
4E5A   0C02 009F                 Cmp.B     $-61, D2
4E5E   6206                      BHI       L948
4E60   143B 201F                 Move.B    DT30(D2.W), D2
4E64   601A                      Bra       L950
4E66   0C02 00BE      L948:      Cmp.B     $-42, D2
4E6A   6514                      BCS       L950
4E6C   0C02 00BF                 Cmp.B     $-41, D2
4E70   6206                      BHI       L949
4E72   0402 0010                 Sub.B     $10, D2
4E76   6008                      Bra       L950
4E78   0C02 00CF      L949:      Cmp.B     $-31, D2
4E7C   6602                      BNE       L950
4E7E   5302                      SubQ.L    $1, D2
4E80   4E75           L950:      Rts
DT30 = . - $1

                      P_tFontDispatch:
4E82   7400                      MoveQ.L   $0, D2
4E84   6006                      Bra       L952
4E86   1410           L951:      Move.B    (A0), D2
4E88   61AE                      Bsr       P188
4E8A   10C2                      Move.B    D2, (A0)+
4E8C   51C8 FFF8      L952:      DBF       D0, L951
4E90   7000                      MoveQ.L   $0, D0
4E92   4E75                      Rts
4E94   4141 4345 4E4F            DC.B      'AACENO'
4E9A   5561 6161 6161            DC.B      'Uaaaaa'
4EA0   6163 6565 6565            DC.B      'aceeee'
4EA6   6969 6969 6E6F            DC.B      'iiiino'
4EAC   6F6F 6F6F 7575            DC.B      'oooouu'
4EB2   7575 A0A1 A2A3            DC.B      'uu    '
4EB8   A4A5 A6A7 A8A9            DC.B      '      '
4EBE   AAAB ACAD AE4F            DC.B      '     O'
4EC4   B0B1 B2B3 B4B5            DC.B      '      '
4ECA   B6B7 B8B9 BA61            DC.B      '     a'
4ED0   6FBD BE6F C0C1            DC.B      'o  o  '
4ED6   C2C3 C4C5 C6C7            DC.B      '      '
4EDC   C8C9 CA41 414F            DC.B      '   AAO'
4EE2   4142 4344 4546            DC.B      'ABCDEF'
4EE8   4748 494A 4B4C            DC.B      'GHIJKL'
4EEE   4D4E 4F50 5152            DC.B      'MNOPQR'
4EF4   5354 5556 5758            DC.B      'STUVWX'
4EFA   595A 7B7C 7D7E            DC.B      'YZ{|}~'
4F00   7F80 8182 8384            DC.B      '      '
4F06   8586 87CB 8980            DC.B      '      '
4F0C   CC81 8283 8F90            DC.B      '      '
4F12   9192 9394 9584            DC.B      '      '
4F18   9798 9985 CD9C            DC.B      '      '
4F1E   9D9E 8600                 DC.B      '    '

                      P_mReadPRAM:
4F22   48E7 6440                 MoveM.L   D1-D2/D5/A1, -(A7)
4F26   72C1                      MoveQ.L   $-3F, D1
4F28   7A0F                      MoveQ.L   $F, D5
4F2A   610C                      Bsr       P190
4F2C   72A1                      MoveQ.L   $-5F, D1
4F2E   7A03                      MoveQ.L   $3, D5
4F30   6106                      Bsr       P190
4F32   4CDF 0226                 MoveM.L   (A7)+, D1-D2/D5/A1
4F36   4E75                      Rts

                      P190:
4F38   6100 00F8                 Bsr       P_mClkRW
4F3C   12C2                      Move.B    D2, (A1)+
4F3E   5801                      AddQ      $4, D1
4F40   51CD FFF6                 DBF       D5, P190
4F44   4E75                      Rts

                      DT31:
4F46   A800 0000 CC0A            DC.B      '      '
4F4C   CC0A 0000 0000            DC.B      '      '
4F52   0002 6300 0388            DC.B      '  c   '
4F58   004C                      DC.B      ' L'

                      P_tInitUtil:
4F5A   7000                      MoveQ.L   $0, D0
4F5C   6100 00A0                 Bsr       P_mWPOff
4F60   7231                      MoveQ.L   $31, D1
4F62   4202                      Clr.B     D2
4F64   6100 00CC                 Bsr       P_mClkRW
4F68   6100 008E                 Bsr       P_mWPOn
4F6C   43F8 01F8                 Lea.L     (SysParam_SPValid), A1
4F70   61B0                      Bsr       P_mReadPRAM
4F72   611A                      Bsr       P191
4F74   7000                      MoveQ.L   $0, D0
4F76   0C11 00A8                 Cmp.B     $-58, (A1)
4F7A   6710                      BEQ       L954
4F7C   70A8                      MoveQ.L   $-58, D0
4F7E   7204                      MoveQ.L   $4, D1
4F80   41FA FFC4                 Lea.L     DT31, A0
4F84   22D8           L953:      Move.L    (A0)+, (A1)+
4F86   51C9 FFFC                 DBF       D1, L953
4F8A   6178                      Bsr       P194
4F8C   4E75           L954:      Rts

                      P191:
4F8E   48E7 6C30                 MoveM.L   D1-D2/D4-D5/A2-A3, -(A7)
4F92   7801                      MoveQ.L   $1, D4
4F94   7000                      MoveQ.L   $0, D0
4F96   729D           L955:      MoveQ.L   $-63, D1
4F98   7A07                      MoveQ.L   $7, D5
4F9A   45F8 01E4                 Lea.L     (Scratch20), A2
4F9E   264A                      Move.L    A2, A3
4FA0   6100 0090      L956:      Bsr       P_mClkRW
4FA4   14C2                      Move.B    D2, (A2)+
4FA6   5901                      SubQ.L    $4, D1
4FA8   51CD FFF6                 DBF       D5, L956
4FAC   B78B                      CmpM.L    (A3)+, (A3)+
4FAE   6706                      BEQ       L957
4FB0   51CC FFE4                 DBF       D4, L955
4FB4   70AB                      MoveQ.L   $-55, D0
4FB6   21F8 01E4 020C L957:      Move.L    (Scratch20), (Time)
4FBC   4CDF 0C36                 MoveM.L   (A7)+, D1-D2/D4-D5/A2-A3
4FC0   4A40                      Tst       D0
4FC2   4E75                      Rts
4FC4   48E7 7C00      L958:      MoveM.L   D1-D5, -(A7)
4FC8   6134                      Bsr       P_mWPOff
4FCA   2638 020C                 Move.L    (Time), D3
4FCE   7A01                      MoveQ.L   $1, D5
4FD0   2403           L959:      Move.L    D3, D2
4FD2   7201                      MoveQ.L   $1, D1
4FD4   7803                      MoveQ.L   $3, D4
4FD6   615A           L960:      Bsr       P_mClkRW
4FD8   5801                      AddQ      $4, D1
4FDA   E08A                      LsR.L     $8, D2
4FDC   51CC FFF8                 DBF       D4, L960
4FE0   61AC                      Bsr       P191
4FE2   660C                      BNE       L961
4FE4   B6B8 020C                 Cmp.L     (Time), D3
4FE8   6706                      BEQ       L961
4FEA   51CD FFE4                 DBF       D5, L959
4FEE   70AA                      MoveQ.L   $-56, D0
4FF0   6106           L961:      Bsr       P_mWPOn
4FF2   4CDF 003E                 MoveM.L   (A7)+, D1-D5
4FF6   4E75                      Rts

                      P_mWPOn:
4FF8   7235                      MoveQ.L   $35, D1
4FFA   74D5                      MoveQ.L   $-2B, D2
4FFC   6034                      Bra       P_mClkRW

                      P_mWPOff:
4FFE   7235                      MoveQ.L   $35, D1
5000   7455                      MoveQ.L   $55, D2
5002   602E                      Bra       P_mClkRW

                      P194:
5004   48E7 7020                 MoveM.L   D1-D3/A2, -(A7)
5008   61F4                      Bsr       P_mWPOff
500A   45F8 01F8                 Lea.L     (SysParam_SPValid), A2
500E   123C 0041                 Move.B    $41, D1
5012   760F                      MoveQ.L   $F, D3
5014   6110                      Bsr       P195
5016   123C 0021                 Move.B    $21, D1
501A   7603                      MoveQ.L   $3, D3
501C   6108                      Bsr       P195
501E   61D8                      Bsr       P_mWPOn
5020   4CDF 040E                 MoveM.L   (A7)+, D1-D3/A2
5024   4E75                      Rts

                      P195:
5026   141A                      Move.B    (A2)+, D2
5028   6108                      Bsr       P_mClkRW
502A   5801                      AddQ      $4, D1
502C   51CB FFF8                 DBF       D3, P195
5030   4E75                      Rts

                      P_mClkRW:
5032   40E7                      Move      SR, -(A7)
5034   48E7 5C40                 MoveM.L   D1/D3-D5/A1, -(A7)
5038   227C 00EF E1FE            Move.L    $EFE1FE, A1
503E   007C 0100                 Or        $100, SR
5042   1611                      Move.B    (A1), D3
5044   7801                      MoveQ.L   $1, D4
5046   0203 00F9                 And.B     $-7, D3
504A   4A01                      Tst.B     D1
504C   6B08                      BMI       L962
504E   6114                      Bsr       P197
5050   3202                      Move      D2, D1
5052   6110                      Bsr       P197
5054   6004                      Bra       L963
5056   610C           L962:      Bsr       P197
5058   611C                      Bsr       P198
505A   08D1 0002      L963:      BSet.B    $2, (A1)
505E   4CDF 023A                 MoveM.L   (A7)+, D1/D3-D5/A1
5062   4E73                      Rte

                      P197:
5064   7A07                      MoveQ.L   $7, D5
5066   E21B           L964:      ROR.B     $1, D3
5068   E311                      RXL.B     $1, D1
506A   E313                      RXL.B     $1, D3
506C   1283                      Move.B    D3, (A1)
506E   09D1                      BSet.B    D4, (A1)
5070   51CD FFF4                 DBF       D5, L964
5074   4E75                      Rts

                      P198:
5076   7A07                      MoveQ.L   $7, D5
5078   08A9 0000 0400            BClr.B    $0, $400(A1)
507E   1803                      Move.B    D3, D4
5080   08C4 0001                 BSet.B    $1, D4
5084   1283           L965:      Move.B    D3, (A1)
5086   1284                      Move.B    D4, (A1)
5088   1211                      Move.B    (A1), D1
508A   E209                      LsR.B     $1, D1
508C   E312                      RXL.B     $1, D2
508E   51CD FFF4                 DBF       D5, L965
5092   08E9 0000 0400            BSet.B    $0, $400(A1)
5098   4E75                      Rts

                      DT32:
509A   0931 09C5 98B4            DC.B      ' 1    '
50A0   8A87 921F 3A1F            DC.B      '    : '
50A6   DEE9 1F82 2091            DC.B      '      '
50AC   21C8 214F 1E45            DC.B      '! !O E'
50B2   1CDC 244B 241F            DC.B      '  $K$ '
50B8   C11E 4A1F 201F            DC.B      '  J   '
50BE   171C D01E 1A22            DC.B      '     "'
50C4   4615 A6A3 83A4            DC.B      'F     '
50CA   94A3 8E8A 163A            DC.B      '     :'
50D0   9991 8E16 6C8F            DC.B      '    l '
50D6   9216 7FA3 8616            DC.B      '      '
50DC   8515 8116 2319            DC.B      '    # '
50E2   FD1B BEBC C48F            DC.B      '      '
50E8   0675 9C80 8026            DC.B      ' u   &'
50EE   D48D 9485 8489            DC.B      '      '
50F4   0A53 A727 AD15            DC.B      ' S '  '
50FA   F521 3585 211F            DC.B      ' !5 ! '
5100   2248 23CB 0847            DC.B      '"H#  G'
5106   8716 44EA 8616            DC.B      '  D   '
510C   1E15 D092 0BA5            DC.B      '      '
5112   26A6 299D 878F            DC.B      '& )   '
5118   8227 4129 B7A1            DC.B      ' 'A)  '
511E   1573 29DA 8586            DC.B      ' s)   '
5124   8485 8B8B 8980            DC.B      '      '
512A   89AA 8383 2B25            DC.B      '    +%'
5130   9EF8 B391 A185            DC.B      '      '
5136   852C B12C 38ED            DC.B      ' , ,8 '
513C   2D2A 9090 8385            DC.B      '-*    '
5142   868C 9098 A788            DC.B      '      '
5148   8A8B 2CF1 2DDA            DC.B      '  , - '
514E   8F8F 8586 2EF6            DC.B      '    . '
5154   898A A42E DE83            DC.B      '   .  '
515A   8883 3007 2F23            DC.B      '  0 /#'
5160   2F16 2EEF 8033            DC.B      '/ .  3'
5166   88CC 8B8C 8680            DC.B      '      '
516C   C685 8582 9188            DC.B      '      '
5172   8783 8A80 378E            DC.B      '    7 '
5178   DE83 8383 8338            DC.B      '     8'
517E   A338 9CA1 8989            DC.B      ' 8    '
5184   CFA2 9B38 B03E            DC.B      '   8 >'
518A   45DE 8383 8383            DC.B      'E     '
5190   808C D583 8383            DC.B      '      '
5196   8380 3FC3 D383            DC.B      '  ?   '
519C   8383 8344 FF80            DC.B      '   D  '
51A2   CBCD 8383 8383            DC.B      '      '
51A8   8C9B B782 4EA1            DC.B      '    N '
51AE   CB46 8CC5 8383            DC.B      ' F    '
51B4   8383 80E4 928A            DC.B      '      '
51BA   98AC A786 AF87            DC.B      '      '
51C0   99D3 88A0 8383            DC.B      '      '
51C6   83FE B02C FF4D            DC.B      '   , M'
51CC   0F4D D22F 5F52            DC.B      ' M /_R'
51D2   A24E 2052 B452            DC.B      ' N R R'
51D8   6EFE 8BD7 A482            DC.B      'n     '
51DE   8058 9BAC B149            DC.B      ' X   I'
51E4   CB46 1180 5940            DC.B      ' F  Y@'
51EA   5AD9 9F59 3D5B            DC.B      'Z  Y=['
51F0   2D5B 1D63 A362            DC.B      '-[ c b'
51F6   125C 348C 5DAE            DC.B      ' \4 ] '
51FC   5C7B ACA2 92D6            DC.B      '\{    '
5202   B697 CF85 CAD8            DC.B      '      '
5208   5F40 8893 9587            DC.B      '_@    '
520E   8E8C BC60 69A0            DC.B      '   `i '
5214   A7B5 98CF AB9D            DC.B      '      '
521A   9190 E362 ACA0            DC.B      '   b  '
5220   8F82 8263 625E            DC.B      '   cb^'
5226   FC5F 7F83 63B2            DC.B      ' _  c '
522C   674F 6669 6774            DC.B      'gOfigt'
5232   63D0 86D1 CEBE            DC.B      'c     '
5238   958E 6657 8B64            DC.B      '  fW d'
523E   F166 DD66 C782            DC.B      ' f f  '
5244   8282 8282 82D0            DC.B      '      '
524A   6812 6735 6802            DC.B      'h g5h '
5250   B2FB 666E 6839            DC.B      '  fnh9'
5256   0803 5FC0 68A1            DC.B      '  _ h '
525C   683D 8080 68CD            DC.B      'h=  h '
5262   6953 9189 8F8D            DC.B      'iS    '
5268   9F87 8C94 968C            DC.B      '      '
526E   A187 8282 A182            DC.B      '      '
5274   8297 D4F7 69B7            DC.B      '    i '
527A   826B 5B80 8080            DC.B      ' k[   '
5280   5BB1 5BAF 5B81            DC.B      '[ [ [ '
5286   8B5B 5689 5B48            DC.B      ' [V [H'
528C   D880 8080 7220            DC.B      '    r '
5292   72EA 9C74 F673            DC.B      'r  t s'
5298   529D DE8B B780            DC.B      'R     '
529E   725C 7256 8282            DC.B      'r\rV  '
52A4   7425 A2A2 9284            DC.B      't%    '
52AA   9FAB 74B9 738F            DC.B      '  t s '
52B0   700C 6D5C 704B            DC.B      'p m\pK'
52B6   6BA2 EBCF 95E3            DC.B      'k     '
52BC   CCD0 849E 8EA4            DC.B      '      '
52C2   AD95 6FE5 9FBC            DC.B      '  o   '
52C8   808F 8A95 9D70            DC.B      '     p'
52CE   1670 A5E9 B6C2            DC.B      ' p    '
52D4   9470 286C 3B77            DC.B      ' p(l;w'
52DA   95DD EBBC BBA6            DC.B      '      '
52E0   8D8D 8484 8484            DC.B      '      '
52E6   ABA8 A06D D478            DC.B      '   m x'
52EC   BD80 8080 7F8F            DC.B      '      '
52F2   BC04 948E 03C8            DC.B      '      '
52F8   79C8 8693 8C9E            DC.B      'y     '
52FE   93A2 91B4 9A7C            DC.B      '     |'
5304   5F92 877D 8F91            DC.B      '_  }  '
530A   8B95 CC9F 7DF5            DC.B      '    } '
5310   D577 19DB 8684            DC.B      ' w    '
5316   8D7F 4196 B081            DC.B      '  A   '
531C   8181 8181 8181            DC.B      '      '
5322   778D 25A2 BCAB            DC.B      'w %   '
5328   2606 268C 8C6C            DC.B      '& &  l'
532E   7585 807E 71A8            DC.B      'u  ~q '
5334   9A98 A3AF 0000            DC.B      '      '

                      P_tInitCursor:
533A   2055                      Move.L    (A5), A0
533C   4868 FF94                 Pea.L     $-6C(A0)
5340   4EBA 0006                 Jsr       P_tSetCursor
5344   4EFA 5F16                 Jmp       P_doInitCrsr

                      P_tSetCursor:
5348   206F 0004                 Move.L    $4(A7), A0
534C   3F28 0042                 Move      $42(A0), -(A7)
5350   3F28 0040                 Move      $40(A0), -(A7)
5354   3F3C 0010                 Move      $10, -(A7)
5358   4850                      Pea.L     (A0)
535A   4868 0020                 Pea.L     $20(A0)
535E   4EBA 5EF6                 Jsr       P_doSetCrsr
5362   2E9F                      Move.L    (A7)+, (A7)
5364   4E75                      Rts

                      P_tHideCursor:
5366   4EFA 5EE8                 Jmp       P_doHideCursor

                      P_tShowCursor:
536A   4EFA 5EDE                 Jmp       P_doShowCursor

                      P_tShieldCursor:
536E   4E56 0000                 Link      A6, $0
5372   48E7 E0C0                 MoveM.L   D0-D2/A0-A1, -(A7)
5376   206E 000C                 Move.L    $C(A6), A0
537A   3028 0002                 Move      $2(A0), D0
537E   906E 000A                 Sub       $A(A6), D0
5382   3F00                      Move      D0, -(A7)
5384   3010                      Move      (A0), D0
5386   906E 0008                 Sub       $8(A6), D0
538A   3F00                      Move      D0, -(A7)
538C   3028 0006                 Move      $6(A0), D0
5390   906E 000A                 Sub       $A(A6), D0
5394   3F00                      Move      D0, -(A7)
5396   3028 0004                 Move      $4(A0), D0
539A   906E 0008                 Sub       $8(A6), D0
539E   3F00                      Move      D0, -(A7)
53A0   4EBA 5EC6                 Jsr       P_doShieldCursor
53A4   4CDF 0307                 MoveM.L   (A7)+, D0-D2/A0-A1
53A8   4E5E                      Unlk      A6
53AA   205F                      Move.L    (A7)+, A0
53AC   504F                      AddQ      $8, A7
53AE   4ED0                      Jmp       (A0)

                      P_tObscureCursor:
53B0   4EFA 5EB0                 Jmp       P_doCrsrObscure

                      P_tBitAnd:
53B4   205F                      Move.L    (A7)+, A0
53B6   201F                      Move.L    (A7)+, D0
53B8   C09F                      And.L     (A7)+, D0
53BA   2E80                      Move.L    D0, (A7)
53BC   4ED0                      Jmp       (A0)

                      P_tBitXOr:
53BE   205F                      Move.L    (A7)+, A0
53C0   201F                      Move.L    (A7)+, D0
53C2   221F                      Move.L    (A7)+, D1
53C4   B380                      Eor.L     D1, D0
53C6   2E80                      Move.L    D0, (A7)
53C8   4ED0                      Jmp       (A0)

                      P_tBitNot:
53CA   205F                      Move.L    (A7)+, A0
53CC   4697                      Not.L     (A7)
53CE   2E9F                      Move.L    (A7)+, (A7)
53D0   4ED0                      Jmp       (A0)

                      P_tBitOr:
53D2   205F                      Move.L    (A7)+, A0
53D4   201F                      Move.L    (A7)+, D0
53D6   809F                      Or.L      (A7)+, D0
53D8   2E80                      Move.L    D0, (A7)
53DA   4ED0                      Jmp       (A0)

                      P_tBitShift:
53DC   205F                      Move.L    (A7)+, A0
53DE   321F                      Move      (A7)+, D1
53E0   6A08                      BPL       L966
53E2   4441                      Neg       D1
53E4   201F                      Move.L    (A7)+, D0
53E6   E2A8                      LsR.L     D1, D0
53E8   6004                      Bra       L967
53EA   201F           L966:      Move.L    (A7)+, D0
53EC   E3A8                      LsL.L     D1, D0
53EE   2E80           L967:      Move.L    D0, (A7)
53F0   4ED0                      Jmp       (A0)

                      P_tBitTst:
53F2   205F                      Move.L    (A7)+, A0
53F4   221F                      Move.L    (A7)+, D1
53F6   3001                      Move      D1, D0
53F8   E681                      AsR.L     $3, D1
53FA   4640                      Not       D0
53FC   225F                      Move.L    (A7)+, A1
53FE   0131 1800                 BTst.B    D0, $0(A1,D1.L)
5402   56D7                      SNE.B     (A7)
5404   4417                      Neg.B     (A7)
5406   4ED0                      Jmp       (A0)

                      P_tBitSet:
5408   205F                      Move.L    (A7)+, A0
540A   221F                      Move.L    (A7)+, D1
540C   3001                      Move      D1, D0
540E   E681                      AsR.L     $3, D1
5410   4640                      Not       D0
5412   225F                      Move.L    (A7)+, A1
5414   01F1 1800                 BSet.B    D0, $0(A1,D1.L)
5418   4ED0                      Jmp       (A0)

                      P_tBitClr:
541A   205F                      Move.L    (A7)+, A0
541C   221F                      Move.L    (A7)+, D1
541E   3001                      Move      D1, D0
5420   E681                      AsR.L     $3, D1
5422   4640                      Not       D0
5424   225F                      Move.L    (A7)+, A1
5426   01B1 1800                 BClr.B    D0, $0(A1,D1.L)
542A   4ED0                      Jmp       (A0)

                      P_tRandom:
542C   2055                      Move.L    (A5), A0
542E   303C 41A7                 Move      $41A7, D0
5432   C0E8 FF84                 MulU      $-7C(A0), D0
5436   2200                      Move.L    D0, D1
5438   4241                      Clr       D1
543A   4841                      Swap      D1
543C   343C 41A7                 Move      $41A7, D2
5440   C4E8 FF82                 MulU      $-7E(A0), D2
5444   D481                      Add.L     D1, D2
5446   2202                      Move.L    D2, D1
5448   D281                      Add.L     D1, D1
544A   4241                      Clr       D1
544C   4841                      Swap      D1
544E   0280 0000 FFFF            And.L     $FFFF, D0
5454   0480 7FFF FFFF            Sub.L     $7FFFFFFF, D0
545A   0282 0000 7FFF            And.L     $7FFF, D2
5460   4842                      Swap      D2
5462   D481                      Add.L     D1, D2
5464   D082                      Add.L     D2, D0
5466   6A06                      BPL       L968
5468   0680 7FFF FFFF            Add.L     $7FFFFFFF, D0
546E   2140 FF82      L968:      Move.L    D0, $-7E(A0)
5472   0C40 8000                 Cmp       $-8000, D0
5476   6602                      BNE       L969
5478   4240                      Clr       D0
547A   3F40 0004      L969:      Move      D0, $4(A7)
547E   4E75                      Rts

                      P_tForeColor:
5480   7050                      MoveQ.L   $50, D0
5482   4EFA 01BA                 Jmp       L_mPortLong

                      P_tBackColor:
5486   7054                      MoveQ.L   $54, D0
5488   4EFA 01B4                 Jmp       L_mPortLong

                      P_tColorBit:
548C   7058                      MoveQ.L   $58, D0
548E   4EFA 01A2                 Jmp       L_mPortWord

                      P_mLeftMask:
5492   0240 000F                 And       $F, D0
5496   D040                      Add       D0, D0
5498   303B 001E                 Move      DT_mMaskTab(D0.W), D0
549C   4640                      Not       D0
549E   4E75                      Rts

                      P_mRightMask:
54A0   0240 000F                 And       $F, D0
54A4   D040                      Add       D0, D0
54A6   303B 0010                 Move      DT_mMaskTab(D0.W), D0
54AA   4E75                      Rts

                      P_mBitMask:
54AC   0240 000F                 And       $F, D0
54B0   D040                      Add       D0, D0
54B2   303B 0024                 Move      DT34(D0.W), D0
54B6   4E75                      Rts

                      DT_mMaskTab:
54B8   0000 8000 C000            DC.B      '      '
54BE   E000 F000 F800            DC.B      '      '
54C4   FC00 FE00 FF00            DC.B      '      '
54CA   FF80 FFC0 FFE0            DC.B      '      '
54D0   FFF0 FFF8 FFFC            DC.B      '      '
54D6   FFFE                      DC.B      '  '

                      DT34:
54D8   8000 4000 2000            DC.B      '  @   '
54DE   1000 0800 0400            DC.B      '      '
54E4   0200 0100 0080            DC.B      '      '
54EA   0040 0020 0010            DC.B      ' @    '
54F0   0008 0004 0002            DC.B      '      '
54F6   0001                      DC.B      '  '

                      P_mPatExpand:
54F8   4E56 FFF0                 Link      A6, $-10
54FC   2F0C                      Move.L    A4, -(A7)
54FE   2855                      Move.L    (A5), A4
5500   7007                      MoveQ.L   $7, D0
5502   C06C FF58                 And       $-A8(A4), D0
5506   671A                      BEQ       L970
5508   2D50 FFF0                 Move.L    (A0), $-10(A6)
550C   2D68 0004 FFF4            Move.L    $4(A0), $-C(A6)
5512   2D50 FFF8                 Move.L    (A0), $-8(A6)
5516   2D68 0004 FFFC            Move.L    $4(A0), $-4(A6)
551C   41EE FFF0                 Lea.L     $-10(A6), A0
5520   D0C0                      AddA      D0, A0
5522   D46C FF5A      L970:      Add       $-A6(A4), D2
5526   0242 0007                 And       $7, D2
552A   7207                      MoveQ.L   $7, D1
552C   2854                      Move.L    (A4), A4
552E   302C 005A                 Move      $5A(A4), D0
5532   0C40 0002                 Cmp       $2, D0
5536   6720                      BEQ       L972
5538   0C40 FFFE                 Cmp       $-2, D0
553C   6740                      BEQ       L974
553E   1018           L971:      Move.B    (A0)+, D0
5540   BF00                      Eor.B     D7, D0
5542   E538                      ROL.B     D2, D0
5544   12C0                      Move.B    D0, (A1)+
5546   12C0                      Move.B    D0, (A1)+
5548   32E9 FFFE                 Move      $-2(A1), (A1)+
554C   2369 FFFC 001C            Move.L    $-4(A1), $1C(A1)
5552   51C9 FFEA                 DBF       D1, L971
5556   6048                      Bra       L976
5558   4240           L972:      Clr       D0
555A   1018           L973:      Move.B    (A0)+, D0
555C   BF00                      Eor.B     D7, D0
555E   E538                      ROL.B     D2, D0
5560   1F00                      Move.B    D0, -(A7)
5562   E808                      LsR.B     $4, D0
5564   12FB 0040                 Move.B    DT35(D0.W), (A1)+
5568   700F                      MoveQ.L   $F, D0
556A   C01F                      And.B     (A7)+, D0
556C   12FB 0038                 Move.B    DT35(D0.W), (A1)+
5570   32E9 FFFE                 Move      $-2(A1), (A1)+
5574   22E9 FFFC                 Move.L    $-4(A1), (A1)+
5578   51C9 FFE0                 DBF       D1, L973
557C   6022                      Bra       L976
557E   4240           L974:      Clr       D0
5580   1018           L975:      Move.B    (A0)+, D0
5582   BF00                      Eor.B     D7, D0
5584   E538                      ROL.B     D2, D0
5586   1F00                      Move.B    D0, -(A7)
5588   E808                      LsR.B     $4, D0
558A   12FB 002A                 Move.B    DT36(D0.W), (A1)+
558E   700F                      MoveQ.L   $F, D0
5590   C01F                      And.B     (A7)+, D0
5592   12FB 0022                 Move.B    DT36(D0.W), (A1)+
5596   32E9 FFFE                 Move      $-2(A1), (A1)+
559A   4299                      Clr.L     (A1)+
559C   51C9 FFE2                 DBF       D1, L975
55A0   285F           L976:      Move.L    (A7)+, A4
55A2   4E5E                      Unlk      A6
55A4   4E75                      Rts

                      DT35:
55A6   0003 0C0F 3033            DC.B      '    03'
55AC   3C3F C0C3 CCCF            DC.B      '<?    '
55B2   F0F3 FCFF                 DC.B      '    '

                      DT36:
55B6   0001 0405 1011            DC.B      '      '
55BC   1415 4041 4445            DC.B      '  @ADE'
55C2   5051 5455                 DC.B      'PQTU'

                      P_mColorMap:
55C6   48E7 F080                 MoveM.L   D0-D3/A0, -(A7)
55CA   2055                      Move.L    (A5), A0
55CC   2050                      Move.L    (A0), A0
55CE   3428 0058                 Move      $58(A0), D2
55D2   362F 001C                 Move      $1C(A7), D3
55D6   7003                      MoveQ.L   $3, D0
55D8   C043                      And       D3, D0
55DA   671E                      BEQ       L979
55DC   0C40 0002                 Cmp       $2, D0
55E0   674A                      BEQ       L984
55E2   6E0E                      BGT       L978
55E4   2228 0050                 Move.L    $50(A0), D1
55E8   0501           L977:      BTst.B    D2, D1
55EA   6640                      BNE       L984
55EC   0A43 0002                 Eor       $2, D3
55F0   6036                      Bra       L983
55F2   2228 0054      L978:      Move.L    $54(A0), D1
55F6   4681                      Not.L     D1
55F8   60EE                      Bra       L977
55FA   2028 0050      L979:      Move.L    $50(A0), D0
55FE   2228 0054                 Move.L    $54(A0), D1
5602   0500                      BTst.B    D2, D0
5604   6714                      BEQ       L981
5606   0501                      BTst.B    D2, D1
5608   6722                      BEQ       L984
560A   363C 0008                 Move      $8, D3
560E   2055           L980:      Move.L    (A5), A0
5610   41E8 FFF0                 Lea.L     $-10(A0), A0
5614   2F48 0018                 Move.L    A0, $18(A7)
5618   600E                      Bra       L983
561A   0501           L981:      BTst.B    D2, D1
561C   6606                      BNE       L982
561E   363C 000C                 Move      $C, D3
5622   60EA                      Bra       L980
5624   0A43 0004      L982:      Eor       $4, D3
5628   3F43 001C      L983:      Move      D3, $1C(A7)
562C   4CDF 010F      L984:      MoveM.L   (A7)+, D0-D3/A0
5630   4E75                      Rts
                      L_mPortWord:
5632   225F                      Move.L    (A7)+, A1
5634   2055                      Move.L    (A5), A0
5636   2050                      Move.L    (A0), A0
5638   319F 0000                 Move      (A7)+, $0(A0,D0.W)
563C   4ED1                      Jmp       (A1)
                      L_mPortLong:
563E   225F                      Move.L    (A7)+, A1
5640   2055                      Move.L    (A5), A0
5642   2050                      Move.L    (A0), A0
5644   219F 0000                 Move.L    (A7)+, $0(A0,D0.W)
5648   4ED1                      Jmp       (A1)

                      P_tGetPixel:
564A   4EBA FD1A                 Jsr       P_tHideCursor
564E   241F                      Move.L    (A7)+, D2
5650   2255                      Move.L    (A5), A1
5652   2251                      Move.L    (A1), A1
5654   301F                      Move      (A7)+, D0
5656   9069 0008                 Sub       $8(A1), D0
565A   321F                      Move      (A7)+, D1
565C   9269 000A                 Sub       $A(A1), D1
5660   C0E9 0006                 MulU      $6(A1), D0
5664   2269 0002                 Move.L    $2(A1), A1
5668   D3C0                      AddA.L    D0, A1
566A   3001                      Move      D1, D0
566C   4640                      Not       D0
566E   E649                      LsR       $3, D1
5670   0131 1000                 BTst.B    D0, $0(A1,D1.W)
5674   56D7                      SNE.B     (A7)
5676   4417                      Neg.B     (A7)
5678   2F02                      Move.L    D2, -(A7)
567A   4EFA FCEE                 Jmp       P_tShowCursor
                      ; Missing Block
567E   206F 0004                 Move.L    $4(A7), A0
5682   2E9F                      Move.L    (A7)+, (A7)
5684   4ED0                      Jmp       (A0)

                      P_tStuffHex:
5686   206F 0004                 Move.L    $4(A7), A0
568A   226F 0008                 Move.L    $8(A7), A1
568E   2F57 0008                 Move.L    (A7), $8(A7)
5692   504F                      AddQ      $8, A7
5694   1418                      Move.B    (A0)+, D2
5696   0242 00FE                 And       $FE, D2
569A   6710                      BEQ       L988
569C   6110           L987:      Bsr       P204
569E   1200                      Move.B    D0, D1
56A0   610C                      Bsr       P204
56A2   E909                      LsL.B     $4, D1
56A4   D200                      Add.B     D0, D1
56A6   12C1                      Move.B    D1, (A1)+
56A8   5542                      SubQ.L    $2, D2
56AA   66F0                      BNE       L987
56AC   4E75           L988:      Rts

                      P204:
56AE   1018                      Move.B    (A0)+, D0
56B0   0C00 0039                 Cmp.B     $39, D0
56B4   6F04                      BLE       L989
56B6   0600 0009                 Add.B     $9, D0
56BA   0200 000F      L989:      And.B     $F, D0
56BE   4E75                      Rts

                      P205:
56C0   B242                      Cmp       D2, D1
56C2   6C46                      BGE       L992
56C4   B26B 0006                 Cmp       $6(A3), D1
56C8   6C40                      BGE       L992
56CA   B26B 0002                 Cmp       $2(A3), D1
56CE   6C04                      BGE       L990
56D0   322B 0002                 Move      $2(A3), D1
56D4   B46B 0002      L990:      Cmp       $2(A3), D2
56D8   6F30                      BLE       L992
56DA   B46B 0006                 Cmp       $6(A3), D2
56DE   6F04                      BLE       L991
56E0   342B 0006                 Move      $6(A3), D2
56E4   3002           L991:      Move      D2, D0
56E6   4EBA FDB8                 Jsr       P_mRightMask
56EA   3600                      Move      D0, D3
56EC   3001                      Move      D1, D0
56EE   4EBA FDA2                 Jsr       P_mLeftMask
56F2   C141                      Exg.L     D0, D1
56F4   E640                      AsR       $3, D0
56F6   0240 FFFE                 And       $-2, D0
56FA   D2C0                      AddA      D0, A1
56FC   D4C0                      AddA      D0, A2
56FE   E642                      AsR       $3, D2
5700   0242 FFFE                 And       $-2, D2
5704   9440                      Sub       D0, D2
5706   E242                      AsR       $1, D2
5708   4ED0                      Jmp       (A0)
570A   4E75           L992:      Rts

                      P_mSlabMode:
570C   0242 0003                 And       $3, D2
5710   D442                      Add       D2, D2
5712   41FA 0008                 Lea.L     DT37, A0
5716   D0F0 2000                 AddA      $0(A0,D2.W), A0
571A   4E75                      Rts

                      DT37:
571C   001C 002E 0040            DC.B      '   . @'
5722   0054                      DC.B      ' T'
5724   C243           L993:      And       D3, D1
5726   3006           L994:      Move      D6, D0
5728   C25A                      And       (A2)+, D1
572A   C041                      And       D1, D0
572C   4641                      Not       D1
572E   C251                      And       (A1), D1
5730   8240                      Or        D0, D1
5732   32C1                      Move      D1, (A1)+
5734   72FF                      MoveQ.L   $-1, D1
5736   5342                      SubQ.L    $1, D2

                      E_222:
5738   6EEC                      BGT       L994
573A   67E8                      BEQ       L993
573C   4E75                      Rts
573E   C243           L995:      And       D3, D1
5740   C246           L996:      And       D6, D1
5742   C25A                      And       (A2)+, D1
5744   8359                      Or        D1, (A1)+
5746   72FF                      MoveQ.L   $-1, D1
5748   5342                      SubQ.L    $1, D2

                      E_223:
574A   6EF4                      BGT       L996
574C   67F0                      BEQ       L995
574E   4E75                      Rts
5750   C243           L997:      And       D3, D1
5752   C246           L998:      And       D6, D1
5754   C25A                      And       (A2)+, D1
5756   B359                      Eor       D1, (A1)+
5758   72FF                      MoveQ.L   $-1, D1
575A   5342                      SubQ.L    $1, D2

                      E_224:
575C   6EF4                      BGT       L998
575E   67F0                      BEQ       L997
5760   4E75                      Rts
5762   C243           L999:      And       D3, D1
5764   C246           L1000:     And       D6, D1
5766   C25A                      And       (A2)+, D1
5768   4641                      Not       D1
576A   C359                      And       D1, (A1)+
576C   72FF                      MoveQ.L   $-1, D1
576E   5342                      SubQ.L    $1, D2

                      E_225:
5770   6EF2                      BGT       L1000
5772   67EE                      BEQ       L999
5774   4E75                      Rts

                      P_tLongMul:
5776   4E56 0000                 Link      A6, $0
577A   48E7 C060                 MoveM.L   D0-D1/A1-A2, -(A7)
577E   206E 0008                 Move.L    $8(A6), A0
5782   43EE 0010                 Lea.L     $10(A6), A1
5786   45EE 000C                 Lea.L     $C(A6), A2
578A   4A9A                      Tst.L     (A2)+
578C   5BC1                      SMI.B     D1
578E   6A04                      BPL       L1001
5790   44AA FFFC                 Neg.L     $-4(A2)
5794   4A99           L1001:     Tst.L     (A1)+
5796   6A04                      BPL       L1002
5798   4601                      Not.B     D1
579A   4492                      Neg.L     (A2)
579C   3021           L1002:     Move      -(A1), D0
579E   C0E2                      MulU      -(A2), D0
57A0   2140 0004                 Move.L    D0, $4(A0)
57A4   3021                      Move      -(A1), D0
57A6   C0E2                      MulU      -(A2), D0
57A8   2080                      Move.L    D0, (A0)
57AA   3019                      Move      (A1)+, D0
57AC   C0EA 0002                 MulU      $2(A2), D0
57B0   D1A8 0002                 Add.L     D0, $2(A0)
57B4   6402                      BCC       L1003
57B6   5250                      AddQ      $1, (A0)
57B8   3012           L1003:     Move      (A2), D0
57BA   C0D1                      MulU      (A1), D0
57BC   D1A8 0002                 Add.L     D0, $2(A0)
57C0   6402                      BCC       L1004
57C2   5250                      AddQ      $1, (A0)
57C4   4A01           L1004:     Tst.B     D1
57C6   6706                      BEQ       L1005
57C8   44A8 0004                 Neg.L     $4(A0)
57CC   4090                      NegX.L    (A0)
57CE   4CDF 0603      L1005:     MoveM.L   (A7)+, D0-D1/A1-A2
57D2   4E5E                      Unlk      A6
57D4   205F                      Move.L    (A7)+, A0
57D6   DEFC 000C                 AddA      $C, A7
57DA   4ED0                      Jmp       (A0)

                      P_tFixMul:
57DC   4E56 FFF8                 Link      A6, $-8
57E0   2F2E 000C                 Move.L    $C(A6), -(A7)
57E4   2F2E 0008                 Move.L    $8(A6), -(A7)
57E8   486E FFF8                 Pea.L     $-8(A6)
57EC   4EBA FF88                 Jsr       P_tLongMul
57F0   2D6E FFFA 0010            Move.L    $-6(A6), $10(A6)
57F6   4E5E                      Unlk      A6
57F8   205F                      Move.L    (A7)+, A0
57FA   504F                      AddQ      $8, A7
57FC   4ED0                      Jmp       (A0)

                      P_tFixRatio:
57FE   302F 0006                 Move      $6(A7), D0
5802   48C0                      Ext.L     D0
5804   5BC1                      SMI.B     D1
5806   6A02                      BPL       L1006
5808   4480                      Neg.L     D0
580A   4A6F 0004      L1006:     Tst       $4(A7)
580E   660A                      BNE       L1007
5810   2F7C 7FFF FFFF            Move.L    $7FFFFFFF, $8(A7)
       0008
5818   601A                      Bra       L1009
581A   6A06           L1007:     BPL       L1008
581C   4641                      Not       D1
581E   446F 0004                 Neg       $4(A7)
5822   81EF 0004      L1008:     DivS      $4(A7), D0
5826   3F40 0008                 Move      D0, $8(A7)
582A   4240                      Clr       D0
582C   80EF 0004                 DivU      $4(A7), D0
5830   3F40 000A                 Move      D0, $A(A7)
5834   4A01           L1009:     Tst.B     D1
5836   6704                      BEQ       L1010
5838   44AF 0008                 Neg.L     $8(A7)
583C   2E9F           L1010:     Move.L    (A7)+, (A7)
583E   4E75                      Rts

                      P_tHiWord:
5840   3F6F 0004 0008            Move      $4(A7), $8(A7)
5846   2E9F                      Move.L    (A7)+, (A7)
5848   4E75                      Rts

                      P_tLoWord:
584A   3F6F 0006 0008            Move      $6(A7), $8(A7)
5850   2E9F                      Move.L    (A7)+, (A7)
5852   4E75                      Rts

                      P_tFixRound:
5854   203C 0000 8000            Move.L    $8000, D0
585A   4AAF 0004                 Tst.L     $4(A7)
585E   6A02                      BPL       L1011
5860   4480                      Neg.L     D0
5862   D1AF 0004      L1011:     Add.L     D0, $4(A7)
5866   3F6F 0004 0008            Move      $4(A7), $8(A7)
586C   2E9F                      Move.L    (A7)+, (A7)
586E   4E75                      Rts

                      P_tInitGraf:
5870   4E56 0000                 Link      A6, $0
5874   2F0C                      Move.L    A4, -(A7)
5876   286E 0008                 Move.L    $8(A6), A4
587A   2A8C                      Move.L    A4, (A5)
587C   41EC FF36                 Lea.L     $-CA(A4), A0
5880   43EC 0004                 Lea.L     $4(A4), A1
5884   4258           L1012:     Clr       (A0)+
5886   B1C9                      CmpA.L    A1, A0
5888   66FA                      BNE       L1012
588A   49EC FF70                 Lea.L     $-90(A4), A4
588E   200C                      Move.L    A4, D0
5890   38FC 000A                 Move      $A, (A4)+
5894   28FC 8001 8001            Move.L    $-7FFE7FFF, (A4)+
589A   28FC 7FFF 7FFF            Move.L    $7FFF7FFF, (A4)+
58A0   220C                      Move.L    A4, D1
58A2   28C0                      Move.L    D0, (A4)+
58A4   28C1                      Move.L    D1, (A4)+
58A6   7001                      MoveQ.L   $1, D0
58A8   28C0                      Move.L    D0, (A4)+
58AA   42A7                      Clr.L     -(A7)
58AC   4EBA 59C0                 Jsr       P_doScrnAddr
58B0   28DF                      Move.L    (A7)+, (A4)+
58B2   486C 0008                 Pea.L     $8(A4)
58B6   486C 0006                 Pea.L     $6(A4)
58BA   4EBA 59B8                 Jsr       P_doScrnSize
58BE   302C 0008                 Move      $8(A4), D0
58C2   E648                      LsR       $3, D0
58C4   38C0                      Move      D0, (A4)+
58C6   429C                      Clr.L     (A4)+
58C8   584C                      AddQ      $4, A4
58CA   701A                      MoveQ.L   $1A, D0
58CC   41FA 0010                 Lea.L     DT38, A0
58D0   28D8           L1013:     Move.L    (A0)+, (A4)+
58D2   51C8 FFFC                 DBF       D0, L1013
58D6   285F                      Move.L    (A7)+, A4
58D8   4E5E                      Unlk      A6
58DA   2E9F                      Move.L    (A7)+, (A7)
58DC   4E75                      Rts

                      DT38:
58DE   0000 4000 6000            DC.B      '  @ ` '
58E4   7000 7800 7C00            DC.B      'p x | '
58EA   7E00 7F00 7F80            DC.B      '~     '
58F0   7C00 6C00 4600            DC.B      '| l F '
58F6   0600 0300 0300            DC.B      '      '
58FC   0000 C000 E000            DC.B      '      '
5902   F000 F800 FC00            DC.B      '      '
5908   FE00 FF00 FF80            DC.B      '      '
590E   FFC0 FFE0 FE00            DC.B      '      '
5914   EF00 CF00 8780            DC.B      '      '
591A   0780 0380 0001            DC.B      '      '
5920   0001 77DD 77DD            DC.B      '  w w '
5926   77DD 77DD 8822            DC.B      'w w  "'
592C   8822 8822 8822            DC.B      ' " " "'
5932   AA55 AA55 AA55            DC.B      ' U U U'
5938   AA55 FFFF FFFF            DC.B      ' U    '
593E   FFFF FFFF 0000            DC.B      '      '
5944   0000 0000 0000            DC.B      '      '

                      P_tOpenPort:
594A   42A7                      Clr.L     -(A7)
594C   4EBA 3534                 Jsr       P_tNewRgn
5950   42A7                      Clr.L     -(A7)
5952   4EBA 352E                 Jsr       P_tNewRgn
5956   206F 000C                 Move.L    $C(A7), A0
595A   215F 001C                 Move.L    (A7)+, $1C(A0)
595E   215F 0018                 Move.L    (A7)+, $18(A0)

                      P_tInitPort:
5962   2055                      Move.L    (A5), A0
5964   226F 0004                 Move.L    $4(A7), A1
5968   2089                      Move.L    A1, (A0)
596A   4259                      Clr       (A1)+
596C   41E8 FF86                 Lea.L     $-7A(A0), A0
5970   22D8                      Move.L    (A0)+, (A1)+
5972   32D8                      Move      (A0)+, (A1)+
5974   22D0                      Move.L    (A0), (A1)+
5976   22E8 0004                 Move.L    $4(A0), (A1)+
597A   22D0                      Move.L    (A0), (A1)+
597C   22E8 0004                 Move.L    $4(A0), (A1)+
5980   2F19                      Move.L    (A1)+, -(A7)
5982   2F08                      Move.L    A0, -(A7)
5984   4EBA 3674                 Jsr       P_tRectRgn
5988   226F 0004                 Move.L    $4(A7), A1
598C   2055                      Move.L    (A5), A0
598E   2F28 FF7E                 Move.L    $-82(A0), -(A7)
5992   2F29 001C                 Move.L    $1C(A1), -(A7)
5996   4EBA 35AA                 Jsr       P_tCopyRgn
599A   226F 0004                 Move.L    $4(A7), A1
599E   43E9 0020                 Lea.L     $20(A1), A1
59A2   4299                      Clr.L     (A1)+
59A4   4299                      Clr.L     (A1)+
59A6   70FF                      MoveQ.L   $-1, D0
59A8   22C0                      Move.L    D0, (A1)+
59AA   22C0                      Move.L    D0, (A1)+
59AC   4299                      Clr.L     (A1)+
59AE   22FC 0001 0001            Move.L    $10001, (A1)+
59B4   32FC 0008                 Move      $8, (A1)+
59B8   22C0                      Move.L    D0, (A1)+
59BA   22C0                      Move.L    D0, (A1)+
59BC   4259                      Clr       (A1)+
59BE   4299                      Clr.L     (A1)+
59C0   32FC 0001                 Move      $1, (A1)+
59C4   4259                      Clr       (A1)+
59C6   4299                      Clr.L     (A1)+
59C8   22FC 0000 0021            Move.L    $21, (A1)+
59CE   22FC 0000 001E            Move.L    $1E, (A1)+
59D4   4299                      Clr.L     (A1)+
59D6   4299                      Clr.L     (A1)+
59D8   4299                      Clr.L     (A1)+
59DA   4299                      Clr.L     (A1)+
59DC   4299                      Clr.L     (A1)+
59DE   2E9F                      Move.L    (A7)+, (A7)
59E0   4E75                      Rts

                      P_tClosePort:
59E2   206F 0004                 Move.L    $4(A7), A0
59E6   2F28 001C                 Move.L    $1C(A0), -(A7)
59EA   4EBA 34BA                 Jsr       P_tDisposeRgn
59EE   206F 0004                 Move.L    $4(A7), A0
59F2   2F28 0018                 Move.L    $18(A0), -(A7)
59F6   4EBA 34AE                 Jsr       P_tDisposeRgn
59FA   2E9F                      Move.L    (A7)+, (A7)
59FC   4E75                      Rts

                      P_tSetStdProcs:
59FE   226F 0004                 Move.L    $4(A7), A1
5A02   41FA 0202                 Lea.L     P_tStdText, A0
5A06   22C8                      Move.L    A0, (A1)+
5A08   41FA 0D06                 Lea.L     P_tStdLine, A0
5A0C   22C8                      Move.L    A0, (A1)+
5A0E   41FA 150C                 Lea.L     P_tStdRect, A0
5A12   22C8                      Move.L    A0, (A1)+
5A14   41FA 2274                 Lea.L     P_tStdRRect, A0
5A18   22C8                      Move.L    A0, (A1)+
5A1A   41FA 235A                 Lea.L     P_tStdOval, A0
5A1E   22C8                      Move.L    A0, (A1)+
5A20   41FA 2564                 Lea.L     P_tStdArc, A0
5A24   22C8                      Move.L    A0, (A1)+
5A26   41FA 306C                 Lea.L     P_tStdPoly, A0
5A2A   22C8                      Move.L    A0, (A1)+
5A2C   41FA 32EA                 Lea.L     P_tStdRgn, A0
5A30   22C8                      Move.L    A0, (A1)+
5A32   41FA 3FEA                 Lea.L     P_tStdBits, A0
5A36   22C8                      Move.L    A0, (A1)+
5A38   41FA 4AA2                 Lea.L     P_tStdComment, A0
5A3C   22C8                      Move.L    A0, (A1)+
5A3E   41FA 047E                 Lea.L     P_tStdTxMeas, A0
5A42   22C8                      Move.L    A0, (A1)+
5A44   41FA 4AFE                 Lea.L     P_tStdGetPic, A0
5A48   22C8                      Move.L    A0, (A1)+
5A4A   41FA 4B1C                 Lea.L     P_tStdPutPic, A0
5A4E   22C8                      Move.L    A0, (A1)+
5A50   2E9F                      Move.L    (A7)+, (A7)
5A52   4E75                      Rts

                      P_tLocalToGlobal:
5A54   48E7 80C0                 MoveM.L   D0/A0-A1, -(A7)
5A58   2055                      Move.L    (A5), A0
5A5A   2050                      Move.L    (A0), A0
5A5C   226F 0010                 Move.L    $10(A7), A1
5A60   3028 0008                 Move      $8(A0), D0
5A64   9159                      Sub       D0, (A1)+
5A66   3028 000A                 Move      $A(A0), D0
5A6A   9159                      Sub       D0, (A1)+
5A6C   4CDF 0301                 MoveM.L   (A7)+, D0/A0-A1
5A70   2E9F                      Move.L    (A7)+, (A7)
5A72   4E75                      Rts

                      P_tGlobalToLocal:
5A74   48E7 80C0                 MoveM.L   D0/A0-A1, -(A7)
5A78   2055                      Move.L    (A5), A0
5A7A   2050                      Move.L    (A0), A0
5A7C   226F 0010                 Move.L    $10(A7), A1
5A80   3028 0008                 Move      $8(A0), D0
5A84   D159                      Add       D0, (A1)+
5A86   3028 000A                 Move      $A(A0), D0
5A8A   D159                      Add       D0, (A1)+
5A8C   4CDF 0301                 MoveM.L   (A7)+, D0/A0-A1
5A90   2E9F                      Move.L    (A7)+, (A7)
5A92   4E75                      Rts

                      P_tGrafDevice:
5A94   7000                      MoveQ.L   $0, D0
5A96   4EFA FB9A                 Jmp       L_mPortWord

                      P_tSetPort:
5A9A   2055                      Move.L    (A5), A0
5A9C   20AF 0004                 Move.L    $4(A7), (A0)
5AA0   2E9F                      Move.L    (A7)+, (A7)
5AA2   4E75                      Rts

                      P_tGetPort:
5AA4   2055                      Move.L    (A5), A0
5AA6   226F 0004                 Move.L    $4(A7), A1
5AAA   2290                      Move.L    (A0), (A1)
5AAC   2E9F                      Move.L    (A7)+, (A7)
5AAE   4E75                      Rts

                      P_tSetPBits:
5AB0   2055                      Move.L    (A5), A0
5AB2   2050                      Move.L    (A0), A0
5AB4   41E8 0002                 Lea.L     $2(A0), A0
5AB8   226F 0004                 Move.L    $4(A7), A1
5ABC   20D9                      Move.L    (A1)+, (A0)+
5ABE   30D9                      Move      (A1)+, (A0)+
5AC0   20D9                      Move.L    (A1)+, (A0)+
5AC2   20D9                      Move.L    (A1)+, (A0)+
5AC4   2E9F                      Move.L    (A7)+, (A7)
5AC6   4E75                      Rts

                      P_tPortSize:
5AC8   2055                      Move.L    (A5), A0
5ACA   2050                      Move.L    (A0), A0
5ACC   3028 0012                 Move      $12(A0), D0
5AD0   D06F 0006                 Add       $6(A7), D0
5AD4   3140 0016                 Move      D0, $16(A0)
5AD8   3028 0010                 Move      $10(A0), D0
5ADC   D06F 0004                 Add       $4(A7), D0
5AE0   3140 0014                 Move      D0, $14(A0)
5AE4   2E9F                      Move.L    (A7)+, (A7)
5AE6   4E75                      Rts

                      P_tMovePortTo:
5AE8   2055                      Move.L    (A5), A0
5AEA   2050                      Move.L    (A0), A0
5AEC   3028 0012                 Move      $12(A0), D0
5AF0   9068 000A                 Sub       $A(A0), D0
5AF4   906F 0006                 Sub       $6(A7), D0
5AF8   3228 0010                 Move      $10(A0), D1
5AFC   9268 0008                 Sub       $8(A0), D1
5B00   926F 0004                 Sub       $4(A7), D1
5B04   D168 000A                 Add       D0, $A(A0)
5B08   D168 000E                 Add       D0, $E(A0)
5B0C   D368 0008                 Add       D1, $8(A0)
5B10   D368 000C                 Add       D1, $C(A0)
5B14   2E9F                      Move.L    (A7)+, (A7)
5B16   4E75                      Rts

                      P_tSetOrigin:
5B18   2055                      Move.L    (A5), A0
5B1A   2050                      Move.L    (A0), A0
5B1C   202F 0004                 Move.L    $4(A7), D0
5B20   B0A8 0010                 Cmp.L     $10(A0), D0
5B24   673C                      BEQ       L1014
5B26   302F 0006                 Move      $6(A7), D0
5B2A   9068 0012                 Sub       $12(A0), D0
5B2E   322F 0004                 Move      $4(A7), D1
5B32   9268 0010                 Sub       $10(A0), D1
5B36   D168 000A                 Add       D0, $A(A0)
5B3A   D168 000E                 Add       D0, $E(A0)
5B3E   D368 0008                 Add       D1, $8(A0)
5B42   D368 000C                 Add       D1, $C(A0)
5B46   D168 0012                 Add       D0, $12(A0)
5B4A   D168 0016                 Add       D0, $16(A0)
5B4E   D368 0010                 Add       D1, $10(A0)
5B52   D368 0014                 Add       D1, $14(A0)
5B56   2F28 0018                 Move.L    $18(A0), -(A7)
5B5A   3F00                      Move      D0, -(A7)
5B5C   3F01                      Move      D1, -(A7)
5B5E   4EBA 34A8                 Jsr       P_tOffsetRgn
5B62   2E9F           L1014:     Move.L    (A7)+, (A7)
5B64   4E75                      Rts

                      P_tSetClip:
5B66   205F                      Move.L    (A7)+, A0
5B68   2255                      Move.L    (A5), A1
5B6A   2251                      Move.L    (A1), A1
5B6C   2F29 001C                 Move.L    $1C(A1), -(A7)
5B70   2F08                      Move.L    A0, -(A7)
5B72   4EFA 33CE                 Jmp       P_tCopyRgn

                      P_tGetClip:
5B76   205F                      Move.L    (A7)+, A0
5B78   201F                      Move.L    (A7)+, D0
5B7A   2255                      Move.L    (A5), A1
5B7C   2251                      Move.L    (A1), A1
5B7E   2F29 001C                 Move.L    $1C(A1), -(A7)
5B82   2F00                      Move.L    D0, -(A7)
5B84   2F08                      Move.L    A0, -(A7)
5B86   4EFA 33BA                 Jmp       P_tCopyRgn

                      P_tClipRect:
5B8A   2055                      Move.L    (A5), A0
5B8C   2050                      Move.L    (A0), A0
5B8E   226F 0004                 Move.L    $4(A7), A1
5B92   2F28 001C                 Move.L    $1C(A0), -(A7)
5B96   2F09                      Move.L    A1, -(A7)
5B98   4EBA 3460                 Jsr       P_tRectRgn
5B9C   2E9F                      Move.L    (A7)+, (A7)
5B9E   4E75                      Rts

                      P_tBackPat:
5BA0   2055                      Move.L    (A5), A0
5BA2   2050                      Move.L    (A0), A0
5BA4   41E8 0020                 Lea.L     $20(A0), A0
5BA8   226F 0004                 Move.L    $4(A7), A1
5BAC   20D9                      Move.L    (A1)+, (A0)+
5BAE   20D9                      Move.L    (A1)+, (A0)+
5BB0   2E9F                      Move.L    (A7)+, (A7)
5BB2   4E75                      Rts

                      P_tAddPt:
5BB4   48E7 8080                 MoveM.L   D0/A0, -(A7)
5BB8   206F 000C                 Move.L    $C(A7), A0
5BBC   302F 0010                 Move      $10(A7), D0
5BC0   D158                      Add       D0, (A0)+
5BC2   302F 0012                 Move      $12(A7), D0
5BC6   D158                      Add       D0, (A0)+
5BC8   4CDF 0101                 MoveM.L   (A7)+, D0/A0
5BCC   2E9F                      Move.L    (A7)+, (A7)
5BCE   2E9F                      Move.L    (A7)+, (A7)
5BD0   4E75                      Rts

                      P_tSubPt:
5BD2   48E7 8080                 MoveM.L   D0/A0, -(A7)
5BD6   206F 000C                 Move.L    $C(A7), A0
5BDA   302F 0010                 Move      $10(A7), D0
5BDE   9158                      Sub       D0, (A0)+
5BE0   302F 0012                 Move      $12(A7), D0
5BE4   9158                      Sub       D0, (A0)+
5BE6   4CDF 0101                 MoveM.L   (A7)+, D0/A0
5BEA   2E9F                      Move.L    (A7)+, (A7)
5BEC   2E9F                      Move.L    (A7)+, (A7)
5BEE   4E75                      Rts

                      P_tSetPt:
5BF0   205F                      Move.L    (A7)+, A0
5BF2   201F                      Move.L    (A7)+, D0
5BF4   225F                      Move.L    (A7)+, A1
5BF6   2280                      Move.L    D0, (A1)
5BF8   4ED0                      Jmp       (A0)

                      P_tEqualPt:
5BFA   205F                      Move.L    (A7)+, A0
5BFC   201F                      Move.L    (A7)+, D0
5BFE   B09F                      Cmp.L     (A7)+, D0
5C00   57D7                      SEQ.B     (A7)
5C02   4417                      Neg.B     (A7)
5C04   4ED0                      Jmp       (A0)

                      P_tStdText:
5C06   4E56 FFFC                 Link      A6, $-4
5C0A   48E7 0718                 MoveM.L   D5-D7/A3-A4, -(A7)
5C0E   3C2E 0014                 Move      $14(A6), D6
5C12   6F00 017A                 BLE       L1029
5C16   4EBA 544A                 Jsr       P_mCheckPic
5C1A   6F00 0160                 BLE       L1028
5C1E   286B 005C                 Move.L    $5C(A3), A4
5C22   2854                      Move.L    (A4), A4
5C24   3E2B 0044                 Move      $44(A3), D7
5C28   BE6C 0012                 Cmp       $12(A4), D7
5C2C   6718                      BEQ       L1015
5C2E   1F3C 0003                 Move.B    $3, -(A7)
5C32   4EBA 527C                 Jsr       P_mPutPicByte
5C36   3F07                      Move      D7, -(A7)
5C38   4EBA 5288                 Jsr       P_mPutPicWord
5C3C   286B 005C                 Move.L    $5C(A3), A4
5C40   2854                      Move.L    (A4), A4
5C42   3947 0012                 Move      D7, $12(A4)
5C46   1E2B 0046      L1015:     Move.B    $46(A3), D7
5C4A   BE2C 0014                 Cmp.B     $14(A4), D7
5C4E   6718                      BEQ       L1016
5C50   1F3C 0004                 Move.B    $4, -(A7)
5C54   4EBA 525A                 Jsr       P_mPutPicByte
5C58   1F07                      Move.B    D7, -(A7)
5C5A   4EBA 5254                 Jsr       P_mPutPicByte
5C5E   286B 005C                 Move.L    $5C(A3), A4
5C62   2854                      Move.L    (A4), A4
5C64   1947 0014                 Move.B    D7, $14(A4)
5C68   3E2B 0048      L1016:     Move      $48(A3), D7
5C6C   BE6C 0016                 Cmp       $16(A4), D7
5C70   6718                      BEQ       L1017
5C72   1F3C 0005                 Move.B    $5, -(A7)
5C76   4EBA 5238                 Jsr       P_mPutPicByte
5C7A   3F07                      Move      D7, -(A7)
5C7C   4EBA 5244                 Jsr       P_mPutPicWord
5C80   286B 005C                 Move.L    $5C(A3), A4
5C84   2854                      Move.L    (A4), A4
5C86   3947 0016                 Move      D7, $16(A4)
5C8A   3E2B 004A      L1017:     Move      $4A(A3), D7
5C8E   BE6C 0018                 Cmp       $18(A4), D7
5C92   6718                      BEQ       L1018
5C94   1F3C 000D                 Move.B    $D, -(A7)
5C98   4EBA 5216                 Jsr       P_mPutPicByte
5C9C   3F07                      Move      D7, -(A7)
5C9E   4EBA 5222                 Jsr       P_mPutPicWord
5CA2   286B 005C                 Move.L    $5C(A3), A4
5CA6   2854                      Move.L    (A4), A4
5CA8   3947 0018                 Move      D7, $18(A4)
5CAC   2E2B 004C      L1018:     Move.L    $4C(A3), D7
5CB0   BEAC 001A                 Cmp.L     $1A(A4), D7
5CB4   6718                      BEQ       L1019
5CB6   1F3C 0006                 Move.B    $6, -(A7)
5CBA   4EBA 51F4                 Jsr       P_mPutPicByte
5CBE   2F07                      Move.L    D7, -(A7)
5CC0   4EBA 5212                 Jsr       P_mPutPicLong
5CC4   286B 005C                 Move.L    $5C(A3), A4
5CC8   2854                      Move.L    (A4), A4
5CCA   2947 001A                 Move.L    D7, $1A(A4)
5CCE   2E2E 000C      L1019:     Move.L    $C(A6), D7
5CD2   2A2E 0008                 Move.L    $8(A6), D5
5CD6   BEAC 001E                 Cmp.L     $1E(A4), D7
5CDA   6606                      BNE       L1020
5CDC   BAAC 0022                 Cmp.L     $22(A4), D5
5CE0   6722                      BEQ       L1021
5CE2   1F3C 0010      L1020:     Move.B    $10, -(A7)
5CE6   4EBA 51C8                 Jsr       P_mPutPicByte
5CEA   2F07                      Move.L    D7, -(A7)
5CEC   4EBA 51E6                 Jsr       P_mPutPicLong
5CF0   2F05                      Move.L    D5, -(A7)
5CF2   4EBA 51E0                 Jsr       P_mPutPicLong
5CF6   286B 005C                 Move.L    $5C(A3), A4
5CFA   2854                      Move.L    (A4), A4
5CFC   2947 001E                 Move.L    D7, $1E(A4)
5D00   2945 0022                 Move.L    D5, $22(A4)
5D04   2A2B 0030      L1021:     Move.L    $30(A3), D5
5D08   9AAC 0026                 Sub.L     $26(A4), D5
5D0C   2005                      Move.L    D5, D0
5D0E   0280 FF00 FF00            And.L     $-FF0100, D0
5D14   6712                      BEQ       L1022
5D16   1F3C 0028                 Move.B    $28, -(A7)
5D1A   4EBA 5194                 Jsr       P_mPutPicByte
5D1E   2F2B 0030                 Move.L    $30(A3), -(A7)
5D22   4EBA 51B0                 Jsr       P_mPutPicLong
5D26   6038                      Bra       L1027
5D28   2005           L1022:     Move.L    D5, D0
5D2A   0280 00FF 0000            And.L     $FF0000, D0
5D30   660A                      BNE       L1023
5D32   1F3C 0029                 Move.B    $29, -(A7)
5D36   4EBA 5178                 Jsr       P_mPutPicByte
5D3A   601E                      Bra       L1026
5D3C   4A05           L1023:     Tst.B     D5
5D3E   660A                      BNE       L1024
5D40   1F3C 002A                 Move.B    $2A, -(A7)
5D44   4EBA 516A                 Jsr       P_mPutPicByte
5D48   600E                      Bra       L1025
5D4A   1F3C 002B      L1024:     Move.B    $2B, -(A7)
5D4E   4EBA 5160                 Jsr       P_mPutPicByte
5D52   1F05                      Move.B    D5, -(A7)
5D54   4EBA 515A                 Jsr       P_mPutPicByte
5D58   4845           L1025:     Swap      D5
5D5A   1F05           L1026:     Move.B    D5, -(A7)
5D5C   4EBA 5152                 Jsr       P_mPutPicByte
5D60   1F06           L1027:     Move.B    D6, -(A7)
5D62   4EBA 514C                 Jsr       P_mPutPicByte
5D66   2F2E 0010                 Move.L    $10(A6), -(A7)
5D6A   3F06                      Move      D6, -(A7)
5D6C   4EBA 512C                 Jsr       P_mPutPicData
5D70   286B 005C                 Move.L    $5C(A3), A4
5D74   2854                      Move.L    (A4), A4
5D76   296B 0030 0026            Move.L    $30(A3), $26(A4)
5D7C   3F06           L1028:     Move      D6, -(A7)
5D7E   2F2E 0010                 Move.L    $10(A6), -(A7)
5D82   2F2E 000C                 Move.L    $C(A6), -(A7)
5D86   2F2E 0008                 Move.L    $8(A6), -(A7)
5D8A   4EBA 0320                 Jsr       P_mDrText
5D8E   4CDF 18E0      L1029:     MoveM.L   (A7)+, D5-D7/A3-A4
5D92   4E5E                      Unlk      A6
5D94   205F                      Move.L    (A7)+, A0
5D96   DEFC 000E                 AddA      $E, A7
5D9A   4ED0                      Jmp       (A0)

                      P_mCallText:
5D9C   205F                      Move.L    (A7)+, A0
5D9E   2F3C 0001 0001            Move.L    $10001, -(A7)
5DA4   2F17                      Move.L    (A7), -(A7)
5DA6   2F08                      Move.L    A0, -(A7)
5DA8   2055                      Move.L    (A5), A0
5DAA   2050                      Move.L    (A0), A0
5DAC   2028 0068                 Move.L    $68(A0), D0
5DB0   41FA FE54                 Lea.L     P_tStdText, A0
5DB4   6704                      BEQ       L1030
5DB6   2040                      Move.L    D0, A0
5DB8   2050                      Move.L    (A0), A0
5DBA   4ED0           L1030:     Jmp       (A0)

                      P_tTextFont:
5DBC   7044                      MoveQ.L   $44, D0
5DBE   4EFA F872                 Jmp       L_mPortWord

                      P_tTextFace:
5DC2   2055                      Move.L    (A5), A0
5DC4   2050                      Move.L    (A0), A0
5DC6   116F 0005 0046            Move.B    $5(A7), $46(A0)
5DCC   205F                      Move.L    (A7)+, A0
5DCE   544F                      AddQ      $2, A7
5DD0   4ED0                      Jmp       (A0)

                      P_tTextMode:
5DD2   7048                      MoveQ.L   $48, D0
5DD4   4EFA F85C                 Jmp       L_mPortWord

                      P_tTextSize:
5DD8   704A                      MoveQ.L   $4A, D0
5DDA   4EFA F856                 Jmp       L_mPortWord

                      P_tSpaceExtra:
5DDE   2055                      Move.L    (A5), A0
5DE0   2050                      Move.L    (A0), A0
5DE2   216F 0004 004C            Move.L    $4(A7), $4C(A0)
5DE8   2E9F                      Move.L    (A7)+, (A7)
5DEA   4E75                      Rts

                      P_tDrawChar:
5DEC   3F3C 0001                 Move      $1, -(A7)
5DF0   486F 0007                 Pea.L     $7(A7)
5DF4   4EBA FFA6                 Jsr       P_mCallText
5DF8   205F                      Move.L    (A7)+, A0
5DFA   544F                      AddQ      $2, A7
5DFC   4ED0                      Jmp       (A0)

                      P_tDrawString:
5DFE   206F 0004                 Move.L    $4(A7), A0
5E02   4240                      Clr       D0
5E04   1018                      Move.B    (A0)+, D0
5E06   3F00                      Move      D0, -(A7)
5E08   2F08                      Move.L    A0, -(A7)
5E0A   4EBA FF90                 Jsr       P_mCallText
5E0E   2E9F                      Move.L    (A7)+, (A7)
5E10   4E75                      Rts

                      P_tDrawText:
5E12   206F 0008                 Move.L    $8(A7), A0
5E16   D0EF 0006                 AddA      $6(A7), A0
5E1A   302F 0004                 Move      $4(A7), D0
5E1E   3F00                      Move      D0, -(A7)
5E20   2F08                      Move.L    A0, -(A7)
5E22   4EBA FF78                 Jsr       P_mCallText
5E26   205F                      Move.L    (A7)+, A0
5E28   504F                      AddQ      $8, A7
5E2A   4ED0                      Jmp       (A0)

                      P_tCharWidth:
5E2C   4267                      Clr       -(A7)
5E2E   2F0F                      Move.L    A7, -(A7)
5E30   3F3C 0007                 Move      $7, -(A7)
5E34   3F3C 0001                 Move      $1, -(A7)
5E38   4EBA 0020                 Jsr       P_tTextWidth
5E3C   3F5F 0006                 Move      (A7)+, $6(A7)
5E40   205F                      Move.L    (A7)+, A0
5E42   544F                      AddQ      $2, A7
5E44   4ED0                      Jmp       (A0)

                      P_tStringWidth:
5E46   225F                      Move.L    (A7)+, A1
5E48   205F                      Move.L    (A7)+, A0
5E4A   4240                      Clr       D0
5E4C   1018                      Move.B    (A0)+, D0
5E4E   2F08                      Move.L    A0, -(A7)
5E50   4267                      Clr       -(A7)
5E52   3F00                      Move      D0, -(A7)
5E54   2F09                      Move.L    A1, -(A7)
5E56   4EFA 0002                 Jmp       P_tTextWidth

                      P_tTextWidth:
5E5A   4E56 FFF0                 Link      A6, $-10
5E5E   426E 0010                 Clr       $10(A6)
5E62   4267                      Clr       -(A7)
5E64   3F2E 0008                 Move      $8(A6), -(A7)
5E68   6F4C                      BLE       L1033
5E6A   206E 000C                 Move.L    $C(A6), A0
5E6E   D0EE 000A                 AddA      $A(A6), A0
5E72   2F08                      Move.L    A0, -(A7)
5E74   2D7C 0001 0001            Move.L    $10001, $-C(A6)
       FFF4
5E7C   2D7C 0001 0001            Move.L    $10001, $-10(A6)
       FFF0
5E84   486E FFF4                 Pea.L     $-C(A6)
5E88   486E FFF0                 Pea.L     $-10(A6)
5E8C   486E FFF8                 Pea.L     $-8(A6)
5E90   2055                      Move.L    (A5), A0
5E92   2050                      Move.L    (A0), A0
5E94   2028 0068                 Move.L    $68(A0), D0
5E98   6606                      BNE       L1031
5E9A   4EBA 0022                 Jsr       P_tStdTxMeas
5E9E   6008                      Bra       L1032
5EA0   2040           L1031:     Move.L    D0, A0
5EA2   2068 0028                 Move.L    $28(A0), A0
5EA6   4E90                      Jsr       (A0)
5EA8   321F           L1032:     Move      (A7)+, D1
5EAA   C2EE FFF6                 MulU      $-A(A6), D1
5EAE   82EE FFF2                 DivU      $-E(A6), D1
5EB2   3D41 0010                 Move      D1, $10(A6)
5EB6   4E5E           L1033:     Unlk      A6
5EB8   205F                      Move.L    (A7)+, A0
5EBA   504F                      AddQ      $8, A7
5EBC   4ED0                      Jmp       (A0)

                      P_tStdTxMeas:
5EBE   4E56 FFEC                 Link      A6, $-14
5EC2   48E7 1F38                 MoveM.L   D3-D7/A2-A4, -(A7)
5EC6   426E 001A                 Clr       $1A(A6)
5ECA   2855                      Move.L    (A5), A4
5ECC   2654                      Move.L    (A4), A3
5ECE   296B 004C FF54            Move.L    $4C(A3), $-AC(A4)
5ED4   43EE FFF0                 Lea.L     $-10(A6), A1
5ED8   32EB 0044                 Move      $44(A3), (A1)+
5EDC   32EB 004A                 Move      $4A(A3), (A1)+
5EE0   12EB 0046                 Move.B    $46(A3), (A1)+
5EE4   4A6B 0042                 Tst       $42(A3)
5EE8   5AD9                      SPL.B     (A1)+
5EEA   32D3                      Move      (A3), (A1)+
5EEC   206E 0010                 Move.L    $10(A6), A0
5EF0   22D0                      Move.L    (A0), (A1)+
5EF2   206E 000C                 Move.L    $C(A6), A0
5EF6   22D0                      Move.L    (A0), (A1)+
5EF8   42A7                      Clr.L     -(A7)
5EFA   486E FFF0                 Pea.L     $-10(A6)
5EFE   4EBA 010A                 Jsr       P208
5F02   2957 FF50                 Move.L    (A7), $-B0(A4)
5F06   285F                      Move.L    (A7)+, A4
5F08   206E 0008                 Move.L    $8(A6), A0
5F0C   4290                      Clr.L     (A0)
5F0E   42A8 0004                 Clr.L     $4(A0)
5F12   4AAC 0002                 Tst.L     $2(A4)
5F16   6700 00E4                 BEQ       L1042
5F1A   116C 000D 0001            Move.B    $D(A4), $1(A0)
5F20   116C 000E 0003            Move.B    $E(A4), $3(A0)
5F26   116C 000F 0005            Move.B    $F(A4), $5(A0)
5F2C   102C 0010                 Move.B    $10(A4), D0
5F30   4880                      Ext       D0
5F32   3140 0006                 Move      D0, $6(A0)
5F36   206E 0010                 Move.L    $10(A6), A0
5F3A   20AC 0012                 Move.L    $12(A4), (A0)
5F3E   206E 000C                 Move.L    $C(A6), A0
5F42   20AC 0016                 Move.L    $16(A4), (A0)
5F46   2A2B 004C                 Move.L    $4C(A3), D5
5F4A   6732                      BEQ       L1034
5F4C   42A7                      Clr.L     -(A7)
5F4E   42A7                      Clr.L     -(A7)
5F50   42A7                      Clr.L     -(A7)
5F52   3F2E FFFA                 Move      $-6(A6), -(A7)
5F56   3F2E FFFE                 Move      $-2(A6), -(A7)
5F5A   4EBA F8A2                 Jsr       P_tFixRatio
5F5E   42A7                      Clr.L     -(A7)
5F60   3F2C 0018                 Move      $18(A4), -(A7)
5F64   3F2C 0014                 Move      $14(A4), -(A7)
5F68   4EBA F894                 Jsr       P_tFixRatio
5F6C   4EBA F86E                 Jsr       P_tFixMul
5F70   2F05                      Move.L    D5, -(A7)
5F72   4EBA F868                 Jsr       P_tFixMul
5F76   2A1F                      Move.L    (A7)+, D5
5F78   2055                      Move.L    (A5), A0
5F7A   2145 FF54                 Move.L    D5, $-AC(A0)
5F7E   342E 0018      L1034:     Move      $18(A6), D2
5F82   6F78                      BLE       L1042
5F84   246C 0002                 Move.L    $2(A4), A2
5F88   2452                      Move.L    (A2), A2
5F8A   122C 000C                 Move.B    $C(A4), D1
5F8E   4881                      Ext       D1
5F90   4A85                      Tst.L     D5
5F92   6612                      BNE       L1035
5F94   3012                      Move      (A2), D0
5F96   0240 2000                 And       $2000, D0
5F9A   670A                      BEQ       L1035
5F9C   D26A 0006                 Add       $6(A2), D1
5FA0   C3C2                      MulW      D2, D1
5FA2   6000 0054                 Bra       L1041
5FA6   42AE FFEC      L1035:     Clr.L     $-14(A6)
5FAA   206E 0014                 Move.L    $14(A6), A0
5FAE   C3C2                      MulW      D2, D1
5FB0   224A                      Move.L    A2, A1
5FB2   D2EA 0010                 AddA      $10(A2), A1
5FB6   D2EA 0010                 AddA      $10(A2), A1
5FBA   362A 0002                 Move      $2(A2), D3
5FBE   382A 0004                 Move      $4(A2), D4
5FC2   4240                      Clr       D0
5FC4   602A                      Bra       L1040
5FC6   1018           L1036:     Move.B    (A0)+, D0
5FC8   0C00 0020                 Cmp.B     $20, D0
5FCC   6604                      BNE       L1037
5FCE   DBAE FFEC                 Add.L     D5, $-14(A6)
5FD2   B044           L1037:     Cmp       D4, D0
5FD4   6F04                      BLE       L1039
5FD6   3004           L1038:     Move      D4, D0
5FD8   5240                      AddQ      $1, D0
5FDA   9043           L1039:     Sub       D3, D0
5FDC   6DF8                      BLT       L1038
5FDE   D040                      Add       D0, D0
5FE0   3031 0010                 Move      $10(A1,D0.W), D0
5FE4   0C40 FFFF                 Cmp       $-1, D0
5FE8   67EC                      BEQ       L1038
5FEA   0240 00FF                 And       $FF, D0
5FEE   D240                      Add       D0, D1
5FF0   51CA FFD4      L1040:     DBF       D2, L1036
5FF4   D26E FFEC                 Add       $-14(A6), D1
5FF8   3D41 001A      L1041:     Move      D1, $1A(A6)
5FFC   4CDF 1CF8      L1042:     MoveM.L   (A7)+, D3-D7/A2-A4
6000   4E5E                      Unlk      A6
6002   205F                      Move.L    (A7)+, A0
6004   DEFC 0012                 AddA      $12, A7
6008   4ED0                      Jmp       (A0)

                      P208:
600A   4EFA 526E                 Jmp       P_tFMSwapFont

                      P_tGetFontInfo:
600E   4E56 FFF8                 Link      A6, $-8
6012   2D7C 0001 0001            Move.L    $10001, $-4(A6)
       FFFC
601A   2D7C 0001 0001            Move.L    $10001, $-8(A6)
       FFF8
6022   42A7                      Clr.L     -(A7)
6024   42A7                      Clr.L     -(A7)
6026   486E FFFC                 Pea.L     $-4(A6)
602A   486E FFF8                 Pea.L     $-8(A6)
602E   2F2E 0008                 Move.L    $8(A6), -(A7)
6032   2055                      Move.L    (A5), A0
6034   2050                      Move.L    (A0), A0
6036   2028 0068                 Move.L    $68(A0), D0
603A   41FA FE82                 Lea.L     P_tStdTxMeas, A0
603E   6706                      BEQ       L1043
6040   2040                      Move.L    D0, A0
6042   2068 0028                 Move.L    $28(A0), A0
6046   4E90           L1043:     Jsr       (A0)
6048   4A5F                      Tst       (A7)+
604A   2055                      Move.L    (A5), A0
604C   2068 FF50                 Move.L    $-B0(A0), A0
6050   226E 0008                 Move.L    $8(A6), A1
6054   1028 000C                 Move.B    $C(A0), D0
6058   4880                      Ext       D0
605A   D169 0004                 Add       D0, $4(A1)
605E   4240                      Clr       D0
6060   1028 000B                 Move.B    $B(A0), D0
6064   6706                      BEQ       L1044
6066   5251                      AddQ      $1, (A1)
6068   D169 0002                 Add       D0, $2(A1)
606C   202E FFFC      L1044:     Move.L    $-4(A6), D0
6070   B0AE FFF8                 Cmp.L     $-8(A6), D0
6074   6730                      BEQ       L1045
6076   3011                      Move      (A1), D0
6078   C0EE FFFC                 MulU      $-4(A6), D0
607C   80EE FFF8                 DivU      $-8(A6), D0
6080   32C0                      Move      D0, (A1)+
6082   3011                      Move      (A1), D0
6084   C0EE FFFC                 MulU      $-4(A6), D0
6088   80EE FFF8                 DivU      $-8(A6), D0
608C   32C0                      Move      D0, (A1)+
608E   3011                      Move      (A1), D0
6090   C0EE FFFE                 MulU      $-2(A6), D0
6094   80EE FFFA                 DivU      $-6(A6), D0
6098   32C0                      Move      D0, (A1)+
609A   3011                      Move      (A1), D0
609C   C0EE FFFC                 MulU      $-4(A6), D0
60A0   80EE FFF8                 DivU      $-8(A6), D0
60A4   32C0                      Move      D0, (A1)+
60A6   4E5E           L1045:     Unlk      A6
60A8   2E9F                      Move.L    (A7)+, (A7)
60AA   4E75                      Rts

                      P_mDrText:
60AC   4E56 FF54                 Link      A6, $-AC
60B0   48E7 FF78                 MoveM.L   D0-D7/A1-A4, -(A7)
60B4   2D4F FFFC                 Move.L    A7, $-4(A6)
60B8   2855                      Move.L    (A5), A4
60BA   2654                      Move.L    (A4), A3
60BC   4267                      Clr       -(A7)
60BE   3F2E 0014                 Move      $14(A6), -(A7)
60C2   6F00 063A                 BLE       L1092
60C6   2F2E 0010                 Move.L    $10(A6), -(A7)
60CA   486E 000C                 Pea.L     $C(A6)
60CE   486E 0008                 Pea.L     $8(A6)
60D2   486E FF58                 Pea.L     $-A8(A6)
60D6   4EBA FDE6                 Jsr       P_tStdTxMeas
60DA   321F                      Move      (A7)+, D1
60DC   286C FF50                 Move.L    $-B0(A4), A4
60E0   4AAC 0002                 Tst.L     $2(A4)
60E4   6700 0618                 BEQ       L1092
60E8   3D41 FFFA                 Move      D1, $-6(A6)
60EC   2D6B 0030 FF96            Move.L    $30(A3), $-6A(A6)
60F2   C2EE 000E                 MulU      $E(A6), D1
60F6   82EE 000A                 DivU      $A(A6), D1
60FA   D36B 0032                 Add       D1, $32(A3)
60FE   4A6B 0042                 Tst       $42(A3)
6102   6D00 05FA                 BLT       L1092
6106   246C 0002                 Move.L    $2(A4), A2
610A   2452                      Move.L    (A2), A2
610C   302E FF96                 Move      $-6A(A6), D0
6110   906A 0012                 Sub       $12(A2), D0
6114   3D40 FFF4                 Move      D0, $-C(A6)
6118   D06A 000E                 Add       $E(A2), D0
611C   3D40 FFF8                 Move      D0, $-8(A6)
6120   302E FF98                 Move      $-68(A6), D0
6124   3D40 FFF6                 Move      D0, $-A(A6)
6128   0640 0020                 Add       $20, D0
612C   D16E FFFA                 Add       D0, $-6(A6)
6130   2D6E FFF4 FFEC            Move.L    $-C(A6), $-14(A6)
6136   2D6E FFF8 FFF0            Move.L    $-8(A6), $-10(A6)
613C   202B 0054                 Move.L    $54(A3), D0
6140   4680                      Not.L     D0
6142   C0AB 0050                 And.L     $50(A3), D0
6146   322B 0058                 Move      $58(A3), D1
614A   0300                      BTst.B    D1, D0
614C   56EE FF9A                 SNE.B     $-66(A6)
6150   202E 000C                 Move.L    $C(A6), D0
6154   B0AE 0008                 Cmp.L     $8(A6), D0
6158   56EE FF88                 SNE.B     $-78(A6)
615C   6748                      BEQ       L1046
615E   422E FF9A                 Clr.B     $-66(A6)
6162   202E FF96                 Move.L    $-6A(A6), D0
6166   2D40 FF78                 Move.L    D0, $-88(A6)
616A   D06E 000E                 Add       $E(A6), D0
616E   3D40 FF7E                 Move      D0, $-82(A6)
6172   4840                      Swap      D0
6174   D06E 000C                 Add       $C(A6), D0
6178   3D40 FF7C                 Move      D0, $-84(A6)
617C   202E FF96                 Move.L    $-6A(A6), D0
6180   2D40 FF80                 Move.L    D0, $-80(A6)
6184   D06E 000A                 Add       $A(A6), D0
6188   3D40 FF86                 Move      D0, $-7A(A6)
618C   4840                      Swap      D0
618E   D06E 0008                 Add       $8(A6), D0
6192   3D40 FF84                 Move      D0, $-7C(A6)
6196   486E FFEC                 Pea.L     $-14(A6)
619A   486E FF80                 Pea.L     $-80(A6)
619E   486E FF78                 Pea.L     $-88(A6)
61A2   4EBA 504C                 Jsr       P_tMapRect
61A6   486E FFEC      L1046:     Pea.L     $-14(A6)
61AA   486B 0008                 Pea.L     $8(A3)
61AE   206B 001C                 Move.L    $1C(A3), A0
61B2   2050                      Move.L    (A0), A0
61B4   4868 0002                 Pea.L     $2(A0)
61B8   206B 0018                 Move.L    $18(A3), A0
61BC   2050                      Move.L    (A0), A0
61BE   4868 0002                 Pea.L     $2(A0)
61C2   3F3C 0004                 Move      $4, -(A7)
61C6   486E FFE4                 Pea.L     $-1C(A6)
61CA   4EBA 0FFC                 Jsr       P_mRSect
61CE   6700 052E                 BEQ       L1092
61D2   41EA 001A                 Lea.L     $1A(A2), A0
61D6   2D48 FF9E                 Move.L    A0, $-62(A6)
61DA   322A 0018                 Move      $18(A2), D1
61DE   D241                      Add       D1, D1
61E0   3D41 FF9C                 Move      D1, $-64(A6)
61E4   3D6A 000E FFCC            Move      $E(A2), $-34(A6)
61EA   4A2E FF9A                 Tst.B     $-66(A6)
61EE   6700 0092                 BEQ       L1049
61F2   4A6C 0006                 Tst       $6(A4)
61F6   6600 008A                 BNE       L1049
61FA   4A6C 000A                 Tst       $A(A4)
61FE   6600 0082                 BNE       L1049
6202   0C6B 0001 0048            Cmp       $1, $48(A3)
6208   6678                      BNE       L1049
620A   206B 001C                 Move.L    $1C(A3), A0
620E   2050                      Move.L    (A0), A0
6210   0C50 000A                 Cmp       $A, (A0)
6214   666C                      BNE       L1049
6216   206B 0018                 Move.L    $18(A3), A0
621A   2050                      Move.L    (A0), A0
621C   0C50 000A                 Cmp       $A, (A0)
6220   6712                      BEQ       L1047
6222   4227                      Clr.B     -(A7)
6224   2F2B 0018                 Move.L    $18(A3), -(A7)
6228   486E FFE4                 Pea.L     $-1C(A6)
622C   4EBA 30FC                 Jsr       P_mTrimRect
6230   4A1F                      Tst.B     (A7)+
6232   674E                      BEQ       L1049
6234   302E FFE4      L1047:     Move      $-1C(A6), D0
6238   906E FFF4                 Sub       $-C(A6), D0
623C   6F06                      BLE       L1048
623E   C0C1                      MulU      D1, D0
6240   D1AE FF9E                 Add.L     D0, $-62(A6)
6244   302E FFE8      L1048:     Move      $-18(A6), D0
6248   906E FFE4                 Sub       $-1C(A6), D0
624C   6F00 04B0                 BLE       L1092
6250   3D40 FFCC                 Move      D0, $-34(A6)
6254   302E FFE4                 Move      $-1C(A6), D0
6258   906B 0008                 Sub       $8(A3), D0
625C   C0EB 0006                 MulU      $6(A3), D0
6260   D0AB 0002                 Add.L     $2(A3), D0
6264   2D40 FFDC                 Move.L    D0, $-24(A6)
6268   3D6B 0006 FFD8            Move      $6(A3), $-28(A6)
626E   3D6B 000A FFD6            Move      $A(A3), $-2A(A6)
6274   486E FFE4                 Pea.L     $-1C(A6)
6278   2F2B 0008                 Move.L    $8(A3), -(A7)
627C   4EBA F0F0                 Jsr       P_tShieldCursor
6280   604A                      Bra       L1051
6282   422E FF9A      L1049:     Clr.B     $-66(A6)
6286   302E FFF6                 Move      $-A(A6), D0
628A   906B 000A                 Sub       $A(A3), D0
628E   0240 FFF0                 And       $-10, D0
6292   0440 0020                 Sub       $20, D0
6296   D06B 000A                 Add       $A(A3), D0
629A   3D40 FFD6                 Move      D0, $-2A(A6)
629E   322E FFFA                 Move      $-6(A6), D1
62A2   9240                      Sub       D0, D1
62A4   EA49                      LsR       $5, D1
62A6   5441                      AddQ      $2, D1
62A8   362E FFCC                 Move      $-34(A6), D3
62AC   C6C1                      MulU      D1, D3
62AE   3D43 FFDA                 Move      D3, $-26(A6)
62B2   E549                      LsL       $2, D1
62B4   3D41 FFD8                 Move      D1, $-28(A6)
62B8   5343                      SubQ.L    $1, D3
62BA   42A7                      Clr.L     -(A7)
62BC   2D4F FFE0                 Move.L    A7, $-20(A6)
62C0   42A7           L1050:     Clr.L     -(A7)
62C2   51CB FFFC                 DBF       D3, L1050
62C6   2D4F FFDC                 Move.L    A7, $-24(A6)
62CA   42A7                      Clr.L     -(A7)
62CC   43EA 001A      L1051:     Lea.L     $1A(A2), A1
62D0   302A 000E                 Move      $E(A2), D0
62D4   C0EE FF9C                 MulU      $-64(A6), D0
62D8   D3C0                      AddA.L    D0, A1
62DA   302A 0010                 Move      $10(A2), D0
62DE   D040                      Add       D0, D0
62E0   41F2 0010                 Lea.L     $10(A2,D0.W), A0
62E4   2D48 FF54                 Move.L    A0, $-AC(A6)
62E8   303C 0020                 Move      $20, D0
62EC   B06A 0004                 Cmp       $4(A2), D0
62F0   6F06                      BLE       L1053
62F2   302A 0004      L1052:     Move      $4(A2), D0
62F6   5240                      AddQ      $1, D0
62F8   906A 0002      L1053:     Sub       $2(A2), D0
62FC   6DF4                      BLT       L1052
62FE   D040                      Add       D0, D0
6300   206E FF54                 Move.L    $-AC(A6), A0
6304   3A30 0000                 Move      $0(A0,D0.W), D5
6308   0C45 FFFF                 Cmp       $-1, D5
630C   67E4                      BEQ       L1052
630E   0245 00FF                 And       $FF, D5
6312   DA2C 000C                 Add.B     $C(A4), D5
6316   4845                      Swap      D5
6318   4245                      Clr       D5
631A   2055                      Move.L    (A5), A0
631C   DAA8 FF54                 Add.L     $-AC(A0), D5
6320   2D45 FF64                 Move.L    D5, $-9C(A6)
6324   302E FF98                 Move      $-68(A6), D0
6328   D06A 0008                 Add       $8(A2), D0
632C   3D40 FF60                 Move      D0, $-A0(A6)
6330   3D7C 8000 FF62            Move      $-8000, $-9E(A6)
6336   536E FFCC                 SubQ.L    $1, $-34(A6)
633A   206E 0010      L1054:     Move.L    $10(A6), A0
633E   1018                      Move.B    (A0)+, D0
6340   2D48 0010                 Move.L    A0, $10(A6)
6344   0C00 0020                 Cmp.B     $20, D0
6348   660C                      BNE       L1055
634A   222E FF64                 Move.L    $-9C(A6), D1
634E   D3AE FF60                 Add.L     D1, $-A0(A6)
6352   6000 0144                 Bra       L1068
6356   0240 00FF      L1055:     And       $FF, D0
635A   B06A 0004                 Cmp       $4(A2), D0
635E   6F06                      BLE       L1057
6360   302A 0004      L1056:     Move      $4(A2), D0
6364   5240                      AddQ      $1, D0
6366   906A 0002      L1057:     Sub       $2(A2), D0
636A   6DF4                      BLT       L1056
636C   D040                      Add       D0, D0
636E   206E FF54                 Move.L    $-AC(A6), A0
6372   3A30 0000                 Move      $0(A0,D0.W), D5
6376   0C45 FFFF                 Cmp       $-1, D5
637A   67E4                      BEQ       L1056
637C   3231 0000                 Move      $0(A1,D0.W), D1
6380   3431 0002                 Move      $2(A1,D0.W), D2
6384   9441                      Sub       D1, D2
6386   6F00 0104                 BLE       L1067
638A   3605                      Move      D5, D3
638C   E04B                      LsR       $8, D3
638E   D66E FF60                 Add       $-A0(A6), D3
6392   D443                      Add       D3, D2
6394   4A2E FF9A                 Tst.B     $-66(A6)
6398   672A                      BEQ       L1059
639A   B46E FFE6                 Cmp       $-1A(A6), D2
639E   6F00 00EC                 BLE       L1067
63A2   B66E FFEA                 Cmp       $-16(A6), D3
63A6   6C00 010E                 BGE       L1069
63AA   B46E FFEA                 Cmp       $-16(A6), D2
63AE   6F04                      BLE       L1058
63B0   342E FFEA                 Move      $-16(A6), D2
63B4   B66E FFE6      L1058:     Cmp       $-1A(A6), D3
63B8   6C0A                      BGE       L1059
63BA   302E FFE6                 Move      $-1A(A6), D0
63BE   9043                      Sub       D3, D0
63C0   D240                      Add       D0, D1
63C2   D640                      Add       D0, D3
63C4   966E FFD6      L1059:     Sub       $-2A(A6), D3
63C8   946E FFD6                 Sub       $-2A(A6), D2
63CC   48E7 047C                 MoveM.L   D5/A1-A5, -(A7)
63D0   3A03                      Move      D3, D5
63D2   9A41                      Sub       D1, D5
63D4   0245 000F                 And       $F, D5
63D8   286E FF9E                 Move.L    $-62(A6), A4
63DC   D245                      Add       D5, D1
63DE   E841                      AsR       $4, D1
63E0   D241                      Add       D1, D1
63E2   5541                      SubQ.L    $2, D1
63E4   D8C1                      AddA      D1, A4
63E6   2A6E FFDC                 Move.L    $-24(A6), A5
63EA   3203                      Move      D3, D1
63EC   3001                      Move      D1, D0
63EE   E841                      AsR       $4, D1
63F0   DAC1                      AddA      D1, A5
63F2   DAC1                      AddA      D1, A5
63F4   4EBA F09C                 Jsr       P_mLeftMask
63F8   3600                      Move      D0, D3
63FA   3C02                      Move      D2, D6
63FC   3006                      Move      D6, D0
63FE   4EBA F0A0                 Jsr       P_mRightMask
6402   3800                      Move      D0, D4
6404   346E FF9C                 Move      $-64(A6), A2
6408   366E FFD8                 Move      $-28(A6), A3
640C   3E2E FFCC                 Move      $-34(A6), D7
6410   E846                      AsR       $4, D6
6412   9C41                      Sub       D1, D6
6414   6760                      BEQ       L1064
6416   5346                      SubQ.L    $1, D6
6418   673C                      BEQ       L1062
641A   5247                      AddQ      $1, D7
641C   6024                      Bra       L1061
641E   2014           L1060:     Move.L    (A4), D0
6420   544C                      AddQ      $2, A4
6422   EAA8                      LsR.L     D5, D0
6424   C041                      And       D1, D0
6426   815D                      Or        D0, (A5)+
6428   72FF                      MoveQ.L   $-1, D1
642A   51CA FFF2                 DBF       D2, L1060
642E   2014                      Move.L    (A4), D0
6430   EAA8                      LsR.L     D5, D0
6432   C044                      And       D4, D0
6434   8155                      Or        D0, (A5)
6436   286E FF8E                 Move.L    $-72(A6), A4
643A   D8CA                      AddA      A2, A4
643C   2A6E FF8A                 Move.L    $-76(A6), A5
6440   DACB                      AddA      A3, A5
6442   2D4C FF8E      L1061:     Move.L    A4, $-72(A6)
6446   2D4D FF8A                 Move.L    A5, $-76(A6)
644A   3203                      Move      D3, D1
644C   3406                      Move      D6, D2
644E   51CF FFCE                 DBF       D7, L1060
6452   6000 0034                 Bra       L1066
6456   554B           L1062:     SubQ.L    $2, A3
6458   2014           L1063:     Move.L    (A4), D0
645A   EAA8                      LsR.L     D5, D0
645C   C043                      And       D3, D0
645E   815D                      Or        D0, (A5)+
6460   202C 0002                 Move.L    $2(A4), D0
6464   EAA8                      LsR.L     D5, D0
6466   C044                      And       D4, D0
6468   8155                      Or        D0, (A5)
646A   D8CA                      AddA      A2, A4
646C   DACB                      AddA      A3, A5
646E   51CF FFE8                 DBF       D7, L1063
6472   6000 0014                 Bra       L1066
6476   C644           L1064:     And       D4, D3
6478   2014           L1065:     Move.L    (A4), D0
647A   EAA8                      LsR.L     D5, D0
647C   C043                      And       D3, D0
647E   8155                      Or        D0, (A5)
6480   D8CA                      AddA      A2, A4
6482   DACB                      AddA      A3, A5
6484   51CF FFF2                 DBF       D7, L1065
6488   4CDF 3E20      L1066:     MoveM.L   (A7)+, D5/A1-A5
648C   0245 00FF      L1067:     And       $FF, D5
6490   DA2C 000C                 Add.B     $C(A4), D5
6494   DB6E FF60                 Add       D5, $-A0(A6)
6498   536E 0014      L1068:     SubQ.L    $1, $14(A6)
649C   6E00 FE9C                 BGT       L1054
64A0   3E2E FF60                 Move      $-A0(A6), D7
64A4   9E6A 0008                 Sub       $8(A2), D7
64A8   4A2E FF9A                 Tst.B     $-66(A6)
64AC   670E                      BEQ       L1070
64AE   4EBA EEBA                 Jsr       P_tShowCursor
64B2   6000 024A                 Bra       L1092
64B6   426E 0014      L1069:     Clr       $14(A6)
64BA   60D0                      Bra       L1067
64BC   4242           L1070:     Clr       D2
64BE   142C 0006                 Move.B    $6(A4), D2
64C2   6014                      Bra       L1073
64C4   206E FFDC      L1071:     Move.L    $-24(A6), A0
64C8   322E FFDA                 Move      $-26(A6), D1
64CC   9040                      Sub       D0, D0
64CE   2010           L1072:     Move.L    (A0), D0
64D0   E290                      RXR.L     $1, D0
64D2   8198                      Or.L      D0, (A0)+
64D4   51C9 FFF8                 DBF       D1, L1072
64D8   51CA FFEA      L1073:     DBF       D2, L1071
64DC   4242                      Clr       D2
64DE   142C 0007                 Move.B    $7(A4), D2
64E2   673A                      BEQ       L1076
64E4   226E FFE0                 Move.L    $-20(A6), A1
64E8   362E FFD8                 Move      $-28(A6), D3
64EC   92C3                      SubA      D3, A1
64EE   E24B                      LsR       $1, D3
64F0   5343                      SubQ.L    $1, D3
64F2   3C2E FFCC                 Move      $-34(A6), D6
64F6   4244                      Clr       D4
64F8   D842           L1074:     Add       D2, D4
64FA   3004                      Move      D4, D0
64FC   E848                      LsR       $4, D0
64FE   7A0F                      MoveQ.L   $F, D5
6500   CA40                      And       D0, D5
6502   E848                      LsR       $4, D0
6504   2049                      Move.L    A1, A0
6506   5948                      SubQ.L    $4, A0
6508   90C0                      SubA      D0, A0
650A   90C0                      SubA      D0, A0
650C   3203                      Move      D3, D1
650E   2010           L1075:     Move.L    (A0), D0
6510   5548                      SubQ.L    $2, A0
6512   EAA8                      LsR.L     D5, D0
6514   3300                      Move      D0, -(A1)
6516   51C9 FFF6                 DBF       D1, L1075
651A   51CE FFDC                 DBF       D6, L1074
651E   4A2C 000A      L1076:     Tst.B     $A(A4)
6522   6700 0080                 BEQ       L1082
6526   206E FFDC                 Move.L    $-24(A6), A0
652A   322E FFD8                 Move      $-28(A6), D1
652E   302A 0012                 Move      $12(A2), D0
6532   342A 0014                 Move      $14(A2), D2
6536   C0C1                      MulU      D1, D0
6538   D1C0                      AddA.L    D0, A0
653A   2248                      Move.L    A0, A1
653C   2448                      Move.L    A0, A2
653E   D2C1                      AddA      D1, A1
6540   0C42 0002                 Cmp       $2, D2
6544   6D5E                      BLT       L1082
6546   6704                      BEQ       L1077
6548   D4C1                      AddA      D1, A2
654A   D4C1                      AddA      D1, A2
654C   9EC1           L1077:     SubA      D1, A7
654E   2F0B                      Move.L    A3, -(A7)
6550   47EF 0004                 Lea.L     $4(A7), A3
6554   E449                      LsR       $2, D1
6556   5341                      SubQ.L    $1, D1
6558   3401                      Move      D1, D2
655A   9040                      Sub       D0, D0
655C   2018           L1078:     Move.L    (A0)+, D0
655E   8099                      Or.L      (A1)+, D0
6560   809A                      Or.L      (A2)+, D0
6562   2680                      Move.L    D0, (A3)
6564   E290                      RXR.L     $1, D0
6566   819B                      Or.L      D0, (A3)+
6568   51C9 FFF2                 DBF       D1, L1078
656C   2049                      Move.L    A1, A0
656E   9040                      Sub       D0, D0
6570   2023           L1079:     Move.L    -(A3), D0
6572   E390                      RXL.L     $1, D0
6574   8093                      Or.L      (A3), D0
6576   4680                      Not.L     D0
6578   81A1                      Or.L      D0, -(A1)
657A   51CA FFF4                 DBF       D2, L1079
657E   265F                      Move.L    (A7)+, A3
6580   302E FFD8                 Move      $-28(A6), D0
6584   E748                      LsL       $3, D0
6586   D06E FFD6                 Add       $-2A(A6), D0
658A   9047                      Sub       D7, D0
658C   5340                      SubQ.L    $1, D0
658E   E848                      LsR       $4, D0
6590   6002                      Bra       L1081
6592   4260           L1080:     Clr       -(A0)
6594   51C8 FFFC      L1081:     DBF       D0, L1080
6598   3007                      Move      D7, D0
659A   906B 000A                 Sub       $A(A3), D0
659E   4EBA EF00                 Jsr       P_mRightMask
65A2   C160                      And       D0, -(A0)
65A4   3D7C 000A FFA6 L1082:     Move      $A, $-5A(A6)
65AA   2D6B 0008 FFA8            Move.L    $8(A3), $-58(A6)
65B0   2D6B 000C FFAC            Move.L    $C(A3), $-54(A6)
65B6   41EE FFA6                 Lea.L     $-5A(A6), A0
65BA   2D48 FFA2                 Move.L    A0, $-5E(A6)
65BE   41EE FFBE                 Lea.L     $-42(A6), A0
65C2   20EE FFDC                 Move.L    $-24(A6), (A0)+
65C6   30EE FFD8                 Move      $-28(A6), (A0)+
65CA   30EE FFF4                 Move      $-C(A6), (A0)+
65CE   30EE FFD6                 Move      $-2A(A6), (A0)+
65D2   20EE FFF8                 Move.L    $-8(A6), (A0)+
65D6   45EB 0002                 Lea.L     $2(A3), A2
65DA   41EE FFB0                 Lea.L     $-50(A6), A0
65DE   20DA                      Move.L    (A2)+, (A0)+
65E0   30DA                      Move      (A2)+, (A0)+
65E2   20DA                      Move.L    (A2)+, (A0)+
65E4   20DA                      Move.L    (A2)+, (A0)+
65E6   4243                      Clr       D3
65E8   162C 000B                 Move.B    $B(A4), D3
65EC   6700 00DE                 BEQ       L1090
65F0   302E FFD8                 Move      $-28(A6), D0
65F4   5340                      SubQ.L    $1, D0
65F6   42A7                      Clr.L     -(A7)
65F8   2D4F FFCE                 Move.L    A7, $-32(A6)
65FC   42A7           L1083:     Clr.L     -(A7)
65FE   51C8 FFFC                 DBF       D0, L1083
6602   302E FFDA                 Move      $-26(A6), D0
6606   5340                      SubQ.L    $1, D0
6608   206E FFE0                 Move.L    $-20(A6), A0
660C   2F20           L1084:     Move.L    -(A0), -(A7)
660E   51C8 FFFC                 DBF       D0, L1084
6612   2D4F FFD2                 Move.L    A7, $-2E(A6)
6616   42A7                      Clr.L     -(A7)
6618   0243 0003                 And       $3, D3
661C   3403                      Move      D3, D2
661E   206E FFD2      L1085:     Move.L    $-2E(A6), A0
6622   322E FFDA                 Move      $-26(A6), D1
6626   9040                      Sub       D0, D0
6628   2010           L1086:     Move.L    (A0), D0
662A   E290                      RXR.L     $1, D0
662C   8198                      Or.L      D0, (A0)+
662E   51C9 FFF8                 DBF       D1, L1086
6632   51CA FFEA                 DBF       D2, L1085
6636   246E FFD2                 Move.L    $-2E(A6), A2
663A   226E FFCE      L1087:     Move.L    $-32(A6), A1
663E   2049                      Move.L    A1, A0
6640   90EE FFC2                 SubA      $-3E(A6), A0
6644   2020           L1088:     Move.L    -(A0), D0
6646   81A1                      Or.L      D0, -(A1)
6648   B1CA                      CmpA.L    A2, A0
664A   6EF8                      BGT       L1088
664C   51CB FFEC                 DBF       D3, L1087
6650   2D4A FFBE                 Move.L    A2, $-42(A6)
6654   586E FFC8                 AddQ      $4, $-38(A6)
6658   2D6E FFF4 FF70            Move.L    $-C(A6), $-90(A6)
665E   2D6E FFF8 FF74            Move.L    $-8(A6), $-8C(A6)
6664   586E FF74                 AddQ      $4, $-8C(A6)
6668   2D6E FF70 FF68            Move.L    $-90(A6), $-98(A6)
666E   2D6E FF74 FF6C            Move.L    $-8C(A6), $-94(A6)
6674   536E FF68                 SubQ.L    $1, $-98(A6)
6678   536E FF6A                 SubQ.L    $1, $-96(A6)
667C   536E FF6C                 SubQ.L    $1, $-94(A6)
6680   536E FF6E                 SubQ.L    $1, $-92(A6)
6684   4A2E FF88                 Tst.B     $-78(A6)
6688   6710                      BEQ       L1089
668A   486E FF68                 Pea.L     $-98(A6)
668E   486E FF80                 Pea.L     $-80(A6)
6692   486E FF78                 Pea.L     $-88(A6)
6696   4EBA 4B58                 Jsr       P_tMapRect
669A   486E FFBE      L1089:     Pea.L     $-42(A6)
669E   486E FFB0                 Pea.L     $-50(A6)
66A2   486E FF70                 Pea.L     $-90(A6)
66A6   486E FF68                 Pea.L     $-98(A6)
66AA   7003                      MoveQ.L   $3, D0
66AC   C06B 0048                 And       $48(A3), D0
66B0   3F00                      Move      D0, -(A7)
66B2   2F2B 001C                 Move.L    $1C(A3), -(A7)
66B6   2F2B 0018                 Move.L    $18(A3), -(A7)
66BA   486E FFA2                 Pea.L     $-5E(A6)
66BE   4EBA 376C                 Jsr       P_mStretchBits
66C2   2D6E FFDC FFBE            Move.L    $-24(A6), $-42(A6)
66C8   596E FFC8                 SubQ.L    $4, $-38(A6)
66CC   486E FFBE      L1090:     Pea.L     $-42(A6)
66D0   486E FFB0                 Pea.L     $-50(A6)
66D4   486E FFF4                 Pea.L     $-C(A6)
66D8   486E FFEC                 Pea.L     $-14(A6)
66DC   302B 0048                 Move      $48(A3), D0
66E0   4A2C 000B                 Tst.B     $B(A4)
66E4   6702                      BEQ       L1091
66E6   4440                      Neg       D0
66E8   0240 0003      L1091:     And       $3, D0
66EC   3F00                      Move      D0, -(A7)
66EE   2F2B 001C                 Move.L    $1C(A3), -(A7)
66F2   2F2B 0018                 Move.L    $18(A3), -(A7)
66F6   486E FFA2                 Pea.L     $-5E(A6)
66FA   4EBA 3730                 Jsr       P_mStretchBits
66FE   2E6E FFFC      L1092:     Move.L    $-4(A6), A7
6702   4CDF 1EFF                 MoveM.L   (A7)+, D0-D7/A1-A4
6706   4E5E                      Unlk      A6
6708   205F                      Move.L    (A7)+, A0
670A   DEFC 000E                 AddA      $E, A7
670E   4ED0                      Jmp       (A0)

                      P_tStdLine:
6710   4E56 0000                 Link      A6, $0
6714   48E7 0718                 MoveM.L   D5-D7/A3-A4, -(A7)
6718   4EBA 4948                 Jsr       P_mCheckPic
671C   6F00 0078                 BLE       L1098
6720   4227                      Clr.B     -(A7)
6722   4EBA 4836                 Jsr       P_mPutPicVerb
6726   7E20                      MoveQ.L   $20, D7
6728   286B 005C                 Move.L    $5C(A3), A4
672C   2854                      Move.L    (A4), A4
672E   202B 0030                 Move.L    $30(A3), D0
6732   B0AC 002A                 Cmp.L     $2A(A4), D0
6736   6602                      BNE       L1093
6738   5247                      AddQ      $1, D7
673A   3C2E 000A      L1093:     Move      $A(A6), D6
673E   9C40                      Sub       D0, D6
6740   3006                      Move      D6, D0
6742   4880                      Ext       D0
6744   B046                      Cmp       D6, D0
6746   6612                      BNE       L1094
6748   3A2E 0008                 Move      $8(A6), D5
674C   9A6B 0030                 Sub       $30(A3), D5
6750   3005                      Move      D5, D0
6752   4880                      Ext       D0
6754   B045                      Cmp       D5, D0
6756   6602                      BNE       L1094
6758   5447                      AddQ      $2, D7
675A   1F07           L1094:     Move.B    D7, -(A7)
675C   4EBA 4752                 Jsr       P_mPutPicByte
6760   0807 0000                 BTst.B    $0, D7
6764   6608                      BNE       L1095
6766   2F2B 0030                 Move.L    $30(A3), -(A7)
676A   4EBA 4768                 Jsr       P_mPutPicLong
676E   0807 0001      L1095:     BTst.B    $1, D7
6772   660A                      BNE       L1096
6774   2F2E 0008                 Move.L    $8(A6), -(A7)
6778   4EBA 475A                 Jsr       P_mPutPicLong
677C   600C                      Bra       L1097
677E   1F06           L1096:     Move.B    D6, -(A7)
6780   4EBA 472E                 Jsr       P_mPutPicByte
6784   1F05                      Move.B    D5, -(A7)
6786   4EBA 4728                 Jsr       P_mPutPicByte
678A   286B 005C      L1097:     Move.L    $5C(A3), A4
678E   2854                      Move.L    (A4), A4
6790   296E 0008 002A            Move.L    $8(A6), $2A(A4)
6796   2F2E 0008      L1098:     Move.L    $8(A6), -(A7)
679A   4EBA 005A                 Jsr       P_mDoLine
679E   4CDF 18E0                 MoveM.L   (A7)+, D5-D7/A3-A4
67A2   4E5E                      Unlk      A6
67A4   2E9F                      Move.L    (A7)+, (A7)
67A6   4E75                      Rts

                      P_tLineTo:
67A8   2055                      Move.L    (A5), A0
67AA   2050                      Move.L    (A0), A0
67AC   2028 0068                 Move.L    $68(A0), D0
67B0   41FA FF5E                 Lea.L     P_tStdLine, A0
67B4   6706                      BEQ       L1099
67B6   2040                      Move.L    D0, A0
67B8   2068 0004                 Move.L    $4(A0), A0
67BC   4ED0           L1099:     Jmp       (A0)

                      P_tLine:
67BE   2055                      Move.L    (A5), A0
67C0   2050                      Move.L    (A0), A0
67C2   3028 0032                 Move      $32(A0), D0
67C6   D16F 0006                 Add       D0, $6(A7)
67CA   3028 0030                 Move      $30(A0), D0
67CE   D16F 0004                 Add       D0, $4(A7)
67D2   4EFA FFD4                 Jmp       P_tLineTo

                      P_tMoveTo:
67D6   205F                      Move.L    (A7)+, A0
67D8   2255                      Move.L    (A5), A1
67DA   2251                      Move.L    (A1), A1
67DC   235F 0030                 Move.L    (A7)+, $30(A1)
67E0   4ED0                      Jmp       (A0)

                      P_tMove:
67E2   205F                      Move.L    (A7)+, A0
67E4   301F                      Move      (A7)+, D0
67E6   321F                      Move      (A7)+, D1
67E8   2255                      Move.L    (A5), A1
67EA   2251                      Move.L    (A1), A1
67EC   D169 0030                 Add       D0, $30(A1)
67F0   D369 0032                 Add       D1, $32(A1)
67F4   4ED0                      Jmp       (A0)

                      P_mDoLine:
67F6   48E7 0318                 MoveM.L   D6-D7/A3-A4, -(A7)
67FA   2855                      Move.L    (A5), A4
67FC   2654                      Move.L    (A4), A3
67FE   2E2F 0014                 Move.L    $14(A7), D7
6802   2C2B 0030                 Move.L    $30(A3), D6
6806   4AAB 0064                 Tst.L     $64(A3)
680A   6734                      BEQ       L1102
680C   226C FF5E                 Move.L    $-A2(A4), A1
6810   2051                      Move.L    (A1), A0
6812   3010                      Move      (A0), D0
6814   0C40 000A                 Cmp       $A, D0
6818   6606                      BNE       L1100
681A   2186 0000                 Move.L    D6, $0(A0,D0.W)
681E   5840                      AddQ      $4, D0
6820   2187 0000      L1100:     Move.L    D7, $0(A0,D0.W)
6824   5840                      AddQ      $4, D0
6826   3080                      Move      D0, (A0)
6828   B06C FF5C                 Cmp       $-A4(A4), D0
682C   6D10                      BLT       L1101
682E   066C 0100 FF5C            Add       $100, $-A4(A4)
6834   2F09                      Move.L    A1, -(A7)
6836   3F2C FF5C                 Move      $-A4(A4), -(A7)
683A   4EBA 49E0                 Jsr       P_mSetHSize
683E   601A           L1101:     Bra       L1103
6840   4AAB 0060      L1102:     Tst.L     $60(A3)
6844   6714                      BEQ       L1103
6846   2F06                      Move.L    D6, -(A7)
6848   2F07                      Move.L    D7, -(A7)
684A   2F2C FF6C                 Move.L    $-94(A4), -(A7)
684E   486C FF6A                 Pea.L     $-96(A4)
6852   486C FF68                 Pea.L     $-98(A4)
6856   4EBA 05C4                 Jsr       P_mPutLine
685A   2F06           L1103:     Move.L    D6, -(A7)
685C   2F07                      Move.L    D7, -(A7)
685E   4EBA 009E                 Jsr       P_mDrawLine
6862   2747 0030                 Move.L    D7, $30(A3)
6866   4CDF 18C0                 MoveM.L   (A7)+, D6-D7/A3-A4
686A   2E9F                      Move.L    (A7)+, (A7)
686C   4E75                      Rts

                      P_tHidePen:
686E   2055                      Move.L    (A5), A0
6870   2050                      Move.L    (A0), A0
6872   5368 0042                 SubQ.L    $1, $42(A0)
6876   4E75                      Rts

                      P_tShowPen:
6878   2055                      Move.L    (A5), A0
687A   2050                      Move.L    (A0), A0
687C   5268 0042                 AddQ      $1, $42(A0)
6880   4E75                      Rts

                      P_tGetPenState:
6882   7001                      MoveQ.L   $1, D0
6884   6002                      Bra       L1104

                      P_tSetPenState:
6886   4240                      Clr       D0
6888   2055           L1104:     Move.L    (A5), A0
688A   2050                      Move.L    (A0), A0
688C   41E8 0030                 Lea.L     $30(A0), A0
6890   226F 0004                 Move.L    $4(A7), A1
6894   4A40                      Tst       D0
6896   6602                      BNE       L1105
6898   C149                      Exg.L     A0, A1
689A   22D8           L1105:     Move.L    (A0)+, (A1)+
689C   22D8                      Move.L    (A0)+, (A1)+
689E   32D8                      Move      (A0)+, (A1)+
68A0   22D8                      Move.L    (A0)+, (A1)+
68A2   22D8                      Move.L    (A0)+, (A1)+
68A4   2E9F                      Move.L    (A7)+, (A7)
68A6   4E75                      Rts

                      P_tGetPen:
68A8   2055                      Move.L    (A5), A0
68AA   2050                      Move.L    (A0), A0
68AC   226F 0004                 Move.L    $4(A7), A1
68B0   22A8 0030                 Move.L    $30(A0), (A1)
68B4   2E9F                      Move.L    (A7)+, (A7)
68B6   4E75                      Rts

                      P_tPenSize:
68B8   2055                      Move.L    (A5), A0
68BA   2050                      Move.L    (A0), A0
68BC   216F 0004 0034            Move.L    $4(A7), $34(A0)
68C2   2E9F                      Move.L    (A7)+, (A7)
68C4   4E75                      Rts

                      P_tPenMode:
68C6   7038                      MoveQ.L   $38, D0
68C8   4EFA ED68                 Jmp       L_mPortWord

                      P_tPenPat:
68CC   2055                      Move.L    (A5), A0
68CE   2050                      Move.L    (A0), A0
68D0   41E8 003A                 Lea.L     $3A(A0), A0
68D4   226F 0004                 Move.L    $4(A7), A1
68D8   20D9                      Move.L    (A1)+, (A0)+
68DA   20D9                      Move.L    (A1)+, (A0)+
68DC   2E9F                      Move.L    (A7)+, (A7)
68DE   4E75                      Rts

                      P_tPenNormal:
68E0   2055                      Move.L    (A5), A0
68E2   2050                      Move.L    (A0), A0
68E4   217C 0001 0001            Move.L    $10001, $34(A0)
       0034
68EC   317C 0008 0038            Move      $8, $38(A0)
68F2   70FF                      MoveQ.L   $-1, D0
68F4   2140 003A                 Move.L    D0, $3A(A0)
68F8   2140 003E                 Move.L    D0, $3E(A0)
68FC   4E75                      Rts

                      P_mDrawLine:
68FE   4E56 FF40                 Link      A6, $-C0
6902   48E7 FF7C                 MoveM.L   D0-D7/A1-A5, -(A7)
6906   2D4F FF8C                 Move.L    A7, $-74(A6)
690A   2D4D FF4A                 Move.L    A5, $-B6(A6)
690E   2055                      Move.L    (A5), A0
6910   2650                      Move.L    (A0), A3
6912   4A6B 0042                 Tst       $42(A3)
6916   6D00 0360                 BLT       L1125
691A   2D4B FF46                 Move.L    A3, $-BA(A6)
691E   70F8                      MoveQ.L   $-8, D0
6920   C06B 0038                 And       $38(A3), D0
6924   0C40 0008                 Cmp       $8, D0
6928   6600 034E                 BNE       L1125
692C   3F2B 0038                 Move      $38(A3), -(A7)
6930   486B 003A                 Pea.L     $3A(A3)
6934   4EBA EC90                 Jsr       P_mColorMap
6938   2D5F FF40                 Move.L    (A7)+, $-C0(A6)
693C   3D5F FF44                 Move      (A7)+, $-BC(A6)
6940   2A4B                      Move.L    A3, A5
6942   246D 001C                 Move.L    $1C(A5), A2
6946   2452                      Move.L    (A2), A2
6948   266D 0018                 Move.L    $18(A5), A3
694C   2653                      Move.L    (A3), A3
694E   322E 000C                 Move      $C(A6), D1
6952   342E 000E                 Move      $E(A6), D2
6956   362E 0008                 Move      $8(A6), D3
695A   382E 000A                 Move      $A(A6), D4
695E   B243                      Cmp       D3, D1
6960   6F02                      BLE       L1106
6962   C343                      Exg.L     D1, D3
6964   B444           L1106:     Cmp       D4, D2
6966   6F02                      BLE       L1107
6968   C544                      Exg.L     D2, D4
696A   D86D 0036      L1107:     Add       $36(A5), D4
696E   D66D 0034                 Add       $34(A5), D3
6972   3D41 FF84                 Move      D1, $-7C(A6)
6976   3D42 FF86                 Move      D2, $-7A(A6)
697A   3D43 FF88                 Move      D3, $-78(A6)
697E   3D44 FF8A                 Move      D4, $-76(A6)
6982   486E FF84                 Pea.L     $-7C(A6)
6986   486D 0008                 Pea.L     $8(A5)
698A   486A 0002                 Pea.L     $2(A2)
698E   486B 0002                 Pea.L     $2(A3)
6992   3F3C 0004                 Move      $4, -(A7)
6996   486E FF7C                 Pea.L     $-84(A6)
699A   4EBA 082C                 Jsr       P_mRSect
699E   6700 02D8                 BEQ       L1125
69A2   486E FF7C                 Pea.L     $-84(A6)
69A6   2F2D 0008                 Move.L    $8(A5), -(A7)
69AA   2A6E FF4A                 Move.L    $-B6(A6), A5
69AE   4EBA E9BE                 Jsr       P_tShieldCursor
69B2   2A6E FF46                 Move.L    $-BA(A6), A5
69B6   322E 000C                 Move      $C(A6), D1
69BA   342E 000E                 Move      $E(A6), D2
69BE   362E 0008                 Move      $8(A6), D3
69C2   382E 000A                 Move      $A(A6), D4
69C6   B842                      Cmp       D2, D4
69C8   6706                      BEQ       L1108
69CA   B641                      Cmp       D1, D3
69CC   6E70                      BGT       L1112
69CE   6D6A                      BLT       L1111
69D0   0CAD 0001 0001 L1108:     Cmp.L     $10001, $34(A5)
       0034
69D8   6622                      BNE       L1110
69DA   206E FF40                 Move.L    $-C0(A6), A0
69DE   2018                      Move.L    (A0)+, D0
69E0   6708                      BEQ       L1109
69E2   0C80 FFFF FFFF            Cmp.L     $-1, D0
69E8   6612                      BNE       L1110
69EA   B098           L1109:     Cmp.L     (A0)+, D0
69EC   660E                      BNE       L1110
69EE   0C52 000A                 Cmp       $A, (A2)
69F2   6608                      BNE       L1110
69F4   0C53 000A                 Cmp       $A, (A3)
69F8   6700 02FC                 BEQ       L1127
69FC   486D 0002      L1110:     Pea.L     $2(A5)
6A00   486D 0002                 Pea.L     $2(A5)
6A04   486E FF7C                 Pea.L     $-84(A6)
6A08   486E FF7C                 Pea.L     $-84(A6)
6A0C   3F2D 0038                 Move      $38(A5), -(A7)
6A10   486D 003A                 Pea.L     $3A(A5)
6A14   2F2D 001C                 Move.L    $1C(A5), -(A7)
6A18   2F2D 0018                 Move.L    $18(A5), -(A7)
6A1C   3D7C 000A FF7A            Move      $A, $-86(A6)
6A22   41EE FF7A                 Lea.L     $-86(A6), A0
6A26   2D48 FF76                 Move.L    A0, $-8A(A6)
6A2A   486E FF76                 Pea.L     $-8A(A6)
6A2E   2A6E FF4A                 Move.L    $-B6(A6), A5
6A32   4EBA 0CAC                 Jsr       P_mRgnBlt
6A36   6000 0238                 Bra       L1124
6A3A   C343           L1111:     Exg.L     D1, D3
6A3C   C544                      Exg.L     D2, D4
6A3E   3003           L1112:     Move      D3, D0
6A40   D06D 0034                 Add       $34(A5), D0
6A44   B06A 0002                 Cmp       $2(A2), D0
6A48   6F00 0226                 BLE       L1124
6A4C   B26A 0006                 Cmp       $6(A2), D1
6A50   6C00 021E                 BGE       L1124
6A54   3D42 FF70                 Move      D2, $-90(A6)
6A58   3D7C 8000 FF72            Move      $-8000, $-8E(A6)
6A5E   2D6E FF70 FF6C            Move.L    $-90(A6), $-94(A6)
6A64   302D 0036                 Move      $36(A5), D0
6A68   6F00 0206                 BLE       L1124
6A6C   D16E FF6C                 Add       D0, $-94(A6)
6A70   3C2D 0034                 Move      $34(A5), D6
6A74   6F00 01FA                 BLE       L1124
6A78   42A7                      Clr.L     -(A7)
6A7A   3F04                      Move      D4, -(A7)
6A7C   9557                      Sub       D2, (A7)
6A7E   3F03                      Move      D3, -(A7)
6A80   9357                      Sub       D1, (A7)
6A82   4EBA ED7A                 Jsr       P_tFixRatio
6A86   2E1F                      Move.L    (A7)+, D7
6A88   2D47 FF68                 Move.L    D7, $-98(A6)
6A8C   42A7                      Clr.L     -(A7)
6A8E   4267                      Clr       -(A7)
6A90   3F06                      Move      D6, -(A7)
6A92   2F07                      Move.L    D7, -(A7)
6A94   4EBA ED46                 Jsr       P_tFixMul
6A98   2C1F                      Move.L    (A7)+, D6
6A9A   2007                      Move.L    D7, D0
6A9C   E280                      AsR.L     $1, D0
6A9E   D1AE FF70                 Add.L     D0, $-90(A6)
6AA2   D1AE FF6C                 Add.L     D0, $-94(A6)
6AA6   4A87                      Tst.L     D7
6AA8   6B18                      BMI       L1114
6AAA   9DAE FF70                 Sub.L     D6, $-90(A6)
6AAE   0C87 0001 0000            Cmp.L     $10000, D7
6AB4   6C06                      BGE       L1113
6AB6   DFAE FF70                 Add.L     D7, $-90(A6)
6ABA   601C                      Bra       L1116
6ABC   536E FF6C      L1113:     SubQ.L    $1, $-94(A6)
6AC0   6016                      Bra       L1116
6AC2   9DAE FF6C      L1114:     Sub.L     D6, $-94(A6)
6AC6   0C87 FFFF 0000            Cmp.L     $-10000, D7
6ACC   6D06                      BLT       L1115
6ACE   DFAE FF6C                 Add.L     D7, $-94(A6)
6AD2   6004                      Bra       L1116
6AD4   526E FF70      L1115:     AddQ      $1, $-90(A6)
6AD8   322E FF7C      L1116:     Move      $-84(A6), D1
6ADC   342E FF7E                 Move      $-82(A6), D2
6AE0   362E FF80                 Move      $-80(A6), D3
6AE4   382E FF82                 Move      $-7E(A6), D4
6AE8   B26E FF84                 Cmp       $-7C(A6), D1
6AEC   671E                      BEQ       L1117
6AEE   3001                      Move      D1, D0
6AF0   906E FF84                 Sub       $-7C(A6), D0
6AF4   2A07                      Move.L    D7, D5
6AF6   4845                      Swap      D5
6AF8   CBC0                      MulW      D0, D5
6AFA   4845                      Swap      D5
6AFC   4245                      Clr       D5
6AFE   2C07                      Move.L    D7, D6
6B00   CCC0                      MulU      D0, D6
6B02   DA86                      Add.L     D6, D5
6B04   DBAE FF70                 Add.L     D5, $-90(A6)
6B08   DBAE FF6C                 Add.L     D5, $-94(A6)
6B0C   3D7C 8001 FFF6 L1117:     Move      $-7FFF, $-A(A6)
6B12   3D7C 8001 FFDE            Move      $-7FFF, $-22(A6)
6B18   3D7C 7FFF FFF8            Move      $7FFF, $-8(A6)
6B1E   3D7C 7FFF FFE0            Move      $7FFF, $-20(A6)
6B24   342E FF7E                 Move      $-82(A6), D2
6B28   946D 000A                 Sub       $A(A5), D2
6B2C   0242 FFF0                 And       $-10, D2
6B30   D46D 000A                 Add       $A(A5), D2
6B34   3D42 FF5A                 Move      D2, $-A6(A6)
6B38   302E FF82                 Move      $-7E(A6), D0
6B3C   9042                      Sub       D2, D0
6B3E   EA48                      LsR       $5, D0
6B40   3D40 FF58                 Move      D0, $-A8(A6)
6B44   42A7           L1118:     Clr.L     -(A7)
6B46   51C8 FFFC                 DBF       D0, L1118
6B4A   2D4F FF5C                 Move.L    A7, $-A4(A6)
6B4E   426E FF74                 Clr       $-8C(A6)
6B52   0C52 000A                 Cmp       $A, (A2)
6B56   671A                      BEQ       L1119
6B58   546E FF74                 AddQ      $2, $-8C(A6)
6B5C   204A                      Move.L    A2, A0
6B5E   43EE FFE8                 Lea.L     $-18(A6), A1
6B62   302E FF7E                 Move      $-82(A6), D0
6B66   322E FF82                 Move      $-7E(A6), D1
6B6A   342E FF5A                 Move      $-A6(A6), D2
6B6E   4EBA 28DA                 Jsr       P_mInitRgn
6B72   0C53 000A      L1119:     Cmp       $A, (A3)
6B76   671A                      BEQ       L1120
6B78   586E FF74                 AddQ      $4, $-8C(A6)
6B7C   204B                      Move.L    A3, A0
6B7E   43EE FFD0                 Lea.L     $-30(A6), A1
6B82   302E FF7E                 Move      $-82(A6), D0
6B86   322E FF82                 Move      $-7E(A6), D1
6B8A   342E FF5A                 Move      $-A6(A6), D2
6B8E   4EBA 28BA                 Jsr       P_mInitRgn
6B92   4A6E FF74      L1120:     Tst       $-8C(A6)
6B96   6618                      BNE       L1121
6B98   206E FF5C                 Move.L    $-A4(A6), A0
6B9C   362E FF7E                 Move      $-82(A6), D3
6BA0   966E FF5A                 Sub       $-A6(A6), D3
6BA4   382E FF82                 Move      $-7E(A6), D4
6BA8   986E FF5A                 Sub       $-A6(A6), D4
6BAC   4EBA 37FA                 Jsr       P252
6BB0   322E FF7C      L1121:     Move      $-84(A6), D1
6BB4   926D 0008                 Sub       $8(A5), D1
6BB8   C2ED 0006                 MulU      $6(A5), D1
6BBC   D2AD 0002                 Add.L     $2(A5), D1
6BC0   946D 000A                 Sub       $A(A5), D2
6BC4   E64A                      LsR       $3, D2
6BC6   48C2                      Ext.L     D2
6BC8   D282                      Add.L     D2, D1
6BCA   2D41 FF54                 Move.L    D1, $-AC(A6)
6BCE   4287                      Clr.L     D7
6BD0   342E FF44                 Move      $-BC(A6), D2
6BD4   0882 0002                 BClr.B    $2, D2
6BD8   6702                      BEQ       L1122
6BDA   4687                      Not.L     D7
6BDC   4EBA EB2E      L1122:     Jsr       P_mSlabMode
6BE0   2D48 FF4E                 Move.L    A0, $-B2(A6)
6BE4   342D 000A                 Move      $A(A5), D2
6BE8   206E FF40                 Move.L    $-C0(A6), A0
6BEC   43EE FF90                 Lea.L     $-70(A6), A1
6BF0   2A6E FF4A                 Move.L    $-B6(A6), A5
6BF4   4EBA E902                 Jsr       P_mPatExpand
6BF8   2A6E FF46                 Move.L    $-BA(A6), A5
6BFC   7E0F                      MoveQ.L   $F, D7
6BFE   CE6E FF7C                 And       $-84(A6), D7
6C02   E54F                      LsL       $2, D7
6C04   2C36 7090                 Move.L    $-70(A6,D7.W), D6
6C08   322E FF5A                 Move      $-A6(A6), D1
6C0C   936E FF70                 Sub       D1, $-90(A6)
6C10   936E FF6C                 Sub       D1, $-94(A6)
6C14   936E FF7E                 Sub       D1, $-82(A6)
6C18   936E FF82                 Sub       D1, $-7E(A6)
6C1C   3D6E FF7C FF52            Move      $-84(A6), $-AE(A6)
6C22   4EBA 0064      L1123:     Jsr       P212
6C26   322E FF70                 Move      $-90(A6), D1
6C2A   342E FF6C                 Move      $-94(A6), D2
6C2E   206E FF4E                 Move.L    $-B2(A6), A0
6C32   226E FF54                 Move.L    $-AC(A6), A1
6C36   246E FF5C                 Move.L    $-A4(A6), A2
6C3A   47EE FF7C                 Lea.L     $-84(A6), A3
6C3E   4EBA EA80                 Jsr       P205
6C42   5847                      AddQ      $4, D7
6C44   0247 003F                 And       $3F, D7
6C48   2C36 7090                 Move.L    $-70(A6,D7.W), D6
6C4C   302D 0006                 Move      $6(A5), D0
6C50   48C0                      Ext.L     D0
6C52   D1AE FF54                 Add.L     D0, $-AC(A6)
6C56   202E FF68                 Move.L    $-98(A6), D0
6C5A   D1AE FF70                 Add.L     D0, $-90(A6)
6C5E   D1AE FF6C                 Add.L     D0, $-94(A6)
6C62   526E FF52                 AddQ      $1, $-AE(A6)
6C66   302E FF52                 Move      $-AE(A6), D0
6C6A   B06E FF80                 Cmp       $-80(A6), D0
6C6E   6DB2                      BLT       L1123
6C70   2A6E FF4A      L1124:     Move.L    $-B6(A6), A5
6C74   4EBA E6F4                 Jsr       P_tShowCursor
6C78   2E6E FF8C      L1125:     Move.L    $-74(A6), A7
6C7C   4CDF 3EFF                 MoveM.L   (A7)+, D0-D7/A1-A5
6C80   4E5E                      Unlk      A6
6C82   205F                      Move.L    (A7)+, A0
6C84   504F                      AddQ      $8, A7
6C86   4ED0                      Jmp       (A0)

                      P212:
6C88   302E FF74                 Move      $-8C(A6), D0
6C8C   303B 0006                 Move      DT39(D0.W), D0
6C90   4EFB 0002                 Jmp       DT39(D0.W)

                      DT39:
6C94   0008 000A 001E            DC.B      '      '
6C9A   0032                      DC.B      ' 2'

                      E_282:
6C9C   4E75                      Rts

                      E_283:
6C9E   302E FF52                 Move      $-AE(A6), D0
6CA2   43EE FFE8                 Lea.L     $-18(A6), A1
6CA6   4EBA 27DA                 Jsr       P_mSeekRgn
6CAA   2D69 0008 FF5C            Move.L    $8(A1), $-A4(A6)
6CB0   4E75                      Rts

                      E_284:
6CB2   302E FF52                 Move      $-AE(A6), D0
6CB6   43EE FFD0                 Lea.L     $-30(A6), A1
6CBA   4EBA 27C6                 Jsr       P_mSeekRgn
6CBE   2D69 0008 FF5C            Move.L    $8(A1), $-A4(A6)
6CC4   4E75                      Rts

                      E_285:
6CC6   302E FF52                 Move      $-AE(A6), D0
6CCA   43EE FFE8                 Lea.L     $-18(A6), A1
6CCE   4EBA 27B2                 Jsr       P_mSeekRgn
6CD2   43EE FFD0                 Lea.L     $-30(A6), A1
6CD6   4EBA 27AA                 Jsr       P_mSeekRgn
6CDA   206E FFF0                 Move.L    $-10(A6), A0
6CDE   226E FFD8                 Move.L    $-28(A6), A1
6CE2   246E FF5C                 Move.L    $-A4(A6), A2
6CE6   322E FF58                 Move      $-A8(A6), D1
6CEA   2018           L1126:     Move.L    (A0)+, D0
6CEC   C099                      And.L     (A1)+, D0
6CEE   24C0                      Move.L    D0, (A2)+
6CF0   51C9 FFF8                 DBF       D1, L1126
6CF4   4E75                      Rts
6CF6   3A2E FF44      L1127:     Move      $-BC(A6), D5
6CFA   4A40                      Tst       D0
6CFC   6604                      BNE       L1128
6CFE   0A45 0004                 Eor       $4, D5
6D02   0C45 000C      L1128:     Cmp       $C, D5
6D06   6E00 FF68                 BGT       L1124
6D0A   B641                      Cmp       D1, D3
6D0C   6600 00A2                 BNE       L1143
6D10   6100 00E0                 Bsr       P213
6D14   4EBA E77C                 Jsr       P_mLeftMask
6D18   3C00                      Move      D0, D6
6D1A   342E FF82                 Move      $-7E(A6), D2
6D1E   946D 000A                 Sub       $A(A5), D2
6D22   3002                      Move      D2, D0
6D24   4EBA E77A                 Jsr       P_mRightMask
6D28   3600                      Move      D0, D3
6D2A   E84A                      LsR       $4, D2
6D2C   0C45 000A                 Cmp       $A, D5
6D30   6D56                      BLT       L1138
6D32   672C                      BEQ       L1133
6D34   4646                      Not       D6
6D36   4643                      Not       D3
6D38   9441                      Sub       D1, D2
6D3A   671C                      BEQ       L1132
6D3C   CD5C                      And       D6, (A4)+
6D3E   4286                      Clr.L     D6
6D40   5342                      SubQ.L    $1, D2
6D42   6714                      BEQ       L1132
6D44   E24A                      LsR       $1, D2
6D46   6408                      BCC       L1130
6D48   38C6                      Move      D6, (A4)+
6D4A   5342                      SubQ.L    $1, D2
6D4C   6006                      Bra       L1131
6D4E   28C6           L1129:     Move.L    D6, (A4)+
6D50   28C6           L1130:     Move.L    D6, (A4)+
6D52   5542                      SubQ.L    $2, D2
6D54   6EF8           L1131:     BGT       L1129
6D56   67F8                      BEQ       L1130
6D58   8C43           L1132:     Or        D3, D6
6D5A   CD54                      And       D6, (A4)
6D5C   6000 FF12                 Bra       L1124
6D60   9441           L1133:     Sub       D1, D2
6D62   671C                      BEQ       L1137
6D64   BD5C                      Eor       D6, (A4)+
6D66   7CFF                      MoveQ.L   $-1, D6
6D68   5342                      SubQ.L    $1, D2
6D6A   6714                      BEQ       L1137
6D6C   E24A                      LsR       $1, D2
6D6E   6408                      BCC       L1135
6D70   BD5C                      Eor       D6, (A4)+
6D72   5342                      SubQ.L    $1, D2
6D74   6006                      Bra       L1136
6D76   469C           L1134:     Not.L     (A4)+
6D78   469C           L1135:     Not.L     (A4)+
6D7A   5542                      SubQ.L    $2, D2
6D7C   6EF8           L1136:     BGT       L1134
6D7E   67F8                      BEQ       L1135
6D80   CC43           L1137:     And       D3, D6
6D82   BD54                      Eor       D6, (A4)
6D84   6000 FEEA                 Bra       L1124
6D88   9441           L1138:     Sub       D1, D2
6D8A   671C                      BEQ       L1142
6D8C   8D5C                      Or        D6, (A4)+
6D8E   7CFF                      MoveQ.L   $-1, D6
6D90   5342                      SubQ.L    $1, D2
6D92   6714                      BEQ       L1142
6D94   E24A                      LsR       $1, D2
6D96   6408                      BCC       L1140
6D98   38C6                      Move      D6, (A4)+
6D9A   5342                      SubQ.L    $1, D2
6D9C   6006                      Bra       L1141
6D9E   28C6           L1139:     Move.L    D6, (A4)+
6DA0   28C6           L1140:     Move.L    D6, (A4)+
6DA2   5542                      SubQ.L    $2, D2
6DA4   6EF8           L1141:     BGT       L1139
6DA6   67F8                      BEQ       L1140
6DA8   CC43           L1142:     And       D3, D6
6DAA   8D54                      Or        D6, (A4)
6DAC   6000 FEC2                 Bra       L1124
6DB0   B842           L1143:     Cmp       D2, D4
6DB2   6100 003E                 Bsr       P213
6DB6   4EBA E6F4                 Jsr       P_mBitMask
6DBA   322E FF80                 Move      $-80(A6), D1
6DBE   926E FF7C                 Sub       $-84(A6), D1
6DC2   5341                      SubQ.L    $1, D1
6DC4   0C45 000A                 Cmp       $A, D5
6DC8   6D1C                      BLT       L1146
6DCA   670E                      BEQ       L1145
6DCC   4640                      Not       D0
6DCE   C154           L1144:     And       D0, (A4)
6DD0   D8C7                      AddA      D7, A4
6DD2   51C9 FFFA                 DBF       D1, L1144
6DD6   6000 FE98                 Bra       L1124
6DDA   B154           L1145:     Eor       D0, (A4)
6DDC   D8C7                      AddA      D7, A4
6DDE   51C9 FFFA                 DBF       D1, L1145
6DE2   6000 FE8C                 Bra       L1124
6DE6   8154           L1146:     Or        D0, (A4)
6DE8   D8C7                      AddA      D7, A4
6DEA   51C9 FFFA                 DBF       D1, L1146
6DEE   6000 FE80                 Bra       L1124

                      P213:
6DF2   322E FF7C                 Move      $-84(A6), D1
6DF6   342E FF7E                 Move      $-82(A6), D2
6DFA   286D 0002                 Move.L    $2(A5), A4
6DFE   3001                      Move      D1, D0
6E00   906D 0008                 Sub       $8(A5), D0
6E04   3E2D 0006                 Move      $6(A5), D7
6E08   C0C7                      MulU      D7, D0
6E0A   D9C0                      AddA.L    D0, A4
6E0C   3002                      Move      D2, D0
6E0E   906D 000A                 Sub       $A(A5), D0
6E12   3200                      Move      D0, D1
6E14   E849                      LsR       $4, D1
6E16   D8C1                      AddA      D1, A4
6E18   D8C1                      AddA      D1, A4
6E1A   4E75                      Rts

                      P_mPutLine:
6E1C   4E56 FFFC                 Link      A6, $-4
6E20   48E7 1F38                 MoveM.L   D3-D7/A2-A4, -(A7)
6E24   342E 001A                 Move      $1A(A6), D2
6E28   382E 0016                 Move      $16(A6), D4
6E2C   B842                      Cmp       D2, D4
6E2E   6700 00DE                 BEQ       L1158
6E32   3002                      Move      D2, D0
6E34   9044                      Sub       D4, D0
6E36   6A00 0004                 BPL       L1147
6E3A   4440                      Neg       D0
6E3C   322E 0018      L1147:     Move      $18(A6), D1
6E40   926E 0014                 Sub       $14(A6), D1
6E44   6A00 0004                 BPL       L1148
6E48   4441                      Neg       D1
6E4A   B041           L1148:     Cmp       D1, D0
6E4C   6F02                      BLE       L1149
6E4E   3001                      Move      D1, D0
6E50   5240           L1149:     AddQ      $1, D0
6E52   E748                      LsL       $3, D0
6E54   266E 0010                 Move.L    $10(A6), A3
6E58   286E 000C                 Move.L    $C(A6), A4
6E5C   D054                      Add       (A4), D0
6E5E   206E 0008                 Move.L    $8(A6), A0
6E62   B050                      Cmp       (A0), D0
6E64   6F12                      BLE       L1150
6E66   0640 0200                 Add       $200, D0
6E6A   3080                      Move      D0, (A0)
6E6C   2F0B                      Move.L    A3, -(A7)
6E6E   3F00                      Move      D0, -(A7)
6E70   4EBA 43AA                 Jsr       P_mSetHSize
6E74   342E 001A                 Move      $1A(A6), D2
6E78   2653           L1150:     Move.L    (A3), A3
6E7A   D6D4                      AddA      (A4), A3
6E7C   322E 0018                 Move      $18(A6), D1
6E80   362E 0014                 Move      $14(A6), D3
6E84   B641                      Cmp       D1, D3
6E86   660C                      BNE       L1151
6E88   36C1                      Move      D1, (A3)+
6E8A   36C2                      Move      D2, (A3)+
6E8C   36C3                      Move      D3, (A3)+
6E8E   36C4                      Move      D4, (A3)+
6E90   6000 0074                 Bra       L1157
6E94   6E04           L1151:     BGT       L1152
6E96   C343                      Exg.L     D1, D3
6E98   C544                      Exg.L     D2, D4
6E9A   3C01           L1152:     Move      D1, D6
6E9C   42A7                      Clr.L     -(A7)
6E9E   3F04                      Move      D4, -(A7)
6EA0   9557                      Sub       D2, (A7)
6EA2   3F03                      Move      D3, -(A7)
6EA4   9357                      Sub       D1, (A7)
6EA6   4EBA E956                 Jsr       P_tFixRatio
6EAA   2E1F                      Move.L    (A7)+, D7
6EAC   3D42 FFFC                 Move      D2, $-4(A6)
6EB0   3D7C 8000 FFFE            Move      $-8000, $-2(A6)
6EB6   2007                      Move.L    D7, D0
6EB8   E280                      AsR.L     $1, D0
6EBA   D1AE FFFC                 Add.L     D0, $-4(A6)
6EBE   4A87                      Tst.L     D7
6EC0   6B0E                      BMI       L1153
6EC2   0C87 0001 0000            Cmp.L     $10000, D7
6EC8   6C12                      BGE       L1154
6ECA   DFAE FFFC                 Add.L     D7, $-4(A6)
6ECE   600C                      Bra       L1154
6ED0   0C87 FFFF 0000 L1153:     Cmp.L     $-10000, D7
6ED6   6C04                      BGE       L1154
6ED8   526E FFFC                 AddQ      $1, $-4(A6)
6EDC   3A02           L1154:     Move      D2, D5
6EDE   BA6E FFFC      L1155:     Cmp       $-4(A6), D5
6EE2   670C                      BEQ       L1156
6EE4   36C6                      Move      D6, (A3)+
6EE6   36C5                      Move      D5, (A3)+
6EE8   3A2E FFFC                 Move      $-4(A6), D5
6EEC   36C6                      Move      D6, (A3)+
6EEE   36C5                      Move      D5, (A3)+
6EF0   5246           L1156:     AddQ      $1, D6
6EF2   DFAE FFFC                 Add.L     D7, $-4(A6)
6EF6   B646                      Cmp       D6, D3
6EF8   66E4                      BNE       L1155
6EFA   BA44                      Cmp       D4, D5
6EFC   6708                      BEQ       L1157
6EFE   36C6                      Move      D6, (A3)+
6F00   36C5                      Move      D5, (A3)+
6F02   36C6                      Move      D6, (A3)+
6F04   36C4                      Move      D4, (A3)+
6F06   206E 0010      L1157:     Move.L    $10(A6), A0
6F0A   97D0                      SubA.L    (A0), A3
6F0C   388B                      Move      A3, (A4)
6F0E   4CDF 1CF8      L1158:     MoveM.L   (A7)+, D3-D7/A2-A4
6F12   4E5E                      Unlk      A6
6F14   205F                      Move.L    (A7)+, A0
6F16   DEFC 0014                 AddA      $14, A7
6F1A   4ED0                      Jmp       (A0)

                      P_tStdRect:
6F1C   4E56 0000                 Link      A6, $0
6F20   48E7 0118                 MoveM.L   D7/A3-A4, -(A7)
6F24   1E2E 000C                 Move.B    $C(A6), D7
6F28   4EBA 4138                 Jsr       P_mCheckPic
6F2C   6F00 0016                 BLE       L1159
6F30   1F07                      Move.B    D7, -(A7)
6F32   4EBA 4026                 Jsr       P_mPutPicVerb
6F36   7030                      MoveQ.L   $30, D0
6F38   D047                      Add       D7, D0
6F3A   1F00                      Move.B    D0, -(A7)
6F3C   2F2E 0008                 Move.L    $8(A6), -(A7)
6F40   4EBA 3FAE                 Jsr       P_mPutPicRect
6F44   2F2E 0008      L1159:     Move.L    $8(A6), -(A7)
6F48   4A07                      Tst.B     D7
6F4A   6620                      BNE       L1161
6F4C   4AAB 0060                 Tst.L     $60(A3)
6F50   6714                      BEQ       L1160
6F52   2F2E 0008                 Move.L    $8(A6), -(A7)
6F56   2F2C FF6C                 Move.L    $-94(A4), -(A7)
6F5A   486C FF6A                 Pea.L     $-96(A4)
6F5E   486C FF68                 Pea.L     $-98(A4)
6F62   4EBA 0382                 Jsr       P_mPutRect
6F66   4EBA 00DC      L1160:     Jsr       P_mFrRect
6F6A   6008                      Bra       L1162
6F6C   4EBA 0012      L1161:     Jsr       P_mPushVerb
6F70   4EBA 0096                 Jsr       P_mDrawRect
6F74   4CDF 1880      L1162:     MoveM.L   (A7)+, D7/A3-A4
6F78   4E5E                      Unlk      A6
6F7A   205F                      Move.L    (A7)+, A0
6F7C   5C4F                      AddQ      $6, A7
6F7E   4ED0                      Jmp       (A0)

                      P_mPushVerb:
6F80   205F                      Move.L    (A7)+, A0
6F82   0C07 0001                 Cmp.B     $1, D7
6F86   6F26                      BLE       L1165
6F88   0C07 0003                 Cmp.B     $3, D7
6F8C   6D0C                      BLT       L1163
6F8E   6714                      BEQ       L1164
6F90   3F3C 0008                 Move      $8, -(A7)
6F94   486B 0028                 Pea.L     $28(A3)
6F98   601C                      Bra       L1166
6F9A   3F3C 0008      L1163:     Move      $8, -(A7)
6F9E   486B 0020                 Pea.L     $20(A3)
6FA2   6012                      Bra       L1166
6FA4   3F3C 000A      L1164:     Move      $A, -(A7)
6FA8   486C FFF0                 Pea.L     $-10(A4)
6FAC   6008                      Bra       L1166
6FAE   3F2B 0038      L1165:     Move      $38(A3), -(A7)
6FB2   486B 003A                 Pea.L     $3A(A3)
6FB6   4ED0           L1166:     Jmp       (A0)
                      P_mCallRect:
6FB8   205F                      Move.L    (A7)+, A0
6FBA   225F                      Move.L    (A7)+, A1
6FBC   1F00                      Move.B    D0, -(A7)
6FBE   2F09                      Move.L    A1, -(A7)
6FC0   2F08                      Move.L    A0, -(A7)
6FC2   2055                      Move.L    (A5), A0
6FC4   2050                      Move.L    (A0), A0
6FC6   2028 0068                 Move.L    $68(A0), D0
6FCA   41FA FF50                 Lea.L     P_tStdRect, A0
6FCE   6706                      BEQ       L1168
6FD0   2040                      Move.L    D0, A0
6FD2   2068 0008                 Move.L    $8(A0), A0
6FD6   4ED0           L1168:     Jmp       (A0)

                      P_tFrameRect:
6FD8   7000                      MoveQ.L   $0, D0
6FDA   4EFA FFDC                 Jmp       P_mCallRect

                      P_tPaintRect:
6FDE   7001                      MoveQ.L   $1, D0
6FE0   4EFA FFD6                 Jmp       P_mCallRect

                      P_tEraseRect:
6FE4   7002                      MoveQ.L   $2, D0
6FE6   4EFA FFD0                 Jmp       P_mCallRect

                      P_tInverRect:
6FEA   7003                      MoveQ.L   $3, D0
6FEC   4EFA FFCA                 Jmp       P_mCallRect

                      P_tFillRect:
6FF0   205F                      Move.L    (A7)+, A0
6FF2   225F                      Move.L    (A7)+, A1
6FF4   2F08                      Move.L    A0, -(A7)
6FF6   2055                      Move.L    (A5), A0
6FF8   2050                      Move.L    (A0), A0
6FFA   41E8 0028                 Lea.L     $28(A0), A0
6FFE   20D9                      Move.L    (A1)+, (A0)+
7000   20D9                      Move.L    (A1)+, (A0)+
7002   7004                      MoveQ.L   $4, D0
7004   4EFA FFB2                 Jmp       P_mCallRect

                      P_mDrawRect:
7008   4E56 0000                 Link      A6, $0
700C   2055                      Move.L    (A5), A0
700E   2250                      Move.L    (A0), A1
7010   4A69 0042                 Tst       $42(A1)
7014   6D24                      BLT       L1169
7016   4869 0002                 Pea.L     $2(A1)
701A   2F17                      Move.L    (A7), -(A7)
701C   2F2E 000E                 Move.L    $E(A6), -(A7)
7020   2F17                      Move.L    (A7), -(A7)
7022   3F2E 000C                 Move      $C(A6), -(A7)
7026   2F2E 0008                 Move.L    $8(A6), -(A7)
702A   2F29 001C                 Move.L    $1C(A1), -(A7)
702E   2F29 0018                 Move.L    $18(A1), -(A7)
7032   2F28 FF7E                 Move.L    $-82(A0), -(A7)
7036   4EBA 06A8                 Jsr       P_mRgnBlt
703A   4E5E           L1169:     Unlk      A6
703C   205F                      Move.L    (A7)+, A0
703E   DEFC 000A                 AddA      $A, A7
7042   4ED0                      Jmp       (A0)

                      P_mFrRect:
7044   4E56 FFE4                 Link      A6, $-1C
7048   2055                      Move.L    (A5), A0
704A   2050                      Move.L    (A0), A0
704C   4A68 0042                 Tst       $42(A0)
7050   6D00 00E0                 BLT       L1171
7054   226E 0008                 Move.L    $8(A6), A1
7058   2D59 FFE4                 Move.L    (A1)+, $-1C(A6)
705C   2D59 FFE8                 Move.L    (A1)+, $-18(A6)
7060   43EE FFE4                 Lea.L     $-1C(A6), A1
7064   3428 0036                 Move      $36(A0), D2
7068   3029 0002                 Move      $2(A1), D0
706C   3D40 FFFE                 Move      D0, $-2(A6)
7070   D042                      Add       D2, D0
7072   3D40 FFFC                 Move      D0, $-4(A6)
7076   3229 0006                 Move      $6(A1), D1
707A   3D41 FFF6                 Move      D1, $-A(A6)
707E   9242                      Sub       D2, D1
7080   3D41 FFFA                 Move      D1, $-6(A6)
7084   B041                      Cmp       D1, D0
7086   6C00 00A8                 BGE       L1170
708A   3428 0034                 Move      $34(A0), D2
708E   3011                      Move      (A1), D0
7090   3D40 FFF4                 Move      D0, $-C(A6)
7094   D042                      Add       D2, D0
7096   3D40 FFF2                 Move      D0, $-E(A6)
709A   3229 0004                 Move      $4(A1), D1
709E   3D41 FFEC                 Move      D1, $-14(A6)
70A2   9242                      Sub       D2, D1
70A4   3D41 FFF0                 Move      D1, $-10(A6)
70A8   B041                      Cmp       D1, D0
70AA   6C00 0084                 BGE       L1170
70AE   3D6E FFFE FFE6            Move      $-2(A6), $-1A(A6)
70B4   3D6E FFFA FFEA            Move      $-6(A6), $-16(A6)
70BA   3D6E FFF4 FFE4            Move      $-C(A6), $-1C(A6)
70C0   3D6E FFF2 FFE8            Move      $-E(A6), $-18(A6)
70C6   613E                      Bsr       P218
70C8   3D6E FFFA FFE6            Move      $-6(A6), $-1A(A6)
70CE   3D6E FFF6 FFEA            Move      $-A(A6), $-16(A6)
70D4   3D6E FFF0 FFE8            Move      $-10(A6), $-18(A6)
70DA   612A                      Bsr       P218
70DC   3D6E FFFC FFE6            Move      $-4(A6), $-1A(A6)
70E2   3D6E FFF0 FFE4            Move      $-10(A6), $-1C(A6)
70E8   3D6E FFEC FFE8            Move      $-14(A6), $-18(A6)
70EE   6116                      Bsr       P218
70F0   3D6E FFFE FFE6            Move      $-2(A6), $-1A(A6)
70F6   3D6E FFFC FFEA            Move      $-4(A6), $-16(A6)
70FC   3D6E FFF2 FFE4            Move      $-E(A6), $-1C(A6)
7102   6102                      Bsr       P218
7104   602C                      Bra       L1171

                      P218:
7106   2055                      Move.L    (A5), A0
7108   2250                      Move.L    (A0), A1
710A   4869 0002                 Pea.L     $2(A1)
710E   2F17                      Move.L    (A7), -(A7)
7110   486E FFE4                 Pea.L     $-1C(A6)
7114   2F17                      Move.L    (A7), -(A7)
7116   3F29 0038                 Move      $38(A1), -(A7)
711A   4869 003A                 Pea.L     $3A(A1)
711E   2F29 001C                 Move.L    $1C(A1), -(A7)
7122   2F29 0018                 Move.L    $18(A1), -(A7)
7126   2F28 FF7E                 Move.L    $-82(A0), -(A7)
712A   4EBA 05B4                 Jsr       P_mRgnBlt
712E   4E75                      Rts
7130   61D4           L1170:     Bsr       P218
7132   4E5E           L1171:     Unlk      A6
7134   2E9F                      Move.L    (A7)+, (A7)
7136   4E75                      Rts

                      P_tSetRect:
7138   205F                      Move.L    (A7)+, A0
713A   221F                      Move.L    (A7)+, D1
713C   201F                      Move.L    (A7)+, D0
713E   225F                      Move.L    (A7)+, A1
7140   22C0                      Move.L    D0, (A1)+
7142   22C1                      Move.L    D1, (A1)+
7144   4ED0                      Jmp       (A0)

                      P_tEqualRect:
7146   201F                      Move.L    (A7)+, D0
7148   225F                      Move.L    (A7)+, A1
714A   205F                      Move.L    (A7)+, A0
714C   B388                      CmpM.L    (A0)+, (A1)+
714E   660A                      BNE       L1172
7150   B388                      CmpM.L    (A0)+, (A1)+
7152   6606                      BNE       L1172
7154   1EBC 0001                 Move.B    $1, (A7)
7158   6002                      Bra       L1173
715A   4217           L1172:     Clr.B     (A7)
715C   2F00           L1173:     Move.L    D0, -(A7)
715E   4E75                      Rts

                      P_tEmptyRect:
7160   225F                      Move.L    (A7)+, A1
7162   205F                      Move.L    (A7)+, A0
7164   3018                      Move      (A0)+, D0
7166   3218                      Move      (A0)+, D1
7168   B058                      Cmp       (A0)+, D0
716A   6C08                      BGE       L1174
716C   B258                      Cmp       (A0)+, D1
716E   6C04                      BGE       L1174
7170   4217                      Clr.B     (A7)
7172   6004                      Bra       L1175
7174   1EBC 0001      L1174:     Move.B    $1, (A7)
7178   4ED1           L1175:     Jmp       (A1)

                      P_tOffsetRect:
717A   205F                      Move.L    (A7)+, A0
717C   321F                      Move      (A7)+, D1
717E   301F                      Move      (A7)+, D0
7180   225F                      Move.L    (A7)+, A1
7182   D359                      Add       D1, (A1)+
7184   D159                      Add       D0, (A1)+
7186   D359                      Add       D1, (A1)+
7188   D159                      Add       D0, (A1)+
718A   4ED0                      Jmp       (A0)

                      P_tInsetRect:
718C   205F                      Move.L    (A7)+, A0
718E   321F                      Move      (A7)+, D1
7190   301F                      Move      (A7)+, D0
7192   225F                      Move.L    (A7)+, A1
7194   D359                      Add       D1, (A1)+
7196   D159                      Add       D0, (A1)+
7198   9359                      Sub       D1, (A1)+
719A   9159                      Sub       D0, (A1)+
719C   4ED0                      Jmp       (A0)

                      P_tSectRect:
719E   4E56 0000                 Link      A6, $0
71A2   2F2E 0010                 Move.L    $10(A6), -(A7)
71A6   2F2E 000C                 Move.L    $C(A6), -(A7)
71AA   3F3C 0002                 Move      $2, -(A7)
71AE   2F2E 0008                 Move.L    $8(A6), -(A7)
71B2   6100 0014                 Bsr       P_mRSect
71B6   56EE 0014                 SNE.B     $14(A6)
71BA   442E 0014                 Neg.B     $14(A6)
71BE   4E5E                      Unlk      A6
71C0   205F                      Move.L    (A7)+, A0
71C2   DEFC 000C                 AddA      $C, A7
71C6   4ED0                      Jmp       (A0)

                      P_mRSect:
71C8   4E56 0000                 Link      A6, $0
71CC   48E7 7840                 MoveM.L   D1-D4/A1, -(A7)
71D0   43EE 000C                 Lea.L     $C(A6), A1
71D4   3019                      Move      (A1)+, D0
71D6   6F3A                      BLE       L1181
71D8   2059                      Move.L    (A1)+, A0
71DA   4C98 001E                 MoveM     (A0)+, D1-D4
71DE   5340                      SubQ.L    $1, D0
71E0   6022                      Bra       L1180
71E2   2059           L1176:     Move.L    (A1)+, A0
71E4   B258                      Cmp       (A0)+, D1
71E6   6C04                      BGE       L1177
71E8   3228 FFFE                 Move      $-2(A0), D1
71EC   B458           L1177:     Cmp       (A0)+, D2
71EE   6C04                      BGE       L1178
71F0   3428 FFFE                 Move      $-2(A0), D2
71F4   B658           L1178:     Cmp       (A0)+, D3
71F6   6F04                      BLE       L1179
71F8   3628 FFFE                 Move      $-2(A0), D3
71FC   B858           L1179:     Cmp       (A0)+, D4
71FE   6F04                      BLE       L1180
7200   3828 FFFE                 Move      $-2(A0), D4
7204   B641           L1180:     Cmp       D1, D3
7206   6F0A                      BLE       L1181
7208   B842                      Cmp       D2, D4
720A   6F06                      BLE       L1181
720C   51C8 FFD4                 DBF       D0, L1176
7210   6008                      Bra       L1182
7212   4241           L1181:     Clr       D1
7214   4242                      Clr       D2
7216   4243                      Clr       D3
7218   4244                      Clr       D4
721A   206E 0008      L1182:     Move.L    $8(A6), A0
721E   30C1                      Move      D1, (A0)+
7220   30C2                      Move      D2, (A0)+
7222   30C3                      Move      D3, (A0)+
7224   30C4                      Move      D4, (A0)+
7226   302E 000C                 Move      $C(A6), D0
722A   E548                      LsL       $2, D0
722C   5C40                      AddQ      $6, D0
722E   B641                      Cmp       D1, D3
7230   4CDF 021E                 MoveM.L   (A7)+, D1-D4/A1
7234   4E5E                      Unlk      A6
7236   205F                      Move.L    (A7)+, A0
7238   DEC0                      AddA      D0, A7
723A   4ED0                      Jmp       (A0)

                      P_tUnionRect:
723C   206F 000C                 Move.L    $C(A7), A0
7240   226F 0008                 Move.L    $8(A7), A1
7244   3018                      Move      (A0)+, D0
7246   B059                      Cmp       (A1)+, D0
7248   6F04                      BLE       L1183
724A   3029 FFFE                 Move      $-2(A1), D0
724E   4840           L1183:     Swap      D0
7250   3018                      Move      (A0)+, D0
7252   B059                      Cmp       (A1)+, D0
7254   6F04                      BLE       L1184
7256   3029 FFFE                 Move      $-2(A1), D0
725A   3218           L1184:     Move      (A0)+, D1
725C   B259                      Cmp       (A1)+, D1
725E   6C04                      BGE       L1185
7260   3229 FFFE                 Move      $-2(A1), D1
7264   4841           L1185:     Swap      D1
7266   3218                      Move      (A0)+, D1
7268   B259                      Cmp       (A1)+, D1
726A   6C04                      BGE       L1186
726C   3229 FFFE                 Move      $-2(A1), D1
7270   206F 0004      L1186:     Move.L    $4(A7), A0
7274   20C0                      Move.L    D0, (A0)+
7276   20C1                      Move.L    D1, (A0)+
7278   205F                      Move.L    (A7)+, A0
727A   DEFC 000C                 AddA      $C, A7
727E   4ED0                      Jmp       (A0)

                      P_tPt2Rect:
7280   206F 0004                 Move.L    $4(A7), A0
7284   302F 000E                 Move      $E(A7), D0
7288   322F 000A                 Move      $A(A7), D1
728C   B240                      Cmp       D0, D1
728E   6C02                      BGE       L1187
7290   C141                      Exg.L     D0, D1
7292   3140 0002      L1187:     Move      D0, $2(A0)
7296   3141 0006                 Move      D1, $6(A0)
729A   302F 000C                 Move      $C(A7), D0
729E   322F 0008                 Move      $8(A7), D1
72A2   B240                      Cmp       D0, D1
72A4   6C02                      BGE       L1188
72A6   C141                      Exg.L     D0, D1
72A8   3080           L1188:     Move      D0, (A0)
72AA   3141 0004                 Move      D1, $4(A0)
72AE   205F                      Move.L    (A7)+, A0
72B0   DEFC 000C                 AddA      $C, A7
72B4   4ED0                      Jmp       (A0)

                      P_tPtInRect:
72B6   4E56 0000                 Link      A6, $0
72BA   206E 0008                 Move.L    $8(A6), A0
72BE   302E 000E                 Move      $E(A6), D0
72C2   322E 000C                 Move      $C(A6), D1
72C6   422E 0010                 Clr.B     $10(A6)
72CA   B258                      Cmp       (A0)+, D1
72CC   6D10                      BLT       L1189
72CE   B058                      Cmp       (A0)+, D0
72D0   6D0C                      BLT       L1189
72D2   B258                      Cmp       (A0)+, D1
72D4   6C08                      BGE       L1189
72D6   B058                      Cmp       (A0)+, D0
72D8   6C04                      BGE       L1189
72DA   522E 0010                 AddQ      $1, $10(A6)
72DE   4E5E           L1189:     Unlk      A6
72E0   205F                      Move.L    (A7)+, A0
72E2   504F                      AddQ      $8, A7
72E4   4ED0                      Jmp       (A0)

                      P_mPutRect:
72E6   4E56 0000                 Link      A6, $0
72EA   206E 000C                 Move.L    $C(A6), A0
72EE   226E 0008                 Move.L    $8(A6), A1
72F2   7010                      MoveQ.L   $10, D0
72F4   D050                      Add       (A0), D0
72F6   B051                      Cmp       (A1), D0
72F8   6F1A                      BLE       L1190
72FA   0651 0400                 Add       $400, (A1)
72FE   48E7 1020                 MoveM.L   D3/A2, -(A7)
7302   2F2E 0010                 Move.L    $10(A6), -(A7)
7306   3F11                      Move      (A1), -(A7)
7308   4EBA 3F12                 Jsr       P_mSetHSize
730C   4CDF 0408                 MoveM.L   (A7)+, D3/A2
7310   206E 000C                 Move.L    $C(A6), A0
7314   226E 0010      L1190:     Move.L    $10(A6), A1
7318   2251                      Move.L    (A1), A1
731A   D2D0                      AddA      (A0), A1
731C   0650 0010                 Add       $10, (A0)
7320   206E 0014                 Move.L    $14(A6), A0
7324   22D0                      Move.L    (A0), (A1)+
7326   32D0                      Move      (A0), (A1)+
7328   32E8 0006                 Move      $6(A0), (A1)+
732C   32E8 0004                 Move      $4(A0), (A1)+
7330   32E8 0002                 Move      $2(A0), (A1)+
7334   22E8 0004                 Move.L    $4(A0), (A1)+
7338   4E5E                      Unlk      A6
733A   205F                      Move.L    (A7)+, A0
733C   DEFC 0010                 AddA      $10, A7
7340   4ED0                      Jmp       (A0)

                      P_mBitBlt:
7342   4E56 FFA8                 Link      A6, $-58
7346   48E7 FF7C                 MoveM.L   D0-D7/A1-A5, -(A7)
734A   2D4D FFA8                 Move.L    A5, $-58(A6)
734E   246E 0012                 Move.L    $12(A6), A2
7352   266E 000E                 Move.L    $E(A6), A3
7356   286E 001A                 Move.L    $1A(A6), A4
735A   2A6E 0016                 Move.L    $16(A6), A5
735E   302B 0004                 Move      $4(A3), D0
7362   9053                      Sub       (A3), D0
7364   6F00 019A                 BLE       L1203
7368   3D40 FFAE                 Move      D0, $-52(A6)
736C   7602                      MoveQ.L   $2, D3
736E   3012                      Move      (A2), D0
7370   906C 0006                 Sub       $6(A4), D0
7374   3D40 FFBE                 Move      D0, $-42(A6)
7378   3013                      Move      (A3), D0
737A   906D 0006                 Sub       $6(A5), D0
737E   3D40 FFBC                 Move      D0, $-44(A6)
7382   3D6C 0004 FFBA            Move      $4(A4), $-46(A6)
7388   3D6D 0004 FFB8            Move      $4(A5), $-48(A6)
738E   4247                      Clr       D7
7390   302E 000C                 Move      $C(A6), D0
7394   0800 0002                 BTst.B    $2, D0
7398   6702                      BEQ       L1191
739A   4647                      Not       D7
739C   0800 0003      L1191:     BTst.B    $3, D0
73A0   6724                      BEQ       L1192
73A2   342D 0008                 Move      $8(A5), D2
73A6   206E 0008                 Move.L    $8(A6), A0
73AA   43EE FFC0                 Lea.L     $-40(A6), A1
73AE   2A6E FFA8                 Move.L    $-58(A6), A5
73B2   4EBA E144                 Jsr       P_mPatExpand
73B6   2A6E 0016                 Move.L    $16(A6), A5
73BA   7E0F                      MoveQ.L   $F, D7
73BC   CE53                      And       (A3), D7
73BE   E54F                      LsL       $2, D7
73C0   2C36 70C0                 Move.L    $-40(A6,D7.W), D6
73C4   6070                      Bra       L1195
73C6   2014           L1192:     Move.L    (A4), D0
73C8   B095                      Cmp.L     (A5), D0
73CA   663A                      BNE       L1194
73CC   302E FFBE                 Move      $-42(A6), D0
73D0   B06E FFBC                 Cmp       $-44(A6), D0
73D4   6E30                      BGT       L1194
73D6   6D18                      BLT       L1193
73D8   302A 0002                 Move      $2(A2), D0
73DC   906C 0008                 Sub       $8(A4), D0
73E0   322B 0002                 Move      $2(A3), D1
73E4   926D 0008                 Sub       $8(A5), D1
73E8   B041                      Cmp       D1, D0
73EA   6C1A                      BGE       L1194
73EC   4443                      Neg       D3
73EE   6016                      Bra       L1194
73F0   302E FFAE      L1193:     Move      $-52(A6), D0
73F4   5340                      SubQ.L    $1, D0
73F6   D16E FFBE                 Add       D0, $-42(A6)
73FA   D16E FFBC                 Add       D0, $-44(A6)
73FE   446E FFBA                 Neg       $-46(A6)
7402   446E FFB8                 Neg       $-48(A6)
7406   3C2B 0002      L1194:     Move      $2(A3), D6
740A   9C6D 0008                 Sub       $8(A5), D6
740E   322A 0002                 Move      $2(A2), D1
7412   926C 0008                 Sub       $8(A4), D1
7416   9C41                      Sub       D1, D6
7418   0246 000F                 And       $F, D6
741C   302E FFBE                 Move      $-42(A6), D0
7420   C0EC 0004                 MulU      $4(A4), D0
7424   2854                      Move.L    (A4), A4
7426   D9C0                      AddA.L    D0, A4
7428   D246                      Add       D6, D1
742A   E641                      AsR       $3, D1
742C   0241 FFFE                 And       $-2, D1
7430   D8C1                      AddA      D1, A4
7432   2D4C FFB4                 Move.L    A4, $-4C(A6)
7436   322B 0002      L1195:     Move      $2(A3), D1
743A   926D 0008                 Sub       $8(A5), D1
743E   302E FFBC                 Move      $-44(A6), D0
7442   C0ED 0004                 MulU      $4(A5), D0
7446   2A55                      Move.L    (A5), A5
7448   DBC0                      AddA.L    D0, A5
744A   3001                      Move      D1, D0
744C   E841                      AsR       $4, D1
744E   D241                      Add       D1, D1
7450   DAC1                      AddA      D1, A5
7452   2D4D FFB0                 Move.L    A5, $-50(A6)
7456   3200                      Move      D0, D1
7458   4EBA E038                 Jsr       P_mLeftMask
745C   3800                      Move      D0, D4
745E   0241 000F                 And       $F, D1
7462   302B 0006                 Move      $6(A3), D0
7466   906B 0002                 Sub       $2(A3), D0
746A   6F00 0094                 BLE       L1203
746E   D041                      Add       D1, D0
7470   3200                      Move      D0, D1
7472   4EBA E02C                 Jsr       P_mRightMask
7476   3A00                      Move      D0, D5
7478   E841                      AsR       $4, D1
747A   3D41 FFAC                 Move      D1, $-54(A6)
747E   4A43                      Tst       D3
7480   6A10                      BPL       L1196
7482   D241                      Add       D1, D1
7484   D8C1                      AddA      D1, A4
7486   2D4C FFB4                 Move.L    A4, $-4C(A6)
748A   DAC1                      AddA      D1, A5
748C   2D4D FFB0                 Move.L    A5, $-50(A6)
7490   C945                      Exg.L     D4, D5
7492   302E 000C      L1196:     Move      $C(A6), D0
7496   6618                      BNE       L1197
7498   4A46                      Tst       D6
749A   6614                      BNE       L1197
749C   4A6E FFAC                 Tst       $-54(A6)
74A0   6F0E                      BLE       L1197
74A2   43FA 00BE                 Lea.L     E_302, A1
74A6   4A43                      Tst       D3
74A8   6A24                      BPL       L1199
74AA   43FA 0082                 Lea.L     E_301, A1
74AE   601E                      Bra       L1199
74B0   0240 000B      L1197:     And       $B, D0
74B4   3200                      Move      D0, D1
74B6   0240 0003                 And       $3, D0
74BA   D240                      Add       D0, D1
74BC   4A6E FFAC                 Tst       $-54(A6)
74C0   6604                      BNE       L1198
74C2   0641 0010                 Add       $10, D1
74C6   43FA 0046      L1198:     Lea.L     DT40, A1
74CA   D2F1 1000                 AddA      $0(A1,D1.W), A1
74CE   3204           L1199:     Move      D4, D1
74D0   342E FFAC                 Move      $-54(A6), D2
74D4   4ED1                      Jmp       (A1)
74D6   286E FFB4      L1200:     Move.L    $-4C(A6), A4
74DA   D8EE FFBA                 AddA      $-46(A6), A4
74DE   2D4C FFB4                 Move.L    A4, $-4C(A6)
74E2   600A                      Bra       L1202
74E4   5847           L1201:     AddQ      $4, D7
74E6   0247 003F                 And       $3F, D7
74EA   2C36 70C0                 Move.L    $-40(A6,D7.W), D6
74EE   2A6E FFB0      L1202:     Move.L    $-50(A6), A5
74F2   DAEE FFB8                 AddA      $-48(A6), A5
74F6   2D4D FFB0                 Move.L    A5, $-50(A6)
74FA   536E FFAE                 SubQ.L    $1, $-52(A6)
74FE   66CE                      BNE       L1199
7500   4CDF 3EFF      L1203:     MoveM.L   (A7)+, D0-D7/A1-A5
7504   4E5E                      Unlk      A6
7506   205F                      Move.L    (A7)+, A0
7508   DEFC 0016                 AddA      $16, A7
750C   4ED0                      Jmp       (A0)

                      DT40:
750E   007C 00A0 00BE            DC.B      ' |    '
7514   00DC 0126 015E            DC.B      '   & ^'
751A   0170 019C 007A            DC.B      ' p   z'
7520   009E 00BC 00DA            DC.B      '      '
7526   00FA 015C 0190            DC.B      '   \  '
752C   019A                      DC.B      '  '

                      E_301:
752E   3014                      Move      (A4), D0
7530   D8C3                      AddA      D3, A4
7532   C041                      And       D1, D0
7534   4641                      Not       D1
7536   C255                      And       (A5), D1
7538   8041                      Or        D1, D0
753A   3A80                      Move      D0, (A5)
753C   DAC3                      AddA      D3, A5
753E   72FF                      MoveQ.L   $-1, D1
7540   5342                      SubQ.L    $1, D2
7542   6744                      BEQ       E_303
7544   98C3                      SubA      D3, A4
7546   9AC3                      SubA      D3, A5
7548   E24A                      LsR       $1, D2
754A   6408                      BCC       L1205
754C   3B24                      Move      -(A4), -(A5)
754E   5342                      SubQ.L    $1, D2
7550   6006                      Bra       L1206
7552   2B24           L1204:     Move.L    -(A4), -(A5)
7554   2B24           L1205:     Move.L    -(A4), -(A5)
7556   5542                      SubQ.L    $2, D2
7558   6EF8           L1206:     BGT       L1204
755A   67F8                      BEQ       L1205
755C   D8C3                      AddA      D3, A4
755E   DAC3                      AddA      D3, A5
7560   6026                      Bra       E_303

                      E_302:
7562   301C                      Move      (A4)+, D0
7564   C041                      And       D1, D0
7566   4641                      Not       D1
7568   C255                      And       (A5), D1
756A   8041                      Or        D1, D0
756C   3AC0                      Move      D0, (A5)+
756E   72FF                      MoveQ.L   $-1, D1
7570   5342                      SubQ.L    $1, D2
7572   6714                      BEQ       E_303
7574   E24A                      LsR       $1, D2
7576   6408                      BCC       L1208
7578   3ADC                      Move      (A4)+, (A5)+
757A   5342                      SubQ.L    $1, D2
757C   6006                      Bra       L1209
757E   2ADC           L1207:     Move.L    (A4)+, (A5)+
7580   2ADC           L1208:     Move.L    (A4)+, (A5)+
7582   5542                      SubQ.L    $2, D2
7584   6EF8           L1209:     BGT       L1207
7586   67F8                      BEQ       L1208

                      E_303:
7588   C245                      And       D5, D1

                      E_304:
758A   202C FFFE                 Move.L    $-2(A4), D0
758E   D8C3                      AddA      D3, A4
7590   ECA8                      LsR.L     D6, D0
7592   BF40                      Eor       D7, D0
7594   C041                      And       D1, D0
7596   4641                      Not       D1
7598   C255                      And       (A5), D1
759A   8041                      Or        D1, D0
759C   3A80                      Move      D0, (A5)
759E   DAC3                      AddA      D3, A5
75A0   72FF                      MoveQ.L   $-1, D1
75A2   5342                      SubQ.L    $1, D2
75A4   6EE4                      BGT       E_304
75A6   67E0                      BEQ       E_303
75A8   6000 FF2C                 Bra       L1200

                      E_305:
75AC   C245                      And       D5, D1

                      E_306:
75AE   202C FFFE                 Move.L    $-2(A4), D0
75B2   D8C3                      AddA      D3, A4
75B4   ECA8                      LsR.L     D6, D0
75B6   BF40                      Eor       D7, D0
75B8   C041                      And       D1, D0
75BA   8155                      Or        D0, (A5)
75BC   DAC3                      AddA      D3, A5
75BE   72FF                      MoveQ.L   $-1, D1
75C0   5342                      SubQ.L    $1, D2
75C2   6EEA                      BGT       E_306
75C4   67E6                      BEQ       E_305
75C6   6000 FF0E                 Bra       L1200

                      E_307:
75CA   C245                      And       D5, D1

                      E_308:
75CC   202C FFFE                 Move.L    $-2(A4), D0
75D0   D8C3                      AddA      D3, A4
75D2   ECA8                      LsR.L     D6, D0
75D4   BF40                      Eor       D7, D0
75D6   C041                      And       D1, D0
75D8   B155                      Eor       D0, (A5)
75DA   DAC3                      AddA      D3, A5
75DC   72FF                      MoveQ.L   $-1, D1
75DE   5342                      SubQ.L    $1, D2
75E0   6EEA                      BGT       E_308
75E2   67E6                      BEQ       E_307
75E4   6000 FEF0                 Bra       L1200

                      E_309:
75E8   C245                      And       D5, D1

                      E_310:
75EA   202C FFFE                 Move.L    $-2(A4), D0
75EE   D8C3                      AddA      D3, A4
75F0   ECA8                      LsR.L     D6, D0
75F2   BF40                      Eor       D7, D0
75F4   C041                      And       D1, D0
75F6   4640                      Not       D0
75F8   C155                      And       D0, (A5)
75FA   DAC3                      AddA      D3, A5
75FC   72FF                      MoveQ.L   $-1, D1
75FE   5342                      SubQ.L    $1, D2
7600   6EE8                      BGT       E_310
7602   67E4                      BEQ       E_309
7604   6000 FED0                 Bra       L1200

                      E_311:
7608   C245                      And       D5, D1
760A   3A01                      Move      D1, D5
760C   4645                      Not       D5
760E   362E FFB8                 Move      $-48(A6), D3
7612   342E FFAE                 Move      $-52(A6), D2
7616   CC41           L1210:     And       D1, D6
7618   3015                      Move      (A5), D0
761A   C045                      And       D5, D0
761C   8046                      Or        D6, D0
761E   3A80                      Move      D0, (A5)
7620   DAC3                      AddA      D3, A5
7622   5847                      AddQ      $4, D7
7624   0247 003F                 And       $3F, D7
7628   3C36 70C0                 Move      $-40(A6,D7.W), D6
762C   5342                      SubQ.L    $1, D2
762E   66E6                      BNE       L1210
7630   6000 FECE                 Bra       L1203

                      E_312:
7634   3006                      Move      D6, D0
7636   C041                      And       D1, D0
7638   4641                      Not       D1
763A   C255                      And       (A5), D1
763C   8041                      Or        D1, D0
763E   3AC0                      Move      D0, (A5)+
7640   72FF                      MoveQ.L   $-1, D1
7642   5342                      SubQ.L    $1, D2
7644   6714                      BEQ       L1214
7646   E24A                      LsR       $1, D2
7648   6408                      BCC       L1212
764A   3AC6                      Move      D6, (A5)+
764C   5342                      SubQ.L    $1, D2
764E   6006                      Bra       L1213
7650   2AC6           L1211:     Move.L    D6, (A5)+
7652   2AC6           L1212:     Move.L    D6, (A5)+
7654   5542                      SubQ.L    $2, D2
7656   6EF8           L1213:     BGT       L1211
7658   67F8                      BEQ       L1212
765A   C245           L1214:     And       D5, D1
765C   CC41                      And       D1, D6
765E   4641                      Not       D1
7660   C255                      And       (A5), D1
7662   8C41                      Or        D1, D6
7664   3AC6                      Move      D6, (A5)+
7666   6000 FE7C                 Bra       L1201

                      E_313:
766A   C245                      And       D5, D1

                      E_314:
766C   3006                      Move      D6, D0
766E   C041                      And       D1, D0
7670   815D                      Or        D0, (A5)+
7672   72FF                      MoveQ.L   $-1, D1
7674   5342                      SubQ.L    $1, D2
7676   6EF4                      BGT       E_314
7678   67F0                      BEQ       E_313
767A   6000 FE68                 Bra       L1201

                      E_315:
767E   3006                      Move      D6, D0
7680   C041                      And       D1, D0
7682   B15D                      Eor       D0, (A5)+
7684   72FF                      MoveQ.L   $-1, D1
7686   5342                      SubQ.L    $1, D2
7688   6714                      BEQ       E_316
768A   E24A                      LsR       $1, D2
768C   6408                      BCC       L1216
768E   BD5D                      Eor       D6, (A5)+
7690   5342                      SubQ.L    $1, D2
7692   6006                      Bra       L1217
7694   BD9D           L1215:     Eor.L     D6, (A5)+
7696   BD9D           L1216:     Eor.L     D6, (A5)+
7698   5542                      SubQ.L    $2, D2
769A   6EF8           L1217:     BGT       L1215
769C   67F8                      BEQ       L1216

                      E_316:
769E   C245                      And       D5, D1
76A0   CC41                      And       D1, D6
76A2   BD5D                      Eor       D6, (A5)+
76A4   6000 FE3E                 Bra       L1201

                      E_317:
76A8   C245                      And       D5, D1

                      E_318:
76AA   3006                      Move      D6, D0
76AC   C041                      And       D1, D0
76AE   4640                      Not       D0
76B0   C15D                      And       D0, (A5)+
76B2   72FF                      MoveQ.L   $-1, D1
76B4   5342                      SubQ.L    $1, D2
76B6   6EF2                      BGT       E_318
76B8   67EE                      BEQ       E_317
76BA   6000 FE28                 Bra       L1201
                      ; CopyRight notice
76BE   436F 7079 5269            DC.B      'CopyRi'
76C4   6768 7420 3139            DC.B      'ght 19'
76CA   3833 2041 7070            DC.B      '83 App'
76D0   6C65 2043 6F6D            DC.B      'le Com'
76D6   7075 7465 7220            DC.B      'puter '
76DC   496E 632E                 DC.B      'Inc.'

                      P_mRgnBlt:
76E0   4E56 FF32                 Link      A6, $-CE
76E4   48E7 FF7C                 MoveM.L   D0-D7/A1-A5, -(A7)
76E8   2D4F FF74                 Move.L    A7, $-8C(A6)
76EC   2D4D FF34                 Move.L    A5, $-CC(A6)
76F0   3F2E 0018                 Move      $18(A6), -(A7)
76F4   2F2E 0014                 Move.L    $14(A6), -(A7)
76F8   4EBA DECC                 Jsr       P_mColorMap
76FC   2D5F 0014                 Move.L    (A7)+, $14(A6)
7700   3D5F 0018                 Move      (A7)+, $18(A6)
7704   226E 0010                 Move.L    $10(A6), A1
7708   2251                      Move.L    (A1), A1
770A   246E 000C                 Move.L    $C(A6), A2
770E   2452                      Move.L    (A2), A2
7710   266E 0008                 Move.L    $8(A6), A3
7714   2653                      Move.L    (A3), A3
7716   286E 001A                 Move.L    $1A(A6), A4
771A   2A6E 0022                 Move.L    $22(A6), A5
771E   2F0C                      Move.L    A4, -(A7)
7720   486D 0006                 Pea.L     $6(A5)
7724   4869 0002                 Pea.L     $2(A1)
7728   486A 0002                 Pea.L     $2(A2)
772C   486B 0002                 Pea.L     $2(A3)
7730   3F3C 0005                 Move      $5, -(A7)
7734   486E FF6C                 Pea.L     $-94(A6)
7738   4EBA FA8E                 Jsr       P_mRSect
773C   6700 02FE                 BEQ       L1237
7740   486E FF6C                 Pea.L     $-94(A6)
7744   2F2D 0006                 Move.L    $6(A5), -(A7)
7748   2A6E FF34                 Move.L    $-CC(A6), A5
774C   4EBA DC20                 Jsr       P_tShieldCursor
7750   2A6E 0022                 Move.L    $22(A6), A5
7754   303C 001E                 Move      $1E, D0
7758   9051                      Sub       (A1), D0
775A   9052                      Sub       (A2), D0
775C   9053                      Sub       (A3), D0
775E   6642                      BNE       L1218
7760   246E 001E                 Move.L    $1E(A6), A2
7764   41EE FF38                 Lea.L     $-C8(A6), A0
7768   302E FF6C                 Move      $-94(A6), D0
776C   9054                      Sub       (A4), D0
776E   D052                      Add       (A2), D0
7770   3080                      Move      D0, (A0)
7772   302E FF6E                 Move      $-92(A6), D0
7776   906C 0002                 Sub       $2(A4), D0
777A   D06A 0002                 Add       $2(A2), D0
777E   3140 0002                 Move      D0, $2(A0)
7782   2F2E 0026                 Move.L    $26(A6), -(A7)
7786   2F0D                      Move.L    A5, -(A7)
7788   2F08                      Move.L    A0, -(A7)
778A   486E FF6C                 Pea.L     $-94(A6)
778E   3F2E 0018                 Move      $18(A6), -(A7)
7792   2F2E 0014                 Move.L    $14(A6), -(A7)
7796   2A6E FF34                 Move.L    $-CC(A6), A5
779A   4EBA FBA6                 Jsr       P_mBitBlt
779E   6000 0294                 Bra       L1236
77A2   322E FF6E      L1218:     Move      $-92(A6), D1
77A6   926D 0008                 Sub       $8(A5), D1
77AA   0241 FFF0                 And       $-10, D1
77AE   D26D 0008                 Add       $8(A5), D1
77B2   3D41 FF60                 Move      D1, $-A0(A6)
77B6   302E FF72                 Move      $-8E(A6), D0
77BA   9041                      Sub       D1, D0
77BC   EA48                      LsR       $5, D0
77BE   3D40 FF5E                 Move      D0, $-A2(A6)
77C2   42A7           L1219:     Clr.L     -(A7)
77C4   51C8 FFFC                 DBF       D0, L1219
77C8   2D4F FF66                 Move.L    A7, $-9A(A6)
77CC   3D7C 8001 FFB6            Move      $-7FFF, $-4A(A6)
77D2   3D7C 8001 FF9E            Move      $-7FFF, $-62(A6)
77D8   3D7C 8001 FF86            Move      $-7FFF, $-7A(A6)
77DE   3D7C 7FFF FFB8            Move      $7FFF, $-48(A6)
77E4   3D7C 7FFF FFA0            Move      $7FFF, $-60(A6)
77EA   3D7C 7FFF FF88            Move      $7FFF, $-78(A6)
77F0   426E FF6A                 Clr       $-96(A6)
77F4   0C51 000A                 Cmp       $A, (A1)
77F8   671A                      BEQ       L1220
77FA   546E FF6A                 AddQ      $2, $-96(A6)
77FE   2049                      Move.L    A1, A0
7800   43EE FFA8                 Lea.L     $-58(A6), A1
7804   302E FF6E                 Move      $-92(A6), D0
7808   322E FF72                 Move      $-8E(A6), D1
780C   342E FF60                 Move      $-A0(A6), D2
7810   4EBA 1C38                 Jsr       P_mInitRgn
7814   0C52 000A      L1220:     Cmp       $A, (A2)
7818   671A                      BEQ       L1221
781A   586E FF6A                 AddQ      $4, $-96(A6)
781E   204A                      Move.L    A2, A0
7820   43EE FF90                 Lea.L     $-70(A6), A1
7824   302E FF6E                 Move      $-92(A6), D0
7828   322E FF72                 Move      $-8E(A6), D1
782C   342E FF60                 Move      $-A0(A6), D2
7830   4EBA 1C18                 Jsr       P_mInitRgn
7834   0C53 000A      L1221:     Cmp       $A, (A3)
7838   671A                      BEQ       L1222
783A   506E FF6A                 AddQ      $8, $-96(A6)
783E   204B                      Move.L    A3, A0
7840   43EE FF78                 Lea.L     $-88(A6), A1
7844   302E FF6E                 Move      $-92(A6), D0
7848   322E FF72                 Move      $-8E(A6), D1
784C   342E FF60                 Move      $-A0(A6), D2
7850   4EBA 1BF8                 Jsr       P_mInitRgn
7854   0C6E 0002 FF6A L1222:     Cmp       $2, $-96(A6)
785A   6608                      BNE       L1223
785C   2D6E FF66 FFB0            Move.L    $-9A(A6), $-50(A6)
7862   601E                      Bra       L1225
7864   0C6E 0004 FF6A L1223:     Cmp       $4, $-96(A6)
786A   6608                      BNE       L1224
786C   2D6E FF66 FF98            Move.L    $-9A(A6), $-68(A6)
7872   600E                      Bra       L1225
7874   0C6E 0008 FF6A L1224:     Cmp       $8, $-96(A6)
787A   6606                      BNE       L1225
787C   2D6E FF66 FF80            Move.L    $-9A(A6), $-80(A6)
7882   3D6E FF6C FF54 L1225:     Move      $-94(A6), $-AC(A6)
7888   3D6E FF70 FF52            Move      $-90(A6), $-AE(A6)
788E   3D7C 0001 FF50            Move      $1, $-B0(A6)
7894   3D7C 0004 FF4E            Move      $4, $-B2(A6)
789A   302D 0004                 Move      $4(A5), D0
789E   48C0                      Ext.L     D0
78A0   2D40 FF46                 Move.L    D0, $-BA(A6)
78A4   2D6E FF66 FF62            Move.L    $-9A(A6), $-9E(A6)
78AA   4287                      Clr.L     D7
78AC   342E 0018                 Move      $18(A6), D2
78B0   6B00 0182                 BMI       L1236
78B4   0882 0002                 BClr.B    $2, D2
78B8   6702                      BEQ       L1226
78BA   4687                      Not.L     D7
78BC   0242 000F      L1226:     And       $F, D2
78C0   7003                      MoveQ.L   $3, D0
78C2   C042                      And       D2, D0
78C4   D440                      Add       D0, D2
78C6   41FA 02C6                 Lea.L     DT42, A0
78CA   D0F0 2000                 AddA      $0(A0,D2.W), A0
78CE   2D48 FF40                 Move.L    A0, $-C0(A6)
78D2   0802 0003                 BTst.B    $3, D2
78D6   6728                      BEQ       L1227
78D8   342D 0008                 Move      $8(A5), D2
78DC   206E 0014                 Move.L    $14(A6), A0
78E0   43EE FFC0                 Lea.L     $-40(A6), A1
78E4   2A6E FF34                 Move.L    $-CC(A6), A5
78E8   4EBA DC0E                 Jsr       P_mPatExpand
78EC   2A6E 0022                 Move.L    $22(A6), A5
78F0   7E0F                      MoveQ.L   $F, D7
78F2   CE6E FF6C                 And       $-94(A6), D7
78F6   E54F                      LsL       $2, D7
78F8   2C36 70C0                 Move.L    $-40(A6,D7.W), D6
78FC   6000 00AC                 Bra       L1230
7900   246E 001E      L1227:     Move.L    $1E(A6), A2
7904   266E 0026                 Move.L    $26(A6), A3
7908   302B 0004                 Move      $4(A3), D0
790C   48C0                      Ext.L     D0
790E   2D40 FF4A                 Move.L    D0, $-B6(A6)
7912   2013                      Move.L    (A3), D0
7914   B095                      Cmp.L     (A5), D0
7916   664C                      BNE       L1229
7918   3014                      Move      (A4), D0
791A   906D 0006                 Sub       $6(A5), D0
791E   3212                      Move      (A2), D1
7920   926D 0006                 Sub       $6(A5), D1
7924   9041                      Sub       D1, D0
7926   6D3C                      BLT       L1229
7928   6E1A                      BGT       L1228
792A   302C 0002                 Move      $2(A4), D0
792E   906D 0008                 Sub       $8(A5), D0
7932   322A 0002                 Move      $2(A2), D1
7936   926B 0008                 Sub       $8(A3), D1
793A   9041                      Sub       D1, D0
793C   6F26                      BLE       L1229
793E   446E FF4E                 Neg       $-B2(A6)
7942   6020                      Bra       L1229
7944   446E FF50      L1228:     Neg       $-B0(A6)
7948   44AE FF4A                 Neg.L     $-B6(A6)
794C   44AE FF46                 Neg.L     $-BA(A6)
7950   3D6E FF70 FF54            Move      $-90(A6), $-AC(A6)
7956   536E FF54                 SubQ.L    $1, $-AC(A6)
795A   3D6E FF6C FF52            Move      $-94(A6), $-AE(A6)
7960   536E FF52                 SubQ.L    $1, $-AE(A6)
7964   3C2C 0002      L1229:     Move      $2(A4), D6
7968   9C6D 0008                 Sub       $8(A5), D6
796C   322A 0002                 Move      $2(A2), D1
7970   926B 0008                 Sub       $8(A3), D1
7974   9C41                      Sub       D1, D6
7976   0246 000F                 And       $F, D6
797A   302E FF54                 Move      $-AC(A6), D0
797E   9054                      Sub       (A4), D0
7980   D052                      Add       (A2), D0
7982   906B 0006                 Sub       $6(A3), D0
7986   C0EB 0004                 MulU      $4(A3), D0
798A   2053                      Move.L    (A3), A0
798C   D1C0                      AddA.L    D0, A0
798E   302E FF6E                 Move      $-92(A6), D0
7992   906C 0002                 Sub       $2(A4), D0
7996   D06A 0002                 Add       $2(A2), D0
799A   906B 0008                 Sub       $8(A3), D0
799E   D046                      Add       D6, D0
79A0   E848                      LsR       $4, D0
79A2   D040                      Add       D0, D0
79A4   D0C0                      AddA      D0, A0
79A6   2D48 FF56                 Move.L    A0, $-AA(A6)
79AA   302E FF54      L1230:     Move      $-AC(A6), D0
79AE   906D 0006                 Sub       $6(A5), D0
79B2   C0ED 0004                 MulU      $4(A5), D0
79B6   2055                      Move.L    (A5), A0
79B8   D1C0                      AddA.L    D0, A0
79BA   302E FF6E                 Move      $-92(A6), D0
79BE   906D 0008                 Sub       $8(A5), D0
79C2   E848                      LsR       $4, D0
79C4   D040                      Add       D0, D0
79C6   D0C0                      AddA      D0, A0
79C8   2D48 FF5A                 Move.L    A0, $-A6(A6)
79CC   4A6E FF4E                 Tst       $-B2(A6)
79D0   6A14                      BPL       L1231
79D2   302E FF5E                 Move      $-A2(A6), D0
79D6   E540                      AsL       $2, D0
79D8   48C0                      Ext.L     D0
79DA   D1AE FF5A                 Add.L     D0, $-A6(A6)
79DE   D1AE FF56                 Add.L     D0, $-AA(A6)
79E2   D1AE FF62                 Add.L     D0, $-9E(A6)
79E6   3D6E FF54 FF44 L1231:     Move      $-AC(A6), $-BC(A6)
79EC   4EBA 0060      L1232:     Jsr       P223
79F0   266E FF56                 Move.L    $-AA(A6), A3
79F4   2A6E FF5A                 Move.L    $-A6(A6), A5
79F8   286E FF62                 Move.L    $-9E(A6), A4
79FC   342E FF5E                 Move      $-A2(A6), D2
7A00   246E FF40                 Move.L    $-C0(A6), A2
7A04   4ED2                      Jmp       (A2)
7A06   202E FF4A      L1233:     Move.L    $-B6(A6), D0
7A0A   D1AE FF56                 Add.L     D0, $-AA(A6)
7A0E   600A                      Bra       L1235
7A10   5847           L1234:     AddQ      $4, D7
7A12   0247 003F                 And       $3F, D7
7A16   2C36 70C0                 Move.L    $-40(A6,D7.W), D6
7A1A   202E FF46      L1235:     Move.L    $-BA(A6), D0
7A1E   D1AE FF5A                 Add.L     D0, $-A6(A6)
7A22   302E FF44                 Move      $-BC(A6), D0
7A26   D06E FF50                 Add       $-B0(A6), D0
7A2A   3D40 FF44                 Move      D0, $-BC(A6)
7A2E   B06E FF52                 Cmp       $-AE(A6), D0
7A32   66B8                      BNE       L1232
7A34   2A6E FF34      L1236:     Move.L    $-CC(A6), A5
7A38   4EBA D930                 Jsr       P_tShowCursor
7A3C   2E6E FF74      L1237:     Move.L    $-8C(A6), A7
7A40   4CDF 3EFF                 MoveM.L   (A7)+, D0-D7/A1-A5
7A44   4E5E                      Unlk      A6
7A46   205F                      Move.L    (A7)+, A0
7A48   DEFC 0022                 AddA      $22, A7
7A4C   4ED0                      Jmp       (A0)

                      P223:
7A4E   302E FF6A                 Move      $-96(A6), D0
7A52   303B 0006                 Move      DT41(D0.W), D0
7A56   4EFB 0002                 Jmp       DT41(D0.W)

                      DT41:
7A5A   FFE2 0010 001E            DC.B      '      '
7A60   003A 002C 0074            DC.B      ' : , t'
7A66   00AE 00E8                 DC.B      '    '

                      E_319:
7A6A   302E FF44                 Move      $-BC(A6), D0
7A6E   43EE FFA8                 Lea.L     $-58(A6), A1
7A72   4EBA 1A0E                 Jsr       P_mSeekRgn
7A76   4E75                      Rts

                      E_320:
7A78   302E FF44                 Move      $-BC(A6), D0
7A7C   43EE FF90                 Lea.L     $-70(A6), A1
7A80   4EBA 1A00                 Jsr       P_mSeekRgn
7A84   4E75                      Rts

                      E_321:
7A86   302E FF44                 Move      $-BC(A6), D0
7A8A   43EE FF78                 Lea.L     $-88(A6), A1
7A8E   4EBA 19F2                 Jsr       P_mSeekRgn
7A92   4E75                      Rts

                      E_322:
7A94   302E FF44                 Move      $-BC(A6), D0
7A98   43EE FFA8                 Lea.L     $-58(A6), A1
7A9C   4EBA 19E4                 Jsr       P_mSeekRgn
7AA0   3D41 FF32                 Move      D1, $-CE(A6)
7AA4   43EE FF90                 Lea.L     $-70(A6), A1
7AA8   4EBA 19D8                 Jsr       P_mSeekRgn
7AAC   836E FF32                 Or        D1, $-CE(A6)
7AB0   671A                      BEQ       L1239
7AB2   206E FFB0                 Move.L    $-50(A6), A0
7AB6   226E FF98                 Move.L    $-68(A6), A1
7ABA   246E FF66                 Move.L    $-9A(A6), A2
7ABE   322E FF5E                 Move      $-A2(A6), D1
7AC2   2018           L1238:     Move.L    (A0)+, D0
7AC4   C099                      And.L     (A1)+, D0
7AC6   24C0                      Move.L    D0, (A2)+
7AC8   51C9 FFF8                 DBF       D1, L1238
7ACC   4E75           L1239:     Rts

                      E_323:
7ACE   302E FF44                 Move      $-BC(A6), D0
7AD2   43EE FFA8                 Lea.L     $-58(A6), A1
7AD6   4EBA 19AA                 Jsr       P_mSeekRgn
7ADA   3D41 FF32                 Move      D1, $-CE(A6)
7ADE   43EE FF78                 Lea.L     $-88(A6), A1
7AE2   4EBA 199E                 Jsr       P_mSeekRgn
7AE6   836E FF32                 Or        D1, $-CE(A6)
7AEA   671A                      BEQ       L1241
7AEC   206E FFB0                 Move.L    $-50(A6), A0
7AF0   226E FF80                 Move.L    $-80(A6), A1
7AF4   246E FF66                 Move.L    $-9A(A6), A2
7AF8   322E FF5E                 Move      $-A2(A6), D1
7AFC   2018           L1240:     Move.L    (A0)+, D0
7AFE   C099                      And.L     (A1)+, D0
7B00   24C0                      Move.L    D0, (A2)+
7B02   51C9 FFF8                 DBF       D1, L1240
7B06   4E75           L1241:     Rts

                      E_324:
7B08   302E FF44                 Move      $-BC(A6), D0
7B0C   43EE FF90                 Lea.L     $-70(A6), A1
7B10   4EBA 1970                 Jsr       P_mSeekRgn
7B14   3D41 FF32                 Move      D1, $-CE(A6)
7B18   43EE FF78                 Lea.L     $-88(A6), A1
7B1C   4EBA 1964                 Jsr       P_mSeekRgn
7B20   836E FF32                 Or        D1, $-CE(A6)
7B24   671A                      BEQ       L1243
7B26   206E FF98                 Move.L    $-68(A6), A0
7B2A   226E FF80                 Move.L    $-80(A6), A1
7B2E   246E FF66                 Move.L    $-9A(A6), A2
7B32   322E FF5E                 Move      $-A2(A6), D1
7B36   2018           L1242:     Move.L    (A0)+, D0
7B38   C099                      And.L     (A1)+, D0
7B3A   24C0                      Move.L    D0, (A2)+
7B3C   51C9 FFF8                 DBF       D1, L1242
7B40   4E75           L1243:     Rts

                      E_325:
7B42   302E FF44                 Move      $-BC(A6), D0
7B46   43EE FFA8                 Lea.L     $-58(A6), A1
7B4A   4EBA 1936                 Jsr       P_mSeekRgn
7B4E   3D41 FF32                 Move      D1, $-CE(A6)
7B52   43EE FF90                 Lea.L     $-70(A6), A1
7B56   4EBA 192A                 Jsr       P_mSeekRgn
7B5A   836E FF32                 Or        D1, $-CE(A6)
7B5E   43EE FF78                 Lea.L     $-88(A6), A1
7B62   4EBA 191E                 Jsr       P_mSeekRgn
7B66   836E FF32                 Or        D1, $-CE(A6)
7B6A   6720                      BEQ       L1245
7B6C   206E FFB0                 Move.L    $-50(A6), A0
7B70   226E FF98                 Move.L    $-68(A6), A1
7B74   246E FF80                 Move.L    $-80(A6), A2
7B78   266E FF66                 Move.L    $-9A(A6), A3
7B7C   322E FF5E                 Move      $-A2(A6), D1
7B80   2018           L1244:     Move.L    (A0)+, D0
7B82   C099                      And.L     (A1)+, D0
7B84   C09A                      And.L     (A2)+, D0
7B86   26C0                      Move.L    D0, (A3)+
7B88   51C9 FFF6                 DBF       D1, L1244
7B8C   4E75           L1245:     Rts

                      DT42:
7B8E   0010 0040 0068            DC.B      '   @ h'
7B94   0090 00BA 00D0            DC.B      '      '
7B9A   00DE 00EC                 DC.B      '    '

                      E_326:
7B9E   202B FFFE                 Move.L    $-2(A3), D0
7BA2   ECA8                      LsR.L     D6, D0
7BA4   4840                      Swap      D0
7BA6   2213                      Move.L    (A3), D1
7BA8   D6EE FF4E                 AddA      $-B2(A6), A3
7BAC   ECA9                      LsR.L     D6, D1
7BAE   3001                      Move      D1, D0
7BB0   BF80                      Eor.L     D7, D0
7BB2   2214                      Move.L    (A4), D1
7BB4   D8EE FF4E                 AddA      $-B2(A6), A4
7BB8   C081                      And.L     D1, D0
7BBA   4681                      Not.L     D1
7BBC   C295                      And.L     (A5), D1
7BBE   8081                      Or.L      D1, D0
7BC0   2A80                      Move.L    D0, (A5)
7BC2   DAEE FF4E                 AddA      $-B2(A6), A5
7BC6   51CA FFD6                 DBF       D2, E_326
7BCA   6000 FE3A                 Bra       L1233

                      E_327:
7BCE   202B FFFE                 Move.L    $-2(A3), D0
7BD2   ECA8                      LsR.L     D6, D0
7BD4   4840                      Swap      D0
7BD6   2213                      Move.L    (A3), D1
7BD8   D6EE FF4E                 AddA      $-B2(A6), A3
7BDC   ECA9                      LsR.L     D6, D1
7BDE   3001                      Move      D1, D0
7BE0   BF80                      Eor.L     D7, D0
7BE2   C094                      And.L     (A4), D0
7BE4   D8EE FF4E                 AddA      $-B2(A6), A4
7BE8   8195                      Or.L      D0, (A5)
7BEA   DAEE FF4E                 AddA      $-B2(A6), A5
7BEE   51CA FFDE                 DBF       D2, E_327
7BF2   6000 FE12                 Bra       L1233

                      E_328:
7BF6   202B FFFE                 Move.L    $-2(A3), D0
7BFA   ECA8                      LsR.L     D6, D0
7BFC   4840                      Swap      D0
7BFE   2213                      Move.L    (A3), D1
7C00   D6EE FF4E                 AddA      $-B2(A6), A3
7C04   ECA9                      LsR.L     D6, D1
7C06   3001                      Move      D1, D0
7C08   BF80                      Eor.L     D7, D0
7C0A   C094                      And.L     (A4), D0
7C0C   D8EE FF4E                 AddA      $-B2(A6), A4
7C10   B195                      Eor.L     D0, (A5)
7C12   DAEE FF4E                 AddA      $-B2(A6), A5
7C16   51CA FFDE                 DBF       D2, E_328
7C1A   6000 FDEA                 Bra       L1233

                      E_329:
7C1E   202B FFFE                 Move.L    $-2(A3), D0
7C22   ECA8                      LsR.L     D6, D0
7C24   4840                      Swap      D0
7C26   2213                      Move.L    (A3), D1
7C28   D6EE FF4E                 AddA      $-B2(A6), A3
7C2C   ECA9                      LsR.L     D6, D1
7C2E   3001                      Move      D1, D0
7C30   BF80                      Eor.L     D7, D0
7C32   C094                      And.L     (A4), D0
7C34   D8EE FF4E                 AddA      $-B2(A6), A4
7C38   4680                      Not.L     D0
7C3A   C195                      And.L     D0, (A5)
7C3C   DAEE FF4E                 AddA      $-B2(A6), A5
7C40   51CA FFDC                 DBF       D2, E_329
7C44   6000 FDC0                 Bra       L1233

                      E_330:
7C48   2006                      Move.L    D6, D0
7C4A   221C                      Move.L    (A4)+, D1
7C4C   C081                      And.L     D1, D0
7C4E   4681                      Not.L     D1
7C50   C295                      And.L     (A5), D1
7C52   8081                      Or.L      D1, D0
7C54   2AC0                      Move.L    D0, (A5)+
7C56   51CA FFF0                 DBF       D2, E_330
7C5A   6000 FDB4                 Bra       L1234

                      E_331:
7C5E   2006                      Move.L    D6, D0
7C60   C09C                      And.L     (A4)+, D0
7C62   819D                      Or.L      D0, (A5)+
7C64   51CA FFF8                 DBF       D2, E_331
7C68   6000 FDA6                 Bra       L1234

                      E_332:
7C6C   2006                      Move.L    D6, D0
7C6E   C09C                      And.L     (A4)+, D0
7C70   B19D                      Eor.L     D0, (A5)+
7C72   51CA FFF8                 DBF       D2, E_332
7C76   6000 FD98                 Bra       L1234

                      E_333:
7C7A   2006                      Move.L    D6, D0
7C7C   C09C                      And.L     (A4)+, D0
7C7E   4680                      Not.L     D0
7C80   C19D                      And.L     D0, (A5)+
7C82   51CA FFF6                 DBF       D2, E_333
7C86   6000 FD88                 Bra       L1234

                      P_tStdRRect:
7C8A   4E56 0000                 Link      A6, $0
7C8E   48E7 0118                 MoveM.L   D7/A3-A4, -(A7)
7C92   1E2E 0010                 Move.B    $10(A6), D7
7C96   4EBA 33CA                 Jsr       P_mCheckPic
7C9A   6F00 0038                 BLE       L1247
7C9E   1F07                      Move.B    D7, -(A7)
7CA0   4EBA 32B8                 Jsr       P_mPutPicVerb
7CA4   206B 005C                 Move.L    $5C(A3), A0
7CA8   2050                      Move.L    (A0), A0
7CAA   202E 0008                 Move.L    $8(A6), D0
7CAE   B0A8 004C                 Cmp.L     $4C(A0), D0
7CB2   6712                      BEQ       L1246
7CB4   2140 004C                 Move.L    D0, $4C(A0)
7CB8   2F00                      Move.L    D0, -(A7)
7CBA   1F3C 000B                 Move.B    $B, -(A7)
7CBE   4EBA 31F0                 Jsr       P_mPutPicByte
7CC2   4EBA 3210                 Jsr       P_mPutPicLong
7CC6   7040           L1246:     MoveQ.L   $40, D0
7CC8   D047                      Add       D7, D0
7CCA   1F00                      Move.B    D0, -(A7)
7CCC   2F2E 000C                 Move.L    $C(A6), -(A7)
7CD0   4EBA 321E                 Jsr       P_mPutPicRect
7CD4   2F2E 000C      L1247:     Move.L    $C(A6), -(A7)
7CD8   4A07                      Tst.B     D7
7CDA   6624                      BNE       L1249
7CDC   4AAB 0060                 Tst.L     $60(A3)
7CE0   6718                      BEQ       L1248
7CE2   2F2E 000C                 Move.L    $C(A6), -(A7)
7CE6   2F2E 0008                 Move.L    $8(A6), -(A7)
7CEA   2F2C FF6C                 Move.L    $-94(A4), -(A7)
7CEE   486C FF6A                 Pea.L     $-96(A4)
7CF2   486C FF68                 Pea.L     $-98(A4)
7CF6   4EBA 0158                 Jsr       P_mPutOval
7CFA   1F3C 0001      L1248:     Move.B    $1, -(A7)
7CFE   6002                      Bra       L1250
7D00   4227           L1249:     Clr.B     -(A7)
7D02   2F2E 0008      L1250:     Move.L    $8(A6), -(A7)
7D06   4EBA F278                 Jsr       P_mPushVerb
7D0A   4267                      Clr       -(A7)
7D0C   3F3C 0168                 Move      $168, -(A7)
7D10   4EBA 034A                 Jsr       P_mDrawArc
7D14   4CDF 1880                 MoveM.L   (A7)+, D7/A3-A4
7D18   4E5E                      Unlk      A6
7D1A   205F                      Move.L    (A7)+, A0
7D1C   DEFC 000A                 AddA      $A, A7
7D20   4ED0                      Jmp       (A0)
                      P_mCallRRect:
7D22   205F                      Move.L    (A7)+, A0
7D24   221F                      Move.L    (A7)+, D1
7D26   225F                      Move.L    (A7)+, A1
7D28   1F00                      Move.B    D0, -(A7)
7D2A   2F09                      Move.L    A1, -(A7)
7D2C   2F01                      Move.L    D1, -(A7)
7D2E   2F08                      Move.L    A0, -(A7)
7D30   2055                      Move.L    (A5), A0
7D32   2050                      Move.L    (A0), A0
7D34   2028 0068                 Move.L    $68(A0), D0
7D38   41FA FF50                 Lea.L     P_tStdRRect, A0
7D3C   6706                      BEQ       L1252
7D3E   2040                      Move.L    D0, A0
7D40   2068 000C                 Move.L    $C(A0), A0
7D44   4ED0           L1252:     Jmp       (A0)

                      P_tFrameRoundRect:
7D46   7000                      MoveQ.L   $0, D0
7D48   4EFA FFD8                 Jmp       P_mCallRRect

                      P_tPaintRoundRect:
7D4C   7001                      MoveQ.L   $1, D0
7D4E   4EFA FFD2                 Jmp       P_mCallRRect

                      P_tEraseRoundRect:
7D52   7002                      MoveQ.L   $2, D0
7D54   4EFA FFCC                 Jmp       P_mCallRRect

                      P_tInverRoundRect:
7D58   7003                      MoveQ.L   $3, D0
7D5A   4EFA FFC6                 Jmp       P_mCallRRect

                      P_tFillRoundRect:
7D5E   205F                      Move.L    (A7)+, A0
7D60   225F                      Move.L    (A7)+, A1
7D62   2F08                      Move.L    A0, -(A7)
7D64   2055                      Move.L    (A5), A0
7D66   2050                      Move.L    (A0), A0
7D68   41E8 0028                 Lea.L     $28(A0), A0
7D6C   20D9                      Move.L    (A1)+, (A0)+
7D6E   20D9                      Move.L    (A1)+, (A0)+
7D70   7004                      MoveQ.L   $4, D0
7D72   4EFA FFAE                 Jmp       P_mCallRRect

                      P_tStdOval:
7D76   4E56 FFFC                 Link      A6, $-4
7D7A   48E7 0118                 MoveM.L   D7/A3-A4, -(A7)
7D7E   1E2E 000C                 Move.B    $C(A6), D7
7D82   4EBA 32DE                 Jsr       P_mCheckPic
7D86   6F00 0016                 BLE       L1253
7D8A   1F07                      Move.B    D7, -(A7)
7D8C   4EBA 31CC                 Jsr       P_mPutPicVerb
7D90   7050                      MoveQ.L   $50, D0
7D92   D047                      Add       D7, D0
7D94   1F00                      Move.B    D0, -(A7)
7D96   2F2E 0008                 Move.L    $8(A6), -(A7)
7D9A   4EBA 3154                 Jsr       P_mPutPicRect
7D9E   206E 0008      L1253:     Move.L    $8(A6), A0
7DA2   3028 0006                 Move      $6(A0), D0
7DA6   9068 0002                 Sub       $2(A0), D0
7DAA   3D40 FFFE                 Move      D0, $-2(A6)
7DAE   3028 0004                 Move      $4(A0), D0
7DB2   9050                      Sub       (A0), D0
7DB4   3D40 FFFC                 Move      D0, $-4(A6)
7DB8   2F08                      Move.L    A0, -(A7)
7DBA   4A07                      Tst.B     D7
7DBC   6622                      BNE       L1255
7DBE   4AAB 0060                 Tst.L     $60(A3)
7DC2   6716                      BEQ       L1254
7DC4   2F08                      Move.L    A0, -(A7)
7DC6   2F2E FFFC                 Move.L    $-4(A6), -(A7)
7DCA   2F2C FF6C                 Move.L    $-94(A4), -(A7)
7DCE   486C FF6A                 Pea.L     $-96(A4)
7DD2   486C FF68                 Pea.L     $-98(A4)
7DD6   4EBA 0078                 Jsr       P_mPutOval
7DDA   1F3C 0001      L1254:     Move.B    $1, -(A7)
7DDE   6002                      Bra       L1256
7DE0   4227           L1255:     Clr.B     -(A7)
7DE2   2F2E FFFC      L1256:     Move.L    $-4(A6), -(A7)
7DE6   4EBA F198                 Jsr       P_mPushVerb
7DEA   4267                      Clr       -(A7)
7DEC   3F3C 0168                 Move      $168, -(A7)
7DF0   4EBA 026A                 Jsr       P_mDrawArc
7DF4   4CDF 1880                 MoveM.L   (A7)+, D7/A3-A4
7DF8   4E5E                      Unlk      A6
7DFA   205F                      Move.L    (A7)+, A0
7DFC   5C4F                      AddQ      $6, A7
7DFE   4ED0                      Jmp       (A0)
                      P_mCallOval:
7E00   205F                      Move.L    (A7)+, A0
7E02   225F                      Move.L    (A7)+, A1
7E04   1F00                      Move.B    D0, -(A7)
7E06   2F09                      Move.L    A1, -(A7)
7E08   2F08                      Move.L    A0, -(A7)
7E0A   2055                      Move.L    (A5), A0
7E0C   2050                      Move.L    (A0), A0
7E0E   2028 0068                 Move.L    $68(A0), D0
7E12   41FA FF62                 Lea.L     P_tStdOval, A0
7E16   6706                      BEQ       L1258
7E18   2040                      Move.L    D0, A0
7E1A   2068 0010                 Move.L    $10(A0), A0
7E1E   4ED0           L1258:     Jmp       (A0)

                      P_tFrameOval:
7E20   7000                      MoveQ.L   $0, D0
7E22   4EFA FFDC                 Jmp       P_mCallOval

                      P_tPaintOval:
7E26   7001                      MoveQ.L   $1, D0
7E28   4EFA FFD6                 Jmp       P_mCallOval

                      P_tEraseOval:
7E2C   7002                      MoveQ.L   $2, D0
7E2E   4EFA FFD0                 Jmp       P_mCallOval

                      P_tInvertOval:
7E32   7003                      MoveQ.L   $3, D0
7E34   4EFA FFCA                 Jmp       P_mCallOval

                      P_tFillOval:
7E38   205F                      Move.L    (A7)+, A0
7E3A   225F                      Move.L    (A7)+, A1
7E3C   2F08                      Move.L    A0, -(A7)
7E3E   2055                      Move.L    (A5), A0
7E40   2050                      Move.L    (A0), A0
7E42   41E8 0028                 Lea.L     $28(A0), A0
7E46   20D9                      Move.L    (A1)+, (A0)+
7E48   20D9                      Move.L    (A1)+, (A0)+
7E4A   7004                      MoveQ.L   $4, D0
7E4C   4EFA FFB2                 Jmp       P_mCallOval

                      P_mPutOval:
7E50   4E56 FFCE                 Link      A6, $-32
7E54   48E7 FF7C                 MoveM.L   D0-D7/A1-A5, -(A7)
7E58   266E 0010                 Move.L    $10(A6), A3
7E5C   2653                      Move.L    (A3), A3
7E5E   244B                      Move.L    A3, A2
7E60   206E 000C                 Move.L    $C(A6), A0
7E64   D6D0                      AddA      (A0), A3
7E66   224A                      Move.L    A2, A1
7E68   206E 0008                 Move.L    $8(A6), A0
7E6C   D2D0                      AddA      (A0), A1
7E6E   2F2E 0018                 Move.L    $18(A6), -(A7)
7E72   486E FFD6                 Pea.L     $-2A(A6)
7E76   3F2E 0016                 Move      $16(A6), -(A7)
7E7A   3F2E 0014                 Move      $14(A6), -(A7)
7E7E   4EBA 084A                 Jsr       P_mInitOval
7E82   3D6E FFDC FFD0            Move      $-24(A6), $-30(A6)
7E88   3D6E FFE0 FFCE            Move      $-20(A6), $-32(A6)
7E8E   302E 0014                 Move      $14(A6), D0
7E92   E240                      AsR       $1, D0
7E94   D06E FFD6                 Add       $-2A(A6), D0
7E98   3D40 FFD4                 Move      D0, $-2C(A6)
7E9C   206E 0018                 Move.L    $18(A6), A0
7EA0   D068 0004                 Add       $4(A0), D0
7EA4   9050                      Sub       (A0), D0
7EA6   906E 0014                 Sub       $14(A6), D0
7EAA   3D40 FFD2                 Move      D0, $-2E(A6)
7EAE   3C2E FFD6                 Move      $-2A(A6), D6
7EB2   3A2E FFD0                 Move      $-30(A6), D5
7EB6   4EBA 0086                 Jsr       P225
7EBA   3A2E FFCE                 Move      $-32(A6), D5
7EBE   4EBA 007E                 Jsr       P225
7EC2   BC6E FFD4      L1259:     Cmp       $-2C(A6), D6
7EC6   6D06                      BLT       L1260
7EC8   BC6E FFD2                 Cmp       $-2E(A6), D6
7ECC   6D42                      BLT       L1262
7ECE   486E FFD6      L1260:     Pea.L     $-2A(A6)
7ED2   3F06                      Move      D6, -(A7)
7ED4   4EBA 08B4                 Jsr       P_mBumpOval
7ED8   3A2E FFDC                 Move      $-24(A6), D5
7EDC   BA6E FFD0                 Cmp       $-30(A6), D5
7EE0   6712                      BEQ       L1261
7EE2   4EBA 005A                 Jsr       P225
7EE6   3A2E FFD0                 Move      $-30(A6), D5
7EEA   4EBA 0052                 Jsr       P225
7EEE   3D6E FFDC FFD0            Move      $-24(A6), $-30(A6)
7EF4   3A2E FFE0      L1261:     Move      $-20(A6), D5
7EF8   BA6E FFCE                 Cmp       $-32(A6), D5
7EFC   6712                      BEQ       L1262
7EFE   4EBA 003E                 Jsr       P225
7F02   3A2E FFCE                 Move      $-32(A6), D5
7F06   4EBA 0036                 Jsr       P225
7F0A   3D6E FFE0 FFCE            Move      $-20(A6), $-32(A6)
7F10   5246           L1262:     AddQ      $1, D6
7F12   BC6E FFD8                 Cmp       $-28(A6), D6
7F16   6DAA                      BLT       L1259
7F18   3A2E FFD0                 Move      $-30(A6), D5
7F1C   4EBA 0020                 Jsr       P225
7F20   3A2E FFCE                 Move      $-32(A6), D5
7F24   4EBA 0018                 Jsr       P225
7F28   97CA                      SubA.L    A2, A3
7F2A   206E 000C                 Move.L    $C(A6), A0
7F2E   308B                      Move      A3, (A0)
7F30   4CDF 3EFF                 MoveM.L   (A7)+, D0-D7/A1-A5
7F34   4E5E                      Unlk      A6
7F36   205F                      Move.L    (A7)+, A0
7F38   DEFC 0014                 AddA      $14, A7
7F3C   4ED0                      Jmp       (A0)

                      P225:
7F3E   B7C9                      CmpA.L    A1, A3
7F40   6D2A                      BLT       L1263
7F42   97CA                      SubA.L    A2, A3
7F44   93CA                      SubA.L    A2, A1
7F46   D2FC 0400                 AddA      $400, A1
7F4A   48E7 FFF0                 MoveM.L   D0-D7/A0-A3, -(A7)
7F4E   206E 0008                 Move.L    $8(A6), A0
7F52   3089                      Move      A1, (A0)
7F54   2F2E 0010                 Move.L    $10(A6), -(A7)
7F58   3F09                      Move      A1, -(A7)
7F5A   4EBA 32C0                 Jsr       P_mSetHSize
7F5E   4CDF 0FFF                 MoveM.L   (A7)+, D0-D7/A0-A3
7F62   246E 0010                 Move.L    $10(A6), A2
7F66   2452                      Move.L    (A2), A2
7F68   D7CA                      AddA.L    A2, A3
7F6A   D3CA                      AddA.L    A2, A1
7F6C   B7CA           L1263:     CmpA.L    A2, A3
7F6E   6710                      BEQ       L1264
7F70   BA6B FFFE                 Cmp       $-2(A3), D5
7F74   660A                      BNE       L1264
7F76   BC6B FFFC                 Cmp       $-4(A3), D6
7F7A   6604                      BNE       L1264
7F7C   594B                      SubQ.L    $4, A3
7F7E   4E75                      Rts
7F80   36C6           L1264:     Move      D6, (A3)+
7F82   36C5                      Move      D5, (A3)+
7F84   4E75                      Rts

                      P_tStdArc:
7F86   4E56 FFFC                 Link      A6, $-4
7F8A   48E7 0918                 MoveM.L   D4/D7/A3-A4, -(A7)
7F8E   1E2E 0010                 Move.B    $10(A6), D7
7F92   4EBA 30CE                 Jsr       P_mCheckPic
7F96   6F00 0026                 BLE       L1265
7F9A   1F07                      Move.B    D7, -(A7)
7F9C   4EBA 2FBC                 Jsr       P_mPutPicVerb
7FA0   7060                      MoveQ.L   $60, D0
7FA2   D047                      Add       D7, D0
7FA4   1F00                      Move.B    D0, -(A7)
7FA6   2F2E 000C                 Move.L    $C(A6), -(A7)
7FAA   4EBA 2F44                 Jsr       P_mPutPicRect
7FAE   3F2E 000A                 Move      $A(A6), -(A7)
7FB2   4EBA 2F0E                 Jsr       P_mPutPicWord
7FB6   3F2E 0008                 Move      $8(A6), -(A7)
7FBA   4EBA 2F06                 Jsr       P_mPutPicWord
7FBE   206E 000C      L1265:     Move.L    $C(A6), A0
7FC2   3028 0006                 Move      $6(A0), D0
7FC6   9068 0002                 Sub       $2(A0), D0
7FCA   3D40 FFFE                 Move      D0, $-2(A6)
7FCE   3028 0004                 Move      $4(A0), D0
7FD2   9050                      Sub       (A0), D0
7FD4   3D40 FFFC                 Move      D0, $-4(A6)
7FD8   2F08                      Move.L    A0, -(A7)
7FDA   4A07                      Tst.B     D7
7FDC   6606                      BNE       L1266
7FDE   1F3C 0001                 Move.B    $1, -(A7)
7FE2   6002                      Bra       L1267
7FE4   4227           L1266:     Clr.B     -(A7)
7FE6   2F2E FFFC      L1267:     Move.L    $-4(A6), -(A7)
7FEA   4EBA EF94                 Jsr       P_mPushVerb
7FEE   3F2E 000A                 Move      $A(A6), -(A7)
7FF2   3F2E 0008                 Move      $8(A6), -(A7)
7FF6   4EBA 0064                 Jsr       P_mDrawArc
7FFA   4CDF 1890                 MoveM.L   (A7)+, D4/D7/A3-A4
7FFE   4E5E                      Unlk      A6
8000   205F                      Move.L    (A7)+, A0
8002   DEFC 000A                 AddA      $A, A7
8006   4ED0                      Jmp       (A0)
                      P_mCallArc:
8008   205F                      Move.L    (A7)+, A0
800A   221F                      Move.L    (A7)+, D1
800C   225F                      Move.L    (A7)+, A1
800E   1F00                      Move.B    D0, -(A7)
8010   2F09                      Move.L    A1, -(A7)
8012   2F01                      Move.L    D1, -(A7)
8014   2F08                      Move.L    A0, -(A7)
8016   2055                      Move.L    (A5), A0
8018   2050                      Move.L    (A0), A0
801A   2028 0068                 Move.L    $68(A0), D0
801E   41FA FF66                 Lea.L     P_tStdArc, A0
8022   6706                      BEQ       L1269
8024   2040                      Move.L    D0, A0
8026   2068 0014                 Move.L    $14(A0), A0
802A   4ED0           L1269:     Jmp       (A0)

                      P_tFrameArc:
802C   7000                      MoveQ.L   $0, D0
802E   4EFA FFD8                 Jmp       P_mCallArc

                      P_tPaintArc:
8032   7001                      MoveQ.L   $1, D0
8034   4EFA FFD2                 Jmp       P_mCallArc

                      P_tEraseArc:
8038   7002                      MoveQ.L   $2, D0
803A   4EFA FFCC                 Jmp       P_mCallArc

                      P_tInvertArc:
803E   7003                      MoveQ.L   $3, D0
8040   4EFA FFC6                 Jmp       P_mCallArc

                      P_tFillArc:
8044   205F                      Move.L    (A7)+, A0
8046   225F                      Move.L    (A7)+, A1
8048   2F08                      Move.L    A0, -(A7)
804A   2055                      Move.L    (A5), A0
804C   2050                      Move.L    (A0), A0
804E   41E8 0028                 Lea.L     $28(A0), A0
8052   20D9                      Move.L    (A1)+, (A0)+
8054   20D9                      Move.L    (A1)+, (A0)+
8056   7004                      MoveQ.L   $4, D0
8058   4EFA FFAE                 Jmp       P_mCallArc

                      P_mDrawArc:
805C   4E56 FED2                 Link      A6, $-12E
8060   48E7 FF7C                 MoveM.L   D0-D7/A1-A5, -(A7)
8064   2D4F FFCC                 Move.L    A7, $-34(A6)
8068   2D4D FEFA                 Move.L    A5, $-106(A6)
806C   2055                      Move.L    (A5), A0
806E   2650                      Move.L    (A0), A3
8070   4A6B 0042                 Tst       $42(A3)
8074   6D00 05D4                 BLT       L1307
8078   2D4B FEFE                 Move.L    A3, $-102(A6)
807C   302E 0008                 Move      $8(A6), D0
8080   6700 05C8                 BEQ       L1307
8084   6A00 000C                 BPL       L1270
8088   D16E 000A                 Add       D0, $A(A6)
808C   4440                      Neg       D0
808E   3D40 0008                 Move      D0, $8(A6)
8092   0C40 0168      L1270:     Cmp       $168, D0
8096   5DEE FEF9                 SLT.B     $-107(A6)
809A   70F8                      MoveQ.L   $-8, D0
809C   C06E 0010                 And       $10(A6), D0
80A0   0C40 0008                 Cmp       $8, D0
80A4   6600 05A4                 BNE       L1307
80A8   3F2E 0010                 Move      $10(A6), -(A7)
80AC   2F2E 000C                 Move.L    $C(A6), -(A7)
80B0   4EBA D514                 Jsr       P_mColorMap
80B4   2D5F 000C                 Move.L    (A7)+, $C(A6)
80B8   3D5F 0010                 Move      (A7)+, $10(A6)
80BC   2A6E FEFE                 Move.L    $-102(A6), A5
80C0   246D 001C                 Move.L    $1C(A5), A2
80C4   2452                      Move.L    (A2), A2
80C6   266D 0018                 Move.L    $18(A5), A3
80CA   2653                      Move.L    (A3), A3
80CC   2F2E 0018                 Move.L    $18(A6), -(A7)
80D0   486D 0008                 Pea.L     $8(A5)
80D4   486A 0002                 Pea.L     $2(A2)
80D8   486B 0002                 Pea.L     $2(A3)
80DC   3F3C 0004                 Move      $4, -(A7)
80E0   486E FF84                 Pea.L     $-7C(A6)
80E4   4EBA F0E2                 Jsr       P_mRSect
80E8   6700 0560                 BEQ       L1307
80EC   422E FEF8                 Clr.B     $-108(A6)
80F0   4A2E FEF9                 Tst.B     $-107(A6)
80F4   6700 0144                 BEQ       L1278
80F8   302E 000A                 Move      $A(A6), D0
80FC   48C0                      Ext.L     D0
80FE   81FC 0168                 DivS      $168, D0
8102   4840                      Swap      D0
8104   4A40                      Tst       D0
8106   6A04                      BPL       L1271
8108   0640 0168                 Add       $168, D0
810C   3D40 000A      L1271:     Move      D0, $A(A6)
8110   D06E 0008                 Add       $8(A6), D0
8114   0C40 0168                 Cmp       $168, D0
8118   6D04                      BLT       L1272
811A   0440 0168                 Sub       $168, D0
811E   3D40 FEF6      L1272:     Move      D0, $-10A(A6)
8122   206E 0018                 Move.L    $18(A6), A0
8126   3010                      Move      (A0), D0
8128   D068 0004                 Add       $4(A0), D0
812C   E240                      AsR       $1, D0
812E   3D40 FEF4                 Move      D0, $-10C(A6)
8132   3028 0002                 Move      $2(A0), D0
8136   D068 0006                 Add       $6(A0), D0
813A   E240                      AsR       $1, D0
813C   3D40 FEF2                 Move      D0, $-10E(A6)
8140   3028 0006                 Move      $6(A0), D0
8144   9068 0002                 Sub       $2(A0), D0
8148   3D40 FEF0                 Move      D0, $-110(A6)
814C   3028 0004                 Move      $4(A0), D0
8150   9050                      Sub       (A0), D0
8152   3D40 FEEE                 Move      D0, $-112(A6)
8156   42A7                      Clr.L     -(A7)
8158   3F2E FEF0                 Move      $-110(A6), -(A7)
815C   3F2E FEEE                 Move      $-112(A6), -(A7)
8160   4EBA D69C                 Jsr       P_tFixRatio
8164   2E1F                      Move.L    (A7)+, D7
8166   42A7                      Clr.L     -(A7)
8168   3F2E 000A                 Move      $A(A6), -(A7)
816C   4EBA 06C2                 Jsr       P231
8170   201F                      Move.L    (A7)+, D0
8172   42A7                      Clr.L     -(A7)
8174   2F00                      Move.L    D0, -(A7)
8176   2F07                      Move.L    D7, -(A7)
8178   4EBA D662                 Jsr       P_tFixMul
817C   2D5F FEEA                 Move.L    (A7)+, $-116(A6)
8180   42A7                      Clr.L     -(A7)
8182   3F2E FEF6                 Move      $-10A(A6), -(A7)
8186   4EBA 06A8                 Jsr       P231
818A   201F                      Move.L    (A7)+, D0
818C   42A7                      Clr.L     -(A7)
818E   2F00                      Move.L    D0, -(A7)
8190   2F07                      Move.L    D7, -(A7)
8192   4EBA D648                 Jsr       P_tFixMul
8196   2D5F FEE6                 Move.L    (A7)+, $-11A(A6)
819A   3C2E FEF2                 Move      $-10E(A6), D6
819E   4846                      Swap      D6
81A0   4246                      Clr       D6
81A2   3E2E FEEE                 Move      $-112(A6), D7
81A6   E24F                      LsR       $1, D7
81A8   302E FEEC                 Move      $-114(A6), D0
81AC   C0C7                      MulU      D7, D0
81AE   2D40 FEE2                 Move.L    D0, $-11E(A6)
81B2   302E FEEA                 Move      $-116(A6), D0
81B6   C1C7                      MulW      D7, D0
81B8   D16E FEE2                 Add       D0, $-11E(A6)
81BC   2006                      Move.L    D6, D0
81BE   90AE FEE2                 Sub.L     $-11E(A6), D0
81C2   2D40 FEE2                 Move.L    D0, $-11E(A6)
81C6   302E FEE8                 Move      $-118(A6), D0
81CA   C0C7                      MulU      D7, D0
81CC   2D40 FEDE                 Move.L    D0, $-122(A6)
81D0   302E FEE6                 Move      $-11A(A6), D0
81D4   C1C7                      MulW      D7, D0
81D6   D16E FEDE                 Add       D0, $-122(A6)
81DA   9CAE FEDE                 Sub.L     $-122(A6), D6
81DE   2D46 FEDE                 Move.L    D6, $-122(A6)
81E2   302E 000A                 Move      $A(A6), D0
81E6   0C40 00B4                 Cmp       $B4, D0
81EA   6C06                      BGE       L1273
81EC   0440 005A                 Sub       $5A, D0
81F0   6006                      Bra       L1274
81F2   0440 010E      L1273:     Sub       $10E, D0
81F6   4440                      Neg       D0
81F8   3D40 FEDC      L1274:     Move      D0, $-124(A6)
81FC   302E FEF6                 Move      $-10A(A6), D0
8200   0C40 00B4                 Cmp       $B4, D0
8204   6C06                      BGE       L1275
8206   0440 005A                 Sub       $5A, D0
820A   6006                      Bra       L1276
820C   0440 010E      L1275:     Sub       $10E, D0
8210   4440                      Neg       D0
8212   3D40 FEDA      L1276:     Move      D0, $-126(A6)
8216   302E 0008                 Move      $8(A6), D0
821A   0C40 00B4                 Cmp       $B4, D0
821E   6E1A                      BGT       L1278
8220   6D0C                      BLT       L1277
8222   0C6E 005A 000A            Cmp       $5A, $A(A6)
8228   57EE FEF8                 SEQ.B     $-108(A6)
822C   600C                      Bra       L1278
822E   302E FEDC      L1277:     Move      $-124(A6), D0
8232   806E FEDA                 Or        $-126(A6), D0
8236   5AEE FEF8                 SPL.B     $-108(A6)
823A   2F2E 0018      L1278:     Move.L    $18(A6), -(A7)
823E   486E FF28                 Pea.L     $-D8(A6)
8242   3F2E 0014                 Move      $14(A6), -(A7)
8246   3F2E 0012                 Move      $12(A6), -(A7)
824A   4EBA 047E                 Jsr       P_mInitOval
824E   302E 0012                 Move      $12(A6), D0
8252   E240                      AsR       $1, D0
8254   D06E FF28                 Add       $-D8(A6), D0
8258   3D40 FF04                 Move      D0, $-FC(A6)
825C   206E 0018                 Move.L    $18(A6), A0
8260   D068 0004                 Add       $4(A0), D0
8264   9050                      Sub       (A0), D0
8266   906E 0012                 Sub       $12(A6), D0
826A   3D40 FF02                 Move      D0, $-FE(A6)
826E   3D7C 7FFF FF52            Move      $7FFF, $-AE(A6)
8274   4A2E 0016                 Tst.B     $16(A6)
8278   6762                      BEQ       L1279
827A   206E 0018                 Move.L    $18(A6), A0
827E   3410                      Move      (A0), D2
8280   D46D 0034                 Add       $34(A5), D2
8284   3628 0004                 Move      $4(A0), D3
8288   966D 0034                 Sub       $34(A5), D3
828C   B443                      Cmp       D3, D2
828E   6C4C                      BGE       L1279
8290   3028 0002                 Move      $2(A0), D0
8294   D06D 0036                 Add       $36(A5), D0
8298   3228 0006                 Move      $6(A0), D1
829C   926D 0036                 Sub       $36(A5), D1
82A0   B041                      Cmp       D1, D0
82A2   6C38                      BGE       L1279
82A4   3D40 FF7E                 Move      D0, $-82(A6)
82A8   3D41 FF82                 Move      D1, $-7E(A6)
82AC   3D42 FF7C                 Move      D2, $-84(A6)
82B0   3D43 FF80                 Move      D3, $-80(A6)
82B4   486E FF7C                 Pea.L     $-84(A6)
82B8   486E FF52                 Pea.L     $-AE(A6)
82BC   302E 0014                 Move      $14(A6), D0
82C0   906D 0036                 Sub       $36(A5), D0
82C4   906D 0036                 Sub       $36(A5), D0
82C8   3F00                      Move      D0, -(A7)
82CA   302E 0012                 Move      $12(A6), D0
82CE   906D 0034                 Sub       $34(A5), D0
82D2   906D 0034                 Sub       $34(A5), D0
82D6   3F00                      Move      D0, -(A7)
82D8   4EBA 03F0                 Jsr       P_mInitOval
82DC   486E FF84      L1279:     Pea.L     $-7C(A6)
82E0   2F2D 0008                 Move.L    $8(A5), -(A7)
82E4   2A6E FEFA                 Move.L    $-106(A6), A5
82E8   4EBA D084                 Jsr       P_tShieldCursor
82EC   2A6E FEFE                 Move.L    $-102(A6), A5
82F0   4CAE 001E FF84            MoveM     $-7C(A6), D1-D4
82F6   3D7C 8001 FFF6            Move      $-7FFF, $-A(A6)
82FC   3D7C 8001 FFDE            Move      $-7FFF, $-22(A6)
8302   3D7C 7FFF FFF8            Move      $7FFF, $-8(A6)
8308   3D7C 7FFF FFE0            Move      $7FFF, $-20(A6)
830E   342E FF86                 Move      $-7A(A6), D2
8312   946D 000A                 Sub       $A(A5), D2
8316   0242 FFF0                 And       $-10, D2
831A   D46D 000A                 Add       $A(A5), D2
831E   3D42 FF12                 Move      D2, $-EE(A6)
8322   302E FF8A                 Move      $-76(A6), D0
8326   9042                      Sub       D2, D0
8328   EA48                      LsR       $5, D0
832A   3D40 FF10                 Move      D0, $-F0(A6)
832E   42A7           L1280:     Clr.L     -(A7)
8330   51C8 FFFC                 DBF       D0, L1280
8334   2D4F FF14                 Move.L    A7, $-EC(A6)
8338   426E FF20                 Clr       $-E0(A6)
833C   0C52 000A                 Cmp       $A, (A2)
8340   671A                      BEQ       L1281
8342   546E FF20                 AddQ      $2, $-E0(A6)
8346   204A                      Move.L    A2, A0
8348   43EE FFE8                 Lea.L     $-18(A6), A1
834C   302E FF86                 Move      $-7A(A6), D0
8350   322E FF8A                 Move      $-76(A6), D1
8354   342E FF12                 Move      $-EE(A6), D2
8358   4EBA 10F0                 Jsr       P_mInitRgn
835C   0C53 000A      L1281:     Cmp       $A, (A3)
8360   671A                      BEQ       L1282
8362   586E FF20                 AddQ      $4, $-E0(A6)
8366   204B                      Move.L    A3, A0
8368   43EE FFD0                 Lea.L     $-30(A6), A1
836C   302E FF86                 Move      $-7A(A6), D0
8370   322E FF8A                 Move      $-76(A6), D1
8374   342E FF12                 Move      $-EE(A6), D2
8378   4EBA 10D0                 Jsr       P_mInitRgn
837C   4A6E FF20      L1282:     Tst       $-E0(A6)
8380   6618                      BNE       L1283
8382   206E FF14                 Move.L    $-EC(A6), A0
8386   362E FF86                 Move      $-7A(A6), D3
838A   966E FF12                 Sub       $-EE(A6), D3
838E   382E FF8A                 Move      $-76(A6), D4
8392   986E FF12                 Sub       $-EE(A6), D4
8396   4EBA 2010                 Jsr       P252
839A   322E FF84      L1283:     Move      $-7C(A6), D1
839E   926D 0008                 Sub       $8(A5), D1
83A2   C2ED 0006                 MulU      $6(A5), D1
83A6   D2AD 0002                 Add.L     $2(A5), D1
83AA   946D 000A                 Sub       $A(A5), D2
83AE   E64A                      LsR       $3, D2
83B0   48C2                      Ext.L     D2
83B2   D282                      Add.L     D2, D1
83B4   2D41 FF0C                 Move.L    D1, $-F4(A6)
83B8   4287                      Clr.L     D7
83BA   342E 0010                 Move      $10(A6), D2
83BE   0882 0002                 BClr.B    $2, D2
83C2   6702                      BEQ       L1284
83C4   4687                      Not.L     D7
83C6   4EBA D344      L1284:     Jsr       P_mSlabMode
83CA   2D48 FF06                 Move.L    A0, $-FA(A6)
83CE   342D 000A                 Move      $A(A5), D2
83D2   206E 000C                 Move.L    $C(A6), A0
83D6   43EE FF8C                 Lea.L     $-74(A6), A1
83DA   2A6E FEFA                 Move.L    $-106(A6), A5
83DE   4EBA D118                 Jsr       P_mPatExpand
83E2   2A6E FEFE                 Move.L    $-102(A6), A5
83E6   7E0F                      MoveQ.L   $F, D7
83E8   CE6E FF84                 And       $-7C(A6), D7
83EC   E54F                      LsL       $2, D7
83EE   2C36 708C                 Move.L    $-74(A6,D7.W), D6
83F2   322E FF12                 Move      $-EE(A6), D1
83F6   936E FF86                 Sub       D1, $-7A(A6)
83FA   936E FF8A                 Sub       D1, $-76(A6)
83FE   936E FF2E                 Sub       D1, $-D2(A6)
8402   936E FF32                 Sub       D1, $-CE(A6)
8406   936E FF58                 Sub       D1, $-A8(A6)
840A   936E FF5C                 Sub       D1, $-A4(A6)
840E   936E FEE2                 Sub       D1, $-11E(A6)
8412   936E FEDE                 Sub       D1, $-122(A6)
8416   3D6E FF28 FF0A            Move      $-D8(A6), $-F6(A6)
841C   302E FF0A      L1285:     Move      $-F6(A6), D0
8420   B06E FF04                 Cmp       $-FC(A6), D0
8424   6D06                      BLT       L1286
8426   B06E FF02                 Cmp       $-FE(A6), D0
842A   6D14                      BLT       L1287
842C   486E FF28      L1286:     Pea.L     $-D8(A6)
8430   3F00                      Move      D0, -(A7)
8432   4EBA 0356                 Jsr       P_mBumpOval
8436   486E FF52                 Pea.L     $-AE(A6)
843A   3F00                      Move      D0, -(A7)
843C   4EBA 034C                 Jsr       P_mBumpOval
8440   B06E FEF4      L1287:     Cmp       $-10C(A6), D0
8444   6664                      BNE       L1290
8446   4A2E FEF9                 Tst.B     $-107(A6)
844A   675E                      BEQ       L1290
844C   446E FEDC                 Neg       $-124(A6)
8450   446E FEDA                 Neg       $-126(A6)
8454   422E FEF8                 Clr.B     $-108(A6)
8458   302E 0008                 Move      $8(A6), D0
845C   0C40 00B4                 Cmp       $B4, D0
8460   6E1A                      BGT       L1289
8462   6D0C                      BLT       L1288
8464   0C6E 010E 000A            Cmp       $10E, $A(A6)
846A   6610                      BNE       L1289
846C   6000 01D4                 Bra       L1306
8470   302E FEDC      L1288:     Move      $-124(A6), D0
8474   806E FEDA                 Or        $-126(A6), D0
8478   6A00 01C8                 BPL       L1306
847C   302E FEDC      L1289:     Move      $-124(A6), D0
8480   3D6E FEDA FEDC            Move      $-126(A6), $-124(A6)
8486   3D40 FEDA                 Move      D0, $-126(A6)
848A   202E FEE2                 Move.L    $-11E(A6), D0
848E   2D6E FEDE FEE2            Move.L    $-122(A6), $-11E(A6)
8494   2D40 FEDE                 Move.L    D0, $-122(A6)
8498   202E FEEA                 Move.L    $-116(A6), D0
849C   2D6E FEE6 FEEA            Move.L    $-11A(A6), $-116(A6)
84A2   2D40 FEE6                 Move.L    D0, $-11A(A6)
84A6   302E FF0A                 Move      $-F6(A6), D0
84AA   B06E FF84      L1290:     Cmp       $-7C(A6), D0
84AE   6D00 0172                 BLT       L1305
84B2   4A2E FEF8                 Tst.B     $-108(A6)
84B6   6600 0156                 BNE       L1304
84BA   4EBA 01A0                 Jsr       P228
84BE   4A2E FEF9                 Tst.B     $-107(A6)
84C2   6618                      BNE       L1291
84C4   302E FF0A                 Move      $-F6(A6), D0
84C8   B06E FF52                 Cmp       $-AE(A6), D0
84CC   6D00 0136                 BLT       L1302
84D0   B06E FF54                 Cmp       $-AC(A6), D0
84D4   6C00 012E                 BGE       L1302
84D8   6000 0114                 Bra       L1301
84DC   322E FF2E      L1291:     Move      $-D2(A6), D1
84E0   4A6E FEDC                 Tst       $-124(A6)
84E4   6A0A                      BPL       L1292
84E6   B26E FEE2                 Cmp       $-11E(A6), D1
84EA   6C04                      BGE       L1292
84EC   322E FEE2                 Move      $-11E(A6), D1
84F0   3D41 FED8      L1292:     Move      D1, $-128(A6)
84F4   342E FF32                 Move      $-CE(A6), D2
84F8   4A6E FEDA                 Tst       $-126(A6)
84FC   6A0A                      BPL       L1293
84FE   B46E FEDE                 Cmp       $-122(A6), D2
8502   6F04                      BLE       L1293
8504   342E FEDE                 Move      $-122(A6), D2
8508   3D42 FED6      L1293:     Move      D2, $-12A(A6)
850C   302E FF0A                 Move      $-F6(A6), D0
8510   B06E FF52                 Cmp       $-AE(A6), D0
8514   6D00 00B0                 BLT       L1300
8518   B06E FF54                 Cmp       $-AC(A6), D0
851C   6C00 00A8                 BGE       L1300
8520   302E FF58                 Move      $-A8(A6), D0
8524   4A6E FEDA                 Tst       $-126(A6)
8528   6A0A                      BPL       L1294
852A   B06E FEDE                 Cmp       $-122(A6), D0
852E   6F04                      BLE       L1294
8530   302E FEDE                 Move      $-122(A6), D0
8534   3D40 FED4      L1294:     Move      D0, $-12C(A6)
8538   302E FF5C                 Move      $-A4(A6), D0
853C   4A6E FEDC                 Tst       $-124(A6)
8540   6A0A                      BPL       L1295
8542   B06E FEE2                 Cmp       $-11E(A6), D0
8546   6C04                      BGE       L1295
8548   302E FEE2                 Move      $-11E(A6), D0
854C   3D40 FED2      L1295:     Move      D0, $-12E(A6)
8550   B242                      Cmp       D2, D1
8552   6C12                      BGE       L1296
8554   342E FED4                 Move      $-12C(A6), D2
8558   6158                      Bsr       P227
855A   322E FED2                 Move      $-12E(A6), D1
855E   342E FED6                 Move      $-12A(A6), D2
8562   6000 00A8                 Bra       L1303
8566   302E FEDC      L1296:     Move      $-124(A6), D0
856A   C06E FEDA                 And       $-126(A6), D0
856E   6A00 009E                 BPL       L1304
8572   0C6E 00B4 0008            Cmp       $B4, $8(A6)
8578   6F00 0094                 BLE       L1304
857C   B46E FED4                 Cmp       $-12C(A6), D2
8580   6608                      BNE       L1297
8582   342E FF58                 Move      $-A8(A6), D2
8586   6000 0014                 Bra       L1298
858A   302E FED8      L1297:     Move      $-128(A6), D0
858E   B06E FED2                 Cmp       $-12E(A6), D0
8592   660A                      BNE       L1299
8594   322E FF5C                 Move      $-A4(A6), D1
8598   342E FED6                 Move      $-12A(A6), D2
859C   6114           L1298:     Bsr       P227
859E   322E FF2E      L1299:     Move      $-D2(A6), D1
85A2   342E FED4                 Move      $-12C(A6), D2
85A6   610A                      Bsr       P227
85A8   322E FED2                 Move      $-12E(A6), D1
85AC   342E FF32                 Move      $-CE(A6), D2
85B0   605A                      Bra       L1303

                      P227:
85B2   206E FF06                 Move.L    $-FA(A6), A0
85B6   226E FF0C                 Move.L    $-F4(A6), A1
85BA   246E FF14                 Move.L    $-EC(A6), A2
85BE   47EE FF84                 Lea.L     $-7C(A6), A3
85C2   4EFA D0FC                 Jmp       P205
85C6   B242           L1300:     Cmp       D2, D1
85C8   6D42                      BLT       L1303
85CA   302E FEDC                 Move      $-124(A6), D0
85CE   C06E FEDA                 And       $-126(A6), D0
85D2   6A00 003A                 BPL       L1304
85D6   0C6E 00B4 0008            Cmp       $B4, $8(A6)
85DC   6F30                      BLE       L1304
85DE   322E FF2E                 Move      $-D2(A6), D1
85E2   61CE                      Bsr       P227
85E4   322E FED8                 Move      $-128(A6), D1
85E8   342E FF32                 Move      $-CE(A6), D2
85EC   601E                      Bra       L1303
85EE   322E FF2E      L1301:     Move      $-D2(A6), D1
85F2   342E FF58                 Move      $-A8(A6), D2
85F6   61BA                      Bsr       P227
85F8   322E FF5C                 Move      $-A4(A6), D1
85FC   342E FF32                 Move      $-CE(A6), D2
8600   61B0                      Bsr       P227
8602   600A                      Bra       L1304
8604   322E FF2E      L1302:     Move      $-D2(A6), D1
8608   342E FF32                 Move      $-CE(A6), D2
860C   61A4           L1303:     Bsr       P227
860E   5847           L1304:     AddQ      $4, D7
8610   0247 003F                 And       $3F, D7
8614   2C36 708C                 Move.L    $-74(A6,D7.W), D6
8618   302D 0006                 Move      $6(A5), D0
861C   48C0                      Ext.L     D0
861E   D1AE FF0C                 Add.L     D0, $-F4(A6)
8622   202E FEEA      L1305:     Move.L    $-116(A6), D0
8626   D1AE FEE2                 Add.L     D0, $-11E(A6)
862A   202E FEE6                 Move.L    $-11A(A6), D0
862E   D1AE FEDE                 Add.L     D0, $-122(A6)
8632   526E FF0A                 AddQ      $1, $-F6(A6)
8636   302E FF0A                 Move      $-F6(A6), D0
863A   B06E FF88                 Cmp       $-78(A6), D0
863E   6D00 FDDC                 BLT       L1285
8642   2A6E FEFA      L1306:     Move.L    $-106(A6), A5
8646   4EBA CD22                 Jsr       P_tShowCursor
864A   2E6E FFCC      L1307:     Move.L    $-34(A6), A7
864E   4CDF 3EFF                 MoveM.L   (A7)+, D0-D7/A1-A5
8652   4E5E                      Unlk      A6
8654   205F                      Move.L    (A7)+, A0
8656   DEFC 0014                 AddA      $14, A7
865A   4ED0                      Jmp       (A0)

                      P228:
865C   302E FF20                 Move      $-E0(A6), D0
8660   303B 0006                 Move      DT43(D0.W), D0
8664   4EFB 0002                 Jmp       DT43(D0.W)

                      DT43:
8668   0008 000A 001E            DC.B      '      '
866E   0032                      DC.B      ' 2'

                      E_352:
8670   4E75                      Rts

                      E_353:
8672   302E FF0A                 Move      $-F6(A6), D0
8676   43EE FFE8                 Lea.L     $-18(A6), A1
867A   4EBA 0E06                 Jsr       P_mSeekRgn
867E   2D69 0008 FF14            Move.L    $8(A1), $-EC(A6)
8684   4E75                      Rts

                      E_354:
8686   302E FF0A                 Move      $-F6(A6), D0
868A   43EE FFD0                 Lea.L     $-30(A6), A1
868E   4EBA 0DF2                 Jsr       P_mSeekRgn
8692   2D69 0008 FF14            Move.L    $8(A1), $-EC(A6)
8698   4E75                      Rts

                      E_355:
869A   302E FF0A                 Move      $-F6(A6), D0
869E   43EE FFE8                 Lea.L     $-18(A6), A1
86A2   4EBA 0DDE                 Jsr       P_mSeekRgn
86A6   43EE FFD0                 Lea.L     $-30(A6), A1
86AA   4EBA 0DD6                 Jsr       P_mSeekRgn
86AE   206E FFF0                 Move.L    $-10(A6), A0
86B2   226E FFD8                 Move.L    $-28(A6), A1
86B6   246E FF14                 Move.L    $-EC(A6), A2
86BA   322E FF10                 Move      $-F0(A6), D1
86BE   2018           L1308:     Move.L    (A0)+, D0
86C0   C099                      And.L     (A1)+, D0
86C2   24C0                      Move.L    D0, (A2)+
86C4   51C9 FFF8                 DBF       D1, L1308
86C8   4E75                      Rts

                      P_mInitOval:
86CA   4E56 0000                 Link      A6, $0
86CE   48E7 FFFC                 MoveM.L   D0-D7/A0-A5, -(A7)
86D2   206E 0010                 Move.L    $10(A6), A0
86D6   226E 000C                 Move.L    $C(A6), A1
86DA   3290                      Move      (A0), (A1)
86DC   3368 0004 0002            Move      $4(A0), $2(A1)
86E2   342E 000A                 Move      $A(A6), D2
86E6   6C02                      BGE       L1309
86E8   4242                      Clr       D2
86EA   322E 0008      L1309:     Move      $8(A6), D1
86EE   6C02                      BGE       L1310
86F0   4241                      Clr       D1
86F2   3028 0006      L1310:     Move      $6(A0), D0
86F6   9068 0002                 Sub       $2(A0), D0
86FA   B440                      Cmp       D0, D2
86FC   6F02                      BLE       L1311
86FE   3400                      Move      D0, D2
8700   3028 0004      L1311:     Move      $4(A0), D0
8704   9050                      Sub       (A0), D0
8706   B240                      Cmp       D0, D1
8708   6F02                      BLE       L1312
870A   3200                      Move      D0, D1
870C   3368 0006 000A L1312:     Move      $6(A0), $A(A1)
8712   4269 000C                 Clr       $C(A1)
8716   3368 0002 0006            Move      $2(A0), $6(A1)
871C   4269 0008                 Clr       $8(A1)
8720   3002                      Move      D2, D0
8722   4840                      Swap      D0
8724   4240                      Clr       D0
8726   E288                      LsR.L     $1, D0
8728   D1A9 0006                 Add.L     D0, $6(A1)
872C   91A9 000A                 Sub.L     D0, $A(A1)
8730   06A9 0000 8000            Add.L     $8000, $A(A1)
       000A
8738   7001                      MoveQ.L   $1, D0
873A   9041                      Sub       D1, D0
873C   3340 0004                 Move      D0, $4(A1)
8740   3001                      Move      D1, D0
8742   48C0                      Ext.L     D0
8744   D080                      Add.L     D0, D0
8746   5380                      SubQ.L    $1, D0
8748   2340 000E                 Move.L    D0, $E(A1)
874C   42A9 0012                 Clr.L     $12(A1)
8750   42A9 0016                 Clr.L     $16(A1)
8754   42A7                      Clr.L     -(A7)
8756   3F01                      Move      D1, -(A7)
8758   3F02                      Move      D2, -(A7)
875A   4EBA D0A2                 Jsr       P_tFixRatio
875E   2F17                      Move.L    (A7), -(A7)
8760   4869 001A                 Pea.L     $1A(A1)
8764   4EBA D010                 Jsr       P_tLongMul
8768   2029 001E                 Move.L    $1E(A1), D0
876C   D080                      Add.L     D0, D0
876E   2340 0026                 Move.L    D0, $26(A1)
8772   2029 001A                 Move.L    $1A(A1), D0
8776   D180                      AddX.L    D0, D0
8778   2340 0022                 Move.L    D0, $22(A1)
877C   4CDF 3FFF                 MoveM.L   (A7)+, D0-D7/A0-A5
8780   4E5E                      Unlk      A6
8782   205F                      Move.L    (A7)+, A0
8784   DEFC 000C                 AddA      $C, A7
8788   4ED0                      Jmp       (A0)

                      P_mBumpOval:
878A   4E56 0000                 Link      A6, $0
878E   48E7 FFFC                 MoveM.L   D0-D7/A0-A5, -(A7)
8792   246E 000A                 Move.L    $A(A6), A2
8796   302E 0008                 Move      $8(A6), D0
879A   B052                      Cmp       (A2), D0
879C   6D00 0086                 BLT       L1317
87A0   B06A 0002                 Cmp       $2(A2), D0
87A4   6C00 007E                 BGE       L1317
87A8   263C 0000 8000            Move.L    $8000, D3
87AE   242A 000A                 Move.L    $A(A2), D2
87B2   222A 0006                 Move.L    $6(A2), D1
87B6   282A 000E                 Move.L    $E(A2), D4
87BA   6020                      Bra       L1314
87BC   D483           L1313:     Add.L     D3, D2
87BE   9283                      Sub.L     D3, D1
87C0   41EA 0022                 Lea.L     $22(A2), A0
87C4   43EA 001A                 Lea.L     $1A(A2), A1
87C8   9040                      Sub       D0, D0
87CA   D388                      AddX.L    -(A0), -(A1)
87CC   D388                      AddX.L    -(A0), -(A1)
87CE   41EA 002A                 Lea.L     $2A(A2), A0
87D2   43EA 0022                 Lea.L     $22(A2), A1
87D6   9040                      Sub       D0, D0
87D8   D388                      AddX.L    -(A0), -(A1)
87DA   D388                      AddX.L    -(A0), -(A1)
87DC   B8AA 0012      L1314:     Cmp.L     $12(A2), D4
87E0   6EDA                      BGT       L1313
87E2   6020                      Bra       L1316
87E4   9483           L1315:     Sub.L     D3, D2
87E6   D283                      Add.L     D3, D1
87E8   41EA 002A                 Lea.L     $2A(A2), A0
87EC   43EA 0022                 Lea.L     $22(A2), A1
87F0   9040                      Sub       D0, D0
87F2   9388                      SubX.L    -(A0), -(A1)
87F4   9388                      SubX.L    -(A0), -(A1)
87F6   41EA 0022                 Lea.L     $22(A2), A0
87FA   43EA 001A                 Lea.L     $1A(A2), A1
87FE   9040                      Sub       D0, D0
8800   9388                      SubX.L    -(A0), -(A1)
8802   9388                      SubX.L    -(A0), -(A1)
8804   B8AA 0012      L1316:     Cmp.L     $12(A2), D4
8808   6DDA                      BLT       L1315
880A   2542 000A                 Move.L    D2, $A(A2)
880E   2541 0006                 Move.L    D1, $6(A2)
8812   302A 0004                 Move      $4(A2), D0
8816   5240                      AddQ      $1, D0
8818   48C0                      Ext.L     D0
881A   E580                      AsL.L     $2, D0
881C   91AA 000E                 Sub.L     D0, $E(A2)
8820   546A 0004                 AddQ      $2, $4(A2)
8824   4CDF 3FFF      L1317:     MoveM.L   (A7)+, D0-D7/A0-A5
8828   4E5E                      Unlk      A6
882A   205F                      Move.L    (A7)+, A0
882C   5C4F                      AddQ      $6, A7
882E   4ED0                      Jmp       (A0)

                      P231:
8830   205F                      Move.L    (A7)+, A0
8832   301F                      Move      (A7)+, D0
8834   48C0                      Ext.L     D0
8836   81FC 00B4                 DivS      $B4, D0
883A   4840                      Swap      D0
883C   4A40                      Tst       D0
883E   6A04                      BPL       L1318
8840   0640 00B4                 Add       $B4, D0
8844   E548           L1318:     LsL       $2, D0
8846   0C40 0168                 Cmp       $168, D0
884A   6F0C                      BLE       L1319
884C   0440 02D0                 Sub       $2D0, D0
8850   4440                      Neg       D0
8852   2EBB 000C                 Move.L    DT44(D0.W), (A7)
8856   4ED0                      Jmp       (A0)
8858   2EBB 0006      L1319:     Move.L    DT44(D0.W), (A7)
885C   4497                      Neg.L     (A7)
885E   4ED0                      Jmp       (A0)

                      DT44:
8860   0000 0000 0000            DC.B      '      '
8866   0478 0000 08F1            DC.B      ' x    '
886C   0000 0D6B 0000            DC.B      '   k  '
8872   11E7 0000 1666            DC.B      '     f'
8878   0000 1AE8 0000            DC.B      '      '
887E   1F6F 0000 23FA            DC.B      ' o  # '
8884   0000 288C 0000            DC.B      '  (   '
888A   2D24 0000 31C3            DC.B      '-$  1 '
8890   0000 366A 0000            DC.B      '  6j  '
8896   3B1A 0000 3FD4            DC.B      ';   ? '
889C   0000 4498 0000            DC.B      '  D   '
88A2   4968 0000 4E44            DC.B      'Ih  ND'
88A8   0000 532E 0000            DC.B      '  S.  '
88AE   5826 0000 5D2D            DC.B      'X&  ]-'
88B4   0000 6245 0000            DC.B      '  bE  '
88BA   676E 0000 6CAA            DC.B      'gn  l '
88C0   0000 71FB 0000            DC.B      '  q   '
88C6   7760 0000 7CDC            DC.B      'w`  | '
88CC   0000 8270 0000            DC.B      '   p  '
88D2   881E 0000 8DE7            DC.B      '      '
88D8   0000 93CD 0000            DC.B      '      '
88DE   99D2 0000 9FF7            DC.B      '      '
88E4   0000 A640 0000            DC.B      '   @  '
88EA   ACAD 0000 B341            DC.B      '     A'
88F0   0000 B9FF 0000            DC.B      '      '
88F6   C0E9 0000 C802            DC.B      '      '
88FC   0000 CF4E 0000            DC.B      '   N  '
8902   D6CF 0000 DE8A            DC.B      '      '
8908   0000 E681 0000            DC.B      '      '
890E   EEB9 0000 F737            DC.B      '     7'
8914   0001 0000 0001            DC.B      '      '
891A   0919 0001 1287            DC.B      '      '
8920   0001 1C51 0001            DC.B      '   Q  '
8926   267F 0001 3117            DC.B      '&   1 '
892C   0001 3C22 0001            DC.B      '  <"  '
8932   47AA 0001 53B9            DC.B      'G   S '
8938   0001 605B 0001            DC.B      '  `[  '
893E   6D9B 0001 7B89            DC.B      'm   { '
8944   0001 8A35 0001            DC.B      '   5  '
894A   99AF 0001 AA0E            DC.B      '      '
8950   0001 BB68 0001            DC.B      '   h  '
8956   CDD6 0001 E177            DC.B      '     w'
895C   0001 F66E 0002            DC.B      '   n  '
8962   0CE1 0002 24FE            DC.B      '    $ '
8968   0002 3EFC 0002            DC.B      '  >   '
896E   5B19 0002 799F            DC.B      '[   y '
8974   0002 9AE7 0002            DC.B      '      '
897A   BF5B 0002 E77A            DC.B      ' [   z'
8980   0003 13E3 0003            DC.B      '      '
8986   4556 0003 7CC7            DC.B      'EV  | '
898C   0003 BB68 0004            DC.B      '   h  '
8992   02C2 0004 54DB            DC.B      '    T '
8998   0004 B462 0005            DC.B      '   b  '
899E   2501 0005 ABD9            DC.B      '%     '
89A4   0006 5051 0007            DC.B      '  PQ  '
89AA   1D88 0008 24F3            DC.B      '    $ '
89B0   0009 83AD 000B            DC.B      '      '
89B6   6E17 000E 4CF5            DC.B      'n   L '
89BC   0013 14BD 001C            DC.B      '      '
89C2   A2D7 0039 4A30            DC.B      '   9J0'
89C8   7FFF FFFF                 DC.B      '    '

                      P232:
89CC   202F 0004                 Move.L    $4(A7), D0
89D0   5BC2                      SMI.B     D2
89D2   6A02                      BPL       L1320
89D4   4480                      Neg.L     D0
89D6   41FA FE88      L1320:     Lea.L     DT44, A0
89DA   323C 00B4                 Move      $B4, D1
89DE   0480 0000 01F4            Sub.L     $1F4, D0
89E4   B098           L1321:     Cmp.L     (A0)+, D0
89E6   5FC9 FFFC                 DBLE      D1, L1321
89EA   303C 00B4                 Move      $B4, D0
89EE   9041                      Sub       D1, D0
89F0   4A02                      Tst.B     D2
89F2   6B02                      BMI       L1322
89F4   3001                      Move      D1, D0
89F6   2E9F           L1322:     Move.L    (A7)+, (A7)
89F8   3F40 0004                 Move      D0, $4(A7)
89FC   4E75                      Rts

                      P_tPtToAngle:
89FE   4E56 0000                 Link      A6, $0
8A02   48E7 0308                 MoveM.L   D6-D7/A4, -(A7)
8A06   286E 0010                 Move.L    $10(A6), A4
8A0A   302C 0004                 Move      $4(A4), D0
8A0E   D054                      Add       (A4), D0
8A10   E240                      AsR       $1, D0
8A12   322E 000C                 Move      $C(A6), D1
8A16   9240                      Sub       D0, D1
8A18   302C 0006                 Move      $6(A4), D0
8A1C   D06C 0002                 Add       $2(A4), D0
8A20   E240                      AsR       $1, D0
8A22   3E2E 000E                 Move      $E(A6), D7
8A26   9E40                      Sub       D0, D7
8A28   660A                      BNE       L1323
8A2A   4A41                      Tst       D1
8A2C   6F50                      BLE       L1324
8A2E   303C 00B4                 Move      $B4, D0
8A32   604C                      Bra       L1325
8A34   42A7           L1323:     Clr.L     -(A7)
8A36   3F07                      Move      D7, -(A7)
8A38   3F01                      Move      D1, -(A7)
8A3A   4EBA CDC2                 Jsr       P_tFixRatio
8A3E   2C1F                      Move.L    (A7)+, D6
8A40   42A7                      Clr.L     -(A7)
8A42   302C 0004                 Move      $4(A4), D0
8A46   9054                      Sub       (A4), D0
8A48   3F00                      Move      D0, -(A7)
8A4A   302C 0006                 Move      $6(A4), D0
8A4E   906C 0002                 Sub       $2(A4), D0
8A52   3F00                      Move      D0, -(A7)
8A54   4EBA CDA8                 Jsr       P_tFixRatio
8A58   201F                      Move.L    (A7)+, D0
8A5A   42A7                      Clr.L     -(A7)
8A5C   2F06                      Move.L    D6, -(A7)
8A5E   2F00                      Move.L    D0, -(A7)
8A60   4EBA CD7A                 Jsr       P_tFixMul
8A64   201F                      Move.L    (A7)+, D0
8A66   4267                      Clr       -(A7)
8A68   2F00                      Move.L    D0, -(A7)
8A6A   4EBA FF60                 Jsr       P232
8A6E   301F                      Move      (A7)+, D0
8A70   4A47                      Tst       D7
8A72   6A0C                      BPL       L1325
8A74   0640 00B4                 Add       $B4, D0
8A78   0C40 0168                 Cmp       $168, D0
8A7C   6602                      BNE       L1325
8A7E   4240           L1324:     Clr       D0
8A80   206E 0008      L1325:     Move.L    $8(A6), A0
8A84   3080                      Move      D0, (A0)
8A86   4CDF 10C0                 MoveM.L   (A7)+, D6-D7/A4
8A8A   4E5E                      Unlk      A6
8A8C   205F                      Move.L    (A7)+, A0
8A8E   DEFC 000C                 AddA      $C, A7
8A92   4ED0                      Jmp       (A0)

                      P_tStdPoly:
8A94   4E56 FFF8                 Link      A6, $-8
8A98   48E7 0738                 MoveM.L   D5-D7/A2-A4, -(A7)
8A9C   1E2E 000C                 Move.B    $C(A6), D7
8AA0   4EBA 25C0                 Jsr       P_mCheckPic
8AA4   6F00 001A                 BLE       L1326
8AA8   1F07                      Move.B    D7, -(A7)
8AAA   4EBA 24AE                 Jsr       P_mPutPicVerb
8AAE   7070                      MoveQ.L   $70, D0
8AB0   D047                      Add       D7, D0
8AB2   1F00                      Move.B    D0, -(A7)
8AB4   4EBA 23FA                 Jsr       P_mPutPicByte
8AB8   2F2E 0008                 Move.L    $8(A6), -(A7)
8ABC   4EBA 247A                 Jsr       P_mPutPicRgn
8AC0   246E 0008      L1326:     Move.L    $8(A6), A2
8AC4   4A07                      Tst.B     D7
8AC6   6608                      BNE       L1327
8AC8   2F0A                      Move.L    A2, -(A7)
8ACA   4EBA 01B4                 Jsr       P_mFrPoly
8ACE   6032                      Bra       L1328
8AD0   2052           L1327:     Move.L    (A2), A0
8AD2   4868 0002                 Pea.L     $2(A0)
8AD6   206B 0018                 Move.L    $18(A3), A0
8ADA   2050                      Move.L    (A0), A0
8ADC   4868 0002                 Pea.L     $2(A0)
8AE0   206B 001C                 Move.L    $1C(A3), A0
8AE4   2050                      Move.L    (A0), A0
8AE6   4868 0002                 Pea.L     $2(A0)
8AEA   3F3C 0003                 Move      $3, -(A7)
8AEE   486E FFF8                 Pea.L     $-8(A6)
8AF2   4EBA E6D4                 Jsr       P_mRSect
8AF6   670A                      BEQ       L1328
8AF8   2F0A                      Move.L    A2, -(A7)
8AFA   4EBA E484                 Jsr       P_mPushVerb
8AFE   4EBA 01C0                 Jsr       P_mDrawPoly
8B02   4CDF 1CE0      L1328:     MoveM.L   (A7)+, D5-D7/A2-A4
8B06   4E5E                      Unlk      A6
8B08   205F                      Move.L    (A7)+, A0
8B0A   5C4F                      AddQ      $6, A7
8B0C   4ED0                      Jmp       (A0)
                      P_mCallPoly:
8B0E   205F                      Move.L    (A7)+, A0
8B10   225F                      Move.L    (A7)+, A1
8B12   1F00                      Move.B    D0, -(A7)
8B14   2F09                      Move.L    A1, -(A7)
8B16   2F08                      Move.L    A0, -(A7)
8B18   2055                      Move.L    (A5), A0
8B1A   2050                      Move.L    (A0), A0
8B1C   2028 0068                 Move.L    $68(A0), D0
8B20   41FA FF72                 Lea.L     P_tStdPoly, A0
8B24   6706                      BEQ       L1330
8B26   2040                      Move.L    D0, A0
8B28   2068 0018                 Move.L    $18(A0), A0
8B2C   4ED0           L1330:     Jmp       (A0)

                      P_tFramePoly:
8B2E   7000                      MoveQ.L   $0, D0
8B30   4EFA FFDC                 Jmp       P_mCallPoly

                      P_tPaintPoly:
8B34   7001                      MoveQ.L   $1, D0
8B36   4EFA FFD6                 Jmp       P_mCallPoly

                      P_tErasePoly:
8B3A   7002                      MoveQ.L   $2, D0
8B3C   4EFA FFD0                 Jmp       P_mCallPoly

                      P_tInvertPoly:
8B40   7003                      MoveQ.L   $3, D0
8B42   4EFA FFCA                 Jmp       P_mCallPoly

                      P_tFillPoly:
8B46   205F                      Move.L    (A7)+, A0
8B48   225F                      Move.L    (A7)+, A1
8B4A   2F08                      Move.L    A0, -(A7)
8B4C   2055                      Move.L    (A5), A0
8B4E   2050                      Move.L    (A0), A0
8B50   41E8 0028                 Lea.L     $28(A0), A0
8B54   20D9                      Move.L    (A1)+, (A0)+
8B56   20D9                      Move.L    (A1)+, (A0)+
8B58   7004                      MoveQ.L   $4, D0
8B5A   4EFA FFB2                 Jmp       P_mCallPoly

                      P_tOpenPoly:
8B5E   4EBA DD0E                 Jsr       P_tHidePen
8B62   42A7                      Clr.L     -(A7)
8B64   3F3C 008A                 Move      $8A, -(A7)
8B68   4EBA 269E                 Jsr       P274
8B6C   225F                      Move.L    (A7)+, A1
8B6E   2F49 0004                 Move.L    A1, $4(A7)
8B72   2055                      Move.L    (A5), A0
8B74   2149 FF5E                 Move.L    A1, $-A2(A0)
8B78   317C 008A FF5C            Move      $8A, $-A4(A0)
8B7E   2050                      Move.L    (A0), A0
8B80   217C 0000 0001            Move.L    $1, $64(A0)
       0064
8B88   2251                      Move.L    (A1), A1
8B8A   32FC 000A                 Move      $A, (A1)+
8B8E   4299                      Clr.L     (A1)+
8B90   4299                      Clr.L     (A1)+
8B92   4E75                      Rts

                      P_tClosePoly:
8B94   48E7 1F08                 MoveM.L   D3-D7/A4, -(A7)
8B98   2855                      Move.L    (A5), A4
8B9A   2054                      Move.L    (A4), A0
8B9C   42A8 0064                 Clr.L     $64(A0)
8BA0   286C FF5E                 Move.L    $-A2(A4), A4
8BA4   2054                      Move.L    (A4), A0
8BA6   3E18                      Move      (A0)+, D7
8BA8   4298                      Clr.L     (A0)+
8BAA   4298                      Clr.L     (A0)+
8BAC   3C07                      Move      D7, D6
8BAE   0446 000A                 Sub       $A, D6
8BB2   E44E                      LsR       $2, D6
8BB4   673A                      BEQ       L1336
8BB6   3218                      Move      (A0)+, D1
8BB8   3401                      Move      D1, D2
8BBA   3618                      Move      (A0)+, D3
8BBC   3803                      Move      D3, D4
8BBE   5346                      SubQ.L    $1, D6
8BC0   601C                      Bra       L1335
8BC2   3018           L1331:     Move      (A0)+, D0
8BC4   B041                      Cmp       D1, D0
8BC6   6C02                      BGE       L1332
8BC8   3200                      Move      D0, D1
8BCA   B042           L1332:     Cmp       D2, D0
8BCC   6F02                      BLE       L1333
8BCE   3400                      Move      D0, D2
8BD0   3018           L1333:     Move      (A0)+, D0
8BD2   B043                      Cmp       D3, D0
8BD4   6C02                      BGE       L1334
8BD6   3600                      Move      D0, D3
8BD8   B044           L1334:     Cmp       D4, D0
8BDA   6F02                      BLE       L1335
8BDC   3800                      Move      D0, D4
8BDE   51CE FFE2      L1335:     DBF       D6, L1331
8BE2   2054                      Move.L    (A4), A0
8BE4   41E8 0002                 Lea.L     $2(A0), A0
8BE8   30C1                      Move      D1, (A0)+
8BEA   30C3                      Move      D3, (A0)+
8BEC   30C2                      Move      D2, (A0)+
8BEE   30C4                      Move      D4, (A0)+
8BF0   2F0C           L1336:     Move.L    A4, -(A7)
8BF2   3F07                      Move      D7, -(A7)
8BF4   4EBA 2626                 Jsr       P_mSetHSize
8BF8   4EBA DC7E                 Jsr       P_tShowPen
8BFC   4CDF 10F8                 MoveM.L   (A7)+, D3-D7/A4
8C00   4E75                      Rts

                      P_tKillPoly:
8C02   4EFA 02A2                 Jmp       P_tDisposeRgn

                      P_tOffsetPoly:
8C06   205F                      Move.L    (A7)+, A0
8C08   301F                      Move      (A7)+, D0
8C0A   321F                      Move      (A7)+, D1
8C0C   225F                      Move.L    (A7)+, A1
8C0E   2251                      Move.L    (A1), A1
8C10   3419                      Move      (A1)+, D2
8C12   5542                      SubQ.L    $2, D2
8C14   E44A                      LsR       $2, D2
8C16   5342                      SubQ.L    $1, D2
8C18   D159           L1337:     Add       D0, (A1)+
8C1A   D359                      Add       D1, (A1)+
8C1C   51CA FFFA                 DBF       D2, L1337
8C20   4ED0                      Jmp       (A0)

                      P_tMapPoly:
8C22   4E56 0000                 Link      A6, $0
8C26   48E7 0138                 MoveM.L   D7/A2-A4, -(A7)
8C2A   246E 000C                 Move.L    $C(A6), A2
8C2E   266E 0008                 Move.L    $8(A6), A3
8C32   2012                      Move.L    (A2), D0
8C34   B093                      Cmp.L     (A3), D0
8C36   660A                      BNE       L1338
8C38   202A 0004                 Move.L    $4(A2), D0
8C3C   B0AB 0004                 Cmp.L     $4(A3), D0
8C40   6730                      BEQ       L1341
8C42   286E 0010      L1338:     Move.L    $10(A6), A4
8C46   2854                      Move.L    (A4), A4
8C48   486C 0002                 Pea.L     $2(A4)
8C4C   2F0A                      Move.L    A2, -(A7)
8C4E   2F0B                      Move.L    A3, -(A7)
8C50   4EBA 259E                 Jsr       P_tMapRect
8C54   3E14                      Move      (A4), D7
8C56   0447 000A                 Sub       $A, D7
8C5A   E44F                      LsR       $2, D7
8C5C   D8FC 000A                 AddA      $A, A4
8C60   600C                      Bra       L1340
8C62   2F0C           L1339:     Move.L    A4, -(A7)
8C64   2F0A                      Move.L    A2, -(A7)
8C66   2F0B                      Move.L    A3, -(A7)
8C68   4EBA 2524                 Jsr       P_tMapPt
8C6C   584C                      AddQ      $4, A4
8C6E   51CF FFF2      L1340:     DBF       D7, L1339
8C72   4CDF 1C80      L1341:     MoveM.L   (A7)+, D7/A2-A4
8C76   4E5E                      Unlk      A6
8C78   205F                      Move.L    (A7)+, A0
8C7A   DEFC 000C                 AddA      $C, A7
8C7E   4ED0                      Jmp       (A0)

                      P_mFrPoly:
8C80   4E56 0000                 Link      A6, $0
8C84   48E7 0308                 MoveM.L   D6-D7/A4, -(A7)
8C88   286E 0008                 Move.L    $8(A6), A4
8C8C   2054                      Move.L    (A4), A0
8C8E   3E10                      Move      (A0), D7
8C90   0447 000A                 Sub       $A, D7
8C94   E44F                      LsR       $2, D7
8C96   671E                      BEQ       L1344
8C98   2F28 000A                 Move.L    $A(A0), -(A7)
8C9C   4EBA DB38                 Jsr       P_tMoveTo
8CA0   7C0E                      MoveQ.L   $E, D6
8CA2   5347                      SubQ.L    $1, D7
8CA4   600C                      Bra       L1343
8CA6   2054           L1342:     Move.L    (A4), A0
8CA8   2F30 6000                 Move.L    $0(A0,D6.W), -(A7)
8CAC   5846                      AddQ      $4, D6
8CAE   4EBA DB46                 Jsr       P_mDoLine
8CB2   51CF FFF2      L1343:     DBF       D7, L1342
8CB6   4CDF 10C0      L1344:     MoveM.L   (A7)+, D6-D7/A4
8CBA   4E5E                      Unlk      A6
8CBC   2E9F                      Move.L    (A7)+, (A7)
8CBE   4E75                      Rts

                      P_mDrawPoly:
8CC0   4E56 0000                 Link      A6, $0
8CC4   2F0C                      Move.L    A4, -(A7)
8CC6   2055                      Move.L    (A5), A0
8CC8   2050                      Move.L    (A0), A0
8CCA   4A68 0042                 Tst       $42(A0)
8CCE   6B3A                      BMI       L1345
8CD0   4EBA 01E8                 Jsr       P_tOpenRgn
8CD4   2F2E 000E                 Move.L    $E(A6), -(A7)
8CD8   4EBA FFA6                 Jsr       P_mFrPoly
8CDC   206E 000E                 Move.L    $E(A6), A0
8CE0   2050                      Move.L    (A0), A0
8CE2   2F28 000A                 Move.L    $A(A0), -(A7)
8CE6   4EBA DB0E                 Jsr       P_mDoLine
8CEA   42A7                      Clr.L     -(A7)
8CEC   4EBA 0194                 Jsr       P_tNewRgn
8CF0   2857                      Move.L    (A7), A4
8CF2   4EBA 01F6                 Jsr       P_tCloseRgn
8CF6   2F0C                      Move.L    A4, -(A7)
8CF8   3F2E 000C                 Move      $C(A6), -(A7)
8CFC   2F2E 0008                 Move.L    $8(A6), -(A7)
8D00   4EBA 00D0                 Jsr       P_mDrawRgn
8D04   2F0C                      Move.L    A4, -(A7)
8D06   4EBA 019E                 Jsr       P_tDisposeRgn
8D0A   4CDF 1000      L1345:     MoveM.L   (A7)+, A4
8D0E   4E5E                      Unlk      A6
8D10   205F                      Move.L    (A7)+, A0
8D12   DEFC 000A                 AddA      $A, A7
8D16   4ED0                      Jmp       (A0)

                      P_tStdRgn:
8D18   4E56 0000                 Link      A6, $0
8D1C   48E7 0338                 MoveM.L   D6-D7/A2-A4, -(A7)
8D20   1E2E 000C                 Move.B    $C(A6), D7
8D24   4EBA 233C                 Jsr       P_mCheckPic
8D28   6F00 001C                 BLE       L1346
8D2C   1F07                      Move.B    D7, -(A7)
8D2E   4EBA 222A                 Jsr       P_mPutPicVerb
8D32   303C 0080                 Move      $80, D0
8D36   D047                      Add       D7, D0
8D38   1F00                      Move.B    D0, -(A7)
8D3A   4EBA 2174                 Jsr       P_mPutPicByte
8D3E   2F2E 0008                 Move.L    $8(A6), -(A7)
8D42   4EBA 21F4                 Jsr       P_mPutPicRgn
8D46   2F2E 0008      L1346:     Move.L    $8(A6), -(A7)
8D4A   4EBA E234                 Jsr       P_mPushVerb
8D4E   4A07                      Tst.B     D7
8D50   6620                      BNE       L1348
8D52   4AAB 0060                 Tst.L     $60(A3)
8D56   6714                      BEQ       L1347
8D58   2F2E 0008                 Move.L    $8(A6), -(A7)
8D5C   2F2C FF6C                 Move.L    $-94(A4), -(A7)
8D60   486C FF6A                 Pea.L     $-96(A4)
8D64   486C FF68                 Pea.L     $-98(A4)
8D68   4EBA 0C3E                 Jsr       P_mPutRgn
8D6C   4EBA 00A0      L1347:     Jsr       P_mFrRgn
8D70   6004                      Bra       L1349
8D72   4EBA 005E      L1348:     Jsr       P_mDrawRgn
8D76   4CDF 1CC0      L1349:     MoveM.L   (A7)+, D6-D7/A2-A4
8D7A   4E5E                      Unlk      A6
8D7C   205F                      Move.L    (A7)+, A0
8D7E   5C4F                      AddQ      $6, A7
8D80   4ED0                      Jmp       (A0)
                      P_mCallRgn:
8D82   205F                      Move.L    (A7)+, A0
8D84   225F                      Move.L    (A7)+, A1
8D86   1F00                      Move.B    D0, -(A7)
8D88   2F09                      Move.L    A1, -(A7)
8D8A   2F08                      Move.L    A0, -(A7)
8D8C   2055                      Move.L    (A5), A0
8D8E   2050                      Move.L    (A0), A0
8D90   2028 0068                 Move.L    $68(A0), D0
8D94   41FA FF82                 Lea.L     P_tStdRgn, A0
8D98   6706                      BEQ       L1351
8D9A   2040                      Move.L    D0, A0
8D9C   2068 001C                 Move.L    $1C(A0), A0
8DA0   4ED0           L1351:     Jmp       (A0)

                      P_tFrameRgn:
8DA2   7000                      MoveQ.L   $0, D0
8DA4   4EFA FFDC                 Jmp       P_mCallRgn

                      P_tPaintRgn:
8DA8   7001                      MoveQ.L   $1, D0
8DAA   4EFA FFD6                 Jmp       P_mCallRgn

                      P_tEraseRgn:
8DAE   7002                      MoveQ.L   $2, D0
8DB0   4EFA FFD0                 Jmp       P_mCallRgn

                      P_tInvertRgn:
8DB4   7003                      MoveQ.L   $3, D0
8DB6   4EFA FFCA                 Jmp       P_mCallRgn

                      P_tFillRgn:
8DBA   205F                      Move.L    (A7)+, A0
8DBC   225F                      Move.L    (A7)+, A1
8DBE   2F08                      Move.L    A0, -(A7)
8DC0   2055                      Move.L    (A5), A0
8DC2   2050                      Move.L    (A0), A0
8DC4   41E8 0028                 Lea.L     $28(A0), A0
8DC8   20D9                      Move.L    (A1)+, (A0)+
8DCA   20D9                      Move.L    (A1)+, (A0)+
8DCC   7004                      MoveQ.L   $4, D0
8DCE   4EFA FFB2                 Jmp       P_mCallRgn

                      P_mDrawRgn:
8DD2   4E56 0000                 Link      A6, $0
8DD6   2055                      Move.L    (A5), A0
8DD8   2050                      Move.L    (A0), A0
8DDA   4A68 0042                 Tst       $42(A0)
8DDE   6B24                      BMI       L1352
8DE0   4868 0002                 Pea.L     $2(A0)
8DE4   2F17                      Move.L    (A7), -(A7)
8DE6   4868 0008                 Pea.L     $8(A0)
8DEA   2F17                      Move.L    (A7), -(A7)
8DEC   3F2E 000C                 Move      $C(A6), -(A7)
8DF0   2F2E 0008                 Move.L    $8(A6), -(A7)
8DF4   2F28 001C                 Move.L    $1C(A0), -(A7)
8DF8   2F28 0018                 Move.L    $18(A0), -(A7)
8DFC   2F2E 000E                 Move.L    $E(A6), -(A7)
8E00   4EBA E8DE                 Jsr       P_mRgnBlt
8E04   4E5E           L1352:     Unlk      A6
8E06   205F                      Move.L    (A7)+, A0
8E08   DEFC 000A                 AddA      $A, A7
8E0C   4ED0                      Jmp       (A0)

                      P_mFrRgn:
8E0E   4E56 0000                 Link      A6, $0
8E12   48E7 0118                 MoveM.L   D7/A3-A4, -(A7)
8E16   2855                      Move.L    (A5), A4
8E18   2654                      Move.L    (A4), A3
8E1A   4A6B 0042                 Tst       $42(A3)
8E1E   6B00 0054                 BMI       L1354
8E22   206E 000E                 Move.L    $E(A6), A0
8E26   2050                      Move.L    (A0), A0
8E28   0C50 000A                 Cmp       $A, (A0)
8E2C   660A                      BNE       L1353
8E2E   4868 0002                 Pea.L     $2(A0)
8E32   4EBA E210                 Jsr       P_mFrRect
8E36   603C                      Bra       L1354
8E38   42A7           L1353:     Clr.L     -(A7)
8E3A   4EBA 0046                 Jsr       P_tNewRgn
8E3E   2E1F                      Move.L    (A7)+, D7
8E40   2F2E 000E                 Move.L    $E(A6), -(A7)
8E44   2F07                      Move.L    D7, -(A7)
8E46   4EBA 00FA                 Jsr       P_tCopyRgn
8E4A   2F07                      Move.L    D7, -(A7)
8E4C   2F2B 0034                 Move.L    $34(A3), -(A7)
8E50   4EBA 01E8                 Jsr       P_tInsetRgn
8E54   2F2E 000E                 Move.L    $E(A6), -(A7)
8E58   2F07                      Move.L    D7, -(A7)
8E5A   2F07                      Move.L    D7, -(A7)
8E5C   4EBA 02DE                 Jsr       P_tDiffRgn
8E60   2F07                      Move.L    D7, -(A7)
8E62   3F2E 000C                 Move      $C(A6), -(A7)
8E66   2F2E 0008                 Move.L    $8(A6), -(A7)
8E6A   4EBA FF66                 Jsr       P_mDrawRgn
8E6E   2F07                      Move.L    D7, -(A7)
8E70   4EBA 0034                 Jsr       P_tDisposeRgn
8E74   4CDF 1880      L1354:     MoveM.L   (A7)+, D7/A3-A4
8E78   4E5E                      Unlk      A6
8E7A   205F                      Move.L    (A7)+, A0
8E7C   DEFC 000A                 AddA      $A, A7
8E80   4ED0                      Jmp       (A0)

                      P_tNewRgn:
8E82   48E7 1020                 MoveM.L   D3/A2, -(A7)
8E86   42A7                      Clr.L     -(A7)
8E88   3F3C 000A                 Move      $A, -(A7)
8E8C   4EBA 237A                 Jsr       P274
8E90   205F                      Move.L    (A7)+, A0
8E92   4CDF 0408                 MoveM.L   (A7)+, D3/A2
8E96   2F48 0004                 Move.L    A0, $4(A7)
8E9A   2050                      Move.L    (A0), A0
8E9C   30FC 000A                 Move      $A, (A0)+
8EA0   4298                      Clr.L     (A0)+
8EA2   4298                      Clr.L     (A0)+
8EA4   4E75                      Rts

                      P_tDisposeRgn:
8EA6   205F                      Move.L    (A7)+, A0
8EA8   225F                      Move.L    (A7)+, A1
8EAA   48E7 10A0                 MoveM.L   D3/A0/A2, -(A7)
8EAE   2F09                      Move.L    A1, -(A7)
8EB0   4EBA 2378                 Jsr       P276
8EB4   4CDF 0508                 MoveM.L   (A7)+, D3/A0/A2
8EB8   4ED0                      Jmp       (A0)

                      P_tOpenRgn:
8EBA   48E7 1038                 MoveM.L   D3/A2-A4, -(A7)
8EBE   2855                      Move.L    (A5), A4
8EC0   2054                      Move.L    (A4), A0
8EC2   217C 0000 0001            Move.L    $1, $60(A0)
       0060
8ECA   426C FF6A                 Clr       $-96(A4)
8ECE   42A7                      Clr.L     -(A7)
8ED0   3F3C 0100                 Move      $100, -(A7)
8ED4   3957 FF68                 Move      (A7), $-98(A4)
8ED8   4EBA 232E                 Jsr       P274
8EDC   295F FF6C                 Move.L    (A7)+, $-94(A4)
8EE0   4EBA D98C                 Jsr       P_tHidePen
8EE4   4CDF 1C08                 MoveM.L   (A7)+, D3/A2-A4
8EE8   4E75                      Rts

                      P_tCloseRgn:
8EEA   4E56 FFFE                 Link      A6, $-2
8EEE   48E7 1038                 MoveM.L   D3/A2-A4, -(A7)
8EF2   2855                      Move.L    (A5), A4
8EF4   2054                      Move.L    (A4), A0
8EF6   4AA8 0060                 Tst.L     $60(A0)
8EFA   673C                      BEQ       L1355
8EFC   42A8 0060                 Clr.L     $60(A0)
8F00   4EBA D976                 Jsr       P_tShowPen
8F04   302C FF6A                 Move      $-96(A4), D0
8F08   E448                      LsR       $2, D0
8F0A   3D40 FFFE                 Move      D0, $-2(A6)
8F0E   266C FF6C                 Move.L    $-94(A4), A3
8F12   2F13                      Move.L    (A3), -(A7)
8F14   3F00                      Move      D0, -(A7)
8F16   4EBA 08D4                 Jsr       P_mSortPoints
8F1A   2F13                      Move.L    (A3), -(A7)
8F1C   486E FFFE                 Pea.L     $-2(A6)
8F20   4EBA 0962                 Jsr       P_mCullPoints
8F24   2F0B                      Move.L    A3, -(A7)
8F26   3F2E FFFE                 Move      $-2(A6), -(A7)
8F2A   2F2E 0008                 Move.L    $8(A6), -(A7)
8F2E   4EBA 09A6                 Jsr       P_mPackRgn
8F32   2F0B                      Move.L    A3, -(A7)
8F34   4EBA 22F4                 Jsr       P276
8F38   4CDF 1C08      L1355:     MoveM.L   (A7)+, D3/A2-A4
8F3C   4E5E                      Unlk      A6
8F3E   2E9F                      Move.L    (A7)+, (A7)
8F40   4E75                      Rts

                      P_tCopyRgn:
8F42   4E56 0000                 Link      A6, $0
8F46   206E 000C                 Move.L    $C(A6), A0
8F4A   226E 0008                 Move.L    $8(A6), A1
8F4E   B3C8                      CmpA.L    A0, A1
8F50   6736                      BEQ       L1359
8F52   2050                      Move.L    (A0), A0
8F54   2251                      Move.L    (A1), A1
8F56   3010                      Move      (A0), D0
8F58   B051                      Cmp       (A1), D0
8F5A   671E                      BEQ       L1356
8F5C   48E7 9020                 MoveM.L   D0/D3/A2, -(A7)
8F60   2F2E 0008                 Move.L    $8(A6), -(A7)
8F64   3F00                      Move      D0, -(A7)
8F66   4EBA 22B4                 Jsr       P_mSetHSize
8F6A   4CDF 0409                 MoveM.L   (A7)+, D0/D3/A2
8F6E   206E 000C                 Move.L    $C(A6), A0
8F72   226E 0008                 Move.L    $8(A6), A1
8F76   2050                      Move.L    (A0), A0
8F78   2251                      Move.L    (A1), A1
8F7A   E448           L1356:     LsR       $2, D0
8F7C   6406                      BCC       L1358
8F7E   32D8                      Move      (A0)+, (A1)+
8F80   6002                      Bra       L1358
8F82   22D8           L1357:     Move.L    (A0)+, (A1)+
8F84   51C8 FFFC      L1358:     DBF       D0, L1357
8F88   4E5E           L1359:     Unlk      A6
8F8A   205F                      Move.L    (A7)+, A0
8F8C   504F                      AddQ      $8, A7
8F8E   4ED0                      Jmp       (A0)

                      P_tSetEmptyRgn:
8F90   205F                      Move.L    (A7)+, A0
8F92   42A7                      Clr.L     -(A7)
8F94   42A7                      Clr.L     -(A7)
8F96   2F08                      Move.L    A0, -(A7)
8F98   4EFA 0002                 Jmp       P_tSetRecRgn

                      P_tSetRecRgn:
8F9C   4E56 0000                 Link      A6, $0
8FA0   48E7 1020                 MoveM.L   D3/A2, -(A7)
8FA4   206E 0010                 Move.L    $10(A6), A0
8FA8   2250                      Move.L    (A0), A1
8FAA   0C51 000A                 Cmp       $A, (A1)
8FAE   6714                      BEQ       L1360
8FB0   2F08                      Move.L    A0, -(A7)
8FB2   3F3C 000A                 Move      $A, -(A7)
8FB6   4EBA 2264                 Jsr       P_mSetHSize
8FBA   206E 0010                 Move.L    $10(A6), A0
8FBE   2250                      Move.L    (A0), A1
8FC0   32BC 000A                 Move      $A, (A1)
8FC4   236E 000C 0002 L1360:     Move.L    $C(A6), $2(A1)
8FCA   236E 0008 0006            Move.L    $8(A6), $6(A1)
8FD0   3029 0004                 Move      $4(A1), D0
8FD4   B069 0008                 Cmp       $8(A1), D0
8FD8   6C0A                      BGE       L1361
8FDA   3029 0002                 Move      $2(A1), D0
8FDE   B069 0006                 Cmp       $6(A1), D0
8FE2   6D08                      BLT       L1362
8FE4   42A9 0002      L1361:     Clr.L     $2(A1)
8FE8   42A9 0006                 Clr.L     $6(A1)
8FEC   4CDF 0408      L1362:     MoveM.L   (A7)+, D3/A2
8FF0   4E5E                      Unlk      A6
8FF2   205F                      Move.L    (A7)+, A0
8FF4   DEFC 000C                 AddA      $C, A7
8FF8   4ED0                      Jmp       (A0)

                      P_tRectRgn:
8FFA   205F                      Move.L    (A7)+, A0
8FFC   225F                      Move.L    (A7)+, A1
8FFE   2F19                      Move.L    (A1)+, -(A7)
9000   2F19                      Move.L    (A1)+, -(A7)
9002   2F08                      Move.L    A0, -(A7)
9004   4EFA FF96                 Jmp       P_tSetRecRgn

                      P_tOffsetRgn:
9008   225F                      Move.L    (A7)+, A1
900A   321F                      Move      (A7)+, D1
900C   301F                      Move      (A7)+, D0
900E   205F                      Move.L    (A7)+, A0
9010   2050                      Move.L    (A0), A0
9012   5448                      AddQ      $2, A0
9014   D358                      Add       D1, (A0)+
9016   D158                      Add       D0, (A0)+
9018   D358                      Add       D1, (A0)+
901A   D158                      Add       D0, (A0)+
901C   0C68 000A FFF6            Cmp       $A, $-A(A0)
9022   6714                      BEQ       L1365
9024   D358           L1363:     Add       D1, (A0)+
9026   D158           L1364:     Add       D0, (A0)+
9028   D158                      Add       D0, (A0)+
902A   0C50 7FFF                 Cmp       $7FFF, (A0)
902E   66F6                      BNE       L1364
9030   5448                      AddQ      $2, A0
9032   0C50 7FFF                 Cmp       $7FFF, (A0)
9036   66EC                      BNE       L1363
9038   4ED1           L1365:     Jmp       (A1)

                      P_tInsetRgn:
903A   4E56 0000                 Link      A6, $0
903E   48E7 1F38                 MoveM.L   D3-D7/A2-A4, -(A7)
9042   2C2E 0008                 Move.L    $8(A6), D6
9046   6700 008C                 BEQ       L1371
904A   286E 000C                 Move.L    $C(A6), A4
904E   2654                      Move.L    (A4), A3
9050   3E1B                      Move      (A3)+, D7
9052   0C47 000A                 Cmp       $A, D7
9056   6624                      BNE       L1367
9058   2F0B                      Move.L    A3, -(A7)
905A   2F06                      Move.L    D6, -(A7)
905C   4EBA E12E                 Jsr       P_tInsetRect
9060   302B 0002                 Move      $2(A3), D0
9064   B06B 0006                 Cmp       $6(A3), D0
9068   6C0A                      BGE       L1366
906A   3013                      Move      (A3), D0
906C   B06B 0004                 Cmp       $4(A3), D0
9070   6D00 0062                 BLT       L1371
9074   429B           L1366:     Clr.L     (A3)+
9076   429B                      Clr.L     (A3)+
9078   6000 005A                 Bra       L1371
907C   DE47           L1367:     Add       D7, D7
907E   42A7                      Clr.L     -(A7)
9080   3F07                      Move      D7, -(A7)
9082   4EBA 2184                 Jsr       P274
9086   265F                      Move.L    (A7)+, A3
9088   6108                      Bsr       P237
908A   4846                      Swap      D6
908C   6104                      Bsr       P237
908E   6000 003E                 Bra       L1370

                      P237:
9092   4267                      Clr       -(A7)
9094   2F0C                      Move.L    A4, -(A7)
9096   2F0C                      Move.L    A4, -(A7)
9098   2F0B                      Move.L    A3, -(A7)
909A   3F07                      Move      D7, -(A7)
909C   3F3C 0008                 Move      $8, -(A7)
90A0   3F06                      Move      D6, -(A7)
90A2   50E7                      ST.B      -(A7)
90A4   4EBA 04A8                 Jsr       P_mRgnOp
90A8   3A1F                      Move      (A7)+, D5
90AA   2053                      Move.L    (A3), A0
90AC   3205                      Move      D5, D1
90AE   6006                      Bra       L1369
90B0   2010           L1368:     Move.L    (A0), D0
90B2   4840                      Swap      D0
90B4   20C0                      Move.L    D0, (A0)+
90B6   51C9 FFF8      L1369:     DBF       D1, L1368
90BA   2F13                      Move.L    (A3), -(A7)
90BC   3F05                      Move      D5, -(A7)
90BE   4EBA 072C                 Jsr       P_mSortPoints
90C2   2F0B                      Move.L    A3, -(A7)
90C4   3F05                      Move      D5, -(A7)
90C6   2F0C                      Move.L    A4, -(A7)
90C8   4EBA 080C                 Jsr       P_mPackRgn
90CC   4E75                      Rts
90CE   2F0B           L1370:     Move.L    A3, -(A7)
90D0   4EBA 2158                 Jsr       P276
90D4   4CDF 1CF8      L1371:     MoveM.L   (A7)+, D3-D7/A2-A4
90D8   4E5E                      Unlk      A6
90DA   205F                      Move.L    (A7)+, A0
90DC   504F                      AddQ      $8, A7
90DE   4ED0                      Jmp       (A0)

                      P_tEmptyRgn:
90E0   205F                      Move.L    (A7)+, A0
90E2   225F                      Move.L    (A7)+, A1
90E4   2251                      Move.L    (A1), A1
90E6   4869 0002                 Pea.L     $2(A1)
90EA   2F08                      Move.L    A0, -(A7)
90EC   4EFA E072                 Jmp       P_tEmptyRect

                      P_tEqualRgn:
90F0   206F 0004                 Move.L    $4(A7), A0
90F4   226F 0008                 Move.L    $8(A7), A1
90F8   B3C8                      CmpA.L    A0, A1
90FA   6722                      BEQ       L1374
90FC   2050                      Move.L    (A0), A0
90FE   2251                      Move.L    (A1), A1
9100   3010                      Move      (A0), D0
9102   3200                      Move      D0, D1
9104   E449                      LsR       $2, D1
9106   5341                      SubQ.L    $1, D1
9108   B388           L1372:     CmpM.L    (A0)+, (A1)+
910A   56C9 FFFC                 DBNE      D1, L1372
910E   6616                      BNE       L1375
9110   0240 0003                 And       $3, D0
9114   6708                      BEQ       L1374
9116   B308           L1373:     CmpM.B    (A0)+, (A1)+
9118   660C                      BNE       L1375
911A   5340                      SubQ.L    $1, D0
911C   66F8                      BNE       L1373
911E   1F7C 0001 000C L1374:     Move.B    $1, $C(A7)
9124   6004                      Bra       L1376
9126   422F 000C      L1375:     Clr.B     $C(A7)
912A   205F           L1376:     Move.L    (A7)+, A0
912C   504F                      AddQ      $8, A7
912E   4ED0                      Jmp       (A0)

                      P_tSectRgn:
9130   7000                      MoveQ.L   $0, D0
9132   4EFA 0014                 Jmp       P_mDoRgnOp

                      P_tUnionRgn:
9136   7004                      MoveQ.L   $4, D0
9138   4EFA 000E                 Jmp       P_mDoRgnOp

                      P_tDiffRgn:
913C   7002                      MoveQ.L   $2, D0
913E   4EFA 0008                 Jmp       P_mDoRgnOp

                      P_tXOrRgn:
9142   7006                      MoveQ.L   $6, D0
9144   4EFA 0002                 Jmp       P_mDoRgnOp
                      P_mDoRgnOp:
9148   4E56 FFF8                 Link      A6, $-8
914C   48E7 1F38                 MoveM.L   D3-D7/A2-A4, -(A7)
9150   3A00                      Move      D0, D5
9152   246E 0010                 Move.L    $10(A6), A2
9156   266E 000C                 Move.L    $C(A6), A3
915A   286E 0008                 Move.L    $8(A6), A4
915E   4227                      Clr.B     -(A7)
9160   2F0A                      Move.L    A2, -(A7)
9162   2F0B                      Move.L    A3, -(A7)
9164   4EBA FF8A                 Jsr       P_tEqualRgn
9168   4A1F                      Tst.B     (A7)+
916A   671C                      BEQ       L1380
916C   0245 0002                 And       $2, D5
9170   660C                      BNE       L1379
9172   2F0A           L1378:     Move.L    A2, -(A7)
9174   2F0C                      Move.L    A4, -(A7)
9176   4EBA FDCA                 Jsr       P_tCopyRgn
917A   6000 00B4                 Bra       L1385
917E   2F0C           L1379:     Move.L    A4, -(A7)
9180   4EBA FE0E                 Jsr       P_tSetEmptyRgn
9184   6000 00AA                 Bra       L1385
9188   2052           L1380:     Move.L    (A2), A0
918A   2253                      Move.L    (A3), A1
918C   0C45 0002                 Cmp       $2, D5
9190   6E4A                      BGT       L1383
9192   6D0A                      BLT       L1381
9194   3029 0004                 Move      $4(A1), D0
9198   B069 0008                 Cmp       $8(A1), D0
919C   6CD4                      BGE       L1378
919E   4868 0002      L1381:     Pea.L     $2(A0)
91A2   4869 0002                 Pea.L     $2(A1)
91A6   3F3C 0002                 Move      $2, -(A7)
91AA   486E FFF8                 Pea.L     $-8(A6)
91AE   4EBA E018                 Jsr       P_mRSect
91B2   6606                      BNE       L1382
91B4   4A45                      Tst       D5
91B6   67C6                      BEQ       L1379
91B8   60B8                      Bra       L1378
91BA   2052           L1382:     Move.L    (A2), A0
91BC   2253                      Move.L    (A3), A1
91BE   4A45                      Tst       D5
91C0   6634                      BNE       L1384
91C2   0C50 000A                 Cmp       $A, (A0)
91C6   662E                      BNE       L1384
91C8   0C51 000A                 Cmp       $A, (A1)
91CC   6628                      BNE       L1384
91CE   2F0C                      Move.L    A4, -(A7)
91D0   486E FFF8                 Pea.L     $-8(A6)
91D4   4EBA FE24                 Jsr       P_tRectRgn
91D8   6000 0056                 Bra       L1385
91DC   3029 0004      L1383:     Move      $4(A1), D0
91E0   B069 0008                 Cmp       $8(A1), D0
91E4   6C8C                      BGE       L1378
91E6   3028 0004                 Move      $4(A0), D0
91EA   B068 0008                 Cmp       $8(A0), D0
91EE   6D06                      BLT       L1384
91F0   244B                      Move.L    A3, A2
91F2   6000 FF7E                 Bra       L1378
91F6   3810           L1384:     Move      (A0), D4
91F8   D851                      Add       (A1), D4
91FA   D844                      Add       D4, D4
91FC   42A7                      Clr.L     -(A7)
91FE   3F04                      Move      D4, -(A7)
9200   4EBA 2006                 Jsr       P274
9204   265F                      Move.L    (A7)+, A3
9206   4267                      Clr       -(A7)
9208   2F2E 0010                 Move.L    $10(A6), -(A7)
920C   2F2E 000C                 Move.L    $C(A6), -(A7)
9210   2F0B                      Move.L    A3, -(A7)
9212   3F04                      Move      D4, -(A7)
9214   3F05                      Move      D5, -(A7)
9216   4267                      Clr       -(A7)
9218   50E7                      ST.B      -(A7)
921A   4EBA 0332                 Jsr       P_mRgnOp
921E   3C1F                      Move      (A7)+, D6
9220   2F0B                      Move.L    A3, -(A7)
9222   3F06                      Move      D6, -(A7)
9224   2F0C                      Move.L    A4, -(A7)
9226   4EBA 06AE                 Jsr       P_mPackRgn
922A   2F0B                      Move.L    A3, -(A7)
922C   4EBA 1FFC                 Jsr       P276
9230   4CDF 1CF8      L1385:     MoveM.L   (A7)+, D3-D7/A2-A4
9234   4E5E                      Unlk      A6
9236   205F                      Move.L    (A7)+, A0
9238   DEFC 000C                 AddA      $C, A7
923C   4ED0                      Jmp       (A0)

                      P_tPtInRgn:
923E   4E56 0000                 Link      A6, $0
9242   2F03                      Move.L    D3, -(A7)
9244   322E 000E                 Move      $E(A6), D1
9248   342E 000C                 Move      $C(A6), D2
924C   4243                      Clr       D3
924E   206E 0008                 Move.L    $8(A6), A0
9252   2050                      Move.L    (A0), A0
9254   B268 0004                 Cmp       $4(A0), D1
9258   6D34                      BLT       L1389
925A   B268 0008                 Cmp       $8(A0), D1
925E   6C2E                      BGE       L1389
9260   B468 0002                 Cmp       $2(A0), D2
9264   6D28                      BLT       L1389
9266   B468 0006                 Cmp       $6(A0), D2
926A   6C22                      BGE       L1389
926C   0C50 000A                 Cmp       $A, (A0)
9270   6604                      BNE       L1386
9272   4643                      Not       D3
9274   6018                      Bra       L1389
9276   41E8 000A      L1386:     Lea.L     $A(A0), A0
927A   B458           L1387:     Cmp       (A0)+, D2
927C   6D10                      BLT       L1389
927E   3018           L1388:     Move      (A0)+, D0
9280   0C40 7FFF                 Cmp       $7FFF, D0
9284   67F4                      BEQ       L1387
9286   B041                      Cmp       D1, D0
9288   6EF4                      BGT       L1388
928A   4643                      Not       D3
928C   60F0                      Bra       L1388
928E   4403           L1389:     Neg.B     D3
9290   1D43 0010                 Move.B    D3, $10(A6)
9294   261F                      Move.L    (A7)+, D3
9296   4E5E                      Unlk      A6
9298   205F                      Move.L    (A7)+, A0
929A   504F                      AddQ      $8, A7
929C   4ED0                      Jmp       (A0)

                      P_tRectInRgn:
929E   4E56 FFDC                 Link      A6, $-24
92A2   48E7 FF7C                 MoveM.L   D0-D7/A1-A5, -(A7)
92A6   2D4F FFF4                 Move.L    A7, $-C(A6)
92AA   422E 0010                 Clr.B     $10(A6)
92AE   226E 0008                 Move.L    $8(A6), A1
92B2   2251                      Move.L    (A1), A1
92B4   2F2E 000C                 Move.L    $C(A6), -(A7)
92B8   4869 0002                 Pea.L     $2(A1)
92BC   3F3C 0002                 Move      $2, -(A7)
92C0   486E FFF8                 Pea.L     $-8(A6)
92C4   4EBA DF02                 Jsr       P_mRSect
92C8   6700 0050                 BEQ       L1393
92CC   0C51 000A                 Cmp       $A, (A1)
92D0   6700 0044                 BEQ       L1392
92D4   2049                      Move.L    A1, A0
92D6   43EE FFDC                 Lea.L     $-24(A6), A1
92DA   302E FFFA                 Move      $-6(A6), D0
92DE   322E FFFE                 Move      $-2(A6), D1
92E2   3400                      Move      D0, D2
92E4   4EBA 0164                 Jsr       P_mInitRgn
92E8   3A29 0014                 Move      $14(A1), D5
92EC   EA4D                      LsR       $5, D5
92EE   302E FFF8                 Move      $-8(A6), D0
92F2   4EBA 018E                 Jsr       P_mSeekRgn
92F6   3C2E FFFC                 Move      $-4(A6), D6
92FA   2069 0008      L1390:     Move.L    $8(A1), A0
92FE   3005                      Move      D5, D0
9300   4A98           L1391:     Tst.L     (A0)+
9302   56C8 FFFC                 DBNE      D0, L1391
9306   660E                      BNE       L1392
9308   3029 0010                 Move      $10(A1), D0
930C   BC40                      Cmp       D0, D6
930E   6F0A                      BLE       L1393
9310   4EBA 0170                 Jsr       P_mSeekRgn
9314   60E4                      Bra       L1390
9316   522E 0010      L1392:     AddQ      $1, $10(A6)
931A   2E6E FFF4      L1393:     Move.L    $-C(A6), A7
931E   4CDF 3EFF                 MoveM.L   (A7)+, D0-D7/A1-A5
9322   4E5E                      Unlk      A6
9324   205F                      Move.L    (A7)+, A0
9326   504F                      AddQ      $8, A7
9328   4ED0                      Jmp       (A0)

                      P_mTrimRect:
932A   4E56 FFD6                 Link      A6, $-2A
932E   48E7 FF78                 MoveM.L   D0-D7/A1-A4, -(A7)
9332   422E 0010                 Clr.B     $10(A6)
9336   41EE FFE8                 Lea.L     $-18(A6), A0
933A   2D48 FFE4                 Move.L    A0, $-1C(A6)
933E   43EE FFDA                 Lea.L     $-26(A6), A1
9342   2D49 FFD6                 Move.L    A1, $-2A(A6)
9346   32FC 000A                 Move      $A, (A1)+
934A   206E 0008                 Move.L    $8(A6), A0
934E   22D8                      Move.L    (A0)+, (A1)+
9350   22D8                      Move.L    (A0)+, (A1)+
9352   4267                      Clr       -(A7)
9354   2F2E 000C                 Move.L    $C(A6), -(A7)
9358   486E FFD6                 Pea.L     $-2A(A6)
935C   486E FFE4                 Pea.L     $-1C(A6)
9360   3F3C 0018                 Move      $18, -(A7)
9364   42A7                      Clr.L     -(A7)
9366   4227                      Clr.B     -(A7)
9368   4EBA 01E4                 Jsr       P_mRgnOp
936C   206E 0008                 Move.L    $8(A6), A0
9370   0C5F 0004                 Cmp       $4, (A7)+
9374   6E14                      BGT       L1396
9376   6D0A                      BLT       L1394
9378   20EE FFE8                 Move.L    $-18(A6), (A0)+
937C   20EE FFF4                 Move.L    $-C(A6), (A0)+
9380   6004                      Bra       L1395
9382   4298           L1394:     Clr.L     (A0)+
9384   4298                      Clr.L     (A0)+
9386   522E 0010      L1395:     AddQ      $1, $10(A6)
938A   4CDF 1EFF      L1396:     MoveM.L   (A7)+, D0-D7/A1-A4
938E   4E5E                      Unlk      A6
9390   205F                      Move.L    (A7)+, A0
9392   504F                      AddQ      $8, A7
9394   4ED0                      Jmp       (A0)

                      P_tMapRgn:
9396   4E56 FFFA                 Link      A6, $-6
939A   48E7 1338                 MoveM.L   D3/D6-D7/A2-A4, -(A7)
939E   206E 000C                 Move.L    $C(A6), A0
93A2   226E 0008                 Move.L    $8(A6), A1
93A6   B388                      CmpM.L    (A0)+, (A1)+
93A8   6606                      BNE       L1397
93AA   B388                      CmpM.L    (A0)+, (A1)+
93AC   6700 008E                 BEQ       L1401
93B0   286E 0010      L1397:     Move.L    $10(A6), A4
93B4   2054                      Move.L    (A4), A0
93B6   0C50 000A                 Cmp       $A, (A0)
93BA   6612                      BNE       L1398
93BC   4868 0002                 Pea.L     $2(A0)
93C0   2F2E 000C                 Move.L    $C(A6), -(A7)
93C4   2F2E 0008                 Move.L    $8(A6), -(A7)
93C8   4EBA 1E26                 Jsr       P_tMapRect
93CC   606E                      Bra       L1401
93CE   42A7           L1398:     Clr.L     -(A7)
93D0   3F3C 0100                 Move      $100, -(A7)
93D4   4EBA 1E32                 Jsr       P274
93D8   265F                      Move.L    (A7)+, A3
93DA   426E FFFE                 Clr       $-2(A6)
93DE   3D7C 0100 FFFC            Move      $100, $-4(A6)
93E4   2F0C                      Move.L    A4, -(A7)
93E6   2F0B                      Move.L    A3, -(A7)
93E8   486E FFFE                 Pea.L     $-2(A6)
93EC   486E FFFC                 Pea.L     $-4(A6)
93F0   4EBA 05B6                 Jsr       P_mPutRgn
93F4   3E2E FFFE                 Move      $-2(A6), D7
93F8   E44F                      LsR       $2, D7
93FA   3C07                      Move      D7, D6
93FC   2453                      Move.L    (A3), A2
93FE   6010                      Bra       L1400
9400   2F0A           L1399:     Move.L    A2, -(A7)
9402   2F2E 000C                 Move.L    $C(A6), -(A7)
9406   2F2E 0008                 Move.L    $8(A6), -(A7)
940A   4EBA 1D82                 Jsr       P_tMapPt
940E   588A                      AddQ      $4, A2
9410   51CE FFEE      L1400:     DBF       D6, L1399
9414   2F13                      Move.L    (A3), -(A7)
9416   3F07                      Move      D7, -(A7)
9418   4EBA 03D2                 Jsr       P_mSortPoints
941C   2F13                      Move.L    (A3), -(A7)
941E   3D47 FFFA                 Move      D7, $-6(A6)
9422   486E FFFA                 Pea.L     $-6(A6)
9426   4EBA 045C                 Jsr       P_mCullPoints
942A   2F0B                      Move.L    A3, -(A7)
942C   3F2E FFFA                 Move      $-6(A6), -(A7)
9430   2F0C                      Move.L    A4, -(A7)
9432   4EBA 04A2                 Jsr       P_mPackRgn
9436   2F0B                      Move.L    A3, -(A7)
9438   4EBA 1DF0                 Jsr       P276
943C   4CDF 1CC8      L1401:     MoveM.L   (A7)+, D3/D6-D7/A2-A4
9440   4E5E                      Unlk      A6
9442   205F                      Move.L    (A7)+, A0
9444   DEFC 000C                 AddA      $C, A7
9448   4ED0                      Jmp       (A0)

                      P_mInitRgn:
944A   3340 0012                 Move      D0, $12(A1)
944E   3341 0014                 Move      D1, $14(A1)
9452   3342 0016                 Move      D2, $16(A1)
9456   2288                      Move.L    A0, (A1)
9458   337C 8001 000E            Move      $-7FFF, $E(A1)
945E   3368 0002 0010            Move      $2(A0), $10(A1)
9464   41E8 000A                 Lea.L     $A(A0), A0
9468   2348 0004                 Move.L    A0, $4(A1)
946C   205F                      Move.L    (A7)+, A0
946E   9242                      Sub       D2, D1
9470   EA49                      LsR       $5, D1
9472   3341 000C                 Move      D1, $C(A1)
9476   42A7           L1402:     Clr.L     -(A7)
9478   51C9 FFFC                 DBF       D1, L1402
947C   234F 0008                 Move.L    A7, $8(A1)
9480   4ED0                      Jmp       (A0)

                      P_mSeekRgn:
9482   B069 0010                 Cmp       $10(A1), D0
9486   6C36                      BGE       L1405
9488   B069 000E                 Cmp       $E(A1), D0
948C   6D04                      BLT       L1403
948E   4241                      Clr       D1
9490   4E75                      Rts
9492   2069 0008      L1403:     Move.L    $8(A1), A0
9496   3229 000C                 Move      $C(A1), D1
949A   4298           L1404:     Clr.L     (A0)+
949C   51C9 FFFC                 DBF       D1, L1404
94A0   2051                      Move.L    (A1), A0
94A2   3368 0002 0010            Move      $2(A0), $10(A1)
94A8   337C 8001 000E            Move      $-7FFF, $E(A1)
94AE   41E8 000A                 Lea.L     $A(A0), A0
94B2   2348 0004                 Move.L    A0, $4(A1)
94B6   B069 0010                 Cmp       $10(A1), D0
94BA   6D00 008C                 BLT       L1415
94BE   48E7 FE30      L1405:     MoveM.L   D0-D6/A2-A3, -(A7)
94C2   3400                      Move      D0, D2
94C4   2469 0004                 Move.L    $4(A1), A2
94C8   335A 000E      L1406:     Move      (A2)+, $E(A1)
94CC   361A           L1407:     Move      (A2)+, D3
94CE   0C43 7FFF                 Cmp       $7FFF, D3
94D2   6762                      BEQ       L1414
94D4   381A                      Move      (A2)+, D4
94D6   B869 0012                 Cmp       $12(A1), D4
94DA   6FF0                      BLE       L1407
94DC   B669 0014                 Cmp       $14(A1), D3
94E0   6CEA                      BGE       L1407
94E2   B669 0012                 Cmp       $12(A1), D3
94E6   6C04                      BGE       L1408
94E8   3629 0012                 Move      $12(A1), D3
94EC   B869 0014      L1408:     Cmp       $14(A1), D4
94F0   6F04                      BLE       L1409
94F2   3829 0014                 Move      $14(A1), D4
94F6   9669 0016      L1409:     Sub       $16(A1), D3
94FA   9869 0016                 Sub       $16(A1), D4
94FE   3003                      Move      D3, D0
9500   4EBA BF90                 Jsr       P_mLeftMask
9504   3A00                      Move      D0, D5
9506   3004                      Move      D4, D0
9508   4EBA BF96                 Jsr       P_mRightMask
950C   3C00                      Move      D0, D6
950E   E84B                      LsR       $4, D3
9510   2669 0008                 Move.L    $8(A1), A3
9514   D6C3                      AddA      D3, A3
9516   D6C3                      AddA      D3, A3
9518   E84C                      LsR       $4, D4
951A   9843                      Sub       D3, D4
951C   6E06                      BGT       L1410
951E   CC45                      And       D5, D6
9520   BD53                      Eor       D6, (A3)
9522   60A8                      Bra       L1407
9524   BB5B           L1410:     Eor       D5, (A3)+
9526   6002                      Bra       L1412
9528   469B           L1411:     Not.L     (A3)+
952A   5544           L1412:     SubQ.L    $2, D4
952C   6EFA                      BGT       L1411
952E   6D02                      BLT       L1413
9530   465B                      Not       (A3)+
9532   BD53           L1413:     Eor       D6, (A3)
9534   6096                      Bra       L1407
9536   234A 0004      L1414:     Move.L    A2, $4(A1)
953A   3352 0010                 Move      (A2), $10(A1)
953E   B469 0010                 Cmp       $10(A1), D2
9542   6C84                      BGE       L1406
9544   4CDF 0C7F                 MoveM.L   (A7)+, D0-D6/A2-A3
9548   323C 0001      L1415:     Move      $1, D1
954C   4E75                      Rts

                      P_mRgnOp:
954E   4E56 FDCE                 Link      A6, $-232
9552   48E7 1F38                 MoveM.L   D3-D7/A2-A4, -(A7)
9556   45EE FDD2                 Lea.L     $-22E(A6), A2
955A   41EE 0018                 Lea.L     $18(A6), A0
955E   6100 017C                 Bsr       P244
9562   2648                      Move.L    A0, A3
9564   41EE 0014                 Lea.L     $14(A6), A0
9568   6100 0172                 Bsr       P244
956C   2848                      Move.L    A0, A4
956E   41FA 01EC                 Lea.L     P_mSectScan, A0
9572   302E 000C                 Move      $C(A6), D0
9576   671C                      BEQ       L1416
9578   41FA 01E8                 Lea.L     P_mDiffScan, A0
957C   5540                      SubQ.L    $2, D0
957E   6714                      BEQ       L1416
9580   41FA 01E4                 Lea.L     P_mUnionScan, A0
9584   5540                      SubQ.L    $2, D0
9586   670C                      BEQ       L1416
9588   41FA 01AE                 Lea.L     P_mXorScan, A0
958C   5540                      SubQ.L    $2, D0
958E   6704                      BEQ       L1416
9590   41FA 0216                 Lea.L     P_mInsetScan, A0
9594   2D48 FDCE      L1416:     Move.L    A0, $-232(A6)
9598   206E 0010                 Move.L    $10(A6), A0
959C   2050                      Move.L    (A0), A0
959E   2D48 FE02                 Move.L    A0, $-1FE(A6)
95A2   026E FFF8 000E            And       $-8, $E(A6)
95A8   D0EE 000E                 AddA      $E(A6), A0
95AC   2D48 FDFE                 Move.L    A0, $-202(A6)
95B0   41EE FF9C                 Lea.L     $-64(A6), A0
95B4   2808                      Move.L    A0, D4
95B6   30BC 7FFF                 Move      $7FFF, (A0)
95BA   41EE FF38                 Lea.L     $-C8(A6), A0
95BE   2A08                      Move.L    A0, D5
95C0   30BC 7FFF                 Move      $7FFF, (A0)
95C4   41EE FED4                 Lea.L     $-12C(A6), A0
95C8   2C08                      Move.L    A0, D6
95CA   30BC 7FFF                 Move      $7FFF, (A0)
95CE   41EE FE70                 Lea.L     $-190(A6), A0
95D2   2E08                      Move.L    A0, D7
95D4   3D5B FE0A                 Move      (A3)+, $-1F6(A6)
95D8   3D5C FE08                 Move      (A4)+, $-1F8(A6)
95DC   0C6E 0008 000C            Cmp       $8, $C(A6)
95E2   6606                      BNE       L1417
95E4   3D7C 7FFF FE08            Move      $7FFF, $-1F8(A6)
95EA   302E FE0A      L1417:     Move      $-1F6(A6), D0
95EE   B06E FE08                 Cmp       $-1F8(A6), D0
95F2   6708                      BEQ       L1418
95F4   6E12                      BGT       L1419
95F6   6100 00B0                 Bsr       P242
95FA   6010                      Bra       L1420
95FC   0C40 7FFF      L1418:     Cmp       $7FFF, D0
9600   6700 0118                 BEQ       L1426
9604   6100 00A2                 Bsr       P242
9608   6100 00B8      L1419:     Bsr       P243
960C   2044           L1420:     Move.L    D4, A0
960E   2245                      Move.L    D5, A1
9610   2447                      Move.L    D7, A2
9612   342E 000A                 Move      $A(A6), D2
9616   487A 0008                 Pea.L     E_393
961A   2F2E FDCE                 Move.L    $-232(A6), -(A7)
961E   4E75                      Rts

                      E_393:
9620   2047                      Move.L    D7, A0
9622   2246                      Move.L    D6, A1
9624   45EE FE0C                 Lea.L     $-1F4(A6), A2
9628   4EBA 010E                 Jsr       P_mXorScan
962C   CF46                      Exg.L     D7, D6
962E   41EE FE0C                 Lea.L     $-1F4(A6), A0
9632   226E FE02                 Move.L    $-1FE(A6), A1
9636   246E FDFE                 Move.L    $-202(A6), A2
963A   202E FE06                 Move.L    $-1FA(A6), D0
963E   6008                      Bra       L1422
9640   3018           L1421:     Move      (A0)+, D0
9642   22C0                      Move.L    D0, (A1)+
9644   3018                      Move      (A0)+, D0
9646   22C0                      Move.L    D0, (A1)+
9648   B3CA           L1422:     CmpA.L    A2, A1
964A   6500 004E                 BCS       L1423
964E   4A2E 0008                 Tst.B     $8(A6)
9652   6700 00C2                 BEQ       L1425
9656   2208                      Move.L    A0, D1
9658   206E 0018                 Move.L    $18(A6), A0
965C   97D0                      SubA.L    (A0), A3
965E   206E 0014                 Move.L    $14(A6), A0
9662   99D0                      SubA.L    (A0), A4
9664   206E 0010                 Move.L    $10(A6), A0
9668   93D0                      SubA.L    (A0), A1
966A   95D0                      SubA.L    (A0), A2
966C   D4FC 0100                 AddA      $100, A2
9670   48E7 FFE0                 MoveM.L   D0-D7/A0-A2, -(A7)
9674   2F08                      Move.L    A0, -(A7)
9676   3F0A                      Move      A2, -(A7)
9678   4EBA 1BA2                 Jsr       P_mSetHSize
967C   4CDF 07FF                 MoveM.L   (A7)+, D0-D7/A0-A2
9680   206E 0018                 Move.L    $18(A6), A0
9684   D7D0                      AddA.L    (A0), A3
9686   206E 0014                 Move.L    $14(A6), A0
968A   D9D0                      AddA.L    (A0), A4
968C   206E 0010                 Move.L    $10(A6), A0
9690   D3D0                      AddA.L    (A0), A1
9692   D5D0                      AddA.L    (A0), A2
9694   2D4A FDFE                 Move.L    A2, $-202(A6)
9698   2041                      Move.L    D1, A0
969A   0C50 7FFF      L1423:     Cmp       $7FFF, (A0)
969E   66A0                      BNE       L1421
96A0   2D49 FE02                 Move.L    A1, $-1FE(A6)
96A4   6000 FF44                 Bra       L1417

                      P242:
96A8   3D6E FE0A FE06            Move      $-1F6(A6), $-1FA(A6)
96AE   204B                      Move.L    A3, A0
96B0   2244                      Move.L    D4, A1
96B2   2447                      Move.L    D7, A2
96B4   4EBA 0082                 Jsr       P_mXorScan
96B8   2648                      Move.L    A0, A3
96BA   3D5B FE0A                 Move      (A3)+, $-1F6(A6)
96BE   C947                      Exg.L     D4, D7
96C0   4E75                      Rts

                      P243:
96C2   3D6E FE08 FE06            Move      $-1F8(A6), $-1FA(A6)
96C8   204C                      Move.L    A4, A0
96CA   2245                      Move.L    D5, A1
96CC   2447                      Move.L    D7, A2
96CE   4EBA 0068                 Jsr       P_mXorScan
96D2   2848                      Move.L    A0, A4
96D4   3D5C FE08                 Move      (A4)+, $-1F8(A6)
96D8   CF45                      Exg.L     D7, D5
96DA   4E75                      Rts

                      P244:
96DC   2250                      Move.L    (A0), A1
96DE   2251                      Move.L    (A1), A1
96E0   0C51 000A                 Cmp       $A, (A1)
96E4   662A                      BNE       L1424
96E6   208A                      Move.L    A2, (A0)
96E8   41EA FFFA                 Lea.L     $-6(A2), A0
96EC   24C8                      Move.L    A0, (A2)+
96EE   24E9 0002                 Move.L    $2(A1), (A2)+
96F2   34E9 0008                 Move      $8(A1), (A2)+
96F6   34FC 7FFF                 Move      $7FFF, (A2)+
96FA   34E9 0006                 Move      $6(A1), (A2)+
96FE   34E9 0004                 Move      $4(A1), (A2)+
9702   34E9 0008                 Move      $8(A1), (A2)+
9706   34FC 7FFF                 Move      $7FFF, (A2)+
970A   34FC 7FFF                 Move      $7FFF, (A2)+
970E   2248                      Move.L    A0, A1
9710   41E9 000A      L1424:     Lea.L     $A(A1), A0
9714   4E75                      Rts
9716   2D49 FE02      L1425:     Move.L    A1, $-1FE(A6)
971A   202E FE02      L1426:     Move.L    $-1FE(A6), D0
971E   206E 0010                 Move.L    $10(A6), A0
9722   9090                      Sub.L     (A0), D0
9724   E448                      LsR       $2, D0
9726   3D40 001C                 Move      D0, $1C(A6)
972A   4CDF 1CF8                 MoveM.L   (A7)+, D3-D7/A2-A4
972E   4E5E                      Unlk      A6
9730   205F                      Move.L    (A7)+, A0
9732   DEFC 0014                 AddA      $14, A7
9736   4ED0                      Jmp       (A0)

                      P_mXorScan:
9738   6006                      Bra       L1428
973A   0C40 7FFF      L1427:     Cmp       $7FFF, D0
973E   6716                      BEQ       L1431
9740   3018           L1428:     Move      (A0)+, D0
9742   3219                      Move      (A1)+, D1
9744   B041           L1429:     Cmp       D1, D0
9746   67F2                      BEQ       L1427
9748   6D06                      BLT       L1430
974A   34C1                      Move      D1, (A2)+
974C   3219                      Move      (A1)+, D1
974E   60F4                      Bra       L1429
9750   34C0           L1430:     Move      D0, (A2)+
9752   3018                      Move      (A0)+, D0
9754   60EE                      Bra       L1429
9756   34FC 7FFF      L1431:     Move      $7FFF, (A2)+
975A   4E75                      Rts

                      P_mSectScan:
975C   4242                      Clr       D2
975E   4243                      Clr       D3
9760   6008                      Bra       L1433

                      P_mDiffScan:
9762   4242                      Clr       D2
9764   6002                      Bra       L1432

                      P_mUnionScan:
9766   74FF                      MoveQ.L   $-1, D2
9768   76FF           L1432:     MoveQ.L   $-1, D3
976A   3018           L1433:     Move      (A0)+, D0
976C   3219                      Move      (A1)+, D1
976E   B041           L1434:     Cmp       D1, D0
9770   6D18                      BLT       L1436
9772   6E22                      BGT       L1438
9774   0C40 7FFF                 Cmp       $7FFF, D0
9778   6728                      BEQ       L1440
977A   B443                      Cmp       D3, D2
977C   6602                      BNE       L1435
977E   34C0                      Move      D0, (A2)+
9780   3018           L1435:     Move      (A0)+, D0
9782   4642                      Not       D2
9784   3219                      Move      (A1)+, D1
9786   4643                      Not       D3
9788   60E4                      Bra       L1434
978A   4A43           L1436:     Tst       D3
978C   6702                      BEQ       L1437
978E   34C0                      Move      D0, (A2)+
9790   3018           L1437:     Move      (A0)+, D0
9792   4642                      Not       D2
9794   60D8                      Bra       L1434
9796   4A42           L1438:     Tst       D2
9798   6702                      BEQ       L1439
979A   34C1                      Move      D1, (A2)+
979C   3219           L1439:     Move      (A1)+, D1
979E   4643                      Not       D3
97A0   60CC                      Bra       L1434
97A2   34FC 7FFF      L1440:     Move      $7FFF, (A2)+
97A6   4E75                      Rts

                      P_mInsetScan:
97A8   4A42                      Tst       D2
97AA   6D18                      BLT       L1442
97AC   0C50 7FFF      L1441:     Cmp       $7FFF, (A0)
97B0   6734                      BEQ       L1447
97B2   3018                      Move      (A0)+, D0
97B4   3218                      Move      (A0)+, D1
97B6   D042                      Add       D2, D0
97B8   9242                      Sub       D2, D1
97BA   B041                      Cmp       D1, D0
97BC   6CEE                      BGE       L1441
97BE   34C0                      Move      D0, (A2)+
97C0   34C1                      Move      D1, (A2)+
97C2   60E8                      Bra       L1441
97C4   327C 8001      L1442:     Move      $-7FFF, A1
97C8   6016                      Bra       L1446
97CA   3018           L1443:     Move      (A0)+, D0
97CC   3218                      Move      (A0)+, D1
97CE   D042                      Add       D2, D0
97D0   9242                      Sub       D2, D1
97D2   B049                      Cmp       A1, D0
97D4   6E04                      BGT       L1444
97D6   554A                      SubQ.L    $2, A2
97D8   6002                      Bra       L1445
97DA   34C0           L1444:     Move      D0, (A2)+
97DC   34C1           L1445:     Move      D1, (A2)+
97DE   3241                      Move      D1, A1
97E0   0C50 7FFF      L1446:     Cmp       $7FFF, (A0)
97E4   66E4                      BNE       L1443
97E6   34FC 7FFF      L1447:     Move      $7FFF, (A2)+
97EA   4E75                      Rts

                      P_mSortPoints:
97EC   4E56 0000                 Link      A6, $0
97F0   48E7 1838                 MoveM.L   D3-D4/A2-A4, -(A7)
97F4   266E 000A                 Move.L    $A(A6), A3
97F8   360B                      Move      A3, D3
97FA   0243 0003                 And       $3, D3
97FE   4280                      Clr.L     D0
9800   302E 0008                 Move      $8(A6), D0
9804   6F00 0072                 BLE       L1459
9808   E588                      LsL.L     $2, D0
980A   284B                      Move.L    A3, A4
980C   D9C0                      AddA.L    D0, A4
980E   594C                      SubQ.L    $4, A4
9810   280F                      Move.L    A7, D4
9812   48E7 0018                 MoveM.L   A3-A4, -(A7)
9816   4CDF 1800      L1448:     MoveM.L   (A7)+, A3-A4
981A   224B           L1449:     Move.L    A3, A1
981C   244C                      Move.L    A4, A2
981E   200B                      Move.L    A3, D0
9820   D08C                      Add.L     A4, D0
9822   E290                      RXR.L     $1, D0
9824   0240 FFFC                 And       $-4, D0
9828   8043                      Or        D3, D0
982A   2040                      Move.L    D0, A0
982C   3228 0002                 Move      $2(A0), D1
9830   3410                      Move      (A0), D2
9832   6002           L1450:     Bra       L1452
9834   5849           L1451:     AddQ      $4, A1
9836   B451           L1452:     Cmp       (A1), D2
9838   6EFA                      BGT       L1451
983A   6D06                      BLT       L1453
983C   B269 0002                 Cmp       $2(A1), D1
9840   6EF2                      BGT       L1451
9842   6002           L1453:     Bra       L1455
9844   594A           L1454:     SubQ.L    $4, A2
9846   B452           L1455:     Cmp       (A2), D2
9848   6DFA                      BLT       L1454
984A   6E06                      BGT       L1456
984C   B26A 0002                 Cmp       $2(A2), D1
9850   6DF2                      BLT       L1454
9852   B3CA           L1456:     CmpA.L    A2, A1
9854   6E0A                      BGT       L1457
9856   2011                      Move.L    (A1), D0
9858   2292                      Move.L    (A2), (A1)
985A   2480                      Move.L    D0, (A2)
985C   5849                      AddQ      $4, A1
985E   594A                      SubQ.L    $4, A2
9860   B3CA           L1457:     CmpA.L    A2, A1
9862   63CE                      BLS       L1450
9864   B3CC                      CmpA.L    A4, A1
9866   6400 0006                 BCC       L1458
986A   48E7 0048                 MoveM.L   A1/A4, -(A7)
986E   284A           L1458:     Move.L    A2, A4
9870   B7CC                      CmpA.L    A4, A3
9872   65A6                      BCS       L1449
9874   BFC4                      CmpA.L    D4, A7
9876   669E                      BNE       L1448
9878   4CDF 1C18      L1459:     MoveM.L   (A7)+, D3-D4/A2-A4
987C   4E5E                      Unlk      A6
987E   205F                      Move.L    (A7)+, A0
9880   5C4F                      AddQ      $6, A7
9882   4ED0                      Jmp       (A0)

                      P_mCullPoints:
9884   4E56 0000                 Link      A6, $0
9888   48E7 FF7C                 MoveM.L   D0-D7/A1-A5, -(A7)
988C   206E 0008                 Move.L    $8(A6), A0
9890   3010                      Move      (A0), D0
9892   6F00 0036                 BLE       L1464
9896   226E 000C                 Move.L    $C(A6), A1
989A   2649                      Move.L    A1, A3
989C   48C0                      Ext.L     D0
989E   E588                      LsL.L     $2, D0
98A0   D7C0                      AddA.L    D0, A3
98A2   594B                      SubQ.L    $4, A3
98A4   2A09                      Move.L    A1, D5
98A6   2449                      Move.L    A1, A2
98A8   600C                      Bra       L1462
98AA   5849           L1460:     AddQ      $4, A1
98AC   6008                      Bra       L1462
98AE   2019           L1461:     Move.L    (A1)+, D0
98B0   B091                      Cmp.L     (A1), D0
98B2   67F6                      BEQ       L1460
98B4   24C0                      Move.L    D0, (A2)+
98B6   B3CB           L1462:     CmpA.L    A3, A1
98B8   6DF4                      BLT       L1461
98BA   6E02                      BGT       L1463
98BC   24D9                      Move.L    (A1)+, (A2)+
98BE   200A           L1463:     Move.L    A2, D0
98C0   9085                      Sub.L     D5, D0
98C2   E448                      LsR       $2, D0
98C4   206E 0008                 Move.L    $8(A6), A0
98C8   3080                      Move      D0, (A0)
98CA   4CDF 3EFF      L1464:     MoveM.L   (A7)+, D0-D7/A1-A5
98CE   4E5E                      Unlk      A6
98D0   205F                      Move.L    (A7)+, A0
98D2   504F                      AddQ      $8, A7
98D4   4ED0                      Jmp       (A0)

                      P_mPackRgn:
98D6   4E56 FFF8                 Link      A6, $-8
98DA   48E7 FF78                 MoveM.L   D0-D7/A1-A4, -(A7)
98DE   286E 000E                 Move.L    $E(A6), A4
98E2   266E 0008                 Move.L    $8(A6), A3
98E6   3C2E 000C                 Move      $C(A6), D6
98EA   2253                      Move.L    (A3), A1
98EC   3A11                      Move      (A1), D5
98EE   2054                      Move.L    (A4), A0
98F0   3E3C 000A                 Move      $A, D7
98F4   42AE FFF8                 Clr.L     $-8(A6)
98F8   42AE FFFC                 Clr.L     $-4(A6)
98FC   0C46 0004                 Cmp       $4, D6
9900   6E12                      BGT       L1465
9902   6D00 007E                 BLT       L1472
9906   2D50 FFF8                 Move.L    (A0), $-8(A6)
990A   2D68 000C FFFC            Move.L    $C(A0), $-4(A6)
9910   6000 0070                 Bra       L1472
9914   3D50 FFF8      L1465:     Move      (A0), $-8(A6)
9918   3228 0002                 Move      $2(A0), D1
991C   3401                      Move      D1, D2
991E   3606                      Move      D6, D3
9920   5343           L1466:     SubQ.L    $1, D3
9922   6D12                      BLT       L1468
9924   2018                      Move.L    (A0)+, D0
9926   B041                      Cmp       D1, D0
9928   6C04                      BGE       L1467
992A   3200                      Move      D0, D1
992C   60F2                      Bra       L1466
992E   B042           L1467:     Cmp       D2, D0
9930   6FEE                      BLE       L1466
9932   3400                      Move      D0, D2
9934   60EA                      Bra       L1466
9936   3D41 FFFA      L1468:     Move      D1, $-6(A6)
993A   3D42 FFFE                 Move      D2, $-2(A6)
993E   3D68 FFFC FFFC            Move      $-4(A0), $-4(A6)
9944   7A03                      MoveQ.L   $3, D5
9946   DA46                      Add       D6, D5
9948   E54D                      LsL       $2, D5
994A   2F0B                      Move.L    A3, -(A7)
994C   3F05                      Move      D5, -(A7)
994E   4EBA 18CC                 Jsr       P_mSetHSize
9952   2054                      Move.L    (A4), A0
9954   2253                      Move.L    (A3), A1
9956   D2FC 000A                 AddA      $A, A1
995A   5346                      SubQ.L    $1, D6
995C   3018                      Move      (A0)+, D0
995E   600C                      Bra       L1470
9960   B058           L1469:     Cmp       (A0)+, D0
9962   670A                      BEQ       L1471
9964   32FC 7FFF                 Move      $7FFF, (A1)+
9968   3028 FFFE                 Move      $-2(A0), D0
996C   32C0           L1470:     Move      D0, (A1)+
996E   32D8           L1471:     Move      (A0)+, (A1)+
9970   51CE FFEE                 DBF       D6, L1469
9974   32FC 7FFF                 Move      $7FFF, (A1)+
9978   32FC 7FFF                 Move      $7FFF, (A1)+
997C   2053                      Move.L    (A3), A0
997E   93C8                      SubA.L    A0, A1
9980   3E09                      Move      A1, D7
9982   2053           L1472:     Move.L    (A3), A0
9984   30C7                      Move      D7, (A0)+
9986   20EE FFF8                 Move.L    $-8(A6), (A0)+
998A   20EE FFFC                 Move.L    $-4(A6), (A0)+
998E   BA47                      Cmp       D7, D5
9990   6708                      BEQ       L1473
9992   2F0B                      Move.L    A3, -(A7)
9994   3F07                      Move      D7, -(A7)
9996   4EBA 1884                 Jsr       P_mSetHSize
999A   4CDF 1EFF      L1473:     MoveM.L   (A7)+, D0-D7/A1-A4
999E   4E5E                      Unlk      A6
99A0   205F                      Move.L    (A7)+, A0
99A2   DEFC 000A                 AddA      $A, A7
99A6   4ED0                      Jmp       (A0)

                      P_mPutRgn:
99A8   4E56 0000                 Link      A6, $0
99AC   48E7 0138                 MoveM.L   D7/A2-A4, -(A7)
99B0   286E 0010                 Move.L    $10(A6), A4
99B4   266E 0014                 Move.L    $14(A6), A3
99B8   246E 000C                 Move.L    $C(A6), A2
99BC   2053                      Move.L    (A3), A0
99BE   3E10                      Move      (A0), D7
99C0   DE47                      Add       D7, D7
99C2   DE52                      Add       (A2), D7
99C4   226E 0008                 Move.L    $8(A6), A1
99C8   BE51                      Cmp       (A1), D7
99CA   6F14                      BLE       L1474
99CC   0647 0100                 Add       $100, D7
99D0   3287                      Move      D7, (A1)
99D2   2F0C                      Move.L    A4, -(A7)
99D4   3F07                      Move      D7, -(A7)
99D6   4EBA 1844                 Jsr       P_mSetHSize
99DA   2053                      Move.L    (A3), A0
99DC   246E 000C                 Move.L    $C(A6), A2
99E0   2254           L1474:     Move.L    (A4), A1
99E2   D2D2                      AddA      (A2), A1
99E4   0C50 000A                 Cmp       $A, (A0)
99E8   6608                      BNE       L1475
99EA   5448                      AddQ      $2, A0
99EC   22D8                      Move.L    (A0)+, (A1)+
99EE   22D8                      Move.L    (A0)+, (A1)+
99F0   601A                      Bra       L1478
99F2   41E8 000A      L1475:     Lea.L     $A(A0), A0
99F6   2E18           L1476:     Move.L    (A0)+, D7
99F8   22C7           L1477:     Move.L    D7, (A1)+
99FA   3E18                      Move      (A0)+, D7
99FC   22C7                      Move.L    D7, (A1)+
99FE   3E18                      Move      (A0)+, D7
9A00   0C47 7FFF                 Cmp       $7FFF, D7
9A04   66F2                      BNE       L1477
9A06   0C50 7FFF                 Cmp       $7FFF, (A0)
9A0A   66EA                      BNE       L1476
9A0C   93D4           L1478:     SubA.L    (A4), A1
9A0E   3489                      Move      A1, (A2)
9A10   4CDF 1C80                 MoveM.L   (A7)+, D7/A2-A4
9A14   4E5E                      Unlk      A6
9A16   205F                      Move.L    (A7)+, A0
9A18   DEFC 0010                 AddA      $10, A7
9A1C   4ED0                      Jmp       (A0)

                      P_tStdBits:
9A1E   4E56 FEEA                 Link      A6, $-116
9A22   48E7 1F38                 MoveM.L   D3-D7/A2-A4, -(A7)
9A26   4EBA 163A                 Jsr       P_mCheckPic
9A2A   6F00 013A                 BLE       L1491
9A2E   206E 0016                 Move.L    $16(A6), A0
9A32   43EE FFF2                 Lea.L     $-E(A6), A1
9A36   2650                      Move.L    (A0), A3
9A38   3828 0004                 Move      $4(A0), D4
9A3C   2368 0006 0006            Move.L    $6(A0), $6(A1)
9A42   2368 000A 000A            Move.L    $A(A0), $A(A1)
9A48   206E 0012                 Move.L    $12(A6), A0
9A4C   3010                      Move      (A0), D0
9A4E   9069 0006                 Sub       $6(A1), D0
9A52   6F08                      BLE       L1479
9A54   D169 0006                 Add       D0, $6(A1)
9A58   C0C4                      MulU      D4, D0
9A5A   D7C0                      AddA.L    D0, A3
9A5C   3028 0004      L1479:     Move      $4(A0), D0
9A60   B069 000A                 Cmp       $A(A1), D0
9A64   6C04                      BGE       L1480
9A66   3340 000A                 Move      D0, $A(A1)
9A6A   3028 0002      L1480:     Move      $2(A0), D0
9A6E   9069 0008                 Sub       $8(A1), D0
9A72   6F0A                      BLE       L1481
9A74   E648                      LsR       $3, D0
9A76   D6C0                      AddA      D0, A3
9A78   E748                      LsL       $3, D0
9A7A   D169 0008                 Add       D0, $8(A1)
9A7E   3028 0006      L1481:     Move      $6(A0), D0
9A82   9069 0008                 Sub       $8(A1), D0
9A86   5E40                      AddQ      $7, D0
9A88   E648                      LsR       $3, D0
9A8A   E748                      LsL       $3, D0
9A8C   D069 0008                 Add       $8(A1), D0
9A90   B069 000C                 Cmp       $C(A1), D0
9A94   6C04                      BGE       L1482
9A96   3340 000C                 Move      D0, $C(A1)
9A9A   3A29 000C      L1482:     Move      $C(A1), D5
9A9E   9A69 0008                 Sub       $8(A1), D5
9AA2   0645 000F                 Add       $F, D5
9AA6   E84D                      LsR       $4, D5
9AA8   6F00 00BA                 BLE       L1490
9AAC   DA45                      Add       D5, D5
9AAE   3345 0004                 Move      D5, $4(A1)
9AB2   1F3C 0090                 Move.B    $-70, -(A7)
9AB6   4AAE 0008                 Tst.L     $8(A6)
9ABA   6704                      BEQ       L1483
9ABC   1EBC 0090                 Move.B    $-70, (A7)
9AC0   0C45 0008      L1483:     Cmp       $8, D5
9AC4   6D02                      BLT       L1484
9AC6   5017                      AddQ      $8, (A7)
9AC8   4EBA 13E6      L1484:     Jsr       P_mPutPicByte
9ACC   486E FFF6                 Pea.L     $-A(A6)
9AD0   3F3C 000A                 Move      $A, -(A7)
9AD4   4EBA 13C4                 Jsr       P_mPutPicData
9AD8   2F2E 0012                 Move.L    $12(A6), -(A7)
9ADC   3F3C 0008                 Move      $8, -(A7)
9AE0   4EBA 13B8                 Jsr       P_mPutPicData
9AE4   2F2E 000E                 Move.L    $E(A6), -(A7)
9AE8   3F3C 0008                 Move      $8, -(A7)
9AEC   4EBA 13AC                 Jsr       P_mPutPicData
9AF0   3F2E 000C                 Move      $C(A6), -(A7)
9AF4   4EBA 13CC                 Jsr       P_mPutPicWord
9AF8   4AAE 0008                 Tst.L     $8(A6)
9AFC   6708                      BEQ       L1485
9AFE   2F2E 0008                 Move.L    $8(A6), -(A7)
9B02   4EBA 1434                 Jsr       P_mPutPicRgn
9B06   45EE FFF2      L1485:     Lea.L     $-E(A6), A2
9B0A   3E2A 000A                 Move      $A(A2), D7
9B0E   9E6A 0006                 Sub       $6(A2), D7
9B12   0C45 0008                 Cmp       $8, D5
9B16   6D48                      BLT       L1489
9B18   6036                      Bra       L1487
9B1A   2D4B FEEE      L1486:     Move.L    A3, $-112(A6)
9B1E   41EE FEF2                 Lea.L     $-10E(A6), A0
9B22   2D48 FEEA                 Move.L    A0, $-116(A6)
9B26   486E FEEE                 Pea.L     $-112(A6)
9B2A   486E FEEA                 Pea.L     $-116(A6)
9B2E   3F05                      Move      D5, -(A7)
9B30   4EBA 0210                 Jsr       P_tPackBits
9B34   2C2E FEEA                 Move.L    $-116(A6), D6
9B38   41EE FEF2                 Lea.L     $-10E(A6), A0
9B3C   9C88                      Sub.L     A0, D6
9B3E   1F06                      Move.B    D6, -(A7)
9B40   4EBA 136E                 Jsr       P_mPutPicByte
9B44   486E FEF2                 Pea.L     $-10E(A6)
9B48   3F06                      Move      D6, -(A7)
9B4A   4EBA 134E                 Jsr       P_mPutPicData
9B4E   D6C4                      AddA      D4, A3
9B50   51CF FFC8      L1487:     DBF       D7, L1486
9B54   600E                      Bra       L1490
9B56   2F0B           L1488:     Move.L    A3, -(A7)
9B58   3F05                      Move      D5, -(A7)
9B5A   4EBA 133E                 Jsr       P_mPutPicData
9B5E   D6C4                      AddA      D4, A3
9B60   51CF FFF4      L1489:     DBF       D7, L1488
9B64   2654           L1490:     Move.L    (A4), A3
9B66   4A6B 0042      L1491:     Tst       $42(A3)
9B6A   6D2A                      BLT       L1493
9B6C   2F2E 0016                 Move.L    $16(A6), -(A7)
9B70   486B 0002                 Pea.L     $2(A3)
9B74   2F2E 0012                 Move.L    $12(A6), -(A7)
9B78   2F2E 000E                 Move.L    $E(A6), -(A7)
9B7C   3F2E 000C                 Move      $C(A6), -(A7)
9B80   2F2B 001C                 Move.L    $1C(A3), -(A7)
9B84   2F2B 0018                 Move.L    $18(A3), -(A7)
9B88   2F2E 0008                 Move.L    $8(A6), -(A7)
9B8C   6604                      BNE       L1492
9B8E   2EAC FF7E                 Move.L    $-82(A4), (A7)
9B92   4EBA 0298      L1492:     Jsr       P_mStretchBits
9B96   4CDF 1CF8      L1493:     MoveM.L   (A7)+, D3-D7/A2-A4
9B9A   4E5E                      Unlk      A6
9B9C   205F                      Move.L    (A7)+, A0
9B9E   DEFC 0012                 AddA      $12, A7
9BA2   4ED0                      Jmp       (A0)

                      P_tCopyBits:
9BA4   4E56 0000                 Link      A6, $0
9BA8   48E7 0338                 MoveM.L   D6-D7/A2-A4, -(A7)
9BAC   2855                      Move.L    (A5), A4
9BAE   2654                      Move.L    (A4), A3
9BB0   246E 001A                 Move.L    $1A(A6), A2
9BB4   2E12                      Move.L    (A2), D7
9BB6   2C2C FF86                 Move.L    $-7A(A4), D6
9BBA   BE86                      Cmp.L     D6, D7
9BBC   660C                      BNE       L1494
9BBE   2F2E 0012                 Move.L    $12(A6), -(A7)
9BC2   2F2A 0006                 Move.L    $6(A2), -(A7)
9BC6   4EBA B7A6                 Jsr       P_tShieldCursor
9BCA   226E 0016      L1494:     Move.L    $16(A6), A1
9BCE   202B 0002                 Move.L    $2(A3), D0
9BD2   B091                      Cmp.L     (A1), D0
9BD4   660A                      BNE       L1495
9BD6   202B 0008                 Move.L    $8(A3), D0
9BDA   B0A9 0006                 Cmp.L     $6(A1), D0
9BDE   6726                      BEQ       L1497
9BE0   2F0A           L1495:     Move.L    A2, -(A7)
9BE2   2F09                      Move.L    A1, -(A7)
9BE4   2F2E 0012                 Move.L    $12(A6), -(A7)
9BE8   2F2E 000E                 Move.L    $E(A6), -(A7)
9BEC   3F2E 000C                 Move      $C(A6), -(A7)
9BF0   2F2C FF7E                 Move.L    $-82(A4), -(A7)
9BF4   2F17                      Move.L    (A7), -(A7)
9BF6   2F2E 0008                 Move.L    $8(A6), -(A7)
9BFA   6604                      BNE       L1496
9BFC   2EAC FF7E                 Move.L    $-82(A4), (A7)
9C00   4EBA 022A      L1496:     Jsr       P_mStretchBits
9C04   6024                      Bra       L1499
9C06   2F0A           L1497:     Move.L    A2, -(A7)
9C08   2F2E 0012                 Move.L    $12(A6), -(A7)
9C0C   2F2E 000E                 Move.L    $E(A6), -(A7)
9C10   3F2E 000C                 Move      $C(A6), -(A7)
9C14   2F2E 0008                 Move.L    $8(A6), -(A7)
9C18   202B 0068                 Move.L    $68(A3), D0
9C1C   41FA FE00                 Lea.L     P_tStdBits, A0
9C20   6706                      BEQ       L1498
9C22   2040                      Move.L    D0, A0
9C24   2068 0020                 Move.L    $20(A0), A0
9C28   4E90           L1498:     Jsr       (A0)
9C2A   BE86           L1499:     Cmp.L     D6, D7
9C2C   6604                      BNE       L1500
9C2E   4EBA B73A                 Jsr       P_tShowCursor
9C32   4CDF 1CC0      L1500:     MoveM.L   (A7)+, D6-D7/A2-A4
9C36   4E5E                      Unlk      A6
9C38   205F                      Move.L    (A7)+, A0
9C3A   DEFC 0016                 AddA      $16, A7
9C3E   4ED0                      Jmp       (A0)

                      P_tScrollRect:
9C40   4E56 FFF8                 Link      A6, $-8
9C44   48E7 0318                 MoveM.L   D6-D7/A3-A4, -(A7)
9C48   2855                      Move.L    (A5), A4
9C4A   2654                      Move.L    (A4), A3
9C4C   4A6B 0042                 Tst       $42(A3)
9C50   6D00 00DA                 BLT       L1501
9C54   4AAE 000C                 Tst.L     $C(A6)
9C58   6700 00D2                 BEQ       L1501
9C5C   42A7                      Clr.L     -(A7)
9C5E   4EBA F222                 Jsr       P_tNewRgn
9C62   2E1F                      Move.L    (A7)+, D7
9C64   42A7                      Clr.L     -(A7)
9C66   4EBA F21A                 Jsr       P_tNewRgn
9C6A   2C1F                      Move.L    (A7)+, D6
9C6C   2F07                      Move.L    D7, -(A7)
9C6E   2F2E 0010                 Move.L    $10(A6), -(A7)
9C72   4EBA F386                 Jsr       P_tRectRgn
9C76   2F07                      Move.L    D7, -(A7)
9C78   2F2B 0018                 Move.L    $18(A3), -(A7)
9C7C   2F07                      Move.L    D7, -(A7)
9C7E   4EBA F4B0                 Jsr       P_tSectRgn
9C82   2F07                      Move.L    D7, -(A7)
9C84   2F2B 001C                 Move.L    $1C(A3), -(A7)
9C88   2F07                      Move.L    D7, -(A7)
9C8A   4EBA F4A4                 Jsr       P_tSectRgn
9C8E   2F07                      Move.L    D7, -(A7)
9C90   2F06                      Move.L    D6, -(A7)
9C92   4EBA F2AE                 Jsr       P_tCopyRgn
9C96   2F06                      Move.L    D6, -(A7)
9C98   2F2E 000C                 Move.L    $C(A6), -(A7)
9C9C   4EBA F36A                 Jsr       P_tOffsetRgn
9CA0   206E 0010                 Move.L    $10(A6), A0
9CA4   2D58 FFF8                 Move.L    (A0)+, $-8(A6)
9CA8   2D58 FFFC                 Move.L    (A0)+, $-4(A6)
9CAC   202E 000C                 Move.L    $C(A6), D0
9CB0   916E FFFA                 Sub       D0, $-6(A6)
9CB4   916E FFFE                 Sub       D0, $-2(A6)
9CB8   4840                      Swap      D0
9CBA   916E FFF8                 Sub       D0, $-8(A6)
9CBE   916E FFFC                 Sub       D0, $-4(A6)
9CC2   2F07                      Move.L    D7, -(A7)
9CC4   2F06                      Move.L    D6, -(A7)
9CC6   2F2E 0008                 Move.L    $8(A6), -(A7)
9CCA   4EBA F470                 Jsr       P_tDiffRgn
9CCE   2F2E 0010                 Move.L    $10(A6), -(A7)
9CD2   2F2B 0008                 Move.L    $8(A3), -(A7)
9CD6   4EBA B696                 Jsr       P_tShieldCursor
9CDA   486B 0002                 Pea.L     $2(A3)
9CDE   2F17                      Move.L    (A7), -(A7)
9CE0   486E FFF8                 Pea.L     $-8(A6)
9CE4   2F2E 0010                 Move.L    $10(A6), -(A7)
9CE8   4267                      Clr       -(A7)
9CEA   42A7                      Clr.L     -(A7)
9CEC   2F06                      Move.L    D6, -(A7)
9CEE   2F07                      Move.L    D7, -(A7)
9CF0   2F2C FF7E                 Move.L    $-82(A4), -(A7)
9CF4   4EBA D9EA                 Jsr       P_mRgnBlt
9CF8   486B 0002                 Pea.L     $2(A3)
9CFC   2F17                      Move.L    (A7), -(A7)
9CFE   2F2E 0010                 Move.L    $10(A6), -(A7)
9D02   2F17                      Move.L    (A7), -(A7)
9D04   3F3C 0008                 Move      $8, -(A7)
9D08   486B 0020                 Pea.L     $20(A3)
9D0C   2F2E 0008                 Move.L    $8(A6), -(A7)
9D10   2F2C FF7E                 Move.L    $-82(A4), -(A7)
9D14   2F17                      Move.L    (A7), -(A7)
9D16   4EBA D9C8                 Jsr       P_mRgnBlt
9D1A   4EBA B64E                 Jsr       P_tShowCursor
9D1E   2F07                      Move.L    D7, -(A7)
9D20   4EBA F184                 Jsr       P_tDisposeRgn
9D24   2F06                      Move.L    D6, -(A7)
9D26   4EBA F17E                 Jsr       P_tDisposeRgn
9D2A   6008                      Bra       L1502
9D2C   2F2E 0008      L1501:     Move.L    $8(A6), -(A7)
9D30   4EBA F25E                 Jsr       P_tSetEmptyRgn
9D34   4CDF 18C0      L1502:     MoveM.L   (A7)+, D6-D7/A3-A4
9D38   4E5E                      Unlk      A6
9D3A   205F                      Move.L    (A7)+, A0
9D3C   DEFC 000C                 AddA      $C, A7
9D40   4ED0                      Jmp       (A0)

                      P_tPackBits:
9D42   4E56 0000                 Link      A6, $0
9D46   2F0A                      Move.L    A2, -(A7)
9D48   206E 000E                 Move.L    $E(A6), A0
9D4C   2050                      Move.L    (A0), A0
9D4E   226E 000A                 Move.L    $A(A6), A1
9D52   2251                      Move.L    (A1), A1
9D54   322E 0008                 Move      $8(A6), D1
9D58   5341                      SubQ.L    $1, D1
9D5A   6D5E                      BLT       L1511
9D5C   1018                      Move.B    (A0)+, D0
9D5E   600A                      Bra       L1504
9D60   1028 FFFF      L1503:     Move.B    $-1(A0), D0
9D64   9448                      Sub       A0, D2
9D66   5242                      AddQ      $1, D2
9D68   1482                      Move.B    D2, (A2)
9D6A   3408           L1504:     Move      A0, D2
9D6C   2449                      Move.L    A1, A2
9D6E   4219                      Clr.B     (A1)+
9D70   B010                      Cmp.B     (A0), D0
9D72   6614                      BNE       L1506
9D74   B028 0001                 Cmp.B     $1(A0), D0
9D78   660E                      BNE       L1506
9D7A   602A                      Bra       L1508
9D7C   1018           L1505:     Move.B    (A0)+, D0
9D7E   B010                      Cmp.B     (A0), D0
9D80   6606                      BNE       L1506
9D82   B028 0001                 Cmp.B     $1(A0), D0
9D86   670E                      BEQ       L1507
9D88   12C0           L1506:     Move.B    D0, (A1)+
9D8A   51C9 FFF0                 DBF       D1, L1505
9D8E   9448                      Sub       A0, D2
9D90   4442                      Neg       D2
9D92   1482                      Move.B    D2, (A2)
9D94   6024                      Bra       L1511
9D96   4A41           L1507:     Tst       D1
9D98   67EE                      BEQ       L1506
9D9A   9448                      Sub       A0, D2
9D9C   4642                      Not       D2
9D9E   1482                      Move.B    D2, (A2)
9DA0   2408                      Move.L    A0, D2
9DA2   2449                      Move.L    A1, A2
9DA4   4219                      Clr.B     (A1)+
9DA6   12C0           L1508:     Move.B    D0, (A1)+
9DA8   B018           L1509:     Cmp.B     (A0)+, D0
9DAA   56C9 FFFC                 DBNE      D1, L1509
9DAE   6704                      BEQ       L1510
9DB0   5341                      SubQ.L    $1, D1
9DB2   6CAC                      BGE       L1503
9DB4   9448           L1510:     Sub       A0, D2
9DB6   5242                      AddQ      $1, D2
9DB8   1482                      Move.B    D2, (A2)
9DBA   4280           L1511:     Clr.L     D0
9DBC   302E 0008                 Move      $8(A6), D0
9DC0   206E 000E                 Move.L    $E(A6), A0
9DC4   D190                      Add.L     D0, (A0)
9DC6   246E 000A                 Move.L    $A(A6), A2
9DCA   2489                      Move.L    A1, (A2)
9DCC   245F                      Move.L    (A7)+, A2
9DCE   4E5E                      Unlk      A6
9DD0   205F                      Move.L    (A7)+, A0
9DD2   DEFC 000A                 AddA      $A, A7
9DD6   4ED0                      Jmp       (A0)

                      P_tUnpackBits:
9DD8   4E56 0000                 Link      A6, $0
9DDC   206E 000E                 Move.L    $E(A6), A0
9DE0   2050                      Move.L    (A0), A0
9DE2   226E 000A                 Move.L    $A(A6), A1
9DE6   2251                      Move.L    (A1), A1
9DE8   342E 0008                 Move      $8(A6), D2
9DEC   48C2                      Ext.L     D2
9DEE   D489                      Add.L     A1, D2
9DF0   6008                      Bra       L1514
9DF2   4881           L1512:     Ext       D1
9DF4   12D8           L1513:     Move.B    (A0)+, (A1)+
9DF6   51C9 FFFC                 DBF       D1, L1513
9DFA   B3C2           L1514:     CmpA.L    D2, A1
9DFC   6400 0016                 BCC       L1516
9E00   1218                      Move.B    (A0)+, D1
9E02   6AEE                      BPL       L1512
9E04   4401                      Neg.B     D1
9E06   69F2                      BVS       L1514
9E08   4881                      Ext       D1
9E0A   1018                      Move.B    (A0)+, D0
9E0C   12C0           L1515:     Move.B    D0, (A1)+
9E0E   51C9 FFFC                 DBF       D1, L1515
9E12   60E6                      Bra       L1514
9E14   2008           L1516:     Move.L    A0, D0
9E16   206E 000E                 Move.L    $E(A6), A0
9E1A   2080                      Move.L    D0, (A0)
9E1C   206E 000A                 Move.L    $A(A6), A0
9E20   2089                      Move.L    A1, (A0)
9E22   4E5E                      Unlk      A6
9E24   205F                      Move.L    (A7)+, A0
9E26   DEFC 000A                 AddA      $A, A7
9E2A   4ED0                      Jmp       (A0)

                      P_mStretchBits:
9E2C   4E56 FF6C                 Link      A6, $-94
9E30   48E7 FF78                 MoveM.L   D0-D7/A1-A4, -(A7)
9E34   2D4F FF94                 Move.L    A7, $-6C(A6)
9E38   206E 0016                 Move.L    $16(A6), A0
9E3C   3028 0004                 Move      $4(A0), D0
9E40   9050                      Sub       (A0), D0
9E42   4840                      Swap      D0
9E44   3028 0006                 Move      $6(A0), D0
9E48   9068 0002                 Sub       $2(A0), D0
9E4C   206E 001A                 Move.L    $1A(A6), A0
9E50   3228 0004                 Move      $4(A0), D1
9E54   9250                      Sub       (A0), D1
9E56   4841                      Swap      D1
9E58   3228 0006                 Move      $6(A0), D1
9E5C   9268 0002                 Sub       $2(A0), D1
9E60   B280                      Cmp.L     D0, D1
9E62   662C                      BNE       L1518
9E64   2F2E 0022      L1517:     Move.L    $22(A6), -(A7)
9E68   2F2E 001E                 Move.L    $1E(A6), -(A7)
9E6C   2F2E 001A                 Move.L    $1A(A6), -(A7)
9E70   2F2E 0016                 Move.L    $16(A6), -(A7)
9E74   3F2E 0014                 Move      $14(A6), -(A7)
9E78   2F2E FF6C                 Move.L    $-94(A6), -(A7)
9E7C   2F2E 0010                 Move.L    $10(A6), -(A7)
9E80   2F2E 000C                 Move.L    $C(A6), -(A7)
9E84   2F2E 0008                 Move.L    $8(A6), -(A7)
9E88   4EBA D856                 Jsr       P_mRgnBlt
9E8C   4EFA 0344                 Jmp       L1536
9E90   3F2E 0014      L1518:     Move      $14(A6), -(A7)
9E94   2F2E FF6C                 Move.L    $-94(A6), -(A7)
9E98   4EBA B72C                 Jsr       P_mColorMap
9E9C   2D5F FF6C                 Move.L    (A7)+, $-94(A6)
9EA0   341F                      Move      (A7)+, D2
9EA2   3602                      Move      D2, D3
9EA4   0243 0008                 And       $8, D3
9EA8   66BA                      BNE       L1517
9EAA   3D42 0014                 Move      D2, $14(A6)
9EAE   2D40 FFFC                 Move.L    D0, $-4(A6)
9EB2   2D41 FFF8                 Move.L    D1, $-8(A6)
9EB6   266E 001E                 Move.L    $1E(A6), A3
9EBA   2F2E 0016                 Move.L    $16(A6), -(A7)
9EBE   486B 0006                 Pea.L     $6(A3)
9EC2   206E 0010                 Move.L    $10(A6), A0
9EC6   2050                      Move.L    (A0), A0
9EC8   4868 0002                 Pea.L     $2(A0)
9ECC   206E 000C                 Move.L    $C(A6), A0
9ED0   2050                      Move.L    (A0), A0
9ED2   4868 0002                 Pea.L     $2(A0)
9ED6   206E 0008                 Move.L    $8(A6), A0
9EDA   2050                      Move.L    (A0), A0
9EDC   4868 0002                 Pea.L     $2(A0)
9EE0   3F3C 0005                 Move      $5, -(A7)
9EE4   486E FFEC                 Pea.L     $-14(A6)
9EE8   4EBA D2DE                 Jsr       P_mRSect
9EEC   6700 02E4                 BEQ       L1536
9EF0   486E FFEC                 Pea.L     $-14(A6)
9EF4   2F2B 0006                 Move.L    $6(A3), -(A7)
9EF8   4EBA B474                 Jsr       P_tShieldCursor
9EFC   206E 0016                 Move.L    $16(A6), A0
9F00   3028 0006                 Move      $6(A0), D0
9F04   9068 0002                 Sub       $2(A0), D0
9F08   3D40 FFFE                 Move      D0, $-2(A6)
9F0C   3028 0004                 Move      $4(A0), D0
9F10   9050                      Sub       (A0), D0
9F12   3D40 FFFC                 Move      D0, $-4(A6)
9F16   206E 001A                 Move.L    $1A(A6), A0
9F1A   3028 0006                 Move      $6(A0), D0
9F1E   9068 0002                 Sub       $2(A0), D0
9F22   3D40 FFFA                 Move      D0, $-6(A6)
9F26   3028 0004                 Move      $4(A0), D0
9F2A   9050                      Sub       (A0), D0
9F2C   3D40 FFF8                 Move      D0, $-8(A6)
9F30   302E FFFA                 Move      $-6(A6), D0
9F34   5340                      SubQ.L    $1, D0
9F36   EA48                      LsR       $5, D0
9F38   3D40 FFE2                 Move      D0, $-1E(A6)
9F3C   42A7                      Clr.L     -(A7)
9F3E   42A7           L1519:     Clr.L     -(A7)
9F40   51C8 FFFC                 DBF       D0, L1519
9F44   2D4F FFE8                 Move.L    A7, $-18(A6)
9F48   302E FFFE                 Move      $-2(A6), D0
9F4C   5340                      SubQ.L    $1, D0
9F4E   EA48                      LsR       $5, D0
9F50   3D40 FFE0                 Move      D0, $-20(A6)
9F54   42A7                      Clr.L     -(A7)
9F56   42A7                      Clr.L     -(A7)
9F58   42A7           L1520:     Clr.L     -(A7)
9F5A   51C8 FFFC                 DBF       D0, L1520
9F5E   2D4F FFE4                 Move.L    A7, $-1C(A6)
9F62   206E 0016                 Move.L    $16(A6), A0
9F66   3228 0002                 Move      $2(A0), D1
9F6A   926B 0008                 Sub       $8(A3), D1
9F6E   0241 FFF0                 And       $-10, D1
9F72   D26B 0008                 Add       $8(A3), D1
9F76   3D41 FF8C                 Move      D1, $-74(A6)
9F7A   302E FFF2                 Move      $-E(A6), D0
9F7E   9041                      Sub       D1, D0
9F80   EA48                      LsR       $5, D0
9F82   3D40 FF8A                 Move      D0, $-76(A6)
9F86   42A7           L1521:     Clr.L     -(A7)
9F88   51C8 FFFC                 DBF       D0, L1521
9F8C   2D4F FF8E                 Move.L    A7, $-72(A6)
9F90   3D7C 8001 FFD6            Move      $-7FFF, $-2A(A6)
9F96   3D7C 8001 FFBE            Move      $-7FFF, $-42(A6)
9F9C   3D7C 8001 FFA6            Move      $-7FFF, $-5A(A6)
9FA2   3D7C 7FFF FFD8            Move      $7FFF, $-28(A6)
9FA8   3D7C 7FFF FFC0            Move      $7FFF, $-40(A6)
9FAE   3D7C 7FFF FFA8            Move      $7FFF, $-58(A6)
9FB4   426E FF92                 Clr       $-6E(A6)
9FB8   206E 0010                 Move.L    $10(A6), A0
9FBC   2050                      Move.L    (A0), A0
9FBE   0C50 000A                 Cmp       $A, (A0)
9FC2   6718                      BEQ       L1522
9FC4   546E FF92                 AddQ      $2, $-6E(A6)
9FC8   43EE FFC8                 Lea.L     $-38(A6), A1
9FCC   302E FFEE                 Move      $-12(A6), D0
9FD0   322E FFF2                 Move      $-E(A6), D1
9FD4   342E FF8C                 Move      $-74(A6), D2
9FD8   4EBA F470                 Jsr       P_mInitRgn
9FDC   206E 000C      L1522:     Move.L    $C(A6), A0
9FE0   2050                      Move.L    (A0), A0
9FE2   0C50 000A                 Cmp       $A, (A0)
9FE6   6718                      BEQ       L1523
9FE8   586E FF92                 AddQ      $4, $-6E(A6)
9FEC   43EE FFB0                 Lea.L     $-50(A6), A1
9FF0   302E FFEE                 Move      $-12(A6), D0
9FF4   322E FFF2                 Move      $-E(A6), D1
9FF8   342E FF8C                 Move      $-74(A6), D2
9FFC   4EBA F44C                 Jsr       P_mInitRgn
A000   206E 0008      L1523:     Move.L    $8(A6), A0
A004   2050                      Move.L    (A0), A0
A006   0C50 000A                 Cmp       $A, (A0)
A00A   6718                      BEQ       L1524
A00C   506E FF92                 AddQ      $8, $-6E(A6)
A010   43EE FF98                 Lea.L     $-68(A6), A1
A014   302E FFEE                 Move      $-12(A6), D0
A018   322E FFF2                 Move      $-E(A6), D1
A01C   342E FF8C                 Move      $-74(A6), D2
A020   4EBA F428                 Jsr       P_mInitRgn
A024   4A6E FF92      L1524:     Tst       $-6E(A6)
A028   6618                      BNE       L1525
A02A   206E FF8E                 Move.L    $-72(A6), A0
A02E   362E FFEE                 Move      $-12(A6), D3
A032   966E FF8C                 Sub       $-74(A6), D3
A036   382E FFF2                 Move      $-E(A6), D4
A03A   986E FF8C                 Sub       $-74(A6), D4
A03E   4EBA 0368                 Jsr       P252
A042   4287           L1525:     Clr.L     D7
A044   342E 0014                 Move      $14(A6), D2
A048   6B00 0184                 BMI       L1535
A04C   0882 0002                 BClr.B    $2, D2
A050   6702                      BEQ       L1526
A052   4687                      Not.L     D7
A054   0C42 0007      L1526:     Cmp       $7, D2
A058   6E00 0174                 BGT       L1535
A05C   3002                      Move      D2, D0
A05E   0240 0003                 And       $3, D0
A062   D440                      Add       D0, D2
A064   41FA 02C0                 Lea.L     DT46, A0
A068   D0F0 2000                 AddA      $0(A0,D2.W), A0
A06C   2D48 FF70                 Move.L    A0, $-90(A6)
A070   246E 0022                 Move.L    $22(A6), A2
A074   302A 0004                 Move      $4(A2), D0
A078   48C0                      Ext.L     D0
A07A   2D40 FF7E                 Move.L    D0, $-82(A6)
A07E   322A 000A                 Move      $A(A2), D1
A082   926A 0006                 Sub       $6(A2), D1
A086   C2C0                      MulU      D0, D1
A088   D292                      Add.L     (A2), D1
A08A   5481                      AddQ      $2, D1
A08C   2D41 FF76                 Move.L    D1, $-8A(A6)
A090   206E 001A                 Move.L    $1A(A6), A0
A094   3228 0002                 Move      $2(A0), D1
A098   926A 0008                 Sub       $8(A2), D1
A09C   3A01                      Move      D1, D5
A09E   4445                      Neg       D5
A0A0   0245 000F                 And       $F, D5
A0A4   3010                      Move      (A0), D0
A0A6   906A 0006                 Sub       $6(A2), D0
A0AA   C0EA 0004                 MulU      $4(A2), D0
A0AE   2052                      Move.L    (A2), A0
A0B0   D1C0                      AddA.L    D0, A0
A0B2   D245                      Add       D5, D1
A0B4   E841                      AsR       $4, D1
A0B6   D0C1                      AddA      D1, A0
A0B8   D0C1                      AddA      D1, A0
A0BA   2D48 FF86                 Move.L    A0, $-7A(A6)
A0BE   302B 0004                 Move      $4(A3), D0
A0C2   48C0                      Ext.L     D0
A0C4   2D40 FF7A                 Move.L    D0, $-86(A6)
A0C8   206E 0016                 Move.L    $16(A6), A0
A0CC   3D50 FF74                 Move      (A0), $-8C(A6)
A0D0   3228 0002                 Move      $2(A0), D1
A0D4   926B 0008                 Sub       $8(A3), D1
A0D8   7C0F                      MoveQ.L   $F, D6
A0DA   CC41                      And       D1, D6
A0DC   302E FFEC                 Move      $-14(A6), D0
A0E0   906B 0006                 Sub       $6(A3), D0
A0E4   C0EB 0004                 MulU      $4(A3), D0
A0E8   2053                      Move.L    (A3), A0
A0EA   D1C0                      AddA.L    D0, A0
A0EC   E841                      AsR       $4, D1
A0EE   D0C1                      AddA      D1, A0
A0F0   D0C1                      AddA      D1, A0
A0F2   2D48 FF82                 Move.L    A0, $-7E(A6)
A0F6   302E FFF8                 Move      $-8(A6), D0
A0FA   E248                      LsR       $1, D0
A0FC   4440                      Neg       D0
A0FE   3D40 FFF4                 Move      D0, $-C(A6)
A102   206E FF86      L1527:     Move.L    $-7A(A6), A0
A106   B1EE FF76                 CmpA.L    $-8A(A6), A0
A10A   6400 00C2                 BCC       L1535
A10E   226E FFE8                 Move.L    $-18(A6), A1
A112   322E FFE2                 Move      $-1E(A6), D1
A116   2028 FFFE      L1528:     Move.L    $-2(A0), D0
A11A   EAA8                      LsR.L     D5, D0
A11C   32C0                      Move      D0, (A1)+
A11E   2018                      Move.L    (A0)+, D0
A120   EAA8                      LsR.L     D5, D0
A122   32C0                      Move      D0, (A1)+
A124   51C9 FFF0                 DBF       D1, L1528
A128   242E FF7E                 Move.L    $-82(A6), D2
A12C   D5AE FF86                 Add.L     D2, $-7A(A6)
A130   302E FFFC                 Move      $-4(A6), D0
A134   D16E FFF4                 Add       D0, $-C(A6)
A138   6E34                      BGT       L1531
A13A   206E FF86      L1529:     Move.L    $-7A(A6), A0
A13E   B1EE FF76                 CmpA.L    $-8A(A6), A0
A142   6400 002A                 BCC       L1531
A146   226E FFE8                 Move.L    $-18(A6), A1
A14A   322E FFE2                 Move      $-1E(A6), D1
A14E   2028 FFFE      L1530:     Move.L    $-2(A0), D0
A152   EAA8                      LsR.L     D5, D0
A154   8159                      Or        D0, (A1)+
A156   2018                      Move.L    (A0)+, D0
A158   EAA8                      LsR.L     D5, D0
A15A   8159                      Or        D0, (A1)+
A15C   51C9 FFF0                 DBF       D1, L1530
A160   D5AE FF86                 Add.L     D2, $-7A(A6)
A164   302E FFFC                 Move      $-4(A6), D0
A168   D16E FFF4                 Add       D0, $-C(A6)
A16C   6FCC                      BLE       L1529
A16E   2F2E FFE8      L1531:     Move.L    $-18(A6), -(A7)
A172   2F2E FFE4                 Move.L    $-1C(A6), -(A7)
A176   3F2E FFE0                 Move      $-20(A6), -(A7)
A17A   3F2E FFFE                 Move      $-2(A6), -(A7)
A17E   3F2E FFFA                 Move      $-6(A6), -(A7)
A182   4EBA 0258                 Jsr       P253
A186   302E FF74      L1532:     Move      $-8C(A6), D0
A18A   B06E FFEC                 Cmp       $-14(A6), D0
A18E   6D22                      BLT       L1534
A190   4EBA 0052                 Jsr       P251
A194   266E FFE4                 Move.L    $-1C(A6), A3
A198   286E FF82                 Move.L    $-7E(A6), A4
A19C   246E FF8E                 Move.L    $-72(A6), A2
A1A0   342E FF8A                 Move      $-76(A6), D2
A1A4   206E FF70                 Move.L    $-90(A6), A0
A1A8   4ED0                      Jmp       (A0)
A1AA   202E FF7A      L1533:     Move.L    $-86(A6), D0
A1AE   D1AE FF82                 Add.L     D0, $-7E(A6)
A1B2   526E FF74      L1534:     AddQ      $1, $-8C(A6)
A1B6   302E FF74                 Move      $-8C(A6), D0
A1BA   B06E FFF0                 Cmp       $-10(A6), D0
A1BE   670E                      BEQ       L1535
A1C0   302E FFF8                 Move      $-8(A6), D0
A1C4   916E FFF4                 Sub       D0, $-C(A6)
A1C8   6CBC                      BGE       L1532
A1CA   6000 FF36                 Bra       L1527
A1CE   4EBA B19A      L1535:     Jsr       P_tShowCursor
A1D2   2E6E FF94      L1536:     Move.L    $-6C(A6), A7
A1D6   4CDF 1EFF                 MoveM.L   (A7)+, D0-D7/A1-A4
A1DA   4E5E                      Unlk      A6
A1DC   205F                      Move.L    (A7)+, A0
A1DE   DEFC 001E                 AddA      $1E, A7
A1E2   4ED0                      Jmp       (A0)

                      P251:
A1E4   302E FF92                 Move      $-6E(A6), D0
A1E8   303B 0006                 Move      DT45(D0.W), D0
A1EC   4EFB 0002                 Jmp       DT45(D0.W)

                      DT45:
A1F0   0010 0012 0026            DC.B      '     &'
A1F6   004E 003A 0084            DC.B      ' N :  '
A1FC   00BA 00F0                 DC.B      '    '

                      E_403:
A200   4E75                      Rts

                      E_404:
A202   302E FF74                 Move      $-8C(A6), D0
A206   43EE FFC8                 Lea.L     $-38(A6), A1
A20A   236E FF8E 0008            Move.L    $-72(A6), $8(A1)
A210   4EBA F270                 Jsr       P_mSeekRgn
A214   4E75                      Rts

                      E_405:
A216   302E FF74                 Move      $-8C(A6), D0
A21A   43EE FFB0                 Lea.L     $-50(A6), A1
A21E   236E FF8E 0008            Move.L    $-72(A6), $8(A1)
A224   4EBA F25C                 Jsr       P_mSeekRgn
A228   4E75                      Rts

                      E_406:
A22A   302E FF74                 Move      $-8C(A6), D0
A22E   43EE FF98                 Lea.L     $-68(A6), A1
A232   236E FF8E 0008            Move.L    $-72(A6), $8(A1)
A238   4EBA F248                 Jsr       P_mSeekRgn
A23C   4E75                      Rts

                      E_407:
A23E   302E FF74                 Move      $-8C(A6), D0
A242   43EE FFC8                 Lea.L     $-38(A6), A1
A246   4EBA F23A                 Jsr       P_mSeekRgn
A24A   3F01                      Move      D1, -(A7)
A24C   43EE FFB0                 Lea.L     $-50(A6), A1
A250   4EBA F230                 Jsr       P_mSeekRgn
A254   825F                      Or        (A7)+, D1
A256   671A                      BEQ       L1538
A258   206E FFD0                 Move.L    $-30(A6), A0
A25C   226E FFB8                 Move.L    $-48(A6), A1
A260   246E FF8E                 Move.L    $-72(A6), A2
A264   322E FF8A                 Move      $-76(A6), D1
A268   2018           L1537:     Move.L    (A0)+, D0
A26A   C099                      And.L     (A1)+, D0
A26C   24C0                      Move.L    D0, (A2)+
A26E   51C9 FFF8                 DBF       D1, L1537
A272   4E75           L1538:     Rts

                      E_408:
A274   302E FF74                 Move      $-8C(A6), D0
A278   43EE FFC8                 Lea.L     $-38(A6), A1
A27C   4EBA F204                 Jsr       P_mSeekRgn
A280   3F01                      Move      D1, -(A7)
A282   43EE FF98                 Lea.L     $-68(A6), A1
A286   4EBA F1FA                 Jsr       P_mSeekRgn
A28A   825F                      Or        (A7)+, D1
A28C   671A                      BEQ       L1540
A28E   206E FFD0                 Move.L    $-30(A6), A0
A292   226E FFA0                 Move.L    $-60(A6), A1
A296   246E FF8E                 Move.L    $-72(A6), A2
A29A   322E FF8A                 Move      $-76(A6), D1
A29E   2018           L1539:     Move.L    (A0)+, D0
A2A0   C099                      And.L     (A1)+, D0
A2A2   24C0                      Move.L    D0, (A2)+
A2A4   51C9 FFF8                 DBF       D1, L1539
A2A8   4E75           L1540:     Rts

                      E_409:
A2AA   302E FF74                 Move      $-8C(A6), D0
A2AE   43EE FFB0                 Lea.L     $-50(A6), A1
A2B2   4EBA F1CE                 Jsr       P_mSeekRgn
A2B6   3F01                      Move      D1, -(A7)
A2B8   43EE FF98                 Lea.L     $-68(A6), A1
A2BC   4EBA F1C4                 Jsr       P_mSeekRgn
A2C0   825F                      Or        (A7)+, D1
A2C2   671A                      BEQ       L1542
A2C4   206E FFB8                 Move.L    $-48(A6), A0
A2C8   226E FFA0                 Move.L    $-60(A6), A1
A2CC   246E FF8E                 Move.L    $-72(A6), A2
A2D0   322E FF8A                 Move      $-76(A6), D1
A2D4   2018           L1541:     Move.L    (A0)+, D0
A2D6   C099                      And.L     (A1)+, D0
A2D8   24C0                      Move.L    D0, (A2)+
A2DA   51C9 FFF8                 DBF       D1, L1541
A2DE   4E75           L1542:     Rts

                      E_410:
A2E0   302E FF74                 Move      $-8C(A6), D0
A2E4   43EE FFC8                 Lea.L     $-38(A6), A1
A2E8   4EBA F198                 Jsr       P_mSeekRgn
A2EC   3F01                      Move      D1, -(A7)
A2EE   43EE FFB0                 Lea.L     $-50(A6), A1
A2F2   4EBA F18E                 Jsr       P_mSeekRgn
A2F6   8357                      Or        D1, (A7)
A2F8   43EE FF98                 Lea.L     $-68(A6), A1
A2FC   4EBA F184                 Jsr       P_mSeekRgn
A300   825F                      Or        (A7)+, D1
A302   6720                      BEQ       L1544
A304   206E FFD0                 Move.L    $-30(A6), A0
A308   226E FFB8                 Move.L    $-48(A6), A1
A30C   246E FFA0                 Move.L    $-60(A6), A2
A310   266E FF8E                 Move.L    $-72(A6), A3
A314   322E FF8A                 Move      $-76(A6), D1
A318   2018           L1543:     Move.L    (A0)+, D0
A31A   C099                      And.L     (A1)+, D0
A31C   C09A                      And.L     (A2)+, D0
A31E   26C0                      Move.L    D0, (A3)+
A320   51C9 FFF6                 DBF       D1, L1543
A324   4E75           L1544:     Rts

                      DT46:
A326   0008 002C 0048            DC.B      '   , H'
A32C   0064                      DC.B      ' d'

                      E_411:
A32E   202B FFFE                 Move.L    $-2(A3), D0
A332   ECA8                      LsR.L     D6, D0
A334   4840                      Swap      D0
A336   221B                      Move.L    (A3)+, D1
A338   ECA9                      LsR.L     D6, D1
A33A   3001                      Move      D1, D0
A33C   BF80                      Eor.L     D7, D0
A33E   221A                      Move.L    (A2)+, D1
A340   C081                      And.L     D1, D0
A342   4681                      Not.L     D1
A344   C294                      And.L     (A4), D1
A346   8081                      Or.L      D1, D0
A348   28C0                      Move.L    D0, (A4)+
A34A   51CA FFE2                 DBF       D2, E_411
A34E   6000 FE5A                 Bra       L1533

                      E_412:
A352   202B FFFE                 Move.L    $-2(A3), D0
A356   ECA8                      LsR.L     D6, D0
A358   4840                      Swap      D0
A35A   221B                      Move.L    (A3)+, D1
A35C   ECA9                      LsR.L     D6, D1
A35E   3001                      Move      D1, D0
A360   BF80                      Eor.L     D7, D0
A362   C09A                      And.L     (A2)+, D0
A364   819C                      Or.L      D0, (A4)+
A366   51CA FFEA                 DBF       D2, E_412
A36A   6000 FE3E                 Bra       L1533

                      E_413:
A36E   202B FFFE                 Move.L    $-2(A3), D0
A372   ECA8                      LsR.L     D6, D0
A374   4840                      Swap      D0
A376   221B                      Move.L    (A3)+, D1
A378   ECA9                      LsR.L     D6, D1
A37A   3001                      Move      D1, D0
A37C   BF80                      Eor.L     D7, D0
A37E   C09A                      And.L     (A2)+, D0
A380   B19C                      Eor.L     D0, (A4)+
A382   51CA FFEA                 DBF       D2, E_413
A386   6000 FE22                 Bra       L1533

                      E_414:
A38A   202B FFFE                 Move.L    $-2(A3), D0
A38E   ECA8                      LsR.L     D6, D0
A390   4840                      Swap      D0
A392   221B                      Move.L    (A3)+, D1
A394   ECA9                      LsR.L     D6, D1
A396   3001                      Move      D1, D0
A398   BF80                      Eor.L     D7, D0
A39A   C09A                      And.L     (A2)+, D0
A39C   4680                      Not.L     D0
A39E   C19C                      And.L     D0, (A4)+
A3A0   51CA FFE8                 DBF       D2, E_414
A3A4   6000 FE04                 Bra       L1533

                      P252:
A3A8   3003                      Move      D3, D0
A3AA   4EBA B0E6                 Jsr       P_mLeftMask
A3AE   3A00                      Move      D0, D5
A3B0   3004                      Move      D4, D0
A3B2   4EBA B0EC                 Jsr       P_mRightMask
A3B6   3C00                      Move      D0, D6
A3B8   E843                      AsR       $4, D3
A3BA   D0C3                      AddA      D3, A0
A3BC   D0C3                      AddA      D3, A0
A3BE   E844                      AsR       $4, D4
A3C0   9843                      Sub       D3, D4
A3C2   6E06                      BGT       L1545
A3C4   CC45                      And       D5, D6
A3C6   BD50                      Eor       D6, (A0)
A3C8   4E75                      Rts
A3CA   BB58           L1545:     Eor       D5, (A0)+
A3CC   6002                      Bra       L1547
A3CE   4698           L1546:     Not.L     (A0)+
A3D0   5544           L1547:     SubQ.L    $2, D4
A3D2   6EFA                      BGT       L1546
A3D4   6D02                      BLT       L1548
A3D6   4658                      Not       (A0)+
A3D8   BD50           L1548:     Eor       D6, (A0)
A3DA   4E75                      Rts

                      P253:
A3DC   4E56 0000                 Link      A6, $0
A3E0   48E7 FF78                 MoveM.L   D0-D7/A1-A4, -(A7)
A3E4   362E 000A                 Move      $A(A6), D3
A3E8   6700 00E4                 BEQ       L1564
A3EC   382E 0008                 Move      $8(A6), D4
A3F0   6700 00DC                 BEQ       L1564
A3F4   206E 0012                 Move.L    $12(A6), A0
A3F8   226E 000E                 Move.L    $E(A6), A1
A3FC   302E 000C                 Move      $C(A6), D0
A400   5240                      AddQ      $1, D0
A402   E548                      LsL       $2, D0
A404   2649                      Move.L    A1, A3
A406   D6C0                      AddA      D0, A3
A408   3003                      Move      D3, D0
A40A   9044                      Sub       D4, D0
A40C   660C                      BNE       L1550
A40E   22D8           L1549:     Move.L    (A0)+, (A1)+
A410   22D8                      Move.L    (A0)+, (A1)+
A412   B3CB                      CmpA.L    A3, A1
A414   65F8                      BCS       L1549
A416   6000 00B6                 Bra       L1564
A41A   6E00 0034      L1550:     BGT       L1554
A41E   D043                      Add       D3, D0
A420   D043                      Add       D3, D0
A422   6704                      BEQ       L1551
A424   6000 005E                 Bra       L1556
A428   2E3C E000 0000 L1551:     Move.L    $-20000000, D7
A42E   1018           L1552:     Move.B    (A0)+, D0
A430   E188                      LsL.L     $8, D0
A432   1018                      Move.B    (A0)+, D0
A434   E188                      LsL.L     $8, D0
A436   1018                      Move.B    (A0)+, D0
A438   E188                      LsL.L     $8, D0
A43A   7407                      MoveQ.L   $7, D2
A43C   D087           L1553:     Add.L     D7, D0
A43E   D341                      AddX      D1, D1
A440   E788                      LsL.L     $3, D0
A442   51CA FFF8                 DBF       D2, L1553
A446   12C1                      Move.B    D1, (A1)+
A448   B3CB                      CmpA.L    A3, A1
A44A   65E2                      BCS       L1552
A44C   6000 0080                 Bra       L1564
A450   9044           L1554:     Sub       D4, D0
A452   6700 0006                 BEQ       L1555
A456   6000 002C                 Bra       L1556
A45A   1018           L1555:     Move.B    (A0)+, D0
A45C   3200                      Move      D0, D1
A45E   E809                      LsR.B     $4, D1
A460   12FB 1012                 Move.B    DT47(D1.W), (A1)+
A464   0240 000F                 And       $F, D0
A468   12FB 000A                 Move.B    DT47(D0.W), (A1)+
A46C   B3CB                      CmpA.L    A3, A1
A46E   65EA                      BCS       L1555
A470   6000 005C                 Bra       L1564

                      DT47:
A474   0003 0C0F 3033            DC.B      '    03'
A47A   3C3F C0C3 CCCF            DC.B      '<?    '
A480   F0F3 FCFF                 DC.B      '    '
A484   203C 8000 0000 L1556:     Move.L    $-80000000, D0
A48A   7201                      MoveQ.L   $1, D1
A48C   3404                      Move      D4, D2
A48E   E24A                      LsR       $1, D2
A490   4442                      Neg       D2
A492   D080           L1557:     Add.L     D0, D0
A494   6408                      BCC       L1558
A496   6616                      BNE       L1560
A498   2018                      Move.L    (A0)+, D0
A49A   D180                      AddX.L    D0, D0
A49C   6510                      BCS       L1560
A49E   D443           L1558:     Add       D3, D2
A4A0   6DF0                      BLT       L1557
A4A2   4245                      Clr       D5
A4A4   600E                      Bra       L1561
A4A6   D080           L1559:     Add.L     D0, D0
A4A8   6604                      BNE       L1560
A4AA   2018                      Move.L    (A0)+, D0
A4AC   D180                      AddX.L    D0, D0
A4AE   D443           L1560:     Add       D3, D2
A4B0   6DF4                      BLT       L1559
A4B2   7A01                      MoveQ.L   $1, D5
A4B4   D281           L1561:     Add.L     D1, D1
A4B6   640E                      BCC       L1562
A4B8   D245                      Add       D5, D1
A4BA   22C1                      Move.L    D1, (A1)+
A4BC   B3CB                      CmpA.L    A3, A1
A4BE   6400 000E                 BCC       L1564
A4C2   7201                      MoveQ.L   $1, D1
A4C4   6002                      Bra       L1563
A4C6   D245           L1562:     Add       D5, D1
A4C8   9444           L1563:     Sub       D4, D2
A4CA   6EE8                      BGT       L1561
A4CC   60C4                      Bra       L1557
A4CE   4CDF 1EFF      L1564:     MoveM.L   (A7)+, D0-D7/A1-A4
A4D2   4E5E                      Unlk      A6
A4D4   205F                      Move.L    (A7)+, A0
A4D6   DEFC 000E                 AddA      $E, A7
A4DA   4ED0                      Jmp       (A0)

                      P_tStdComment:
A4DC   4E56 0000                 Link      A6, $0
A4E0   48E7 0300                 MoveM.L   D6-D7, -(A7)
A4E4   2055                      Move.L    (A5), A0
A4E6   2050                      Move.L    (A0), A0
A4E8   4AA8 005C                 Tst.L     $5C(A0)
A4EC   674A                      BEQ       L1566
A4EE   3C2E 000E                 Move      $E(A6), D6
A4F2   3E2E 000C                 Move      $C(A6), D7
A4F6   6E10                      BGT       L1565
A4F8   1F3C 00A0                 Move.B    $-60, -(A7)
A4FC   4EBA 09B2                 Jsr       P_mPutPicByte
A500   3F06                      Move      D6, -(A7)
A502   4EBA 09BE                 Jsr       P_mPutPicWord
A506   6030                      Bra       L1566
A508   1F3C 00A1      L1565:     Move.B    $-5F, -(A7)
A50C   4EBA 09A2                 Jsr       P_mPutPicByte
A510   3F06                      Move      D6, -(A7)
A512   4EBA 09AE                 Jsr       P_mPutPicWord
A516   3F07                      Move      D7, -(A7)
A518   4EBA 09A8                 Jsr       P_mPutPicWord
A51C   2F2E 0008                 Move.L    $8(A6), -(A7)
A520   4EBA 0D10                 Jsr       P277
A524   206E 0008                 Move.L    $8(A6), A0
A528   2F10                      Move.L    (A0), -(A7)
A52A   3F07                      Move      D7, -(A7)
A52C   4EBA 096C                 Jsr       P_mPutPicData
A530   2F2E 0008                 Move.L    $8(A6), -(A7)
A534   4EBA 0D08                 Jsr       P278
A538   4CDF 00C0      L1566:     MoveM.L   (A7)+, D6-D7
A53C   4E5E                      Unlk      A6
A53E   205F                      Move.L    (A7)+, A0
A540   504F                      AddQ      $8, A7
A542   4ED0                      Jmp       (A0)

                      P_tStdGetPic:
A544   205F                      Move.L    (A7)+, A0
A546   321F                      Move      (A7)+, D1
A548   225F                      Move.L    (A7)+, A1
A54A   2F08                      Move.L    A0, -(A7)
A54C   2055                      Move.L    (A5), A0
A54E   3028 FF62                 Move      $-9E(A0), D0
A552   D368 FF62                 Add       D1, $-9E(A0)
A556   2068 FF64                 Move.L    $-9C(A0), A0
A55A   2050                      Move.L    (A0), A0
A55C   D0C0                      AddA      D0, A0
A55E   6002                      Bra       L1568
A560   12D8           L1567:     Move.B    (A0)+, (A1)+
A562   51C9 FFFC      L1568:     DBF       D1, L1567
A566   4E75                      Rts

                      P_tStdPutPic:
A568   4E56 0000                 Link      A6, $0
A56C   48E7 0310                 MoveM.L   D6-D7/A3, -(A7)
A570   2255                      Move.L    (A5), A1
A572   2251                      Move.L    (A1), A1
A574   4AA9 005C                 Tst.L     $5C(A1)
A578   6752                      BEQ       L1574
A57A   2269 005C                 Move.L    $5C(A1), A1
A57E   2251                      Move.L    (A1), A1
A580   2651                      Move.L    (A1), A3
A582   2053                      Move.L    (A3), A0
A584   3C2E 0008                 Move      $8(A6), D6
A588   3010                      Move      (A0), D0
A58A   6B40                      BMI       L1574
A58C   D046                      Add       D6, D0
A58E   6A10                      BPL       L1570
A590   30BC FFFF      L1569:     Move      $-1, (A0)
A594   2F0B                      Move.L    A3, -(A7)
A596   3F3C 000A                 Move      $A, -(A7)
A59A   4EBA 0C80                 Jsr       P_mSetHSize
A59E   602C                      Bra       L1574
A5A0   B069 0004      L1570:     Cmp       $4(A1), D0
A5A4   6F14                      BLE       L1571
A5A6   0640 0100                 Add       $100, D0
A5AA   6BE4                      BMI       L1569
A5AC   3340 0004                 Move      D0, $4(A1)
A5B0   2F0B                      Move.L    A3, -(A7)
A5B2   3F00                      Move      D0, -(A7)
A5B4   4EBA 0C66                 Jsr       P_mSetHSize
A5B8   2053                      Move.L    (A3), A0
A5BA   3010           L1571:     Move      (A0), D0
A5BC   DD50                      Add       D6, (A0)
A5BE   D0C0                      AddA      D0, A0
A5C0   226E 000A                 Move.L    $A(A6), A1
A5C4   6002                      Bra       L1573
A5C6   10D9           L1572:     Move.B    (A1)+, (A0)+
A5C8   51CE FFFC      L1573:     DBF       D6, L1572
A5CC   4CDF 08C0      L1574:     MoveM.L   (A7)+, D6-D7/A3
A5D0   4E5E                      Unlk      A6
A5D2   205F                      Move.L    (A7)+, A0
A5D4   5C4F                      AddQ      $6, A7
A5D6   4ED0                      Jmp       (A0)

                      P_tPicComment:
A5D8   2055                      Move.L    (A5), A0
A5DA   2050                      Move.L    (A0), A0
A5DC   2028 0068                 Move.L    $68(A0), D0
A5E0   41FA FEFA                 Lea.L     P_tStdComment, A0
A5E4   6706                      BEQ       L1575
A5E6   2040                      Move.L    D0, A0
A5E8   2068 0024                 Move.L    $24(A0), A0
A5EC   4ED0           L1575:     Jmp       (A0)

                      P_tOpenPicture:
A5EE   4E56 0000                 Link      A6, $0
A5F2   48E7 0018                 MoveM.L   A3-A4, -(A7)
A5F6   42AE 000C                 Clr.L     $C(A6)
A5FA   2855                      Move.L    (A5), A4
A5FC   2654                      Move.L    (A4), A3
A5FE   4AAB 005C                 Tst.L     $5C(A3)
A602   6600 008E                 BNE       L1576
A606   4EBA C266                 Jsr       P_tHidePen
A60A   42A7                      Clr.L     -(A7)
A60C   3F3C 005C                 Move      $5C, -(A7)
A610   4EBA 0BF6                 Jsr       P274
A614   285F                      Move.L    (A7)+, A4
A616   274C 005C                 Move.L    A4, $5C(A3)
A61A   42A7                      Clr.L     -(A7)
A61C   4EBA E864                 Jsr       P_tNewRgn
A620   42A7                      Clr.L     -(A7)
A622   3F3C 0100                 Move      $100, -(A7)
A626   4EBA 0BE0                 Jsr       P274
A62A   225F                      Move.L    (A7)+, A1
A62C   2D49 000C                 Move.L    A1, $C(A6)
A630   2854                      Move.L    (A4), A4
A632   28C9                      Move.L    A1, (A4)+
A634   2251                      Move.L    (A1), A1
A636   32FC 000A                 Move      $A, (A1)+
A63A   206E 0008                 Move.L    $8(A6), A0
A63E   22D8                      Move.L    (A0)+, (A1)+
A640   22D8                      Move.L    (A0)+, (A1)+
A642   38FC 0100                 Move      $100, (A4)+
A646   28DF                      Move.L    (A7)+, (A4)+
A648   429C                      Clr.L     (A4)+
A64A   429C                      Clr.L     (A4)+
A64C   429C                      Clr.L     (A4)+
A64E   38FC 0001                 Move      $1, (A4)+
A652   425C                      Clr       (A4)+
A654   429C                      Clr.L     (A4)+
A656   203C 0001 0001            Move.L    $10001, D0
A65C   28C0                      Move.L    D0, (A4)+
A65E   28C0                      Move.L    D0, (A4)+
A660   429C                      Clr.L     (A4)+
A662   429C                      Clr.L     (A4)+
A664   28C0                      Move.L    D0, (A4)+
A666   38FC 0008                 Move      $8, (A4)+
A66A   70FF                      MoveQ.L   $-1, D0
A66C   28C0                      Move.L    D0, (A4)+
A66E   28C0                      Move.L    D0, (A4)+
A670   28C0                      Move.L    D0, (A4)+
A672   28C0                      Move.L    D0, (A4)+
A674   429C                      Clr.L     (A4)+
A676   429C                      Clr.L     (A4)+
A678   429C                      Clr.L     (A4)+
A67A   28EB 0010                 Move.L    $10(A3), (A4)+
A67E   28FC 0000 0021            Move.L    $21, (A4)+
A684   28FC 0000 001E            Move.L    $1E, (A4)+
A68A   3F3C 1101                 Move      $1101, -(A7)
A68E   4EBA 0832                 Jsr       P_mPutPicWord
A692   4CDF 1800      L1576:     MoveM.L   (A7)+, A3-A4
A696   4E5E                      Unlk      A6
A698   2E9F                      Move.L    (A7)+, (A7)
A69A   4E75                      Rts

                      P_tClosePicture:
A69C   48E7 0318                 MoveM.L   D6-D7/A3-A4, -(A7)
A6A0   2855                      Move.L    (A5), A4
A6A2   2654                      Move.L    (A4), A3
A6A4   2E2B 005C                 Move.L    $5C(A3), D7
A6A8   6734                      BEQ       L1578
A6AA   1F3C 00FF                 Move.B    $-1, -(A7)
A6AE   4EBA 0800                 Jsr       P_mPutPicByte
A6B2   2047                      Move.L    D7, A0
A6B4   2050                      Move.L    (A0), A0
A6B6   2C28 0006                 Move.L    $6(A0), D6
A6BA   2250                      Move.L    (A0), A1
A6BC   2051                      Move.L    (A1), A0
A6BE   3010                      Move      (A0), D0
A6C0   6B08                      BMI       L1577
A6C2   2F09                      Move.L    A1, -(A7)
A6C4   3F00                      Move      D0, -(A7)
A6C6   4EBA 0B54                 Jsr       P_mSetHSize
A6CA   2F06           L1577:     Move.L    D6, -(A7)
A6CC   4EBA E7D8                 Jsr       P_tDisposeRgn
A6D0   2F07                      Move.L    D7, -(A7)
A6D2   4EBA 0B56                 Jsr       P276
A6D6   42AB 005C                 Clr.L     $5C(A3)
A6DA   4EBA C19C                 Jsr       P_tShowPen
A6DE   4CDF 18C0      L1578:     MoveM.L   (A7)+, D6-D7/A3-A4
A6E2   4E75                      Rts

                      P_tKillPicture:
A6E4   4EFA 0B44                 Jmp       P276

                      P_tDrawPicture:
A6E8   4E56 FF60                 Link      A6, $-A0
A6EC   48E7 1F38                 MoveM.L   D3-D7/A2-A4, -(A7)
A6F0   2855                      Move.L    (A5), A4
A6F2   2654                      Move.L    (A4), A3
A6F4   206E 0008                 Move.L    $8(A6), A0
A6F8   3028 0006                 Move      $6(A0), D0
A6FC   9068 0002                 Sub       $2(A0), D0
A700   6F00 0100                 BLE       L1582
A704   3D40 FFF2                 Move      D0, $-E(A6)
A708   3028 0004                 Move      $4(A0), D0
A70C   9050                      Sub       (A0), D0
A70E   6F00 00F2                 BLE       L1582
A712   3D40 FFF0                 Move      D0, $-10(A6)
A716   43EE FFE8                 Lea.L     $-18(A6), A1
A71A   22D8                      Move.L    (A0)+, (A1)+
A71C   22D8                      Move.L    (A0)+, (A1)+
A71E   206E 000C                 Move.L    $C(A6), A0
A722   2050                      Move.L    (A0), A0
A724   41E8 0002                 Lea.L     $2(A0), A0
A728   3028 0006                 Move      $6(A0), D0
A72C   9068 0002                 Sub       $2(A0), D0
A730   6F00 00D0                 BLE       L1582
A734   3D40 FFF6                 Move      D0, $-A(A6)
A738   3028 0004                 Move      $4(A0), D0
A73C   9050                      Sub       (A0), D0
A73E   6F00 00C2                 BLE       L1582
A742   3D40 FFF4                 Move      D0, $-C(A6)
A746   43EE FFE0                 Lea.L     $-20(A6), A1
A74A   22D8                      Move.L    (A0)+, (A1)+
A74C   22D8                      Move.L    (A0)+, (A1)+
A74E   204B                      Move.L    A3, A0
A750   43EE FF60                 Lea.L     $-A0(A6), A1
A754   7035                      MoveQ.L   $35, D0
A756   32D8           L1579:     Move      (A0)+, (A1)+
A758   51C8 FFFC                 DBF       D0, L1579
A75C   42AC FF58                 Clr.L     $-A8(A4)
A760   296E 000C FF64            Move.L    $C(A6), $-9C(A4)
A766   397C 000A FF62            Move      $A, $-9E(A4)
A76C   41EE FFCC                 Lea.L     $-34(A6), A0
A770   4298                      Clr.L     (A0)+
A772   4298                      Clr.L     (A0)+
A774   4298                      Clr.L     (A0)+
A776   4298                      Clr.L     (A0)+
A778   4298                      Clr.L     (A0)+
A77A   2D6B 001C FFFC            Move.L    $1C(A3), $-4(A6)
A780   42A7                      Clr.L     -(A7)
A782   4EBA E6FE                 Jsr       P_tNewRgn
A786   2D5F FFF8                 Move.L    (A7)+, $-8(A6)
A78A   42A7                      Clr.L     -(A7)
A78C   4EBA E6F4                 Jsr       P_tNewRgn
A790   275F 001C                 Move.L    (A7)+, $1C(A3)
A794   41EB 0020                 Lea.L     $20(A3), A0
A798   4298                      Clr.L     (A0)+
A79A   4298                      Clr.L     (A0)+
A79C   70FF                      MoveQ.L   $-1, D0
A79E   20C0                      Move.L    D0, (A0)+
A7A0   20C0                      Move.L    D0, (A0)+
A7A2   4298                      Clr.L     (A0)+
A7A4   223C 0001 0001            Move.L    $10001, D1
A7AA   20C1                      Move.L    D1, (A0)+
A7AC   30FC 0008                 Move      $8, (A0)+
A7B0   20C0                      Move.L    D0, (A0)+
A7B2   20C0                      Move.L    D0, (A0)+
A7B4   5448                      AddQ      $2, A0
A7B6   4298                      Clr.L     (A0)+
A7B8   30FC 0001                 Move      $1, (A0)+
A7BC   4258                      Clr       (A0)+
A7BE   4298                      Clr.L     (A0)+
A7C0   20FC 0000 0021            Move.L    $21, (A0)+
A7C6   20FC 0000 001E            Move.L    $1E, (A0)+
A7CC   4227           L1580:     Clr.B     -(A7)
A7CE   486E FFCC                 Pea.L     $-34(A6)
A7D2   4EBA 003A                 Jsr       P_mPicItem
A7D6   101F                      Move.B    (A7)+, D0
A7D8   66F2                      BNE       L1580
A7DA   2F2E FFF8                 Move.L    $-8(A6), -(A7)
A7DE   4EBA E6C6                 Jsr       P_tDisposeRgn
A7E2   2F2B 001C                 Move.L    $1C(A3), -(A7)
A7E6   4EBA E6BE                 Jsr       P_tDisposeRgn
A7EA   41EE FF60                 Lea.L     $-A0(A6), A0
A7EE   7035                      MoveQ.L   $35, D0
A7F0   36D8           L1581:     Move      (A0)+, (A3)+
A7F2   51C8 FFFC                 DBF       D0, L1581
A7F6   42AC FF58                 Clr.L     $-A8(A4)
A7FA   42AC FF64                 Clr.L     $-9C(A4)
A7FE   426C FF62                 Clr       $-9E(A4)
A802   4CDF 1CF8      L1582:     MoveM.L   (A7)+, D3-D7/A2-A4
A806   4E5E                      Unlk      A6
A808   205F                      Move.L    (A7)+, A0
A80A   504F                      AddQ      $8, A7
A80C   4ED0                      Jmp       (A0)

                      P_mPicItem:
A80E   4E56 FECC                 Link      A6, $-134
A812   48E7 1F38                 MoveM.L   D3-D7/A2-A4, -(A7)
A816   2855                      Move.L    (A5), A4
A818   2654                      Move.L    (A4), A3
A81A   6100 0594                 Bsr       P255
A81E   3E00                      Move      D0, D7
A820   0C07 00FF                 Cmp.B     $-1, D7
A824   6608                      BNE       L1583
A826   422E 000C                 Clr.B     $C(A6)
A82A   6000 064E                 Bra       E_449
A82E   1D7C 0001 000C L1583:     Move.B    $1, $C(A6)
A834   0C47 0020                 Cmp       $20, D7
A838   6500 0040                 BCS       L1584
A83C   1007                      Move.B    D7, D0
A83E   0240 00F0                 And       $F0, D0
A842   0807 0003                 BTst.B    $3, D7
A846   56EE FFD8                 SNE.B     $-28(A6)
A84A   0247 0007                 And       $7, D7
A84E   E648                      LsR       $3, D0
A850   303B 0006                 Move      DT48(D0.W), D0
A854   4EFB 0002                 Jmp       DT48(D0.W)

                      DT48:
A858   0622 0622 01B2            DC.B      ' " "  '
A85E   02C4 02E0 0304            DC.B      '      '
A864   0320 0348 037C            DC.B      '   H |'
A86A   03B0 0484 0622            DC.B      '     "'
A870   0622 0622 0622            DC.B      ' " " "'
A876   0622 0622                 DC.B      ' " "'
A87A   0247 001F      L1584:     And       $1F, D7
A87E   DE47                      Add       D7, D7
A880   303B 7006                 Move      DT49(D7.W), D0
A884   4EFB 0002                 Jmp       DT49(D0.W)

                      DT49:
A888   05F2 0040 009E            DC.B      '   @  '
A88E   00A4 00AA 00B4            DC.B      '      '
A894   00C0 00C6 0116            DC.B      '      '
A89A   011E 0126 012E            DC.B      '   & .'
A8A0   014E 00BA 0092            DC.B      ' N    '
A8A6   0098 00E6 010E            DC.B      '      '
A8AC   05F2 05F2 05F2            DC.B      '      '
A8B2   05F2 05F2 05F2            DC.B      '      '
A8B8   05F2 05F2 05F2            DC.B      '      '
A8BE   05F2 05F2 05F2            DC.B      '      '
A8C4   05F2 05F2                 DC.B      '    '

                      E_423:
A8C8   6100 0564                 Bsr       P260
A8CC   246E 0008                 Move.L    $8(A6), A2
A8D0   2F2E FFFC                 Move.L    $-4(A6), -(A7)
A8D4   2F2A 002C                 Move.L    $2C(A2), -(A7)
A8D8   4EBA E668      L1585:     Jsr       P_tCopyRgn
A8DC   246E 0008                 Move.L    $8(A6), A2
A8E0   2F2E FFFC                 Move.L    $-4(A6), -(A7)
A8E4   486A 0014                 Pea.L     $14(A2)
A8E8   486A 001C                 Pea.L     $1C(A2)
A8EC   4EBA EAA8                 Jsr       P_tMapRgn
A8F0   246E 0008                 Move.L    $8(A6), A2
A8F4   2F2E FFFC                 Move.L    $-4(A6), -(A7)
A8F8   2F2A 0030                 Move.L    $30(A2), -(A7)
A8FC   2F2B 001C                 Move.L    $1C(A3), -(A7)
A900   4EBA E82E                 Jsr       P_tSectRgn
A904   6000 056C                 Bra       L1609
A908   7C08           L1586:     MoveQ.L   $8, D6
A90A   6000 0498                 Bra       L1604
A90E   7C04           L1587:     MoveQ.L   $4, D6
A910   6000 0492                 Bra       L1604
A914   7C02           L1588:     MoveQ.L   $2, D6
A916   6000 048C                 Bra       L1604

                      E_424:
A91A   47EB 0050                 Lea.L     $50(A3), A3
A91E   60EE                      Bra       L1587

                      E_425:
A920   47EB 0054                 Lea.L     $54(A3), A3
A924   60E8                      Bra       L1587

                      E_426:
A926   47EB 0020                 Lea.L     $20(A3), A3
A92A   60DC                      Bra       L1586

                      E_427:
A92C   47EB 0044                 Lea.L     $44(A3), A3
A930   60E2                      Bra       L1588

                      E_428:
A932   47EB 0046                 Lea.L     $46(A3), A3
A936   7C01                      MoveQ.L   $1, D6
A938   6000 046A                 Bra       L1604

                      E_429:
A93C   47EB 0048                 Lea.L     $48(A3), A3
A940   60D2                      Bra       L1588

                      E_430:
A942   47EB 004A                 Lea.L     $4A(A3), A3
A946   60CC                      Bra       L1588

                      E_431:
A948   47EB 004C                 Lea.L     $4C(A3), A3
A94C   60C0                      Bra       L1587

                      E_432:
A94E   4EBA 0494                 Jsr       P258
A952   2740 0034                 Move.L    D0, $34(A3)
A956   486B 0034                 Pea.L     $34(A3)
A95A   246E 0008                 Move.L    $8(A6), A2
A95E   486A 0014                 Pea.L     $14(A2)
A962   486A 001C                 Pea.L     $1C(A2)
A966   4EBA 07CE                 Jsr       P_tScalePt
A96A   6000 050E                 Bra       E_449

                      E_433:
A96E   266E 0008                 Move.L    $8(A6), A3
A972   4EBA 0470                 Jsr       P258
A976   2740 0024                 Move.L    D0, $24(A3)
A97A   4EBA 0468                 Jsr       P258
A97E   2740 0028                 Move.L    D0, $28(A3)
A982   486B 0024                 Pea.L     $24(A3)
A986   486B 0014                 Pea.L     $14(A3)
A98A   486B 001C                 Pea.L     $1C(A3)
A98E   4EBA 07A6                 Jsr       P_tScalePt
A992   6000 04E6                 Bra       E_449

                      E_434:
A996   6100 0418                 Bsr       P255
A99A   6000 04DE                 Bra       E_449

                      E_435:
A99E   47EB 0038                 Lea.L     $38(A3), A3
A9A2   6000 FF70                 Bra       L1588

                      E_436:
A9A6   47EB 003A                 Lea.L     $3A(A3), A3
A9AA   6000 FF5C                 Bra       L1586

                      E_437:
A9AE   47EB 0028                 Lea.L     $28(A3), A3
A9B2   6000 FF54                 Bra       L1586

                      E_438:
A9B6   4EBA 042C                 Jsr       P258
A9BA   246E 0008                 Move.L    $8(A6), A2
A9BE   2540 0010                 Move.L    D0, $10(A2)
A9C2   486A 0010                 Pea.L     $10(A2)
A9C6   486A 0014                 Pea.L     $14(A2)
A9CA   486A 001C                 Pea.L     $1C(A2)
A9CE   4EBA 0766                 Jsr       P_tScalePt
A9D2   6000 04A6                 Bra       E_449

                      E_439:
A9D6   4EBA 040C                 Jsr       P258
A9DA   246E 0008                 Move.L    $8(A6), A2
A9DE   D16A 0014                 Add       D0, $14(A2)
A9E2   D16A 0018                 Add       D0, $18(A2)
A9E6   D16C FF58                 Add       D0, $-A8(A4)
A9EA   4840                      Swap      D0
A9EC   D16A 0016                 Add       D0, $16(A2)
A9F0   D16A 001A                 Add       D0, $1A(A2)
A9F4   D16C FF5A                 Add       D0, $-A6(A4)
A9F8   2F2A 002C                 Move.L    $2C(A2), -(A7)
A9FC   42A7                      Clr.L     -(A7)
A9FE   4EBA E482                 Jsr       P_tNewRgn
AA02   2D57 FFFC                 Move.L    (A7), $-4(A6)
AA06   6000 FED0                 Bra       L1585

                      E_440:
AA0A   4A2E FFD8                 Tst.B     $-28(A6)
AA0E   6600 0084                 BNE       L1592
AA12   246E 0008                 Move.L    $8(A6), A2
AA16   202A 0008                 Move.L    $8(A2), D0
AA1A   0807 0000                 BTst.B    $0, D7
AA1E   6604                      BNE       L1589
AA20   6100 03C2                 Bsr       P258
AA24   2740 0030      L1589:     Move.L    D0, $30(A3)
AA28   2D40 FFD4                 Move.L    D0, $-2C(A6)
AA2C   246E 0008                 Move.L    $8(A6), A2
AA30   486B 0030                 Pea.L     $30(A3)
AA34   486A 0014                 Pea.L     $14(A2)
AA38   486A 001C                 Pea.L     $1C(A2)
AA3C   4EBA 0750                 Jsr       P_tMapPt
AA40   0807 0001                 BTst.B    $1, D7
AA44   660A                      BNE       L1590
AA46   6100 039C                 Bsr       P258
AA4A   2D40 FFD4                 Move.L    D0, $-2C(A6)
AA4E   6010                      Bra       L1591
AA50   6100 0370      L1590:     Bsr       P256
AA54   D16E FFD6                 Add       D0, $-2A(A6)
AA58   6100 0368                 Bsr       P256
AA5C   D16E FFD4                 Add       D0, $-2C(A6)
AA60   246E 0008      L1591:     Move.L    $8(A6), A2
AA64   256E FFD4 0008            Move.L    $-2C(A6), $8(A2)
AA6A   486E FFD4                 Pea.L     $-2C(A6)
AA6E   486A 0014                 Pea.L     $14(A2)
AA72   486A 001C                 Pea.L     $1C(A2)
AA76   4EBA 0716                 Jsr       P_tMapPt
AA7A   2F2E FFD4                 Move.L    $-2C(A6), -(A7)
AA7E   41FA BC90                 Lea.L     P_tStdLine, A0
AA82   202B 0068                 Move.L    $68(A3), D0
AA86   6700 03DA                 BEQ       L1606
AA8A   2040                      Move.L    D0, A0
AA8C   2068 0004                 Move.L    $4(A0), A0
AA90   6000 03D0                 Bra       L1606
AA94   0247 0003      L1592:     And       $3, D7
AA98   6726                      BEQ       L1594
AA9A   0807 0000                 BTst.B    $0, D7
AA9E   670C                      BEQ       L1593
AAA0   6100 030E                 Bsr       P255
AAA4   246E 0008                 Move.L    $8(A6), A2
AAA8   D16A 000E                 Add       D0, $E(A2)
AAAC   0807 0001      L1593:     BTst.B    $1, D7
AAB0   671A                      BEQ       L1595
AAB2   6100 02FC                 Bsr       P255
AAB6   246E 0008                 Move.L    $8(A6), A2
AABA   D16A 000C                 Add       D0, $C(A2)
AABE   600C                      Bra       L1595
AAC0   6100 0322      L1594:     Bsr       P258
AAC4   246E 0008                 Move.L    $8(A6), A2
AAC8   2540 000C                 Move.L    D0, $C(A2)
AACC   6100 02E2      L1595:     Bsr       P255
AAD0   3C00                      Move      D0, D6
AAD2   486E FED4                 Pea.L     $-12C(A6)
AAD6   3F06                      Move      D6, -(A7)
AAD8   4EBA 03AA                 Jsr       P_mGetPicData
AADC   246E 0008                 Move.L    $8(A6), A2
AAE0   276A 000C 0030            Move.L    $C(A2), $30(A3)
AAE6   486B 0030                 Pea.L     $30(A3)
AAEA   486A 0014                 Pea.L     $14(A2)
AAEE   486A 001C                 Pea.L     $1C(A2)
AAF2   4EBA 069A                 Jsr       P_tMapPt
AAF6   3F06                      Move      D6, -(A7)
AAF8   486E FED4                 Pea.L     $-12C(A6)
AAFC   246E 0008                 Move.L    $8(A6), A2
AB00   2F2A 0024                 Move.L    $24(A2), -(A7)
AB04   2F2A 0028                 Move.L    $28(A2), -(A7)
AB08   41FA B0FC                 Lea.L     P_tStdText, A0
AB0C   202B 0068                 Move.L    $68(A3), D0
AB10   6700 0350                 BEQ       L1606
AB14   2040                      Move.L    D0, A0
AB16   2050                      Move.L    (A0), A0
AB18   6000 0348                 Bra       L1606

                      E_441:
AB1C   1F07                      Move.B    D7, -(A7)
AB1E   6100 02D4                 Bsr       P259
AB22   41FA C3F8                 Lea.L     P_tStdRect, A0
AB26   202B 0068                 Move.L    $68(A3), D0
AB2A   6700 0336                 BEQ       L1606
AB2E   2040                      Move.L    D0, A0
AB30   2068 0008                 Move.L    $8(A0), A0
AB34   6000 032C                 Bra       L1606

                      E_442:
AB38   1F07                      Move.B    D7, -(A7)
AB3A   6100 02B8                 Bsr       P259
AB3E   246E 0008                 Move.L    $8(A6), A2
AB42   2F2A 0010                 Move.L    $10(A2), -(A7)
AB46   41FA D142                 Lea.L     P_tStdRRect, A0
AB4A   202B 0068                 Move.L    $68(A3), D0
AB4E   6700 0312                 BEQ       L1606
AB52   2040                      Move.L    D0, A0
AB54   2068 000C                 Move.L    $C(A0), A0
AB58   6000 0308                 Bra       L1606

                      E_443:
AB5C   1F07                      Move.B    D7, -(A7)
AB5E   6100 0294                 Bsr       P259
AB62   41FA D212                 Lea.L     P_tStdOval, A0
AB66   202B 0068                 Move.L    $68(A3), D0
AB6A   6700 02F6                 BEQ       L1606
AB6E   2040                      Move.L    D0, A0
AB70   2068 0010                 Move.L    $10(A0), A0
AB74   6000 02EC                 Bra       L1606

                      E_444:
AB78   1F07                      Move.B    D7, -(A7)
AB7A   6100 0278                 Bsr       P259
AB7E   6100 0254                 Bsr       P257
AB82   3F00                      Move      D0, -(A7)
AB84   6100 024E                 Bsr       P257
AB88   3F00                      Move      D0, -(A7)
AB8A   41FA D3FA                 Lea.L     P_tStdArc, A0
AB8E   202B 0068                 Move.L    $68(A3), D0
AB92   6700 02CE                 BEQ       L1606
AB96   2040                      Move.L    D0, A0
AB98   2068 0014                 Move.L    $14(A0), A0
AB9C   6000 02C4                 Bra       L1606

                      E_445:
ABA0   6100 028C                 Bsr       P260
ABA4   2F2E FFFC                 Move.L    $-4(A6), -(A7)
ABA8   246E 0008                 Move.L    $8(A6), A2
ABAC   486A 0014                 Pea.L     $14(A2)
ABB0   486A 001C                 Pea.L     $1C(A2)
ABB4   4EBA E06C                 Jsr       P_tMapPoly
ABB8   1F07                      Move.B    D7, -(A7)
ABBA   2F2E FFFC                 Move.L    $-4(A6), -(A7)
ABBE   41FA DED4                 Lea.L     P_tStdPoly, A0
ABC2   202B 0068                 Move.L    $68(A3), D0
ABC6   6700 029E                 BEQ       L1607
ABCA   2040                      Move.L    D0, A0
ABCC   2068 0018                 Move.L    $18(A0), A0
ABD0   6000 0294                 Bra       L1607

                      E_446:
ABD4   6100 0258                 Bsr       P260
ABD8   2F2E FFFC                 Move.L    $-4(A6), -(A7)
ABDC   246E 0008                 Move.L    $8(A6), A2
ABE0   486A 0014                 Pea.L     $14(A2)
ABE4   486A 001C                 Pea.L     $1C(A2)
ABE8   4EBA E7AC                 Jsr       P_tMapRgn
ABEC   1F07                      Move.B    D7, -(A7)
ABEE   2F2E FFFC                 Move.L    $-4(A6), -(A7)
ABF2   41FA E124                 Lea.L     P_tStdRgn, A0
ABF6   202B 0068                 Move.L    $68(A3), D0
ABFA   6700 026A                 BEQ       L1607
ABFE   2040                      Move.L    D0, A0
AC00   2068 001C                 Move.L    $1C(A0), A0
AC04   6000 0260                 Bra       L1607

                      E_447:
AC08   486E FFDE                 Pea.L     $-22(A6)
AC0C   3F3C 001A                 Move      $1A, -(A7)
AC10   4EBA 0272                 Jsr       P_mGetPicData
AC14   246E 0008                 Move.L    $8(A6), A2
AC18   486E FFF0                 Pea.L     $-10(A6)
AC1C   486A 0014                 Pea.L     $14(A2)
AC20   486A 001C                 Pea.L     $1C(A2)
AC24   4EBA 05CA                 Jsr       P_tMapRect
AC28   486E FFDA                 Pea.L     $-26(A6)
AC2C   486E FFE8                 Pea.L     $-18(A6)
AC30   486E FFF0                 Pea.L     $-10(A6)
AC34   6100 019E                 Bsr       P257
AC38   3F00                      Move      D0, -(A7)
AC3A   4A47                      Tst       D7
AC3C   6604                      BNE       L1596
AC3E   42A7                      Clr.L     -(A7)
AC40   600E                      Bra       L1597
AC42   6100 01EA      L1596:     Bsr       P260
AC46   2F2E FFFC                 Move.L    $-4(A6), -(A7)
AC4A   2D6E FFFC FFF8            Move.L    $-4(A6), $-8(A6)
AC50   3C2E FFE4      L1597:     Move      $-1C(A6), D6
AC54   9C6E FFE0                 Sub       $-20(A6), D6
AC58   3A06                      Move      D6, D5
AC5A   CAEE FFDE                 MulU      $-22(A6), D5
AC5E   42A7                      Clr.L     -(A7)
AC60   3F05                      Move      D5, -(A7)
AC62   4EBA 05A4                 Jsr       P274
AC66   2D57 FFFC                 Move.L    (A7), $-4(A6)
AC6A   4EBA 05C6                 Jsr       P277
AC6E   206E FFFC                 Move.L    $-4(A6), A0
AC72   4A2E FFD8                 Tst.B     $-28(A6)
AC76   672E                      BEQ       L1600
AC78   2D50 FECC                 Move.L    (A0), $-134(A6)
AC7C   6022                      Bra       L1599
AC7E   6100 0130      L1598:     Bsr       P255
AC82   486E FED4                 Pea.L     $-12C(A6)
AC86   2D57 FED0                 Move.L    (A7), $-130(A6)
AC8A   3F00                      Move      D0, -(A7)
AC8C   4EBA 01F6                 Jsr       P_mGetPicData
AC90   486E FED0                 Pea.L     $-130(A6)
AC94   486E FECC                 Pea.L     $-134(A6)
AC98   3F2E FFDE                 Move      $-22(A6), -(A7)
AC9C   4EBA F13A                 Jsr       P_tUnpackBits
ACA0   51CE FFDC      L1599:     DBF       D6, L1598
ACA4   6008                      Bra       L1601
ACA6   2F10           L1600:     Move.L    (A0), -(A7)
ACA8   3F05                      Move      D5, -(A7)
ACAA   4EBA 01D8                 Jsr       P_mGetPicData
ACAE   206E FFFC      L1601:     Move.L    $-4(A6), A0
ACB2   2D50 FFDA                 Move.L    (A0), $-26(A6)
ACB6   41FA ED66                 Lea.L     P_tStdBits, A0
ACBA   202B 0068                 Move.L    $68(A3), D0
ACBE   6700 0008                 BEQ       L1602
ACC2   2040                      Move.L    D0, A0
ACC4   2068 0020                 Move.L    $20(A0), A0
ACC8   4E90           L1602:     Jsr       (A0)
ACCA   2F2E FFFC                 Move.L    $-4(A6), -(A7)
ACCE   4EBA 056E                 Jsr       P278
ACD2   4A47                      Tst       D7
ACD4   6700 019C                 BEQ       L1609
ACD8   6000 0190                 Bra       L1608

                      E_448:
ACDC   6100 00F6                 Bsr       P257
ACE0   3F00                      Move      D0, -(A7)
ACE2   4A07                      Tst.B     D7
ACE4   661A                      BNE       L1603
ACE6   4267                      Clr       -(A7)
ACE8   42A7                      Clr.L     -(A7)
ACEA   41FA F7F0                 Lea.L     P_tStdComment, A0
ACEE   202B 0068                 Move.L    $68(A3), D0
ACF2   6700 016E                 BEQ       L1606
ACF6   2040                      Move.L    D0, A0
ACF8   2068 0024                 Move.L    $24(A0), A0
ACFC   6000 0164                 Bra       L1606
AD00   6100 00D2      L1603:     Bsr       P257
AD04   3F00                      Move      D0, -(A7)
AD06   4244                      Clr       D4
AD08   6100 0128                 Bsr       P261
AD0C   2F2E FFFC                 Move.L    $-4(A6), -(A7)
AD10   41FA F7CA                 Lea.L     P_tStdComment, A0
AD14   202B 0068                 Move.L    $68(A3), D0
AD18   6700 014C                 BEQ       L1607
AD1C   2040                      Move.L    D0, A0
AD1E   2068 0024                 Move.L    $24(A0), A0
AD22   6000 0142                 Bra       L1607
                      ; Missing Block
AD26   2055                      Move.L    (A5), A0
AD28   2268 FF86                 Move.L    $-7A(A0), A1
AD2C   3028 FF8A                 Move      $-76(A0), D0
AD30   41FA 000E                 Lea.L     DT60, A0
AD34   7218                      MoveQ.L   $18, D1
AD36   2298           L2329:     Move.L    (A0)+, (A1)
AD38   D2C0                      AddA      D0, A1
AD3A   51C9 FFFA                 DBF       D1, L2329
AD3E   60FE           L2330:     Bra       L2330
AD40   0000 0000 7EE9 DT60:      DC.B      '    ~ '
AD46   D200 44A9 1A00            DC.B      '  D   '
AD4C   74A9 9610 14A9            DC.B      't     '
AD52   1230 74EF D260            DC.B      ' 0t  `'
AD58   0000 0040 7774            DC.B      '   @wt'
AD5E   4358 4557 C7FC            DC.B      'CXEW  '
AD64   7755 4FFE 4654            DC.B      'wUO FT'
AD6A   4FF8 4574 4FF0            DC.B      'O EtO '
AD70   0000 0FF0 7774            DC.B      '    wt'
AD76   EFF8 5554 8FFE            DC.B      '  UT  '
AD7C   7774 CFFE 5444            DC.B      'wt  TD'
AD82   87BC 5447 E318            DC.B      '  TG  '
AD88   0000 0000 7745            DC.B      '    wE'
AD8E   D7FE 456D 554A            DC.B      '  EmUJ'
AD94   4555 D56E 4545            DC.B      'EU nEE'
AD9A   154C 7745 1D7A            DC.B      ' LwE z'
ADA0   0000 0000                 DC.B      '    '
ADA4   2F0B           L1604:     Move.L    A3, -(A7)
ADA6   3F06                      Move      D6, -(A7)
ADA8   4EBA 00DA                 Jsr       P_mGetPicData
ADAC   6000 00CC                 Bra       E_449

                      P255:
ADB0   4227                      Clr.B     -(A7)
ADB2   2F0F                      Move.L    A7, -(A7)
ADB4   3F3C 0001                 Move      $1, -(A7)
ADB8   4EBA 00CA                 Jsr       P_mGetPicData
ADBC   4240                      Clr       D0
ADBE   101F                      Move.B    (A7)+, D0
ADC0   4E75                      Rts

                      P256:
ADC2   4227                      Clr.B     -(A7)
ADC4   2F0F                      Move.L    A7, -(A7)
ADC6   3F3C 0001                 Move      $1, -(A7)
ADCA   4EBA 00B8                 Jsr       P_mGetPicData
ADCE   101F                      Move.B    (A7)+, D0
ADD0   4880                      Ext       D0
ADD2   4E75                      Rts

                      P257:
ADD4   4267                      Clr       -(A7)
ADD6   2F0F                      Move.L    A7, -(A7)
ADD8   3F3C 0002                 Move      $2, -(A7)
ADDC   4EBA 00A6                 Jsr       P_mGetPicData
ADE0   301F                      Move      (A7)+, D0
ADE2   4E75                      Rts

                      P258:
ADE4   42A7                      Clr.L     -(A7)
ADE6   2F0F                      Move.L    A7, -(A7)
ADE8   3F3C 0004                 Move      $4, -(A7)
ADEC   4EBA 0096                 Jsr       P_mGetPicData
ADF0   201F                      Move.L    (A7)+, D0
ADF2   4E75                      Rts

                      P259:
ADF4   4A2E FFD8                 Tst.B     $-28(A6)
ADF8   660E                      BNE       L1605
ADFA   246E 0008                 Move.L    $8(A6), A2
ADFE   4852                      Pea.L     (A2)
AE00   3F3C 0008                 Move      $8, -(A7)
AE04   4EBA 007E                 Jsr       P_mGetPicData
AE08   246E 0008      L1605:     Move.L    $8(A6), A2
AE0C   2D52 FFF0                 Move.L    (A2), $-10(A6)
AE10   2D6A 0004 FFF4            Move.L    $4(A2), $-C(A6)
AE16   486E FFF0                 Pea.L     $-10(A6)
AE1A   486A 0014                 Pea.L     $14(A2)
AE1E   486A 001C                 Pea.L     $1C(A2)
AE22   4EBA 03CC                 Jsr       P_tMapRect
AE26   205F                      Move.L    (A7)+, A0
AE28   486E FFF0                 Pea.L     $-10(A6)
AE2C   4ED0                      Jmp       (A0)

                      P260:
AE2E   7802                      MoveQ.L   $2, D4
AE30   61A2                      Bsr       P257

                      P261:
AE32   3A00                      Move      D0, D5
AE34   42A7                      Clr.L     -(A7)
AE36   3F05                      Move      D5, -(A7)
AE38   4EBA 03CE                 Jsr       P274
AE3C   2D57 FFFC                 Move.L    (A7), $-4(A6)
AE40   4EBA 03F0                 Jsr       P277
AE44   206E FFFC                 Move.L    $-4(A6), A0
AE48   2050                      Move.L    (A0), A0
AE4A   3085                      Move      D5, (A0)
AE4C   9A44                      Sub       D4, D5
AE4E   4870 4000                 Pea.L     $0(A0,D4.W)
AE52   3F05                      Move      D5, -(A7)
AE54   4EBA 002E                 Jsr       P_mGetPicData
AE58   2F2E FFFC                 Move.L    $-4(A6), -(A7)
AE5C   4EBA 03E0                 Jsr       P278
AE60   4E75                      Rts
AE62   4E90           L1606:     Jsr       (A0)
AE64   6014                      Bra       E_449
AE66   4E90           L1607:     Jsr       (A0)
AE68   6008                      Bra       L1609
AE6A   2F2E FFF8      L1608:     Move.L    $-8(A6), -(A7)
AE6E   4EBA 03BA                 Jsr       P276
AE72   2F2E FFFC      L1609:     Move.L    $-4(A6), -(A7)
AE76   4EBA 03B2                 Jsr       P276

                      E_449:
AE7A   4CDF 1CF8                 MoveM.L   (A7)+, D3-D7/A2-A4
AE7E   4E5E                      Unlk      A6
AE80   2E9F                      Move.L    (A7)+, (A7)
AE82   4E75                      Rts

                      P_mGetPicData:
AE84   2055                      Move.L    (A5), A0
AE86   2050                      Move.L    (A0), A0
AE88   2028 0068                 Move.L    $68(A0), D0
AE8C   6604                      BNE       L1610
AE8E   4EFA F6B4                 Jmp       P_tStdGetPic
AE92   2040           L1610:     Move.L    D0, A0
AE94   2068 002C                 Move.L    $2C(A0), A0
AE98   4ED0                      Jmp       (A0)

                      P_mPutPicData:
AE9A   2055                      Move.L    (A5), A0
AE9C   2050                      Move.L    (A0), A0
AE9E   2028 0068                 Move.L    $68(A0), D0
AEA2   6604                      BNE       L1611
AEA4   4EFA F6C2                 Jmp       P_tStdPutPic
AEA8   2040           L1611:     Move.L    D0, A0
AEAA   2068 0030                 Move.L    $30(A0), A0
AEAE   4ED0                      Jmp       (A0)

                      P_mPutPicByte:
AEB0   486F 0004                 Pea.L     $4(A7)
AEB4   3F3C 0001                 Move      $1, -(A7)
AEB8   4EBA FFE0                 Jsr       P_mPutPicData
AEBC   205F                      Move.L    (A7)+, A0
AEBE   4A1F                      Tst.B     (A7)+
AEC0   4ED0                      Jmp       (A0)

                      P_mPutPicWord:
AEC2   486F 0004                 Pea.L     $4(A7)
AEC6   3F3C 0002                 Move      $2, -(A7)
AECA   4EBA FFCE                 Jsr       P_mPutPicData
AECE   205F                      Move.L    (A7)+, A0
AED0   4A5F                      Tst       (A7)+
AED2   4ED0                      Jmp       (A0)

                      P_mPutPicLong:
AED4   486F 0004                 Pea.L     $4(A7)
AED8   3F3C 0004                 Move      $4, -(A7)
AEDC   4EBA FFBC                 Jsr       P_mPutPicData
AEE0   2E9F                      Move.L    (A7)+, (A7)
AEE2   4E75                      Rts

                      P_mPutPicPat:
AEE4   205F                      Move.L    (A7)+, A0
AEE6   3F3C 0008                 Move      $8, -(A7)
AEEA   2F08                      Move.L    A0, -(A7)
AEEC   4EFA FFAC                 Jmp       P_mPutPicData

                      P_mPutPicRect:
AEF0   205F                      Move.L    (A7)+, A0
AEF2   225F                      Move.L    (A7)+, A1
AEF4   141F                      Move.B    (A7)+, D2
AEF6   2F08                      Move.L    A0, -(A7)
AEF8   2011                      Move.L    (A1), D0
AEFA   2229 0004                 Move.L    $4(A1), D1
AEFE   2055                      Move.L    (A5), A0
AF00   2050                      Move.L    (A0), A0
AF02   2068 005C                 Move.L    $5C(A0), A0
AF06   2050                      Move.L    (A0), A0
AF08   B0A8 0044                 Cmp.L     $44(A0), D0
AF0C   6610                      BNE       L1612
AF0E   B2A8 0048                 Cmp.L     $48(A0), D1
AF12   660A                      BNE       L1612
AF14   5042                      AddQ      $8, D2
AF16   1F02                      Move.B    D2, -(A7)
AF18   4EBA FF96                 Jsr       P_mPutPicByte
AF1C   4E75                      Rts
AF1E   2140 0044      L1612:     Move.L    D0, $44(A0)
AF22   2141 0048                 Move.L    D1, $48(A0)
AF26   2F09                      Move.L    A1, -(A7)
AF28   3F3C 0008                 Move      $8, -(A7)
AF2C   1F02                      Move.B    D2, -(A7)
AF2E   4EBA FF80                 Jsr       P_mPutPicByte
AF32   4EBA FF66                 Jsr       P_mPutPicData
AF36   4E75                      Rts

                      P_mPutPicRgn:
AF38   2F2F 0004                 Move.L    $4(A7), -(A7)
AF3C   4EBA 02F4                 Jsr       P277
AF40   206F 0004                 Move.L    $4(A7), A0
AF44   2050                      Move.L    (A0), A0
AF46   2F08                      Move.L    A0, -(A7)
AF48   3F10                      Move      (A0), -(A7)
AF4A   4EBA FF4E                 Jsr       P_mPutPicData
AF4E   2F2F 0004                 Move.L    $4(A7), -(A7)
AF52   4EBA 02EA                 Jsr       P278
AF56   2E9F                      Move.L    (A7)+, (A7)
AF58   4E75                      Rts

                      P_mPutPicVerb:
AF5A   4E56 0000                 Link      A6, $0
AF5E   48E7 0718                 MoveM.L   D5-D7/A3-A4, -(A7)
AF62   2855                      Move.L    (A5), A4
AF64   2654                      Move.L    (A4), A3
AF66   286B 005C                 Move.L    $5C(A3), A4
AF6A   2854                      Move.L    (A4), A4
AF6C   1E2E 0008                 Move.B    $8(A6), D7
AF70   0C07 0001                 Cmp.B     $1, D7
AF74   6D70                      BLT       L1616
AF76   6700 0090                 BEQ       L1617
AF7A   0C07 0003                 Cmp.B     $3, D7
AF7E   6700 00D6                 BEQ       L1620
AF82   6D32                      BLT       L1614
AF84   2A2B 0028                 Move.L    $28(A3), D5
AF88   2C2B 002C                 Move.L    $2C(A3), D6
AF8C   BAAC 003C                 Cmp.L     $3C(A4), D5
AF90   6608                      BNE       L1613
AF92   BCAC 0040                 Cmp.L     $40(A4), D6
AF96   6700 00BE                 BEQ       L1620
AF9A   2945 003C      L1613:     Move.L    D5, $3C(A4)
AF9E   2946 0040                 Move.L    D6, $40(A4)
AFA2   1F3C 000A                 Move.B    $A, -(A7)
AFA6   4EBA FF08                 Jsr       P_mPutPicByte
AFAA   486B 0028                 Pea.L     $28(A3)
AFAE   4EBA FF34                 Jsr       P_mPutPicPat
AFB2   6000 00A2                 Bra       L1620
AFB6   2A2B 0020      L1614:     Move.L    $20(A3), D5
AFBA   2C2B 0024                 Move.L    $24(A3), D6
AFBE   BAAC 000A                 Cmp.L     $A(A4), D5
AFC2   6608                      BNE       L1615
AFC4   BCAC 000E                 Cmp.L     $E(A4), D6
AFC8   6700 008C                 BEQ       L1620
AFCC   2945 000A      L1615:     Move.L    D5, $A(A4)
AFD0   2946 000E                 Move.L    D6, $E(A4)
AFD4   1F3C 0002                 Move.B    $2, -(A7)
AFD8   4EBA FED6                 Jsr       P_mPutPicByte
AFDC   486B 0020                 Pea.L     $20(A3)
AFE0   4EBA FF02                 Jsr       P_mPutPicPat
AFE4   6070                      Bra       L1620
AFE6   2C2B 0034      L1616:     Move.L    $34(A3), D6
AFEA   BCAC 002E                 Cmp.L     $2E(A4), D6
AFEE   6718                      BEQ       L1617
AFF0   1F3C 0007                 Move.B    $7, -(A7)
AFF4   4EBA FEBA                 Jsr       P_mPutPicByte
AFF8   2F06                      Move.L    D6, -(A7)
AFFA   4EBA FED8                 Jsr       P_mPutPicLong
AFFE   286B 005C                 Move.L    $5C(A3), A4
B002   2854                      Move.L    (A4), A4
B004   2946 002E                 Move.L    D6, $2E(A4)
B008   3C2B 0038      L1617:     Move      $38(A3), D6
B00C   BC6C 0032                 Cmp       $32(A4), D6
B010   6718                      BEQ       L1618
B012   1F3C 0008                 Move.B    $8, -(A7)
B016   4EBA FE98                 Jsr       P_mPutPicByte
B01A   3F06                      Move      D6, -(A7)
B01C   4EBA FEA4                 Jsr       P_mPutPicWord
B020   286B 005C                 Move.L    $5C(A3), A4
B024   2854                      Move.L    (A4), A4
B026   3946 0032                 Move      D6, $32(A4)
B02A   2A2B 003A      L1618:     Move.L    $3A(A3), D5
B02E   2C2B 003E                 Move.L    $3E(A3), D6
B032   BAAC 0034                 Cmp.L     $34(A4), D5
B036   6606                      BNE       L1619
B038   BCAC 0038                 Cmp.L     $38(A4), D6
B03C   6718                      BEQ       L1620
B03E   2945 0034      L1619:     Move.L    D5, $34(A4)
B042   2946 0038                 Move.L    D6, $38(A4)
B046   1F3C 0009                 Move.B    $9, -(A7)
B04A   4EBA FE64                 Jsr       P_mPutPicByte
B04E   486B 003A                 Pea.L     $3A(A3)
B052   4EBA FE90                 Jsr       P_mPutPicPat
B056   4CDF 18E0      L1620:     MoveM.L   (A7)+, D5-D7/A3-A4
B05A   4E5E                      Unlk      A6
B05C   205F                      Move.L    (A7)+, A0
B05E   544F                      AddQ      $2, A7
B060   4ED0                      Jmp       (A0)

                      P_mCheckPic:
B062   48E7 0100                 MoveM.L   D7, -(A7)
B066   2855                      Move.L    (A5), A4
B068   2654                      Move.L    (A4), A3
B06A   4AAB 005C                 Tst.L     $5C(A3)
B06E   6700 00C0                 BEQ       L1625
B072   0C6B FFFF 0042            Cmp       $-1, $42(A3)
B078   6D00 00B6                 BLT       L1625
B07C   286B 005C                 Move.L    $5C(A3), A4
B080   2854                      Move.L    (A4), A4
B082   2E2B 0050                 Move.L    $50(A3), D7
B086   BEAC 0054                 Cmp.L     $54(A4), D7
B08A   6718                      BEQ       L1621
B08C   1F3C 000E                 Move.B    $E, -(A7)
B090   4EBA FE1E                 Jsr       P_mPutPicByte
B094   2F07                      Move.L    D7, -(A7)
B096   4EBA FE3C                 Jsr       P_mPutPicLong
B09A   286B 005C                 Move.L    $5C(A3), A4
B09E   2854                      Move.L    (A4), A4
B0A0   2947 0054                 Move.L    D7, $54(A4)
B0A4   2E2B 0054      L1621:     Move.L    $54(A3), D7
B0A8   BEAC 0058                 Cmp.L     $58(A4), D7
B0AC   6718                      BEQ       L1622
B0AE   1F3C 000F                 Move.B    $F, -(A7)
B0B2   4EBA FDFC                 Jsr       P_mPutPicByte
B0B6   2F07                      Move.L    D7, -(A7)
B0B8   4EBA FE1A                 Jsr       P_mPutPicLong
B0BC   286B 005C                 Move.L    $5C(A3), A4
B0C0   2854                      Move.L    (A4), A4
B0C2   2947 0058                 Move.L    D7, $58(A4)
B0C6   202B 0010      L1622:     Move.L    $10(A3), D0
B0CA   B0AC 0050                 Cmp.L     $50(A4), D0
B0CE   672E                      BEQ       L1623
B0D0   3E2B 0012                 Move      $12(A3), D7
B0D4   9E6C 0052                 Sub       $52(A4), D7
B0D8   DF6C 0052                 Add       D7, $52(A4)
B0DC   4847                      Swap      D7
B0DE   3E2B 0010                 Move      $10(A3), D7
B0E2   9E6C 0050                 Sub       $50(A4), D7
B0E6   DF6C 0050                 Add       D7, $50(A4)
B0EA   1F3C 000C                 Move.B    $C, -(A7)
B0EE   4EBA FDC0                 Jsr       P_mPutPicByte
B0F2   2F07                      Move.L    D7, -(A7)
B0F4   4EBA FDDE                 Jsr       P_mPutPicLong
B0F8   286B 005C                 Move.L    $5C(A3), A4
B0FC   2854                      Move.L    (A4), A4
B0FE   4227           L1623:     Clr.B     -(A7)
B100   2F2B 001C                 Move.L    $1C(A3), -(A7)
B104   2F2C 0006                 Move.L    $6(A4), -(A7)
B108   4EBA DFE6                 Jsr       P_tEqualRgn
B10C   4A1F                      Tst.B     (A7)+
B10E   661C                      BNE       L1624
B110   2F2B 001C                 Move.L    $1C(A3), -(A7)
B114   2F2C 0006                 Move.L    $6(A4), -(A7)
B118   1F3C 0001                 Move.B    $1, -(A7)
B11C   4EBA FD92                 Jsr       P_mPutPicByte
B120   2F2B 001C                 Move.L    $1C(A3), -(A7)
B124   4EBA FE12                 Jsr       P_mPutPicRgn
B128   4EBA DE18                 Jsr       P_tCopyRgn
B12C   2855           L1624:     Move.L    (A5), A4
B12E   7001                      MoveQ.L   $1, D0
B130   4CDF 0080      L1625:     MoveM.L   (A7)+, D7
B134   4E75                      Rts

                      P_tScalePt:
B136   4E56 0000                 Link      A6, $0
B13A   48E7 FEE0                 MoveM.L   D0-D6/A0-A2, -(A7)
B13E   206E 0010                 Move.L    $10(A6), A0
B142   226E 000C                 Move.L    $C(A6), A1
B146   246E 0008                 Move.L    $8(A6), A2
B14A   6116                      Bsr       P272
B14C   5448                      AddQ      $2, A0
B14E   5449                      AddQ      $2, A1
B150   544A                      AddQ      $2, A2
B152   610E                      Bsr       P272
B154   4CDF 077F                 MoveM.L   (A7)+, D0-D6/A0-A2
B158   4E5E                      Unlk      A6
B15A   205F                      Move.L    (A7)+, A0
B15C   DEFC 000C                 AddA      $C, A7
B160   4ED0                      Jmp       (A0)

                      P272:
B162   3629 0004                 Move      $4(A1), D3
B166   9651                      Sub       (A1), D3
B168   342A 0004                 Move      $4(A2), D2
B16C   9452                      Sub       (A2), D2
B16E   B642                      Cmp       D2, D3
B170   671A                      BEQ       L1628
B172   3203                      Move      D3, D1
B174   E249                      LsR       $1, D1
B176   48C1                      Ext.L     D1
B178   3010                      Move      (A0), D0
B17A   6E04                      BGT       L1626
B17C   4250                      Clr       (A0)
B17E   4E75                      Rts
B180   C0C2           L1626:     MulU      D2, D0
B182   D081                      Add.L     D1, D0
B184   80C3                      DivU      D3, D0
B186   6602                      BNE       L1627
B188   7001                      MoveQ.L   $1, D0
B18A   3080           L1627:     Move      D0, (A0)
B18C   4E75           L1628:     Rts

                      P_tMapPt:
B18E   4E56 0000                 Link      A6, $0
B192   48E7 FEE0                 MoveM.L   D0-D6/A0-A2, -(A7)
B196   206E 0010                 Move.L    $10(A6), A0
B19A   226E 000C                 Move.L    $C(A6), A1
B19E   246E 0008                 Move.L    $8(A6), A2
B1A2   6116                      Bsr       P273
B1A4   5448                      AddQ      $2, A0
B1A6   5449                      AddQ      $2, A1
B1A8   544A                      AddQ      $2, A2
B1AA   610E                      Bsr       P273
B1AC   4CDF 077F                 MoveM.L   (A7)+, D0-D6/A0-A2
B1B0   4E5E                      Unlk      A6
B1B2   205F                      Move.L    (A7)+, A0
B1B4   DEFC 000C                 AddA      $C, A7
B1B8   4ED0                      Jmp       (A0)

                      P273:
B1BA   3411                      Move      (A1), D2
B1BC   3629 0004                 Move      $4(A1), D3
B1C0   9642                      Sub       D2, D3
B1C2   3812                      Move      (A2), D4
B1C4   3A2A 0004                 Move      $4(A2), D5
B1C8   9A44                      Sub       D4, D5
B1CA   3010                      Move      (A0), D0
B1CC   9042                      Sub       D2, D0
B1CE   BA43                      Cmp       D3, D5
B1D0   6718                      BEQ       L1630
B1D2   3203                      Move      D3, D1
B1D4   E249                      LsR       $1, D1
B1D6   48C1                      Ext.L     D1
B1D8   3400                      Move      D0, D2
B1DA   6A02                      BPL       L1629
B1DC   4440                      Neg       D0
B1DE   C0C5           L1629:     MulU      D5, D0
B1E0   D081                      Add.L     D1, D0
B1E2   80C3                      DivU      D3, D0
B1E4   4A42                      Tst       D2
B1E6   6A02                      BPL       L1630
B1E8   4440                      Neg       D0
B1EA   D044           L1630:     Add       D4, D0
B1EC   3080                      Move      D0, (A0)
B1EE   4E75                      Rts

                      P_tMapRect:
B1F0   2F2F 000C                 Move.L    $C(A7), -(A7)
B1F4   2F2F 000C                 Move.L    $C(A7), -(A7)
B1F8   2F2F 000C                 Move.L    $C(A7), -(A7)
B1FC   4EBA FF90                 Jsr       P_tMapPt
B200   58AF 000C                 AddQ      $4, $C(A7)
B204   4EFA FF88                 Jmp       P_tMapPt

                      P274:
B208   7000                      MoveQ.L   $0, D0
B20A   225F                      Move.L    (A7)+, A1
B20C   301F                      Move      (A7)+, D0
B20E   A122                      _NewHandle
B210   6604                      BNE       L1631
B212   2E88                      Move.L    A0, (A7)
B214   4ED1                      Jmp       (A1)
B216   7019           L1631:     MoveQ.L   $19, D0
B218   A9C9                      _SysError
B21A   A9FF                      _Debugger

                      P_mSetHSize:
B21C   7000                      MoveQ.L   $0, D0
B21E   225F                      Move.L    (A7)+, A1
B220   301F                      Move      (A7)+, D0
B222   205F                      Move.L    (A7)+, A0
B224   A024                      _SetHandleSize
B226   66EE                      BNE       L1631
B228   4ED1                      Jmp       (A1)

                      P276:
B22A   225F                      Move.L    (A7)+, A1
B22C   205F                      Move.L    (A7)+, A0
B22E   A023                      _DisposeHandle
B230   4ED1                      Jmp       (A1)

                      P277:
B232   206F 0004                 Move.L    $4(A7), A0
B236   08D0 0007                 BSet.B    $7, (A0)
B23A   2E9F                      Move.L    (A7)+, (A7)
B23C   4E75                      Rts

                      P278:
B23E   206F 0004                 Move.L    $4(A7), A0
B242   0890 0007                 BClr.B    $7, (A0)
B246   2E9F                      Move.L    (A7)+, (A7)
B248   4E75                      Rts

                      P_doShowCursor:
B24A   2F38 0804                 Move.L    (JShowCursor), -(A7)
B24E   4E75                      Rts

                      P_doHideCursor:
B250   2F38 0800                 Move.L    (GrafBegin_JHideCursor), -(A7)
B254   4E75                      Rts

                      P_doSetCrsr:
B256   2F38 0818                 Move.L    (JSetCrsr), -(A7)
B25A   4E75                      Rts

                      P_doInitCrsr:
B25C   2F38 0814                 Move.L    (JInitCrsr), -(A7)
B260   4E75                      Rts

                      P_doCrsrObscure:
B262   2F38 081C                 Move.L    (JCrsrObscure), -(A7)
B266   4E75                      Rts

                      P_doShieldCursor:
B268   2F38 0808                 Move.L    (JShieldCursor), -(A7)
B26C   4E75                      Rts

                      P_doScrnAddr:
B26E   2F38 080C                 Move.L    (JScrnAddr), -(A7)
B272   4E75                      Rts

                      P_doScrnSize:
B274   2F38 0810                 Move.L    (JScrnSize), -(A7)
B278   4E75                      Rts

                      P_tFMSwapFont:
B27A   2F38 08E0                 Move.L    (JSwapFont), -(A7)
B27E   4E75                      Rts

                      P_tInitFonts:
B280   2F03                      Move.L    D3, -(A7)
B282   70FF                      MoveQ.L   $-1, D0
B284   31C0 0988                 Move      D0, (CurFMFamily)
B288   6100 02B0                 Bsr       P290
B28C   4278 098E                 Clr       (CurFMDevice)
B290   4238 0A63                 Clr.B     (FScaleDisable)
B294   31F8 0204 0984            Move      (SPFont), (ApFontID)
B29A   760C                      MoveQ.L   $C, D3
B29C   31C3 0986                 Move      D3, (GotStrike)
B2A0   6100 0154                 Bsr       P285
B2A4   21C8 0980                 Move.L    A0, (ROMFont0)
B2A8   261F                      Move.L    (A7)+, D3
B2AA   41FA 0012                 Lea.L     P_SwapFont, A0
B2AE   21C8 08E0                 Move.L    A0, (JSwapFont)
B2B2   4E75                      Rts
B2B4   4A2B 0005      L1636:     Tst.B     $5(A3)
B2B8   6728                      BEQ       L1638
B2BA   6000 00DE      L1637:     Bra       L1647

                      P_SwapFont:
B2BE   41F8 0998                 Lea.L     (FOutError), A0
B2C2   2F48 0008                 Move.L    A0, $8(A7)
B2C6   2F0B                      Move.L    A3, -(A7)
B2C8   266F 0008                 Move.L    $8(A7), A3
B2CC   4278 0998                 Clr       (FOutError)
B2D0   204B                      Move.L    A3, A0
B2D2   43F8 0988                 Lea.L     (CurFMFamily), A1
B2D6   B388                      CmpM.L    (A0)+, (A1)+
B2D8   66E0                      BNE       L1637
B2DA   1018                      Move.B    (A0)+, D0
B2DC   1219                      Move.B    (A1)+, D1
B2DE   B308                      CmpM.B    (A0)+, (A1)+
B2E0   66D2                      BNE       L1636
B2E2   B348           L1638:     CmpM      (A0)+, (A1)+
B2E4   66D4                      BNE       L1637
B2E6   B388                      CmpM.L    (A0)+, (A1)+
B2E8   66D0                      BNE       L1637
B2EA   B388                      CmpM.L    (A0)+, (A1)+
B2EC   66CC                      BNE       L1637
B2EE   B001                      Cmp.B     D1, D0
B2F0   661E                      BNE       L1641
B2F2   2078 099A      L1639:     Move.L    (FOutFontHandle), A0
B2F6   4A90                      Tst.L     (A0)
B2F8   6610                      BNE       L1640
B2FA   2F08                      Move.L    A0, -(A7)
B2FC   A9A2                      _LoadResource
B2FE   4A78 0A60                 Tst       (ResErr)
B302   6706                      BEQ       L1640
B304   21F8 0980 099A            Move.L    (ROMFont0), (FOutFontHandle)
B30A   265F           L1640:     Move.L    (A7)+, A3
B30C   2E9F                      Move.L    (A7)+, (A7)
B30E   4E75                      Rts
B310   48E7 1F00      L1641:     MoveM.L   D3-D7, -(A7)
B314   41F8 099E      L1642:     Lea.L     (FOutBold), A0
B318   4298                      Clr.L     (A0)+
B31A   4258                      Clr       (A0)+
B31C   4218                      Clr.B     (A0)+
B31E   122B 0004                 Move.B    $4(A3), D1
B322   6734                      BEQ       L1645
B324   7400                      MoveQ.L   $0, D2
B326   43F8 09B6                 Lea.L     (FMStyleTab), A1
B32A   7006                      MoveQ.L   $6, D0
B32C   41F8 099E                 Lea.L     (FOutBold), A0
B330   1419           L1643:     Move.B    (A1)+, D2
B332   1619                      Move.B    (A1)+, D3
B334   1819                      Move.B    (A1)+, D4
B336   E249                      LsR       $1, D1
B338   6408                      BCC       L1644
B33A   D730 2000                 Add.B     D3, $0(A0,D2.W)
B33E   D938 09A4                 Add.B     D4, (FOutExtra)
B342   51C8 FFEC      L1644:     DBF       D0, L1643
B346   082B 0002 0004            BTst.B    $2, $4(A3)
B34C   670A                      BEQ       L1645
B34E   41F8 09A0                 Lea.L     (FOutULOffset), A0
B352   10D9                      Move.B    (A1)+, (A0)+
B354   10D9                      Move.B    (A1)+, (A0)+
B356   10D9                      Move.B    (A1)+, (A0)+
B358   70FF           L1645:     MoveQ.L   $-1, D0
B35A   102B 0006                 Move.B    $6(A3), D0
B35E   671E                      BEQ       L1646
B360   7232                      MoveQ.L   $32, D1
B362   9FC1                      SubA.L    D1, A7
B364   204F                      Move.L    A7, A0
B366   3140 0018                 Move      D0, $18(A0)
B36A   317C 0008 001A            Move      $8, $1A(A0)
B370   214B 001C                 Move.L    A3, $1C(A0)
B374   316B 0006 0020            Move      $6(A3), $20(A0)
B37A   A004                      _Control
B37C   DFC1                      AddA.L    D1, A7
B37E   204B           L1646:     Move.L    A3, A0
B380   43F8 0988                 Lea.L     (CurFMFamily), A1
B384   22D8                      Move.L    (A0)+, (A1)+
B386   22D8                      Move.L    (A0)+, (A1)+
B388   22D8                      Move.L    (A0)+, (A1)+
B38A   22D8                      Move.L    (A0)+, (A1)+
B38C   11F8 0986 098D            Move.B    (GotStrike), (CurFMNeedBits)
B392   4CDF 00F8                 MoveM.L   (A7)+, D3-D7
B396   6000 FF5A                 Bra       L1639
B39A   48E7 1F00      L1647:     MoveM.L   D3-D7, -(A7)
B39E   302B 0006                 Move      $6(A3), D0
B3A2   B078 098E                 Cmp       (CurFMDevice), D0
B3A6   6704                      BEQ       L1648
B3A8   6100 0166                 Bsr       P289
B3AC   6166           L1648:     Bsr       P287
B3AE   2078 099A                 Move.L    (FOutFontHandle), A0
B3B2   2F08                      Move.L    A0, -(A7)
B3B4   A9A2                      _LoadResource
B3B6   2050                      Move.L    (A0), A0
B3B8   43F8 09A5                 Lea.L     (FOutAscent), A1
B3BC   12E8 0013                 Move.B    $13(A0), (A1)+
B3C0   12E8 0015                 Move.B    $15(A0), (A1)+
B3C4   12E8 0007                 Move.B    $7(A0), (A1)+
B3C8   12A8 0017                 Move.B    $17(A0), (A1)
B3CC   6000 FF46                 Bra       L1642

                      P283:
B3D0   3A2B 0002                 Move      $2(A3), D5
B3D4   6604                      BNE       L1649
B3D6   1A38 0987                 Move.B    (FMDefaultSize), D5
B3DA   4E75           L1649:     Rts

                      P284:
B3DC   4A2B 0005                 Tst.B     $5(A3)
B3E0   6614                      BNE       P285
B3E2   594F                      SubQ.L    $4, A7
B3E4   4238 0986                 Clr.B     (GotStrike)
B3E8   2F3C 4657 4944            Move.L    $46574944, -(A7)
B3EE   3F03                      Move      D3, -(A7)
B3F0   A9A0                      _GetResource
B3F2   201F                      Move.L    (A7)+, D0
B3F4   6612                      BNE       L1650

                      P285:
B3F6   594F                      SubQ.L    $4, A7
B3F8   2F3C 464F 4E54            Move.L    $464F4E54, -(A7)
B3FE   3F03                      Move      D3, -(A7)
B400   A9A0                      _GetResource
B402   50F8 0986                 ST.B      (GotStrike)
B406   201F                      Move.L    (A7)+, D0
B408   2040           L1650:     Move.L    D0, A0
B40A   4E75                      Rts

                      P286:
B40C   0243 FF80                 And       $-80, D3
B410   8640                      Or        D0, D3
B412   4E75                      Rts

                      P287:
B414   61BA                      Bsr       P283
B416   3613                      Move      (A3), D3
B418   0C43 0001                 Cmp       $1, D3
B41C   6604                      BNE       L1652
B41E   3638 0984      L1651:     Move      (ApFontID), D3
B422   9EFC 000E      L1652:     SubA      $E, A7
B426   3F38 09B4                 Move      (FMDotsPerInch.v), -(A7)
B42A   3F3C 0050                 Move      $50, -(A7)
B42E   A869                      _FixRatio
B430   594F                      SubQ.L    $4, A7
B432   3F2B 000A                 Move      $A(A3), -(A7)
B436   3F2B 000E                 Move      $E(A3), -(A7)
B43A   A869                      _FixRatio
B43C   A868                      _FixMul
B43E   4267                      Clr       -(A7)
B440   3F2B 0002                 Move      $2(A3), -(A7)
B444   6606                      BNE       L1653
B446   1F78 0987 0001            Move.B    (FMDefaultSize), $1(A7)
B44C   A868           L1653:     _FixMul
B44E   A86C                      _FixRound
B450   301F                      Move      (A7)+, D0
B452   0240 007F                 And       $7F, D0
B456   EF43                      AsL       $7, D3
B458   8640                      Or        D0, D3
B45A   3E00                      Move      D0, D7
B45C   6100 FF7E                 Bsr       P284
B460   663C                      BNE       L1657
B462   3803                      Move      D3, D4
B464   3007                      Move      D7, D0
B466   0C40 0040                 Cmp       $40, D0
B46A   6C0A                      BGE       L1654
B46C   D040                      Add       D0, D0
B46E   619C                      Bsr       P286
B470   6100 FF6A                 Bsr       P284
B474   6628                      BNE       L1657
B476   3007           L1654:     Move      D7, D0
B478   E248                      LsR       $1, D0
B47A   6508                      BCS       L1655
B47C   618E                      Bsr       P286
B47E   6100 FF5C                 Bsr       P284
B482   661A                      BNE       L1657
B484   3604           L1655:     Move      D4, D3
B486   7C01                      MoveQ.L   $1, D6
B488   D646           L1656:     Add       D6, D3
B48A   0243 007F                 And       $7F, D3
B48E   6774                      BEQ       L1659
B490   3004                      Move      D4, D0
B492   0240 FF80                 And       $-80, D0
B496   8640                      Or        D0, D3
B498   6100 FF42                 Bsr       P284
B49C   67EA                      BEQ       L1656
B49E   21C8 099A      L1657:     Move.L    A0, (FOutFontHandle)
B4A2   6100 FF2C                 Bsr       P283
B4A6   594F                      SubQ.L    $4, A7
B4A8   3F05                      Move      D5, -(A7)
B4AA   3F03                      Move      D3, -(A7)
B4AC   0257 007F                 And       $7F, (A7)
B4B0   A869                      _FixRatio
B4B2   2C1F                      Move.L    (A7)+, D6
B4B4   7A00                      MoveQ.L   $0, D5
B4B6   6102                      Bsr       P288
B4B8   7A02                      MoveQ.L   $2, D5

                      P288:
B4BA   9EFC 000C                 SubA      $C, A7
B4BE   3F33 5008                 Move      $8(A3,D5.W), -(A7)
B4C2   3F33 500C                 Move      $C(A3,D5.W), -(A7)
B4C6   A869                      _FixRatio
B4C8   594F                      SubQ.L    $4, A7
B4CA   41F8 09B2                 Lea.L     (FMDotsPerInch_h), A0
B4CE   3F30 5000                 Move      $0(A0,D5.W), -(A7)
B4D2   3F3C 0050                 Move      $50, -(A7)
B4D6   A869                      _FixRatio
B4D8   A868                      _FixMul
B4DA   2F06                      Move.L    D6, -(A7)
B4DC   A868                      _FixMul
B4DE   41F8 09AA                 Lea.L     (FOutNumer_h), A0
B4E2   201F                      Move.L    (A7)+, D0
B4E4   E088                      LsR.L     $8, D0
B4E6   5040                      AddQ      $8, D0
B4E8   0240 FFF0                 And       $-10, D0
B4EC   3180 5000                 Move      D0, $0(A0,D5.W)
B4F0   31BC 0100 5004            Move      $100, $4(A0,D5.W)
B4F6   4A38 0A63                 Tst.B     (FScaleDisable)
B4FA   6706                      BEQ       L1658
B4FC   31BC 0100 5000            Move      $100, $0(A0,D5.W)
B502   4E75           L1658:     Rts
B504   4446           L1659:     Neg       D6
B506   6A00 FF16                 BPL       L1651
B50A   3604                      Move      D4, D3
B50C   6000 FF7A                 Bra       L1656

                      P289:
B510   4A40                      Tst       D0
B512   6726                      BEQ       P290
B514   70FF                      MoveQ.L   $-1, D0
B516   102B 0006                 Move.B    $6(A3), D0
B51A   7232                      MoveQ.L   $32, D1
B51C   9FC1                      SubA.L    D1, A7
B51E   41EF 0018                 Lea.L     $18(A7), A0
B522   30C0                      Move      D0, (A0)+
B524   30FC 0008                 Move      $8, (A0)+
B528   43F8 09B2                 Lea.L     (FMDotsPerInch_h), A1
B52C   20C9                      Move.L    A1, (A0)+
B52E   30EB 0006                 Move      $6(A3), (A0)+
B532   204F                      Move.L    A7, A0
B534   A005                      _Status
B536   DFC1                      AddA.L    D1, A7
B538   4E75                      Rts

                      P290:
B53A   43F8 09B2                 Lea.L     (FMDotsPerInch_h), A1
B53E   41FA 0008                 Lea.L     DT50, A0
B542   701C                      MoveQ.L   $1C, D0
B544   A02E                      _BlockMove
B546   4E75                      Rts

                      DT50:
B548   0050 0050 0001            DC.B      ' P P  '
B54E   0101 0801 0000            DC.B      '      '
B554   0005 0101 0502            DC.B      '      '
B55A   0200 00FF 0000            DC.B      '      '
B560   0101 0101 0077            DC.B      '     w'
B566   7A3B C935 3019            DC.B      'z; 50 '
B56C   80AF 3018 7A60            DC.B      '  0 z`'
B572   1809 0060 3198            DC.B      '   `1 '
B578   0972 7BBA 49BF            DC.B      ' r{ I '
B57E   E09D 0102 20BF            DC.B      '      '
B584   4088 01F1 FE02            DC.B      '@     '
B58A   0A81 BC04 0703            DC.B      '      '
B590   9A08 040F 8099            DC.B      '      '
B596   1FC0 3760 B90F            DC.B      '  7`  '
B59C   0403 DF0F 9808            DC.B      '      '
B5A2   3760 1FC1 A804            DC.B      '7`    '
B5A8   0F80 0202 9A01            DC.B      '      '
B5AE   0487 0800                 DC.B      '    '

                      P_tGetFName:
B5B2   2F03                      Move.L    D3, -(A7)
B5B4   4278 0A5E                 Clr       (ResLoad)
B5B8   362F 000C                 Move      $C(A7), D3
B5BC   0C43 0001                 Cmp       $1, D3
B5C0   6604                      BNE       L1660
B5C2   3638 0984                 Move      (ApFontID), D3
B5C6   EF43           L1660:     AsL       $7, D3
B5C8   6100 FE2C                 Bsr       P285
B5CC   671A                      BEQ       L1662
B5CE   2F08                      Move.L    A0, -(A7)
B5D0   4878 09FA                 Pea.L     (scratch8)
B5D4   2F17                      Move.L    (A7), -(A7)
B5D6   2F2F 0014                 Move.L    $14(A7), -(A7)
B5DA   A9A8                      _GetResInfo
B5DC   50F8 0A5E      L1661:     ST.B      (ResLoad)
B5E0   261F                      Move.L    (A7)+, D3
B5E2   205F                      Move.L    (A7)+, A0
B5E4   5C4F                      AddQ      $6, A7
B5E6   4ED0                      Jmp       (A0)
B5E8   206F 0008      L1662:     Move.L    $8(A7), A0
B5EC   4250                      Clr       (A0)
B5EE   60EC                      Bra       L1661

                      P_tGetFNum:
B5F0   4E56 FEF2                 Link      A6, $-10E
B5F4   4278 0A5E                 Clr       (ResLoad)
B5F8   594F                      SubQ.L    $4, A7
B5FA   2F3C 464F 4E54            Move.L    $464F4E54, -(A7)
B600   2F2E 000C                 Move.L    $C(A6), -(A7)
B604   A9A1                      _GetNamedResource
B606   201F                      Move.L    (A7)+, D0
B608   6728                      BEQ       L1664
B60A   2F00                      Move.L    D0, -(A7)
B60C   486E FFFC                 Pea.L     $-4(A6)
B610   486E FFF8                 Pea.L     $-8(A6)
B614   486E FEF2                 Pea.L     $-10E(A6)
B618   A9A8                      _GetResInfo
B61A   206E 0008                 Move.L    $8(A6), A0
B61E   302E FFFC                 Move      $-4(A6), D0
B622   EE48                      LsR       $7, D0
B624   3080                      Move      D0, (A0)
B626   50F8 0A5E      L1663:     ST.B      (ResLoad)
B62A   4E5E                      Unlk      A6
B62C   205F                      Move.L    (A7)+, A0
B62E   504F                      AddQ      $8, A7
B630   4ED0                      Jmp       (A0)
B632   206E 0008      L1664:     Move.L    $8(A6), A0
B636   4250                      Clr       (A0)
B638   60EC                      Bra       L1663

                      P_tSetFontLock:
B63A   2278 099A                 Move.L    (FOutFontHandle), A1
B63E   2F09                      Move.L    A1, -(A7)
B640   4A2F 0008                 Tst.B     $8(A7)
B644   660C                      BNE       L1666
B646   08D1 0006                 BSet.B    $6, (A1)
B64A   A9A3                      _ReleaseResource
B64C   205F           L1665:     Move.L    (A7)+, A0
B64E   544F                      AddQ      $2, A7
B650   4ED0                      Jmp       (A0)
B652   A9A2           L1666:     _LoadResource
B654   0891 0006                 BClr.B    $6, (A1)
B658   60F2                      Bra       L1665

                      P_tRealFont:
B65A   426F 0008                 Clr       $8(A7)
B65E   4278 0A5E                 Clr       (ResLoad)
B662   302F 0006                 Move      $6(A7), D0
B666   EF40                      AsL       $7, D0
B668   322F 0004                 Move      $4(A7), D1
B66C   0241 007F                 And       $7F, D1
B670   6716                      BEQ       L1667
B672   8041                      Or        D1, D0
B674   594F                      SubQ.L    $4, A7
B676   2F3C 464F 4E54            Move.L    $464F4E54, -(A7)
B67C   3F00                      Move      D0, -(A7)
B67E   A9A0                      _GetResource
B680   4A9F                      Tst.L     (A7)+
B682   6704                      BEQ       L1667
B684   522F 0008                 AddQ      $1, $8(A7)
B688   50F8 0A5E      L1667:     ST.B      (ResLoad)
B68C   2E9F                      Move.L    (A7)+, (A7)
B68E   4E75                      Rts

                      P_tGetKeys:
B690   226F 0004                 Move.L    $4(A7), A1
B694   41F8 0174                 Lea.L     (KeyMap), A0
B698   22D8                      Move.L    (A0)+, (A1)+
B69A   22D8                      Move.L    (A0)+, (A1)+
B69C   22D8                      Move.L    (A0)+, (A1)+
B69E   22D8                      Move.L    (A0)+, (A1)+
B6A0   226F 0004                 Move.L    $4(A7), A1
B6A4   7203                      MoveQ.L   $3, D1
B6A6   6120                      Bsr       P291
B6A8   2E9F                      Move.L    (A7)+, (A7)
B6AA   4E75                      Rts

                      P_tButton:
B6AC   43EF 0004                 Lea.L     $4(A7), A1
B6B0   4251                      Clr       (A1)
B6B2   4A38 0172                 Tst.B     (MBState)
B6B6   6B02                      BMI       L1668
B6B8   5211                      AddQ      $1, (A1)
B6BA   7202           L1668:     MoveQ.L   $2, D1
B6BC   600A                      Bra       P291

                      P_tTickCount:
B6BE   43EF 0004                 Lea.L     $4(A7), A1
B6C2   22B8 016A                 Move.L    (Ticks), (A1)
B6C6   7200                      MoveQ.L   $0, D1

                      P291:
B6C8   3038 08DE                 Move      (JournalFlag), D0
B6CC   6732                      BEQ       L1672
B6CE   6A04                      BPL       L1669
B6D0   7010                      MoveQ.L   $10, D0
B6D2   6002                      Bra       L1670
B6D4   7011           L1669:     MoveQ.L   $11, D0
B6D6   9EFC 0028      L1670:     SubA      $28, A7
B6DA   3F40 001A                 Move      D0, $1A(A7)
B6DE   3F78 08E8 0018            Move      (JournalRef), $18(A7)
B6E4   2F49 001C                 Move.L    A1, $1C(A7)
B6E8   3F41 0020                 Move      D1, $20(A7)
B6EC   204F                      Move.L    A7, A0
B6EE   A004                      _Control
B6F0   DEFC 0028                 AddA      $28, A7
B6F4   6602                      BNE       L1671
B6F6   4E75                      Rts
B6F8   4278 08DE      L1671:     Clr       (JournalFlag)
B6FC   50F8 08CF                 ST.B      (CrsrCouple)
B700   4E75           L1672:     Rts

                      P_tGetMouse:
B702   226F 0004                 Move.L    $4(A7), A1
B706   22B8 0830                 Move.L    (Mouse_v), (A1)
B70A   7201                      MoveQ.L   $1, D1
B70C   61BA                      Bsr       P291
B70E   2F2F 0004                 Move.L    $4(A7), -(A7)
B712   A871                      _GlobalToLocal
B714   2E9F                      Move.L    (A7)+, (A7)
B716   4E75                      Rts

                      P_tStillDown:
B718   4E56 FFEC                 Link      A6, $-14
B71C   426E 0008                 Clr       $8(A6)
B720   554F                      SubQ.L    $2, A7
B722   A974                      _Button
B724   4A5F                      Tst       (A7)+
B726   6714                      BEQ       L1673
B728   554F                      SubQ.L    $2, A7
B72A   3F3C 0007                 Move      $7, -(A7)
B72E   486E FFEC                 Pea.L     $-14(A6)
B732   A971                      _EventAvail
B734   4A5F                      Tst       (A7)+
B736   6604                      BNE       L1673
B738   522E 0008                 AddQ      $1, $8(A6)
B73C   4E5E           L1673:     Unlk      A6
B73E   4E75                      Rts

                      P_tWaitMouseUp:
B740   4E56 FFEC                 Link      A6, $-14
B744   4267                      Clr       -(A7)
B746   A973                      _StillDown
B748   3D5F 0008                 Move      (A7)+, $8(A6)
B74C   660C                      BNE       L1674
B74E   554F                      SubQ.L    $2, A7
B750   3F3C 0004                 Move      $4, -(A7)
B754   486E FFEC                 Pea.L     $-14(A6)
B758   A970                      _GetNextEvent
B75A   4E5E           L1674:     Unlk      A6
B75C   4E75                      Rts

                      P_tEventAvail:
B75E   70FF                      MoveQ.L   $-1, D0
B760   6002                      Bra       L1675

                      P_tGetNextEvent:
B762   7000                      MoveQ.L   $0, D0
B764   4E56 0000      L1675:     Link      A6, $0
B768   48E7 1010                 MoveM.L   D3/A3, -(A7)
B76C   2600                      Move.L    D0, D3
B76E   426E 000E                 Clr       $E(A6)
B772   266E 0008                 Move.L    $8(A6), A3
B776   302E 000C                 Move      $C(A6), D0
B77A   204B                      Move.L    A3, A0
B77C   6100 006E                 Bsr       P292
B780   6706                      BEQ       L1676
B782   522E 000E                 AddQ      $1, $E(A6)
B786   6036                      Bra       L1680
B788   302E 000C      L1676:     Move      $C(A6), D0
B78C   204B                      Move.L    A3, A0
B78E   4A43                      Tst       D3
B790   6A04                      BPL       L1677
B792   A030                      _OSEventAvail
B794   6002                      Bra       L1678
B796   A031           L1677:     _GetOSEvent
B798   224B           L1678:     Move.L    A3, A1
B79A   7204                      MoveQ.L   $4, D1
B79C   6100 FF2A                 Bsr       P291
B7A0   4A53                      Tst       (A3)
B7A2   6706                      BEQ       L1679
B7A4   522E 000E                 AddQ      $1, $E(A6)
B7A8   6014                      Bra       L1680
B7AA   302E 000C      L1679:     Move      $C(A6), D0
B7AE   0800 0006                 BTst.B    $6, D0
B7B2   670A                      BEQ       L1680
B7B4   4267                      Clr       -(A7)
B7B6   2F0B                      Move.L    A3, -(A7)
B7B8   A911                      _CheckUpDate
B7BA   3D5F 000E                 Move      (A7)+, $E(A6)
B7BE   4A43           L1680:     Tst       D3
B7C0   6B14                      BMI       L1681
B7C2   4A6E 000E                 Tst       $E(A6)
B7C6   670E                      BEQ       L1681
B7C8   554F                      SubQ.L    $2, A7
B7CA   2F0B                      Move.L    A3, -(A7)
B7CC   A9B2                      _SystemEvent
B7CE   4A5F                      Tst       (A7)+
B7D0   6704                      BEQ       L1681
B7D2   426E 000E                 Clr       $E(A6)
B7D6   4A53           L1681:     Tst       (A3)
B7D8   6606                      BNE       L1682
B7DA   4878 09FA                 Pea.L     (scratch8)
B7DE   A972                      _GetMouse
B7E0   4CDF 0808      L1682:     MoveM.L   (A7)+, D3/A3
B7E4   4E5E                      Unlk      A6
B7E6   205F                      Move.L    (A7)+, A0
B7E8   5C4F                      AddQ      $6, A7
B7EA   4ED0                      Jmp       (A0)

                      P292:
B7EC   0800 0008                 BTst.B    $8, D0
B7F0   6754                      BEQ       L1686
B7F2   2238 0A68                 Move.L    (CurDeactive), D1
B7F6   6E5A                      BGT       L1688
B7F8   2238 0A64                 Move.L    (CurActivate), D1
B7FC   6F48                      BLE       L1686
B7FE   7401                      MoveQ.L   $1, D2
B800   7000           L1683:     MoveQ.L   $0, D0
B802   A030                      _OSEventAvail
B804   30FC 0008                 Move      $8, (A0)+
B808   2081                      Move.L    D1, (A0)
B80A   2038 0A68                 Move.L    (CurDeactive), D0
B80E   6716                      BEQ       L1684
B810   3038 0A22                 Move      (CurDeKind), D0
B814   2238 0A64                 Move.L    (CurActivate), D1
B818   670C                      BEQ       L1684
B81A   2041                      Move.L    D1, A0
B81C   3228 006C                 Move      $6C(A0), D1
B820   B141                      Eor       D0, D1
B822   6A02                      BPL       L1684
B824   5442                      AddQ      $2, D2
B826   302B 000E      L1684:     Move      $E(A3), D0
B82A   0240 FFFC                 And       $-4, D0
B82E   8042                      Or        D2, D0
B830   3740 000E                 Move      D0, $E(A3)
B834   4A43                      Tst       D3
B836   660A                      BNE       L1685
B838   E248                      LsR       $1, D0
B83A   640E                      BCC       L1687
B83C   08F8 0007 0A64            BSet.B    $7, (CurActivate)
B842   72FF           L1685:     MoveQ.L   $-1, D1
B844   4E75                      Rts
B846   7200           L1686:     MoveQ.L   $0, D1
B848   4E75                      Rts
B84A   08F8 0007 0A68 L1687:     BSet.B    $7, (CurDeactive)
B850   60F0                      Bra       L1685
B852   4242           L1688:     Clr       D2
B854   60AA                      Bra       L1683
B856   2843 2920 3139            DC.B      '(C) 19'
B85C   3832 2041 7070            DC.B      '82 App'
B862   6C65 2041 4A48            DC.B      'le AJH'

                      P_tNewString:
B868   610A                      Bsr       P293
B86A   A9E3                      _PtrToHand
B86C   2F48 0008                 Move.L    A0, $8(A7)
B870   2E9F                      Move.L    (A7)+, (A7)
B872   4E75                      Rts

                      P293:
B874   206F 0008                 Move.L    $8(A7), A0
B878   7000                      MoveQ.L   $0, D0
B87A   1010                      Move.B    (A0), D0
B87C   5240                      AddQ      $1, D0
B87E   4E75                      Rts

                      P_tSetString:
B880   226F 0008                 Move.L    $8(A7), A1
B884   61EE                      Bsr       P293
B886   A9E2                      _PtrToXHand
B888   6000 004E                 Bra       L1693

                      P294:
B88C   2F00                      Move.L    D0, -(A7)
B88E   2278 09D6                 Move.L    (WindowList), A1
B892   91C8                      SubA.L    A0, A0
B894   B3D7           L1689:     CmpA.L    (A7), A1
B896   670A                      BEQ       L1690
B898   2049                      Move.L    A1, A0
B89A   2268 0090                 Move.L    $90(A0), A1
B89E   2009                      Move.L    A1, D0
B8A0   66F2                      BNE       L1689
B8A2   201F           L1690:     Move.L    (A7)+, D0
B8A4   4E75                      Rts

                      P295:
B8A6   222F 0008                 Move.L    $8(A7), D1
B8AA   2241                      Move.L    D1, A1
B8AC   42A9 0090                 Clr.L     $90(A1)
B8B0   4AB8 09D6                 Tst.L     (WindowList)
B8B4   6606                      BNE       L1691
B8B6   21C1 09D6                 Move.L    D1, (WindowList)
B8BA   601C                      Bra       L1693
B8BC   202F 0004      L1691:     Move.L    $4(A7), D0
B8C0   670E                      BEQ       L1692
B8C2   2040                      Move.L    D0, A0
B8C4   2368 0090 0090            Move.L    $90(A0), $90(A1)
B8CA   2149 0090                 Move.L    A1, $90(A0)
B8CE   6008                      Bra       L1693
B8D0   7000           L1692:     MoveQ.L   $0, D0
B8D2   61B8                      Bsr       P294
B8D4   2141 0090                 Move.L    D1, $90(A0)
B8D8   205F           L1693:     Move.L    (A7)+, A0
B8DA   504F                      AddQ      $8, A7
B8DC   4ED0                      Jmp       (A0)

                      P_mDeleteWindow:
B8DE   202F 0004                 Move.L    $4(A7), D0
B8E2   61A8                      Bsr       P294
B8E4   2208                      Move.L    A0, D1
B8E6   6604                      BNE       L1694
B8E8   41F8 0946                 Lea.L     (ChooserBits), A0
B8EC   2240           L1694:     Move.L    D0, A1
B8EE   2169 0090 0090            Move.L    $90(A1), $90(A0)
B8F4   601E                      Bra       L1696

                      P_tCalcVis:
B8F6   48E7 0830                 MoveM.L   D4/A2-A3, -(A7)
B8FA   202F 0010                 Move.L    $10(A7), D0
B8FE   6710                      BEQ       L1695
B900   2440                      Move.L    D0, A2
B902   282A 0018                 Move.L    $18(A2), D4
B906   4A2A 006E                 Tst.B     $6E(A2)
B90A   660C                      BNE       L1698
B90C   2F04                      Move.L    D4, -(A7)
B90E   A8DD                      _SetEmptyRgn
B910   4CDF 0C10      L1695:     MoveM.L   (A7)+, D4/A2-A3
B914   2E9F           L1696:     Move.L    (A7)+, (A7)
B916   4E75           L1697:     Rts
B918   2F38 09EE      L1698:     Move.L    (GrayRgn), -(A7)
B91C   2F2A 0076                 Move.L    $76(A2), -(A7)
B920   2F04                      Move.L    D4, -(A7)
B922   A8E4                      _SectRgn
B924   610A                      Bsr       P297
B926   2F04                      Move.L    D4, -(A7)
B928   2F2A 0008                 Move.L    $8(A2), -(A7)
B92C   A8E0                      _OffsetRgn
B92E   60E0                      Bra       L1695

                      P297:
B930   2678 09D6                 Move.L    (WindowList), A3
B934   B7CA           L1699:     CmpA.L    A2, A3
B936   67DE                      BEQ       L1697
B938   4A2B 006E                 Tst.B     $6E(A3)
B93C   670A                      BEQ       L1700
B93E   2F04                      Move.L    D4, -(A7)
B940   2F2B 0072                 Move.L    $72(A3), -(A7)
B944   2F04                      Move.L    D4, -(A7)
B946   A8E6                      _DiffRgn
B948   266B 0090      L1700:     Move.L    $90(A3), A3
B94C   60E6                      Bra       L1699

                      P_tCalcVBehind:
B94E   2F0A                      Move.L    A2, -(A7)
B950   202F 000C                 Move.L    $C(A7), D0
B954   6736                      BEQ       L1703
B956   2440                      Move.L    D0, A2
B958   2F0A           L1701:     Move.L    A2, -(A7)
B95A   619A                      Bsr       P_tCalcVis
B95C   246A 0090      L1702:     Move.L    $90(A2), A2
B960   200A                      Move.L    A2, D0
B962   6728                      BEQ       L1703
B964   4A2A 006E                 Tst.B     $6E(A2)
B968   67F2                      BEQ       L1702
B96A   554F                      SubQ.L    $2, A7
B96C   206A 0076                 Move.L    $76(A2), A0
B970   2050                      Move.L    (A0), A0
B972   4868 0002                 Pea.L     $2(A0)
B976   206F 000E                 Move.L    $E(A7), A0
B97A   2050                      Move.L    (A0), A0
B97C   4868 0002                 Pea.L     $2(A0)
B980   4878 09CE                 Pea.L     (ToolScratch)
B984   A8AA                      _SectRect
B986   4A1F                      Tst.B     (A7)+
B988   67D2                      BEQ       L1702
B98A   60CC                      Bra       L1701
B98C   245F           L1703:     Move.L    (A7)+, A2
B98E   6000 FF48                 Bra       L1693

                      P_tClipAbove:
B992   48E7 0830                 MoveM.L   D4/A2-A3, -(A7)
B996   2078 09DE                 Move.L    (WMgrPort), A0
B99A   2828 001C                 Move.L    $1C(A0), D4
B99E   246F 0010                 Move.L    $10(A7), A2
B9A2   2F04                      Move.L    D4, -(A7)
B9A4   2F38 09EE                 Move.L    (GrayRgn), -(A7)
B9A8   2F04                      Move.L    D4, -(A7)
B9AA   A8E4                      _SectRgn
B9AC   6182                      Bsr       P297
B9AE   4CDF 0C10                 MoveM.L   (A7)+, D4/A2-A3
B9B2   2E9F                      Move.L    (A7)+, (A7)
B9B4   4E75                      Rts

                      P_tPaintOne:
B9B6   48E7 1830                 MoveM.L   D3-D4/A2-A3, -(A7)
B9BA   246F 0018                 Move.L    $18(A7), A2
B9BE   6168                      Bsr       P298
B9C0   200A                      Move.L    A2, D0
B9C2   6612                      BNE       L1705
B9C4   2F2F 0014                 Move.L    $14(A7), -(A7)
B9C8   A879                      _SetClip
B9CA   6100 007A                 Bsr       P300
B9CE   4CDF 0C18      L1704:     MoveM.L   (A7)+, D3-D4/A2-A3
B9D2   6000 FF04                 Bra       L1693
B9D6   4A2A 006E      L1705:     Tst.B     $6E(A2)
B9DA   67F2                      BEQ       L1704
B9DC   2F2F 0014                 Move.L    $14(A7), -(A7)
B9E0   2F2A 0072                 Move.L    $72(A2), -(A7)
B9E4   2F03                      Move.L    D3, -(A7)
B9E6   A8E4                      _SectRgn
B9E8   614C                      Bsr       P299
B9EA   2F0A                      Move.L    A2, -(A7)
B9EC   61A4                      Bsr       P_tClipAbove
B9EE   6146                      Bsr       P299
B9F0   264A                      Move.L    A2, A3
B9F2   6100 06B6                 Bsr       P309
B9F6   6100 00CA                 Bsr       P301
B9FA   265F                      Move.L    (A7)+, A3
B9FC   2F2A 0076                 Move.L    $76(A2), -(A7)
BA00   2F03                      Move.L    D3, -(A7)
BA02   2F0B                      Move.L    A3, -(A7)
BA04   A8E4                      _SectRgn
BA06   4A38 09DC                 Tst.B     (PaintWhite)
BA0A   6704                      BEQ       L1706
BA0C   2F0B                      Move.L    A3, -(A7)
BA0E   A8D4                      _EraseRgn
BA10   4A38 09DA      L1706:     Tst.B     (SaveUpdate)
BA14   670C                      BEQ       L1707
BA16   2F2A 007A                 Move.L    $7A(A2), -(A7)
BA1A   2F0B                      Move.L    A3, -(A7)
BA1C   2F2A 007A                 Move.L    $7A(A2), -(A7)
BA20   A8E5                      _UnionRgn
BA22   2F0B           L1707:     Move.L    A3, -(A7)
BA24   A8D9                      _DisposeRgn
BA26   60A6                      Bra       L1704

                      P298:
BA28   6100 0160                 Bsr       P_mGetSetWPort
BA2C   2678 09DE                 Move.L    (WMgrPort), A3
BA30   262B 001C                 Move.L    $1C(A3), D3
BA34   4E75                      Rts

                      P299:
BA36   554F                      SubQ.L    $2, A7
BA38   2F03                      Move.L    D3, -(A7)
BA3A   A8E2                      _EmptyRgn
BA3C   4A1F                      Tst.B     (A7)+
BA3E   6602                      BNE       L1708
BA40   4E75                      Rts
BA42   584F           L1708:     AddQ      $4, A7
BA44   6088                      Bra       L1704

                      P300:
BA46   42A7                      Clr.L     -(A7)
BA48   A90B                      _ClipAbove
BA4A   2038 0A6C                 Move.L    (DeskHook), D0
BA4E   6706                      BEQ       L1709
BA50   2040                      Move.L    D0, A0
BA52   7000                      MoveQ.L   $0, D0
BA54   4ED0                      Jmp       (A0)
BA56   486B 0010      L1709:     Pea.L     $10(A3)
BA5A   4878 0A3C                 Pea.L     (DeskPattern)
BA5E   A8A5                      _FillRect
BA60   4E75                      Rts

                      P_tPaintBehind:
BA62   48E7 1830                 MoveM.L   D3-D4/A2-A3, -(A7)
BA66   61C0                      Bsr       P298
BA68   2F2F 0014                 Move.L    $14(A7), -(A7)
BA6C   2F03                      Move.L    D3, -(A7)
BA6E   A8DC                      _CopyRgn
BA70   6150                      Bsr       P301
BA72   281F                      Move.L    (A7)+, D4
BA74   246F 0018                 Move.L    $18(A7), A2
BA78   2F0A                      Move.L    A2, -(A7)
BA7A   A90B                      _ClipAbove
BA7C   2F03                      Move.L    D3, -(A7)
BA7E   2F04                      Move.L    D4, -(A7)
BA80   A8DC                      _CopyRgn
BA82   61C2                      Bsr       P300
BA84   2F04                      Move.L    D4, -(A7)
BA86   2F03                      Move.L    D3, -(A7)
BA88   2F04                      Move.L    D4, -(A7)
BA8A   A8E6                      _DiffRgn
BA8C   486B 0010                 Pea.L     $10(A3)
BA90   A87B                      _ClipRect
BA92   2F04                      Move.L    D4, -(A7)
BA94   A8D4                      _EraseRgn
BA96   2F04                      Move.L    D4, -(A7)
BA98   A8D9                      _DisposeRgn
BA9A   4278 09DC                 Clr       (PaintWhite)
BA9E   200A           L1710:     Move.L    A2, D0
BAA0   6714                      BEQ       L1712
BAA2   4A2A 006E                 Tst.B     $6E(A2)
BAA6   6708                      BEQ       L1711
BAA8   2F0A                      Move.L    A2, -(A7)
BAAA   2F2F 0018                 Move.L    $18(A7), -(A7)
BAAE   A90C                      _PaintOne
BAB0   246A 0090      L1711:     Move.L    $90(A2), A2
BAB4   60E8                      Bra       L1710
BAB6   50F8 09DC      L1712:     ST.B      (PaintWhite)
BABA   4CDF 0C18                 MoveM.L   (A7)+, D3-D4/A2-A3
BABE   6000 FE18                 Bra       L1693

                      P301:
BAC2   594F                      SubQ.L    $4, A7
BAC4   A8D8                      _NewRgn
BAC6   206F 0004                 Move.L    $4(A7), A0
BACA   2E9F                      Move.L    (A7)+, (A7)
BACC   4ED0                      Jmp       (A0)

                      P_tSaveOld:
BACE   48E7 1820                 MoveM.L   D3-D4/A2, -(A7)
BAD2   61EE                      Bsr       P301
BAD4   261F                      Move.L    (A7)+, D3
BAD6   61EA                      Bsr       P301
BAD8   281F                      Move.L    (A7)+, D4
BADA   246F 0010                 Move.L    $10(A7), A2
BADE   2F2A 0072                 Move.L    $72(A2), -(A7)
BAE2   2F03                      Move.L    D3, -(A7)
BAE4   A8DC                      _CopyRgn
BAE6   2F2A 0076                 Move.L    $76(A2), -(A7)
BAEA   2F04                      Move.L    D4, -(A7)
BAEC   A8DC                      _CopyRgn
BAEE   48F8 0018 09E6            MoveM.L   D3-D4, (OldStructure)
BAF4   4CDF 0418                 MoveM.L   (A7)+, D3-D4/A2
BAF8   2E9F                      Move.L    (A7)+, (A7)
BAFA   4E75                      Rts

                      P_tDrawNew:
BAFC   48E7 1820                 MoveM.L   D3-D4/A2, -(A7)
BB00   246F 0012                 Move.L    $12(A7), A2
BB04   4CF8 0018 09E6            MoveM.L   (OldStructure), D3-D4
BB0A   4A2A 006E                 Tst.B     $6E(A2)
BB0E   6714                      BEQ       L1713
BB10   2F2A 0072                 Move.L    $72(A2), -(A7)
BB14   2F03                      Move.L    D3, -(A7)
BB16   2F03                      Move.L    D3, -(A7)
BB18   A8E7                      _XOrRgn
BB1A   2F2A 0076                 Move.L    $76(A2), -(A7)
BB1E   2F04                      Move.L    D4, -(A7)
BB20   2F04                      Move.L    D4, -(A7)
BB22   A8E7                      _XOrRgn
BB24   2F04           L1713:     Move.L    D4, -(A7)
BB26   2F03                      Move.L    D3, -(A7)
BB28   2F03                      Move.L    D3, -(A7)
BB2A   A8E5                      _UnionRgn
BB2C   11EF 0010 09DA            Move.B    $10(A7), (SaveUpdate)
BB32   2F0A                      Move.L    A2, -(A7)
BB34   2F03                      Move.L    D3, -(A7)
BB36   A90C                      _PaintOne
BB38   50F8 09DA                 ST.B      (SaveUpdate)
BB3C   2F2A 0090                 Move.L    $90(A2), -(A7)
BB40   2F03                      Move.L    D3, -(A7)
BB42   A90D                      _PaintBehind
BB44   2F0A                      Move.L    A2, -(A7)
BB46   2F03                      Move.L    D3, -(A7)
BB48   A90A                      _CalcVBehind
BB4A   2F03                      Move.L    D3, -(A7)
BB4C   A8D9                      _DisposeRgn
BB4E   2F04                      Move.L    D4, -(A7)
BB50   A8D9                      _DisposeRgn
BB52   4CDF 0418                 MoveM.L   (A7)+, D3-D4/A2
BB56   205F           L1714:     Move.L    (A7)+, A0
BB58   5C4F                      AddQ      $6, A7
BB5A   4ED0                      Jmp       (A0)

                      P_tShowHide:
BB5C   48E7 1850                 MoveM.L   D3-D4/A1/A3, -(A7)
BB60   266F 0016                 Move.L    $16(A7), A3
BB64   162F 0014                 Move.B    $14(A7), D3
BB68   B62B 006E                 Cmp.B     $6E(A3), D3
BB6C   6716                      BEQ       L1715
BB6E   611A                      Bsr       P_mGetSetWPort
BB70   2F0B                      Move.L    A3, -(A7)
BB72   A90E                      _SaveOld
BB74   1743 006E                 Move.B    D3, $6E(A3)
BB78   6100 053C                 Bsr       P310
BB7C   2F0B                      Move.L    A3, -(A7)
BB7E   50E7                      ST.B      -(A7)
BB80   A90F                      _DrawNew
BB82   6110                      Bsr       P_mRestorePort
BB84   4CDF 0A18      L1715:     MoveM.L   (A7)+, D3-D4/A1/A3
BB88   60CC                      Bra       L1714

                      P_mGetSetWPort:
BB8A   2055                      Move.L    (A5), A0
BB8C   2810                      Move.L    (A0), D4
BB8E   20B8 09DE                 Move.L    (WMgrPort), (A0)
BB92   4E75                      Rts

                      P_mRestorePort:
BB94   2F04                      Move.L    D4, -(A7)
BB96   A873                      _SetPort
BB98   4E75                      Rts

                      P_tGetWMgrPort:
BB9A   225F                      Move.L    (A7)+, A1
BB9C   205F                      Move.L    (A7)+, A0
BB9E   20B8 09DE                 Move.L    (WMgrPort), (A0)
BBA2   4ED1                      Jmp       (A1)

                      P_tCheckUpDate:
BBA4   4E56 FFF8                 Link      A6, $-8
BBA8   2F0B                      Move.L    A3, -(A7)
BBAA   426E 000C                 Clr       $C(A6)
BBAE   594F                      SubQ.L    $4, A7
BBB0   2F0F                      Move.L    A7, -(A7)
BBB2   A874                      _GetPort
BBB4   2038 09D6                 Move.L    (WindowList), D0
BBB8   6758                      BEQ       L1718
BBBA   2640           L1716:     Move.L    D0, A3
BBBC   4A2B 006E                 Tst.B     $6E(A3)
BBC0   674A                      BEQ       L1717
BBC2   554F                      SubQ.L    $2, A7
BBC4   2F2B 007A                 Move.L    $7A(A3), -(A7)
BBC8   A8E2                      _EmptyRgn
BBCA   4A1F                      Tst.B     (A7)+
BBCC   663E                      BNE       L1717
BBCE   4AAB 0094                 Tst.L     $94(A3)
BBD2   6748                      BEQ       L1719
BBD4   2F0B                      Move.L    A3, -(A7)
BBD6   A873                      _SetPort
BBD8   594F                      SubQ.L    $4, A7
BBDA   A8D8                      _NewRgn
BBDC   2D57 FFFC                 Move.L    (A7), $-4(A6)
BBE0   A87A                      _GetClip
BBE2   2F2B 001C                 Move.L    $1C(A3), -(A7)
BBE6   486B 0010                 Pea.L     $10(A3)
BBEA   A8DF                      _RectRgn
BBEC   2F0B                      Move.L    A3, -(A7)
BBEE   A922                      _BeginUpDate
BBF0   206B 0094                 Move.L    $94(A3), A0
BBF4   2F08                      Move.L    A0, -(A7)
BBF6   2050                      Move.L    (A0), A0
BBF8   4868 0002                 Pea.L     $2(A0)
BBFC   A8F6                      _DrawPicture
BBFE   2F0B                      Move.L    A3, -(A7)
BC00   A923                      _EndUpDate
BC02   2F2E FFFC                 Move.L    $-4(A6), -(A7)
BC06   2F17                      Move.L    (A7), -(A7)
BC08   A879                      _SetClip
BC0A   A8D9                      _DisposeRgn
BC0C   202B 0090      L1717:     Move.L    $90(A3), D0
BC10   66A8                      BNE       L1716
BC12   A873           L1718:     _SetPort
BC14   265F                      Move.L    (A7)+, A3
BC16   4E5E                      Unlk      A6
BC18   2E9F                      Move.L    (A7)+, (A7)
BC1A   4E75                      Rts
BC1C   206E 0008      L1719:     Move.L    $8(A6), A0
BC20   30FC 0006                 Move      $6, (A0)+
BC24   208B                      Move.L    A3, (A0)
BC26   522E 000C                 AddQ      $1, $C(A6)
BC2A   60E6                      Bra       L1718

                      P304:
BC2C   706C                      MoveQ.L   $6C, D0

                      P305:
BC2E   A11E                      _NewPtr

                      P306:
BC30   2648                      Move.L    A0, A3
BC32   2F08                      Move.L    A0, -(A7)
BC34   A86F                      _OpenPort
BC36   4E75                      Rts

                      P_tInitWindows:
BC38   48E7 1C18                 MoveM.L   D3-D5/A3-A4, -(A7)
BC3C   21F8 0A06 09DA            Move.L    (MinusOne), (SaveUpdate)
BC42   594F                      SubQ.L    $4, A7
BC44   3F3C 0010                 Move      $10, -(A7)
BC48   A9B8                      _GetPattern
BC4A   205F                      Move.L    (A7)+, A0
BC4C   2050                      Move.L    (A0), A0
BC4E   21D8 0A3C                 Move.L    (A0)+, (DeskPattern)
BC52   21D0 0A40                 Move.L    (A0), (DeskPattern.1)
BC56   61D4                      Bsr       P304
BC58   21CB 09DE                 Move.L    A3, (WMgrPort)
BC5C   486B 0010                 Pea.L     $10(A3)
BC60   2F17                      Move.L    (A7), -(A7)
BC62   49F8 09FA                 Lea.L     (scratch8), A4
BC66   7A0C                      MoveQ.L   $C, D5
BC68   2057                      Move.L    (A7), A0
BC6A   28D8                      Move.L    (A0)+, (A4)+
BC6C   2890                      Move.L    (A0), (A4)
BC6E   3610                      Move      (A0), D3
BC70   3885                      Move      D5, (A4)
BC72   4878 09FA                 Pea.L     (scratch8)
BC76   A8A2                      _PaintRect
BC78   3883                      Move      D3, (A4)
BC7A   9645                      Sub       D5, D3
BC7C   594C                      SubQ.L    $4, A4
BC7E   3883                      Move      D3, (A4)
BC80   2F0C                      Move.L    A4, -(A7)
BC82   A8A2                      _PaintRect
BC84   263C 0010 0010            Move.L    $100010, D3
BC8A   2F03                      Move.L    D3, -(A7)
BC8C   4878 0A3C                 Pea.L     (DeskPattern)
BC90   A8B4                      _FillRoundRect
BC92   4EBA 0C24                 Jsr       P328
BC96   6100 FE2A                 Bsr       P301
BC9A   2A1F                      Move.L    (A7)+, D5
BC9C   21C5 09EE                 Move.L    D5, (GrayRgn)
BCA0   A896                      _HidePen
BCA2   A8DA                      _OpenRgn
BCA4   2F03                      Move.L    D3, -(A7)
BCA6   A8B0                      _FrameRoundRect
BCA8   2F05                      Move.L    D5, -(A7)
BCAA   A8DB                      _CloseRgn
BCAC   A897                      _ShowPen
BCAE   2F05                      Move.L    D5, -(A7)
BCB0   2F2B 001C                 Move.L    $1C(A3), -(A7)
BCB4   2F05                      Move.L    D5, -(A7)
BCB6   A8E6                      _DiffRgn
BCB8   2F05                      Move.L    D5, -(A7)
BCBA   A879                      _SetClip
BCBC   A853                      _ShowCursor
BCBE   42B8 09D6                 Clr.L     (WindowList)
BCC2   6100 FDFE                 Bsr       P301
BCC6   21DF 09F2                 Move.L    (A7)+, (SaveVisRgn)
BCCA   42B8 0A84                 Clr.L     (GhostWindow)
BCCE   41F8 0A64                 Lea.L     (CurActivate), A0
BCD2   4298                      Clr.L     (A0)+
BCD4   4298                      Clr.L     (A0)+
BCD6   4CDF 1838                 MoveM.L   (A7)+, D3-D5/A3-A4
BCDA   4E75                      Rts
BCDC   C0B8 031A      L1720:     And.L     (Lo3Bytes), D0
BCE0   2040                      Move.L    D0, A0
BCE2   6100 FF4C                 Bsr       P306
BCE6   601C                      Bra       L1721

                      P_tNewWindow:
BCE8   4E56 0000                 Link      A6, $0
BCEC   48E7 1C38                 MoveM.L   D3-D5/A2-A4, -(A7)
BCF0   6100 FE98                 Bsr       P_mGetSetWPort
BCF4   202E 001E                 Move.L    $1E(A6), D0
BCF8   66E2                      BNE       L1720
BCFA   7000                      MoveQ.L   $0, D0
BCFC   303C 009C                 Move      $9C, D0
BD00   6100 FF2C                 Bsr       P305
BD04   2D4B 0022      L1721:     Move.L    A3, $22(A6)
BD08   377C 0001 0044            Move      $1, $44(A3)
BD0E   246E 001A                 Move.L    $1A(A6), A2
BD12   2F12                      Move.L    (A2), -(A7)
BD14   A877                      _MovePortTo
BD16   594F                      SubQ.L    $4, A7
BD18   2F2A 0004                 Move.L    $4(A2), -(A7)
BD1C   2F12                      Move.L    (A2), -(A7)
BD1E   6100 0260                 Bsr       P_tDeltaPoint
BD22   A876                      _PortSize
BD24   2F38 09DE                 Move.L    (WMgrPort), -(A7)
BD28   A873                      _SetPort
BD2A   45EB 006C                 Lea.L     $6C(A3), A2
BD2E   34FC 0008                 Move      $8, (A2)+
BD32   4A2E 0014                 Tst.B     $14(A6)
BD36   56DA                      SNE.B     (A2)+
BD38   421A                      Clr.B     (A2)+
BD3A   4A2E 000C                 Tst.B     $C(A6)
BD3E   56DA                      SNE.B     (A2)+
BD40   421A                      Clr.B     (A2)+
BD42   7602                      MoveQ.L   $2, D3
BD44   6100 FD7C      L1722:     Bsr       P301
BD48   24DF                      Move.L    (A7)+, (A2)+
BD4A   51CB FFF8                 DBF       D3, L1722
BD4E   362E 0012                 Move      $12(A6), D3
BD52   E84B                      LsR       $4, D3
BD54   594F           L1723:     SubQ.L    $4, A7
BD56   2F3C 5744 4546            Move.L    $57444546, -(A7)
BD5C   3F03                      Move      D3, -(A7)
BD5E   A9A0                      _GetResource
BD60   7600                      MoveQ.L   $0, D3
BD62   249F                      Move.L    (A7)+, (A2)
BD64   67EE                      BEQ       L1723
BD66   760F                      MoveQ.L   $F, D3
BD68   C66E 0012                 And       $12(A6), D3
BD6C   1483                      Move.B    D3, (A2)
BD6E   584A                      AddQ      $4, A2
BD70   429A                      Clr.L     (A2)+
BD72   262E 0016                 Move.L    $16(A6), D3
BD76   42A7                      Clr.L     -(A7)
BD78   2F03                      Move.L    D3, -(A7)
BD7A   A906                      _NewString
BD7C   24DF                      Move.L    (A7)+, (A2)+
BD7E   4267                      Clr       -(A7)
BD80   2F03                      Move.L    D3, -(A7)
BD82   A88C                      _StringWidth
BD84   34DF                      Move      (A7)+, (A2)+
BD86   429A                      Clr.L     (A2)+
BD88   429A                      Clr.L     (A2)+
BD8A   429A                      Clr.L     (A2)+
BD8C   24EE 0008                 Move.L    $8(A6), (A2)+
BD90   7003                      MoveQ.L   $3, D0
BD92   6100 02E2                 Bsr       P308
BD96   6100 031E                 Bsr       P310
BD9A   2A2E 000E                 Move.L    $E(A6), D5
BD9E   0805 0000                 BTst.B    $0, D5
BDA2   6630                      BNE       L1725
BDA4   4AB8 09D6                 Tst.L     (WindowList)
BDA8   672A                      BEQ       L1725
BDAA   2F0B                      Move.L    A3, -(A7)
BDAC   2F05                      Move.L    D5, -(A7)
BDAE   6100 FAF6                 Bsr       P295
BDB2   2F0B           L1724:     Move.L    A3, -(A7)
BDB4   2F2B 0072                 Move.L    $72(A3), -(A7)
BDB8   A90C                      _PaintOne
BDBA   2F0B                      Move.L    A3, -(A7)
BDBC   2F2B 0072                 Move.L    $72(A3), -(A7)
BDC0   A90A                      _CalcVBehind
BDC2   6100 FDD0                 Bsr       P_mRestorePort
BDC6   4CDF 1C38                 MoveM.L   (A7)+, D3-D5/A2-A4
BDCA   4E5E                      Unlk      A6
BDCC   205F                      Move.L    (A7)+, A0
BDCE   DEFC 001A                 AddA      $1A, A7
BDD2   4ED0                      Jmp       (A0)
BDD4   4A2B 006E      L1725:     Tst.B     $6E(A3)
BDD8   6712                      BEQ       L1727
BDDA   594F                      SubQ.L    $4, A7
BDDC   A924                      _FrontWindow
BDDE   201F                      Move.L    (A7)+, D0
BDE0   6702                      BEQ       L1726
BDE2   617E                      Bsr       P307
BDE4   50EB 006F      L1726:     ST.B      $6F(A3)
BDE8   21CB 0A64                 Move.L    A3, (CurActivate)
BDEC   2778 09D6 0090 L1727:     Move.L    (WindowList), $90(A3)
BDF2   21CB 09D6                 Move.L    A3, (WindowList)
BDF6   60BA                      Bra       L1724

                      P_tCloseWindow:
BDF8   48E7 1810                 MoveM.L   D3-D4/A3, -(A7)
BDFC   266F 0010                 Move.L    $10(A7), A3
BE00   6100 FD88                 Bsr       P_mGetSetWPort
BE04   594F                      SubQ.L    $4, A7
BE06   A924                      _FrontWindow
BE08   2F0B                      Move.L    A3, -(A7)
BE0A   A956                      _KillControls
BE0C   7004                      MoveQ.L   $4, D0
BE0E   6100 0266                 Bsr       P308
BE12   2F0B                      Move.L    A3, -(A7)
BE14   4267                      Clr       -(A7)
BE16   A908                      _ShowHide
BE18   2F0B                      Move.L    A3, -(A7)
BE1A   6100 FAC2                 Bsr       P_mDeleteWindow
BE1E   206B 0086                 Move.L    $86(A3), A0
BE22   A023                      _DisposeHandle
BE24   2F2B 0072                 Move.L    $72(A3), -(A7)
BE28   A8D9                      _DisposeRgn
BE2A   2F2B 0076                 Move.L    $76(A3), -(A7)
BE2E   A8D9                      _DisposeRgn
BE30   2F2B 007A                 Move.L    $7A(A3), -(A7)
BE34   A8D9                      _DisposeRgn
BE36   2F0B                      Move.L    A3, -(A7)
BE38   A87D                      _ClosePort
BE3A   202B 0094                 Move.L    $94(A3), D0
BE3E   6704                      BEQ       L1728
BE40   2F00                      Move.L    D0, -(A7)
BE42   A8F5                      _KillPicture
BE44   B7DF           L1728:     CmpA.L    (A7)+, A3
BE46   660E                      BNE       L1729
BE48   31EB 006C 0A22            Move      $6C(A3), (CurDeKind)
BE4E   594F                      SubQ.L    $4, A7
BE50   A924                      _FrontWindow
BE52   6100 0392                 Bsr       P315
BE56   6100 FD3C      L1729:     Bsr       P_mRestorePort
BE5A   4CDF 0818      L1730:     MoveM.L   (A7)+, D3-D4/A3
BE5E   2E9F                      Move.L    (A7)+, (A7)
BE60   4E75                      Rts

                      P307:
BE62   2F00                      Move.L    D0, -(A7)
BE64   2F00                      Move.L    D0, -(A7)
BE66   4267                      Clr       -(A7)
BE68   A91C                      _HiliteWindow
BE6A   201F                      Move.L    (A7)+, D0
BE6C   4AB8 0A68                 Tst.L     (CurDeactive)
BE70   6E0C                      BGT       L1731
BE72   2040                      Move.L    D0, A0
BE74   31E8 006C 0A22            Move      $6C(A0), (CurDeKind)
BE7A   21C0 0A68                 Move.L    D0, (CurDeactive)
BE7E   4E75           L1731:     Rts

                      P_tDisposeWindow:
BE80   2F2F 0004                 Move.L    $4(A7), -(A7)
BE84   6100 FF72                 Bsr       P_tCloseWindow
BE88   225F                      Move.L    (A7)+, A1
BE8A   205F                      Move.L    (A7)+, A0
BE8C   A01F                      _DisposePtr
BE8E   4ED1                      Jmp       (A1)

                      P_tShowWindow:
BE90   2078 09D6                 Move.L    (WindowList), A0
BE94   4A28 006E      L1732:     Tst.B     $6E(A0)
BE98   660E                      BNE       L1733
BE9A   B1EF 0004                 CmpA.L    $4(A7), A0
BE9E   6710                      BEQ       L1734
BEA0   2068 0090                 Move.L    $90(A0), A0
BEA4   2008                      Move.L    A0, D0
BEA6   66EC                      BNE       L1732
BEA8   225F           L1733:     Move.L    (A7)+, A1
BEAA   50E7                      ST.B      -(A7)
BEAC   A908                      _ShowHide
BEAE   4ED1                      Jmp       (A1)
BEB0   2F08           L1734:     Move.L    A0, -(A7)
BEB2   A91F                      _SelectWindow
BEB4   60F2                      Bra       L1733

                      P_tHideWindow:
BEB6   594F                      SubQ.L    $4, A7
BEB8   A924                      _FrontWindow
BEBA   2F2F 0008                 Move.L    $8(A7), -(A7)
BEBE   4267                      Clr       -(A7)
BEC0   A908                      _ShowHide
BEC2   201F                      Move.L    (A7)+, D0
BEC4   B0AF 0004                 Cmp.L     $4(A7), D0
BEC8   660E                      BNE       L1735
BECA   6196                      Bsr       P307
BECC   594F                      SubQ.L    $4, A7
BECE   A924                      _FrontWindow
BED0   21D7 0A64                 Move.L    (A7), (CurActivate)
BED4   6706                      BEQ       L1736
BED6   A91F                      _SelectWindow
BED8   2E9F           L1735:     Move.L    (A7)+, (A7)
BEDA   4E75                      Rts
BEDC   584F           L1736:     AddQ      $4, A7
BEDE   60F8                      Bra       L1735

                      P_tGetWRefCon:
BEE0   323C 0098                 Move      $98, D1
BEE4   205F           L1737:     Move.L    (A7)+, A0
BEE6   225F                      Move.L    (A7)+, A1
BEE8   2EB1 1000                 Move.L    $0(A1,D1.W), (A7)
BEEC   4ED0                      Jmp       (A0)

                      P_tSetWRefCon:
BEEE   323C 0098                 Move      $98, D1
BEF2   205F           L1738:     Move.L    (A7)+, A0
BEF4   201F                      Move.L    (A7)+, D0
BEF6   225F                      Move.L    (A7)+, A1
BEF8   2380 1000                 Move.L    D0, $0(A1,D1.W)
BEFC   4ED0                      Jmp       (A0)

                      P_tSetWindowPic:
BEFE   323C 0094                 Move      $94, D1
BF02   60EE                      Bra       L1738

                      P_tGetWindowPic:
BF04   323C 0094                 Move      $94, D1
BF08   60DA                      Bra       L1737

                      P_tGetWTitle:
BF0A   4CDF 0302                 MoveM.L   (A7)+, D1/A0-A1
BF0E   2269 0086                 Move.L    $86(A1), A1
BF12   2251                      Move.L    (A1), A1
BF14   7000                      MoveQ.L   $0, D0
BF16   1011                      Move.B    (A1), D0
BF18   10D9           L1739:     Move.B    (A1)+, (A0)+
BF1A   51C8 FFFC                 DBF       D0, L1739
BF1E   2041                      Move.L    D1, A0
BF20   4ED0                      Jmp       (A0)

                      P_tSetWTitle:
BF22   48E7 1C30                 MoveM.L   D3-D5/A2-A3, -(A7)
BF26   2A2F 0018                 Move.L    $18(A7), D5
BF2A   266F 001C                 Move.L    $1C(A7), A3
BF2E   6100 FC5A                 Bsr       P_mGetSetWPort
BF32   206B 0072                 Move.L    $72(A3), A0
BF36   A9E1                      _HandToHand
BF38   2608                      Move.L    A0, D3
BF3A   2F2B 0086                 Move.L    $86(A3), -(A7)
BF3E   2F05                      Move.L    D5, -(A7)
BF40   A907                      _SetString
BF42   554F                      SubQ.L    $2, A7
BF44   2F05                      Move.L    D5, -(A7)
BF46   A88C                      _StringWidth
BF48   375F 008A                 Move      (A7)+, $8A(A3)
BF4C   6100 0168                 Bsr       P310
BF50   2F2B 0072                 Move.L    $72(A3), -(A7)
BF54   2F03                      Move.L    D3, -(A7)
BF56   2F03                      Move.L    D3, -(A7)
BF58   A8E5                      _UnionRgn
BF5A   2F03                      Move.L    D3, -(A7)
BF5C   2F2B 0076                 Move.L    $76(A3), -(A7)
BF60   2F03                      Move.L    D3, -(A7)
BF62   A8E6                      _DiffRgn
BF64   2F0B                      Move.L    A3, -(A7)
BF66   2F03                      Move.L    D3, -(A7)
BF68   A90D                      _PaintBehind
BF6A   2F0B                      Move.L    A3, -(A7)
BF6C   2F03                      Move.L    D3, -(A7)
BF6E   A90A                      _CalcVBehind
BF70   2F03                      Move.L    D3, -(A7)
BF72   A8D9                      _DisposeRgn
BF74   6100 FC1E                 Bsr       P_mRestorePort
BF78   4CDF 0C38                 MoveM.L   (A7)+, D3-D5/A2-A3
BF7C   6000 F95A      L1740:     Bra       L1693

                      P_tDeltaPoint:
BF80   302F 0008                 Move      $8(A7), D0
BF84   906F 0004                 Sub       $4(A7), D0
BF88   3F40 000C                 Move      D0, $C(A7)
BF8C   302F 000A                 Move      $A(A7), D0
BF90   906F 0006                 Sub       $6(A7), D0
BF94   3F40 000E                 Move      D0, $E(A7)
BF98   60E2                      Bra       L1740

                      P_tMoveWindow:
BF9A   48E7 1E18                 MoveM.L   D3-D6/A3-A4, -(A7)
BF9E   6100 FBEA                 Bsr       P_mGetSetWPort
BFA2   266F 0022                 Move.L    $22(A7), A3
BFA6   6100 0164                 Bsr       P312
BFAA   6100 FB16                 Bsr       P301
BFAE   2A1F                      Move.L    (A7)+, D5
BFB0   286B 0072                 Move.L    $72(A3), A4
BFB4   2F0C                      Move.L    A4, -(A7)
BFB6   2078 09DE                 Move.L    (WMgrPort), A0
BFBA   2F28 001C                 Move.L    $1C(A0), -(A7)
BFBE   2F05                      Move.L    D5, -(A7)
BFC0   A8E4                      _SectRgn
BFC2   204C                      Move.L    A4, A0
BFC4   A9E1                      _HandToHand
BFC6   2C08                      Move.L    A0, D6
BFC8   2F0C                      Move.L    A4, -(A7)
BFCA   594F                      SubQ.L    $4, A7
BFCC   2F2F 0026                 Move.L    $26(A7), -(A7)
BFD0   594F                      SubQ.L    $4, A7
BFD2   2F2B 0010                 Move.L    $10(A3), -(A7)
BFD6   2F2B 0008                 Move.L    $8(A3), -(A7)
BFDA   61A4                      Bsr       P_tDeltaPoint
BFDC   61A2                      Bsr       P_tDeltaPoint
BFDE   2617                      Move.L    (A7), D3
BFE0   A8E0                      _OffsetRgn
BFE2   2F2B 0076                 Move.L    $76(A3), -(A7)
BFE6   2F03                      Move.L    D3, -(A7)
BFE8   A8E0                      _OffsetRgn
BFEA   2F2B 007A                 Move.L    $7A(A3), -(A7)
BFEE   2F03                      Move.L    D3, -(A7)
BFF0   A8E0                      _OffsetRgn
BFF2   2F05                      Move.L    D5, -(A7)
BFF4   2F03                      Move.L    D3, -(A7)
BFF6   A8E0                      _OffsetRgn
BFF8   486B 0008                 Pea.L     $8(A3)
BFFC   2F03                      Move.L    D3, -(A7)
BFFE   6100 028E                 Bsr       P317
C002   A8A8                      _OffsetRect
C004   4A2F 001C                 Tst.B     $1C(A7)
C008   6706                      BEQ       L1741
C00A   2F38 09EE                 Move.L    (GrayRgn), -(A7)
C00E   A879                      _SetClip
C010   2078 09DE      L1741:     Move.L    (WMgrPort), A0
C014   4868 0002                 Pea.L     $2(A0)
C018   2F17                      Move.L    (A7), -(A7)
C01A   2046                      Move.L    D6, A0
C01C   2050                      Move.L    (A0), A0
C01E   4868 0002                 Pea.L     $2(A0)
C022   2054                      Move.L    (A4), A0
C024   4868 0002                 Pea.L     $2(A0)
C028   4267                      Clr       -(A7)
C02A   2F05                      Move.L    D5, -(A7)
C02C   A8EC                      _CopyBits
C02E   2F0C                      Move.L    A4, -(A7)
C030   2F05                      Move.L    D5, -(A7)
C032   2F05                      Move.L    D5, -(A7)
C034   A8E6                      _DiffRgn
C036   2F2B 0090                 Move.L    $90(A3), -(A7)
C03A   2F06                      Move.L    D6, -(A7)
C03C   A90D                      _PaintBehind
C03E   4A2F 001C                 Tst.B     $1C(A7)
C042   670A                      BEQ       L1742
C044   2F0B                      Move.L    A3, -(A7)
C046   50F8 0A44                 ST.B      (DragFlag)
C04A   6100 0182                 Bsr       P314
C04E   2F0B           L1742:     Move.L    A3, -(A7)
C050   2F05                      Move.L    D5, -(A7)
C052   A90C                      _PaintOne
C054   2F06                      Move.L    D6, -(A7)
C056   2F0C                      Move.L    A4, -(A7)
C058   2F06                      Move.L    D6, -(A7)
C05A   A8E5                      _UnionRgn
C05C   2F0B                      Move.L    A3, -(A7)
C05E   2F06                      Move.L    D6, -(A7)
C060   A90A                      _CalcVBehind
C062   2F05                      Move.L    D5, -(A7)
C064   A8D9                      _DisposeRgn
C066   2F06                      Move.L    D6, -(A7)
C068   A8D9                      _DisposeRgn
C06A   6100 FB28                 Bsr       P_mRestorePort
C06E   4CDF 1878                 MoveM.L   (A7)+, D3-D6/A3-A4
C072   6000 00E4                 Bra       L1747

                      P308:
C076   42A7                      Clr.L     -(A7)
C078   7200                      MoveQ.L   $0, D1
C07A   122B 007E                 Move.B    $7E(A3), D1
C07E   3F01                      Move      D1, -(A7)
C080   2F0B                      Move.L    A3, -(A7)
C082   3F00                      Move      D0, -(A7)
C084   2F03                      Move.L    D3, -(A7)
C086   206B 007E                 Move.L    $7E(A3), A0
C08A   2010                      Move.L    (A0), D0
C08C   6608                      BNE       L1743
C08E   2F08                      Move.L    A0, -(A7)
C090   4217                      Clr.B     (A7)
C092   A9A2                      _LoadResource
C094   2010                      Move.L    (A0), D0
C096   08D0 0007      L1743:     BSet.B    $7, (A0)
C09A   2040                      Move.L    D0, A0
C09C   4E90                      Jsr       (A0)
C09E   201F                      Move.L    (A7)+, D0
C0A0   206B 007E                 Move.L    $7E(A3), A0
C0A4   0890 0007                 BClr.B    $7, (A0)
C0A8   4E75                      Rts

                      P309:
C0AA   2F03                      Move.L    D3, -(A7)
C0AC   7600                      MoveQ.L   $0, D3
C0AE   7000                      MoveQ.L   $0, D0
C0B0   61C4                      Bsr       P308
C0B2   261F                      Move.L    (A7)+, D3
C0B4   4E75                      Rts

                      P310:
C0B6   7002                      MoveQ.L   $2, D0
C0B8   4A2B 006E                 Tst.B     $6E(A3)
C0BC   66B8                      BNE       P308
C0BE   2F2B 0072                 Move.L    $72(A3), -(A7)
C0C2   A8DD                      _SetEmptyRgn
C0C4   2F2B 0076                 Move.L    $76(A3), -(A7)
C0C8   A8DD                      _SetEmptyRgn
C0CA   2F2B 0018                 Move.L    $18(A3), -(A7)
C0CE   A8DD                      _SetEmptyRgn
C0D0   4E75                      Rts

                      P_tHiliteWindow:
C0D2   48E7 1818                 MoveM.L   D3-D4/A3-A4, -(A7)
C0D6   266F 0016                 Move.L    $16(A7), A3
C0DA   162F 0014                 Move.B    $14(A7), D3
C0DE   6100 FAAA                 Bsr       P_mGetSetWPort
C0E2   102B 006F                 Move.B    $6F(A3), D0
C0E6   B740                      Eor       D3, D0
C0E8   E248                      LsR       $1, D0
C0EA   6408                      BCC       L1744
C0EC   1743 006F                 Move.B    D3, $6F(A3)
C0F0   610E                      Bsr       P311
C0F2   61B6                      Bsr       P309
C0F4   6100 FA9E      L1744:     Bsr       P_mRestorePort
C0F8   4CDF 1818                 MoveM.L   (A7)+, D3-D4/A3-A4
C0FC   6000 FA58                 Bra       L1714

                      P311:
C100   2F2B 0072                 Move.L    $72(A3), -(A7)
C104   A879           L1745:     _SetClip
C106   2F0B                      Move.L    A3, -(A7)
C108   A90B                      _ClipAbove
C10A   4E75                      Rts

                      P312:
C10C   2F38 09EE                 Move.L    (GrayRgn), -(A7)
C110   60F2                      Bra       L1745

                      P_tSizeWindow:
C112   48E7 1818                 MoveM.L   D3-D4/A3-A4, -(A7)
C116   262F 0016                 Move.L    $16(A7), D3
C11A   6738                      BEQ       L1746
C11C   266F 001A                 Move.L    $1A(A7), A3
C120   382F 0016                 Move      $16(A7), D4
C124   49EB 0010                 Lea.L     $10(A3), A4
C128   D85C                      Add       (A4)+, D4
C12A   D65C                      Add       (A4)+, D3
C12C   38C4                      Move      D4, (A4)+
C12E   38C3                      Move      D3, (A4)+
C130   4A2B 006E                 Tst.B     $6E(A3)
C134   671E                      BEQ       L1746
C136   6100 FA52                 Bsr       P_mGetSetWPort
C13A   2F0B                      Move.L    A3, -(A7)
C13C   A90E                      _SaveOld
C13E   6100 FF76                 Bsr       P310
C142   61BC                      Bsr       P311
C144   6100 FF64                 Bsr       P309
C148   2F0B                      Move.L    A3, -(A7)
C14A   3F2F 0018                 Move      $18(A7), -(A7)
C14E   A90F                      _DrawNew
C150   6100 FA42                 Bsr       P_mRestorePort
C154   4CDF 1818      L1746:     MoveM.L   (A7)+, D3-D4/A3-A4
C158   205F           L1747:     Move.L    (A7)+, A0
C15A   DEFC 000A                 AddA      $A, A7
C15E   4ED0                      Jmp       (A0)

                      P_tTrackGoAway:
C160   4E56 FFFC                 Link      A6, $-4
C164   48E7 1C10                 MoveM.L   D3-D5/A3, -(A7)
C168   6100 FA20                 Bsr       P_mGetSetWPort
C16C   41EE 0008                 Lea.L     $8(A6), A0
C170   2D58 FFFC                 Move.L    (A0)+, $-4(A6)
C174   2658                      Move.L    (A0)+, A3
C176   4250                      Clr       (A0)
C178   7A00                      MoveQ.L   $0, D5
C17A   6184                      Bsr       P311
C17C   7001           L1748:     MoveQ.L   $1, D0
C17E   262E FFFC                 Move.L    $-4(A6), D3
C182   6100 FEF2                 Bsr       P308
C186   0C40 0004                 Cmp       $4, D0
C18A   6702                      BEQ       L1749
C18C   7000                      MoveQ.L   $0, D0
C18E   BA40           L1749:     Cmp       D0, D5
C190   6704                      BEQ       L1750
C192   3A00                      Move      D0, D5
C194   612A                      Bsr       P313
C196   486E FFFC      L1750:     Pea.L     $-4(A6)
C19A   A972                      _GetMouse
C19C   6100 037C                 Bsr       P318
C1A0   4267                      Clr       -(A7)
C1A2   A977                      _WaitMouseUp
C1A4   4A1F                      Tst.B     (A7)+
C1A6   66D4                      BNE       L1748
C1A8   4A45                      Tst       D5
C1AA   6706                      BEQ       L1751
C1AC   522E 0010                 AddQ      $1, $10(A6)
C1B0   610E                      Bsr       P313
C1B2   6100 F9E0      L1751:     Bsr       P_mRestorePort
C1B6   4CDF 0838                 MoveM.L   (A7)+, D3-D5/A3
C1BA   4E5E                      Unlk      A6
C1BC   6000 F71A                 Bra       L1693

                      P313:
C1C0   7000                      MoveQ.L   $0, D0
C1C2   7604                      MoveQ.L   $4, D3
C1C4   6100 FEB0                 Bsr       P308
C1C8   4E75                      Rts

                      P_tSelectWindow:
C1CA   4238 0A44                 Clr.B     (DragFlag)

                      P314:
C1CE   594F                      SubQ.L    $4, A7
C1D0   A924                      _FrontWindow
C1D2   2F2F 0008                 Move.L    $8(A7), -(A7)
C1D6   6126                      Bsr       P316
C1D8   201F                      Move.L    (A7)+, D0
C1DA   670A                      BEQ       P315
C1DC   B0AF 0004                 Cmp.L     $4(A7), D0
C1E0   670E                      BEQ       L1752
C1E2   6100 FC7E                 Bsr       P307

                      P315:
C1E6   202F 0004                 Move.L    $4(A7), D0
C1EA   670A                      BEQ       L1753
C1EC   21C0 0A64                 Move.L    D0, (CurActivate)
C1F0   2F00           L1752:     Move.L    D0, -(A7)
C1F2   50E7                      ST.B      -(A7)
C1F4   A91C                      _HiliteWindow
C1F6   2E9F           L1753:     Move.L    (A7)+, (A7)
C1F8   4E75                      Rts

                      P_tBringToFront:
C1FA   4238 0A44                 Clr.B     (DragFlag)

                      P316:
C1FE   48E7 1E38                 MoveM.L   D3-D6/A2-A4, -(A7)
C202   266F 0020                 Move.L    $20(A7), A3
C206   6100 F982                 Bsr       P_mGetSetWPort
C20A   45F8 09D6                 Lea.L     (WindowList), A2
C20E   B7D2                      CmpA.L    (A2), A3
C210   6700 0070                 BEQ       L1758
C214   6100 F8AC                 Bsr       P301
C218   261F                      Move.L    (A7)+, D3
C21A   2852                      Move.L    (A2), A4
C21C   B9CB           L1754:     CmpA.L    A3, A4
C21E   6738                      BEQ       L1756
C220   4A2C 006E                 Tst.B     $6E(A4)
C224   672A                      BEQ       L1755
C226   2C2C 0008                 Move.L    $8(A4), D6
C22A   2A2C 0018                 Move.L    $18(A4), D5
C22E   2F05                      Move.L    D5, -(A7)
C230   2F06                      Move.L    D6, -(A7)
C232   615A                      Bsr       P317
C234   A8E0                      _OffsetRgn
C236   2F05                      Move.L    D5, -(A7)
C238   2F2B 0072                 Move.L    $72(A3), -(A7)
C23C   2F05                      Move.L    D5, -(A7)
C23E   A8E6                      _DiffRgn
C240   2F05                      Move.L    D5, -(A7)
C242   2F06                      Move.L    D6, -(A7)
C244   A8E0                      _OffsetRgn
C246   2F2C 0072                 Move.L    $72(A4), -(A7)
C24A   2F03                      Move.L    D3, -(A7)
C24C   2F03                      Move.L    D3, -(A7)
C24E   A8E5                      _UnionRgn
C250   286C 0090      L1755:     Move.L    $90(A4), A4
C254   200C                      Move.L    A4, D0
C256   66C4                      BNE       L1754
C258   2F0B           L1756:     Move.L    A3, -(A7)
C25A   6100 F682                 Bsr       P_mDeleteWindow
C25E   2752 0090                 Move.L    (A2), $90(A3)
C262   248B                      Move.L    A3, (A2)
C264   4A38 0A44                 Tst.B     (DragFlag)
C268   6610                      BNE       L1757
C26A   2F2B 0072                 Move.L    $72(A3), -(A7)
C26E   2F03                      Move.L    D3, -(A7)
C270   2F03                      Move.L    D3, -(A7)
C272   A8E4                      _SectRgn
C274   2F0B                      Move.L    A3, -(A7)
C276   2F03                      Move.L    D3, -(A7)
C278   A90C                      _PaintOne
C27A   2F0B           L1757:     Move.L    A3, -(A7)
C27C   A909                      _CalcVis
C27E   2F03                      Move.L    D3, -(A7)
C280   A8D9                      _DisposeRgn
C282   6100 F910      L1758:     Bsr       P_mRestorePort
C286   4CDF 1C78                 MoveM.L   (A7)+, D3-D6/A2-A4
C28A   2E9F                      Move.L    (A7)+, (A7)
C28C   4E75                      Rts

                      P317:
C28E   446F 0004                 Neg       $4(A7)
C292   446F 0006                 Neg       $6(A7)
C296   4E75                      Rts

                      P_tSendBehind:
C298   48E7 1810                 MoveM.L   D3-D4/A3, -(A7)
C29C   266F 0014                 Move.L    $14(A7), A3
C2A0   6100 F8E8                 Bsr       P_mGetSetWPort
C2A4   594F                      SubQ.L    $4, A7
C2A6   A924                      _FrontWindow
C2A8   B7DF                      CmpA.L    (A7)+, A3
C2AA   6614                      BNE       L1760
C2AC   204B                      Move.L    A3, A0
C2AE   2068 0090      L1759:     Move.L    $90(A0), A0
C2B2   2008                      Move.L    A0, D0
C2B4   670A                      BEQ       L1760
C2B6   4A28 006E                 Tst.B     $6E(A0)
C2BA   67F2                      BEQ       L1759
C2BC   2F08                      Move.L    A0, -(A7)
C2BE   A91F                      _SelectWindow
C2C0   2F0B           L1760:     Move.L    A3, -(A7)
C2C2   6100 F61A                 Bsr       P_mDeleteWindow
C2C6   262B 0072                 Move.L    $72(A3), D3
C2CA   2F2B 0090                 Move.L    $90(A3), -(A7)
C2CE   2F17                      Move.L    (A7), -(A7)
C2D0   2F0B                      Move.L    A3, -(A7)
C2D2   2F2F 001C                 Move.L    $1C(A7), -(A7)
C2D6   6100 F5CE                 Bsr       P295
C2DA   2F03                      Move.L    D3, -(A7)
C2DC   A90A                      _CalcVBehind
C2DE   2F03                      Move.L    D3, -(A7)
C2E0   A90D                      _PaintBehind
C2E2   6100 F8B0                 Bsr       P_mRestorePort
C2E6   4CDF 0818                 MoveM.L   (A7)+, D3-D4/A3
C2EA   6000 F5EC                 Bra       L1693

                      P_tBeginUpDate:
C2EE   48E7 1810                 MoveM.L   D3-D4/A3, -(A7)
C2F2   266F 0010                 Move.L    $10(A7), A3
C2F6   262B 0008                 Move.L    $8(A3), D3
C2FA   282B 0018                 Move.L    $18(A3), D4
C2FE   2F04                      Move.L    D4, -(A7)
C300   2F03                      Move.L    D3, -(A7)
C302   618A                      Bsr       P317
C304   A8E0                      _OffsetRgn
C306   2F04                      Move.L    D4, -(A7)
C308   2F38 09F2                 Move.L    (SaveVisRgn), -(A7)
C30C   A8DC                      _CopyRgn
C30E   2F04                      Move.L    D4, -(A7)
C310   2F2B 007A                 Move.L    $7A(A3), -(A7)
C314   2F04                      Move.L    D4, -(A7)
C316   A8E4                      _SectRgn
C318   2F04                      Move.L    D4, -(A7)
C31A   2F03                      Move.L    D3, -(A7)
C31C   A8E0                      _OffsetRgn
C31E   2F2B 007A                 Move.L    $7A(A3), -(A7)
C322   A8DD                      _SetEmptyRgn
C324   6000 FB34                 Bra       L1730

                      P_tEndUpDate:
C328   2F0B                      Move.L    A3, -(A7)
C32A   266F 0008                 Move.L    $8(A7), A3
C32E   2F38 09F2                 Move.L    (SaveVisRgn), -(A7)
C332   2F17                      Move.L    (A7), -(A7)
C334   2F17                      Move.L    (A7), -(A7)
C336   2F2B 0008                 Move.L    $8(A3), -(A7)
C33A   A8E0                      _OffsetRgn
C33C   2F2B 0018                 Move.L    $18(A3), -(A7)
C340   A8DC                      _CopyRgn
C342   A8DD                      _SetEmptyRgn
C344   265F                      Move.L    (A7)+, A3
C346   2E9F                      Move.L    (A7)+, (A7)
C348   4E75                      Rts

                      P_tFrontWindow:
C34A   2078 09D6                 Move.L    (WindowList), A0
C34E   2008           L1761:     Move.L    A0, D0
C350   6712                      BEQ       L1763
C352   B1F8 0A84                 CmpA.L    (GhostWindow), A0
C356   6706                      BEQ       L1762
C358   4A28 006E                 Tst.B     $6E(A0)
C35C   6606                      BNE       L1763
C35E   2068 0090      L1762:     Move.L    $90(A0), A0
C362   60EA                      Bra       L1761
C364   2F48 0004      L1763:     Move.L    A0, $4(A7)
C368   4E75                      Rts

                      P_tDragWindow:
C36A   4E56 FFDC                 Link      A6, $-24
C36E   48E7 1E18                 MoveM.L   D3-D6/A3-A4, -(A7)
C372   554F                      SubQ.L    $2, A7
C374   A977                      _WaitMouseUp
C376   4A1F                      Tst.B     (A7)+
C378   6700 008E                 BEQ       L1767
C37C   206E 0008                 Move.L    $8(A6), A0
C380   3018                      Move      (A0)+, D0
C382   0C40 0018                 Cmp       $18, D0
C386   6400 0004                 BCC       L1764
C38A   7018                      MoveQ.L   $18, D0
C38C   43EE FFF0      L1764:     Lea.L     $-10(A6), A1
C390   32C0                      Move      D0, (A1)+
C392   32D8                      Move      (A0)+, (A1)+
C394   2290                      Move.L    (A0), (A1)
C396   262E 000C                 Move.L    $C(A6), D3
C39A   266E 0010                 Move.L    $10(A6), A3
C39E   6100 F7EA                 Bsr       P_mGetSetWPort
C3A2   2F38 09EE                 Move.L    (GrayRgn), -(A7)
C3A6   A879                      _SetClip
C3A8   486E FFDC                 Pea.L     $-24(A6)
C3AC   A976                      _GetKeys
C3AE   1C2E FFE2                 Move.B    $-1E(A6), D6
C3B2   6A04                      BPL       L1765
C3B4   6100 FD56                 Bsr       P312
C3B8   6100 F708      L1765:     Bsr       P301
C3BC   2857                      Move.L    (A7), A4
C3BE   2F2B 0072                 Move.L    $72(A3), -(A7)
C3C2   2F0C                      Move.L    A4, -(A7)
C3C4   A8DC                      _CopyRgn
C3C6   2F0C                      Move.L    A4, -(A7)
C3C8   2F03                      Move.L    D3, -(A7)
C3CA   486E FFF0                 Pea.L     $-10(A6)
C3CE   2F17                      Move.L    (A7), -(A7)
C3D0   4267                      Clr       -(A7)
C3D2   42A7                      Clr.L     -(A7)
C3D4   A905                      _DragGrayRgn
C3D6   2A1F                      Move.L    (A7)+, D5
C3D8   6738                      BEQ       L1768
C3DA   0C45 8000                 Cmp       $-8000, D5
C3DE   6720                      BEQ       L1766
C3E0   2F0B                      Move.L    A3, -(A7)
C3E2   202B 0010                 Move.L    $10(A3), D0
C3E6   906B 000A                 Sub       $A(A3), D0
C3EA   D045                      Add       D5, D0
C3EC   3F00                      Move      D0, -(A7)
C3EE   4840                      Swap      D0
C3F0   4845                      Swap      D5
C3F2   906B 0008                 Sub       $8(A3), D0
C3F6   D045                      Add       D5, D0
C3F8   3F00                      Move      D0, -(A7)
C3FA   4A06                      Tst.B     D6
C3FC   5AE7                      SPL.B     -(A7)
C3FE   A91B                      _MoveWindow
C400   2F0C           L1766:     Move.L    A4, -(A7)
C402   A8D9                      _DisposeRgn
C404   6100 F78E                 Bsr       P_mRestorePort
C408   4CDF 1878      L1767:     MoveM.L   (A7)+, D3-D6/A3-A4
C40C   4E5E                      Unlk      A6
C40E   6000 0256                 Bra       L1790
C412   4A06           L1768:     Tst.B     D6
C414   6BEA                      BMI       L1766
C416   2F0B                      Move.L    A3, -(A7)
C418   A91F                      _SelectWindow
C41A   60E4                      Bra       L1766

                      DT_mWMgrGray:
C41C   AA55 AA55                 DC.B      ' U U'

                      DT_mWMgrGray.4:
C420   AA55 AA55                 DC.B      ' U U'

                      P_tDragGrayRgn:
C424   21FA FFF6 0A34            Move.L    DT_mWMgrGray, (DragPattern)
C42A   21FA FFF4 0A38            Move.L    DT_mWMgrGray.4, (DragPattern.1)

                      P_tDragTheRgn:
C430   4E56 FFEC                 Link      A6, $-14
C434   48E7 1C10                 MoveM.L   D3-D5/A3, -(A7)
C438   41EE 0016                 Lea.L     $16(A6), A0
C43C   2618                      Move.L    (A0)+, D3
C43E   2658                      Move.L    (A0)+, A3
C440   4290                      Clr.L     (A0)
C442   486E FFEC                 Pea.L     $-14(A6)
C446   2F17                      Move.L    (A7), -(A7)
C448   A898                      _GetPenState
C44A   4878 0A34                 Pea.L     (DragPattern)
C44E   A89D                      _PenPat
C450   3F3C 000E                 Move      $E, -(A7)
C454   A89C                      _PenMode
C456   2F0B                      Move.L    A3, -(A7)
C458   6100 F668                 Bsr       P301
C45C   2817                      Move.L    (A7), D4
C45E   A8DC                      _CopyRgn
C460   2F04                      Move.L    D4, -(A7)
C462   2F38 0A02                 Move.L    (OneOne), -(A7)
C466   A8E1                      _InsetRgn
C468   2F0B                      Move.L    A3, -(A7)
C46A   2F04                      Move.L    D4, -(A7)
C46C   2F0B                      Move.L    A3, -(A7)
C46E   A8E6                      _DiffRgn
C470   2F04                      Move.L    D4, -(A7)
C472   A8D9                      _DisposeRgn
C474   2F0B                      Move.L    A3, -(A7)
C476   A8D3                      _PaintRgn
C478   7AFF                      MoveQ.L   $-1, D5
C47A   5D4F           L1769:     SubQ.L    $6, A7
C47C   2F0F                      Move.L    A7, -(A7)
C47E   A972                      _GetMouse
C480   2817                      Move.L    (A7), D4
C482   2F2E 0012                 Move.L    $12(A6), -(A7)
C486   A8AD                      _PtInRect
C488   4A1F                      Tst.B     (A7)+
C48A   6700 009A                 BEQ       L1779
C48E   2204           L1770:     Move.L    D4, D1
C490   4841                      Swap      D1
C492   B684                      Cmp.L     D4, D3
C494   6738                      BEQ       L1774
C496   2F04                      Move.L    D4, -(A7)
C498   9843                      Sub       D3, D4
C49A   4843                      Swap      D3
C49C   9243                      Sub       D3, D1
C49E   302E 000C                 Move      $C(A6), D0
C4A2   670A                      BEQ       L1772
C4A4   5340                      SubQ.L    $1, D0
C4A6   6604                      BNE       L1771
C4A8   4241                      Clr       D1
C4AA   6002                      Bra       L1772
C4AC   4244           L1771:     Clr       D4
C4AE   D36E 001E      L1772:     Add       D1, $1E(A6)
C4B2   D96E 0020                 Add       D4, $20(A6)
C4B6   2F0B                      Move.L    A3, -(A7)
C4B8   3F04                      Move      D4, -(A7)
C4BA   3F01                      Move      D1, -(A7)
C4BC   4A45                      Tst       D5
C4BE   6704                      BEQ       L1773
C4C0   2F0B                      Move.L    A3, -(A7)
C4C2   A8D3                      _PaintRgn
C4C4   A8E0           L1773:     _OffsetRgn
C4C6   2F0B                      Move.L    A3, -(A7)
C4C8   A8D3                      _PaintRgn
C4CA   7AFF                      MoveQ.L   $-1, D5
C4CC   261F                      Move.L    (A7)+, D3
C4CE   202E 0008      L1774:     Move.L    $8(A6), D0
C4D2   614A                      Bsr       P319
C4D4   6144                      Bsr       P318
C4D6   2038 016A                 Move.L    (Ticks), D0
C4DA   5480                      AddQ      $2, D0
C4DC   B0B8 016A      L1775:     Cmp.L     (Ticks), D0
C4E0   66FA                      BNE       L1775
C4E2   554F                      SubQ.L    $2, A7
C4E4   A977                      _WaitMouseUp
C4E6   4A1F                      Tst.B     (A7)+
C4E8   6690                      BNE       L1769
C4EA   4A45                      Tst       D5
C4EC   6704                      BEQ       L1776
C4EE   2F0B                      Move.L    A3, -(A7)
C4F0   A8D3                      _PaintRgn
C4F2   A899           L1776:     _SetPenState
C4F4   5D4F                      SubQ.L    $6, A7
C4F6   2F0F                      Move.L    A7, -(A7)
C4F8   A972                      _GetMouse
C4FA   2F2E 000E                 Move.L    $E(A6), -(A7)
C4FE   A8AD                      _PtInRect
C500   4A1F                      Tst.B     (A7)+
C502   6608                      BNE       L1777
C504   2D7C 8000 8000            Move.L    $-7FFF8000, $1E(A6)
       001E
C50C   4CDF 0838      L1777:     MoveM.L   (A7)+, D3-D5/A3
C510   4E5E                      Unlk      A6
C512   205F                      Move.L    (A7)+, A0
C514   DEFC 0016                 AddA      $16, A7
C518   4ED0                      Jmp       (A0)

                      P318:
C51A   2038 09F6                 Move.L    (DragHook), D0

                      P319:
C51E   6704                      BEQ       L1778
C520   2040                      Move.L    D0, A0
C522   4E90                      Jsr       (A0)
C524   4E75           L1778:     Rts
C526   554F           L1779:     SubQ.L    $2, A7
C528   2F04                      Move.L    D4, -(A7)
C52A   2F2E 000E                 Move.L    $E(A6), -(A7)
C52E   A8AD                      _PtInRect
C530   4A1F                      Tst.B     (A7)+
C532   660C                      BNE       L1781
C534   4A45                      Tst       D5
C536   6796                      BEQ       L1774
C538   7A00                      MoveQ.L   $0, D5
C53A   2F0B           L1780:     Move.L    A3, -(A7)
C53C   A8D3                      _PaintRgn
C53E   608E                      Bra       L1774
C540   4A45           L1781:     Tst       D5
C542   6604                      BNE       L1782
C544   7A01                      MoveQ.L   $1, D5
C546   60F2                      Bra       L1780
C548   594F           L1782:     SubQ.L    $4, A7
C54A   2F2E 0012                 Move.L    $12(A6), -(A7)
C54E   2F04                      Move.L    D4, -(A7)
C550   A94E                      _PinRect
C552   281F                      Move.L    (A7)+, D4
C554   6000 FF38                 Bra       L1770

                      P_tInvalRgn:
C558   7000                      MoveQ.L   $0, D0

                      P320:
C55A   48E7 1C10                 MoveM.L   D3-D5/A3, -(A7)
C55E   3A00                      Move      D0, D5
C560   2055                      Move.L    (A5), A0
C562   2650                      Move.L    (A0), A3
C564   282F 0014                 Move.L    $14(A7), D4
C568   262B 0008                 Move.L    $8(A3), D3
C56C   2F04                      Move.L    D4, -(A7)
C56E   2F03                      Move.L    D3, -(A7)
C570   6100 FD1C                 Bsr       P317
C574   A8E0                      _OffsetRgn
C576   2F2B 007A                 Move.L    $7A(A3), -(A7)
C57A   2F04                      Move.L    D4, -(A7)
C57C   2F2B 007A                 Move.L    $7A(A3), -(A7)
C580   4A45                      Tst       D5
C582   6604                      BNE       L1783
C584   A8E5                      _UnionRgn
C586   6002                      Bra       L1784
C588   A8E6           L1783:     _DiffRgn
C58A   2F04           L1784:     Move.L    D4, -(A7)
C58C   2F03                      Move.L    D3, -(A7)
C58E   A8E0                      _OffsetRgn
C590   4CDF 0838      L1785:     MoveM.L   (A7)+, D3-D5/A3
C594   2E9F                      Move.L    (A7)+, (A7)
C596   4E75                      Rts

                      P_tInvalRect:
C598   7000                      MoveQ.L   $0, D0
C59A   48E7 3C10      L1786:     MoveM.L   D2-D5/A3, -(A7)
C59E   3A00                      Move      D0, D5
C5A0   A8D8                      _NewRgn
C5A2   2817                      Move.L    (A7), D4
C5A4   2F2F 0018                 Move.L    $18(A7), -(A7)
C5A8   A8DF                      _RectRgn
C5AA   2F04                      Move.L    D4, -(A7)
C5AC   3005                      Move      D5, D0
C5AE   61AA                      Bsr       P320
C5B0   2F04                      Move.L    D4, -(A7)
C5B2   A8D9                      _DisposeRgn
C5B4   60DA                      Bra       L1785

                      P_tValidRgn:
C5B6   70FF                      MoveQ.L   $-1, D0
C5B8   60A0                      Bra       P320

                      P_tValidRect:
C5BA   70FF                      MoveQ.L   $-1, D0
C5BC   60DC                      Bra       L1786

                      P_tGrowWindow:
C5BE   4E56 FFE4                 Link      A6, $-1C
C5C2   48E7 1F18                 MoveM.L   D3-D7/A3-A4, -(A7)
C5C6   6100 F5C2                 Bsr       P_mGetSetWPort
C5CA   262E 000C                 Move.L    $C(A6), D3
C5CE   266E 0010                 Move.L    $10(A6), A3
C5D2   6100 FB38                 Bsr       P312
C5D6   486E FFE4                 Pea.L     $-1C(A6)
C5DA   2F17                      Move.L    (A7), -(A7)
C5DC   A898                      _GetPenState
C5DE   A89E                      _PenNormal
C5E0   3F3C 000E                 Move      $E, -(A7)
C5E4   A89C                      _PenMode
C5E6   487A FE34                 Pea.L     DT_mWMgrGray
C5EA   A89D                      _PenPat
C5EC   49EE FFF8                 Lea.L     $-8(A6), A4
C5F0   28AB 0010                 Move.L    $10(A3), (A4)
C5F4   296B 0014 0004            Move.L    $14(A3), $4(A4)
C5FA   2F0C                      Move.L    A4, -(A7)
C5FC   2F2B 0008                 Move.L    $8(A3), -(A7)
C600   6100 FC8C                 Bsr       P317
C604   A8A8                      _OffsetRect
C606   6100 0066                 Bsr       P321
C60A   6100 00A8                 Bsr       P323
C60E   2C00                      Move.L    D0, D6
C610   594F                      SubQ.L    $4, A7
C612   2F03                      Move.L    D3, -(A7)
C614   2F2C 0004                 Move.L    $4(A4), -(A7)
C618   6100 F966                 Bsr       P_tDeltaPoint
C61C   2A1F                      Move.L    (A7)+, D5
C61E   2F03           L1787:     Move.L    D3, -(A7)
C620   6100 005A                 Bsr       P322
C624   2017                      Move.L    (A7), D0
C626   2F03                      Move.L    D3, -(A7)
C628   2F00                      Move.L    D0, -(A7)
C62A   6100 F954                 Bsr       P_tDeltaPoint
C62E   2E1F                      Move.L    (A7)+, D7
C630   670E                      BEQ       L1788
C632   613A                      Bsr       P321
C634   DF6C 0006                 Add       D7, $6(A4)
C638   4847                      Swap      D7
C63A   DF6C 0004                 Add       D7, $4(A4)
C63E   612E                      Bsr       P321
C640   6100 FED8      L1788:     Bsr       P318
C644   4267                      Clr       -(A7)
C646   A977                      _WaitMouseUp
C648   4A1F                      Tst.B     (A7)+
C64A   66D2                      BNE       L1787
C64C   6120                      Bsr       P321
C64E   6164                      Bsr       P323
C650   BC80                      Cmp.L     D0, D6
C652   6602                      BNE       L1789
C654   7000                      MoveQ.L   $0, D0
C656   2D40 0014      L1789:     Move.L    D0, $14(A6)
C65A   A899                      _SetPenState
C65C   6100 F536                 Bsr       P_mRestorePort
C660   4CDF 18F8                 MoveM.L   (A7)+, D3-D7/A3-A4
C664   4E5E                      Unlk      A6
C666   205F           L1790:     Move.L    (A7)+, A0
C668   DEFC 000C                 AddA      $C, A7
C66C   4ED0                      Jmp       (A0)

                      P321:
C66E   2F03                      Move.L    D3, -(A7)
C670   7005                      MoveQ.L   $5, D0
C672   260C                      Move.L    A4, D3
C674   6100 FA00                 Bsr       P308
C678   261F                      Move.L    (A7)+, D3
C67A   4E75                      Rts

                      P322:
C67C   2F2C 0004                 Move.L    $4(A4), -(A7)
C680   514F                      SubQ.L    $8, A7
C682   2F0F                      Move.L    A7, -(A7)
C684   A972                      _GetMouse
C686   2F05                      Move.L    D5, -(A7)
C688   6100 F8F6                 Bsr       P_tDeltaPoint
C68C   295F 0004                 Move.L    (A7)+, $4(A4)
C690   6122                      Bsr       P323
C692   2957 0004                 Move.L    (A7), $4(A4)
C696   2F2E 0008                 Move.L    $8(A6), -(A7)
C69A   2F00                      Move.L    D0, -(A7)
C69C   A94E                      _PinRect
C69E   4845                      Swap      D5
C6A0   3614                      Move      (A4), D3
C6A2   D65F                      Add       (A7)+, D3
C6A4   D645                      Add       D5, D3
C6A6   4843                      Swap      D3
C6A8   4845                      Swap      D5
C6AA   362C 0002                 Move      $2(A4), D3
C6AE   D65F                      Add       (A7)+, D3
C6B0   D645                      Add       D5, D3
C6B2   4E75                      Rts

                      P323:
C6B4   594F                      SubQ.L    $4, A7
C6B6   2F2C 0004                 Move.L    $4(A4), -(A7)
C6BA   2F14                      Move.L    (A4), -(A7)
C6BC   6100 F8C2                 Bsr       P_tDeltaPoint
C6C0   201F                      Move.L    (A7)+, D0
C6C2   4E75                      Rts

                      P_tFindWindow:
C6C4   48E7 1010                 MoveM.L   D3/A3, -(A7)
C6C8   41EF 000C                 Lea.L     $C(A7), A0
C6CC   2258                      Move.L    (A0)+, A1
C6CE   4291                      Clr.L     (A1)
C6D0   2618                      Move.L    (A0)+, D3
C6D2   4250                      Clr       (A0)
C6D4   0C83 0014 0000            Cmp.L     $140000, D3
C6DA   6C04                      BGE       L1791
C6DC   7001                      MoveQ.L   $1, D0
C6DE   603C                      Bra       L1795
C6E0   2678 09D6      L1791:     Move.L    (WindowList), A3
C6E4   200B           L1792:     Move.L    A3, D0
C6E6   6700 0054                 BEQ       L1800
C6EA   4A2B 006E                 Tst.B     $6E(A3)
C6EE   6718                      BEQ       L1793
C6F0   4267                      Clr       -(A7)
C6F2   2F03                      Move.L    D3, -(A7)
C6F4   2F2B 0072                 Move.L    $72(A3), -(A7)
C6F8   A8E8                      _PtInRgn
C6FA   4A1F                      Tst.B     (A7)+
C6FC   670A                      BEQ       L1793
C6FE   7001                      MoveQ.L   $1, D0
C700   6100 F974                 Bsr       P308
C704   4A40                      Tst       D0
C706   6606                      BNE       L1794
C708   266B 0090      L1793:     Move.L    $90(A3), A3
C70C   60D6                      Bra       L1792
C70E   206F 000C      L1794:     Move.L    $C(A7), A0
C712   208B                      Move.L    A3, (A0)
C714   4A6B 006C                 Tst       $6C(A3)
C718   6A04                      BPL       L1796
C71A   7002                      MoveQ.L   $2, D0
C71C   6012           L1795:     Bra       L1799
C71E   0C40 0002      L1796:     Cmp       $2, D0
C722   6D0A                      BLT       L1798
C724   6E04                      BGT       L1797
C726   7004                      MoveQ.L   $4, D0
C728   6006                      Bra       L1799
C72A   5440           L1797:     AddQ      $2, D0
C72C   6002                      Bra       L1799
C72E   7003           L1798:     MoveQ.L   $3, D0
C730   3F40 0014      L1799:     Move      D0, $14(A7)
C734   4CDF 0808                 MoveM.L   (A7)+, D3/A3
C738   6000 F19E                 Bra       L1693
C73C   2038 0A6C      L1800:     Move.L    (DeskHook), D0
C740   67EE                      BEQ       L1799
C742   7002                      MoveQ.L   $2, D0
C744   60EA                      Bra       L1799

                      P_tDrawGrowIcon:
C746   48E7 0810                 MoveM.L   D4/A3, -(A7)
C74A   266F 000C                 Move.L    $C(A7), A3
C74E   6100 F43A                 Bsr       P_mGetSetWPort
C752   7006                      MoveQ.L   $6, D0
C754   6100 F920                 Bsr       P308
C758   6100 F43A                 Bsr       P_mRestorePort
C75C   4CDF 0810                 MoveM.L   (A7)+, D4/A3
C760   2E9F                      Move.L    (A7)+, (A7)
C762   4E75                      Rts

                      P_tInitMenus:
C764   6122                      Bsr       P324
C766   21C8 0A1C                 Move.L    A0, (MenuList)
C76A   700C                      MoveQ.L   $C, D0
C76C   C038 020B                 And.B     (SPMisc2), D0
C770   E448                      LsR       $2, D0
C772   31C0 0A24                 Move      D0, (MenuFlash)
C776   4278 0A20                 Clr       (MBarEnable)
C77A   42B8 0A2C                 Clr.L     (MBarHook)
C77E   42B8 0A30                 Clr.L     (MenuHook)
C782   A934                      _ClearMenuBar
C784   A937                      _DrawMenuBar
C786   4E75                      Rts

                      P324:
C788   7066                      MoveQ.L   $66, D0
C78A   A122                      _NewHandle

                      P325:
C78C   2250                      Move.L    (A0), A1
C78E   4259                      Clr       (A1)+
C790   32FC 000A                 Move      $A, (A1)+
C794   4259                      Clr       (A1)+
C796   7017                      MoveQ.L   $17, D0
C798   4299           L1801:     Clr.L     (A1)+
C79A   51C8 FFFC                 DBF       D0, L1801
C79E   4E75                      Rts

                      P_tClearMenuBar:
C7A0   2078 0A1C                 Move.L    (MenuList), A0
C7A4   61E6                      Bsr       P325
C7A6   4278 0A26                 Clr       (TheMenu)
C7AA   4E75                      Rts

                      P_tInsertMenu:
C7AC   48E7 1838                 MoveM.L   D3-D4/A2-A4, -(A7)
C7B0   2678 0A1C                 Move.L    (MenuList), A3
C7B4   2653                      Move.L    (A3), A3
C7B6   0C53 0060                 Cmp       $60, (A3)
C7BA   6C62                      BGE       L1805
C7BC   286F 001A                 Move.L    $1A(A7), A4
C7C0   2454                      Move.L    (A4), A2
C7C2   3212                      Move      (A2), D1
C7C4   6162                      Bsr       P326
C7C6   6656                      BNE       L1805
C7C8   4EBA F3C0                 Jsr       P_mGetSetWPort
C7CC   42A7                      Clr.L     -(A7)
C7CE   A887                      _TextFont
C7D0   A888                      _TextFace
C7D2   4267                      Clr       -(A7)
C7D4   486A 000E                 Pea.L     $E(A2)
C7D8   A88C                      _StringWidth
C7DA   760D                      MoveQ.L   $D, D3
C7DC   D65F                      Add       (A7)+, D3
C7DE   322F 0018                 Move      $18(A7), D1
C7E2   6144                      Bsr       P326
C7E4   660A                      BNE       L1802
C7E6   3013                      Move      (A3), D0
C7E8   5C40                      AddQ      $6, D0
C7EA   322B 0002                 Move      $2(A3), D1
C7EE   601C                      Bra       L1804
C7F0   3233 0004      L1802:     Move      $4(A3,D0.W), D1
C7F4   3413                      Move      (A3), D2
C7F6   27B3 2000 2006 L1803:     Move.L    $0(A3,D2.W), $6(A3,D2.W)
C7FC   37B3 2004 200A            Move      $4(A3,D2.W), $A(A3,D2.W)
C802   D773 200A                 Add       D3, $A(A3,D2.W)
C806   5D42                      SubQ.L    $6, D2
C808   B440                      Cmp       D0, D2
C80A   6CEA                      BGE       L1803
C80C   D76B 0002      L1804:     Add       D3, $2(A3)
C810   278C 0000                 Move.L    A4, $0(A3,D0.W)
C814   3781 0004                 Move      D1, $4(A3,D0.W)
C818   5C53                      AddQ      $6, (A3)
C81A   4EBA F378                 Jsr       P_mRestorePort
C81E   4CDF 1C18      L1805:     MoveM.L   (A7)+, D3-D4/A2-A4
C822   205F           L1806:     Move.L    (A7)+, A0
C824   5C4F                      AddQ      $6, A7
C826   4ED0                      Jmp       (A0)

                      P326:
C828   4A41                      Tst       D1
C82A   671C                      BEQ       L1809
C82C   2278 0A1C                 Move.L    (MenuList), A1
C830   2251                      Move.L    (A1), A1
C832   3411                      Move      (A1), D2
C834   6712                      BEQ       L1809
C836   2031 2000      L1807:     Move.L    $0(A1,D2.W), D0
C83A   6708                      BEQ       L1808
C83C   2040                      Move.L    D0, A0
C83E   2050                      Move.L    (A0), A0
C840   B250                      Cmp       (A0), D1
C842   6706                      BEQ       L1810
C844   5D42           L1808:     SubQ.L    $6, D2
C846   66EE                      BNE       L1807
C848   7400           L1809:     MoveQ.L   $0, D2
C84A   3002           L1810:     Move      D2, D0
C84C   4E75                      Rts

                      P_tDeleteMenu:
C84E   322F 0004                 Move      $4(A7), D1
C852   61D4                      Bsr       P326
C854   6736                      BEQ       L1814
C856   2278 0A1C                 Move.L    (MenuList), A1
C85A   2251                      Move.L    (A1), A1
C85C   B051                      Cmp       (A1), D0
C85E   6608                      BNE       L1811
C860   3371 0004 0002            Move      $4(A1,D0.W), $2(A1)
C866   6022                      Bra       L1813
C868   3431 000A      L1811:     Move      $A(A1,D0.W), D2
C86C   9471 0004                 Sub       $4(A1,D0.W), D2
C870   9569 0002                 Sub       D2, $2(A1)
C874   23B1 0006 0000 L1812:     Move.L    $6(A1,D0.W), $0(A1,D0.W)
C87A   33B1 000A 0004            Move      $A(A1,D0.W), $4(A1,D0.W)
C880   9571 0004                 Sub       D2, $4(A1,D0.W)
C884   5C40                      AddQ      $6, D0
C886   B051                      Cmp       (A1), D0
C888   6FEA                      BLE       L1812
C88A   5D51           L1813:     SubQ.L    $6, (A1)
C88C   205F           L1814:     Move.L    (A7)+, A0
C88E   544F                      AddQ      $2, A7
C890   4ED0                      Jmp       (A0)

                      P327:
C892   41F8 09FA                 Lea.L     (scratch8), A0
C896   30FC 0001                 Move      $1, (A0)+
C89A   30B1 0004                 Move      $4(A1,D0.W), (A0)
C89E   5358                      SubQ.L    $1, (A0)+
C8A0   30FC 0013                 Move      $13, (A0)+
C8A4   B051                      Cmp       (A1), D0
C8A6   6708                      BEQ       L1815
C8A8   5C40                      AddQ      $6, D0
C8AA   30B1 0004                 Move      $4(A1,D0.W), (A0)
C8AE   6004                      Bra       L1816
C8B0   30A9 0002      L1815:     Move      $2(A1), (A0)
C8B4   5850           L1816:     AddQ      $4, (A0)
C8B6   4E75                      Rts

                      P328:
C8B8   2678 09DE                 Move.L    (WMgrPort), A3
C8BC   2F2B 001C                 Move.L    $1C(A3), -(A7)
C8C0   42A7                      Clr.L     -(A7)
C8C2   3F2B 0016                 Move      $16(A3), -(A7)
C8C6   3F3C 0014                 Move      $14, -(A7)
C8CA   A8DE                      _SetRectRgn
C8CC   486B 0010                 Pea.L     $10(A3)
C8D0   2F3C 0010 0010            Move.L    $100010, -(A7)
C8D6   A8B2                      _EraseRoundRect
C8D8   3F2B 0016                 Move      $16(A3), -(A7)
C8DC   7013                      MoveQ.L   $13, D0
C8DE   3F00                      Move      D0, -(A7)
C8E0   4840                      Swap      D0
C8E2   2F00                      Move.L    D0, -(A7)
C8E4   A893                      _MoveTo
C8E6   A891                      _LineTo
C8E8   4E75                      Rts

                      P_tDrawMenuBar:
C8EA   48E7 1C18                 MoveM.L   D3-D5/A3-A4, -(A7)
C8EE   4EBA F29A                 Jsr       P_mGetSetWPort
C8F2   61C4                      Bsr       P328
C8F4   4EBA 0384                 Jsr       P_mFullClip
C8F8   7606                      MoveQ.L   $6, D3
C8FA   2678 0A1C                 Move.L    (MenuList), A3
C8FE   2653                      Move.L    (A3), A3
C900   4A53                      Tst       (A3)
C902   6742                      BEQ       L1820
C904   3F33 3004      L1817:     Move      $4(A3,D3.W), -(A7)
C908   5057                      AddQ      $8, (A7)
C90A   3F3C 000E                 Move      $E, -(A7)
C90E   A893                      _MoveTo
C910   3A03                      Move      D3, D5
C912   6100 009E                 Bsr       P331
C916   2848                      Move.L    A0, A4
C918   486C 000E                 Pea.L     $E(A4)
C91C   A884                      _DrawString
C91E   082C 0000 000D            BTst.B    $0, $D(A4)
C924   6710                      BEQ       L1818
C926   3038 0A26                 Move      (TheMenu), D0
C92A   B054                      Cmp       (A4), D0
C92C   6612                      BNE       L1819
C92E   3003                      Move      D3, D0
C930   6100 0094                 Bsr       P333
C934   600A                      Bra       L1819
C936   3003           L1818:     Move      D3, D0
C938   224B                      Move.L    A3, A1
C93A   6100 FF56                 Bsr       P327
C93E   6110                      Bsr       P329
C940   5C43           L1819:     AddQ      $6, D3
C942   B653                      Cmp       (A3), D3
C944   6FBE                      BLE       L1817
C946   4EBA F24C      L1820:     Jsr       P_mRestorePort
C94A   4CDF 1838                 MoveM.L   (A7)+, D3-D5/A3-A4
C94E   4E75                      Rts

                      P329:
C950   3F3C 000B                 Move      $B, -(A7)
C954   A89C                      _PenMode
C956   487A FAC4                 Pea.L     DT_mWMgrGray
C95A   A89D                      _PenPat
C95C   4878 09FA                 Pea.L     (scratch8)
C960   A8A2                      _PaintRect
C962   A89E                      _PenNormal
C964   4E75                      Rts

                      P_tHiliteMenu:
C966   2F04                      Move.L    D4, -(A7)
C968   4EBA F220                 Jsr       P_mGetSetWPort
C96C   6100 030C                 Bsr       P_mFullClip
C970   3238 0A26                 Move      (TheMenu), D1
C974   B26F 0008                 Cmp       $8(A7), D1
C978   670C                      BEQ       L1821
C97A   6144                      Bsr       P332
C97C   322F 0008                 Move      $8(A7), D1
C980   31C1 0A26                 Move      D1, (TheMenu)
C984   613A                      Bsr       P332
C986   4EBA F20C      L1821:     Jsr       P_mRestorePort
C98A   281F                      Move.L    (A7)+, D4
C98C   6000 FEFE                 Bra       L1814

                      P_tEnableItem:
C990   610A                      Bsr       P330
C992   01C1                      BSet.B    D0, D1
C994   2141 000A      L1822:     Move.L    D1, $A(A0)
C998   6000 FE88                 Bra       L1806

                      P330:
C99C   206F 000A                 Move.L    $A(A7), A0
C9A0   2050                      Move.L    (A0), A0
C9A2   302F 0008                 Move      $8(A7), D0
C9A6   2228 000A                 Move.L    $A(A0), D1
C9AA   4E75                      Rts

                      P_tDisableItem:
C9AC   61EE                      Bsr       P330
C9AE   0181                      BClr.B    D0, D1
C9B0   60E2                      Bra       L1822

                      P331:
C9B2   2078 0A1C                 Move.L    (MenuList), A0
C9B6   2050                      Move.L    (A0), A0
C9B8   2270 5000                 Move.L    $0(A0,D5.W), A1
C9BC   2051                      Move.L    (A1), A0
C9BE   4E75           L1823:     Rts

                      P332:
C9C0   6100 FE66                 Bsr       P326
C9C4   67F8                      BEQ       L1823

                      P333:
C9C6   2278 0A1C                 Move.L    (MenuList), A1
C9CA   2251                      Move.L    (A1), A1
C9CC   B051                      Cmp       (A1), D0
C9CE   6E10                      BGT       L1824
C9D0   0240 FFFE                 And       $-2, D0
C9D4   670A                      BEQ       L1824
C9D6   6100 FEBA                 Bsr       P327
C9DA   4878 09FA                 Pea.L     (scratch8)
C9DE   A8A4                      _InvertRect
C9E0   4E75           L1824:     Rts

                      P_tMenuSelect:
C9E2   4E56 FFE0                 Link      A6, $-20
C9E6   48E7 1F10                 MoveM.L   D3-D7/A3, -(A7)
C9EA   42A7                      Clr.L     -(A7)
C9EC   A938                      _HiliteMenu
C9EE   42AE 000C                 Clr.L     $C(A6)
C9F2   A977                      _WaitMouseUp
C9F4   4A1F                      Tst.B     (A7)+
C9F6   6700 012E                 BEQ       L1839
C9FA   486E FFE0                 Pea.L     $-20(A6)
C9FE   A874                      _GetPort
CA00   2F38 09DE                 Move.L    (WMgrPort), -(A7)
CA04   A873                      _SetPort
CA06   6100 0272                 Bsr       P_mFullClip
CA0A   4244                      Clr       D4
CA0C   262E 0008                 Move.L    $8(A6), D3
CA10   600A                      Bra       L1826
CA12   0C83 0014 0000 L1825:     Cmp.L     $140000, D3
CA18   6C00 0096                 BGE       L1832
CA1C   4245           L1826:     Clr       D5
CA1E   2078 0A1C                 Move.L    (MenuList), A0
CA22   2050                      Move.L    (A0), A0
CA24   B668 0002                 Cmp       $2(A0), D3
CA28   6C0C                      BGE       L1828
CA2A   3A10                      Move      (A0), D5
CA2C   B670 5004      L1827:     Cmp       $4(A0,D5.W), D3
CA30   6E04                      BGT       L1828
CA32   5D45                      SubQ.L    $6, D5
CA34   66F6                      BNE       L1827
CA36   3C30 5004      L1828:     Move      $4(A0,D5.W), D6
CA3A   B845                      Cmp       D5, D4
CA3C   6772                      BEQ       L1832
CA3E   4A44                      Tst       D4
CA40   670A                      BEQ       L1829
CA42   6100 00F8                 Bsr       P334
CA46   3004                      Move      D4, D0
CA48   6100 FF7C                 Bsr       P333
CA4C   3805           L1829:     Move      D5, D4
CA4E   426E 000C                 Clr       $C(A6)
CA52   4A45                      Tst       D5
CA54   675C                      BEQ       L1833
CA56   6100 FF5A                 Bsr       P331
CA5A   3D50 000C                 Move      (A0), $C(A6)
CA5E   426E 000E                 Clr       $E(A6)
CA62   2278 09DE                 Move.L    (WMgrPort), A1
CA66   3006                      Move      D6, D0
CA68   D068 0002                 Add       $2(A0), D0
CA6C   5040                      AddQ      $8, D0
CA6E   B069 0016                 Cmp       $16(A1), D0
CA72   6F0A                      BLE       L1830
CA74   3C29 0016                 Move      $16(A1), D6
CA78   5146                      SubQ.L    $8, D6
CA7A   9C68 0002                 Sub       $2(A0), D6
CA7E   43EE FFE4      L1830:     Lea.L     $-1C(A6), A1
CA82   7014                      MoveQ.L   $14, D0
CA84   32C0                      Move      D0, (A1)+
CA86   32C6                      Move      D6, (A1)+
CA88   D068 0004                 Add       $4(A0), D0
CA8C   32C0                      Move      D0, (A1)+
CA8E   DC68 0002                 Add       $2(A0), D6
CA92   32C6                      Move      D6, (A1)+
CA94   3005                      Move      D5, D0
CA96   6100 FF2E                 Bsr       P333
CA9A   2038 0A2C                 Move.L    (MBarHook), D0
CA9E   670C                      BEQ       L1831
CAA0   2040                      Move.L    D0, A0
CAA2   486E FFE4                 Pea.L     $-1C(A6)
CAA6   4E90                      Jsr       (A0)
CAA8   4A40                      Tst       D0
CAAA   6674                      BNE       L1838
CAAC   6100 00C2      L1831:     Bsr       P336
CAB0   4A45           L1832:     Tst       D5
CAB2   6728           L1833:     BEQ       L1834
CAB4   486E FFE4                 Pea.L     $-1C(A6)
CAB8   A87B                      _ClipRect
CABA   6100 FEF6                 Bsr       P331
CABE   3F3C 0001                 Move      $1, -(A7)
CAC2   2F09                      Move.L    A1, -(A7)
CAC4   486E FFE4                 Pea.L     $-1C(A6)
CAC8   2F03                      Move.L    D3, -(A7)
CACA   486E 000E                 Pea.L     $E(A6)
CACE   6100 0164                 Bsr       P338
CAD2   4E90                      Jsr       (A0)
CAD4   6100 016E                 Bsr       P339
CAD8   6100 01A0                 Bsr       P_mFullClip
CADC   594F           L1834:     SubQ.L    $4, A7
CADE   2F0F                      Move.L    A7, -(A7)
CAE0   A972                      _GetMouse
CAE2   261F                      Move.L    (A7)+, D3
CAE4   2038 0A30                 Move.L    (MenuHook), D0
CAE8   6704                      BEQ       L1835
CAEA   2040                      Move.L    D0, A0
CAEC   4E90                      Jsr       (A0)
CAEE   4267           L1835:     Clr       -(A7)
CAF0   A977                      _WaitMouseUp
CAF2   4A1F                      Tst.B     (A7)+
CAF4   6600 FF1C                 BNE       L1825
CAF8   4A45                      Tst       D5
CAFA   6706                      BEQ       L1836
CAFC   6100 0154                 Bsr       P341
CB00   613A                      Bsr       P334
CB02   4A6E 000E      L1836:     Tst       $E(A6)
CB06   660A                      BNE       L1837
CB08   426E 000C                 Clr       $C(A6)
CB0C   3005                      Move      D5, D0
CB0E   6100 FEB6                 Bsr       P333
CB12   31EE 000C 0A26 L1837:     Move      $C(A6), (TheMenu)
CB18   6B16                      BMI       L1840
CB1A   4A78 0A20                 Tst       (MBarEnable)
CB1E   6B10                      BMI       L1840
CB20   2F2E FFE0      L1838:     Move.L    $-20(A6), -(A7)
CB24   A873                      _SetPort
CB26   4CDF 08F8      L1839:     MoveM.L   (A7)+, D3-D7/A3
CB2A   4E5E                      Unlk      A6
CB2C   2E9F                      Move.L    (A7)+, (A7)
CB2E   4E75                      Rts
CB30   2F2E 000C      L1840:     Move.L    $C(A6), -(A7)
CB34   A9B5                      _SystemMenu
CB36   42AE 000C                 Clr.L     $C(A6)
CB3A   60E4                      Bra       L1838

                      P334:
CB3C   2078 0A28                 Move.L    (SavedHandle), A0
CB40   2D50 FFEC                 Move.L    (A0), $-14(A6)
CB44   486E FFEC                 Pea.L     $-14(A6)
CB48   2078 09DE                 Move.L    (WMgrPort), A0
CB4C   4868 0002                 Pea.L     $2(A0)
CB50   6108                      Bsr       P335
CB52   2078 0A28                 Move.L    (SavedHandle), A0
CB56   A023                      _DisposeHandle
CB58   4E75                      Rts

                      P335:
CB5A   2E1F                      Move.L    (A7)+, D7
CB5C   486E FFF2                 Pea.L     $-E(A6)
CB60   2F17                      Move.L    (A7), -(A7)
CB62   4267                      Clr       -(A7)
CB64   42A7                      Clr.L     -(A7)
CB66   A8EC                      _CopyBits
CB68   2F07                      Move.L    D7, -(A7)
CB6A   4E75                      Rts
CB6C   7019           L1841:     MoveQ.L   $19, D0
CB6E   A9C9                      _SysError

                      P336:
CB70   48E7 0838                 MoveM.L   D4/A2-A4, -(A7)
CB74   283C 0002 0002            Move.L    $20002, D4
CB7A   47F8 09FA                 Lea.L     (scratch8), A3
CB7E   49EE FFE4                 Lea.L     $-1C(A6), A4
CB82   244C                      Move.L    A4, A2
CB84   2F0B                      Move.L    A3, -(A7)
CB86   26DA                      Move.L    (A2)+, (A3)+
CB88   26D2                      Move.L    (A2), (A3)+
CB8A   2F3C FFFC FFFC            Move.L    $-30004, -(A7)
CB90   A8A9                      _InsetRect
CB92   700F                      MoveQ.L   $F, D0
CB94   D063                      Add       -(A3), D0
CB96   3223                      Move      -(A3), D1
CB98   9063                      Sub       -(A3), D0
CB9A   9263                      Sub       -(A3), D1
CB9C   E848                      LsR       $4, D0
CB9E   D040                      Add       D0, D0
CBA0   3D40 FFF0                 Move      D0, $-10(A6)
CBA4   C0C1                      MulU      D1, D0
CBA6   A122                      _NewHandle
CBA8   66C2                      BNE       L1841
CBAA   21C8 0A28                 Move.L    A0, (SavedHandle)
CBAE   2D50 FFEC                 Move.L    (A0), $-14(A6)
CBB2   2D5B FFF2                 Move.L    (A3)+, $-E(A6)
CBB6   2D53 FFF6                 Move.L    (A3), $-A(A6)
CBBA   2078 09DE                 Move.L    (WMgrPort), A0
CBBE   4868 0002                 Pea.L     $2(A0)
CBC2   486E FFEC                 Pea.L     $-14(A6)
CBC6   6192                      Bsr       P335
CBC8   2F0C                      Move.L    A4, -(A7)
CBCA   A8A3                      _EraseRect
CBCC   A89E                      _PenNormal
CBCE   2F12                      Move.L    (A2), -(A7)
CBD0   2F17                      Move.L    (A7), -(A7)
CBD2   2F14                      Move.L    (A4), -(A7)
CBD4   536F 0002                 SubQ.L    $1, $2(A7)
CBD8   2F17                      Move.L    (A7), -(A7)
CBDA   3F52 0004                 Move      (A2), $4(A7)
CBDE   3F54 000C                 Move      (A4), $C(A7)
CBE2   A893                      _MoveTo
CBE4   A891                      _LineTo
CBE6   A891                      _LineTo
CBE8   A891                      _LineTo
CBEA   6120                      Bsr       P337
CBEC   2F0C                      Move.L    A4, -(A7)
CBEE   A87B                      _ClipRect
CBF0   4267                      Clr       -(A7)
CBF2   6100 FDBE                 Bsr       P331
CBF6   2F09                      Move.L    A1, -(A7)
CBF8   2F0C                      Move.L    A4, -(A7)
CBFA   514F                      SubQ.L    $8, A7
CBFC   6136                      Bsr       P338
CBFE   4E90                      Jsr       (A0)
CC00   6142                      Bsr       P339
CC02   6100 0076                 Bsr       P_mFullClip
CC06   4CDF 1C10                 MoveM.L   (A7)+, D4/A2-A4
CC0A   4E75                      Rts

                      P337:
CC0C   2F04                      Move.L    D4, -(A7)
CC0E   A89B                      _PenSize
CC10   302C 0006                 Move      $6(A4), D0
CC14   3F00                      Move      D0, -(A7)
CC16   3F14                      Move      (A4), -(A7)
CC18   D957                      Add       D4, (A7)
CC1A   3F00                      Move      D0, -(A7)
CC1C   302C 0004                 Move      $4(A4), D0
CC20   3F00                      Move      D0, -(A7)
CC22   3F2C 0002                 Move      $2(A4), -(A7)
CC26   D957                      Add       D4, (A7)
CC28   3F00                      Move      D0, -(A7)
CC2A   A893                      _MoveTo
CC2C   A891                      _LineTo
CC2E   A891                      _LineTo
CC30   A89E                      _PenNormal
CC32   4E75                      Rts

                      P338:
CC34   2068 0006                 Move.L    $6(A0), A0
CC38   2F08                      Move.L    A0, -(A7)
CC3A   A9A2                      _LoadResource
CC3C   08D0 0007                 BSet.B    $7, (A0)
CC40   2050                      Move.L    (A0), A0
CC42   4E75                      Rts

                      P339:
CC44   6100 FD6C                 Bsr       P331

                      P340:
CC48   2068 0006                 Move.L    $6(A0), A0
CC4C   0890 0007                 BClr.B    $7, (A0)
CC50   4E75                      Rts

                      P341:
CC52   3F04                      Move      D4, -(A7)
CC54   3838 0A24                 Move      (MenuFlash), D4
CC58   671C                      BEQ       L1843
CC5A   31EE 000E 09CE            Move      $E(A6), (ToolScratch)
CC60   6714                      BEQ       L1843
CC62   486E FFE4                 Pea.L     $-1C(A6)
CC66   A87B                      _ClipRect
CC68   7200           L1842:     MoveQ.L   $0, D1
CC6A   611A                      Bsr       P343
CC6C   2203                      Move.L    D3, D1
CC6E   6116                      Bsr       P343
CC70   5344                      SubQ.L    $1, D4
CC72   66F4                      BNE       L1842
CC74   6104                      Bsr       P_mFullClip
CC76   381F           L1843:     Move      (A7)+, D4
CC78   4E75                      Rts

                      P_mFullClip:
CC7A   2078 09DE                 Move.L    (WMgrPort), A0
CC7E   4868 0010                 Pea.L     $10(A0)
CC82   A87B                      _ClipRect
CC84   4E75                      Rts

                      P343:
CC86   3F3C 0001                 Move      $1, -(A7)
CC8A   6100 FD26                 Bsr       P331
CC8E   2F09                      Move.L    A1, -(A7)
CC90   486E FFE4                 Pea.L     $-1C(A6)
CC94   2F01                      Move.L    D1, -(A7)
CC96   4878 09CE                 Pea.L     (ToolScratch)
CC9A   6198                      Bsr       P338
CC9C   4E90                      Jsr       (A0)
CC9E   61A4                      Bsr       P339
CCA0   2038 016A                 Move.L    (Ticks), D0
CCA4   5680                      AddQ      $3, D0
CCA6   B0B8 016A      L1844:     Cmp.L     (Ticks), D0
CCAA   6EFA                      BGT       L1844
CCAC   4E75                      Rts

                      P_tGetMenuBar:
CCAE   6100 FAD8                 Bsr       P324
CCB2   2F48 0004                 Move.L    A0, $4(A7)
CCB6   2250                      Move.L    (A0), A1
CCB8   2078 0A1C                 Move.L    (MenuList), A0
CCBC   2050           L1845:     Move.L    (A0), A0
CCBE   7066                      MoveQ.L   $66, D0
CCC0   A02E                      _BlockMove
CCC2   4E75                      Rts

                      P_tSetMenuBar:
CCC4   206F 0004                 Move.L    $4(A7), A0
CCC8   2278 0A1C                 Move.L    (MenuList), A1
CCCC   2251                      Move.L    (A1), A1
CCCE   2E9F                      Move.L    (A7)+, (A7)
CCD0   60EA                      Bra       L1845

                      P_tDisposeMenu:
CCD2   206F 0004                 Move.L    $4(A7), A0
CCD6   A023                      _DisposeHandle
CCD8   2E9F                      Move.L    (A7)+, (A7)
CCDA   4E75                      Rts

                      P_tFlashMenuBar:
CCDC   2F04                      Move.L    D4, -(A7)
CCDE   4EBA EEAA                 Jsr       P_mGetSetWPort
CCE2   6196                      Bsr       P_mFullClip
CCE4   322F 0008                 Move      $8(A7), D1
CCE8   670E                      BEQ       L1847
CCEA   6100 FCD4                 Bsr       P332
CCEE   4EBA EEA4      L1846:     Jsr       P_mRestorePort
CCF2   281F                      Move.L    (A7)+, D4
CCF4   6000 FB96                 Bra       L1814
CCF8   2078 09DE      L1847:     Move.L    (WMgrPort), A0
CCFC   4868 0010                 Pea.L     $10(A0)
CD00   2F28 001C                 Move.L    $1C(A0), -(A7)
CD04   42A7                      Clr.L     -(A7)
CD06   3F28 0016                 Move      $16(A0), -(A7)
CD0A   3F3C 0014                 Move      $14, -(A7)
CD0E   A8DE                      _SetRectRgn
CD10   2F3C 0010 0010            Move.L    $100010, -(A7)
CD16   A8B3                      _InvertRoundRect
CD18   60D4                      Bra       L1846

                      P344:
CD1A   4A40                      Tst       D0
CD1C   6F18                      BLE       L1849
CD1E   7200                      MoveQ.L   $0, D1
CD20   43E8 000E                 Lea.L     $E(A0), A1
CD24   1219                      Move.B    (A1)+, D1
CD26   D2C1                      AddA      D1, A1
CD28   5340           L1848:     SubQ.L    $1, D0
CD2A   6712                      BEQ       L1850
CD2C   1219                      Move.B    (A1)+, D1
CD2E   6706                      BEQ       L1849
CD30   5841                      AddQ      $4, D1
CD32   D2C1                      AddA      D1, A1
CD34   60F2                      Bra       L1848
CD36   91C8           L1849:     SubA.L    A0, A0
CD38   2248                      Move.L    A0, A1
CD3A   2008                      Move.L    A0, D0
CD3C   4E75                      Rts
CD3E   4A11           L1850:     Tst.B     (A1)
CD40   67F4                      BEQ       L1849
CD42   2049                      Move.L    A1, A0
CD44   1219                      Move.B    (A1)+, D1
CD46   D2C1                      AddA      D1, A1
CD48   4E75                      Rts
CD4A   206F 0008      L1851:     Move.L    $8(A7), A0
CD4E   2050                      Move.L    (A0), A0
CD50   302F 0006                 Move      $6(A7), D0
CD54   61C4                      Bsr       P344
CD56   670C                      BEQ       L1852
CD58   13AF 0005 2000            Move.B    $5(A7), $0(A1,D2.W)
CD5E   2F2F 0008                 Move.L    $8(A7), -(A7)
CD62   A948                      _CalcMenuSize
CD64   205F           L1852:     Move.L    (A7)+, A0
CD66   504F                      AddQ      $8, A7
CD68   4ED0                      Jmp       (A0)
CD6A   206F 000A      L1853:     Move.L    $A(A7), A0
CD6E   2050                      Move.L    (A0), A0
CD70   302F 0008                 Move      $8(A7), D0
CD74   61A4                      Bsr       P344
CD76   206F 0004                 Move.L    $4(A7), A0
CD7A   4250                      Clr       (A0)
CD7C   2009                      Move.L    A1, D0
CD7E   6706                      BEQ       L1854
CD80   1171 2000 0001            Move.B    $0(A1,D2.W), $1(A0)
CD86   205F           L1854:     Move.L    (A7)+, A0
CD88   DEFC 000A                 AddA      $A, A7
CD8C   4ED0                      Jmp       (A0)

                      P_tGetItmIcon:
CD8E   7400                      MoveQ.L   $0, D2
CD90   60D8                      Bra       L1853

                      P_tSetItmIcon:
CD92   7400                      MoveQ.L   $0, D2
CD94   60B4                      Bra       L1851

                      P_tGetItmStyle:
CD96   7403                      MoveQ.L   $3, D2
CD98   60D0                      Bra       L1853

                      P_tSetItmStyle:
CD9A   7403                      MoveQ.L   $3, D2
CD9C   60AC                      Bra       L1851

                      P_tGetItmMark:
CD9E   7402                      MoveQ.L   $2, D2
CDA0   60C8                      Bra       L1853

                      P_tSetItmMark:
CDA2   7402                      MoveQ.L   $2, D2
CDA4   60A4                      Bra       L1851

                      P_tCheckItem:
CDA6   4A2F 0004                 Tst.B     $4(A7)
CDAA   6708                      BEQ       L1855
CDAC   3F7C 0012 0004            Move      $12, $4(A7)
CDB2   60EE                      Bra       P_tSetItmMark
CDB4   426F 0004      L1855:     Clr       $4(A7)
CDB8   60E8                      Bra       P_tSetItmMark

                      P_tMenuKey:
CDBA   48E7 1C10                 MoveM.L   D3-D5/A3, -(A7)
CDBE   182F 0015                 Move.B    $15(A7), D4
CDC2   0C04 0060                 Cmp.B     $60, D4
CDC6   6D04                      BLT       L1856
CDC8   0404 0020                 Sub.B     $20, D4
CDCC   2078 0A1C      L1856:     Move.L    (MenuList), A0
CDD0   2050                      Move.L    (A0), A0
CDD2   3A10                      Move      (A0), D5
CDD4   6100 FBDC      L1857:     Bsr       P331
CDD8   2648                      Move.L    A0, A3
CDDA   082B 0000 000D            BTst.B    $0, $D(A3)
CDE0   672A                      BEQ       L1861
CDE2   7601                      MoveQ.L   $1, D3
CDE4   202B 000A      L1858:     Move.L    $A(A3), D0
CDE8   0700                      BTst.B    D3, D0
CDEA   671C                      BEQ       L1860
CDEC   204B                      Move.L    A3, A0
CDEE   3003                      Move      D3, D0
CDF0   6100 FF28                 Bsr       P344
CDF4   6716                      BEQ       L1861
CDF6   1029 0001                 Move.B    $1(A1), D0
CDFA   0C00 0060                 Cmp.B     $60, D0
CDFE   6D04                      BLT       L1859
CE00   0400 0020                 Sub.B     $20, D0
CE04   B800           L1859:     Cmp.B     D0, D4
CE06   6714                      BEQ       L1863
CE08   5243           L1860:     AddQ      $1, D3
CE0A   60D8                      Bra       L1858
CE0C   5D45           L1861:     SubQ.L    $6, D5
CE0E   66C4                      BNE       L1857
CE10   42AF 0016                 Clr.L     $16(A7)
CE14   4CDF 0838      L1862:     MoveM.L   (A7)+, D3-D5/A3
CE18   6000 FA72                 Bra       L1814
CE1C   6100 FB94      L1863:     Bsr       P331
CE20   3010                      Move      (A0), D0
CE22   4840                      Swap      D0
CE24   3003                      Move      D3, D0
CE26   2F40 0016                 Move.L    D0, $16(A7)
CE2A   4840                      Swap      D0
CE2C   3F00                      Move      D0, -(A7)
CE2E   A938                      _HiliteMenu
CE30   4A78 0A20                 Tst       (MBarEnable)
CE34   6B06                      BMI       L1864
CE36   202F 0016                 Move.L    $16(A7), D0
CE3A   6AD8                      BPL       L1862
CE3C   2F00           L1864:     Move.L    D0, -(A7)
CE3E   A9B5                      _SystemMenu
CE40   42AF 0016                 Clr.L     $16(A7)
CE44   60CE                      Bra       L1862

                      P_tGetMenuItemText:
CE46   206F 000A                 Move.L    $A(A7), A0
CE4A   2050                      Move.L    (A0), A0
CE4C   302F 0008                 Move      $8(A7), D0
CE50   6100 FEC8                 Bsr       P344
CE54   226F 0004                 Move.L    $4(A7), A1
CE58   670C                      BEQ       L1866
CE5A   7000                      MoveQ.L   $0, D0
CE5C   1010                      Move.B    (A0), D0
CE5E   5240                      AddQ      $1, D0
CE60   A02E                      _BlockMove
CE62   6000 FF22      L1865:     Bra       L1854
CE66   4211           L1866:     Clr.B     (A1)
CE68   60F8                      Bra       L1865

                      P_tCalcMenuSize:
CE6A   3F3C 0002                 Move      $2, -(A7)
CE6E   206F 0006                 Move.L    $6(A7), A0
CE72   2F08                      Move.L    A0, -(A7)
CE74   9EFC 000C                 SubA      $C, A7
CE78   2050                      Move.L    (A0), A0
CE7A   6100 FDB8                 Bsr       P338
CE7E   4E90                      Jsr       (A0)
CE80   206F 0004                 Move.L    $4(A7), A0
CE84   2050                      Move.L    (A0), A0
CE86   6100 FDC0                 Bsr       P340
CE8A   2E9F                      Move.L    (A7)+, (A7)
CE8C   4E75                      Rts
                      ; Missing Block
CE8E   2053                      Move.L    (A3), A0
CE90   2028 000A                 Move.L    $A(A0), D0
CE94   0900                      BTst.B    D4, D0
CE96   6704                      BEQ       L2331
CE98   0800 0000                 BTst.B    $0, D0
CE9C   4E75           L2331:     Rts

                      P_tNewMenu:
CE9E   7200                      MoveQ.L   $0, D1
CEA0   7010                      MoveQ.L   $10, D0
CEA2   206F 0004                 Move.L    $4(A7), A0
CEA6   1210                      Move.B    (A0), D1
CEA8   D041                      Add       D1, D0
CEAA   A122                      _NewHandle
CEAC   2F48 000A                 Move.L    A0, $A(A7)
CEB0   2250                      Move.L    (A0), A1
CEB2   3F01                      Move      D1, -(A7)
CEB4   32EF 000A                 Move      $A(A7), (A1)+
CEB8   4299                      Clr.L     (A1)+
CEBA   594F                      SubQ.L    $4, A7
CEBC   2F3C 4D44 4546            Move.L    $4D444546, -(A7)
CEC2   4267                      Clr       -(A7)
CEC4   A9A0                      _GetResource
CEC6   205F                      Move.L    (A7)+, A0
CEC8   226F 000C                 Move.L    $C(A7), A1
CECC   2251                      Move.L    (A1), A1
CECE   5C49                      AddQ      $6, A1
CED0   22C8                      Move.L    A0, (A1)+
CED2   22F8 0A06                 Move.L    (MinusOne), (A1)+
CED6   321F                      Move      (A7)+, D1
CED8   206F 0004                 Move.L    $4(A7), A0
CEDC   12D8           L1867:     Move.B    (A0)+, (A1)+
CEDE   51C9 FFFC                 DBF       D1, L1867
CEE2   4219                      Clr.B     (A1)+
CEE4   6000 F93C                 Bra       L1806

                      P_tAppendMenu:
CEE8   4E56 FEE8                 Link      A6, $-118
CEEC   48E7 1818                 MoveM.L   D3-D4/A3-A4, -(A7)
CEF0   286E 0008                 Move.L    $8(A6), A4
CEF4   266E 000C                 Move.L    $C(A6), A3
CEF8   4243                      Clr       D3
CEFA   161C                      Move.B    (A4)+, D3
CEFC   611C                      Bsr       P345
CEFE   5343                      SubQ.L    $1, D3
CF00   101C           L1868:     Move.B    (A4)+, D0
CF02   612C                      Bsr       P346
CF04   51CB FFFA                 DBF       D3, L1868
CF08   6100 00A0                 Bsr       P347
CF0C   2F0B                      Move.L    A3, -(A7)
CF0E   A948                      _CalcMenuSize
CF10   4CDF 1818                 MoveM.L   (A7)+, D3-D4/A3-A4
CF14   4E5E                      Unlk      A6
CF16   6000 FE4C                 Bra       L1852

                      P345:
CF1A   41EE FEEC                 Lea.L     $-114(A6), A0
CF1E   4298                      Clr.L     (A0)+
CF20   4290                      Clr.L     (A0)
CF22   4E75                      Rts

                      DT53:
CF24   5E2F 213C 0D3B            DC.B      '^/!< ;'
CF2A   28                        DC.B      '('

                      DT54:
CF2B   4249 554F 53              DC.B      'BIUOS'

                      P346:
CF30   4241                      Clr       D1
CF32   122E FEEC                 Move.B    $-114(A6), D1
CF36   6736                      BEQ       L1873
CF38   0C01 0001                 Cmp.B     $1, D1
CF3C   6604                      BNE       L1869
CF3E   0440 0030                 Sub       $30, D0
CF42   0C01 0004      L1869:     Cmp.B     $4, D1
CF46   6618                      BNE       L1872
CF48   7404                      MoveQ.L   $4, D2
CF4A   B03B 20DF      L1870:     Cmp.B     DT54(D2.W), D0
CF4E   6706                      BEQ       L1871
CF50   51CA FFF8                 DBF       D2, L1870
CF54   4E75                      Rts
CF56   41EE FEEF      L1871:     Lea.L     $-111(A6), A0
CF5A   1030 1000                 Move.B    $0(A0,D1.W), D0
CF5E   05C0                      BSet.B    D2, D0
CF60   41EE FEEF      L1872:     Lea.L     $-111(A6), A0
CF64   1180 1000                 Move.B    D0, $0(A0,D1.W)
CF68   422E FEEC                 Clr.B     $-114(A6)
CF6C   4E75                      Rts
CF6E   41FA FFB4      L1873:     Lea.L     DT53, A0
CF72   323C 0006                 Move      $6, D1
CF76   B030 1000      L1874:     Cmp.B     $0(A0,D1.W), D0
CF7A   6716                      BEQ       L1875
CF7C   51C9 FFF8                 DBF       D1, L1874
CF80   322E FEEE                 Move      $-112(A6), D1
CF84   41EE FEF4                 Lea.L     $-10C(A6), A0
CF88   1180 1000                 Move.B    D0, $0(A0,D1.W)
CF8C   526E FEEE                 AddQ      $1, $-112(A6)
CF90   4E75                      Rts
CF92   0C41 0003      L1875:     Cmp       $3, D1
CF96   6E08                      BGT       L1876
CF98   5241                      AddQ      $1, D1
CF9A   1D41 FEEC                 Move.B    D1, $-114(A6)
CF9E   4E75                      Rts
CFA0   5D41           L1876:     SubQ.L    $6, D1
CFA2   6606                      BNE       P347
CFA4   50EE FEED                 ST.B      $-113(A6)
CFA8   4E75                      Rts

                      P347:
CFAA   322E FEEE                 Move      $-112(A6), D1
CFAE   674E                      BEQ       L1881
CFB0   204B                      Move.L    A3, A0
CFB2   A025                      _GetHandleSize
CFB4   5A40                      AddQ      $5, D0
CFB6   D041                      Add       D1, D0
CFB8   A024                      _SetHandleSize
CFBA   4240                      Clr       D0
CFBC   2253                      Move.L    (A3), A1
CFBE   43E9 000E                 Lea.L     $E(A1), A1
CFC2   1019                      Move.B    (A1)+, D0
CFC4   D2C0                      AddA      D0, A1
CFC6   7401                      MoveQ.L   $1, D2
CFC8   1011           L1877:     Move.B    (A1), D0
CFCA   6708                      BEQ       L1878
CFCC   D2C0                      AddA      D0, A1
CFCE   5A49                      AddQ      $5, A1
CFD0   5242                      AddQ      $1, D2
CFD2   60F4                      Bra       L1877
CFD4   41EE FEF4      L1878:     Lea.L     $-10C(A6), A0
CFD8   12C1                      Move.B    D1, (A1)+
CFDA   12D8           L1879:     Move.B    (A0)+, (A1)+
CFDC   5341                      SubQ.L    $1, D1
CFDE   66FA                      BNE       L1879
CFE0   41EE FEF0                 Lea.L     $-110(A6), A0
CFE4   323C 0003                 Move      $3, D1
CFE8   12D8           L1880:     Move.B    (A0)+, (A1)+
CFEA   51C9 FFFC                 DBF       D1, L1880
CFEE   4219                      Clr.B     (A1)+
CFF0   4A2E FEED                 Tst.B     $-113(A6)
CFF4   6708                      BEQ       L1881
CFF6   2F0B                      Move.L    A3, -(A7)
CFF8   3F02                      Move      D2, -(A7)
CFFA   6100 F9B0                 Bsr       P_tDisableItem
CFFE   6100 FF1A      L1881:     Bsr       P345
D002   4E75                      Rts

                      P_tGetMenuHandle:
D004   42AF 0006                 Clr.L     $6(A7)
D008   322F 0004                 Move      $4(A7), D1
D00C   6100 F81A                 Bsr       P326
D010   670E                      BEQ       L1882
D012   3F05                      Move      D5, -(A7)
D014   3A00                      Move      D0, D5
D016   6100 F99A                 Bsr       P331
D01A   3A1F                      Move      (A7)+, D5
D01C   2F49 0006                 Move.L    A1, $6(A7)
D020   6000 F86A      L1882:     Bra       L1814

                      P_tSetMenuItemText:
D024   48E7 1838                 MoveM.L   D3-D4/A2-A4, -(A7)
D028   266F 001E                 Move.L    $1E(A7), A3
D02C   362F 001C                 Move      $1C(A7), D3
D030   246F 0018                 Move.L    $18(A7), A2
D034   3003                      Move      D3, D0
D036   2053                      Move.L    (A3), A0
D038   6100 FCE0                 Bsr       P344
D03C   6722                      BEQ       L1883
D03E   2848                      Move.L    A0, A4
D040   99D3                      SubA.L    (A3), A4
D042   7801                      MoveQ.L   $1, D4
D044   D810                      Add.B     (A0), D4
D046   7401                      MoveQ.L   $1, D2
D048   D412                      Add.B     (A2), D2
D04A   594F                      SubQ.L    $4, A7
D04C   2F0B                      Move.L    A3, -(A7)
D04E   2F0C                      Move.L    A4, -(A7)
D050   42A7                      Clr.L     -(A7)
D052   2F04                      Move.L    D4, -(A7)
D054   2F0A                      Move.L    A2, -(A7)
D056   2F02                      Move.L    D2, -(A7)
D058   A9E0                      _Munger
D05A   584F                      AddQ      $4, A7
D05C   2F0B                      Move.L    A3, -(A7)
D05E   A948                      _CalcMenuSize
D060   4CDF 1C18      L1883:     MoveM.L   (A7)+, D3-D4/A2-A4
D064   6000 FD20                 Bra       L1854

                      P_tSetMFlash:
D068   31EF 0004 0A24            Move      $4(A7), (MenuFlash)
D06E   6000 F81C                 Bra       L1814

                      P_tAppendResMenu:
D072   205F                      Move.L    (A7)+, A0
D074   3F3C 03E7                 Move      $3E7, -(A7)
D078   2F08                      Move.L    A0, -(A7)

                      P_tInsertResMenu:
D07A   4E56 FEF2                 Link      A6, $-10E
D07E   48E7 1E18                 MoveM.L   D3-D6/A3-A4, -(A7)
D082   4267                      Clr       -(A7)
D084   A99B                      _SetResLoad
D086   554F                      SubQ.L    $2, A7
D088   2F2E 000A                 Move.L    $A(A6), -(A7)
D08C   A99C                      _CountResources
D08E   381F                      Move      (A7)+, D4
D090   6700 0098                 BEQ       L1888
D094   7601                      MoveQ.L   $1, D3
D096   594F           L1884:     SubQ.L    $4, A7
D098   2F2E 000A                 Move.L    $A(A6), -(A7)
D09C   3F03                      Move      D3, -(A7)
D09E   A99D                      _GetIndResource
D0A0   47EE FEF2                 Lea.L     $-10E(A6), A3
D0A4   486E FFFC                 Pea.L     $-4(A6)
D0A8   486E FFF8                 Pea.L     $-8(A6)
D0AC   2F0B                      Move.L    A3, -(A7)
D0AE   A9A8                      _GetResInfo
D0B0   4A13                      Tst.B     (A3)
D0B2   676A                      BEQ       L1887
D0B4   0C2B 002E 0001            Cmp.B     $2E, $1(A3)
D0BA   6762                      BEQ       L1887
D0BC   0C2B 0025 0001            Cmp.B     $25, $1(A3)
D0C2   675A                      BEQ       L1887
D0C4   286E 000E                 Move.L    $E(A6), A4
D0C8   2054                      Move.L    (A4), A0
D0CA   302E 0008                 Move      $8(A6), D0
D0CE   5240                      AddQ      $1, D0
D0D0   3C00                      Move      D0, D6
D0D2   6100 FC46                 Bsr       P344
D0D6   6762                      BEQ       L1889
D0D8   2008                      Move.L    A0, D0
D0DA   9094                      Sub.L     (A4), D0
D0DC   594F                      SubQ.L    $4, A7
D0DE   2F0C                      Move.L    A4, -(A7)
D0E0   48C0                      Ext.L     D0
D0E2   2F00                      Move.L    D0, -(A7)
D0E4   2F08                      Move.L    A0, -(A7)
D0E6   42A7                      Clr.L     -(A7)
D0E8   7000                      MoveQ.L   $0, D0
D0EA   1013                      Move.B    (A3), D0
D0EC   41F3 0001                 Lea.L     $1(A3,D0.W), A0
D0F0   4218                      Clr.B     (A0)+
D0F2   4218                      Clr.B     (A0)+
D0F4   4218                      Clr.B     (A0)+
D0F6   4218                      Clr.B     (A0)+
D0F8   5A80                      AddQ      $5, D0
D0FA   2F0B                      Move.L    A3, -(A7)
D0FC   2F00                      Move.L    D0, -(A7)
D0FE   A9E0                      _Munger
D100   584F                      AddQ      $4, A7
D102   2054                      Move.L    (A4), A0
D104   2A28 000A                 Move.L    $A(A0), D5
D108   701F                      MoveQ.L   $1F, D0
D10A   E385           L1885:     AsL.L     $1, D5
D10C   E391                      RXL.L     $1, D1
D10E   B046                      Cmp       D6, D0
D110   6604                      BNE       L1886
D112   E381                      AsL.L     $1, D1
D114   5241                      AddQ      $1, D1
D116   51C8 FFF2      L1886:     DBF       D0, L1885
D11A   2141 000A                 Move.L    D1, $A(A0)
D11E   5243           L1887:     AddQ      $1, D3
D120   B644                      Cmp       D4, D3
D122   6F00 FF72                 BLE       L1884
D126   2F0C                      Move.L    A4, -(A7)
D128   A948                      _CalcMenuSize
D12A   3F3C 0100      L1888:     Move      $100, -(A7)
D12E   A99B                      _SetResLoad
D130   4CDF 1878                 MoveM.L   (A7)+, D3-D6/A3-A4
D134   4E5E                      Unlk      A6
D136   6000 FC4E                 Bra       L1854
D13A   2F0C           L1889:     Move.L    A4, -(A7)
D13C   2F0B                      Move.L    A3, -(A7)
D13E   A933                      _AppendMenu
D140   60DC                      Bra       L1887

                      P_tCountMItems:
D142   7400                      MoveQ.L   $0, D2
D144   5242           L1890:     AddQ      $1, D2
D146   206F 0004                 Move.L    $4(A7), A0
D14A   2050                      Move.L    (A0), A0
D14C   3002                      Move      D2, D0
D14E   6100 FBCA                 Bsr       P344
D152   66F0                      BNE       L1890
D154   5342                      SubQ.L    $1, D2
D156   3F42 0008                 Move      D2, $8(A7)
D15A   2E9F                      Move.L    (A7)+, (A7)
D15C   4E75                      Rts

                      P_tPlotIcon:
D15E   43F8 0A0E                 Lea.L     (IconBitmap), A1
D162   202F 0004                 Move.L    $4(A7), D0
D166   672E                      BEQ       L1891
D168   2040                      Move.L    D0, A0
D16A   22D0                      Move.L    (A0), (A1)+
D16C   32FC 0004                 Move      $4, (A1)+
D170   4299                      Clr.L     (A1)+
D172   22BC 0020 0020            Move.L    $200020, (A1)
D178   222F 0008                 Move.L    $8(A7), D1
D17C   43F8 0A0E                 Lea.L     (IconBitmap), A1
D180   2F09                      Move.L    A1, -(A7)
D182   2055                      Move.L    (A5), A0
D184   2050                      Move.L    (A0), A0
D186   4868 0002                 Pea.L     $2(A0)
D18A   4869 0006                 Pea.L     $6(A1)
D18E   2F01                      Move.L    D1, -(A7)
D190   4267                      Clr       -(A7)
D192   42A7                      Clr.L     -(A7)
D194   A8EC                      _CopyBits
D196   6000 FBCC      L1891:     Bra       L1852

                      P_tNewControl:
D19A   4E56 0000                 Link      A6, $0
D19E   48E7 0038                 MoveM.L   A2-A4, -(A7)
D1A2   49EE 0022                 Lea.L     $22(A6), A4
D1A6   7029                      MoveQ.L   $29, D0
D1A8   7200                      MoveQ.L   $0, D1
D1AA   206E 0016                 Move.L    $16(A6), A0
D1AE   1210                      Move.B    (A0), D1
D1B0   D081                      Add.L     D1, D0
D1B2   A122                      _NewHandle
D1B4   2648                      Move.L    A0, A3
D1B6   2888                      Move.L    A0, (A4)
D1B8   2453                      Move.L    (A3), A2
D1BA   2264                      Move.L    -(A4), A1
D1BC   2549 0004                 Move.L    A1, $4(A2)
D1C0   24A9 008C                 Move.L    $8C(A1), (A2)
D1C4   234B 008C                 Move.L    A3, $8C(A1)
D1C8   43EA 0008                 Lea.L     $8(A2), A1
D1CC   2064                      Move.L    -(A4), A0
D1CE   22D8                      Move.L    (A0)+, (A1)+
D1D0   2290                      Move.L    (A0), (A1)
D1D2   422A 0010                 Clr.B     $10(A2)
D1D6   2F0B                      Move.L    A3, -(A7)
D1D8   2F24                      Move.L    -(A4), -(A7)
D1DA   A95F                      _SetControlTitle
D1DC   2453                      Move.L    (A3), A2
D1DE   41EA 0010                 Lea.L     $10(A2), A0
D1E2   554C                      SubQ.L    $2, A4
D1E4   4A14                      Tst.B     (A4)
D1E6   56D8                      SNE.B     (A0)+
D1E8   4218                      Clr.B     (A0)+
D1EA   30E4                      Move      -(A4), (A0)+
D1EC   30E4                      Move      -(A4), (A0)+
D1EE   30E4                      Move      -(A4), (A0)+
D1F0   3024                      Move      -(A4), D0
D1F2   E848                      LsR       $4, D0
D1F4   594F           L1892:     SubQ.L    $4, A7
D1F6   2F3C 4344 4546            Move.L    $43444546, -(A7)
D1FC   3F00                      Move      D0, -(A7)
D1FE   A9A0                      _GetResource
D200   7000                      MoveQ.L   $0, D0
D202   2053                      Move.L    (A3), A0
D204   41E8 0018                 Lea.L     $18(A0), A0
D208   209F                      Move.L    (A7)+, (A0)
D20A   67E8                      BEQ       L1892
D20C   3014                      Move      (A4), D0
D20E   0240 000F                 And       $F, D0
D212   1080                      Move.B    D0, (A0)
D214   5848                      AddQ      $4, A0
D216   4298                      Clr.L     (A0)+
D218   4298                      Clr.L     (A0)+
D21A   20E4                      Move.L    -(A4), (A0)+
D21C   7003                      MoveQ.L   $3, D0
D21E   6122                      Bsr       P349
D220   4A2E 0014                 Tst.B     $14(A6)
D224   6704                      BEQ       L1893
D226   7200                      MoveQ.L   $0, D1
D228   610E                      Bsr       P348
D22A   4CDF 1C00      L1893:     MoveM.L   (A7)+, A2-A4
D22E   4E5E                      Unlk      A6
D230   205F                      Move.L    (A7)+, A0
D232   DEFC 001A                 AddA      $1A, A7
D236   4ED0                      Jmp       (A0)

                      P348:
D238   7000                      MoveQ.L   $0, D0
D23A   2053                      Move.L    (A3), A0
D23C   4A28 0010                 Tst.B     $10(A0)
D240   673C                      BEQ       L1896

                      P349:
D242   6100 0302                 Bsr       P352
D246   42A7                      Clr.L     -(A7)
D248   2053                      Move.L    (A3), A0
D24A   7400                      MoveQ.L   $0, D2
D24C   1428 0018                 Move.B    $18(A0), D2
D250   3F02                      Move      D2, -(A7)
D252   2F0B                      Move.L    A3, -(A7)
D254   3F00                      Move      D0, -(A7)
D256   2F01                      Move.L    D1, -(A7)
D258   2053                      Move.L    (A3), A0
D25A   2068 0018                 Move.L    $18(A0), A0
D25E   4A90                      Tst.L     (A0)
D260   6606                      BNE       L1894
D262   2F08                      Move.L    A0, -(A7)
D264   4217                      Clr.B     (A7)
D266   A9A2                      _LoadResource
D268   08D0 0007      L1894:     BSet.B    $7, (A0)
D26C   2050                      Move.L    (A0), A0
D26E   4E90                      Jsr       (A0)
D270   201F                      Move.L    (A7)+, D0
D272   2053                      Move.L    (A3), A0
D274   2068 0018                 Move.L    $18(A0), A0
D278   0890 0007                 BClr.B    $7, (A0)
D27C   A873           L1895:     _SetPort
D27E   4E75           L1896:     Rts

                      P350:
D280   6100 02C4                 Bsr       P352
D284   48E7 0078                 MoveM.L   A1-A4, -(A7)
D288   A8D8                      _NewRgn
D28A   2857                      Move.L    (A7), A4
D28C   7002                      MoveQ.L   $2, D0
D28E   220C                      Move.L    A4, D1
D290   0881 001F                 BClr.B    $1F, D1
D294   61AC                      Bsr       P349
D296   A8D4                      _EraseRgn
D298   2F0C                      Move.L    A4, -(A7)
D29A   A927                      _InvalRgn
D29C   2F0C                      Move.L    A4, -(A7)
D29E   A8D9                      _DisposeRgn
D2A0   4CDF 1C00                 MoveM.L   (A7)+, A2-A4
D2A4   60D6                      Bra       L1895

                      P_tDisposeControl:
D2A6   2F0B                      Move.L    A3, -(A7)
D2A8   266F 0008                 Move.L    $8(A7), A3
D2AC   61D2                      Bsr       P350
D2AE   204B                      Move.L    A3, A0
D2B0   2253                      Move.L    (A3), A1
D2B2   2269 0004                 Move.L    $4(A1), A1
D2B6   43E9 008C                 Lea.L     $8C(A1), A1
D2BA   6100 03D2                 Bsr       P353
D2BE   7004                      MoveQ.L   $4, D0
D2C0   6180                      Bsr       P349
D2C2   204B                      Move.L    A3, A0
D2C4   A023                      _DisposeHandle
D2C6   602A                      Bra       L1898

                      P_tKillControls:
D2C8   2F0B                      Move.L    A3, -(A7)
D2CA   266F 0008                 Move.L    $8(A7), A3
D2CE   202B 008C      L1897:     Move.L    $8C(A3), D0
D2D2   671E                      BEQ       L1898
D2D4   2F00                      Move.L    D0, -(A7)
D2D6   A955                      _DisposeControl
D2D8   60F4                      Bra       L1897

                      P_tShowControl:
D2DA   2F0B                      Move.L    A3, -(A7)
D2DC   266F 0008                 Move.L    $8(A7), A3
D2E0   2053                      Move.L    (A3), A0
D2E2   4A28 0010                 Tst.B     $10(A0)
D2E6   660A                      BNE       L1898
D2E8   50E8 0010                 ST.B      $10(A0)
D2EC   7200                      MoveQ.L   $0, D1
D2EE   6100 FF48                 Bsr       P348
D2F2   265F           L1898:     Move.L    (A7)+, A3
D2F4   2E9F                      Move.L    (A7)+, (A7)
D2F6   4E75                      Rts

                      P_tHideControl:
D2F8   2F0B                      Move.L    A3, -(A7)
D2FA   266F 0008                 Move.L    $8(A7), A3
D2FE   2053                      Move.L    (A3), A0
D300   4A28 0010                 Tst.B     $10(A0)
D304   67EC                      BEQ       L1898
D306   6100 FF78                 Bsr       P350
D30A   2053                      Move.L    (A3), A0
D30C   4228 0010                 Clr.B     $10(A0)
D310   60E0                      Bra       L1898

                      P_tMoveControl:
D312   48E7 1010                 MoveM.L   D3/A3, -(A7)
D316   266F 0010                 Move.L    $10(A7), A3
D31A   2053                      Move.L    (A3), A0
D31C   1628 0010                 Move.B    $10(A0), D3
D320   2F0B                      Move.L    A3, -(A7)
D322   A958                      _HideControl
D324   2053                      Move.L    (A3), A0
D326   5048                      AddQ      $8, A0
D328   302F 000C                 Move      $C(A7), D0
D32C   9050                      Sub       (A0), D0
D32E   322F 000E                 Move      $E(A7), D1
D332   9268 0002                 Sub       $2(A0), D1
D336   2F08                      Move.L    A0, -(A7)
D338   3F01                      Move      D1, -(A7)
D33A   3F00                      Move      D0, -(A7)
D33C   A8A8                      _OffsetRect
D33E   4A03           L1899:     Tst.B     D3
D340   6704                      BEQ       L1900
D342   2F0B                      Move.L    A3, -(A7)
D344   A957                      _ShowControl
D346   4CDF 0808      L1900:     MoveM.L   (A7)+, D3/A3
D34A   205F           L1901:     Move.L    (A7)+, A0
D34C   504F                      AddQ      $8, A7
D34E   4ED0                      Jmp       (A0)

                      P_tGetControlReference:
D350   7224                      MoveQ.L   $24, D1
D352   205F           L1902:     Move.L    (A7)+, A0
D354   225F                      Move.L    (A7)+, A1
D356   2251                      Move.L    (A1), A1
D358   2EB1 1000                 Move.L    $0(A1,D1.W), (A7)
D35C   4ED0                      Jmp       (A0)

                      P_tSetControlReference:
D35E   7224                      MoveQ.L   $24, D1
D360   205F           L1903:     Move.L    (A7)+, A0
D362   201F                      Move.L    (A7)+, D0
D364   225F                      Move.L    (A7)+, A1
D366   2251                      Move.L    (A1), A1
D368   2380 1000                 Move.L    D0, $0(A1,D1.W)
D36C   4ED0                      Jmp       (A0)

                      P_tGetControlAction:
D36E   7220                      MoveQ.L   $20, D1
D370   60E0                      Bra       L1902

                      P_tSetControlAction:
D372   7220                      MoveQ.L   $20, D1
D374   60EA                      Bra       L1903

                      P_tSizeControl:
D376   48E7 1010                 MoveM.L   D3/A3, -(A7)
D37A   266F 0010                 Move.L    $10(A7), A3
D37E   2053                      Move.L    (A3), A0
D380   1628 0010                 Move.B    $10(A0), D3
D384   2F0B                      Move.L    A3, -(A7)
D386   A958                      _HideControl
D388   302F 000C                 Move      $C(A7), D0
D38C   322F 000E                 Move      $E(A7), D1
D390   2053                      Move.L    (A3), A0
D392   5048                      AddQ      $8, A0
D394   D058                      Add       (A0)+, D0
D396   D258                      Add       (A0)+, D1
D398   30C0                      Move      D0, (A0)+
D39A   30C1                      Move      D1, (A0)+
D39C   60A0                      Bra       L1899

                      P_tHiliteControl:
D39E   2F0B                      Move.L    A3, -(A7)
D3A0   266F 000A                 Move.L    $A(A7), A3
D3A4   2053                      Move.L    (A3), A0
D3A6   7200                      MoveQ.L   $0, D1
D3A8   7000                      MoveQ.L   $0, D0
D3AA   122F 0009                 Move.B    $9(A7), D1
D3AE   1028 0011                 Move.B    $11(A0), D0
D3B2   B200                      Cmp.B     D0, D1
D3B4   670C                      BEQ       L1905
D3B6   1141 0011                 Move.B    D1, $11(A0)
D3BA   6602                      BNE       L1904
D3BC   3200                      Move      D0, D1
D3BE   6100 FE78      L1904:     Bsr       P348
D3C2   265F           L1905:     Move.L    (A7)+, A3
D3C4   205F           L1906:     Move.L    (A7)+, A0
D3C6   5C4F                      AddQ      $6, A7
D3C8   4ED0                      Jmp       (A0)

                      P_tGetControlTitle:
D3CA   201F                      Move.L    (A7)+, D0
D3CC   225F                      Move.L    (A7)+, A1
D3CE   205F                      Move.L    (A7)+, A0
D3D0   2F00                      Move.L    D0, -(A7)
D3D2   2050                      Move.L    (A0), A0
D3D4   41E8 0028                 Lea.L     $28(A0), A0
D3D8   7000                      MoveQ.L   $0, D0
D3DA   1010                      Move.B    (A0), D0
D3DC   5280                      AddQ      $1, D0
D3DE   A02E                      _BlockMove
D3E0   4E75                      Rts

                      P_tSetControlTitle:
D3E2   48E7 1018                 MoveM.L   D3/A3-A4, -(A7)
D3E6   266F 0014                 Move.L    $14(A7), A3
D3EA   2053                      Move.L    (A3), A0
D3EC   1628 0010                 Move.B    $10(A0), D3
D3F0   2F0B                      Move.L    A3, -(A7)
D3F2   A958                      _HideControl
D3F4   286F 0010                 Move.L    $10(A7), A4
D3F8   7000                      MoveQ.L   $0, D0
D3FA   1014                      Move.B    (A4), D0
D3FC   2F00                      Move.L    D0, -(A7)
D3FE   0640 0029                 Add       $29, D0
D402   204B                      Move.L    A3, A0
D404   A024                      _SetHandleSize
D406   201F                      Move.L    (A7)+, D0
D408   204C                      Move.L    A4, A0
D40A   2253                      Move.L    (A3), A1
D40C   43E9 0028                 Lea.L     $28(A1), A1
D410   5240                      AddQ      $1, D0
D412   A02E                      _BlockMove
D414   4A03                      Tst.B     D3
D416   6704                      BEQ       L1907
D418   2F0B                      Move.L    A3, -(A7)
D41A   A957                      _ShowControl
D41C   4CDF 1808      L1907:     MoveM.L   (A7)+, D3/A3-A4
D420   6000 FF28                 Bra       L1901

                      P_tGetControlValue:
D424   7012                      MoveQ.L   $12, D0
D426   225F           L1908:     Move.L    (A7)+, A1
D428   205F                      Move.L    (A7)+, A0
D42A   2050                      Move.L    (A0), A0
D42C   3EB0 0000                 Move      $0(A0,D0.W), (A7)
D430   4ED1                      Jmp       (A1)

                      P_tGetControlMinimum:
D432   7014                      MoveQ.L   $14, D0
D434   60F0                      Bra       L1908

                      P_tGetControlMaximum:
D436   7016                      MoveQ.L   $16, D0
D438   60EC                      Bra       L1908

                      P_tSetControlValue:
D43A   7012                      MoveQ.L   $12, D0
D43C   2F0B           L1909:     Move.L    A3, -(A7)
D43E   266F 000A                 Move.L    $A(A7), A3
D442   322F 0008                 Move      $8(A7), D1
D446   2053                      Move.L    (A3), A0
D448   B270 0000                 Cmp       $0(A0,D0.W), D1
D44C   6728                      BEQ       L1912
D44E   3181 0000                 Move      D1, $0(A0,D0.W)
D452   3228 0012                 Move      $12(A0), D1
D456   B268 0014                 Cmp       $14(A0), D1
D45A   6C04                      BGE       L1910
D45C   3228 0014                 Move      $14(A0), D1
D460   B268 0016      L1910:     Cmp       $16(A0), D1
D464   6F04                      BLE       L1911
D466   3228 0016                 Move      $16(A0), D1
D46A   3141 0012      L1911:     Move      D1, $12(A0)
D46E   323C 0081                 Move      $81, D1
D472   6100 FDC4                 Bsr       P348
D476   265F           L1912:     Move.L    (A7)+, A3
D478   6000 FF4A                 Bra       L1906

                      P_tSetControlMinimum:
D47C   7014                      MoveQ.L   $14, D0
D47E   60BC                      Bra       L1909

                      P_tSetControlMaximum:
D480   7016                      MoveQ.L   $16, D0
D482   60B8                      Bra       L1909

                      P_tTestControl:
D484   2F0B                      Move.L    A3, -(A7)
D486   266F 000C                 Move.L    $C(A7), A3
D48A   2053                      Move.L    (A3), A0
D48C   426F 0010                 Clr       $10(A7)
D490   1228 0010                 Move.B    $10(A0), D1
D494   6716                      BEQ       L1913
D496   0C28 00FF 0011            Cmp.B     $-1, $11(A0)
D49C   670E                      BEQ       L1913
D49E   222F 0008                 Move.L    $8(A7), D1
D4A2   7001                      MoveQ.L   $1, D0
D4A4   6100 FD9C                 Bsr       P349
D4A8   3F40 0010                 Move      D0, $10(A7)
D4AC   265F           L1913:     Move.L    (A7)+, A3
D4AE   6000 FE9A                 Bra       L1901

                      P_tDragControl:
D4B2   4278 0A44                 Clr       (DragFlag)

                      P351:
D4B6   4E56 0000                 Link      A6, $0
D4BA   48E7 1818                 MoveM.L   D3-D4/A3-A4, -(A7)
D4BE   4CEE 0818 000E            MoveM.L   $E(A6), D3-D4/A3
D4C4   6100 0080                 Bsr       P352
D4C8   3238 0A44                 Move      (DragFlag), D1
D4CC   7007                      MoveQ.L   $7, D0
D4CE   6100 FD72                 Bsr       P349
D4D2   4A40                      Tst       D0
D4D4   663E                      BNE       L1915
D4D6   4EBA E5EA                 Jsr       P301
D4DA   4A78 0A44                 Tst       (DragFlag)
D4DE   56D7                      SNE.B     (A7)
D4E0   2217                      Move.L    (A7), D1
D4E2   7002                      MoveQ.L   $2, D0
D4E4   6100 FD5C                 Bsr       P349
D4E8   4217                      Clr.B     (A7)
D4EA   285F                      Move.L    (A7)+, A4
D4EC   48E7 180C                 MoveM.L   D3-D4/A4-A5, -(A7)
D4F0   2F2E 000A                 Move.L    $A(A6), -(A7)
D4F4   3F2E 0008                 Move      $8(A6), -(A7)
D4F8   2F38 0A46                 Move.L    (CurDragAction), -(A7)
D4FC   4A78 0A44                 Tst       (DragFlag)
D500   6602                      BNE       L1914
D502   4297                      Clr.L     (A7)
D504   A926           L1914:     _DragTheRgn
D506   2F0C                      Move.L    A4, -(A7)
D508   A8D9                      _DisposeRgn
D50A   261F                      Move.L    (A7)+, D3
D50C   6726                      BEQ       L1917
D50E   0C43 8000                 Cmp       $-8000, D3
D512   6604                      BNE       L1916
D514   7600           L1915:     MoveQ.L   $0, D3
D516   601C                      Bra       L1917
D518   4A78 0A44      L1916:     Tst       (DragFlag)
D51C   6616                      BNE       L1917
D51E   2053                      Move.L    (A3), A0
D520   2028 0008                 Move.L    $8(A0), D0
D524   D043                      Add       D3, D0
D526   4840                      Swap      D0
D528   4843                      Swap      D3
D52A   D043                      Add       D3, D0
D52C   4840                      Swap      D0
D52E   2F0B                      Move.L    A3, -(A7)
D530   2F00                      Move.L    D0, -(A7)
D532   A959                      _MoveControl
D534   A873           L1917:     _SetPort
D536   2203                      Move.L    D3, D1
D538   4CDF 1818                 MoveM.L   (A7)+, D3-D4/A3-A4
D53C   4E5E                      Unlk      A6
D53E   205F                      Move.L    (A7)+, A0
D540   DEFC 0012                 AddA      $12, A7
D544   4ED0                      Jmp       (A0)

                      P352:
D546   241F                      Move.L    (A7)+, D2
D548   594F                      SubQ.L    $4, A7
D54A   2F0F                      Move.L    A7, -(A7)
D54C   A874                      _GetPort
D54E   2F02                      Move.L    D2, -(A7)
D550   2053                      Move.L    (A3), A0
D552   2F28 0004                 Move.L    $4(A0), -(A7)
D556   A873                      _SetPort
D558   4E75                      Rts

                      P_tTrackControl:
D55A   4E56 FFE4                 Link      A6, $-1C
D55E   48E7 1010                 MoveM.L   D3/A3, -(A7)
D562   266E 0010                 Move.L    $10(A6), A3
D566   2D6E 000C FFF8            Move.L    $C(A6), $-8(A6)
D56C   61D8                      Bsr       P352
D56E   7600                      MoveQ.L   $0, D3
D570   2F0B           L1918:     Move.L    A3, -(A7)
D572   4267                      Clr       -(A7)
D574   2F0B                      Move.L    A3, -(A7)
D576   2F2E FFF8                 Move.L    $-8(A6), -(A7)
D57A   A966                      _TestControl
D57C   4A43                      Tst       D3
D57E   6608                      BNE       L1919
D580   3617                      Move      (A7), D3
D582   4A03                      Tst.B     D3
D584   6A08                      BPL       L1920
D586   6060                      Bra       L1924
D588   B657           L1919:     Cmp       (A7), D3
D58A   6702                      BEQ       L1920
D58C   4257                      Clr       (A7)
D58E   3D57 0014      L1920:     Move      (A7), $14(A6)
D592   A95D                      _HiliteControl
D594   202E 0008                 Move.L    $8(A6), D0
D598   672A                      BEQ       L1922
D59A   0800 0000                 BTst.B    $0, D0
D59E   671A                      BEQ       L1921
D5A0   2053                      Move.L    (A3), A0
D5A2   2028 0020                 Move.L    $20(A0), D0
D5A6   671C                      BEQ       L1922
D5A8   0800 0000                 BTst.B    $0, D0
D5AC   670C                      BEQ       L1921
D5AE   7008                      MoveQ.L   $8, D0
D5B0   322E 0014                 Move      $14(A6), D1
D5B4   6100 FC8C                 Bsr       P349
D5B8   600A                      Bra       L1922
D5BA   2F0B           L1921:     Move.L    A3, -(A7)
D5BC   3F2E 0014                 Move      $14(A6), -(A7)
D5C0   2040                      Move.L    D0, A0
D5C2   4E90                      Jsr       (A0)
D5C4   486E FFF8      L1922:     Pea.L     $-8(A6)
D5C8   A972                      _GetMouse
D5CA   4267                      Clr       -(A7)
D5CC   A977                      _WaitMouseUp
D5CE   4A1F                      Tst.B     (A7)+
D5D0   669E                      BNE       L1918
D5D2   2F0B                      Move.L    A3, -(A7)
D5D4   4267                      Clr       -(A7)
D5D6   A95D                      _HiliteControl
D5D8   A873           L1923:     _SetPort
D5DA   4CDF 0808                 MoveM.L   (A7)+, D3/A3
D5DE   4E5E                      Unlk      A6
D5E0   205F                      Move.L    (A7)+, A0
D5E2   DEFC 000C                 AddA      $C, A7
D5E6   4ED0                      Jmp       (A0)
D5E8   3D5F 0014      L1924:     Move      (A7)+, $14(A6)
D5EC   584F                      AddQ      $4, A7
D5EE   41EE FFE4                 Lea.L     $-1C(A6), A0
D5F2   20AE 000C                 Move.L    $C(A6), (A0)
D5F6   2208                      Move.L    A0, D1
D5F8   7006                      MoveQ.L   $6, D0
D5FA   6100 FC46                 Bsr       P349
D5FE   50F8 0A44                 ST.B      (DragFlag)
D602   202E 0008                 Move.L    $8(A6), D0
D606   0800 0000                 BTst.B    $0, D0
D60A   670E                      BEQ       L1925
D60C   2053                      Move.L    (A3), A0
D60E   2028 0020                 Move.L    $20(A0), D0
D612   0800 0000                 BTst.B    $0, D0
D616   6702                      BEQ       L1925
D618   7000                      MoveQ.L   $0, D0
D61A   21C0 0A46      L1925:     Move.L    D0, (CurDragAction)
D61E   2F0B                      Move.L    A3, -(A7)
D620   2F2E 000C                 Move.L    $C(A6), -(A7)
D624   41EE FFE4                 Lea.L     $-1C(A6), A0
D628   2F08                      Move.L    A0, -(A7)
D62A   4868 0008                 Pea.L     $8(A0)
D62E   3F28 0010                 Move      $10(A0), -(A7)
D632   6100 FE82                 Bsr       P351
D636   4A81                      Tst.L     D1
D638   6708                      BEQ       L1926
D63A   7005                      MoveQ.L   $5, D0
D63C   6100 FC04                 Bsr       P349
D640   6096                      Bra       L1923
D642   426E 0014      L1926:     Clr       $14(A6)
D646   6090                      Bra       L1923

                      P_tDrawControls:
D648   4E56 FFE8                 Link      A6, $-18
D64C   2F0B                      Move.L    A3, -(A7)
D64E   266E 0008                 Move.L    $8(A6), A3
D652   594F                      SubQ.L    $4, A7
D654   2F0F                      Move.L    A7, -(A7)
D656   A874                      _GetPort
D658   2F0B                      Move.L    A3, -(A7)
D65A   A873                      _SetPort
D65C   486E FFE8                 Pea.L     $-18(A6)
D660   2F17                      Move.L    (A7), -(A7)
D662   A898                      _GetPenState
D664   A89E                      _PenNormal
D666   202B 008C                 Move.L    $8C(A3), D0
D66A   6716                      BEQ       L1929
D66C   2640           L1927:     Move.L    D0, A3
D66E   2053                      Move.L    (A3), A0
D670   4A28 0010                 Tst.B     $10(A0)
D674   6706                      BEQ       L1928
D676   7200                      MoveQ.L   $0, D1
D678   6100 FBBE                 Bsr       P348
D67C   2053           L1928:     Move.L    (A3), A0
D67E   2010                      Move.L    (A0), D0
D680   66EA                      BNE       L1927
D682   A899           L1929:     _SetPenState
D684   A873                      _SetPort
D686   265F                      Move.L    (A7)+, A3
D688   4E5E                      Unlk      A6
D68A   2E9F                      Move.L    (A7)+, (A7)
D68C   4E75                      Rts

                      P353:
D68E   48E7 4030                 MoveM.L   D1/A2-A3, -(A7)
D692   70FF                      MoveQ.L   $-1, D0
D694   4A91                      Tst.L     (A1)
D696   6718                      BEQ       L1932
D698   2451                      Move.L    (A1), A2
D69A   2649                      Move.L    A1, A3
D69C   6008                      Bra       L1931
D69E   2652           L1930:     Move.L    (A2), A3
D6A0   2453                      Move.L    (A3), A2
D6A2   220A                      Move.L    A2, D1
D6A4   670A                      BEQ       L1932
D6A6   B5C8           L1931:     CmpA.L    A0, A2
D6A8   66F4                      BNE       L1930
D6AA   2452                      Move.L    (A2), A2
D6AC   2692                      Move.L    (A2), (A3)
D6AE   7000                      MoveQ.L   $0, D0
D6B0   4CDF 0C02      L1932:     MoveM.L   (A7)+, D1/A2-A3
D6B4   4E75                      Rts

                      P_tFindControl:
D6B6   4E56 FFFC                 Link      A6, $-4
D6BA   48E7 3010                 MoveM.L   D2-D3/A3, -(A7)
D6BE   41EE 0008                 Lea.L     $8(A6), A0
D6C2   2258                      Move.L    (A0)+, A1
D6C4   4291                      Clr.L     (A1)
D6C6   2658                      Move.L    (A0)+, A3
D6C8   2618                      Move.L    (A0)+, D3
D6CA   4250                      Clr       (A0)
D6CC   2F0F                      Move.L    A7, -(A7)
D6CE   A874                      _GetPort
D6D0   2F0B                      Move.L    A3, -(A7)
D6D2   A873                      _SetPort
D6D4   4A2B 006E                 Tst.B     $6E(A3)
D6D8   6700 FEFE                 BEQ       L1923
D6DC   4267                      Clr       -(A7)
D6DE   2F03                      Move.L    D3, -(A7)
D6E0   486B 0010                 Pea.L     $10(A3)
D6E4   A8AD                      _PtInRect
D6E6   4A1F                      Tst.B     (A7)+
D6E8   6700 FEEE                 BEQ       L1923
D6EC   202B 008C                 Move.L    $8C(A3), D0
D6F0   6700 FEE6                 BEQ       L1923
D6F4   2640                      Move.L    D0, A3
D6F6   2053           L1933:     Move.L    (A3), A0
D6F8   0C28 00FF 0011            Cmp.B     $-1, $11(A0)
D6FE   670C                      BEQ       L1934
D700   4267                      Clr       -(A7)
D702   2F0B                      Move.L    A3, -(A7)
D704   2F03                      Move.L    D3, -(A7)
D706   A966                      _TestControl
D708   301F                      Move      (A7)+, D0
D70A   660C                      BNE       L1935
D70C   2053           L1934:     Move.L    (A3), A0
D70E   2650                      Move.L    (A0), A3
D710   200B                      Move.L    A3, D0
D712   66E2                      BNE       L1933
D714   6000 FEC2                 Bra       L1923
D718   206E 0008      L1935:     Move.L    $8(A6), A0
D71C   208B                      Move.L    A3, (A0)
D71E   3D40 0014                 Move      D0, $14(A6)
D722   60E8                      Bra       L1934

                      DT55:
D724   0000 0100 0000            DC.B      '      '
D72A   0100 0000 0000            DC.B      '      '
D730   0000 001E 0000            DC.B      '      '
D736   0000 0000 0000            DC.B      '      '
D73C   001C 001E FFFF            DC.B      '      '
D742   0000                      DC.B      '  '

                      P_tInitResources:
D744   6100 059E                 Bsr       P373
D748   47F8 0118                 Lea.L     (TheZone), A3
D74C   2F13                      Move.L    (A3), -(A7)
D74E   26B8 02A6                 Move.L    (SysZone), (A3)
D752   43F8 0AD8                 Lea.L     (SysResName), A1
D756   6142                      Bsr       P_NewMap
D758   269F                      Move.L    (A7)+, (A3)
D75A   3D46 0008                 Move      D6, $8(A6)
D75E   4A80                      Tst.L     D0
D760   6F0E                      BLE       L1936
D762   41F8 0A50                 Lea.L     (TopMapHndl), A0
D766   20CA                      Move.L    A2, (A0)+
D768   20CA                      Move.L    A2, (A0)+
D76A   30C6                      Move      D6, (A0)+
D76C   3086                      Move      D6, (A0)
D76E   6104                      Bsr       P354
D770   6000 03DA      L1936:     Bra       L1985

                      P354:
D774   50F8 0A5E                 ST.B      (ResLoad)
D778   6100 04E6                 Bsr       P365
D77C   6100 01AA                 Bsr       P359
D780   6B16                      BMI       L1939
D782   42AA 0008      L1937:     Clr.L     $8(A2)
D786   082A 0002 0004            BTst.B    $2, $4(A2)
D78C   6704                      BEQ       L1938
D78E   6100 0610                 Bsr       P378
D792   6100 0198      L1938:     Bsr       P360
D796   67EA                      BEQ       L1937
D798   4E75           L1939:     Rts

                      P_NewMap:
D79A   7010                      MoveQ.L   $10, D0
D79C   A122                      _NewHandle
D79E   6B74                      BMI       L1943
D7A0   2448                      Move.L    A0, A2
D7A2   6100 0726                 Bsr       P386
D7A6   6100 00B2                 Bsr       P357
D7AA   6710                      BEQ       L1940
D7AC   0C40 FFCF                 Cmp       $-31, D0
D7B0   665E                      BNE       L1942
D7B2   4278 0A60                 Clr       (ResErr)
D7B6   204A                      Move.L    A2, A0
D7B8   A023                      _DisposeHandle
D7BA   4E75                      Rts
D7BC   A011           L1940:     _GetEOF
D7BE   31FC FFD9 0A60            Move      $-27, (ResErr)
D7C4   4AA8 001C                 Tst.L     $1C(A0)
D7C8   6740                      BEQ       L1941
D7CA   7010                      MoveQ.L   $10, D0
D7CC   2252                      Move.L    (A2), A1
D7CE   2209                      Move.L    A1, D1
D7D0   7400                      MoveQ.L   $0, D2
D7D2   6100 0710                 Bsr       P387
D7D6   6B32                      BMI       L1941
D7D8   7210                      MoveQ.L   $10, D1
D7DA   2429 0004                 Move.L    $4(A1), D2
D7DE   D481                      Add.L     D1, D2
D7E0   2829 000C                 Move.L    $C(A1), D4
D7E4   2004                      Move.L    D4, D0
D7E6   204A                      Move.L    A2, A0
D7E8   A024                      _SetHandleSize
D7EA   31C0 0A60                 Move      D0, (ResErr)
D7EE   661A                      BNE       L1941
D7F0   2252                      Move.L    (A2), A1
D7F2   2004                      Move.L    D4, D0
D7F4   9081                      Sub.L     D1, D0
D7F6   D289                      Add.L     A1, D1
D7F8   6100 06EA                 Bsr       P387
D7FC   6B0C                      BMI       L1941
D7FE   42A9 0010                 Clr.L     $10(A1)
D802   3346 0014                 Move      D6, $14(A1)
D806   7001                      MoveQ.L   $1, D0
D808   4E75                      Rts
D80A   6100 06BE      L1941:     Bsr       P386
D80E   A001                      _Close
D810   204A           L1942:     Move.L    A2, A0
D812   A023                      _DisposeHandle
D814   7CFF           L1943:     MoveQ.L   $-1, D6
D816   70FF                      MoveQ.L   $-1, D0
D818   4E75                      Rts

                      P_tRsrcZoneInit:
D81A   6100 04C8                 Bsr       P373
D81E   4A78 0A58                 Tst       (SysMap)
D822   6B1E                      BMI       L1946
D824   6120                      Bsr       P356
D826   6100 0438                 Bsr       P365
D82A   6100 0480                 Bsr       P369
D82E   6B12                      BMI       L1946
D830   082A 0006 0004 L1944:     BTst.B    $6, $4(A2)
D836   6604                      BNE       L1945
D838   42AA 0008                 Clr.L     $8(A2)
D83C   6100 0542      L1945:     Bsr       P377
D840   6AEE                      BPL       L1944
D842   6000 0308      L1946:     Bra       L1985

                      P356:
D846   2078 0A50                 Move.L    (TopMapHndl), A0
D84A   B1F8 0A54                 CmpA.L    (SysMapHndl), A0
D84E   6724                      BEQ       L1947
D850   2050                      Move.L    (A0), A0
D852   3F28 0014                 Move      $14(A0), -(A7)
D856   A99A                      _CloseResFile
D858   60EC                      Bra       P356

                      P357:
D85A   2149 0012                 Move.L    A1, $12(A0)
D85E   4268 001A                 Clr       $1A(A0)
D862   42A8 001C                 Clr.L     $1C(A0)
D866   4268 0016                 Clr       $16(A0)
D86A   A00A                      _OpenRF
D86C   3C28 0018                 Move      $18(A0), D6
D870   31C0 0A60                 Move      D0, (ResErr)
D874   4E75           L1947:     Rts

                      P_tCreateResFile:
D876   6100 046C                 Bsr       P373
D87A   2250                      Move.L    (A0), A1
D87C   6100 064C                 Bsr       P386
D880   61D8                      Bsr       P357
D882   670C                      BEQ       L1948
D884   0C40 FFD5                 Cmp       $-2B, D0
D888   662C                      BNE       L1950
D88A   A008                      _Create
D88C   61CC                      Bsr       P357
D88E   6B26                      BMI       L1950
D890   A011           L1948:     _GetEOF
D892   31FC FFD0 0A60            Move      $-30, (ResErr)
D898   4AA8 001C                 Tst.L     $1C(A0)
D89C   6616                      BNE       L1949
D89E   7010                      MoveQ.L   $10, D0
D8A0   43FA FE82                 Lea.L     DT55, A1
D8A4   2209                      Move.L    A1, D1
D8A6   6100 0646                 Bsr       P388
D8AA   701E                      MoveQ.L   $1E, D0
D8AC   7440                      MoveQ.L   $40, D2
D8AE   E542                      AsL       $2, D2
D8B0   6100 063E                 Bsr       P389
D8B4   A001           L1949:     _Close
D8B6   6026           L1950:     Bra       L1951

                      P_tOpenResFile:
D8B8   6100 042A                 Bsr       P373
D8BC   2250                      Move.L    (A0), A1
D8BE   6100 FEDA                 Bsr       P_NewMap
D8C2   3D46 000C                 Move      D6, $C(A6)
D8C6   6B16                      BMI       L1951
D8C8   31C6 0A5A                 Move      D6, (CurMap)
D8CC   4A40                      Tst       D0
D8CE   670E                      BEQ       L1951
D8D0   2378 0A50 0010            Move.L    (TopMapHndl), $10(A1)
D8D6   21CA 0A50                 Move.L    A2, (TopMapHndl)
D8DA   6100 FE98                 Bsr       P354
D8DE   6000 07CE      L1951:     Bra       L2052

                      P_tUseResFile:
D8E2   6126                      Bsr       P358
D8E4   31C6 0A5A                 Move      D6, (CurMap)
D8E8   603A                      Bra       L1954

                      P_tGetResFileAttrs:
D8EA   611E                      Bsr       P358
D8EC   1D6B 0016 000B            Move.B    $16(A3), $B(A6)
D8F2   6030                      Bra       L1954

                      P_tSetResFileAttrs:
D8F4   6100 03EE                 Bsr       P373
D8F8   3C2E 000A                 Move      $A(A6), D6
D8FC   6100 0366                 Bsr       P366
D900   6B06                      BMI       L1952
D902   176E 0009 0016            Move.B    $9(A6), $16(A3)
D908   60D4           L1952:     Bra       L1951

                      P358:
D90A   201F                      Move.L    (A7)+, D0
D90C   6100 03D6                 Bsr       P373
D910   2F00                      Move.L    D0, -(A7)
D912   3C10                      Move      (A0), D6
D914   6100 034E                 Bsr       P366
D918   6B02                      BMI       L1953
D91A   4E75                      Rts
D91C   584F           L1953:     AddQ      $4, A7
D91E   31FC FF3F 0A60            Move      $-C1, (ResErr)
D924   6000 0114      L1954:     Bra       L1968

                      P359:
D928   70FF                      MoveQ.L   $-1, D0
D92A   6008                      Bra       L1955

                      P360:
D92C   202A 0004                 Move.L    $4(A2), D0
D930   C0B8 031A                 And.L     (Lo3Bytes), D0
D934   48E7 3F18      L1955:     MoveM.L   D2-D7/A3-A4, -(A7)
D938   2400                      Move.L    D0, D2
D93A   6100 0370                 Bsr       P369
D93E   6B3A                      BMI       L1958
D940   41F8 0A06                 Lea.L     (MinusOne), A0
D944   5988                      SubQ.L    $4, A0
D946   2C08                      Move.L    A0, D6
D948   7EFF                      MoveQ.L   $-1, D7
D94A   E28F                      LsR.L     $1, D7
D94C   4A2A 0004      L1956:     Tst.B     $4(A2)
D950   6B14                      BMI       L1957
D952   202A 0004                 Move.L    $4(A2), D0
D956   C0B8 031A                 And.L     (Lo3Bytes), D0
D95A   B480                      Cmp.L     D0, D2
D95C   6C08                      BGE       L1957
D95E   BE80                      Cmp.L     D0, D7
D960   6F04                      BLE       L1957
D962   2E00                      Move.L    D0, D7
D964   2C0A                      Move.L    A2, D6
D966   6100 0418      L1957:     Bsr       P377
D96A   6AE0                      BPL       L1956
D96C   2446                      Move.L    D6, A2
D96E   2007                      Move.L    D7, D0
D970   2E2A 0004                 Move.L    $4(A2), D7
D974   CEB8 031A                 And.L     (Lo3Bytes), D7
D978   BE80                      Cmp.L     D0, D7
D97A   4CDF 18FC      L1958:     MoveM.L   (A7)+, D2-D7/A3-A4
D97E   4E75                      Rts

                      P361:
D980   48E7 01E0                 MoveM.L   D7/A0-A2, -(A7)
D984   202A 0004                 Move.L    $4(A2), D0
D988   C0B8 031A                 And.L     (Lo3Bytes), D0
D98C   2E00                      Move.L    D0, D7
D98E   619C                      Bsr       P360
D990   6A0E                      BPL       L1959
D992   2054                      Move.L    (A4), A0
D994   2028 0004                 Move.L    $4(A0), D0
D998   9087                      Sub.L     D7, D0
D99A   9090                      Sub.L     (A0), D0
D99C   7EFF                      MoveQ.L   $-1, D7
D99E   6002                      Bra       L1960
D9A0   9087           L1959:     Sub.L     D7, D0
D9A2   4CDF 0780      L1960:     MoveM.L   (A7)+, D7/A0-A2
D9A6   4E75                      Rts

                      P_tUpdateResFile:
D9A8   6100 FF60                 Bsr       P358
D9AC   6100 05BE                 Bsr       P395
D9B0   6600 0088                 BNE       L1968
D9B4   6100 FF72                 Bsr       P359
D9B8   6B12                      BMI       L1963
D9BA   082A 0001 0004 L1961:     BTst.B    $1, $4(A2)
D9C0   6704                      BEQ       L1962
D9C2   6100 04E6                 Bsr       P385
D9C6   6100 FF64      L1962:     Bsr       P360
D9CA   67EE                      BEQ       L1961
D9CC   08AB 0006 0016 L1963:     BClr.B    $6, $16(A3)
D9D2   6740                      BEQ       L1967
D9D4   50F8 0A5E                 ST.B      (ResLoad)
D9D8   6100 FF4E                 Bsr       P359
D9DC   6632                      BNE       L1966
D9DE   2E00                      Move.L    D0, D7
D9E0   4487                      Neg.L     D7
D9E2   4A87           L1964:     Tst.L     D7
D9E4   6714                      BEQ       L1965
D9E6   6100 03B8                 Bsr       P378
D9EA   41EA 0004                 Lea.L     $4(A2), A0
D9EE   1010                      Move.B    (A0), D0
D9F0   4210                      Clr.B     (A0)
D9F2   DF90                      Add.L     D7, (A0)
D9F4   1080                      Move.B    D0, (A0)
D9F6   6100 04B2                 Bsr       P385
D9FA   6184           L1965:     Bsr       P361
D9FC   6B12                      BMI       L1966
D9FE   2E00                      Move.L    D0, D7
DA00   4487                      Neg.L     D7
DA02   6100 0464                 Bsr       P382
DA06   5880                      AddQ      $4, D0
DA08   DE80                      Add.L     D0, D7
DA0A   6100 FF20                 Bsr       P360
DA0E   60D2                      Bra       L1964
DA10   DFAB 0008      L1966:     Add.L     D7, $8(A3)
DA14   08AB 0005 0016 L1967:     BClr.B    $5, $16(A3)
DA1A   671E                      BEQ       L1968
DA1C   242B 0008                 Move.L    $8(A3), D2
DA20   D493                      Add.L     (A3), D2
DA22   2742 0004                 Move.L    D2, $4(A3)
DA26   202B 000C                 Move.L    $C(A3), D0
DA2A   220B                      Move.L    A3, D1
DA2C   6100 04C2                 Bsr       P389
DA30   7010                      MoveQ.L   $10, D0
DA32   6100 04BA                 Bsr       P388
DA36   6100 04CA                 Bsr       P390
DA3A   7002           L1968:     MoveQ.L   $2, D0
DA3C   6000 02BC                 Bra       L2011

                      P_tCloseResFile:
DA40   4A6F 0004                 Tst       $4(A7)
DA44   6604                      BNE       L1969
DA46   6100 FDFE                 Bsr       P356
DA4A   6100 FEBE      L1969:     Bsr       P358
DA4E   3F06                      Move      D6, -(A7)
DA50   A999                      _UpdateResFile
DA52   6100 0258                 Bsr       P369
DA56   4A2A 0004      L1970:     Tst.B     $4(A2)
DA5A   6B0A                      BMI       L1971
DA5C   202A 0008                 Move.L    $8(A2), D0
DA60   6704                      BEQ       L1971
DA62   2F00                      Move.L    D0, -(A7)
DA64   A9A3                      _ReleaseResource
DA66   6100 0318      L1971:     Bsr       P377
DA6A   6AEA                      BPL       L1970
DA6C   6100 01F6                 Bsr       P366
DA70   206B 0010                 Move.L    $10(A3), A0
DA74   4A80                      Tst.L     D0
DA76   6606                      BNE       L1972
DA78   21C8 0A50                 Move.L    A0, (TopMapHndl)
DA7C   6008                      Bra       L1973
DA7E   2240           L1972:     Move.L    D0, A1
DA80   2251                      Move.L    (A1), A1
DA82   2348 0010                 Move.L    A0, $10(A1)
DA86   B9F8 0A54      L1973:     CmpA.L    (SysMapHndl), A4
DA8A   660E                      BNE       L1974
DA8C   41F8 0A50                 Lea.L     (TopMapHndl), A0
DA90   4298                      Clr.L     (A0)+
DA92   4298                      Clr.L     (A0)+
DA94   50D8                      ST.B      (A0)+
DA96   50D8                      ST.B      (A0)+
DA98   600E                      Bra       L1975
DA9A   BC78 0A5A      L1974:     Cmp       (CurMap), D6
DA9E   6608                      BNE       L1975
DAA0   2050                      Move.L    (A0), A0
DAA2   31E8 0014 0A5A            Move      $14(A0), (CurMap)
DAA8   6100 0420      L1975:     Bsr       P386
DAAC   A001                      _Close
DAAE   31C0 0A60                 Move      D0, (ResErr)
DAB2   204C                      Move.L    A4, A0
DAB4   A023                      _DisposeHandle
DAB6   6082                      Bra       L1968

                      P_tSetResPurge:
DAB8   2078 02AA                 Move.L    (ApplZone), A0
DABC   201F                      Move.L    (A7)+, D0
DABE   4A1F                      Tst.B     (A7)+
DAC0   487A 000E                 Pea.L     E_580
DAC4   6602                      BNE       L1976
DAC6   4297                      Clr.L     (A7)
DAC8   215F 0028      L1976:     Move.L    (A7)+, $28(A0)
DACC   2F00                      Move.L    D0, -(A7)
DACE   4E75                      Rts

                      E_580:
DAD0   225F                      Move.L    (A7)+, A1
DAD2   205F                      Move.L    (A7)+, A0
DAD4   0810 0005                 BTst.B    $5, (A0)
DAD8   6704                      BEQ       L1977
DADA   2F08                      Move.L    A0, -(A7)
DADC   A9B0                      _WriteResource
DADE   4ED1           L1977:     Jmp       (A1)

                      P_tSetResLoad:
DAE0   205F                      Move.L    (A7)+, A0
DAE2   11DF 0A5E                 Move.B    (A7)+, (ResLoad)
DAE6   4ED0                      Jmp       (A0)

                      P_tCountResources:
DAE8   6100 01FA                 Bsr       P373
DAEC   2210                      Move.L    (A0), D1
DAEE   7E00                      MoveQ.L   $0, D7
DAF0   610A                      Bsr       P362
DAF2   4447                      Neg       D7
DAF4   3D47 000C                 Move      D7, $C(A6)
DAF8   6000 05B4                 Bra       L2052

                      P362:
DAFC   6100 0156                 Bsr       P364
DB00   2601           L1978:     Move.L    D1, D3
DB02   6100 01C0                 Bsr       P371
DB06   6B14                      BMI       L1981
DB08   6100 01CA                 Bsr       P372
DB0C   4A2A 0004      L1979:     Tst.B     $4(A2)
DB10   6B04                      BMI       L1980
DB12   5347                      SubQ.L    $1, D7
DB14   670C                      BEQ       L1982
DB16   6100 0268      L1980:     Bsr       P377
DB1A   67F0                      BEQ       L1979
DB1C   6100 0170      L1981:     Bsr       P367
DB20   67DE                      BEQ       L1978
DB22   4E75           L1982:     Rts

                      P_tGetIndResource:
DB24   6100 01BE                 Bsr       P373
DB28   3E18                      Move      (A0)+, D7
DB2A   6F10                      BLE       L1984
DB2C   2218                      Move.L    (A0)+, D1
DB2E   4298                      Clr.L     (A0)+
DB30   61CA                      Bsr       P362
DB32   6B08                      BMI       L1984
DB34   6100 026A      L1983:     Bsr       P378
DB38   2D48 000E                 Move.L    A0, $E(A6)
DB3C   7006           L1984:     MoveQ.L   $6, D0
DB3E   600E                      Bra       L1986

                      P_tCountTypes:
DB40   6100 01A2                 Bsr       P373
DB44   610C                      Bsr       P363
DB46   4E5E                      Unlk      A6
DB48   3D47 0008                 Move      D7, $8(A6)
DB4C   7000           L1985:     MoveQ.L   $0, D0
DB4E   6000 01AA      L1986:     Bra       L2011

                      P363:
DB52   205F                      Move.L    (A7)+, A0
DB54   4E56 0000                 Link      A6, $0
DB58   7E00                      MoveQ.L   $0, D7
DB5A   6100 00F8                 Bsr       P364
DB5E   6100 0140      L1987:     Bsr       P368
DB62   6B1C                      BMI       L1992
DB64   2612           L1988:     Move.L    (A2), D3
DB66   224F                      Move.L    A7, A1
DB68   3007                      Move      D7, D0
DB6A   5340                      SubQ.L    $1, D0
DB6C   6B08                      BMI       L1990
DB6E   B699           L1989:     Cmp.L     (A1)+, D3
DB70   6708                      BEQ       L1991
DB72   51C8 FFFA                 DBF       D0, L1989
DB76   2F03           L1990:     Move.L    D3, -(A7)
DB78   5247                      AddQ      $1, D7
DB7A   508A           L1991:     AddQ      $8, A2
DB7C   51CD FFE6                 DBF       D5, L1988
DB80   6100 010C      L1992:     Bsr       P367
DB84   67D8                      BEQ       L1987
DB86   4ED0                      Jmp       (A0)

                      P_tGetIndType:
DB88   6100 015A                 Bsr       P373
DB8C   3418                      Move      (A0)+, D2
DB8E   2210                      Move.L    (A0), D1
DB90   61C0                      Bsr       P363
DB92   2041                      Move.L    D1, A0
DB94   4290                      Clr.L     (A0)
DB96   5342                      SubQ.L    $1, D2
DB98   6B0A                      BMI       L1993
DB9A   BE42                      Cmp       D2, D7
DB9C   6F06                      BLE       L1993
DB9E   E542                      AsL       $2, D2
DBA0   20B7 2000                 Move.L    $0(A7,D2.W), (A0)
DBA4   4E5E           L1993:     Unlk      A6
DBA6   6094                      Bra       L1984

                      P_tUniqueID:
DBA8   6100 013A                 Bsr       P373
DBAC   3E38 016C                 Move      (Ticks.LoWord), D7
DBB0   6100 00A2      L1994:     Bsr       P364
DBB4   554F                      SubQ.L    $2, A7
DBB6   A861                      _Random
DBB8   DE5F                      Add       (A7)+, D7
DBBA   0247 7FFF                 And       $7FFF, D7
DBBE   262E 0008                 Move.L    $8(A6), D3
DBC2   3407                      Move      D7, D2
DBC4   6100 00FE      L1995:     Bsr       P371
DBC8   6B0A                      BMI       L1996
DBCA   6100 0108                 Bsr       P372
DBCE   6100 00E6                 Bsr       P370
DBD2   67DC                      BEQ       L1994
DBD4   6100 00B8      L1996:     Bsr       P367
DBD8   67EA                      BEQ       L1995
DBDA   3D42 000C                 Move      D2, $C(A6)
DBDE   6000 04CE                 Bra       L2052

                      P_tGetResource:
DBE2   6100 0100                 Bsr       P373
DBE6   6100 0078                 Bsr       P365
DBEA   3418                      Move      (A0)+, D2
DBEC   2618                      Move.L    (A0)+, D3
DBEE   4290                      Clr.L     (A0)
DBF0   6100 00D2      L1997:     Bsr       P371
DBF4   6B0C                      BMI       L1998
DBF6   6100 00DC                 Bsr       P372
DBFA   6100 00BA                 Bsr       P370
DBFE   6700 FF34                 BEQ       L1983
DC02   6100 008A      L1998:     Bsr       P367
DC06   67E8                      BEQ       L1997
DC08   6000 FF32                 Bra       L1984

                      P_tGetNamedResource:
DC0C   6100 00D6                 Bsr       P373
DC10   614E                      Bsr       P365
DC12   2250                      Move.L    (A0), A1
DC14   42AE 0010                 Clr.L     $10(A6)
DC18   262E 000C      L1999:     Move.L    $C(A6), D3
DC1C   6100 00A6                 Bsr       P371
DC20   6B1E                      BMI       L2002
DC22   6100 00B0                 Bsr       P372
DC26   6100 0140      L2000:     Bsr       P376
DC2A   6B0E                      BMI       L2001
DC2C   7000                      MoveQ.L   $0, D0
DC2E   1018                      Move.B    (A0)+, D0
DC30   4840                      Swap      D0
DC32   1019                      Move.B    (A1)+, D0
DC34   A03C                      _CmpString
DC36   5349                      SubQ.L    $1, A1
DC38   670C                      BEQ       L2003
DC3A   6100 0144      L2001:     Bsr       P377
DC3E   67E6                      BEQ       L2000
DC40   614C           L2002:     Bsr       P367
DC42   67D4                      BEQ       L1999
DC44   6008                      Bra       L2004
DC46   6100 0158      L2003:     Bsr       P378
DC4A   2D48 0010                 Move.L    A0, $10(A6)
DC4E   7008           L2004:     MoveQ.L   $8, D0
DC50   6000 00A8                 Bra       L2011

                      P364:
DC54   2878 0A50                 Move.L    (TopMapHndl), A4
DC58   2654                      Move.L    (A4), A3
DC5A   3C2B 0014                 Move      $14(A3), D6
DC5E   602A                      Bra       L2008

                      P365:
DC60   3C38 0A5A                 Move      (CurMap), D6

                      P366:
DC64   4A46                      Tst       D6
DC66   6B00 00AE                 BMI       L2013
DC6A   6604                      BNE       L2005
DC6C   3C38 0A58                 Move      (SysMap), D6
DC70   2878 0A50      L2005:     Move.L    (TopMapHndl), A4
DC74   7000                      MoveQ.L   $0, D0
DC76   600A                      Bra       L2007
DC78   202B 0010      L2006:     Move.L    $10(A3), D0
DC7C   6700 0098                 BEQ       L2013
DC80   C18C                      Exg.L     D0, A4
DC82   2654           L2007:     Move.L    (A4), A3
DC84   BC6B 0014                 Cmp       $14(A3), D6
DC88   66EE                      BNE       L2006
DC8A   244B           L2008:     Move.L    A3, A2
DC8C   4E75                      Rts

                      P367:
DC8E   2654                      Move.L    (A4), A3
DC90   286B 0010                 Move.L    $10(A3), A4
DC94   200C                      Move.L    A4, D0
DC96   677E                      BEQ       L2013
DC98   2654                      Move.L    (A4), A3
DC9A   3C2B 0014                 Move      $14(A3), D6
DC9E   6040                      Bra       L2010

                      P368:
DCA0   2654                      Move.L    (A4), A3
DCA2   D6EB 0018                 AddA      $18(A3), A3
DCA6   244B                      Move.L    A3, A2
DCA8   3A1A                      Move      (A2)+, D5
DCAA   4E75                      Rts

                      P369:
DCAC   61F2                      Bsr       P368
DCAE   2612                      Move.L    (A2), D3
DCB0   6122                      Bsr       P372
DCB2   4A45                      Tst       D5
DCB4   4E75                      Rts

                      P370:
DCB6   B452                      Cmp       (A2), D2
DCB8   6726                      BEQ       L2010
DCBA   D4FC 000C                 AddA      $C, A2
DCBE   51CC FFF6                 DBF       D4, P370
DCC2   6052                      Bra       L2013

                      P371:
DCC4   61DA                      Bsr       P368
DCC6   6B4E                      BMI       L2013
DCC8   B692           L2009:     Cmp.L     (A2), D3
DCCA   6714                      BEQ       L2010
DCCC   504A                      AddQ      $8, A2
DCCE   51CD FFF8                 DBF       D5, L2009
DCD2   6042                      Bra       L2013

                      P372:
DCD4   382A 0004                 Move      $4(A2), D4
DCD8   346A 0006                 Move      $6(A2), A2
DCDC   D5CB                      AddA.L    A3, A2
DCDE   4E75                      Rts
DCE0   7000           L2010:     MoveQ.L   $0, D0
DCE2   4E75                      Rts

                      P373:
DCE4   4278 0A60                 Clr       (ResErr)
DCE8   205F                      Move.L    (A7)+, A0
DCEA   4E56 FFCE                 Link      A6, $-32
DCEE   48E7 7F78                 MoveM.L   D1-D7/A1-A4, -(A7)
DCF2   2F08                      Move.L    A0, -(A7)
DCF4   41EE 0008                 Lea.L     $8(A6), A0
DCF8   4E75                      Rts
DCFA   4CDF 1EFE      L2011:     MoveM.L   (A7)+, D1-D7/A1-A4
DCFE   4E5E                      Unlk      A6
DD00   205F                      Move.L    (A7)+, A0
DD02   DFC0                      AddA.L    D0, A7
DD04   2F08                      Move.L    A0, -(A7)
DD06   3038 0A60                 Move      (ResErr), D0
DD0A   6708                      BEQ       L2012
DD0C   2F38 0AF2                 Move.L    (ResErrProc), -(A7)
DD10   6602                      BNE       L2012
DD12   584F                      AddQ      $4, A7
DD14   4E75           L2012:     Rts
DD16   70FF           L2013:     MoveQ.L   $-1, D0
DD18   4E75                      Rts

                      P374:
DD1A   6126                      Bsr       P375
DD1C   6BF8                      BMI       L2013
DD1E   BC78 0A58                 Cmp       (SysMap), D6
DD22   66F2                      BNE       L2013
DD24   3412                      Move      (A2), D2
DD26   6100 FF38                 Bsr       P365
DD2A   6198                      Bsr       P371
DD2C   6BE8                      BMI       L2013
DD2E   61A4                      Bsr       P372
DD30   4A2A 0004      L2014:     Tst.B     $4(A2)
DD34   6A06                      BPL       L2015
DD36   B46A 0008                 Cmp       $8(A2), D2
DD3A   67A4                      BEQ       L2010
DD3C   6142           L2015:     Bsr       P377
DD3E   67F0                      BEQ       L2014
DD40   60D4                      Bra       L2013

                      P375:
DD42   2009                      Move.L    A1, D0
DD44   67D0                      BEQ       L2013
DD46   6100 FF0C                 Bsr       P364
DD4A   6100 FF60      L2016:     Bsr       P369
DD4E   6B10                      BMI       L2019
DD50   4A2A 0004      L2017:     Tst.B     $4(A2)
DD54   6B06                      BMI       L2018
DD56   B3EA 0008                 CmpA.L    $8(A2), A1
DD5A   6784                      BEQ       L2010
DD5C   6122           L2018:     Bsr       P377
DD5E   6AF0                      BPL       L2017
DD60   6100 FF2C      L2019:     Bsr       P367
DD64   67E4                      BEQ       L2016
DD66   60AE                      Bra       L2013

                      P376:
DD68   302A 0002                 Move      $2(A2), D0
DD6C   6B0C                      BMI       L2020
DD6E   2054                      Move.L    (A4), A0
DD70   D0E8 001A                 AddA      $1A(A0), A0
DD74   D0C0                      AddA      D0, A0
DD76   6000 FF68                 Bra       L2010
DD7A   41FA F9A8      L2020:     Lea.L     DT55, A0
DD7E   6096                      Bra       L2013

                      P377:
DD80   D4FC 000C                 AddA      $C, A2
DD84   5344                      SubQ.L    $1, D4
DD86   6A00 FF58                 BPL       L2010
DD8A   5345                      SubQ.L    $1, D5
DD8C   6B88                      BMI       L2013
DD8E   3013                      Move      (A3), D0
DD90   9045                      Sub       D5, D0
DD92   E740                      AsL       $3, D0
DD94   2633 0002                 Move.L    $2(A3,D0.W), D3
DD98   3833 0006                 Move      $6(A3,D0.W), D4
DD9C   7001                      MoveQ.L   $1, D0
DD9E   4E75                      Rts

                      P378:
DDA0   122A 0004                 Move.B    $4(A2), D1
DDA4   6A32                      BPL       L2022
DDA6   6120                      Bsr       P379
DDA8   504A                      AddQ      $8, A2
DDAA   3212                      Move      (A2), D1
DDAC   61BA                      Bsr       P376
DDAE   6B0E                      BMI       L2021
DDB0   594F                      SubQ.L    $4, A7
DDB2   2F03                      Move.L    D3, -(A7)
DDB4   2F08                      Move.L    A0, -(A7)
DDB6   A9A1                      _GetNamedResource
DDB8   205F                      Move.L    (A7)+, A0
DDBA   2008                      Move.L    A0, D0
DDBC   660A                      BNE       P379
DDBE   594F           L2021:     SubQ.L    $4, A7
DDC0   2F03                      Move.L    D3, -(A7)
DDC2   3F01                      Move      D1, -(A7)
DDC4   A9A0                      _GetResource
DDC6   205F                      Move.L    (A7)+, A0

                      P379:
DDC8   3038 0A5A                 Move      (CurMap), D0
DDCC   31F8 0A58 0A5A            Move      (SysMap), (CurMap)
DDD2   31C0 0A58                 Move      D0, (SysMap)
DDD6   4E75                      Rts
DDD8   2F38 0118      L2022:     Move.L    (TheZone), -(A7)
DDDC   0801 0006                 BTst.B    $6, D1
DDE0   6706                      BEQ       L2023
DDE2   21F8 02A6 0118            Move.L    (SysZone), (TheZone)
DDE8   206A 0008      L2023:     Move.L    $8(A2), A0
DDEC   97D4                      SubA.L    (A4), A3
DDEE   4A38 0A5E                 Tst.B     (ResLoad)
DDF2   6742                      BEQ       L2028
DDF4   2008                      Move.L    A0, D0
DDF6   661A                      BNE       L2025
DDF8   6106                      Bsr       P380
DDFA   A122                      _NewHandle
DDFC   671E                      BEQ       L2026
DDFE   602E                      Bra       L2027

                      P380:
DE00   6166                      Bsr       P382
DE02   95D4                      SubA.L    (A4), A2
DE04   0801 0004                 BTst.B    $4, D1
DE08   6706                      BEQ       L2024
DE0A   2400                      Move.L    D0, D2
DE0C   A040                      _ResrvMem
DE0E   2002                      Move.L    D2, D0
DE10   4E75           L2024:     Rts
DE12   4A90           L2025:     Tst.L     (A0)
DE14   662E                      BNE       L2030
DE16   61E8                      Bsr       P380
DE18   A027                      _ReallocHandle
DE1A   6B12                      BMI       L2027
DE1C   D5D4           L2026:     AddA.L    (A4), A2
DE1E   2548 0008                 Move.L    A0, $8(A2)
DE22   615A                      Bsr       P383
DE24   612E                      Bsr       P381
DE26   3038 0A60                 Move      (ResErr), D0
DE2A   6718                      BEQ       L2030
DE2C   95D4                      SubA.L    (A4), A2
DE2E   31C0 0A60      L2027:     Move      D0, (ResErr)
DE32   91C8                      SubA.L    A0, A0
DE34   600C                      Bra       L2029
DE36   2008           L2028:     Move.L    A0, D0
DE38   660A                      BNE       L2030
DE3A   95D4                      SubA.L    (A4), A2
DE3C   7004                      MoveQ.L   $4, D0
DE3E   A122                      _NewHandle
DE40   A02B                      _EmptyHandle
DE42   D5D4           L2029:     AddA.L    (A4), A2
DE44   2008           L2030:     Move.L    A0, D0
DE46   6704                      BEQ       L2031
DE48   2548 0008                 Move.L    A0, $8(A2)
DE4C   D7D4           L2031:     AddA.L    (A4), A3
DE4E   21DF 0118                 Move.L    (A7)+, (TheZone)
DE52   4E75                      Rts

                      P381:
DE54   E709                      LsL.B     $3, D1
DE56   6A04                      BPL       L2032
DE58   7281                      MoveQ.L   $-7F, D1
DE5A   6002                      Bra       L2033
DE5C   7280           L2032:     MoveQ.L   $-80, D1
DE5E   E411           L2033:     RXR.B     $2, D1
DE60   0210 001F                 And.B     $1F, (A0)
DE64   8310                      Or.B      D1, (A0)
DE66   4E75                      Rts

                      P382:
DE68   48E7 60C0                 MoveM.L   D1-D2/A0-A1, -(A7)
DE6C   6124                      Bsr       P384
DE6E   598F                      SubQ.L    $4, A7
DE70   220F                      Move.L    A7, D1
DE72   7004                      MoveQ.L   $4, D0
DE74   616E                      Bsr       P387
DE76   201F                      Move.L    (A7)+, D0
DE78   4CDF 0306                 MoveM.L   (A7)+, D1-D2/A0-A1
DE7C   4E75                      Rts

                      P383:
DE7E   48E7 E0C0                 MoveM.L   D0-D2/A0-A1, -(A7)
DE82   610E                      Bsr       P384
DE84   61E2                      Bsr       P382
DE86   5882                      AddQ      $4, D2
DE88   2211                      Move.L    (A1), D1
DE8A   6158                      Bsr       P387
DE8C   4CDF 0307      L2034:     MoveM.L   (A7)+, D0-D2/A0-A1
DE90   4E75                      Rts

                      P384:
DE92   022A 00FD 0004            And.B     $-3, $4(A2)
DE98   2054                      Move.L    (A4), A0
DE9A   242A 0004                 Move.L    $4(A2), D2
DE9E   C4B8 031A                 And.L     (Lo3Bytes), D2
DEA2   D490                      Add.L     (A0), D2
DEA4   226A 0008                 Move.L    $8(A2), A1
DEA8   4E75                      Rts

                      P385:
DEAA   48E7 E0C0                 MoveM.L   D0-D2/A0-A1, -(A7)
DEAE   61E2                      Bsr       P384
DEB0   2049                      Move.L    A1, A0
DEB2   A025                      _GetHandleSize
DEB4   6A02                      BPL       L2035
DEB6   7000                      MoveQ.L   $0, D0
DEB8   2F00           L2035:     Move.L    D0, -(A7)
DEBA   220F                      Move.L    A7, D1
DEBC   7004                      MoveQ.L   $4, D0
DEBE   6130                      Bsr       P389
DEC0   5882                      AddQ      $4, D2
DEC2   2211                      Move.L    (A1), D1
DEC4   201F                      Move.L    (A7)+, D0
DEC6   6128                      Bsr       P389
DEC8   60C2                      Bra       L2034

                      P386:
DECA   41EE FFE6                 Lea.L     $-1A(A6), A0
DECE   30C6                      Move      D6, (A0)+
DED0   5C48                      AddQ      $6, A0
DED2   20C1                      Move.L    D1, (A0)+
DED4   20C0                      Move.L    D0, (A0)+
DED6   5848                      AddQ      $4, A0
DED8   30FC 0001                 Move      $1, (A0)+
DEDC   20C2                      Move.L    D2, (A0)+
DEDE   41EE FFCE                 Lea.L     $-32(A6), A0
DEE2   4E75                      Rts

                      P387:
DEE4   48E7 80C0                 MoveM.L   D0/A0-A1, -(A7)
DEE8   61E0                      Bsr       P386
DEEA   A002                      _Read
DEEC   600A                      Bra       L2036

                      P388:
DEEE   7400                      MoveQ.L   $0, D2

                      P389:
DEF0   48E7 80C0                 MoveM.L   D0/A0-A1, -(A7)
DEF4   61D4                      Bsr       P386
DEF6   A003                      _Write
DEF8   31C0 0A60      L2036:     Move      D0, (ResErr)
DEFC   4CDF 0301      L2037:     MoveM.L   (A7)+, D0/A0-A1
DF00   4E75                      Rts

                      P390:
DF02   48E7 80C0                 MoveM.L   D0/A0-A1, -(A7)
DF06   6164                      Bsr       P395
DF08   66F2                      BNE       L2037
DF0A   61BE                      Bsr       P386
DF0C   2254                      Move.L    (A4), A1
DF0E   2029 0004                 Move.L    $4(A1), D0
DF12   D0A9 000C                 Add.L     $C(A1), D0
DF16   2140 001C                 Move.L    D0, $1C(A0)
DF1A   A012                      _SetEOF
DF1C   60DA                      Bra       L2036

                      P391:
DF1E   610E                      Bsr       P392
DF20   6100 FA5E                 Bsr       P361
DF24   6A22                      BPL       L2038
DF26   9280                      Sub.L     D0, D1
DF28   6F40                      BLE       L2040
DF2A   610E                      Bsr       P393
DF2C   6036                      Bra       L2039

                      P392:
DF2E   206A 0008                 Move.L    $8(A2), A0
DF32   A025                      _GetHandleSize
DF34   5840                      AddQ      $4, D0
DF36   2200                      Move.L    D0, D1
DF38   4E75                      Rts

                      P393:
DF3A   2054                      Move.L    (A4), A0
DF3C   5888                      AddQ      $4, A0
DF3E   D398                      Add.L     D1, (A0)+
DF40   2010                      Move.L    (A0), D0
DF42   D390                      Add.L     D1, (A0)
DF44   5188                      SubQ.L    $8, A0
DF46   4E75                      Rts
DF48   B280           L2038:     Cmp.L     D0, D1
DF4A   6F1E                      BLE       L2040
DF4C   2054                      Move.L    (A4), A0
DF4E   08E8 0006 0016            BSet.B    $6, $16(A0)

                      P394:
DF54   61D8                      Bsr       P392
DF56   61E2                      Bsr       P393
DF58   1F2A 0004                 Move.B    $4(A2), -(A7)
DF5C   2540 0004                 Move.L    D0, $4(A2)
DF60   155F 0004                 Move.B    (A7)+, $4(A2)
DF64   08E8 0005 0016 L2039:     BSet.B    $5, $16(A0)
DF6A   6096           L2040:     Bra       P390

                      P395:
DF6C   2054                      Move.L    (A4), A0
DF6E   0828 0007 0016            BTst.B    $7, $16(A0)
DF74   4E75                      Rts

                      P396:
DF76   48E7 E0C0                 MoveM.L   D0-D2/A0-A1, -(A7)
DF7A   97D4                      SubA.L    (A4), A3
DF7C   95D4                      SubA.L    (A4), A2
DF7E   7246                      MoveQ.L   $46, D1
DF80   E541                      AsL       $2, D1
DF82   204C                      Move.L    A4, A0
DF84   A025                      _GetHandleSize
DF86   2400                      Move.L    D0, D2
DF88   D081                      Add.L     D1, D0
DF8A   A024                      _SetHandleSize
DF8C   C142                      Exg.L     D0, D2
DF8E   A024                      _SetHandleSize
DF90   4A42                      Tst       D2
DF92   6B28                      BMI       L2042
DF94   61D6                      Bsr       P395
DF96   6624                      BNE       L2042
DF98   2009                      Move.L    A1, D0
DF9A   670A                      BEQ       L2041
DF9C   2049                      Move.L    A1, A0
DF9E   A025                      _GetHandleSize
DFA0   2400                      Move.L    D0, D2
DFA2   6B18                      BMI       L2042
DFA4   D280                      Add.L     D0, D1
DFA6   6100 FF22      L2041:     Bsr       P386
DFAA   43E8 001C                 Lea.L     $1C(A0), A1
DFAE   A011                      _GetEOF
DFB0   2411                      Move.L    (A1), D2
DFB2   D391                      Add.L     D1, (A1)
DFB4   A012                      _SetEOF
DFB6   C142                      Exg.L     D0, D2
DFB8   2280                      Move.L    D0, (A1)
DFBA   A012                      _SetEOF
DFBC   31C2 0A60      L2042:     Move      D2, (ResErr)
DFC0   D7D4                      AddA.L    (A4), A3
DFC2   D5D4                      AddA.L    (A4), A2
DFC4   4CDF 0307                 MoveM.L   (A7)+, D0-D2/A0-A1
DFC8   4E75                      Rts

                      P_tLoadResource:
DFCA   48E7 8080                 MoveM.L   D0/A0, -(A7)
DFCE   487A 0030                 Pea.L     E_590
DFD2   6100 FD10                 Bsr       P373
DFD6   226E 0014                 Move.L    $14(A6), A1
DFDA   4A91                      Tst.L     (A1)
DFDC   661E                      BNE       L2044
DFDE   6100 FD62                 Bsr       P375
DFE2   6708                      BEQ       L2043
DFE4   31FC FF40 0A60            Move      $-C0, (ResErr)
DFEA   6010                      Bra       L2044
DFEC   1F38 0A5E      L2043:     Move.B    (ResLoad), -(A7)
DFF0   50F8 0A5E                 ST.B      (ResLoad)
DFF4   6100 FDAA                 Bsr       P378
DFF8   11DF 0A5E                 Move.B    (A7)+, (ResLoad)
DFFC   6000 FB4E      L2044:     Bra       L1985

                      E_590:
E000   4CDF 0101                 MoveM.L   (A7)+, D0/A0
E004   2E9F                      Move.L    (A7)+, (A7)
E006   4E75                      Rts

                      P_tReleaseResource:
E008   615C                      Bsr       P397
E00A   082A 0001 0004            BTst.B    $1, $4(A2)
E010   6618                      BNE       L2046
E012   2049                      Move.L    A1, A0
E014   A023                      _DisposeHandle
E016   600E                      Bra       L2045

                      P_tDetachResource:
E018   614C                      Bsr       P397
E01A   082A 0001 0004            BTst.B    $1, $4(A2)
E020   6608                      BNE       L2046
E022   0891 0005                 BClr.B    $5, (A1)
E026   42AA 0008      L2045:     Clr.L     $8(A2)
E02A   6022           L2046:     Bra       L2048

                      P_tChangedResource:
E02C   6138                      Bsr       P397
E02E   1E11                      Move.B    (A1), D7
E030   0891 0006                 BClr.B    $6, (A1)
E034   082A 0003 0004            BTst.B    $3, $4(A2)
E03A   6610                      BNE       L2047
E03C   6100 FF38                 Bsr       P396
E040   6B0A                      BMI       L2047
E042   08EA 0001 0004            BSet.B    $1, $4(A2)
E048   6100 FED4                 Bsr       P391
E04C   1287           L2047:     Move.B    D7, (A1)
E04E   605E           L2048:     Bra       L2052

                      P_tWriteResource:
E050   6114                      Bsr       P397
E052   6100 FF18                 Bsr       P395
E056   660C                      BNE       L2049
E058   082A 0001 0004            BTst.B    $1, $4(A2)
E05E   6704                      BEQ       L2049
E060   6100 FE48                 Bsr       P385
E064   6048           L2049:     Bra       L2052

                      P397:
E066   201F                      Move.L    (A7)+, D0
E068   6100 FC7A                 Bsr       P373
E06C   2F00                      Move.L    D0, -(A7)
E06E   2250                      Move.L    (A0), A1
E070   6100 FCD0                 Bsr       P375
E074   6726                      BEQ       L2051
E076   584F                      AddQ      $4, A7
E078   31FC FF40 0A60            Move      $-C0, (ResErr)
E07E   602E                      Bra       L2052

                      P_tHomeResFile:
E080   3F78 0A06 0008            Move      (MinusOne), $8(A7)
E086   61DE                      Bsr       P397
E088   BC78 0A58                 Cmp       (SysMap), D6
E08C   6602                      BNE       L2050
E08E   7C00                      MoveQ.L   $0, D6
E090   3D46 000C      L2050:     Move      D6, $C(A6)
E094   6018                      Bra       L2052

                      P_tCurResFile:
E096   3F78 0A5A 0004            Move      (CurMap), $4(A7)
E09C   4E75           L2051:     Rts

                      P_tGetResAttrs:
E09E   6100 FC44                 Bsr       P373
E0A2   2250                      Move.L    (A0), A1
E0A4   6122                      Bsr       P398
E0A6   6B06                      BMI       L2052
E0A8   1D6A 0004 000D            Move.B    $4(A2), $D(A6)
E0AE   7004           L2052:     MoveQ.L   $4, D0
E0B0   6056                      Bra       L2057

                      P_tSetResAttrs:
E0B2   6100 FC30                 Bsr       P373
E0B6   226E 000A                 Move.L    $A(A6), A1
E0BA   610C                      Bsr       P398
E0BC   6B06                      BMI       L2053
E0BE   156E 0009 0004            Move.B    $9(A6), $4(A2)
E0C4   6000 FA76      L2053:     Bra       L1984

                      P398:
E0C8   6100 FC50                 Bsr       P374
E0CC   670C                      BEQ       L2054
E0CE   6100 FC72                 Bsr       P375
E0D2   6706                      BEQ       L2054
E0D4   31FC FF40 0A60            Move      $-C0, (ResErr)
E0DA   4E75           L2054:     Rts

                      P_tGetResInfo:
E0DC   6100 FC06                 Bsr       P373
E0E0   226E 0014                 Move.L    $14(A6), A1
E0E4   61E2                      Bsr       P398
E0E6   6706                      BEQ       L2055
E0E8   45F8 0A06                 Lea.L     (MinusOne), A2
E0EC   7600                      MoveQ.L   $0, D3
E0EE   41EE 0010      L2055:     Lea.L     $10(A6), A0
E0F2   2250                      Move.L    (A0), A1
E0F4   3292                      Move      (A2), (A1)
E0F6   2260                      Move.L    -(A0), A1
E0F8   2283                      Move.L    D3, (A1)
E0FA   2260                      Move.L    -(A0), A1
E0FC   4211                      Clr.B     (A1)
E0FE   6100 FC68                 Bsr       P376
E102   6B02                      BMI       L2056
E104   6106                      Bsr       P399
E106   7010           L2056:     MoveQ.L   $10, D0
E108   6000 FBF0      L2057:     Bra       L2011

                      P399:
E10C   7000                      MoveQ.L   $0, D0
E10E   1010                      Move.B    (A0), D0
E110   5280                      AddQ      $1, D0
E112   A02E                      _BlockMove
E114   4E75                      Rts

                      P_tSetResInfo:
E116   6100 FBCC                 Bsr       P373
E11A   226E 000E                 Move.L    $E(A6), A1
E11E   61A8                      Bsr       P398
E120   6B24                      BMI       L2058
E122   082A 0003 0004            BTst.B    $3, $4(A2)
E128   661C                      BNE       L2058
E12A   93C9                      SubA.L    A1, A1
E12C   6100 FE48                 Bsr       P396
E130   6B14                      BMI       L2058
E132   34AE 000C                 Move      $C(A6), (A2)
E136   202E 0008                 Move.L    $8(A6), D0
E13A   670A                      BEQ       L2058
E13C   2040                      Move.L    D0, A0
E13E   6100 0296                 Bsr       P406
E142   6100 01F8                 Bsr       P402
E146   700A           L2058:     MoveQ.L   $A, D0
E148   60BE                      Bra       L2057

                      P_tAddResource:
E14A   6100 FB98                 Bsr       P373
E14E   31FC FF3E 0A60            Move      $-C2, (ResErr)
E154   226E 0012                 Move.L    $12(A6), A1
E158   2009                      Move.L    A1, D0
E15A   673C                      BEQ       L2059
E15C   6100 FBE4                 Bsr       P375
E160   6736                      BEQ       L2059
E162   6100 FAFC                 Bsr       P365
E166   6100 FE0E                 Bsr       P396
E16A   6B2C                      BMI       L2059
E16C   262E 000E                 Move.L    $E(A6), D3
E170   612C                      Bsr       P400
E172   34EE 000C                 Move      $C(A6), (A2)+
E176   34F8 0A06                 Move      (MinusOne), (A2)+
E17A   24FC 0200 0000            Move.L    $2000000, (A2)+
E180   206E 0012                 Move.L    $12(A6), A0
E184   08D0 0005                 BSet.B    $5, (A0)
E188   2488                      Move.L    A0, (A2)
E18A   518A                      SubQ.L    $8, A2
E18C   206E 0008                 Move.L    $8(A6), A0
E190   6100 01AA                 Bsr       P402
E194   6100 FDBE                 Bsr       P394
E198   700E           L2059:     MoveQ.L   $E, D0
E19A   6000 FF6C                 Bra       L2057

                      P400:
E19E   08EB 0005 0016            BSet.B    $5, $16(A3)
E1A4   6100 FB1E                 Bsr       P371
E1A8   673C                      BEQ       L2061
E1AA   7014                      MoveQ.L   $14, D0
E1AC   6100 01C2                 Bsr       P403
E1B0   6100 FAEE                 Bsr       P368
E1B4   6B04                      BMI       L2060
E1B6   6100 FB1C                 Bsr       P372
E1BA   264A           L2060:     Move.L    A2, A3
E1BC   2454                      Move.L    (A4), A2
E1BE   D4EA 001A                 AddA      $1A(A2), A2
E1C2   94FC 0014                 SubA      $14, A2
E1C6   7008                      MoveQ.L   $8, D0
E1C8   204B                      Move.L    A3, A0
E1CA   224A                      Move.L    A2, A1
E1CC   6100 01F2                 Bsr       P405
E1D0   2054                      Move.L    (A4), A0
E1D2   D0E8 0018                 AddA      $18(A0), A0
E1D6   5250                      AddQ      $1, (A0)
E1D8   26C3                      Move.L    D3, (A3)+
E1DA   425B                      Clr       (A3)+
E1DC   93C8                      SubA.L    A0, A1
E1DE   3689                      Move      A1, (A3)
E1E0   508A                      AddQ      $8, A2
E1E2   3A18                      Move      (A0)+, D5
E1E4   602A                      Bra       P401
E1E6   700C           L2061:     MoveQ.L   $C, D0
E1E8   6100 0186                 Bsr       P403
E1EC   2254                      Move.L    (A4), A1
E1EE   D2E9 001A                 AddA      $1A(A1), A1
E1F2   92C0                      SubA      D0, A1
E1F4   6100 FACE                 Bsr       P371
E1F8   2F0A                      Move.L    A2, -(A7)
E1FA   526A 0004                 AddQ      $1, $4(A2)
E1FE   346A 0006                 Move      $6(A2), A2
E202   D5CB                      AddA.L    A3, A2
E204   204A                      Move.L    A2, A0
E206   700C                      MoveQ.L   $C, D0
E208   6100 01B6                 Bsr       P405
E20C   205F                      Move.L    (A7)+, A0
E20E   6004                      Bra       L2062

                      P401:
E210   D168 0006                 Add       D0, $6(A0)
E214   5048           L2062:     AddQ      $8, A0
E216   51CD FFF8                 DBF       D5, P401
E21A   4E75                      Rts

                      P_tAddReference:
E21C   6100 FAC6                 Bsr       P373
E220   31FC FF3D 0A60            Move      $-C3, (ResErr)
E226   3038 0A5A                 Move      (CurMap), D0
E22A   B078 0A58                 Cmp       (SysMap), D0
E22E   6754                      BEQ       L2064
E230   226E 000E                 Move.L    $E(A6), A1
E234   6100 FAE4                 Bsr       P374
E238   674A                      BEQ       L2064
E23A   6100 FB06                 Bsr       P375
E23E   6B44                      BMI       L2064
E240   BC78 0A58                 Cmp       (SysMap), D6
E244   663E                      BNE       L2064
E246   6100 FB20                 Bsr       P376
E24A   2F08                      Move.L    A0, -(A7)
E24C   3F12                      Move      (A2), -(A7)
E24E   6100 FA10                 Bsr       P365
E252   93C9                      SubA.L    A1, A1
E254   6100 FD20                 Bsr       P396
E258   6706                      BEQ       L2063
E25A   5C4F                      AddQ      $6, A7
E25C   6000 0026                 Bra       L2064
E260   6100 FF3C      L2063:     Bsr       P400
E264   206E 0008                 Move.L    $8(A6), A0
E268   6100 00D2                 Bsr       P402
E26C   34AE 000C                 Move      $C(A6), (A2)
E270   42AA 0004                 Clr.L     $4(A2)
E274   08EA 0007 0004            BSet.B    $7, $4(A2)
E27A   504A                      AddQ      $8, A2
E27C   349F                      Move      (A7)+, (A2)
E27E   205F                      Move.L    (A7)+, A0
E280   6100 00BA                 Bsr       P402
E284   6000 FEC0      L2064:     Bra       L2058

                      P_tRmveResource:
E288   6100 FA5A                 Bsr       P373
E28C   31FC FF3C 0A60            Move      $-C4, (ResErr)
E292   2250                      Move.L    (A0), A1
E294   6100 FAAC                 Bsr       P375
E298   6B6E                      BMI       L2068
E29A   082A 0003 0004            BTst.B    $3, $4(A2)
E2A0   6666                      BNE       L2068
E2A2   BC78 0A5A                 Cmp       (CurMap), D6
E2A6   6660                      BNE       L2068
E2A8   0891 0005                 BClr.B    $5, (A1)
E2AC   7060                      MoveQ.L   $60, D0
E2AE   2054           L2065:     Move.L    (A4), A0
E2B0   8128 0016                 Or.B      D0, $16(A0)
E2B4   6100 0120                 Bsr       P406
E2B8   7EF4                      MoveQ.L   $-C, D7
E2BA   204A                      Move.L    A2, A0
E2BC   90C7                      SubA      D7, A0
E2BE   6100 FA04                 Bsr       P371
E2C2   2254                      Move.L    (A4), A1
E2C4   D2E9 001A                 AddA      $1A(A1), A1
E2C8   2007                      Move.L    D7, D0
E2CA   6100 00F4                 Bsr       P405
E2CE   204A                      Move.L    A2, A0
E2D0   5048                      AddQ      $8, A0
E2D2   5345                      SubQ.L    $1, D5
E2D4   6B04                      BMI       L2066
E2D6   6100 FF38                 Bsr       P401
E2DA   536A 0004      L2066:     SubQ.L    $1, $4(A2)
E2DE   6A1E                      BPL       L2067
E2E0   504A                      AddQ      $8, A2
E2E2   204A                      Move.L    A2, A0
E2E4   D2C0                      AddA      D0, A1
E2E6   70F8                      MoveQ.L   $-8, D0
E2E8   DE80                      Add.L     D0, D7
E2EA   6100 00D4                 Bsr       P405
E2EE   2054                      Move.L    (A4), A0
E2F0   D0E8 0018                 AddA      $18(A0), A0
E2F4   5350                      SubQ.L    $1, (A0)
E2F6   3A18                      Move      (A0)+, D5
E2F8   6B04                      BMI       L2067
E2FA   6100 FF14                 Bsr       P401
E2FE   2007           L2067:     Move.L    D7, D0
E300   6100 006E                 Bsr       P403
E304   4278 0A60                 Clr       (ResErr)
E308   6000 FDA4      L2068:     Bra       L2052

                      P_tRmveReference:
E30C   6100 F9D6                 Bsr       P373
E310   31FC FF3B 0A60            Move      $-C5, (ResErr)
E316   2250                      Move.L    (A0), A1
E318   6100 FA00                 Bsr       P374
E31C   6BEA                      BMI       L2068
E31E   082A 0003 0004            BTst.B    $3, $4(A2)
E324   66E2                      BNE       L2068
E326   504A                      AddQ      $8, A2
E328   6100 00AC                 Bsr       P406
E32C   514A                      SubQ.L    $8, A2
E32E   7020                      MoveQ.L   $20, D0
E330   6000 FF7C                 Bra       L2065

                      P_tResError:
E334   3F78 0A60 0004            Move      (ResErr), $4(A7)
E33A   4E75                      Rts

                      P402:
E33C   48E7 E0C0                 MoveM.L   D0-D2/A0-A1, -(A7)
E340   74FF                      MoveQ.L   $-1, D2
E342   4A10                      Tst.B     (A0)
E344   6720                      BEQ       L2069
E346   2254                      Move.L    (A4), A1
E348   2229 000C                 Move.L    $C(A1), D1
E34C   2401                      Move.L    D1, D2
E34E   7000                      MoveQ.L   $0, D0
E350   1010                      Move.B    (A0), D0
E352   5280                      AddQ      $1, D0
E354   6100 0046                 Bsr       P404
E358   2254                      Move.L    (A4), A1
E35A   3029 001A                 Move      $1A(A1), D0
E35E   9440                      Sub       D0, D2
E360   D3C1                      AddA.L    D1, A1
E362   6100 FDA8                 Bsr       P399
E366   3542 0002      L2069:     Move      D2, $2(A2)
E36A   4CDF 0307                 MoveM.L   (A7)+, D0-D2/A0-A1
E36E   4E75                      Rts

                      P403:
E370   48E7 C0C0                 MoveM.L   D0-D1/A0-A1, -(A7)
E374   2054                      Move.L    (A4), A0
E376   2228 000C                 Move.L    $C(A0), D1
E37A   4A80                      Tst.L     D0
E37C   6B04                      BMI       L2070
E37E   611C                      Bsr       P404
E380   2054                      Move.L    (A4), A0
E382   2248           L2070:     Move.L    A0, A1
E384   D0E8 001A                 AddA      $1A(A0), A0
E388   D169 001A                 Add       D0, $1A(A1)
E38C   D3C1                      AddA.L    D1, A1
E38E   6130                      Bsr       P405
E390   4A80                      Tst.L     D0
E392   6A02                      BPL       L2071
E394   6106                      Bsr       P404
E396   4CDF 0303      L2071:     MoveM.L   (A7)+, D0-D1/A0-A1
E39A   4E75                      Rts

                      P404:
E39C   97D4                      SubA.L    (A4), A3
E39E   95D4                      SubA.L    (A4), A2
E3A0   48E7 8080                 MoveM.L   D0/A0, -(A7)
E3A4   2054                      Move.L    (A4), A0
E3A6   D0A8 000C                 Add.L     $C(A0), D0
E3AA   2140 000C                 Move.L    D0, $C(A0)
E3AE   204C                      Move.L    A4, A0
E3B0   A024                      _SetHandleSize
E3B2   6100 FB4E                 Bsr       P390
E3B6   4CDF 0101                 MoveM.L   (A7)+, D0/A0
E3BA   D7D4                      AddA.L    (A4), A3
E3BC   D5D4                      AddA.L    (A4), A2
E3BE   4E75                      Rts

                      P405:
E3C0   48E7 80C0                 MoveM.L   D0/A0-A1, -(A7)
E3C4   C189                      Exg.L     D0, A1
E3C6   9088                      Sub.L     A0, D0
E3C8   C0B8 031A                 And.L     (Lo3Bytes), D0
E3CC   D3C8                      AddA.L    A0, A1
E3CE   A02E                      _BlockMove
E3D0   4CDF 0301                 MoveM.L   (A7)+, D0/A0-A1
E3D4   4E75                      Rts

                      P406:
E3D6   48E7 E0C0                 MoveM.L   D0-D2/A0-A1, -(A7)
E3DA   342A 0002                 Move      $2(A2), D2
E3DE   6B4A                      BMI       L2075
E3E0   2054                      Move.L    (A4), A0
E3E2   2248                      Move.L    A0, A1
E3E4   D0E8 001A                 AddA      $1A(A0), A0
E3E8   D0C2                      AddA      D2, A0
E3EA   D3E9 000C                 AddA.L    $C(A1), A1
E3EE   7000                      MoveQ.L   $0, D0
E3F0   1010                      Move.B    (A0), D0
E3F2   5280                      AddQ      $1, D0
E3F4   D1C0                      AddA.L    D0, A0
E3F6   4480                      Neg.L     D0
E3F8   2200                      Move.L    D0, D1
E3FA   61C4                      Bsr       P405
E3FC   619E                      Bsr       P404
E3FE   48E7 1F38                 MoveM.L   D3-D7/A2-A4, -(A7)
E402   6100 F8A8                 Bsr       P369
E406   43EA 0002      L2072:     Lea.L     $2(A2), A1
E40A   102A 0004                 Move.B    $4(A2), D0
E40E   4A51           L2073:     Tst       (A1)
E410   6B06                      BMI       L2074
E412   B451                      Cmp       (A1), D2
E414   6C02                      BGE       L2074
E416   D351                      Add       D1, (A1)
E418   5049           L2074:     AddQ      $8, A1
E41A   0880 0007                 BClr.B    $7, D0
E41E   66EE                      BNE       L2073
E420   6100 F95E                 Bsr       P377
E424   6AE0                      BPL       L2072
E426   4CDF 1CF8                 MoveM.L   (A7)+, D3-D7/A2-A4
E42A   4CDF 0307      L2075:     MoveM.L   (A7)+, D0-D2/A0-A1
E42E   3578 0A06 0002            Move      (MinusOne), $2(A2)
E434   4E75                      Rts

                      DT_mMaxIAppend:
E436   000A 0014 002A            DC.B      '     *'
E43C   0034                      DC.B      ' 4'

                      DT57:
E43E   0000                      DC.B      '  '

                      P_tInitDialogs:
E440   6100 0340                 Bsr       P410
E444   21EE 0008 0A8C            Move.L    $8(A6), (ResumeProc)
E44A   4278 0A9A                 Clr       (ACount)
E44E   50F8 0A98                 ST.B      (ANumber)
E452   41F8 0A9C                 Lea.L     (DABeeper), A0
E456   43FA 0016                 Lea.L     E_607, A1
E45A   20C9                      Move.L    A1, (A0)+
E45C   4298                      Clr.L     (A0)+
E45E   4298                      Clr.L     (A0)+
E460   4298                      Clr.L     (A0)+
E462   4298                      Clr.L     (A0)+
E464   4278 0AFA                 Clr       (DlgFont)
E468   7004                      MoveQ.L   $4, D0
E46A   6000 0322                 Bra       L2103

                      E_607:
E46E   225F                      Move.L    (A7)+, A1
E470   341F                      Move      (A7)+, D2
E472   6736           L2076:     BEQ       L2079
E474   3F3C 0003                 Move      $3, -(A7)
E478   A9C8                      _SysBeep
E47A   307C 0006                 Move      $6, A0
E47E   A03B                      _Delay
E480   5342                      SubQ.L    $1, D2
E482   60EE                      Bra       L2076

                      E_608:
E484   4CDF 0306                 MoveM.L   (A7)+, D1-D2/A0-A1
E488   4257                      Clr       (A7)
E48A   0C50 0003                 Cmp       $3, (A0)
E48E   6618                      BNE       L2078
E490   0C28 0003 0005            Cmp.B     $3, $5(A0)
E496   6708                      BEQ       L2077
E498   0C28 000D 0005            Cmp.B     $D, $5(A0)
E49E   6608                      BNE       L2078
E4A0   2042           L2077:     Move.L    D2, A0
E4A2   30A9 00A8                 Move      $A8(A1), (A0)
E4A6   5217                      AddQ      $1, (A7)
E4A8   2241           L2078:     Move.L    D1, A1
E4AA   4ED1           L2079:     Jmp       (A1)

                      P_tStopAlert:
E4AC   7000                      MoveQ.L   $0, D0
E4AE   600A                      Bra       L2080

                      P_tNoteAlert:
E4B0   7001                      MoveQ.L   $1, D0
E4B2   6006                      Bra       L2080

                      P_tCautionAlert:
E4B4   7002                      MoveQ.L   $2, D0
E4B6   6002                      Bra       L2080

                      P_tAlert:
E4B8   70FF                      MoveQ.L   $-1, D0
E4BA   6100 02C6      L2080:     Bsr       P410
E4BE   3600                      Move      D0, D3
E4C0   302E 000C                 Move      $C(A6), D0
E4C4   6100 03A6                 Bsr       P414
E4C8   3038 0A9A                 Move      (ACount), D0
E4CC   322E 000C                 Move      $C(A6), D1
E4D0   B278 0A98                 Cmp       (ANumber), D1
E4D4   6706                      BEQ       L2081
E4D6   31C1 0A98                 Move      D1, (ANumber)
E4DA   7000                      MoveQ.L   $0, D0
E4DC   31C0 0A9A      L2081:     Move      D0, (ACount)
E4E0   3829 000A                 Move      $A(A1), D4
E4E4   5340           L2082:     SubQ.L    $1, D0
E4E6   6D04                      BLT       L2083
E4E8   E84C                      LsR       $4, D4
E4EA   60F8                      Bra       L2082
E4EC   0244 000F      L2083:     And       $F, D4
E4F0   2004                      Move.L    D4, D0
E4F2   0240 0003                 And       $3, D0
E4F6   6100 00C6                 Bsr       P408
E4FA   0804 0002                 BTst.B    $2, D4
E4FE   660A                      BNE       L2084
E500   3D78 0A06 000E            Move      (MinusOne), $E(A6)
E506   6000 008A                 Bra       L2086
E50A   203C 0000 01FF L2084:     Move.L    $1FF, D0
E510   A032                      _FlushEvents
E512   3029 0008                 Move      $8(A1), D0
E516   6100 0094                 Bsr       P407
E51A   2252                      Move.L    (A2), A1
E51C   594F                      SubQ.L    $4, A7
E51E   42A7                      Clr.L     -(A7)
E520   4851                      Pea.L     (A1)
E522   487A FF1A                 Pea.L     DT57
E526   50E7                      ST.B      -(A7)
E528   3F3C 0001                 Move      $1, -(A7)
E52C   2F38 0A06                 Move.L    (MinusOne), -(A7)
E530   4267                      Clr       -(A7)
E532   42A7                      Clr.L     -(A7)
E534   2F08                      Move.L    A0, -(A7)
E536   A97D                      _NewDialog
E538   2857                      Move.L    (A7), A4
E53A   486E FFD4                 Pea.L     $-2C(A6)
E53E   A874                      _GetPort
E540   A873                      _SetPort
E542   4A43                      Tst       D3
E544   6B12                      BMI       L2085
E546   594F                      SubQ.L    $4, A7
E548   3F03                      Move      D3, -(A7)
E54A   A9BB                      _GetIcon
E54C   201F                      Move.L    (A7)+, D0
E54E   6708                      BEQ       L2085
E550   487A FEE4                 Pea.L     DT_mMaxIAppend
E554   2F00                      Move.L    D0, -(A7)
E556   A94B                      _PlotIcon
E558   E644           L2085:     AsR       $3, D4
E55A   5244                      AddQ      $1, D4
E55C   3944 00A8                 Move      D4, $A8(A4)
E560   2F0C                      Move.L    A4, -(A7)
E562   3F04                      Move      D4, -(A7)
E564   486E FFC4                 Pea.L     $-3C(A6)
E568   2F17                      Move.L    (A7), -(A7)
E56A   486E FFD8                 Pea.L     $-28(A6)
E56E   A98D                      _GetDialogItem
E570   41EE FFD8                 Lea.L     $-28(A6), A0
E574   7003                      MoveQ.L   $3, D0
E576   7210                      MoveQ.L   $10, D1
E578   7404                      MoveQ.L   $4, D2
E57A   6100 0846                 Bsr       P425
E57E   2F2E 0008                 Move.L    $8(A6), -(A7)
E582   486E 000E                 Pea.L     $E(A6)
E586   A991                      _ModalDialog
E588   2F2E FFD4                 Move.L    $-2C(A6), -(A7)
E58C   A873                      _SetPort
E58E   2F0C                      Move.L    A4, -(A7)
E590   A983                      _DisposeDialog
E592   0892 0007      L2086:     BClr.B    $7, (A2)
E596   3238 0A9A                 Move      (ACount), D1
E59A   5241                      AddQ      $1, D1
E59C   0C41 0004                 Cmp       $4, D1
E5A0   6D02                      BLT       L2087
E5A2   7203                      MoveQ.L   $3, D1
E5A4   31C1 0A9A      L2087:     Move      D1, (ACount)
E5A8   7006                      MoveQ.L   $6, D0
E5AA   605E                      Bra       L2089

                      P407:
E5AC   594F                      SubQ.L    $4, A7
E5AE   2F3C 4449 544C            Move.L    $4449544C, -(A7)
E5B4   3F00                      Move      D0, -(A7)
E5B6   A9A0                      _GetResource
E5B8   205F                      Move.L    (A7)+, A0
E5BA   A9E1                      _HandToHand
E5BC   4E75                      Rts

                      P408:
E5BE   48E7 E0E0                 MoveM.L   D0-D2/A0-A2, -(A7)
E5C2   2238 0A9C                 Move.L    (DABeeper), D1
E5C6   6706                      BEQ       L2088
E5C8   3F00                      Move      D0, -(A7)
E5CA   2041                      Move.L    D1, A0
E5CC   4E90                      Jsr       (A0)
E5CE   4CDF 0707      L2088:     MoveM.L   (A7)+, D0-D2/A0-A2
E5D2   4E75                      Rts

                      P_tGetNewDialog:
E5D4   6100 01AC                 Bsr       P410
E5D8   302E 0010                 Move      $10(A6), D0
E5DC   6100 0296                 Bsr       P415
E5E0   594F                      SubQ.L    $4, A7
E5E2   2F2E 000C                 Move.L    $C(A6), -(A7)
E5E6   2F09                      Move.L    A1, -(A7)
E5E8   4869 0014                 Pea.L     $14(A1)
E5EC   5089                      AddQ      $8, A1
E5EE   2F19                      Move.L    (A1)+, -(A7)
E5F0   2F2E 0008                 Move.L    $8(A6), -(A7)
E5F4   3F19                      Move      (A1)+, -(A7)
E5F6   2F19                      Move.L    (A1)+, -(A7)
E5F8   3019                      Move      (A1)+, D0
E5FA   61B0                      Bsr       P407
E5FC   2F08                      Move.L    A0, -(A7)
E5FE   A97D                      _NewDialog
E600   0892 0007                 BClr.B    $7, (A2)
E604   2D5F 0012                 Move.L    (A7)+, $12(A6)
E608   700A                      MoveQ.L   $A, D0
E60A   607E           L2089:     Bra       L2091

                      P_tNewDialog:
E60C   6100 0174                 Bsr       P410
E610   4AAE 0022                 Tst.L     $22(A6)
E614   660C                      BNE       L2090
E616   203C 0000 00AA            Move.L    $AA, D0
E61C   A11E                      _NewPtr
E61E   2D48 0022                 Move.L    A0, $22(A6)
E622   41EE 000C      L2090:     Lea.L     $C(A6), A0
E626   701E                      MoveQ.L   $1E, D0
E628   9FC0                      SubA.L    D0, A7
E62A   224F                      Move.L    A7, A1
E62C   A02E                      _BlockMove
E62E   A913                      _NewWindow
E630   285F                      Move.L    (A7)+, A4
E632   2D4C 0026                 Move.L    A4, $26(A6)
E636   266E 0008                 Move.L    $8(A6), A3
E63A   397C 0002 006C            Move      $2, $6C(A4)
E640   294B 009C                 Move.L    A3, $9C(A4)
E644   3978 0A06 00A4            Move      (MinusOne), $A4(A4)
E64A   3978 0AFA 0044            Move      (DlgFont), $44(A4)
E650   594F                      SubQ.L    $4, A7
E652   2F0F                      Move.L    A7, -(A7)
E654   A874                      _GetPort
E656   2F0C                      Move.L    A4, -(A7)
E658   A873                      _SetPort
E65A   397C 0001 00A8            Move      $1, $A8(A4)
E660   594F                      SubQ.L    $4, A7
E662   486C 0010                 Pea.L     $10(A4)
E666   2F17                      Move.L    (A7), -(A7)
E668   A9D2                      _TENew
E66A   2957 00A0                 Move.L    (A7), $A0(A4)
E66E   225F                      Move.L    (A7)+, A1
E670   2451                      Move.L    (A1), A2
E672   206A 003E                 Move.L    $3E(A2), A0
E676   A023                      _DisposeHandle
E678   A873                      _SetPort
E67A   6100 015E                 Bsr       P411
E67E   7800                      MoveQ.L   $0, D4
E680   6100 0392                 Bsr       P417
E684   6100 018C                 Bsr       P412
E688   701E                      MoveQ.L   $1E, D0
E68A   6050           L2091:     Bra       L2095

                      P409:
E68C   3612                      Move      (A2), D3
E68E   5D43                      SubQ.L    $6, D3
E690   670C                      BEQ       L2092
E692   5543                      SubQ.L    $2, D3
E694   6708                      BEQ       L2092
E696   594F                      SubQ.L    $4, A7
E698   A924                      _FrontWindow
E69A   285F                      Move.L    (A7)+, A4
E69C   4E75                      Rts
E69E   286A 0002      L2092:     Move.L    $2(A2), A4
E6A2   4E75                      Rts

                      P_tIsDialogEvent:
E6A4   6100 00DC                 Bsr       P410
E6A8   426E 000C                 Clr       $C(A6)
E6AC   246E 0008                 Move.L    $8(A6), A2
E6B0   61DA                      Bsr       P409
E6B2   0C6C 0002 006C            Cmp       $2, $6C(A4)
E6B8   6620                      BNE       L2094
E6BA   3612                      Move      (A2), D3
E6BC   5343                      SubQ.L    $1, D3
E6BE   6616                      BNE       L2093
E6C0   554F                      SubQ.L    $2, A7
E6C2   2F2A 000A                 Move.L    $A(A2), -(A7)
E6C6   486E FFEC                 Pea.L     $-14(A6)
E6CA   A92C                      _FindWindow
E6CC   575F                      SubQ.L    $3, (A7)+
E6CE   660A                      BNE       L2094
E6D0   B9EE FFEC                 CmpA.L    $-14(A6), A4
E6D4   6604                      BNE       L2094
E6D6   522E 000C      L2093:     AddQ      $1, $C(A6)
E6DA   7004           L2094:     MoveQ.L   $4, D0
E6DC   603E           L2095:     Bra       L2097

                      P_tDialogSelect:
E6DE   6100 00A2                 Bsr       P410
E6E2   426E 0014                 Clr       $14(A6)
E6E6   266E 000C                 Move.L    $C(A6), A3
E6EA   4293                      Clr.L     (A3)
E6EC   246E 0010                 Move.L    $10(A6), A2
E6F0   619A                      Bsr       P409
E6F2   268C                      Move.L    A4, (A3)
E6F4   6100 00E4                 Bsr       P411
E6F8   206E 0010                 Move.L    $10(A6), A0
E6FC   43EE FFB4                 Lea.L     $-4C(A6), A1
E700   7010                      MoveQ.L   $10, D0
E702   A02E                      _BlockMove
E704   6100 054C                 Bsr       P421
E708   4A43                      Tst       D3
E70A   6B04                      BMI       L2096
E70C   522E 0014                 AddQ      $1, $14(A6)
E710   206E 0008      L2096:     Move.L    $8(A6), A0
E714   3083                      Move      D3, (A0)
E716   6100 00FA                 Bsr       P412
E71A   700C                      MoveQ.L   $C, D0
E71C   6052           L2097:     Bra       L2101

                      P_tModalDialog:
E71E   6100 0062                 Bsr       P410
E722   A9B4           L2098:     _SystemTask
E724   5D4F                      SubQ.L    $6, A7
E726   3F3C 01FF                 Move      $1FF, -(A7)
E72A   486E FFB4                 Pea.L     $-4C(A6)
E72E   A970                      _GetNextEvent
E730   262E 000C                 Move.L    $C(A6), D3
E734   6606                      BNE       L2099
E736   41FA FD4C                 Lea.L     E_608, A0
E73A   2608                      Move.L    A0, D3
E73C   A924           L2099:     _FrontWindow
E73E   486E FFB4                 Pea.L     $-4C(A6)
E742   2F2E 0008                 Move.L    $8(A6), -(A7)
E746   2043                      Move.L    D3, A0
E748   4E90                      Jsr       (A0)
E74A   4A1F                      Tst.B     (A7)+
E74C   6620                      BNE       L2100
E74E   554F                      SubQ.L    $2, A7
E750   486E FFB4                 Pea.L     $-4C(A6)
E754   A97F                      _IsDialogEvent
E756   4A5F                      Tst       (A7)+
E758   6718                      BEQ       L2102
E75A   554F                      SubQ.L    $2, A7
E75C   486E FFB4                 Pea.L     $-4C(A6)
E760   486E FFE4                 Pea.L     $-1C(A6)
E764   2F2E 0008                 Move.L    $8(A6), -(A7)
E768   A980                      _DialogSelect
E76A   4A5F                      Tst       (A7)+
E76C   6FB4                      BLE       L2098
E76E   7008           L2100:     MoveQ.L   $8, D0
E770   601C           L2101:     Bra       L2103
E772   302E FFB4      L2102:     Move      $-4C(A6), D0
E776   5340                      SubQ.L    $1, D0
E778   66A8                      BNE       L2098
E77A   7001                      MoveQ.L   $1, D0
E77C   6100 FE40                 Bsr       P408
E780   60A0                      Bra       L2098

                      P410:
E782   205F                      Move.L    (A7)+, A0
E784   4E56 FFB4                 Link      A6, $-4C
E788   48E7 1F38                 MoveM.L   D3-D7/A2-A4, -(A7)
E78C   4ED0                      Jmp       (A0)
E78E   4CDF 1CF8      L2103:     MoveM.L   (A7)+, D3-D7/A2-A4
E792   4E5E                      Unlk      A6
E794   205F                      Move.L    (A7)+, A0
E796   DFC0                      AddA.L    D0, A7
E798   4ED0                      Jmp       (A0)

                      P_tDrawDialog:
E79A   61E6                      Bsr       P410
E79C   286E 0008                 Move.L    $8(A6), A4
E7A0   6138                      Bsr       P411
E7A2   2F0C                      Move.L    A4, -(A7)
E7A4   A969                      _DrawControls
E7A6   7801                      MoveQ.L   $1, D4
E7A8   6100 026A                 Bsr       P417
E7AC   6164                      Bsr       P412
E7AE   6026                      Bra       L2104

                      P_tCloseDialog:
E7B0   61D0                      Bsr       P410
E7B2   286E 0008                 Move.L    $8(A6), A4
E7B6   6122                      Bsr       P411
E7B8   2F2C 001C                 Move.L    $1C(A4), -(A7)
E7BC   A8DD                      _SetEmptyRgn
E7BE   7802                      MoveQ.L   $2, D4
E7C0   6100 0252                 Bsr       P417
E7C4   614C                      Bsr       P412
E7C6   206C 00A0                 Move.L    $A0(A4), A0
E7CA   2050                      Move.L    (A0), A0
E7CC   206C 00A0                 Move.L    $A0(A4), A0
E7D0   A023                      _DisposeHandle
E7D2   2F0C                      Move.L    A4, -(A7)
E7D4   A92D                      _CloseWindow
E7D6   7004           L2104:     MoveQ.L   $4, D0
E7D8   60B4           L2105:     Bra       L2103

                      P411:
E7DA   486E FFD4                 Pea.L     $-2C(A6)
E7DE   A874                      _GetPort
E7E0   2F0C                      Move.L    A4, -(A7)
E7E2   A873                      _SetPort
E7E4   266C 009C                 Move.L    $9C(A4), A3
E7E8   08D3 0007                 BSet.B    $7, (A3)
E7EC   76FF                      MoveQ.L   $-1, D3
E7EE   342C 00A4                 Move      $A4(A4), D2
E7F2   6B0A                      BMI       L2107
E7F4   6100 04DC      L2106:     Bsr       P422
E7F8   51CA FFFA                 DBF       D2, L2106
E7FC   600E                      Bra       L2108
E7FE   6100 04D2      L2107:     Bsr       P422
E802   6718                      BEQ       L2109
E804   082A 0004 000C            BTst.B    $4, $C(A2)
E80A   67F2                      BEQ       L2107
E80C   74FE           L2108:     MoveQ.L   $-2, D2
E80E   6000 0570                 Bra       L2181

                      P412:
E812   0893 0007                 BClr.B    $7, (A3)
E816   2F2E FFD4                 Move.L    $-2C(A6), -(A7)
E81A   A873                      _SetPort
E81C   4E75           L2109:     Rts

                      P_tDisposeDialog:
E81E   206F 0004                 Move.L    $4(A7), A0
E822   2F28 009C                 Move.L    $9C(A0), -(A7)
E826   2F08                      Move.L    A0, -(A7)
E828   A982                      _CloseDialog
E82A   205F                      Move.L    (A7)+, A0
E82C   A023                      _DisposeHandle
E82E   225F                      Move.L    (A7)+, A1
E830   205F                      Move.L    (A7)+, A0
E832   A01F                      _DisposePtr
E834   4ED1                      Jmp       (A1)

                      P413:
E836   2052                      Move.L    (A2), A0
E838   594F                      SubQ.L    $4, A7
E83A   2F3C 4449 544C            Move.L    $4449544C, -(A7)
E840   3F28 0008                 Move      $8(A0), -(A7)
E844   A9A0           L2110:     _GetResource
E846   245F                      Move.L    (A7)+, A2
E848   4E75                      Rts

                      P_tCouldAlert:
E84A   6100 FF36                 Bsr       P410
E84E   302E 0008                 Move      $8(A6), D0
E852   6118                      Bsr       P414
E854   675C                      BEQ       L2112
E856   0212 003F                 And.B     $3F, (A2)
E85A   61DA                      Bsr       P413
E85C   0892 0006                 BClr.B    $6, (A2)
E860   264A                      Move.L    A2, A3
E862   78FE                      MoveQ.L   $-2, D4
E864   6152                      Bsr       P416
E866   0892 0006                 BClr.B    $6, (A2)
E86A   6046                      Bra       L2112

                      P414:
E86C   207C 414C 5254            Move.L    $414C5254, A0
E872   6006                      Bra       L2111

                      P415:
E874   207C 444C 4F47            Move.L    $444C4F47, A0
E87A   594F           L2111:     SubQ.L    $4, A7
E87C   2F08                      Move.L    A0, -(A7)
E87E   3F00                      Move      D0, -(A7)
E880   A9A0                      _GetResource
E882   2457                      Move.L    (A7), A2
E884   08D2 0007                 BSet.B    $7, (A2)
E888   2252                      Move.L    (A2), A1
E88A   4A9F                      Tst.L     (A7)+
E88C   4E75                      Rts

                      P_tFreeAlert:
E88E   6100 FEF2                 Bsr       P410
E892   302E 0008                 Move      $8(A6), D0
E896   61D4                      Bsr       P414
E898   6718                      BEQ       L2112
E89A   0892 0007                 BClr.B    $7, (A2)
E89E   6100 01FE                 Bsr       P419
E8A2   6192                      Bsr       P413
E8A4   6100 01F8                 Bsr       P419
E8A8   264A                      Move.L    A2, A3
E8AA   78FF                      MoveQ.L   $-1, D4
E8AC   610A                      Bsr       P416
E8AE   6100 01EE                 Bsr       P419
E8B2   7002           L2112:     MoveQ.L   $2, D0
E8B4   6000 FF22      L2113:     Bra       L2105

                      P416:
E8B8   08D3 0007                 BSet.B    $7, (A3)
E8BC   6100 0156                 Bsr       P417
E8C0   0893 0007                 BClr.B    $7, (A3)
E8C4   594F                      SubQ.L    $4, A7
E8C6   2F3C 5744 4546            Move.L    $57444546, -(A7)
E8CC   4267                      Clr       -(A7)
E8CE   6000 FF74                 Bra       L2110

                      P_tParamText:
E8D2   43F8 0AB0                 Lea.L     (TEScrpLength), A1
E8D6   7403                      MoveQ.L   $3, D2
E8D8   222F 0004      L2114:     Move.L    $4(A7), D1
E8DC   2061                      Move.L    -(A1), A0
E8DE   670E                      BEQ       L2116
E8E0   2008                      Move.L    A0, D0
E8E2   6702                      BEQ       L2115
E8E4   A023                      _DisposeHandle
E8E6   2041           L2115:     Move.L    D1, A0
E8E8   6100 04FA                 Bsr       P426
E8EC   2288                      Move.L    A0, (A1)
E8EE   2E9F           L2116:     Move.L    (A7)+, (A7)
E8F0   51CA FFE6                 DBF       D2, L2114
E8F4   4E75                      Rts

                      P_tErrorSound:
E8F6   205F                      Move.L    (A7)+, A0
E8F8   21DF 0A9C                 Move.L    (A7)+, (DABeeper)
E8FC   4ED0                      Jmp       (A0)

                      P_tGetDialogItem:
E8FE   6100 FE82                 Bsr       P410
E902   286E 0016                 Move.L    $16(A6), A4
E906   6100 FED2                 Bsr       P411
E90A   362E 0014                 Move      $14(A6), D3
E90E   5343                      SubQ.L    $1, D3
E910   6100 04E2                 Bsr       P427
E914   671C                      BEQ       L2117
E916   41EA 0004                 Lea.L     $4(A2), A0
E91A   226E 0008                 Move.L    $8(A6), A1
E91E   22D8                      Move.L    (A0)+, (A1)+
E920   22D8                      Move.L    (A0)+, (A1)+
E922   4CEE 0300 000C            MoveM.L   $C(A6), A0-A1
E928   2092                      Move.L    (A2), (A0)
E92A   7000                      MoveQ.L   $0, D0
E92C   102A 000C                 Move.B    $C(A2), D0
E930   3280                      Move      D0, (A1)
E932   6100 FEDE      L2117:     Bsr       P412
E936   7012                      MoveQ.L   $12, D0
E938   6000 FF7A      L2118:     Bra       L2113

                      P_tSetDialogItem:
E93C   6100 FE44                 Bsr       P410
E940   286E 0014                 Move.L    $14(A6), A4
E944   6100 FE94                 Bsr       P411
E948   362E 0012                 Move      $12(A6), D3
E94C   5343                      SubQ.L    $1, D3
E94E   6100 04A4                 Bsr       P427
E952   6716                      BEQ       L2119
E954   206E 0008                 Move.L    $8(A6), A0
E958   43EA 0004                 Lea.L     $4(A2), A1
E95C   22D8                      Move.L    (A0)+, (A1)+
E95E   22D8                      Move.L    (A0)+, (A1)+
E960   24AE 000C                 Move.L    $C(A6), (A2)
E964   156E 0011 000C            Move.B    $11(A6), $C(A2)
E96A   6100 FEA6      L2119:     Bsr       P412
E96E   7010                      MoveQ.L   $10, D0
E970   60C6           L2120:     Bra       L2118

                      P_tGetDialogItemText:
E972   7200                      MoveQ.L   $0, D1
E974   5301                      SubQ.L    $1, D1
E976   6100 FE0A                 Bsr       P410
E97A   226E 0008                 Move.L    $8(A6), A1
E97E   206E 000C                 Move.L    $C(A6), A0
E982   A025                      _GetHandleSize
E984   B081                      Cmp.L     D1, D0
E986   6F02                      BLE       L2121
E988   2001                      Move.L    D1, D0
E98A   12C0           L2121:     Move.B    D0, (A1)+
E98C   2050                      Move.L    (A0), A0
E98E   A02E                      _BlockMove
E990   6056                      Bra       L2127

                      P_tSetDialogItemText:
E992   6100 FDEE                 Bsr       P410
E996   206E 0008                 Move.L    $8(A6), A0
E99A   7000                      MoveQ.L   $0, D0
E99C   1018                      Move.B    (A0)+, D0
E99E   226E 000C                 Move.L    $C(A6), A1
E9A2   2C09                      Move.L    A1, D6
E9A4   A9E2                      _PtrToXHand
E9A6   2878 09D6                 Move.L    (WindowList), A4
E9AA   0C6C 0002 006C L2122:     Cmp       $2, $6C(A4)
E9B0   662E                      BNE       L2126
E9B2   6100 FE26                 Bsr       P411
E9B6   76FF                      MoveQ.L   $-1, D3
E9B8   6100 0318      L2123:     Bsr       P422
E9BC   671E                      BEQ       L2125
E9BE   BC92                      Cmp.L     (A2), D6
E9C0   66F6                      BNE       L2123
E9C2   B66C 00A4                 Cmp       $A4(A4), D3
E9C6   6606                      BNE       L2124
E9C8   2F2C 00A0                 Move.L    $A0(A4), -(A7)
E9CC   A9D0                      _TECalText
E9CE   486E FFD8      L2124:     Pea.L     $-28(A6)
E9D2   2F17                      Move.L    (A7), -(A7)
E9D4   A8A3                      _EraseRect
E9D6   6100 015E                 Bsr       P420
E9DA   A92A                      _ValidRect
E9DC   6100 FE34      L2125:     Bsr       P412
E9E0   286C 0090      L2126:     Move.L    $90(A4), A4
E9E4   200C                      Move.L    A4, D0
E9E6   66C2                      BNE       L2122
E9E8   7008           L2127:     MoveQ.L   $8, D0
E9EA   6084           L2128:     Bra       L2120

                      P_tSelectDialogItemText:
E9EC   6100 FD94                 Bsr       P410
E9F0   286E 000E                 Move.L    $E(A6), A4
E9F4   6100 FDE4                 Bsr       P411
E9F8   362E 000C                 Move      $C(A6), D3
E9FC   5343                      SubQ.L    $1, D3
E9FE   6100 03F4                 Bsr       P427
EA02   242E 0008                 Move.L    $8(A6), D2
EA06   4842                      Swap      D2
EA08   6100 035A                 Bsr       P423
EA0C   6100 FE04                 Bsr       P412
EA10   700A                      MoveQ.L   $A, D0
EA12   60D6                      Bra       L2128

                      P417:
EA14   48E7 FFF8                 MoveM.L   D0-D7/A0-A4, -(A7)
EA18   76FF                      MoveQ.L   $-1, D3

                      E_630:
EA1A   6100 02B6                 Bsr       P422
EA1E   660E                      BNE       L2129
EA20   4CDF 1FFF                 MoveM.L   (A7)+, D0-D7/A0-A4
EA24   4E75                      Rts

                      P418:
EA26   2052                      Move.L    (A2), A0
EA28   102A 000C                 Move.B    $C(A2), D0
EA2C   4E75                      Rts
EA2E   61F6           L2129:     Bsr       P418
EA30   487A FFE8                 Pea.L     E_630
EA34   0C44 0001                 Cmp       $1, D4
EA38   6E00 01D8                 BGT       L2159
EA3C   6700 00F8                 BEQ       P420
EA40   4A44                      Tst       D4
EA42   676E                      BEQ       L2137
EA44   0800 0002                 BTst.B    $2, D0
EA48   6608                      BNE       L2130
EA4A   EE50                      RXR       $7, D0
EA4C   6B28                      BMI       L2132
EA4E   652E                      BCS       L2133
EA50   4E75                      Rts
EA52   0240 0003      L2130:     And       $3, D0
EA56   0C40 0003                 Cmp       $3, D0
EA5A   6612                      BNE       L2131
EA5C   487A 000A                 Pea.L     E_631
EA60   223C 434E 544C            Move.L    $434E544C, D1
EA66   601C                      Bra       L2134

                      E_631:
EA68   2252                      Move.L    (A2), A1
EA6A   3029 0010                 Move      $10(A1), D0
EA6E   223C 4344 4546 L2131:     Move.L    $43444546, D1
EA74   6012                      Bra       L2135
EA76   223C 4943 4F4E L2132:     Move.L    $49434F4E, D1
EA7C   6006                      Bra       L2134
EA7E   223C 5049 4354 L2133:     Move.L    $50494354, D1
EA84   302A 000E      L2134:     Move      $E(A2), D0
EA88   594F           L2135:     SubQ.L    $4, A7
EA8A   2F01                      Move.L    D1, -(A7)
EA8C   3F00                      Move      D0, -(A7)
EA8E   A9A0                      _GetResource
EA90   245F                      Move.L    (A7)+, A2
EA92   0C44 FFFF                 Cmp       $-1, D4
EA96   6706                      BEQ       P419
EA98   0892 0006                 BClr.B    $6, (A2)
EA9C   4E75                      Rts

                      P419:
EA9E   554F                      SubQ.L    $2, A7
EAA0   2F0A                      Move.L    A2, -(A7)
EAA2   A9A6                      _GetResAttrs
EAA4   301F                      Move      (A7)+, D0
EAA6   0800 0005                 BTst.B    $5, D0
EAAA   6704                      BEQ       L2136
EAAC   08D2 0006                 BSet.B    $6, (A2)
EAB0   4E75           L2136:     Rts
EAB2   2208           L2137:     Move.L    A0, D1
EAB4   6702                      BEQ       L2138
EAB6   4E75                      Rts
EAB8   0800 0002      L2138:     BTst.B    $2, D0
EABC   6636                      BNE       L2143
EABE   EA50                      RXR       $5, D0
EAC0   650A                      BCS       L2139
EAC2   6B08                      BMI       L2139
EAC4   E450                      RXR       $2, D0
EAC6   6B12                      BMI       L2140
EAC8   6518                      BCS       L2141
EACA   4E75                      Rts
EACC   41EA 000D      L2139:     Lea.L     $D(A2), A0
EAD0   7000                      MoveQ.L   $0, D0
EAD2   1018                      Move.B    (A0)+, D0
EAD4   A9E3                      _PtrToHand
EAD6   2F08                      Move.L    A0, -(A7)
EAD8   6058                      Bra       L2146
EADA   203C 4943 4F4E L2140:     Move.L    $49434F4E, D0
EAE0   6006                      Bra       L2142
EAE2   203C 5049 4354 L2141:     Move.L    $50494354, D0
EAE8   594F           L2142:     SubQ.L    $4, A7
EAEA   2F00                      Move.L    D0, -(A7)
EAEC   3F2A 000E                 Move      $E(A2), -(A7)
EAF0   A9A0                      _GetResource
EAF2   603E                      Bra       L2146
EAF4   0240 0003      L2143:     And       $3, D0
EAF8   0C40 0003                 Cmp       $3, D0
EAFC   6614                      BNE       L2144
EAFE   594F                      SubQ.L    $4, A7
EB00   3F2A 000E                 Move      $E(A2), -(A7)
EB04   2F0C                      Move.L    A4, -(A7)
EB06   A9BE                      _GetNewControl
EB08   2F17                      Move.L    (A7), -(A7)
EB0A   2F2A 0004                 Move.L    $4(A2), -(A7)
EB0E   A959                      _MoveControl
EB10   601A                      Bra       L2145
EB12   594F           L2144:     SubQ.L    $4, A7
EB14   2F0C                      Move.L    A4, -(A7)
EB16   486E FFD8                 Pea.L     $-28(A6)
EB1A   486A 000D                 Pea.L     $D(A2)
EB1E   50E7                      ST.B      -(A7)
EB20   42A7                      Clr.L     -(A7)
EB22   3F3C 0001                 Move      $1, -(A7)
EB26   3F00                      Move      D0, -(A7)
EB28   42A7                      Clr.L     -(A7)
EB2A   A954                      _NewControl
EB2C   486E FFD8      L2145:     Pea.L     $-28(A6)
EB30   A92A                      _ValidRect
EB32   249F           L2146:     Move.L    (A7)+, (A2)
EB34   4E75                      Rts

                      P420:
EB36   6100 FEEE                 Bsr       P418
EB3A   0800 0002                 BTst.B    $2, D0
EB3E   6636                      BNE       L2150
EB40   EA50                      RXR       $5, D0
EB42   6534                      BCS       L2151
EB44   6B32                      BMI       L2151
EB46   E450                      RXR       $2, D0
EB48   6B12                      BMI       L2148
EB4A   651E                      BCS       L2149
EB4C   2012                      Move.L    (A2), D0
EB4E   670A                      BEQ       L2147
EB50   2F0C                      Move.L    A4, -(A7)
EB52   3F03                      Move      D3, -(A7)
EB54   5257                      AddQ      $1, (A7)
EB56   2040                      Move.L    D0, A0
EB58   4E90                      Jsr       (A0)
EB5A   4E75           L2147:     Rts
EB5C   486E FFD8      L2148:     Pea.L     $-28(A6)
EB60   2F12                      Move.L    (A2), -(A7)
EB62   2F17                      Move.L    (A7), -(A7)
EB64   A9A2                      _LoadResource
EB66   A94B                      _PlotIcon
EB68   4E75                      Rts
EB6A   2F12           L2149:     Move.L    (A2), -(A7)
EB6C   2F17                      Move.L    (A7), -(A7)
EB6E   A9A2                      _LoadResource
EB70   486E FFD8                 Pea.L     $-28(A6)
EB74   A8F6                      _DrawPicture
EB76   4E75           L2150:     Rts
EB78   5BC7           L2151:     SMI.B     D7
EB7A   B66C 00A4                 Cmp       $A4(A4), D3
EB7E   6622                      BNE       L2154
EB80   486E FFD8                 Pea.L     $-28(A6)
EB84   2F17                      Move.L    (A7), -(A7)
EB86   A8A3                      _EraseRect
EB88   2F2C 00A0                 Move.L    $A0(A4), -(A7)
EB8C   A9D3                      _TEUpdate
EB8E   4A07           L2152:     Tst.B     D7
EB90   660E                      BNE       L2153
EB92   41EE FFD8                 Lea.L     $-28(A6), A0
EB96   7001                      MoveQ.L   $1, D0
EB98   7201                      MoveQ.L   $1, D1
EB9A   7403                      MoveQ.L   $3, D2
EB9C   6100 0224                 Bsr       P425
EBA0   4E75           L2153:     Rts
EBA2   48E7 3F18      L2154:     MoveM.L   D2-D7/A3-A4, -(A7)
EBA6   2052                      Move.L    (A2), A0
EBA8   A9E1                      _HandToHand
EBAA   2E08                      Move.L    A0, D7
EBAC   7A02                      MoveQ.L   $2, D5
EBAE   47F8 0AA0                 Lea.L     (DAStrings), A3
EBB2   49FA 0056                 Lea.L     DT58, A4
EBB6   7C03                      MoveQ.L   $3, D6
EBB8   7600           L2155:     MoveQ.L   $0, D3
EBBA   7000           L2156:     MoveQ.L   $0, D0
EBBC   2813                      Move.L    (A3), D4
EBBE   6708                      BEQ       L2157
EBC0   2044                      Move.L    D4, A0
EBC2   A029                      _HLock
EBC4   2050                      Move.L    (A0), A0
EBC6   1018                      Move.B    (A0)+, D0
EBC8   594F           L2157:     SubQ.L    $4, A7
EBCA   2F07                      Move.L    D7, -(A7)
EBCC   2F03                      Move.L    D3, -(A7)
EBCE   2F0C                      Move.L    A4, -(A7)
EBD0   2F05                      Move.L    D5, -(A7)
EBD2   2F08                      Move.L    A0, -(A7)
EBD4   2F00                      Move.L    D0, -(A7)
EBD6   A9E0                      _Munger
EBD8   261F                      Move.L    (A7)+, D3
EBDA   6ADE                      BPL       L2156
EBDC   4A84                      Tst.L     D4
EBDE   6704                      BEQ       L2158
EBE0   2044                      Move.L    D4, A0
EBE2   A02A                      _HUnlock
EBE4   544C           L2158:     AddQ      $2, A4
EBE6   584B                      AddQ      $4, A3
EBE8   51CE FFCE                 DBF       D6, L2155
EBEC   2047                      Move.L    D7, A0
EBEE   08D0 0007                 BSet.B    $7, (A0)
EBF2   2F10                      Move.L    (A0), -(A7)
EBF4   A025                      _GetHandleSize
EBF6   2F00                      Move.L    D0, -(A7)
EBF8   486E FFD8                 Pea.L     $-28(A6)
EBFC   4267                      Clr       -(A7)
EBFE   A9CE                      _TETextBox
EC00   2047                      Move.L    D7, A0
EC02   A023                      _DisposeHandle
EC04   4CDF 18FC                 MoveM.L   (A7)+, D2-D7/A3-A4
EC08   6084                      Bra       L2152

                      DT58:
EC0A   5E30 5E31 5E32            DC.B      '^0^1^2'
EC10   5E33                      DC.B      '^3'
EC12   E658           L2159:     ROR       $3, D0
EC14   6500 FF60                 BCS       L2150
EC18   E450                      RXR       $2, D0
EC1A   6506                      BCS       L2161
EC1C   6B04                      BMI       L2161
EC1E   4292           L2160:     Clr.L     (A2)
EC20   4E75                      Rts
EC22   A023           L2161:     _DisposeHandle
EC24   60F8                      Bra       L2160
                      ; Missing Block
EC26   2F08                      Move.L    A0, -(A7)
EC28   A955                      _DisposeControl
EC2A   60F2                      Bra       L2160
EC2C   206E FFB6      L2162:     Move.L    $-4A(A6), A0
EC30   4A68 00A4                 Tst       $A4(A0)
EC34   6B42                      BMI       L2165
EC36   2F28 00A0                 Move.L    $A0(A0), -(A7)
EC3A   2F08                      Move.L    A0, -(A7)
EC3C   A873                      _SetPort
EC3E   082E 0000 FFC3            BTst.B    $0, $-3D(A6)
EC44   6704                      BEQ       L2163
EC46   A9D8                      _TEActivate
EC48   6002                      Bra       L2164
EC4A   A9D9           L2163:     _TEDeactivate
EC4C   2F0C           L2164:     Move.L    A4, -(A7)
EC4E   A873                      _SetPort
EC50   6026                      Bra       L2165

                      P421:
EC52   302E FFB4                 Move      $-4C(A6), D0
EC56   5340                      SubQ.L    $1, D0
EC58   6700 0080                 BEQ       L2173
EC5C   5540                      SubQ.L    $2, D0
EC5E   672C                      BEQ       L2167
EC60   5540                      SubQ.L    $2, D0
EC62   6728                      BEQ       L2167
EC64   5340                      SubQ.L    $1, D0
EC66   6714                      BEQ       L2166
EC68   5540                      SubQ.L    $2, D0
EC6A   67C0                      BEQ       L2162
EC6C   4A6C 00A4                 Tst       $A4(A4)
EC70   6B06                      BMI       L2165
EC72   2F2C 00A0                 Move.L    $A0(A4), -(A7)
EC76   A9DA                      _TEIdle
EC78   76FF           L2165:     MoveQ.L   $-1, D3
EC7A   4E75                      Rts
EC7C   2F0C           L2166:     Move.L    A4, -(A7)
EC7E   2F17                      Move.L    (A7), -(A7)
EC80   2F17                      Move.L    (A7), -(A7)
EC82   A922                      _BeginUpDate
EC84   6100 FB14                 Bsr       P_tDrawDialog
EC88   A923                      _EndUpDate
EC8A   60EC                      Bra       L2165
EC8C   122E FFB9      L2167:     Move.B    $-47(A6), D1
EC90   0C01 0009                 Cmp.B     $9, D1
EC94   6710                      BEQ       L2168
EC96   362C 00A4                 Move      $A4(A4), D3
EC9A   6BDC                      BMI       L2165
EC9C   3F01                      Move      D1, -(A7)
EC9E   2F2C 00A0                 Move.L    $A0(A4), -(A7)
ECA2   A9DC                      _TEKey
ECA4   6020                      Bra       L2170
ECA6   362C 00A4      L2168:     Move      $A4(A4), D3
ECAA   6126           L2169:     Bsr       P422
ECAC   671A                      BEQ       L2171
ECAE   B66C 00A4                 Cmp       $A4(A4), D3
ECB2   67C4                      BEQ       L2165
ECB4   082A 0004 000C            BTst.B    $4, $C(A2)
ECBA   67EE                      BEQ       L2169
ECBC   243C 0000 7FFF            Move.L    $7FFF, D2
ECC2   6100 00A0                 Bsr       P423
ECC6   6062           L2170:     Bra       L2175
ECC8   76FF           L2171:     MoveQ.L   $-1, D3
ECCA   4A6C 00A4                 Tst       $A4(A4)
ECCE   6ADA                      BPL       L2169
ECD0   60A6           L2172:     Bra       L2165

                      P422:
ECD2   5243                      AddQ      $1, D3
ECD4   6100 011E                 Bsr       P427
ECD8   4E75                      Rts
ECDA   2D6E FFBE FFE4 L2173:     Move.L    $-42(A6), $-1C(A6)
ECE0   486E FFE4                 Pea.L     $-1C(A6)
ECE4   A871                      _GlobalToLocal
ECE6   76FF                      MoveQ.L   $-1, D3
ECE8   61E8           L2174:     Bsr       P422
ECEA   67E4                      BEQ       L2172
ECEC   554F                      SubQ.L    $2, A7
ECEE   2F2E FFE4                 Move.L    $-1C(A6), -(A7)
ECF2   486E FFD8                 Pea.L     $-28(A6)
ECF6   A8AD                      _PtInRect
ECF8   4A1F                      Tst.B     (A7)+
ECFA   67EC                      BEQ       L2174
ECFC   082A 0002 000C            BTst.B    $2, $C(A2)
ED02   6728                      BEQ       L2176
ED04   554F                      SubQ.L    $2, A7
ED06   2F2E FFE4                 Move.L    $-1C(A6), -(A7)
ED0A   2F0C                      Move.L    A4, -(A7)
ED0C   486E FFE8                 Pea.L     $-18(A6)
ED10   A96C                      _FindControl
ED12   301F                      Move      (A7)+, D0
ED14   67BA                      BEQ       L2172
ED16   554F                      SubQ.L    $2, A7
ED18   2F2E FFE8                 Move.L    $-18(A6), -(A7)
ED1C   2F2E FFE4                 Move.L    $-1C(A6), -(A7)
ED20   2F38 0A06                 Move.L    (MinusOne), -(A7)
ED24   A968                      _TrackControl
ED26   4A5F                      Tst       (A7)+
ED28   67A6                      BEQ       L2172
ED2A   602A           L2175:     Bra       L2178
ED2C   082A 0004 000C L2176:     BTst.B    $4, $C(A2)
ED32   6722                      BEQ       L2178
ED34   B66C 00A4                 Cmp       $A4(A4), D3
ED38   6704                      BEQ       L2177
ED3A   7400                      MoveQ.L   $0, D2
ED3C   6126                      Bsr       P423
ED3E   4A6C 00A4      L2177:     Tst       $A4(A4)
ED42   6B12                      BMI       L2178
ED44   2F2E FFE4                 Move.L    $-1C(A6), -(A7)
ED48   082E 0001 FFC2            BTst.B    $1, $-3E(A6)
ED4E   56E7                      SNE.B     -(A7)
ED50   2F2C 00A0                 Move.L    $A0(A4), -(A7)
ED54   A9D4                      _TEClick
ED56   082A 0007 000C L2178:     BTst.B    $7, $C(A2)
ED5C   6600 FF72                 BNE       L2172
ED60   5243                      AddQ      $1, D3
ED62   4E75                      Rts

                      P423:
ED64   4A6C 00A4                 Tst       $A4(A4)
ED68   6B06                      BMI       L2179
ED6A   2F2C 00A0                 Move.L    $A0(A4), -(A7)
ED6E   A9D9                      _TEDeactivate
ED70   6114           L2179:     Bsr       P424
ED72   4A6C 00A4                 Tst       $A4(A4)
ED76   6B06                      BMI       L2180
ED78   2F2C 00A0                 Move.L    $A0(A4), -(A7)
ED7C   A9D8                      _TEActivate
ED7E   4E75           L2180:     Rts
ED80   B66C 00A4      L2181:     Cmp       $A4(A4), D3
ED84   673A                      BEQ       L2183

                      P424:
ED86   2012                      Move.L    (A2), D0
ED88   6F36                      BLE       L2183
ED8A   3943 00A4                 Move      D3, $A4(A4)
ED8E   6B30                      BMI       L2183
ED90   206C 00A0                 Move.L    $A0(A4), A0
ED94   2250                      Move.L    (A0), A1
ED96   2340 003E                 Move.L    D0, $3E(A1)
ED9A   70FE                      MoveQ.L   $-2, D0
ED9C   B480                      Cmp.L     D0, D2
ED9E   6704                      BEQ       L2182
EDA0   2342 0020                 Move.L    D2, $20(A1)
EDA4   41D1           L2182:     Lea.L     (A1), A0
EDA6   20EE FFD8                 Move.L    $-28(A6), (A0)+
EDAA   20EE FFDC                 Move.L    $-24(A6), (A0)+
EDAE   20EE FFD8                 Move.L    $-28(A6), (A0)+
EDB2   20EE FFDC                 Move.L    $-24(A6), (A0)+
EDB6   3340 0032                 Move      D0, $32(A1)
EDBA   2F2C 00A0                 Move.L    $A0(A4), -(A7)
EDBE   A9D0                      _TECalText
EDC0   4E75           L2183:     Rts

                      P425:
EDC2   2F08                      Move.L    A0, -(A7)
EDC4   3F02                      Move      D2, -(A7)
EDC6   3F02                      Move      D2, -(A7)
EDC8   2F08                      Move.L    A0, -(A7)
EDCA   3F01                      Move      D1, -(A7)
EDCC   3F01                      Move      D1, -(A7)
EDCE   2F08                      Move.L    A0, -(A7)
EDD0   4442                      Neg       D2
EDD2   3F02                      Move      D2, -(A7)
EDD4   3F02                      Move      D2, -(A7)
EDD6   3F00                      Move      D0, -(A7)
EDD8   3F00                      Move      D0, -(A7)
EDDA   A89B                      _PenSize
EDDC   A8A9                      _InsetRect
EDDE   A8B0                      _FrameRoundRect
EDE0   A8A9                      _InsetRect
EDE2   4E75                      Rts

                      P426:
EDE4   48E7 E060                 MoveM.L   D0-D2/A1-A2, -(A7)
EDE8   2F08                      Move.L    A0, -(A7)
EDEA   A906                      _NewString
EDEC   205F                      Move.L    (A7)+, A0
EDEE   4CDF 0606                 MoveM.L   (A7)+, D1-D2/A1-A2
EDF2   4E75                      Rts

                      P427:
EDF4   200B                      Move.L    A3, D0
EDF6   6728                      BEQ       L2185
EDF8   2F00                      Move.L    D0, -(A7)
EDFA   A9A2                      _LoadResource
EDFC   2453                      Move.L    (A3), A2
EDFE   301A                      Move      (A2)+, D0
EE00   4A43                      Tst       D3
EE02   6D1C                      BLT       L2185
EE04   B043                      Cmp       D3, D0
EE06   6D18                      BLT       L2185
EE08   3003                      Move      D3, D0
EE0A   4A40           L2184:     Tst       D0
EE0C   6714                      BEQ       L2186
EE0E   720E                      MoveQ.L   $E, D1
EE10   D22A 000D                 Add.B     $D(A2), D1
EE14   5241                      AddQ      $1, D1
EE16   0241 FFFE                 And       $-2, D1
EE1A   D4C1                      AddA      D1, A2
EE1C   51C8 FFEC                 DBF       D0, L2184
EE20   95CA           L2185:     SubA.L    A2, A2
EE22   41EA 0004      L2186:     Lea.L     $4(A2), A0
EE26   43EE FFD8                 Lea.L     $-28(A6), A1
EE2A   22D8                      Move.L    (A0)+, (A1)+
EE2C   22D8                      Move.L    (A0)+, (A1)+
EE2E   200A                      Move.L    A2, D0
EE30   4E75                      Rts

                      P_tMunger:
EE32   4E56 0000                 Link      A6, $0
EE36   48E7 3F38                 MoveM.L   D2-D7/A2-A4, -(A7)
EE3A   246E 001C                 Move.L    $1C(A6), A2
EE3E   204A                      Move.L    A2, A0
EE40   A025                      _GetHandleSize
EE42   2A00                      Move.L    D0, D5
EE44   242E 0018                 Move.L    $18(A6), D2
EE48   266E 0014                 Move.L    $14(A6), A3
EE4C   286E 000C                 Move.L    $C(A6), A4
EE50   262E 0010                 Move.L    $10(A6), D3
EE54   6758                      BEQ       L2195
EE56   6A04                      BPL       L2188
EE58   2605           L2187:     Move.L    D5, D3
EE5A   9682                      Sub.L     D2, D3
EE5C   2005           L2188:     Move.L    D5, D0
EE5E   9083                      Sub.L     D3, D0
EE60   6D2C                      BLT       L2192
EE62   9082                      Sub.L     D2, D0
EE64   6DF2                      BLT       L2187
EE66   200B                      Move.L    A3, D0
EE68   672C                      BEQ       L2194
EE6A   2C12                      Move.L    (A2), D6
EE6C   2E05                      Move.L    D5, D7
EE6E   DE86                      Add.L     D6, D7
EE70   DC82                      Add.L     D2, D6
EE72   2203           L2189:     Move.L    D3, D1
EE74   2046                      Move.L    D6, A0
EE76   224B                      Move.L    A3, A1
EE78   BE86           L2190:     Cmp.L     D6, D7
EE7A   6512                      BCS       L2192
EE7C   B308                      CmpM.B    (A0)+, (A1)+
EE7E   660A                      BNE       L2191
EE80   5381                      SubQ.L    $1, D1
EE82   66F4                      BNE       L2190
EE84   2406                      Move.L    D6, D2
EE86   9492                      Sub.L     (A2), D2
EE88   6008                      Bra       L2193
EE8A   5286           L2191:     AddQ      $1, D6
EE8C   60E4                      Bra       L2189
EE8E   74FF           L2192:     MoveQ.L   $-1, D2
EE90   6044                      Bra       L2196
EE92   200C           L2193:     Move.L    A4, D0
EE94   6740                      BEQ       L2196
EE96   2005           L2194:     Move.L    D5, D0
EE98   9083                      Sub.L     D3, D0
EE9A   2A00                      Move.L    D0, D5
EE9C   9082                      Sub.L     D2, D0
EE9E   2252                      Move.L    (A2), A1
EEA0   D3C2                      AddA.L    D2, A1
EEA2   2049                      Move.L    A1, A0
EEA4   D1C3                      AddA.L    D3, A0
EEA6   A02E                      _BlockMove
EEA8   204A                      Move.L    A2, A0
EEAA   2005                      Move.L    D5, D0
EEAC   A024                      _SetHandleSize
EEAE   282E 0008      L2195:     Move.L    $8(A6), D4
EEB2   6722                      BEQ       L2196
EEB4   2005                      Move.L    D5, D0
EEB6   D084                      Add.L     D4, D0
EEB8   204A                      Move.L    A2, A0
EEBA   A024                      _SetHandleSize
EEBC   6618                      BNE       L2196
EEBE   2252                      Move.L    (A2), A1
EEC0   D3C2                      AddA.L    D2, A1
EEC2   2049                      Move.L    A1, A0
EEC4   D3C4                      AddA.L    D4, A1
EEC6   2005                      Move.L    D5, D0
EEC8   9082                      Sub.L     D2, D0
EECA   A02E                      _BlockMove
EECC   2252                      Move.L    (A2), A1
EECE   D3C2                      AddA.L    D2, A1
EED0   204C                      Move.L    A4, A0
EED2   2004                      Move.L    D4, D0
EED4   A02E                      _BlockMove
EED6   2D42 0020      L2196:     Move.L    D2, $20(A6)
EEDA   4CDF 1CFC                 MoveM.L   (A7)+, D2-D7/A2-A4
EEDE   4E5E                      Unlk      A6
EEE0   205F                      Move.L    (A7)+, A0
EEE2   DEFC 0018                 AddA      $18, A7
EEE6   4ED0                      Jmp       (A0)

                      P_tHandToHand:
EEE8   2248                      Move.L    A0, A1
EEEA   A025                      _GetHandleSize
EEEC   2200                      Move.L    D0, D1
EEEE   A122                      _NewHandle
EEF0   2251                      Move.L    (A1), A1
EEF2   600E                      Bra       L2197

                      P_tPtrToXHand:
EEF4   C149                      Exg.L     A0, A1
EEF6   2200                      Move.L    D0, D1
EEF8   A024                      _SetHandleSize
EEFA   6006                      Bra       L2197

                      P_tPtrToHand:
EEFC   2248                      Move.L    A0, A1
EEFE   2200                      Move.L    D0, D1
EF00   A122                      _NewHandle
EF02   6610           L2197:     BNE       L2199
EF04   7400                      MoveQ.L   $0, D2
EF06   2F08           L2198:     Move.L    A0, -(A7)
EF08   2050                      Move.L    (A0), A0
EF0A   D1C2                      AddA.L    D2, A0
EF0C   C149                      Exg.L     A0, A1
EF0E   2001                      Move.L    D1, D0
EF10   A02E                      _BlockMove
EF12   205F                      Move.L    (A7)+, A0
EF14   4E75           L2199:     Rts

                      P_tHandAndHand:
EF16   A025                      _GetHandleSize
EF18   2050                      Move.L    (A0), A0

                      P_tPtrAndHand:
EF1A   2200                      Move.L    D0, D1
EF1C   C348                      Exg.L     A1, A0
EF1E   A025                      _GetHandleSize
EF20   2400                      Move.L    D0, D2
EF22   D081                      Add.L     D1, D0
EF24   A024                      _SetHandleSize
EF26   66EC                      BNE       L2199
EF28   60DC                      Bra       L2198

                      P_tSystemEvent:
EF2A   2F0B                      Move.L    A3, -(A7)
EF2C   266F 0008                 Move.L    $8(A7), A3
EF30   426F 000C                 Clr       $C(A7)
EF34   594F                      SubQ.L    $4, A7
EF36   2F0F                      Move.L    A7, -(A7)
EF38   A874                      _GetPort
EF3A   3013                      Move      (A3), D0
EF3C   0C40 0009                 Cmp       $9, D0
EF40   6422                      BCC       E_639
EF42   D040                      Add       D0, D0
EF44   41FA 0008                 Lea.L     DT59, A0
EF48   D0F0 0000                 AddA      $0(A0,D0.W), A0
EF4C   4ED0                      Jmp       (A0)

                      DT59:
EF4E   0016 0016 001E            DC.B      '      '
EF54   001E 001E 001E            DC.B      '      '
EF5A   0072 007E 0072            DC.B      ' r ~ r'
EF60   522F 0010      L2200:     AddQ      $1, $10(A7)

                      E_639:
EF64   A873                      _SetPort
EF66   265F                      Move.L    (A7)+, A3
EF68   2E9F                      Move.L    (A7)+, (A7)
EF6A   4E75                      Rts

                      E_640:
EF6C   594F                      SubQ.L    $4, A7
EF6E   A924                      _FrontWindow
EF70   205F                      Move.L    (A7)+, A0
EF72   6110                      Bsr       P428
EF74   66EE                      BNE       E_639
EF76   3013                      Move      (A3), D0
EF78   3229 0024                 Move      $24(A1), D1
EF7C   0101                      BTst.B    D0, D1
EF7E   67E4                      BEQ       E_639
EF80   611E                      Bsr       P429
EF82   60DC                      Bra       L2200

                      P428:
EF84   3028 006C                 Move      $6C(A0), D0
EF88   6A12                      BPL       L2201
EF8A   4640                      Not       D0
EF8C   E540                      AsL       $2, D0
EF8E   2078 011C                 Move.L    (UTableBase), A0
EF92   2070 0000                 Move.L    $0(A0,D0.W), A0
EF96   2250                      Move.L    (A0), A1
EF98   7000                      MoveQ.L   $0, D0
EF9A   4E75                      Rts
EF9C   70FF           L2201:     MoveQ.L   $-1, D0
EF9E   4E75                      Rts

                      P429:
EFA0   7040                      MoveQ.L   $40, D0

                      P430:
EFA2   4E56 FFE0                 Link      A6, $-20
EFA6   41EE FFF8                 Lea.L     $-8(A6), A0
EFAA   30E9 0018                 Move      $18(A1), (A0)+
EFAE   30C0                      Move      D0, (A0)+
EFB0   208B                      Move.L    A3, (A0)
EFB2   41EE FFE0                 Lea.L     $-20(A6), A0
EFB6   A204                      _ControlImmed
EFB8   4E5E                      Unlk      A6
EFBA   4E75                      Rts

                      P431:
EFBC   7041                      MoveQ.L   $41, D0
EFBE   60E2                      Bra       P430

                      E_641:
EFC0   206B 0002                 Move.L    $2(A3), A0
EFC4   61BE                      Bsr       P428
EFC6   669C                      BNE       E_639
EFC8   61D6                      Bsr       P429
EFCA   6094                      Bra       L2200

                      E_642:
EFCC   9EFC 0018                 SubA      $18, A7
EFD0   204F                      Move.L    A7, A0
EFD2   316B 0004 0016            Move      $4(A3), $16(A0)
EFD8   A00F                      _MountVol
EFDA   DEFC 0018                 AddA      $18, A7
EFDE   3740 0002                 Move      D0, $2(A3)
EFE2   6080                      Bra       E_639

                      P_tSystemClick:
EFE4   48E7 9818                 MoveM.L   D0/D3-D4/A3-A4, -(A7)
EFE8   2F0F                      Move.L    A7, -(A7)
EFEA   A874                      _GetPort
EFEC   286F 0018                 Move.L    $18(A7), A4
EFF0   282F 001C                 Move.L    $1C(A7), D4
EFF4   200C                      Move.L    A4, D0
EFF6   6700 0062                 BEQ       L2203
EFFA   2040                      Move.L    D0, A0
EFFC   6186                      Bsr       P428
EFFE   664E                      BNE       L2202
F000   2609                      Move.L    A1, D3
F002   7000                      MoveQ.L   $0, D0
F004   102C 007E                 Move.B    $7E(A4), D0
F008   42A7                      Clr.L     -(A7)
F00A   3F00                      Move      D0, -(A7)
F00C   2F0C                      Move.L    A4, -(A7)
F00E   3F3C 0001                 Move      $1, -(A7)
F012   2044                      Move.L    D4, A0
F014   2F28 000A                 Move.L    $A(A0), -(A7)
F018   206C 007E                 Move.L    $7E(A4), A0
F01C   08D0 0007                 BSet.B    $7, (A0)
F020   2F08                      Move.L    A0, -(A7)
F022   A9A2                      _LoadResource
F024   2050                      Move.L    (A0), A0
F026   4E90                      Jsr       (A0)
F028   206C 007E                 Move.L    $7E(A4), A0
F02C   0890 0007                 BClr.B    $7, (A0)
F030   201F                      Move.L    (A7)+, D0
F032   671A                      BEQ       L2202
F034   5540                      SubQ.L    $2, D0
F036   674A                      BEQ       L2205
F038   5540                      SubQ.L    $2, D0
F03A   6758                      BEQ       L2206
F03C   42A7                      Clr.L     -(A7)
F03E   A924                      _FrontWindow
F040   201F                      Move.L    (A7)+, D0
F042   B08C                      Cmp.L     A4, D0
F044   6636                      BNE       L2204
F046   2644                      Move.L    D4, A3
F048   2243                      Move.L    D3, A1
F04A   6100 FF54                 Bsr       P429
F04E   A873           L2202:     _SetPort
F050   4CDF 1818                 MoveM.L   (A7)+, D3-D4/A3-A4
F054   205F                      Move.L    (A7)+, A0
F056   504F                      AddQ      $8, A7
F058   4ED0                      Jmp       (A0)
F05A   4AB8 0A6C      L2203:     Tst.L     (DeskHook)
F05E   67EE                      BEQ       L2202
F060   2F38 09DE                 Move.L    (WMgrPort), -(A7)
F064   A873                      _SetPort
F066   2F38 09EE                 Move.L    (GrayRgn), -(A7)
F06A   A879                      _SetClip
F06C   42A7                      Clr.L     -(A7)
F06E   A90B                      _ClipAbove
F070   2044                      Move.L    D4, A0
F072   2278 0A6C                 Move.L    (DeskHook), A1
F076   70FF                      MoveQ.L   $-1, D0
F078   4E91                      Jsr       (A1)
F07A   60D2                      Bra       L2202
F07C   2F0C           L2204:     Move.L    A4, -(A7)
F07E   A91F                      _SelectWindow
F080   60CC                      Bra       L2202
F082   2F0C           L2205:     Move.L    A4, -(A7)
F084   2044                      Move.L    D4, A0
F086   2F28 000A                 Move.L    $A(A0), -(A7)
F08A   2055                      Move.L    (A5), A0
F08C   4868 FF8C                 Pea.L     $-74(A0)
F090   A925                      _DragWindow
F092   60BA                      Bra       L2202
F094   4267           L2206:     Clr       -(A7)
F096   2F0C                      Move.L    A4, -(A7)
F098   2044                      Move.L    D4, A0
F09A   2F28 000A                 Move.L    $A(A0), -(A7)
F09E   A91E                      _TrackGoAway
F0A0   4A1F                      Tst.B     (A7)+
F0A2   67AA                      BEQ       L2202
F0A4   2243                      Move.L    D3, A1
F0A6   2038 0A88                 Move.L    (CloseOrnHook), D0
F0AA   6608                      BNE       L2207
F0AC   3F29 0018                 Move      $18(A1), -(A7)
F0B0   A9B7                      _CloseDeskAcc
F0B2   609A                      Bra       L2202
F0B4   2040           L2207:     Move.L    D0, A0
F0B6   4E90                      Jsr       (A0)
F0B8   6094                      Bra       L2202

                      P_tSystemTask:
F0BA   48E7 1010                 MoveM.L   D3/A3, -(A7)
F0BE   08F8 0007 0A62            BSet.B    $7, (TaskLock)
F0C4   6600 0066                 BNE       L2212
F0C8   594F                      SubQ.L    $4, A7
F0CA   2F0F                      Move.L    A7, -(A7)
F0CC   A874                      _GetPort
F0CE   42A7                      Clr.L     -(A7)
F0D0   A924                      _FrontWindow
F0D2   205F                      Move.L    (A7)+, A0
F0D4   6100 FEAE                 Bsr       P428
F0D8   660E                      BNE       L2208
F0DA   0829 0007 0005            BTst.B    $7, $5(A1)
F0E0   6606                      BNE       L2208
F0E2   7042                      MoveQ.L   $42, D0
F0E4   6100 FEBC                 Bsr       P430
F0E8   2678 011C      L2208:     Move.L    (UTableBase), A3
F0EC   3638 01D2                 Move      (UnitTableEntryCount), D3
F0F0   201B           L2209:     Move.L    (A3)+, D0
F0F2   672E                      BEQ       L2211
F0F4   2040                      Move.L    D0, A0
F0F6   2250                      Move.L    (A0), A1
F0F8   3029 0004                 Move      $4(A1), D0
F0FC   0240 20A0                 And       $20A0, D0
F100   0C40 2020                 Cmp       $2020, D0
F104   661C                      BNE       L2211
F106   7000                      MoveQ.L   $0, D0
F108   3029 0022                 Move      $22(A1), D0
F10C   6710                      BEQ       L2210
F10E   D0A9 001A                 Add.L     $1A(A1), D0
F112   B0B8 016A                 Cmp.L     (Ticks), D0
F116   6E0A                      BGT       L2211
F118   2378 016A 001A            Move.L    (Ticks), $1A(A1)
F11E   6100 FE9C      L2210:     Bsr       P431
F122   5343           L2211:     SubQ.L    $1, D3
F124   6ECA                      BGT       L2209
F126   A873                      _SetPort
F128   4238 0A62                 Clr.B     (TaskLock)
F12C   4CDF 0808      L2212:     MoveM.L   (A7)+, D3/A3
F130   4E75                      Rts

                      P_tSystemMenu:
F132   48E7 0030                 MoveM.L   A2-A3, -(A7)
F136   222F 000C                 Move.L    $C(A7), D1
F13A   4841                      Swap      D1
F13C   3038 0A20                 Move      (MBarEnable), D0
F140   6702                      BEQ       L2213
F142   3200                      Move      D0, D1
F144   2478 011C      L2213:     Move.L    (UTableBase), A2
F148   3438 01D2                 Move      (UnitTableEntryCount), D2
F14C   201A           L2214:     Move.L    (A2)+, D0
F14E   671E                      BEQ       L2215
F150   2040                      Move.L    D0, A0
F152   2250                      Move.L    (A0), A1
F154   0829 0005 0005            BTst.B    $5, $5(A1)
F15A   6712                      BEQ       L2215
F15C   B269 0026                 Cmp       $26(A1), D1
F160   660C                      BNE       L2215
F162   266F 000C                 Move.L    $C(A7), A3
F166   7043                      MoveQ.L   $43, D0
F168   6100 FE38                 Bsr       P430
F16C   6004                      Bra       L2216
F16E   5342           L2215:     SubQ.L    $1, D2
F170   6EDA                      BGT       L2214
F172   4CDF 0C00      L2216:     MoveM.L   (A7)+, A2-A3
F176   2E9F                      Move.L    (A7)+, (A7)
F178   4E75                      Rts

                      P_tSysEdit:
F17A   426F 0006                 Clr       $6(A7)
F17E   514F                      SubQ.L    $8, A7
F180   486F 0004                 Pea.L     $4(A7)
F184   A874                      _GetPort
F186   A924                      _FrontWindow
F188   201F                      Move.L    (A7)+, D0
F18A   6718                      BEQ       L2217
F18C   2040                      Move.L    D0, A0
F18E   6100 FDF4                 Bsr       P428
F192   6610                      BNE       L2217
F194   302F 0008                 Move      $8(A7), D0
F198   0640 0044                 Add       $44, D0
F19C   6100 FE04                 Bsr       P430
F1A0   522F 000A                 AddQ      $1, $A(A7)
F1A4   A873           L2217:     _SetPort
F1A6   6060                      Bra       L2219

                      P_tOpenDeskAcc:
F1A8   426F 0008                 Clr       $8(A7)
F1AC   9EFC 0020                 SubA      $20, A7
F1B0   2F6F 0024 0012            Move.L    $24(A7), $12(A7)
F1B6   426F 0016                 Clr       $16(A7)
F1BA   426F 001A                 Clr       $1A(A7)
F1BE   42AF 001C                 Clr.L     $1C(A7)
F1C2   204F                      Move.L    A7, A0
F1C4   A000                      _Open
F1C6   6624                      BNE       L2218
F1C8   302F 0018                 Move      $18(A7), D0
F1CC   3F40 0028                 Move      D0, $28(A7)
F1D0   4640                      Not       D0
F1D2   E540                      AsL       $2, D0
F1D4   2278 011C                 Move.L    (UTableBase), A1
F1D8   2271 0000                 Move.L    $0(A1,D0.W), A1
F1DC   2251                      Move.L    (A1), A1
F1DE   2029 001E                 Move.L    $1E(A1), D0
F1E2   6708                      BEQ       L2218
F1E4   2F00                      Move.L    D0, -(A7)
F1E6   2F00                      Move.L    D0, -(A7)
F1E8   A91F                      _SelectWindow
F1EA   A915                      _ShowWindow
F1EC   DEFC 0020      L2218:     AddA      $20, A7
F1F0   2E9F                      Move.L    (A7)+, (A7)
F1F2   4E75                      Rts

                      P_tCloseDeskAcc:
F1F4   302F 0004                 Move      $4(A7), D0
F1F8   9EFC 001E                 SubA      $1E, A7
F1FC   3F40 0018                 Move      D0, $18(A7)
F200   204F                      Move.L    A7, A0
F202   A001                      _Close
F204   DEFC 001E                 AddA      $1E, A7
F208   205F           L2219:     Move.L    (A7)+, A0
F20A   544F                      AddQ      $2, A7
F20C   4ED0                      Jmp       (A0)

                      P_tGetPattern:
F20E   203C 5041 5420            Move.L    $50415420, D0
F214   594F           L2220:     SubQ.L    $4, A7
F216   2F00                      Move.L    D0, -(A7)
F218   3F2F 000C                 Move      $C(A7), -(A7)
F21C   A9A0                      _GetResource
F21E   201F                      Move.L    (A7)+, D0
F220   205F                      Move.L    (A7)+, A0
F222   544F                      AddQ      $2, A7
F224   2E80                      Move.L    D0, (A7)
F226   4ED0                      Jmp       (A0)

                      P_tGetCursor:
F228   203C 4355 5253            Move.L    $43555253, D0
F22E   60E4                      Bra       L2220

                      P_tGetString:
F230   203C 5354 5220            Move.L    $53545220, D0
F236   60DC                      Bra       L2220

                      P_tGetIcon:
F238   203C 4943 4F4E            Move.L    $49434F4E, D0
F23E   60D4                      Bra       L2220

                      P_tGetPicture:
F240   203C 5049 4354            Move.L    $50494354, D0
F246   60CC                      Bra       L2220

                      P_tGetNewWindow:
F248   4E56 0000                 Link      A6, $0
F24C   2F0B                      Move.L    A3, -(A7)
F24E   42AE 0012                 Clr.L     $12(A6)
F252   594F                      SubQ.L    $4, A7
F254   2F3C 5749 4E44            Move.L    $57494E44, -(A7)
F25A   3F2E 0010                 Move      $10(A6), -(A7)
F25E   A9A0                      _GetResource
F260   265F                      Move.L    (A7)+, A3
F262   200B                      Move.L    A3, D0
F264   672C                      BEQ       L2221
F266   2053                      Move.L    (A3), A0
F268   594F                      SubQ.L    $4, A7
F26A   2F2E 000C                 Move.L    $C(A6), -(A7)
F26E   2F08                      Move.L    A0, -(A7)
F270   4868 0012                 Pea.L     $12(A0)
F274   2F28 0008                 Move.L    $8(A0), -(A7)
F278   2F2E 0008                 Move.L    $8(A6), -(A7)
F27C   3F28 000C                 Move      $C(A0), -(A7)
F280   2F28 000E                 Move.L    $E(A0), -(A7)
F284   08D3 0007                 BSet.B    $7, (A3)
F288   A913                      _NewWindow
F28A   2D5F 0012                 Move.L    (A7)+, $12(A6)
F28E   2F0B                      Move.L    A3, -(A7)
F290   A9A3                      _ReleaseResource
F292   265F           L2221:     Move.L    (A7)+, A3
F294   4E5E                      Unlk      A6
F296   205F                      Move.L    (A7)+, A0
F298   DEFC 000A                 AddA      $A, A7
F29C   4ED0                      Jmp       (A0)

                      P_tGetNewControl:
F29E   4E56 0000                 Link      A6, $0
F2A2   2F0B                      Move.L    A3, -(A7)
F2A4   42AE 000E                 Clr.L     $E(A6)
F2A8   594F                      SubQ.L    $4, A7
F2AA   2F3C 434E 544C            Move.L    $434E544C, -(A7)
F2B0   3F2E 000C                 Move      $C(A6), -(A7)
F2B4   A9A0                      _GetResource
F2B6   265F                      Move.L    (A7)+, A3
F2B8   200B                      Move.L    A3, D0
F2BA   6728                      BEQ       L2222
F2BC   2053                      Move.L    (A3), A0
F2BE   594F                      SubQ.L    $4, A7
F2C0   2F2E 0008                 Move.L    $8(A6), -(A7)
F2C4   2F08                      Move.L    A0, -(A7)
F2C6   4868 0016                 Pea.L     $16(A0)
F2CA   43E8 0008                 Lea.L     $8(A0), A1
F2CE   2F19                      Move.L    (A1)+, -(A7)
F2D0   2F19                      Move.L    (A1)+, -(A7)
F2D2   3F19                      Move      (A1)+, -(A7)
F2D4   2F19                      Move.L    (A1)+, -(A7)
F2D6   08D3 0007                 BSet.B    $7, (A3)
F2DA   A954                      _NewControl
F2DC   2D5F 000E                 Move.L    (A7)+, $E(A6)
F2E0   2F0B                      Move.L    A3, -(A7)
F2E2   A9A3                      _ReleaseResource
F2E4   265F           L2222:     Move.L    (A7)+, A3
F2E6   4E5E                      Unlk      A6
F2E8   205F                      Move.L    (A7)+, A0
F2EA   5C4F                      AddQ      $6, A7
F2EC   4ED0                      Jmp       (A0)

                      P_tGetRMenu:
F2EE   4E56 0000                 Link      A6, $0
F2F2   2F0B                      Move.L    A3, -(A7)
F2F4   594F                      SubQ.L    $4, A7
F2F6   2F3C 4D45 4E55            Move.L    $4D454E55, -(A7)
F2FC   3F2E 0008                 Move      $8(A6), -(A7)
F300   A9A0                      _GetResource
F302   265F                      Move.L    (A7)+, A3
F304   2D4B 000A                 Move.L    A3, $A(A6)
F308   671A                      BEQ       L2223
F30A   594F                      SubQ.L    $4, A7
F30C   2F3C 4D44 4546            Move.L    $4D444546, -(A7)
F312   2053                      Move.L    (A3), A0
F314   3F28 0006                 Move      $6(A0), -(A7)
F318   A9A0                      _GetResource
F31A   2053                      Move.L    (A3), A0
F31C   215F 0006                 Move.L    (A7)+, $6(A0)
F320   2F0B                      Move.L    A3, -(A7)
F322   A948                      _CalcMenuSize
F324   265F           L2223:     Move.L    (A7)+, A3
F326   4E5E                      Unlk      A6
F328   205F                      Move.L    (A7)+, A0
F32A   544F                      AddQ      $2, A7
F32C   4ED0                      Jmp       (A0)

                      P_tGetNewMBar:
F32E   4E56 0000                 Link      A6, $0
F332   48E7 1010                 MoveM.L   D3/A3, -(A7)
F336   42AE 000A                 Clr.L     $A(A6)
F33A   594F                      SubQ.L    $4, A7
F33C   A93B                      _GetMenuBar
F33E   A934                      _ClearMenuBar
F340   594F                      SubQ.L    $4, A7
F342   2F3C 4D42 4152            Move.L    $4D424152, -(A7)
F348   3F2E 0008                 Move      $8(A6), -(A7)
F34C   A9A0                      _GetResource
F34E   265F                      Move.L    (A7)+, A3
F350   200B                      Move.L    A3, D0
F352   6728                      BEQ       L2225
F354   7600                      MoveQ.L   $0, D3
F356   594F           L2224:     SubQ.L    $4, A7
F358   2053                      Move.L    (A3), A0
F35A   3003                      Move      D3, D0
F35C   D040                      Add       D0, D0
F35E   3F30 0002                 Move      $2(A0,D0.W), -(A7)
F362   618A                      Bsr       P_tGetRMenu
F364   4267                      Clr       -(A7)
F366   A935                      _InsertMenu
F368   2053                      Move.L    (A3), A0
F36A   5243                      AddQ      $1, D3
F36C   B650                      Cmp       (A0), D3
F36E   6DE6                      BLT       L2224
F370   594F                      SubQ.L    $4, A7
F372   A93B                      _GetMenuBar
F374   2D5F 000A                 Move.L    (A7)+, $A(A6)
F378   2F0B                      Move.L    A3, -(A7)
F37A   A9A3                      _ReleaseResource
F37C   2F17           L2225:     Move.L    (A7), -(A7)
F37E   A93C                      _SetMenuBar
F380   205F                      Move.L    (A7)+, A0
F382   A023                      _DisposeHandle
F384   4CDF 0808                 MoveM.L   (A7)+, D3/A3
F388   4E5E                      Unlk      A6
F38A   205F                      Move.L    (A7)+, A0
F38C   544F                      AddQ      $2, A7
F38E   4ED0                      Jmp       (A0)

                      P_tTEGetText:
F390   6100 049C                 Bsr       P441
F394   24AB 003E                 Move.L    $3E(A3), (A2)
F398   6000 00BE                 Bra       L2229

                      P_tTEInit:
F39C   7000                      MoveQ.L   $0, D0
F39E   31C0 0AB0                 Move      D0, (TEScrpLength)
F3A2   A122                      _NewHandle
F3A4   21C8 0AB4                 Move.L    A0, (TEScrpHandle)
F3A8   41FA 0304                 Lea.L     P_TEDoText, A0
F3AC   21C8 0A70                 Move.L    A0, (TEDoText)
F3B0   41FA 0666                 Lea.L     P_TERecal, A0
F3B4   21C8 0A74                 Move.L    A0, (TERecal)
F3B8   41FA 05EC                 Lea.L     P_TEWdBreak, A0
F3BC   21C8 0AF6                 Move.L    A0, (TEWdBreak)
F3C0   4E75                      Rts

                      P_tTEDispose:
F3C2   48E7 3F38                 MoveM.L   D2-D7/A2-A4, -(A7)
F3C6   286F 0028                 Move.L    $28(A7), A4
F3CA   2654                      Move.L    (A4), A3
F3CC   206B 003E                 Move.L    $3E(A3), A0
F3D0   A023                      _DisposeHandle
F3D2   204C                      Move.L    A4, A0
F3D4   A023                      _DisposeHandle
F3D6   7004                      MoveQ.L   $4, D0
F3D8   603A                      Bra       L2227

                      P_tTETextBox:
F3DA   48E7 3F38                 MoveM.L   D2-D7/A2-A4, -(A7)
F3DE   594F                      SubQ.L    $4, A7
F3E0   2F2F 002E                 Move.L    $2E(A7), -(A7)
F3E4   2F17                      Move.L    (A7), -(A7)
F3E6   2F17                      Move.L    (A7), -(A7)
F3E8   A8A3                      _EraseRect
F3EA   A9D2                      _TENew
F3EC   285F                      Move.L    (A7)+, A4
F3EE   2054                      Move.L    (A4), A0
F3F0   316F 0028 003A            Move      $28(A7), $3A(A0)
F3F6   202F 002E                 Move.L    $2E(A7), D0
F3FA   6712                      BEQ       L2226
F3FC   2F2F 0032                 Move.L    $32(A7), -(A7)
F400   2F00                      Move.L    D0, -(A7)
F402   2F0C                      Move.L    A4, -(A7)
F404   A9CF                      _TESetText
F406   2F2F 002A                 Move.L    $2A(A7), -(A7)
F40A   2F0C                      Move.L    A4, -(A7)
F40C   A9D3                      _TEUpdate
F40E   2F0C           L2226:     Move.L    A4, -(A7)
F410   A9CD                      _TEDispose
F412   700E                      MoveQ.L   $E, D0
F414   6060           L2227:     Bra       L2231

                      P_tTESetText:
F416   6100 0416                 Bsr       P441
F41A   201A                      Move.L    (A2)+, D0
F41C   3740 0020                 Move      D0, $20(A3)
F420   3740 0022                 Move      D0, $22(A3)
F424   3740 003C                 Move      D0, $3C(A3)
F428   205A                      Move.L    (A2)+, A0
F42A   226B 003E                 Move.L    $3E(A3), A1
F42E   0891 0007                 BClr.B    $7, (A1)
F432   A9E2                      _PtrToXHand
F434   2F0C                      Move.L    A4, -(A7)
F436   A9D0                      _TECalText
F438   6000 07D8      L2228:     Bra       L2298

                      P_tTECalText:
F43C   6100 03F0                 Bsr       P441
F440   2F2B 0020                 Move.L    $20(A3), -(A7)
F444   426B 0020                 Clr       $20(A3)
F448   3E3C 8002                 Move      $-7FFE, D7
F44C   42AB 0060                 Clr.L     $60(A3)
F450   6100 05C0                 Bsr       P_doTERecal
F454   275F 0020                 Move.L    (A7)+, $20(A3)
F458   7004           L2229:     MoveQ.L   $4, D0
F45A   286F 0032      L2230:     Move.L    $32(A7), A4
F45E   2654                      Move.L    (A4), A3
F460   3800                      Move      D0, D4
F462   206B 003E                 Move.L    $3E(A3), A0
F466   0890 0007                 BClr.B    $7, (A0)
F46A   2F17                      Move.L    (A7), -(A7)
F46C   A879                      _SetClip
F46E   A8D9                      _DisposeRgn
F470   189F                      Move.B    (A7)+, (A4)
F472   A873                      _SetPort
F474   3004                      Move      D4, D0
F476   4CDF 1CFC      L2231:     MoveM.L   (A7)+, D2-D7/A2-A4
F47A   205F                      Move.L    (A7)+, A0
F47C   DEC0                      AddA      D0, A7
F47E   4ED0                      Jmp       (A0)

                      P_tTESetSelect:
F480   6100 03AC                 Bsr       P441
F484   6100 065A                 Bsr       P453
F488   6100 00A2                 Bsr       P433
F48C   275A 0020                 Move.L    (A2)+, $20(A3)
F490   275A 001E                 Move.L    (A2)+, $1E(A3)
F494   6100 03EA                 Bsr       P442
F498   6100 0628                 Bsr       P452
F49C   6100 008E                 Bsr       P433
F4A0   6096                      Bra       L2228

                      P_tTENew:
F4A2   48E7 3F38                 MoveM.L   D2-D7/A2-A4, -(A7)
F4A6   7068                      MoveQ.L   $68, D0
F4A8   A322                      _NewHandleClear
F4AA   2848                      Move.L    A0, A4
F4AC   08D4 0007                 BSet.B    $7, (A4)
F4B0   2654                      Move.L    (A4), A3
F4B2   7000                      MoveQ.L   $0, D0
F4B4   A122                      _NewHandle
F4B6   2748 003E                 Move.L    A0, $3E(A3)
F4BA   41D3                      Lea.L     (A3), A0
F4BC   246F 002C                 Move.L    $2C(A7), A2
F4C0   20DA                      Move.L    (A2)+, (A0)+
F4C2   20DA                      Move.L    (A2)+, (A0)+
F4C4   246F 0028                 Move.L    $28(A7), A2
F4C8   20DA                      Move.L    (A2)+, (A0)+
F4CA   20DA                      Move.L    (A2)+, (A0)+
F4CC   514F                      SubQ.L    $8, A7
F4CE   2F0F                      Move.L    A7, -(A7)
F4D0   A88B                      _GetFontInfo
F4D2   301F                      Move      (A7)+, D0
F4D4   3740 001A                 Move      D0, $1A(A3)
F4D8   D05F                      Add       (A7)+, D0
F4DA   544F                      AddQ      $2, A7
F4DC   D05F                      Add       (A7)+, D0
F4DE   3740 0018                 Move      D0, $18(A3)
F4E2   2455                      Move.L    (A5), A2
F4E4   2452                      Move.L    (A2), A2
F4E6   274A 0052                 Move.L    A2, $52(A3)
F4EA   276A 0044 004A            Move.L    $44(A2), $4A(A3)
F4F0   276A 0048 004E            Move.L    $48(A2), $4E(A3)
F4F6   2778 0AF6 0026            Move.L    (TEWdBreak), $26(A3)
F4FC   0894 0007                 BClr.B    $7, (A4)
F500   2F4C 0030                 Move.L    A4, $30(A7)
F504   7008                      MoveQ.L   $8, D0
F506   6000 FF6E                 Bra       L2231

                      P_tTEUpdate:
F50A   6100 0322                 Bsr       P441
F50E   205A                      Move.L    (A2)+, A0
F510   3010                      Move      (A0), D0
F512   3228 0004                 Move      $4(A0), D1
F516   6100 0794                 Bsr       P458
F51A   6000 0772                 Bra       L2302

                      P432:
F51E   3006                      Move      D6, D0
F520   3206                      Move      D6, D1
F522   4A02                      Tst.B     D2
F524   6704                      BEQ       L2232
F526   6100 0444                 Bsr       P447
F52A   4E75           L2232:     Rts

                      P433:
F52C   4A2B 0024                 Tst.B     $24(A3)
F530   67F8                      BEQ       L2232
F532   4CAB 0018 0020            MoveM     $20(A3), D3-D4
F538   7E01                      MoveQ.L   $1, D7
F53A   6000 016C                 Bra       P_doTEDoText

                      P_tTEClick:
F53E   6100 02EE                 Bsr       P441
F542   276F 0038 001C            Move.L    $38(A7), $1C(A3)
F548   6100 00D2                 Bsr       P434
F54C   6100 0592                 Bsr       P453
F550   594F                      SubQ.L    $4, A7
F552   A975                      _TickCount
F554   2017                      Move.L    (A7), D0
F556   90AB 002E                 Sub.L     $2E(A3), D0
F55A   B0B8 02F0                 Cmp.L     (DoubleTime), D0
F55E   5FC2                      SLE.B     D2
F560   BC6B 0032                 Cmp       $32(A3), D6
F564   57C1                      SEQ.B     D1
F566   C401                      And.B     D1, D2
F568   3746 0032                 Move      D6, $32(A3)
F56C   275F 002E                 Move.L    (A7)+, $2E(A3)
F570   4A2F 0036                 Tst.B     $36(A7)
F574   6718                      BEQ       L2235
F576   4CAB 0003 0020            MoveM     $20(A3), D0-D1
F57C   B046                      Cmp       D6, D0
F57E   6406                      BCC       L2233
F580   3440                      Move      D0, A2
F582   3840                      Move      D0, A4
F584   6004                      Bra       L2234
F586   3441           L2233:     Move      D1, A2
F588   3841                      Move      D1, A4
F58A   3A06           L2234:     Move      D6, D5
F58C   6040                      Bra       L2238
F58E   619C           L2235:     Bsr       P433
F590   618C                      Bsr       P432
F592   48AB 0003 0020            MoveM     D0-D1, $20(A3)
F598   3440                      Move      D0, A2
F59A   3841                      Move      D1, A4
F59C   3A06                      Move      D6, D5
F59E   176B 0046 0047            Move.B    $46(A3), $47(A3)
F5A4   6100 051C                 Bsr       P452
F5A8   6182                      Bsr       P433
F5AA   202B 002A      L2236:     Move.L    $2A(A3), D0
F5AE   6706                      BEQ       L2237
F5B0   2040                      Move.L    D0, A0
F5B2   4E90                      Jsr       (A0)
F5B4   675C                      BEQ       L2242
F5B6   4267           L2237:     Clr       -(A7)
F5B8   A977                      _WaitMouseUp
F5BA   4A5F                      Tst       (A7)+
F5BC   6754                      BEQ       L2242
F5BE   486B 001C                 Pea.L     $1C(A3)
F5C2   A972                      _GetMouse
F5C4   6156                      Bsr       P434
F5C6   BA46                      Cmp       D6, D5
F5C8   67E0                      BEQ       L2236
F5CA   6100 0514                 Bsr       P453
F5CE   6100 FF4E      L2238:     Bsr       P432
F5D2   41EB 0022                 Lea.L     $22(A3), A0
F5D6   B8C6                      CmpA      D6, A4
F5D8   6512                      BCS       L2239
F5DA   3620                      Move      -(A0), D3
F5DC   30C0                      Move      D0, (A0)+
F5DE   3800                      Move      D0, D4
F5E0   4843                      Swap      D3
F5E2   4844                      Swap      D4
F5E4   360C                      Move      A4, D3
F5E6   3818                      Move      (A0)+, D4
F5E8   310C                      Move      A4, -(A0)
F5EA   6014                      Bra       L2240
F5EC   B4C6           L2239:     CmpA      D6, A2
F5EE   621E                      BHI       L2241
F5F0   3618                      Move      (A0)+, D3
F5F2   3101                      Move      D1, -(A0)
F5F4   3801                      Move      D1, D4
F5F6   4843                      Swap      D3
F5F8   4844                      Swap      D4
F5FA   3620                      Move      -(A0), D3
F5FC   380A                      Move      A2, D4
F5FE   30CA                      Move      A2, (A0)+
F600   7E01           L2240:     MoveQ.L   $1, D7
F602   6100 00A4                 Bsr       P_doTEDoText
F606   4843                      Swap      D3
F608   4844                      Swap      D4
F60A   6100 009C                 Bsr       P_doTEDoText
F60E   3A06           L2241:     Move      D6, D5
F610   6098                      Bra       L2236
F612   6100 04AE      L2242:     Bsr       P452
F616   700A                      MoveQ.L   $A, D0
F618   6000 FE40                 Bra       L2230

                      P434:
F61C   302B 001C                 Move      $1C(A3), D0
F620   6100 067C                 Bsr       P457
F624   6C12                      BGE       L2243
F626   D040                      Add       D0, D0
F628   6D14                      BLT       L2244
F62A   4CB3 0018 0060            MoveM     $60(A3,D0.W), D3-D4
F630   7E00                      MoveQ.L   $0, D7
F632   6174                      Bsr       P_doTEDoText
F634   3C00                      Move      D0, D6
F636   4E75                      Rts
F638   3C2B 003C      L2243:     Move      $3C(A3), D6
F63C   4E75                      Rts
F63E   7C00           L2244:     MoveQ.L   $0, D6
F640   4E75                      Rts

                      P435:
F642   302B 0018                 Move      $18(A3), D0
F646   D16B 0010                 Add       D0, $10(A3)
F64A   D16B 0014                 Add       D0, $14(A3)
F64E   D16A 0030                 Add       D0, $30(A2)
F652   4E75                      Rts

                      P436:
F654   3F03                      Move      D3, -(A7)
F656   3614                      Move      (A4), D3
F658   6122                      Bsr       P437
F65A   361F                      Move      (A7)+, D3
F65C   322B 0006                 Move      $6(A3), D1
F660   926B 0002                 Sub       $2(A3), D1
F664   9240                      Sub       D0, D1
F666   5341                      SubQ.L    $1, D1
F668   4A6B 003A                 Tst       $3A(A3)
F66C   6708                      BEQ       L2246
F66E   6B02                      BMI       L2245
F670   E241                      AsR       $1, D1
F672   D36A 0032      L2245:     Add       D1, $32(A2)
F676   526A 0032      L2246:     AddQ      $1, $32(A2)
F67A   4E75                      Rts

                      P437:
F67C   3F03                      Move      D3, -(A7)
F67E   5343           L2247:     SubQ.L    $1, D3
F680   BC43                      Cmp       D3, D6
F682   6708                      BEQ       L2248
F684   3243                      Move      D3, A1
F686   6100 0306                 Bsr       P448
F68A   66F2                      BNE       L2247
F68C   5243           L2248:     AddQ      $1, D3
F68E   6104                      Bsr       P438
F690   361F                      Move      (A7)+, D3
F692   4E75                      Rts

                      P438:
F694   554F                      SubQ.L    $2, A7
F696   206B 003E                 Move.L    $3E(A3), A0
F69A   2F10                      Move.L    (A0), -(A7)
F69C   3F06                      Move      D6, -(A7)
F69E   3F03                      Move      D3, -(A7)
F6A0   9D57                      Sub       D6, (A7)
F6A2   A886                      _TextWidth
F6A4   301F                      Move      (A7)+, D0
F6A6   4E75                      Rts

                      P_doTEDoText:
F6A8   2F38 0A70                 Move.L    (TEDoText), -(A7)
F6AC   4E75                      Rts

                      P_TEDoText:
F6AE   48E7 3F38                 MoveM.L   D2-D7/A2-A4, -(A7)
F6B2   2455                      Move.L    (A5), A2
F6B4   2452                      Move.L    (A2), A2
F6B6   3013                      Move      (A3), D0
F6B8   3740 0010                 Move      D0, $10(A3)
F6BC   D06B 0018                 Add       $18(A3), D0
F6C0   3740 0014                 Move      D0, $14(A3)
F6C4   2553 0030                 Move.L    (A3), $30(A2)
F6C8   302B 001A                 Move      $1A(A3), D0
F6CC   D16A 0030                 Add       D0, $30(A2)
F6D0   B843                      Cmp       D3, D4
F6D2   6402                      BCC       L2249
F6D4   C943                      Exg.L     D4, D3
F6D6   49EB 0060      L2249:     Lea.L     $60(A3), A4
F6DA   3C1C           L2250:     Move      (A4)+, D6
F6DC   3014                      Move      (A4), D0
F6DE   B06B 003C                 Cmp       $3C(A3), D0
F6E2   6418                      BCC       L2252
F6E4   B640                      Cmp       D0, D3
F6E6   6536                      BCS       L2253
F6E8   660C                      BNE       L2251
F6EA   0C47 FFFE                 Cmp       $-2, D7
F6EE   6606                      BNE       L2251
F6F0   4A2B 0047                 Tst.B     $47(A3)
F6F4   6728                      BEQ       L2253
F6F6   6100 FF4A      L2251:     Bsr       P435
F6FA   60DE                      Bra       L2250
F6FC   0C07 00FE      L2252:     Cmp.B     $-2, D7
F700   661C                      BNE       L2253
F702   206B 003E                 Move.L    $3E(A3), A0
F706   2050                      Move.L    (A0), A0
F708   1230 00FF                 Move.B    $-1(A0,D0.W), D1
F70C   0C01 000D                 Cmp.B     $D, D1
F710   660C                      BNE       L2253
F712   B043                      Cmp       D3, D0
F714   6608                      BNE       L2253
F716   6100 FF2A                 Bsr       P435
F71A   3C14                      Move      (A4), D6
F71C   6008                      Bra       L2254
F71E   6100 FF74      L2253:     Bsr       P438
F722   D16A 0032                 Add       D0, $32(A2)
F726   6100 FF2C      L2254:     Bsr       P436
F72A   3C03                      Move      D3, D6
F72C   6000 00DA                 Bra       L2264
F730   BC54           L2255:     Cmp       (A4), D6
F732   651C                      BCS       L2256
F734   544C                      AddQ      $2, A4
F736   302A 0030                 Move      $30(A2), D0
F73A   B06B 000C                 Cmp       $C(A3), D0
F73E   6E00 00D6                 BGT       L2266
F742   6100 FEFE                 Bsr       P435
F746   356B 0002 0032            Move      $2(A3), $32(A2)
F74C   6100 FF06                 Bsr       P436
F750   376A 0032 0012 L2256:     Move      $32(A2), $12(A3)
F756   31EA 0032 09FA            Move      $32(A2), (scratch8)
F75C   4A47                      Tst       D7
F75E   6606                      BNE       L2257
F760   3606                      Move      D6, D3
F762   5243                      AddQ      $1, D3
F764   600A                      Bra       L2259
F766   B854           L2257:     Cmp       (A4), D4
F768   6404                      BCC       L2258
F76A   3604                      Move      D4, D3
F76C   6002                      Bra       L2259
F76E   3614           L2258:     Move      (A4), D3
F770   6100 FF22      L2259:     Bsr       P438
F774   3400                      Move      D0, D2
F776   D06A 0032                 Add       $32(A2), D0
F77A   3A00                      Move      D0, D5
F77C   3F00                      Move      D0, -(A7)
F77E   3740 0016                 Move      D0, $16(A3)
F782   BC6C FFFE                 Cmp       $-2(A4), D6
F786   660E                      BNE       L2260
F788   377C 8002 0012            Move      $-7FFE, $12(A3)
F78E   DA45                      Add       D5, D5
F790   9A78 09FA                 Sub       (scratch8), D5
F794   9A42                      Sub       D2, D5
F796   B654           L2260:     Cmp       (A4), D3
F798   6618                      BNE       L2261
F79A   377C 7FFE 0016            Move      $7FFE, $16(A3)
F7A0   206B 003E                 Move.L    $3E(A3), A0
F7A4   2050                      Move.L    (A0), A0
F7A6   0C30 000D 6000            Cmp.B     $D, $0(A0,D6.W)
F7AC   6604                      BNE       L2261
F7AE   3A3C 7000                 Move      $7000, D5
F7B2   4A47           L2261:     Tst       D7
F7B4   6A14                      BPL       L2262
F7B6   486B 0010                 Pea.L     $10(A3)
F7BA   A8A3                      _EraseRect
F7BC   206B 003E                 Move.L    $3E(A3), A0
F7C0   2F10                      Move.L    (A0), -(A7)
F7C2   3F06                      Move      D6, -(A7)
F7C4   3F03                      Move      D3, -(A7)
F7C6   9D57                      Sub       D6, (A7)
F7C8   A885                      _DrawText
F7CA   3C03           L2262:     Move      D3, D6
F7CC   355F 0032                 Move      (A7)+, $32(A2)
F7D0   4A47                      Tst       D7
F7D2   6F06                      BLE       L2263
F7D4   202B 0056                 Move.L    $56(A3), D0
F7D8   6146                      Bsr       P440
F7DA   4A47           L2263:     Tst       D7
F7DC   662A                      BNE       L2264
F7DE   4267                      Clr       -(A7)
F7E0   2F2B 001C                 Move.L    $1C(A3), -(A7)
F7E4   486B 0010                 Pea.L     $10(A3)
F7E8   A8AD                      _PtInRect
F7EA   4A1F                      Tst.B     (A7)+
F7EC   671A                      BEQ       L2264
F7EE   51EB 0046                 SF.B      $46(A3)
F7F2   9A6B 001E                 Sub       $1E(A3), D5
F7F6   9A6B 001E                 Sub       $1E(A3), D5
F7FA   DA78 09FA                 Add       (scratch8), D5
F7FE   6D16                      BLT       L2266
F800   5346                      SubQ.L    $1, D6
F802   50EB 0046                 ST.B      $46(A3)
F806   600E                      Bra       L2266
F808   BC44           L2264:     Cmp       D4, D6
F80A   6408                      BCC       L2265
F80C   BC6B 003C                 Cmp       $3C(A3), D6
F810   6500 FF1E                 BCS       L2255
F814   7C00           L2265:     MoveQ.L   $0, D6
F816   3006           L2266:     Move      D6, D0
F818   204A                      Move.L    A2, A0
F81A   4CDF 1CFC                 MoveM.L   (A7)+, D2-D7/A2-A4
F81E   4E75                      Rts

                      P440:
F820   486B 0010                 Pea.L     $10(A3)
F824   6704                      BEQ       L2267
F826   2040                      Move.L    D0, A0
F828   4ED0                      Jmp       (A0)
F82A   A8A4           L2267:     _InvertRect
F82C   4E75                      Rts

                      P441:
F82E   205F                      Move.L    (A7)+, A0
F830   48E7 3F38                 MoveM.L   D2-D7/A2-A4, -(A7)
F834   9EFC 000A                 SubA      $A, A7
F838   2F08                      Move.L    A0, -(A7)
F83A   286F 0036                 Move.L    $36(A7), A4
F83E   2654                      Move.L    (A4), A3
F840   1F54 0008                 Move.B    (A4), $8(A7)
F844   486F 000A                 Pea.L     $A(A7)
F848   A874                      _GetPort
F84A   08D4 0007                 BSet.B    $7, (A4)
F84E   246B 0052                 Move.L    $52(A3), A2
F852   2F0A                      Move.L    A2, -(A7)
F854   A873                      _SetPort
F856   594F                      SubQ.L    $4, A7
F858   A8D8                      _NewRgn
F85A   2F57 0008                 Move.L    (A7), $8(A7)
F85E   2F17                      Move.L    (A7), -(A7)
F860   A87A                      _GetClip
F862   486B 0008                 Pea.L     $8(A3)
F866   A87B                      _ClipRect
F868   2F2A 001C                 Move.L    $1C(A2), -(A7)
F86C   2F17                      Move.L    (A7), -(A7)
F86E   A8E4                      _SectRgn
F870   2055                      Move.L    (A5), A0
F872   2050                      Move.L    (A0), A0
F874   216B 004A 0044            Move.L    $4A(A3), $44(A0)
F87A   216B 004E 0048            Move.L    $4E(A3), $48(A0)

                      P442:
F880   206B 003E                 Move.L    $3E(A3), A0
F884   A029                      _HLock
F886   A025                      _GetHandleSize
F888   3740 003C                 Move      D0, $3C(A3)
F88C   322B 0022                 Move      $22(A3), D1
F890   9240                      Sub       D0, D1
F892   6304                      BLS       L2268
F894   3740 0022                 Move      D0, $22(A3)
F898   322B 0020      L2268:     Move      $20(A3), D1
F89C   926B 0022                 Sub       $22(A3), D1
F8A0   6304                      BLS       L2269
F8A2   936B 0020                 Sub       D1, $20(A3)
F8A6   6106           L2269:     Bsr       P443
F8A8   45EF 003A                 Lea.L     $3A(A7), A2
F8AC   4E75                      Rts

                      P443:
F8AE   45EB 0020                 Lea.L     $20(A3), A2
F8B2   2012                      Move.L    (A2), D0
F8B4   B052                      Cmp       (A2), D0
F8B6   6404                      BCC       L2270
F8B8   4840                      Swap      D0
F8BA   2480                      Move.L    D0, (A2)
F8BC   4E75           L2270:     Rts

                      P_tTECopy:
F8BE   6100 FF6E                 Bsr       P441
F8C2   61EA                      Bsr       P443
F8C4   9052                      Sub       (A2), D0
F8C6   31C0 0AB0                 Move      D0, (TEScrpLength)
F8CA   206B 003E                 Move.L    $3E(A3), A0
F8CE   2050                      Move.L    (A0), A0
F8D0   D0D2                      AddA      (A2), A0
F8D2   2278 0AB4                 Move.L    (TEScrpHandle), A1
F8D6   7000                      MoveQ.L   $0, D0
F8D8   3038 0AB0                 Move      (TEScrpLength), D0
F8DC   A9E2                      _PtrToXHand
F8DE   6000 FB78      L2271:     Bra       L2229

                      P_tTECut:
F8E2   6100 FF4A                 Bsr       P441
F8E6   2F0C                      Move.L    A4, -(A7)
F8E8   2F0C                      Move.L    A4, -(A7)
F8EA   A9D5                      _TECopy
F8EC   A9D7                      _TEDelete
F8EE   60EE                      Bra       L2271

                      P_tTEDelete:
F8F0   6100 FF3C                 Bsr       P441
F8F4   6100 01EA                 Bsr       P453
F8F8   6108                      Bsr       P444
F8FA   6132                      Bsr       P445
F8FC   6100 01C4                 Bsr       P452
F900   60DC                      Bra       L2271

                      P444:
F902   61AA                      Bsr       P443
F904   3E00                      Move      D0, D7
F906   9E52                      Sub       (A2), D7
F908   6722                      BEQ       L2272
F90A   598F                      SubQ.L    $4, A7
F90C   206B 003E                 Move.L    $3E(A3), A0
F910   2F08                      Move.L    A0, -(A7)
F912   A02A                      _HUnlock
F914   3F12                      Move      (A2), -(A7)
F916   4267                      Clr       -(A7)
F918   42A7                      Clr.L     -(A7)
F91A   3F07                      Move      D7, -(A7)
F91C   4267                      Clr       -(A7)
F91E   42A7                      Clr.L     -(A7)
F920   42A7                      Clr.L     -(A7)
F922   A9E0                      _Munger
F924   588F                      AddQ      $4, A7
F926   9F6B 003C                 Sub       D7, $3C(A3)
F92A   349A                      Move      (A2)+, (A2)
F92C   4E75           L2272:     Rts

                      P445:
F92E   7400                      MoveQ.L   $0, D2
F930   382B 003C                 Move      $3C(A3), D4
F934   6100 00DC                 Bsr       P_doTERecal
F938   3602                      Move      D2, D3
F93A   302B 005E                 Move      $5E(A3), D0
F93E   C0EB 0018                 MulU      $18(A3), D0
F942   41EB 0014                 Lea.L     $14(A3), A0
F946   20BC 7FF0 7FF0            Move.L    $7FF07FF0, (A0)
F94C   2113                      Move.L    (A3), -(A0)
F94E   D150                      Add       D0, (A0)
F950   2F08                      Move.L    A0, -(A7)
F952   A8A3                      _EraseRect
F954   4A6B 003A                 Tst       $3A(A3)
F958   6608                      BNE       L2273
F95A   610C                      Bsr       P446
F95C   3600                      Move      D0, D3
F95E   6702                      BEQ       L2273
F960   5343                      SubQ.L    $1, D3
F962   7EFF           L2273:     MoveQ.L   $-1, D7
F964   6000 FD42                 Bra       P_doTEDoText

                      P446:
F968   302B 0020                 Move      $20(A3), D0

                      P447:
F96C   3200                      Move      D0, D1
F96E   670C                      BEQ       L2275
F970   5340           L2274:     SubQ.L    $1, D0
F972   6308                      BLS       L2275
F974   3240                      Move      D0, A1
F976   6116                      Bsr       P448
F978   67F6                      BEQ       L2274
F97A   5240                      AddQ      $1, D0
F97C   B26B 003C      L2275:     Cmp       $3C(A3), D1
F980   640A                      BCC       L2276
F982   3241                      Move      D1, A1
F984   6108                      Bsr       P448
F986   6604                      BNE       L2276
F988   5241                      AddQ      $1, D1
F98A   60F0                      Bra       L2275
F98C   4E75           L2276:     Rts

                      P448:
F98E   48E7 80C0                 MoveM.L   D0/A0-A1, -(A7)
F992   3009                      Move      A1, D0
F994   206B 003E                 Move.L    $3E(A3), A0
F998   2050                      Move.L    (A0), A0
F99A   226B 0026                 Move.L    $26(A3), A1
F99E   4E91                      Jsr       (A1)
F9A0   4CDF 0301                 MoveM.L   (A7)+, D0/A0-A1
F9A4   4E75                      Rts

                      P_TEWdBreak:
F9A6   0C30 0020 0000            Cmp.B     $20, $0(A0,D0.W)
F9AC   53C0                      SLS.B     D0
F9AE   4A00                      Tst.B     D0
F9B0   4E75                      Rts

                      P449:
F9B2   48E7 7F60                 MoveM.L   D1-D7/A1-A2, -(A7)
F9B6   346B 0006                 Move      $6(A3), A2
F9BA   94EB 0002                 SubA      $2(A3), A2
F9BE   534A                      SubQ.L    $1, A2
F9C0   7AFE                      MoveQ.L   $-2, D5
F9C2   7EFF                      MoveQ.L   $-1, D7
F9C4   3606           L2277:     Move      D6, D3
F9C6   B66B 003C      L2278:     Cmp       $3C(A3), D3
F9CA   6432                      BCC       L2282
F9CC   4A2B 0048                 Tst.B     $48(A3)
F9D0   6618                      BNE       L2281
F9D2   4A47                      Tst       D7
F9D4   6706                      BEQ       L2279
F9D6   3003                      Move      D3, D0
F9D8   6192                      Bsr       P447
F9DA   6004                      Bra       L2280
F9DC   3203           L2279:     Move      D3, D1
F9DE   5241                      AddQ      $1, D1
F9E0   3601           L2280:     Move      D1, D3
F9E2   6100 FC98                 Bsr       P437
F9E6   B04A                      Cmp       A2, D0
F9E8   6C1A                      BGE       L2283
F9EA   3A03           L2281:     Move      D3, D5
F9EC   206B 003E                 Move.L    $3E(A3), A0
F9F0   2050                      Move.L    (A0), A0
F9F2   0C30 000D 3000            Cmp.B     $D, $0(A0,D3.W)
F9F8   670A                      BEQ       L2283
F9FA   5243                      AddQ      $1, D3
F9FC   60C8                      Bra       L2278
F9FE   3A2B 003C      L2282:     Move      $3C(A3), D5
FA02   5345                      SubQ.L    $1, D5
FA04   7E00           L2283:     MoveQ.L   $0, D7
FA06   5245                      AddQ      $1, D5
FA08   6BBA                      BMI       L2277
FA0A   3005                      Move      D5, D0
FA0C   4CDF 06FE                 MoveM.L   (A7)+, D1-D7/A1-A2
FA10   4E75                      Rts

                      P_doTERecal:
FA12   2F38 0A74                 Move.L    (TERecal), -(A7)
FA16   4E75                      Rts

                      P_TERecal:
FA18   4E56 0000                 Link      A6, $0
FA1C   48E7 3E20                 MoveM.L   D2-D6/A2, -(A7)
FA20   45EB 005E                 Lea.L     $5E(A3), A2
FA24   425A                      Clr       (A2)+
FA26   6100 FF40                 Bsr       P446
FA2A   3600                      Move      D0, D3
FA2C   671A                      BEQ       L2285
FA2E   5343                      SubQ.L    $1, D3
FA30   3C1A           L2284:     Move      (A2)+, D6
FA32   3D46 FFEA                 Move      D6, $-16(A6)
FA36   3012                      Move      (A2), D0
FA38   B06B 003C                 Cmp       $3C(A3), D0
FA3C   6414                      BCC       L2287
FA3E   B640                      Cmp       D0, D3
FA40   6510                      BCS       L2287
FA42   526B 005E                 AddQ      $1, $5E(A3)
FA46   60E8                      Bra       L2284
FA48   3C1A           L2285:     Move      (A2)+, D6
FA4A   6006                      Bra       L2287
FA4C   BC6B 003C      L2286:     Cmp       $3C(A3), D6
FA50   642C                      BCC       L2291
FA52   6100 FF5E      L2287:     Bsr       P449
FA56   3600                      Move      D0, D3
FA58   B66B 0022                 Cmp       $22(A3), D3
FA5C   6306                      BLS       L2288
FA5E   9752                      Sub       D3, (A2)
FA60   BE52                      Cmp       (A2), D7
FA62   6708                      BEQ       L2289
FA64   6132           L2288:     Bsr       P451
FA66   34C3                      Move      D3, (A2)+
FA68   3C03                      Move      D3, D6
FA6A   60E0                      Bra       L2286
FA6C   3D43 FFF2      L2289:     Move      D3, $-E(A6)
FA70   D752                      Add       D3, (A2)
FA72   6124           L2290:     Bsr       P451
FA74   9F52                      Sub       D7, (A2)
FA76   3C1A                      Move      (A2)+, D6
FA78   BC6B 003C                 Cmp       $3C(A3), D6
FA7C   65F4                      BCS       L2290
FA7E   6118           L2291:     Bsr       P451
FA80   3506                      Move      D6, -(A2)
FA82   536B 005E                 SubQ.L    $1, $5E(A3)
FA86   4A6B 003C                 Tst       $3C(A3)
FA8A   6604                      BNE       L2292
FA8C   426B 005E                 Clr       $5E(A3)
FA90   4CDF 047C      L2292:     MoveM.L   (A7)+, D2-D6/A2
FA94   4E5E                      Unlk      A6
FA96   4E75                      Rts

                      P451:
FA98   526B 005E                 AddQ      $1, $5E(A3)
FA9C   204C                      Move.L    A4, A0
FA9E   A025                      _GetHandleSize
FAA0   2200                      Move.L    D0, D1
FAA2   7068                      MoveQ.L   $68, D0
FAA4   D06B 005E                 Add       $5E(A3), D0
FAA8   D06B 005E                 Add       $5E(A3), D0
FAAC   B280                      Cmp.L     D0, D1
FAAE   6C10                      BGE       L2293
FAB0   95CB                      SubA.L    A3, A2
FAB2   5040                      AddQ      $8, D0
FAB4   0894 0007                 BClr.B    $7, (A4)
FAB8   A024                      _SetHandleSize
FABA   A029                      _HLock
FABC   2654                      Move.L    (A4), A3
FABE   D5CB                      AddA.L    A3, A2
FAC0   4E75           L2293:     Rts

                      P452:
FAC2   4A2B 0024                 Tst.B     $24(A3)
FAC6   67F8                      BEQ       L2293
FAC8   302B 0020                 Move      $20(A3), D0
FACC   B06B 0022                 Cmp       $22(A3), D0
FAD0   66EE                      BNE       L2293
FAD2   41EB 0039                 Lea.L     $39(A3), A0
FAD6   50D0                      ST.B      (A0)
FAD8   4A20                      Tst.B     -(A0)
FADA   66E4                      BNE       L2293
FADC   50D0                      ST.B      (A0)
FADE   6012           L2294:     Bra       P454

                      P453:
FAE0   4A2B 0024                 Tst.B     $24(A3)
FAE4   67DA                      BEQ       L2293
FAE6   41EB 0039                 Lea.L     $39(A3), A0
FAEA   51D0                      SF.B      (A0)
FAEC   4A20                      Tst.B     -(A0)
FAEE   67D0                      BEQ       L2293
FAF0   51D0                      SF.B      (A0)

                      P454:
FAF2   48E7 FF00                 MoveM.L   D0-D7, -(A7)
FAF6   362B 0020                 Move      $20(A3), D3
FAFA   3803                      Move      D3, D4
FAFC   7EFE                      MoveQ.L   $-2, D7
FAFE   6100 FBA8                 Bsr       P_doTEDoText
FB02   3028 0032                 Move      $32(A0), D0
FB06   3740 0016                 Move      D0, $16(A3)
FB0A   5340                      SubQ.L    $1, D0
FB0C   3740 0012                 Move      D0, $12(A3)
FB10   202B 005A                 Move.L    $5A(A3), D0
FB14   6100 FD0A                 Bsr       P440
FB18   4CDF 00FF                 MoveM.L   (A7)+, D0-D7
FB1C   4E75                      Rts

                      P_tTEActivate:
FB1E   6100 FD0E                 Bsr       P441
FB22   4A2B 0024                 Tst.B     $24(A3)
FB26   6616                      BNE       L2296
FB28   302B 0020                 Move      $20(A3), D0
FB2C   B06B 0022                 Cmp       $22(A3), D0
FB30   6604                      BNE       L2295
FB32   50EB 0039                 ST.B      $39(A3)
FB36   50EB 0024      L2295:     ST.B      $24(A3)
FB3A   6100 F9F0                 Bsr       P433
FB3E   603C           L2296:     Bra       L2297

                      P_tTEDeactivate:
FB40   6100 FCEC                 Bsr       P441
FB44   4A2B 0024                 Tst.B     $24(A3)
FB48   6732                      BEQ       L2297
FB4A   6194                      Bsr       P453
FB4C   6100 F9DE                 Bsr       P433
FB50   51EB 0024                 SF.B      $24(A3)
FB54   6026                      Bra       L2297

                      P_tTEIdle:
FB56   6100 FCD6                 Bsr       P441
FB5A   4A2B 0039                 Tst.B     $39(A3)
FB5E   671C                      BEQ       L2297
FB60   594F                      SubQ.L    $4, A7
FB62   A975                      _TickCount
FB64   205F                      Move.L    (A7)+, A0
FB66   B1EB 0034                 CmpA.L    $34(A3), A0
FB6A   6510                      BCS       L2297
FB6C   D1F8 02F4                 AddA.L    (CaretTime), A0
FB70   2748 0034                 Move.L    A0, $34(A3)
FB74   6100 FF7C                 Bsr       P454
FB78   462B 0038                 Not.B     $38(A3)
FB7C   6000 F8DA      L2297:     Bra       L2229

                      P_tTEPaste:
FB80   6100 FCAC                 Bsr       P441
FB84   2278 0AB4                 Move.L    (TEScrpHandle), A1
FB88   08D1 0007                 BSet.B    $7, (A1)
FB8C   2C11                      Move.L    (A1), D6
FB8E   7A00                      MoveQ.L   $0, D5
FB90   3A38 0AB0                 Move      (TEScrpLength), D5
FB94   610A                      Bsr       P455
FB96   2278 0AB4                 Move.L    (TEScrpHandle), A1
FB9A   0891 0007                 BClr.B    $7, (A1)
FB9E   60DC                      Bra       L2297

                      P455:
FBA0   6100 FF3E                 Bsr       P453
FBA4   6100 F986                 Bsr       P433
FBA8   6100 FD58                 Bsr       P444
FBAC   6112                      Bsr       P456
FBAE   6100 FD7E                 Bsr       P445
FBB2   41EB 0020                 Lea.L     $20(A3), A0
FBB6   DB50                      Add       D5, (A0)
FBB8   3098                      Move      (A0)+, (A0)
FBBA   6100 FF06                 Bsr       P452
FBBE   4E75                      Rts

                      P456:
FBC0   598F                      SubQ.L    $4, A7
FBC2   206B 003E                 Move.L    $3E(A3), A0
FBC6   2F08                      Move.L    A0, -(A7)
FBC8   A02A                      _HUnlock
FBCA   3F2B 0020                 Move      $20(A3), -(A7)
FBCE   4267                      Clr       -(A7)
FBD0   42A7                      Clr.L     -(A7)
FBD2   42A7                      Clr.L     -(A7)
FBD4   2F06                      Move.L    D6, -(A7)
FBD6   2F05                      Move.L    D5, -(A7)
FBD8   A9E0                      _Munger
FBDA   588F                      AddQ      $4, A7
FBDC   206B 003E                 Move.L    $3E(A3), A0
FBE0   A029                      _HLock
FBE2   DB6B 003C                 Add       D5, $3C(A3)
FBE6   9E45                      Sub       D5, D7
FBE8   4E75                      Rts

                      P_tTEInsert:
FBEA   6100 FC42                 Bsr       P441
FBEE   6100 FEF0                 Bsr       P453
FBF2   6100 F938                 Bsr       P433
FBF6   7E00                      MoveQ.L   $0, D7
FBF8   4CDA 0060                 MoveM.L   (A2)+, D5-D6
FBFC   61C2                      Bsr       P456
FBFE   6100 FD2E                 Bsr       P445
FC02   DB6B 0020                 Add       D5, $20(A3)
FC06   DB6B 0022                 Add       D5, $22(A3)
FC0A   6100 FEB6                 Bsr       P452
FC0E   6100 F91C                 Bsr       P433
FC12   700C           L2298:     MoveQ.L   $C, D0
FC14   6000 F844                 Bra       L2230

                      P_tTEKey:
FC18   6100 FC14                 Bsr       P441
FC1C   50EB 0047                 ST.B      $47(A3)
FC20   A856                      _ObscureCursor
FC22   3212                      Move      (A2), D1
FC24   0C01 0008                 Cmp.B     $8, D1
FC28   670C                      BEQ       L2299
FC2A   2C0A                      Move.L    A2, D6
FC2C   5246                      AddQ      $1, D6
FC2E   7A01                      MoveQ.L   $1, D5
FC30   6100 FF6E                 Bsr       P455
FC34   601A                      Bra       L2301
FC36   302B 0020      L2299:     Move      $20(A3), D0
FC3A   B06B 0022                 Cmp       $22(A3), D0
FC3E   660C                      BNE       L2300
FC40   4A40                      Tst       D0
FC42   670C                      BEQ       L2301
FC44   6100 FE9A                 Bsr       P453
FC48   536B 0020                 SubQ.L    $1, $20(A3)
FC4C   2F0C           L2300:     Move.L    A4, -(A7)
FC4E   A9D7                      _TEDelete
FC50   7006           L2301:     MoveQ.L   $6, D0
FC52   6000 F806                 Bra       L2230

                      P_tTEScroll:
FC56   6100 FBD6                 Bsr       P441
FC5A   6100 FE84                 Bsr       P453
FC5E   241A                      Move.L    (A2)+, D2
FC60   4853                      Pea.L     (A3)
FC62   2F02                      Move.L    D2, -(A7)
FC64   A8A8                      _OffsetRect
FC66   594F                      SubQ.L    $4, A7
FC68   A8D8                      _NewRgn
FC6A   245F                      Move.L    (A7)+, A2
FC6C   486B 0008                 Pea.L     $8(A3)
FC70   2F02                      Move.L    D2, -(A7)
FC72   2F0A                      Move.L    A2, -(A7)
FC74   A8EF                      _ScrollRect
FC76   6100 FE4A                 Bsr       P452
FC7A   2F0A                      Move.L    A2, -(A7)
FC7C   A879                      _SetClip
FC7E   2052                      Move.L    (A2), A0
FC80   3028 0002                 Move      $2(A0), D0
FC84   3228 0006                 Move      $6(A0), D1
FC88   6122                      Bsr       P458
FC8A   2F0A                      Move.L    A2, -(A7)
FC8C   A8D9                      _DisposeRgn
FC8E   7008           L2302:     MoveQ.L   $8, D0
FC90   6000 F7C8                 Bra       L2230

                      P_tTESetAlignment:
FC94   6100 FB98                 Bsr       P441
FC98   3752 003A                 Move      (A2), $3A(A3)
FC9C   60B2                      Bra       L2301

                      P457:
FC9E   9053                      Sub       (A3), D0
FCA0   48C0                      Ext.L     D0
FCA2   81EB 0018                 DivS      $18(A3), D0
FCA6   B06B 005E                 Cmp       $5E(A3), D0
FCAA   4E75           L2303:     Rts

                      P458:
FCAC   7600                      MoveQ.L   $0, D3
FCAE   61EE                      Bsr       P457
FCB0   6C22                      BGE       L2306
FCB2   D040                      Add       D0, D0
FCB4   6D04                      BLT       L2304
FCB6   3633 0060                 Move      $60(A3,D0.W), D3
FCBA   78FF           L2304:     MoveQ.L   $-1, D4
FCBC   D26B 0018                 Add       $18(A3), D1
FCC0   5341                      SubQ.L    $1, D1
FCC2   3001                      Move      D1, D0
FCC4   61D8                      Bsr       P457
FCC6   6C06                      BGE       L2305
FCC8   D040                      Add       D0, D0
FCCA   3833 0060                 Move      $60(A3,D0.W), D4
FCCE   7EFF           L2305:     MoveQ.L   $-1, D7
FCD0   6100 F9D6                 Bsr       P_doTEDoText
FCD4   6100 F856      L2306:     Bsr       P433
FCD8   4A2B 0038                 Tst.B     $38(A3)
FCDC   67CC                      BEQ       L2303
FCDE   6000 FDFE                 Bra       L2294

                      P_tInfoScrap:
FCE2   205F                      Move.L    (A7)+, A0
FCE4   43F8 0960                 Lea.L     (ScrapSize), A1
FCE8   2E89                      Move.L    A1, (A7)
FCEA   4ED0                      Jmp       (A0)

                      P459:
FCEC   225F                      Move.L    (A7)+, A1
FCEE   4E56 FFA8                 Link      A6, $-58
FCF2   48E7 3F38                 MoveM.L   D2-D7/A2-A4, -(A7)
FCF6   2F09                      Move.L    A1, -(A7)
FCF8   4CF8 0470 0960            MoveM.L   (ScrapSize), D4-D6/A2
FCFE   49F8 0964                 Lea.L     (ScrapHandle), A4
FD02   41EE FFB0                 Lea.L     $-50(A6), A0
FD06   2648                      Move.L    A0, A3
FD08   214A 0012                 Move.L    A2, $12(A0)
FD0C   4268 0016                 Clr       $16(A0)
FD10   4268 001A                 Clr       $1A(A0)
FD14   42A8 001C                 Clr.L     $1C(A0)
FD18   4A46                      Tst       D6
FD1A   6646                      BNE       L2310

                      P460:
FD1C   A000                      _Open
FD1E   6744                      BEQ       L2311
FD20   0C40 FFCF                 Cmp       $-31, D0
FD24   673C                      BEQ       L2310
FD26   0C40 FFD5                 Cmp       $-2B, D0
FD2A   6638                      BNE       L2311
FD2C   A008                      _Create
FD2E   6634                      BNE       L2311
FD30   60EA                      Bra       P460

                      P_tUnloadScrap:
FD32   61B8                      Bsr       P459
FD34   6618                      BNE       L2308
FD36   4A46                      Tst       D6
FD38   6F12                      BLE       L2307
FD3A   61E0                      Bsr       P460
FD3C   2004                      Move.L    D4, D0
FD3E   613E                      Bsr       P461
FD40   A003                      _Write
FD42   660A                      BNE       L2308
FD44   2045                      Move.L    D5, A0
FD46   A023                      _DisposeHandle
FD48   429C                      Clr.L     (A4)+
FD4A   429C                      Clr.L     (A4)+
FD4C   7000           L2307:     MoveQ.L   $0, D0
FD4E   48C0           L2308:     Ext.L     D0
FD50   2D40 0008                 Move.L    D0, $8(A6)
FD54   7000                      MoveQ.L   $0, D0
FD56   4CDF 1CFC      L2309:     MoveM.L   (A7)+, D2-D7/A2-A4
FD5A   4E5E                      Unlk      A6
FD5C   205F                      Move.L    (A7)+, A0
FD5E   DEC0                      AddA      D0, A7
FD60   4ED0                      Jmp       (A0)
FD62   7000           L2310:     MoveQ.L   $0, D0
FD64   4E75           L2311:     Rts

                      P_tLoadScrap:
FD66   6184                      Bsr       P459
FD68   66E4                      BNE       L2308
FD6A   4A46                      Tst       D6
FD6C   66DE                      BNE       L2307
FD6E   2004                      Move.L    D4, D0
FD70   A122                      _NewHandle
FD72   66DA                      BNE       L2308
FD74   28C8                      Move.L    A0, (A4)+
FD76   529C                      AddQ      $1, (A4)+
FD78   6106                      Bsr       P462
FD7A   A002                      _Read
FD7C   60D0                      Bra       L2308

                      P461:
FD7E   2045                      Move.L    D5, A0

                      P462:
FD80   2750 0020                 Move.L    (A0), $20(A3)
FD84   2740 0024                 Move.L    D0, $24(A3)
FD88   377C 0001 002C            Move      $1, $2C(A3)
FD8E   42AB 002E                 Clr.L     $2E(A3)
FD92   204B                      Move.L    A3, A0
FD94   4E75                      Rts

                      P_tZeroScrap:
FD96   6100 FF54                 Bsr       P459
FD9A   66B2                      BNE       L2308
FD9C   21C0 0960                 Move.L    D0, (ScrapSize)
FDA0   506C 0004                 AddQ      $8, $4(A4)
FDA4   4A46                      Tst       D6
FDA6   6710                      BEQ       L2314
FDA8   6E04                      BGT       L2312
FDAA   A122                      _NewHandle
FDAC   6004                      Bra       L2313
FDAE   2045           L2312:     Move.L    D5, A0
FDB0   A024                      _SetHandleSize
FDB2   28C8           L2313:     Move.L    A0, (A4)+
FDB4   389C                      Move      (A4)+, (A4)
FDB6   6096                      Bra       L2308
FDB8   42A8 001C      L2314:     Clr.L     $1C(A0)
FDBC   A012                      _SetEOF
FDBE   608E                      Bra       L2308

                      P463:
FDC0   4A46                      Tst       D6
FDC2   670A                      BEQ       L2315
FDC4   2445                      Move.L    D5, A2
FDC6   2052                      Move.L    (A2), A0
FDC8   D1C3                      AddA.L    D3, A0
FDCA   A02E                      _BlockMove
FDCC   6094                      Bra       L2310
FDCE   61AE           L2315:     Bsr       P461
FDD0   2143 002E                 Move.L    D3, $2E(A0)
FDD4   2149 0020                 Move.L    A1, $20(A0)
FDD8   A002                      _Read
FDDA   4E75                      Rts

                      P_tGetScrap:
FDDC   6100 FF0E                 Bsr       P459
FDE0   664C                      BNE       L2319
FDE2   709C                      MoveQ.L   $-64, D0
FDE4   4A46                      Tst       D6
FDE6   6B46                      BMI       L2319
FDE8   7600                      MoveQ.L   $0, D3
FDEA   B684           L2316:     Cmp.L     D4, D3
FDEC   6C1C                      BGE       L2317
FDEE   7008                      MoveQ.L   $8, D0
FDF0   43EE FFA8                 Lea.L     $-58(A6), A1
FDF4   61CA                      Bsr       P463
FDF6   6636                      BNE       L2319
FDF8   5083                      AddQ      $8, D3
FDFA   2E19                      Move.L    (A1)+, D7
FDFC   BEAE 000C                 Cmp.L     $C(A6), D7
FE00   670C                      BEQ       L2318
FE02   D699                      Add.L     (A1)+, D3
FE04   5283                      AddQ      $1, D3
FE06   0183                      BClr.B    D0, D3
FE08   60E0                      Bra       L2316
FE0A   709A           L2317:     MoveQ.L   $-66, D0
FE0C   6022                      Bra       L2320
FE0E   246E 0008      L2318:     Move.L    $8(A6), A2
FE12   2483                      Move.L    D3, (A2)
FE14   2011                      Move.L    (A1), D0
FE16   2D40 0014                 Move.L    D0, $14(A6)
FE1A   222E 0010                 Move.L    $10(A6), D1
FE1E   6714                      BEQ       L2321
FE20   2041                      Move.L    D1, A0
FE22   A024                      _SetHandleSize
FE24   6608                      BNE       L2319
FE26   2011                      Move.L    (A1), D0
FE28   2250                      Move.L    (A0), A1
FE2A   6194                      Bsr       P463
FE2C   6706                      BEQ       L2321
FE2E   48C0           L2319:     Ext.L     D0
FE30   2D40 0014      L2320:     Move.L    D0, $14(A6)
FE34   700C           L2321:     MoveQ.L   $C, D0
FE36   6000 FF1E                 Bra       L2309

                      P_tPutScrap:
FE3A   6100 FEB0                 Bsr       P459
FE3E   6100 FF3E                 Bsr       P461
FE42   709C                      MoveQ.L   $-64, D0
FE44   4A46                      Tst       D6
FE46   6BE6                      BMI       L2319
FE48   7008                      MoveQ.L   $8, D0
FE4A   41EE 000C                 Lea.L     $C(A6), A0
FE4E   6114                      Bsr       P464
FE50   206E 0008                 Move.L    $8(A6), A0
FE54   202E 0010                 Move.L    $10(A6), D0
FE58   72FE                      MoveQ.L   $-2, D1
FE5A   5280                      AddQ      $1, D0
FE5C   C081                      And.L     D1, D0
FE5E   6104                      Bsr       P464
FE60   2904                      Move.L    D4, -(A4)
FE62   60CA                      Bra       L2319

                      P464:
FE64   2744 002E                 Move.L    D4, $2E(A3)
FE68   D880                      Add.L     D0, D4
FE6A   4A46                      Tst       D6
FE6C   6706                      BEQ       L2322
FE6E   2245                      Move.L    D5, A1
FE70   A9EF                      _PtrAndHand
FE72   4E75                      Rts
FE74   2748 0020      L2322:     Move.L    A0, $20(A3)
FE78   2740 0024                 Move.L    D0, $24(A3)
FE7C   204B                      Move.L    A3, A0
FE7E   A003                      _Write
FE80   4E75                      Rts

                      P_tInitPack:
FE82   4267                      Clr       -(A7)
FE84   A99B                      _SetResLoad
FE86   598F                      SubQ.L    $4, A7
FE88   2F3C 5041 434B            Move.L    $5041434B, -(A7)
FE8E   3F2F 000C                 Move      $C(A7), -(A7)
FE92   A9A0                      _GetResource
FE94   302F 0008                 Move      $8(A7), D0
FE98   E548                      LsL       $2, D0
FE9A   43F8 0AB8                 Lea.L     (AppPacks), A1
FE9E   239F 0000                 Move.L    (A7)+, $0(A1,D0.W)
FEA2   1F3C 0001                 Move.B    $1, -(A7)
FEA6   A99B                      _SetResLoad
FEA8   205F                      Move.L    (A7)+, A0
FEAA   548F                      AddQ      $2, A7
FEAC   4ED0                      Jmp       (A0)

                      P_tInitAllPacks:
FEAE   3F3C 0004                 Move      $4, -(A7)
FEB2   61CE                      Bsr       P_tInitPack
FEB4   3F3C 0005                 Move      $5, -(A7)
FEB8   61C8                      Bsr       P_tInitPack
FEBA   3F3C 0006                 Move      $6, -(A7)
FEBE   61C2                      Bsr       P_tInitPack
FEC0   3F3C 0007                 Move      $7, -(A7)
FEC4   61BC                      Bsr       P_tInitPack
FEC6   4278 0A4A                 Clr       (FPState)
FECA   41FA 0008                 Lea.L     E_690, A0
FECE   21C8 0A4C                 Move.L    A0, (FPHaltVector)
FED2   4E75                      Rts

                      E_690:
FED4   7010                      MoveQ.L   $10, D0
FED6   A9C9                      _SysError

                      P465:
FED8   48E7 8080                 MoveM.L   D0/A0, -(A7)
FEDC   202F 0008                 Move.L    $8(A7), D0
FEE0   41FA 002E                 Lea.L     P_tPack1, A0
FEE4   9088                      Sub.L     A0, D0
FEE6   D040                      Add       D0, D0
FEE8   41F8 0AB8                 Lea.L     (AppPacks), A0
FEEC   D1C0                      AddA.L    D0, A0
FEEE   4A90                      Tst.L     (A0)
FEF0   6714                      BEQ       L2324
FEF2   2050                      Move.L    (A0), A0
FEF4   4A90                      Tst.L     (A0)
FEF6   6604                      BNE       L2323
FEF8   2F08                      Move.L    A0, -(A7)
FEFA   A9A2                      _LoadResource
FEFC   2F50 0008      L2323:     Move.L    (A0), $8(A7)
FF00   4CDF 0101                 MoveM.L   (A7)+, D0/A0
FF04   4E75                      Rts
FF06   E448           L2324:     LsR       $2, D0
FF08   0640 0011                 Add       $11, D0
FF0C   A9C9                      _SysError

                      P_tPack0:
FF0E   61C8                      Bsr       P465

                      P_tPack1:
FF10   61C6                      Bsr       P465

                      P_tPack2:
FF12   61C4                      Bsr       P465

                      P_tPack3:
FF14   61C2                      Bsr       P465

                      P_tFP68K:
FF16   61C0                      Bsr       P465

                      P_tElems68K:
FF18   61BE                      Bsr       P465

                      P_tPack6:
FF1A   61BC                      Bsr       P465

                      P_tDECSTR68K:
FF1C   61BA                      Bsr       P465

                      P_tSecondsToDate:
FF1E   48E7 F880                 MoveM.L   D0-D4/A0, -(A7)
FF22   7200                      MoveQ.L   $0, D1
FF24   E288                      LsR.L     $1, D0
FF26   E291                      RXR.L     $1, D1
FF28   80FC A8C0                 DivU      $-5740, D0
FF2C   4840                      Swap      D0
FF2E   3200                      Move      D0, D1
FF30   E399                      ROL.L     $1, D1
FF32   4240                      Clr       D0
FF34   4840                      Swap      D0
FF36   2400                      Move.L    D0, D2
FF38   E582                      AsL.L     $2, D2
FF3A   84FC 05B5                 DivU      $5B5, D2
FF3E   0642 0770                 Add       $770, D2
FF42   30C2                      Move      D2, (A0)+
FF44   763B                      MoveQ.L   $3B, D3
FF46   0242 0003                 And       $3, D2
FF4A   6602                      BNE       L2325
FF4C   5243                      AddQ      $1, D3
FF4E   4242           L2325:     Clr       D2
FF50   4842                      Swap      D2
FF52   E44A                      LsR       $2, D2
FF54   7801                      MoveQ.L   $1, D4
FF56   B443                      Cmp       D3, D2
FF58   6D04                      BLT       L2326
FF5A   5444                      AddQ      $2, D4
FF5C   9443                      Sub       D3, D2
FF5E   EF8A           L2326:     LsL.L     $7, D2
FF60   7647                      MoveQ.L   $47, D3
FF62   D483                      Add.L     D3, D2
FF64   84FC 0F4F                 DivU      $F4F, D2
FF68   D444                      Add       D4, D2
FF6A   4842                      Swap      D2
FF6C   EE4A                      LsR       $7, D2
FF6E   5242                      AddQ      $1, D2
FF70   20C2                      Move.L    D2, (A0)+
FF72   82FC 0E10                 DivU      $E10, D1
FF76   30C1                      Move      D1, (A0)+
FF78   4241                      Clr       D1
FF7A   4841                      Swap      D1
FF7C   82FC 003C                 DivU      $3C, D1
FF80   4841                      Swap      D1
FF82   20C1                      Move.L    D1, (A0)+
FF84   5A40                      AddQ      $5, D0
FF86   80FC 0007                 DivU      $7, D0
FF8A   4840                      Swap      D0
FF8C   5240                      AddQ      $1, D0
FF8E   3080                      Move      D0, (A0)
FF90   4CDF 011F                 MoveM.L   (A7)+, D0-D4/A0
FF94   4E75                      Rts

                      P_tDateToSeconds:
FF96   48E7 7800                 MoveM.L   D1-D4, -(A7)
FF9A   7000                      MoveQ.L   $0, D0
FF9C   5088                      AddQ      $8, A0
FF9E   2210                      Move.L    (A0), D1
FFA0   3001                      Move      D1, D0
FFA2   4841                      Swap      D1
FFA4   3420                      Move      -(A0), D2
FFA6   763C                      MoveQ.L   $3C, D3
FFA8   C4C3                      MulU      D3, D2
FFAA   D441                      Add       D1, D2
FFAC   C4C3                      MulU      D3, D2
FFAE   D082                      Add.L     D2, D0
FFB0   3220                      Move      -(A0), D1
FFB2   5341                      SubQ.L    $1, D1
FFB4   3420                      Move      -(A0), D2
FFB6   3620                      Move      -(A0), D3
FFB8   3803                      Move      D3, D4
FFBA   0443 0770                 Sub       $770, D3
FFBE   C6FC 05B5                 MulU      $5B5, D3
FFC2   5683                      AddQ      $3, D3
FFC4   E48B                      LsR.L     $2, D3
FFC6   D243                      Add       D3, D1
FFC8   5342                      SubQ.L    $1, D2
FFCA   0C42 0001                 Cmp       $1, D2
FFCE   6F0E                      BLE       L2328
FFD0   5542                      SubQ.L    $2, D2
FFD2   763B                      MoveQ.L   $3B, D3
FFD4   0244 0003                 And       $3, D4
FFD8   6602                      BNE       L2327
FFDA   5243                      AddQ      $1, D3
FFDC   D243           L2327:     Add       D3, D1
FFDE   C4FC 0F4D      L2328:     MulU      $F4D, D2
FFE2   0642 0034                 Add       $34, D2
FFE6   EE4A                      LsR       $7, D2
FFE8   D242                      Add       D2, D1
FFEA   C2FC A8C0                 MulU      $-5740, D1
FFEE   D281                      Add.L     D1, D1
FFF0   D081                      Add.L     D1, D0
FFF2   4CDF 001E                 MoveM.L   (A7)+, D1-D4
FFF6   4E75                      Rts
                      ; Unused area
                      ; Might be initials like seen at end of the Mac Plus ROM.
                      ; Perhaps WDA could be William D. Atkinson, usually known
                      ; as Bill Atkinson. But no obvious candidates for RHS.
FFF8   5248 5320 5744            DC.B      'RHS WD'
FFFE   4120                      DC.B      'A '
